import { MockAdapter } from '../mock-adapter';
const mock = MockAdapter.getInstance();

import Mock from 'mockjs'

// 获取全部数组
mock.onGet('./assets/json/data-dictionary.json').reply((config: any) => {
    let status = MockAdapter.mockStatus(config);
    return [status, [
        {
        "srfkey": "SysOperator",
        "emptytext": "未定义",
        "codelisttype":"dynamic",
        "appdataentity":"",
        "appdedataset":"",
        "items": []
    },
    {
        srfkey: 'WFEngineTypeCodeList',
        emptytext: '未定义',
        "codelisttype":"static",
        items: [
            {
                id: 'ACTIVITI',
                label: 'Activiti',
                text: 'Activiti',
                value: 'ACTIVITI',
                disabled: false,
            },
        ]
    },
    {
        srfkey: 'YesNo1',
        emptytext: '未定义',
        "codelisttype":"static",
        items: [
            {
                id: '1',
                label: '是',
                text: '是',
                value: 1,
                disabled: false,
            },
            {
                id: '0',
                label: '否',
                text: '否',
                value: 0,
                disabled: false,
            },
        ]
    },
    {
        srfkey: 'YesNo',
        emptytext: '未定义',
        "codelisttype":"static",
        items: [
            {
                id: '1',
                label: '是',
                text: '是',
                value: '1',
                disabled: false,
            },
            {
                id: '0',
                label: '否',
                text: '否',
                value: '0',
                disabled: false,
            },
        ]
    },
    {
        srfkey: 'CertType',
        emptytext: '未定义',
        "codelisttype":"static",
        items: [
            {
                id: 'IDCARD',
                label: '身份证',
                text: '身份证',
                value: 'IDCARD',
                disabled: false,
            },
        ]
    },
    {
        srfkey: 'WFRoleTypeCodeList',
        emptytext: '未定义',
        "codelisttype":"static",
        items: [
            {
                id: 'ORG',
                label: '当前组织',
                text: '当前组织',
                value: 'ORG',
                disabled: false,
            },
            {
                id: 'ORGADMIN',
                label: '当前组织管理员',
                text: '当前组织管理员',
                value: 'ORGADMIN',
                disabled: false,
            },
            {
                id: 'ORGSECTORADMIN',
                label: '当前部门管理员',
                text: '当前部门管理员',
                value: 'ORGSECTORADMIN',
                disabled: false,
            },
            {
                id: 'PORG',
                label: '当前组织父组织',
                text: '当前组织父组织',
                value: 'PORG',
                disabled: false,
            },
            {
                id: 'ORGSECTOR',
                label: '当前部门',
                text: '当前部门',
                value: 'ORGSECTOR',
                disabled: false,
            },
            {
                id: 'PORGSECTOR',
                label: '当前部门父部门',
                text: '当前部门父部门',
                value: 'PORGSECTOR',
                disabled: false,
            },
            {
                id: 'USERGROUP',
                label: '用户组',
                text: '用户组',
                value: 'USERGROUP',
                disabled: false,
            },
            {
                id: 'ORGGROUP',
                label: '机构组',
                text: '机构组',
                value: 'ORGGROUP',
                disabled: false,
            },
            {
                id: 'ORGUSERGROUP',
                label: '机构人员组',
                text: '机构人员组',
                value: 'ORGUSERGROUP',
                disabled: false,
            },
            {
                id: 'ORGSECTORGROUP',
                label: '部门组',
                text: '部门组',
                value: 'ORGSECTORGROUP',
                disabled: false,
            },
            {
                id: 'ORGSECTORUSERGROUP',
                label: '部门人员组',
                text: '部门人员组',
                value: 'ORGSECTORUSERGROUP',
                disabled: false,
            },
            {
                id: 'DEDATASET',
                label: '实体数据集合',
                text: '实体数据集合',
                value: 'DEDATASET',
                disabled: false,
            },
            {
                id: 'CUSTOM',
                label: '自定义',
                text: '自定义',
                value: 'CUSTOM',
                disabled: false,
            },
        ]
    },
    {
        srfkey: 'WFStateCodeList',
        emptytext: '未定义',
        "codelisttype":"static",
        items: [
            {
                id: '40',
                label: '取消',
                text: '取消',
                value: '40',
                disabled: false,
            },
            {
                id: '30',
                label: '挂起',
                text: '挂起',
                value: '30',
                disabled: false,
            },
            {
                id: '20',
                label: '流程中',
                text: '流程中',
                value: '20',
                disabled: false,
            },
            {
                id: '50',
                label: '结束',
                text: '结束',
                value: '50',
                disabled: false,
            },
        ]
    }
    ]];
});

