import { MockAdapter } from '../mock-adapter';
const mock = MockAdapter.getInstance();

import Mock from 'mockjs'

// 获取studio链接数据
mock.onGet('./assets/json/view-config.json').reply((config: any) => {
    let status = MockAdapter.mockStatus(config);
    return [status,{
                "wfappgridview": {
            "title": "工作流应用表格视图",
            "caption": "工作流应用",
            "viewtype": "DEGRIDVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "WFAppGridView",
            "viewtag": "0687278343b1284ce8d09a6babd0980b"
        },
        "wfinstancegridview": {
            "title": "工作流实例表格视图",
            "caption": "工作流实例",
            "viewtype": "DEGRIDVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "WFInstanceGridView",
            "viewtag": "10fe98ae83a75a2f1a767a7b718d306a"
        },
        "psdewfgridview": {
            "title": "业务实体工作流表格视图",
            "caption": "业务实体工作流",
            "viewtype": "DEGRIDVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "PSDEWFGridView",
            "viewtag": "13946b410aa15937523a592bc1c65e46"
        },
        "pssysappgridview": {
            "title": "业务系统应用表格视图",
            "caption": "业务系统应用",
            "viewtype": "DEGRIDVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "PSSysAppGridView",
            "viewtag": "13ddcae153d1ca8a563ae14f2dbe07ac"
        },
        "indexview": {
            "title": "流程管理平台",
            "caption": "流程管理平台",
            "viewtype": "APPINDEXVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "IndexView",
            "viewtag": "1e466d0cc8d3d4262b359e89cbe38591"
        },
        "wfstepdataeditview": {
            "title": "流程步骤信息编辑视图",
            "caption": "流程步骤信息",
            "viewtype": "DEEDITVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "WFStepDataEditView",
            "viewtag": "225ec71cac39dd10ea8cecc3b48c7882"
        },
        "pswfroleeditview": {
            "title": "平台流程角色编辑视图",
            "caption": "平台流程角色",
            "viewtype": "DEEDITVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "PSWFRoleEditView",
            "viewtag": "2414a7b5ce4f83bfa01a06b2398f53fe"
        },
        "orgdeptusergridview": {
            "title": "部门用户表格视图",
            "caption": "部门用户",
            "viewtype": "DEGRIDVIEW",
            "viewmodule": "r7rt_org",
            "viewname": "OrgDeptUserGridView",
            "viewtag": "243c717ea117ff06bad0a97c64f07311"
        },
        "orggridview": {
            "title": "组织（公司）表格视图",
            "caption": "组织",
            "viewtype": "DEGRIDVIEW",
            "viewmodule": "r7rt_org",
            "viewname": "OrgGridView",
            "viewtag": "34c7eb0626378c9449b3bd015e4a4b5d"
        },
        "pssysappeditview": {
            "title": "业务系统应用编辑视图",
            "caption": "业务系统应用",
            "viewtype": "DEEDITVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "PSSysAppEditView",
            "viewtag": "42c1a7f78d55fccc683c2339383139f2"
        },
        "orgdeptusereditview": {
            "title": "部门用户编辑视图",
            "caption": "部门用户",
            "viewtype": "DEEDITVIEW",
            "viewmodule": "r7rt_org",
            "viewname": "OrgDeptUserEditView",
            "viewtag": "4c4bab35f0f1f6c6041baf35048812c1"
        },
        "orgdeptpickupview": {
            "title": "部门数据选择视图",
            "caption": "部门",
            "viewtype": "DEPICKUPVIEW",
            "viewmodule": "r7rt_org",
            "viewname": "OrgDeptPickupView",
            "viewtag": "4ccb5d6ac81b5d1e0fbb0f1ed45e5767"
        },
        "pswfrolegridview": {
            "title": "平台流程角色表格视图",
            "caption": "平台流程角色",
            "viewtype": "DEGRIDVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "PSWFRoleGridView",
            "viewtag": "4ec9f117c1ad545d9cda19f562a8bde4"
        },
        "orgdeptgridview": {
            "title": "部门表格视图",
            "caption": "部门",
            "viewtype": "DEGRIDVIEW",
            "viewmodule": "r7rt_org",
            "viewname": "OrgDeptGridView",
            "viewtag": "51c7fb0cd63ca38e497c153dab2d9901"
        },
        "pswfroledetailgridview": {
            "title": "平台流程角色成员表格视图",
            "caption": "平台流程角色成员",
            "viewtype": "DEGRIDVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "PSWFRoleDetailGridView",
            "viewtag": "542bb35662b74844bb340c90b00d4ab6"
        },
        "wfappeditview": {
            "title": "工作流应用编辑视图",
            "caption": "工作流应用",
            "viewtype": "DEEDITVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "WFAppEditView",
            "viewtag": "55237979003b0151981cb953bb166aee"
        },
        "orguserpickupview": {
            "title": "组织用户数据选择视图",
            "caption": "组织用户",
            "viewtype": "DEPICKUPVIEW",
            "viewmodule": "r7rt_org",
            "viewname": "OrgUserPickupView",
            "viewtag": "65c4ebed51226e73991e20fbbc72849f"
        },
        "pswfversioneditview": {
            "title": "业务流程版本编辑视图",
            "caption": "业务流程版本",
            "viewtype": "DEEDITVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "PSWFVersionEditView",
            "viewtag": "6a9f67dcb8abc183d0b3eee6c1cec33f"
        },
        "pswfversiongridview": {
            "title": "业务流程版本表格视图",
            "caption": "业务流程版本",
            "viewtype": "DEGRIDVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "PSWFVersionGridView",
            "viewtag": "72a5e4481e38cf93ba83f9b6dbb0949f"
        },
        "orgusereditview3": {
            "title": "组织用户编辑视图",
            "caption": "组织用户",
            "viewtype": "DEEDITVIEW3",
            "viewmodule": "r7rt_org",
            "viewname": "OrgUserEditView3",
            "viewtag": "74a55a903a16316b141b904c2bfb199e"
        },
        "pssystemeditview": {
            "title": "业务系统编辑视图",
            "caption": "业务系统",
            "viewtype": "DEEDITVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "PSSystemEditView",
            "viewtag": "95f4affcaced44f3a6bab5441f5c507b"
        },
        "orgpickupgridview": {
            "title": "组织（公司）选择表格视图",
            "caption": "组织",
            "viewtype": "DEPICKUPGRIDVIEW",
            "viewmodule": "r7rt_org",
            "viewname": "OrgPickupGridView",
            "viewtag": "a0e340bebba3c6f8c6b25971660d89e2"
        },
        "psdewfeditview": {
            "title": "业务实体工作流编辑视图",
            "caption": "业务实体工作流",
            "viewtype": "DEEDITVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "PSDEWFEditView",
            "viewtag": "a203786916eaf92c131186a53fb3304b"
        },
        "orgdeptpickupgridview": {
            "title": "部门选择表格视图",
            "caption": "部门",
            "viewtype": "DEPICKUPGRIDVIEW",
            "viewmodule": "r7rt_org",
            "viewname": "OrgDeptPickupGridView",
            "viewtag": "a42495ad6a66eda719dd8d7cf00fff99"
        },
        "psworkflowgridview": {
            "title": "业务工作流表格视图",
            "caption": "业务工作流",
            "viewtype": "DEGRIDVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "PSWorkflowGridView",
            "viewtag": "b7fe05f041c12d2db892857684c3f1bd"
        },
        "orgusergridview": {
            "title": "组织用户表格视图",
            "caption": "组织用户",
            "viewtype": "DEGRIDVIEW",
            "viewmodule": "r7rt_org",
            "viewname": "OrgUserGridView",
            "viewtag": "b914bb240b5bacc5909fbd9d2631f711"
        },
        "orguserpickupgridview": {
            "title": "组织用户选择表格视图",
            "caption": "组织用户",
            "viewtype": "DEPICKUPGRIDVIEW",
            "viewmodule": "r7rt_org",
            "viewname": "OrgUserPickupGridView",
            "viewtag": "b929ff46f2b5de4e51892c55d7413d21"
        },
        "wfworklisteditview": {
            "title": "工作流工作列表编辑视图",
            "caption": "工作流工作列表",
            "viewtype": "DEEDITVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "WFWorklistEditView",
            "viewtag": "c36fb8dbd745881dfdbfa353495cd8a0"
        },
        "orgpickupview": {
            "title": "组织（公司）数据选择视图",
            "caption": "组织",
            "viewtype": "DEPICKUPVIEW",
            "viewmodule": "r7rt_org",
            "viewname": "OrgPickupView",
            "viewtag": "c93817d91abd45f4c01e1cff8a603909"
        },
        "orgdepteditview": {
            "title": "部门编辑视图",
            "caption": "部门",
            "viewtype": "DEEDITVIEW",
            "viewmodule": "r7rt_org",
            "viewname": "OrgDeptEditView",
            "viewtag": "cb6394884f46a3c7fda86160c868e165"
        },
        "orgeditview": {
            "title": "组织（公司）编辑视图",
            "caption": "组织",
            "viewtype": "DEEDITVIEW",
            "viewmodule": "r7rt_org",
            "viewname": "OrgEditView",
            "viewtag": "cc2ba10ba36503c0847d45d5cd393903"
        },
        "wfstepdatagridview": {
            "title": "流程步骤信息表格视图",
            "caption": "流程步骤信息",
            "viewtype": "DEGRIDVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "WFStepDataGridView",
            "viewtag": "d27e1a51b62fe780d3468a2e0a7fe463"
        },
        "psworkfloweditview": {
            "title": "业务工作流编辑视图",
            "caption": "业务工作流",
            "viewtype": "DEEDITVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "PSWorkflowEditView",
            "viewtag": "e9cdb1f0fa6386c9c73f0389f214da05"
        },
        "pswfroledetaileditview": {
            "title": "平台流程角色成员编辑视图",
            "caption": "平台流程角色成员",
            "viewtype": "DEEDITVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "PSWFRoleDetailEditView",
            "viewtag": "ebbd1866998e34f7784792a80ef06909"
        },
        "wfworklistgridview": {
            "title": "工作流工作列表表格视图",
            "caption": "工作流工作列表",
            "viewtype": "DEGRIDVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "WFWorklistGridView",
            "viewtag": "ed2c1b6cc9ce7f7bf6a76e1478de1f96"
        },
        "wfinstanceeditview": {
            "title": "工作流实例编辑视图",
            "caption": "工作流实例",
            "viewtype": "DEEDITVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "WFInstanceEditView",
            "viewtag": "edb12bd38604a9d4d88148f588da6fb2"
        },
        "wfworklistwfdataredirectview": {
            "title": "工作流工作列表系统流程数据重定向视图",
            "caption": "工作流工作列表",
            "viewtype": "DEWFDATAREDIRECTVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "WFWorklistWFDataRedirectView",
            "viewtag": "f8491a2a26eb241ce56cf24c488187a8"
        },
        "pssystemgridview": {
            "title": "业务系统表格视图",
            "caption": "业务系统",
            "viewtype": "DEGRIDVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "PSSystemGridView",
            "viewtag": "ff9ccf00b52131e96ccf87bc091d7910"
        }
    }];
});