import { Http,Util } from '@/utils';
import EntityService from '../entity-service';



/**
 * 平台流程角色成员服务对象基类
 *
 * @export
 * @class PSWFRoleDetailServiceBase
 * @extends {EntityServie}
 */
export default class PSWFRoleDetailServiceBase extends EntityService {

    /**
     * Creates an instance of  PSWFRoleDetailServiceBase.
     * 
     * @param {*} [opts={}]
     * @memberof  PSWFRoleDetailServiceBase
     */
    constructor(opts: any = {}) {
        super(opts);
    }

    /**
     * 初始化基础数据
     *
     * @memberof PSWFRoleDetailServiceBase
     */
    public initBasicData(){
        this.APPLYDEKEY ='pswfroledetail';
        this.APPDEKEY = 'pswfroledetailid';
        this.APPDENAME = 'pswfroledetails';
        this.APPDETEXT = 'pswfroledetailname';
    }

// 实体接口

    /**
     * Select接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof PSWFRoleDetailServiceBase
     */
    public async Select(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.pswfrole && context.pswfroledetail){
            return Http.getInstance().get(`/pswfroles/${context.pswfrole}/pswfroledetails/${context.pswfroledetail}/select`,isloading);
        }
            return Http.getInstance().get(`/pswfroledetails/${context.pswfroledetail}/select`,isloading);
    }

    /**
     * Save接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof PSWFRoleDetailServiceBase
     */
    public async Save(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.pswfrole && context.pswfroledetail){
            return Http.getInstance().post(`/pswfroles/${context.pswfrole}/pswfroledetails/${context.pswfroledetail}/save`,data,isloading);
        }
        let masterData:any = {};
        Object.assign(data,masterData);
            let res:any = await  Http.getInstance().post(`/pswfroledetails/${context.pswfroledetail}/save`,data,isloading);
            return res;
    }

    /**
     * Update接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof PSWFRoleDetailServiceBase
     */
    public async Update(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.pswfrole && context.pswfroledetail){
            return Http.getInstance().put(`/pswfroles/${context.pswfrole}/pswfroledetails/${context.pswfroledetail}`,data,isloading);
        }
        let masterData:any = {};
        Object.assign(data,masterData);
            let res:any = await  Http.getInstance().put(`/pswfroledetails/${context.pswfroledetail}`,data,isloading);
            return res;
    }

    /**
     * Get接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof PSWFRoleDetailServiceBase
     */
    public async Get(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.pswfrole && context.pswfroledetail){
            return Http.getInstance().get(`/pswfroles/${context.pswfrole}/pswfroledetails/${context.pswfroledetail}`,isloading);
        }
            let res:any = await Http.getInstance().get(`/pswfroledetails/${context.pswfroledetail}`,isloading);
            return res;

    }

    /**
     * CheckKey接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof PSWFRoleDetailServiceBase
     */
    public async CheckKey(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.pswfrole && context.pswfroledetail){
            return Http.getInstance().post(`/pswfroles/${context.pswfrole}/pswfroledetails/${context.pswfroledetail}/checkkey`,data,isloading);
        }
            return Http.getInstance().post(`/pswfroledetails/${context.pswfroledetail}/checkkey`,data,isloading);
    }

    /**
     * Create接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof PSWFRoleDetailServiceBase
     */
    public async Create(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.pswfrole && true){
            data[this.APPDEKEY] = null;
            return Http.getInstance().post(`/pswfroles/${context.pswfrole}/pswfroledetails`,data,isloading);
        }
        let masterData:any = {};
        Object.assign(data,masterData);
        data[this.APPDEKEY] = null;
        let tempContext:any = JSON.parse(JSON.stringify(context));
        let res:any = await Http.getInstance().post(`/pswfroledetails`,data,isloading);
        return res;
    }

    /**
     * GetDraft接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof PSWFRoleDetailServiceBase
     */
    public async GetDraft(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.pswfrole && true){
            return Http.getInstance().get(`/pswfroles/${context.pswfrole}/pswfroledetails/getdraft`,isloading);
        }
        let res:any = await  Http.getInstance().get(`/pswfroledetails/getdraft`,isloading);
        res.data.pswfroledetail = data.pswfroledetail;
        return res;
    }

    /**
     * Remove接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof PSWFRoleDetailServiceBase
     */
    public async Remove(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.pswfrole && context.pswfroledetail){
            return Http.getInstance().delete(`/pswfroles/${context.pswfrole}/pswfroledetails/${context.pswfroledetail}`,isloading);
        }
            return Http.getInstance().delete(`/pswfroledetails/${context.pswfroledetail}`,isloading);

    }

    /**
     * FetchDefault接口方法
     *
     * @param {*} [context={}]
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof PSWFRoleDetailServiceBase
     */
    public async FetchDefault(context: any = {},data: any = {}, isloading?: boolean): Promise<any> {
        if(context.pswfrole && true){
            let tempData:any = JSON.parse(JSON.stringify(data));
            return Http.getInstance().get(`/pswfroles/${context.pswfrole}/pswfroledetails/fetchdefault`,tempData,isloading);
        }
        let tempData:any = JSON.parse(JSON.stringify(data));
        return Http.getInstance().get(`/pswfroledetails/fetchdefault`,tempData,isloading);
    }
}