import WFIAActionService from '@/service/wfiaaction/wfiaaction-service';
import { Verify } from '@/utils/verify/verify';


/**
 * Proc
 *
 * @export
 * @class ProcLogicBase
 */
export default class ProcLogicBase {

    /**
     * 名称
     * 
     * @memberof  ProcLogicBase
     */
    private name:string ="Proc";

    /**
     * 唯一标识
     * 
     * @memberof  ProcLogicBase
     */
    private id:string = "0f20b19513e4660145ffb2c454a4f7e7";

    /**
     * 默认参数名称
     * 
     * @memberof  ProcLogicBase
     */
    private defaultParamName:string = "Default";

    /**
     * Creates an instance of  ProcLogicBase.
     * 
     * @param {*} [opts={}]
     * @memberof  ProcLogicBase
     */
    constructor(opts: any = {}) {
        
    }


    /**
     * 计算0节点结果
     * 
     * @param params 传入参数
     */
    public compute0Cond(params:any):boolean{
        return true;
    }

    /**
     * 执行逻辑
     * 
     * @param context 应用上下文
     * @param params 传入参数
     */
    public onExecute(context:any,params:any,isloading:boolean){
        return this.executeBegin(context,params,isloading);
    }


    /**
    * 处理
    * 
    * @param context 应用上下文
    * @param params 传入参数
    */
    private async executeDeaction1(context:any,params:any,isloading:boolean){
        // 行为处理节点
        let result: any;
        const targetService:WFIAActionService = new WFIAActionService();
        if (targetService['Proc'] && targetService['Proc'] instanceof Function) {
            result = await targetService['Proc'](context,params, false);
        }
        if(result && result.status == 200){
            Object.assign(params,result.data);
        return params;
        }
    }

    /**
    * 开始
    * 
    * @param params 传入参数
    */
    private async executeBegin(context:any,params:any,isloading:boolean){
        //开始节点
        if(this.compute0Cond(params)){
            return this.executeDeaction1(context,params,isloading);   
        }
    }


}