/**
 * IndexView 部件模型
 *
 * @export
 * @class IndexViewModel
 */
export default class IndexViewModel {

    /**
     * 菜单项集合
     *
     * @private
     * @type {any[]}
     * @memberof IndexViewModel
     */
    private items: any[] = [
        {
	id: 'd84fa30a843802fb2dc1d85d9b71e82b',
	name: 'menuitem5',
	text: '组织人员',
	type: 'MENUITEM',
	counterid: '',
	tooltip: '组织人员',
	expanded: false,
	separator: false,
	hidden: false,
	hidesidebar: false,
	opendefault: false,
	iconcls: '',
	icon: '',
	textcls: '',
	appfunctag: '',
	resourcetag: '',
	items: [
		{
	id: '9fe6438a9b1591a15335a5994be5c7b3',
	name: 'menuitem1',
	text: '组织管理',
	type: 'MENUITEM',
	counterid: '',
	tooltip: '组织管理',
	expanded: false,
	separator: false,
	hidden: false,
	hidesidebar: false,
	opendefault: false,
	iconcls: '',
	icon: '',
	textcls: '',
	appfunctag: 'Auto19',
	resourcetag: '',
},
		{
	id: '898589ac9e2b6bf4307e036a097d9437',
	name: 'menuitem2',
	text: '部门管理',
	type: 'MENUITEM',
	counterid: '',
	tooltip: '部门管理',
	expanded: false,
	separator: false,
	hidden: false,
	hidesidebar: false,
	opendefault: false,
	iconcls: '',
	icon: '',
	textcls: '',
	appfunctag: 'Auto26',
	resourcetag: '',
},
		{
	id: 'c85cf566c50d49bf6397e141dab881b7',
	name: 'menuitem3',
	text: '组织人员',
	type: 'MENUITEM',
	counterid: '',
	tooltip: '组织人员',
	expanded: false,
	separator: false,
	hidden: false,
	hidesidebar: false,
	opendefault: false,
	iconcls: '',
	icon: '',
	textcls: '',
	appfunctag: 'Auto18',
	resourcetag: '',
},
		{
	id: '3309e9419102246bcae65d4ae85920dc',
	name: 'menuitem4',
	text: '部门人员',
	type: 'MENUITEM',
	counterid: '',
	tooltip: '部门人员',
	expanded: false,
	separator: false,
	hidden: false,
	hidesidebar: false,
	opendefault: false,
	iconcls: '',
	icon: '',
	textcls: '',
	appfunctag: 'Auto17',
	resourcetag: '',
},
	],
},
        {
	id: '7986d2312f1ec99d7ebcf203f2b0180d',
	name: 'menuitem7',
	text: '系统管理',
	type: 'MENUITEM',
	counterid: '',
	tooltip: '系统管理',
	expanded: false,
	separator: false,
	hidden: false,
	hidesidebar: false,
	opendefault: false,
	iconcls: '',
	icon: '',
	textcls: '',
	appfunctag: 'Auto30',
	resourcetag: '',
},
        {
	id: '9a0c197c5d9cd49d31dfcf4378a04d8f',
	name: 'menuitem9',
	text: '应用管理',
	type: 'MENUITEM',
	counterid: '',
	tooltip: '应用管理',
	expanded: false,
	separator: false,
	hidden: false,
	hidesidebar: false,
	opendefault: false,
	iconcls: '',
	icon: '',
	textcls: '',
	appfunctag: 'Auto24',
	resourcetag: '',
},
        {
	id: 'c3f84c25d0cafe46171d6c209917d8b3',
	name: 'menuitem8',
	text: '流程应用管理',
	type: 'MENUITEM',
	counterid: '',
	tooltip: '流程应用管理',
	expanded: false,
	separator: false,
	hidden: false,
	hidesidebar: false,
	opendefault: false,
	iconcls: '',
	icon: '',
	textcls: '',
	appfunctag: 'Auto16',
	resourcetag: '',
},
        {
	id: '54ab056af94be14db0bafcaec3397492',
	name: 'menuitem6',
	text: '工作流管理',
	type: 'MENUITEM',
	counterid: '',
	tooltip: '工作流管理',
	expanded: false,
	separator: false,
	hidden: false,
	hidesidebar: false,
	opendefault: false,
	iconcls: '',
	icon: '',
	textcls: '',
	appfunctag: 'Auto23',
	resourcetag: '',
},
        {
	id: '52d62405188655a92936785107f49e14',
	name: 'menuitem14',
	text: '流程实体管理',
	type: 'MENUITEM',
	counterid: '',
	tooltip: '流程实体管理',
	expanded: false,
	separator: false,
	hidden: false,
	hidesidebar: false,
	opendefault: false,
	iconcls: '',
	icon: '',
	textcls: '',
	appfunctag: 'Auto20',
	resourcetag: '',
},
        {
	id: '87a7a6dc78b22df01ddad340d7cda799',
	name: 'menuitem11',
	text: '流程版本管理',
	type: 'MENUITEM',
	counterid: '',
	tooltip: '流程版本管理',
	expanded: false,
	separator: false,
	hidden: false,
	hidesidebar: false,
	opendefault: false,
	iconcls: '',
	icon: '',
	textcls: '',
	appfunctag: 'Auto25',
	resourcetag: '',
},
        {
	id: 'b6a2aaebc0e2364257893a892d27b721',
	name: 'menuitem10',
	text: '流程角色',
	type: 'MENUITEM',
	counterid: '',
	tooltip: '流程角色',
	expanded: false,
	separator: false,
	hidden: false,
	hidesidebar: false,
	opendefault: false,
	iconcls: '',
	icon: '',
	textcls: '',
	appfunctag: 'Auto21',
	resourcetag: '',
},
        {
	id: '84d6cdfdc875376f0ffe0cc61f429bb2',
	name: 'menuitem12',
	text: '流程实例管理',
	type: 'MENUITEM',
	counterid: '',
	tooltip: '流程实例管理',
	expanded: false,
	separator: false,
	hidden: false,
	hidesidebar: false,
	opendefault: false,
	iconcls: '',
	icon: '',
	textcls: '',
	appfunctag: 'Auto27',
	resourcetag: '',
},
        {
	id: '4881e2b0cf75a011281e2708605548db',
	name: 'menuitem13',
	text: '流程代办',
	type: 'MENUITEM',
	counterid: '',
	tooltip: '流程代办',
	expanded: false,
	separator: false,
	hidden: false,
	hidesidebar: false,
	opendefault: false,
	iconcls: '',
	icon: '',
	textcls: '',
	appfunctag: 'Auto28',
	resourcetag: '',
},
        {
	id: 'ef42c25edfbba9b436d8df20440e29c6',
	name: 'menuitem15',
	text: '流程步骤信息',
	type: 'MENUITEM',
	counterid: '',
	tooltip: '流程步骤信息',
	expanded: false,
	separator: false,
	hidden: false,
	hidesidebar: false,
	opendefault: false,
	iconcls: '',
	icon: '',
	textcls: '',
	appfunctag: 'Auto22',
	resourcetag: '',
},
    ];

	/**
	 * 应用功能集合
	 *
	 * @private
	 * @type {any[]}
	 * @memberof IndexViewModel
	 */
	private funcs: any[] = [
        {
            appfunctag: 'Auto28',
            appfuncyype: 'APPVIEW',
            openmode: '',
            codename: 'wfworklistgridview',
            deResParameters: [],
            routepath: '/indexview/:indexview?/wfworklists/:wfworklist?/gridview/:gridview?',
            parameters: [
                { pathName: 'wfworklists', parameterName: 'wfworklist' },
                { pathName: 'gridview', parameterName: 'gridview' },
            ],
        },
        {
            appfunctag: 'Auto20',
            appfuncyype: 'APPVIEW',
            openmode: '',
            codename: 'psdewfgridview',
            deResParameters: [],
            routepath: '/indexview/:indexview?/psdewfs/:psdewf?/gridview/:gridview?',
            parameters: [
                { pathName: 'psdewfs', parameterName: 'psdewf' },
                { pathName: 'gridview', parameterName: 'gridview' },
            ],
        },
        {
            appfunctag: 'Auto16',
            appfuncyype: 'APPVIEW',
            openmode: '',
            codename: 'wfappgridview',
            deResParameters: [],
            routepath: '/indexview/:indexview?/wfapps/:wfapp?/gridview/:gridview?',
            parameters: [
                { pathName: 'wfapps', parameterName: 'wfapp' },
                { pathName: 'gridview', parameterName: 'gridview' },
            ],
        },
        {
            appfunctag: 'Auto23',
            appfuncyype: 'APPVIEW',
            openmode: '',
            codename: 'psworkflowgridview',
            deResParameters: [],
            routepath: '/indexview/:indexview?/psworkflows/:psworkflow?/gridview/:gridview?',
            parameters: [
                { pathName: 'psworkflows', parameterName: 'psworkflow' },
                { pathName: 'gridview', parameterName: 'gridview' },
            ],
        },
        {
            appfunctag: 'Auto24',
            appfuncyype: 'APPVIEW',
            openmode: '',
            codename: 'pssysappgridview',
            deResParameters: [],
            routepath: '/indexview/:indexview?/pssysapps/:pssysapp?/gridview/:gridview?',
            parameters: [
                { pathName: 'pssysapps', parameterName: 'pssysapp' },
                { pathName: 'gridview', parameterName: 'gridview' },
            ],
        },
        {
            appfunctag: 'Auto26',
            appfuncyype: 'APPVIEW',
            openmode: '',
            codename: 'orgdeptgridview',
            deResParameters: [],
            routepath: '/indexview/:indexview?/orgdepts/:orgdept?/gridview/:gridview?',
            parameters: [
                { pathName: 'orgdepts', parameterName: 'orgdept' },
                { pathName: 'gridview', parameterName: 'gridview' },
            ],
        },
        {
            appfunctag: 'Auto21',
            appfuncyype: 'APPVIEW',
            openmode: '',
            codename: 'pswfrolegridview',
            deResParameters: [],
            routepath: '/indexview/:indexview?/pswfroles/:pswfrole?/gridview/:gridview?',
            parameters: [
                { pathName: 'pswfroles', parameterName: 'pswfrole' },
                { pathName: 'gridview', parameterName: 'gridview' },
            ],
        },
        {
            appfunctag: 'Auto25',
            appfuncyype: 'APPVIEW',
            openmode: '',
            codename: 'pswfversiongridview',
            deResParameters: [],
            routepath: '/indexview/:indexview?/pswfversions/:pswfversion?/gridview/:gridview?',
            parameters: [
                { pathName: 'pswfversions', parameterName: 'pswfversion' },
                { pathName: 'gridview', parameterName: 'gridview' },
            ],
        },
        {
            appfunctag: 'Auto19',
            appfuncyype: 'APPVIEW',
            openmode: '',
            codename: 'orggridview',
            deResParameters: [],
            routepath: '/indexview/:indexview?/orgs/:org?/gridview/:gridview?',
            parameters: [
                { pathName: 'orgs', parameterName: 'org' },
                { pathName: 'gridview', parameterName: 'gridview' },
            ],
        },
        {
            appfunctag: 'Auto27',
            appfuncyype: 'APPVIEW',
            openmode: '',
            codename: 'wfinstancegridview',
            deResParameters: [],
            routepath: '/indexview/:indexview?/wfinstances/:wfinstance?/gridview/:gridview?',
            parameters: [
                { pathName: 'wfinstances', parameterName: 'wfinstance' },
                { pathName: 'gridview', parameterName: 'gridview' },
            ],
        },
        {
            appfunctag: 'Auto18',
            appfuncyype: 'APPVIEW',
            openmode: '',
            codename: 'orgusergridview',
            deResParameters: [],
            routepath: '/indexview/:indexview?/orgusers/:orguser?/gridview/:gridview?',
            parameters: [
                { pathName: 'orgusers', parameterName: 'orguser' },
                { pathName: 'gridview', parameterName: 'gridview' },
            ],
        },
        {
            appfunctag: 'Auto22',
            appfuncyype: 'APPVIEW',
            openmode: '',
            codename: 'wfstepdatagridview',
            deResParameters: [],
            routepath: '/indexview/:indexview?/wfstepdata/:wfstepdata?/gridview/:gridview?',
            parameters: [
                { pathName: 'wfstepdata', parameterName: 'wfstepdata' },
                { pathName: 'gridview', parameterName: 'gridview' },
            ],
        },
        {
            appfunctag: 'Auto17',
            appfuncyype: 'APPVIEW',
            openmode: '',
            codename: 'orgdeptusergridview',
            deResParameters: [],
            routepath: '/indexview/:indexview?/orgdeptusers/:orgdeptuser?/gridview/:gridview?',
            parameters: [
                { pathName: 'orgdeptusers', parameterName: 'orgdeptuser' },
                { pathName: 'gridview', parameterName: 'gridview' },
            ],
        },
        {
            appfunctag: 'Auto30',
            appfuncyype: 'APPVIEW',
            openmode: '',
            codename: 'pssystemgridview',
            deResParameters: [],
            routepath: '/indexview/:indexview?/pssystems/:pssystem?/gridview/:gridview?',
            parameters: [
                { pathName: 'pssystems', parameterName: 'pssystem' },
                { pathName: 'gridview', parameterName: 'gridview' },
            ],
        },
	];

    /**
     * 获取所有菜单项集合
     *
     * @returns {any[]}
     * @memberof IndexViewModel
     */
    public getAppMenuItems(): any[] {
        return this.items;
    }

    /**
     * 获取所有应用功能集合
     *
     * @returns {any[]}
     * @memberof IndexViewModel
     */
    public getAppFuncs(): any[] {
        return this.funcs;
    }
}