/**
 * Main 部件模型
 *
 * @export
 * @class MainModel
 */
export default class MainModel {

	/**
	 * 获取数据项集合
	 *
	 * @returns {any[]}
	 * @memberof MainGridMode
	 */
	public getDataItems(): any[] {
		return [
			{
				name: 'endtime',
				prop: 'endtime',
				dataType: 'DATETIME',
			},
			{
				name: 'isclosed',
				prop: 'isclosed',
				dataType: 'YESNO',
			},
			{
				name: 'wfinstancename',
				prop: 'wfinstancename',
				dataType: 'TEXT',
			},
			{
				name: 'starttime',
				prop: 'starttime',
				dataType: 'DATETIME',
			},
			{
				name: 'wfinstanceid',
				prop: 'wfinstanceid',
				dataType: 'GUID',
			},
			{
				name: 'pswfversionid',
				prop: 'pswfversionid',
				dataType: 'PICKUP',
			},
			{
				name: 'srfmajortext',
				prop: 'wfinstancename',
				dataType: 'TEXT',
			},
			{
				name: 'srfdataaccaction',
				prop: 'wfinstanceid',
				dataType: 'GUID',
			},
			{
				name: 'srfkey',
				prop: 'wfinstanceid',
				dataType: 'GUID',
			},
			{
				name: 'orgdeptid',
				prop: 'orgdeptid',
				dataType: 'PICKUP',
			},
			{
				name: 'wfstate',
				prop: 'wfstate',
				dataType: 'SSCODELIST',
			},
			{
				name: 'orgid',
				prop: 'orgid',
				dataType: 'PICKUP',
			},
			{
				name: 'bsdata',
				prop: 'bsdata',
				dataType: 'TEXT',
			},
			{
				name: 'curstep',
				prop: 'curstep',
				dataType: 'TEXT',
			},
			{
				name: 'owner',
				prop: 'owner',
				dataType: 'TEXT',
			},
			{
				name: 'psworkflowid',
				prop: 'psworkflowid',
				dataType: 'PICKUP',
			},
			{
				name: 'wfengineid',
				prop: 'wfengineid',
				dataType: 'PICKUP',
			},
			{
				name: 'prevstep',
				prop: 'prevstep',
				dataType: 'TEXT',
			},
			{
				name: 'updatedate',
				prop: 'updatedate',
				dataType: 'DATETIME',
			},
			{
				name: 'bswfdata',
				prop: 'bswfdata',
				dataType: 'TEXT',
			},
			{
				name: 'wfengineinstanceid',
				prop: 'wfengineinstanceid',
				dataType: 'TEXT',
			},
			{
				name: 'wfinstance',
				prop: 'wfinstanceid',
			},


      {
        name:'size',
        prop:'size'
      },
      {
        name:'query',
        prop:'query'
      },
      {
        name:'page',
        prop:'page'
      },
      {
        name:'sort',
        prop:'sort'
      },
      {
        name:'srfparentdata',
        prop:'srfparentdata'
      }
		]
	}

}