import { Http,Util,Errorlog } from '@/utils';
import ControlService from '@/widgets/control-service';
import SelectIndexViewModel from './select-index-view-appmenu-model';


/**
 * SelectIndexView 部件服务对象
 *
 * @export
 * @class SelectIndexViewService
 */
export default class SelectIndexViewService extends ControlService {

    /**
     * 设置从数据模式
     *
     * @type {boolean}
     * @memberof SelectIndexViewService
     */
    public setTempMode(){
        this.isTempMode = false;
    }

    /**
     * Creates an instance of SelectIndexViewService.
     * 
     * @param {*} [opts={}]
     * @memberof SelectIndexViewService
     */
    constructor(opts: any = {}) {
        super(opts);
        this.model = new SelectIndexViewModel();
    }

    /**
     * 获取数据
     *
     * @returns {Promise<any>}
     * @memberof SelectIndexView
     */
    @Errorlog
    public get(params: any = {}): Promise<any> {
        return Http.getInstance().get('v7/select-index-viewappmenu', params);
    }

}