import { MockAdapter } from '../mock-adapter';
const mock = MockAdapter.getInstance();

import Mock from 'mockjs'

// 获取studio链接数据
mock.onGet('./assets/json/view-config.json').reply((config: any) => {
    let status = MockAdapter.mockStatus(config);
    return [status,{
                "orgdeptwfvereditview": {
            "title": "部门流程版本编辑视图",
            "caption": "部门流程版本",
            "viewtype": "DEEDITVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "OrgDeptWFVerEditView",
            "viewtag": "03dc2d639f88e911f62733b728f372d4"
        },
        "orgeditview": {
            "title": "组织（公司）编辑视图",
            "caption": "组织",
            "viewtype": "DEEDITVIEW",
            "viewmodule": "r7rt_org",
            "viewname": "OrgEditView",
            "viewtag": "065464965c46a3702da9c605bd2f0d4d"
        },
        "pswfversionpickupview": {
            "title": "业务流程版本数据选择视图",
            "caption": "业务流程版本",
            "viewtype": "DEPICKUPVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "PSWFVersionPickupView",
            "viewtag": "09940528a9d6701f647081603ed0eff2"
        },
        "psworkflowcurorggridview": {
            "title": "业务工作流表格视图",
            "caption": "业务工作流",
            "viewtype": "DEGRIDVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "PSWorkflowCurOrgGridView",
            "viewtag": "1234947aec0be8b05bd03089af079b31"
        },
        "orgpickupgridview": {
            "title": "组织（公司）选择表格视图",
            "caption": "组织",
            "viewtype": "DEPICKUPGRIDVIEW",
            "viewmodule": "r7rt_org",
            "viewname": "OrgPickupGridView",
            "viewtag": "2a6f77a1e9d6981ecaf52f903eef096c"
        },
        "psworkflowpickupgridview": {
            "title": "业务工作流选择表格视图",
            "caption": "业务工作流",
            "viewtype": "DEPICKUPGRIDVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "PSWorkflowPickupGridView",
            "viewtag": "366692d31eb2ac8c40ebe6c86384fcf3"
        },
        "orgusereditview3": {
            "title": "组织用户编辑视图",
            "caption": "组织用户",
            "viewtype": "DEEDITVIEW3",
            "viewmodule": "r7rt_org",
            "viewname": "OrgUserEditView3",
            "viewtag": "4b01b93a2636dba41af4f18daedeccb4"
        },
        "orgdeptpickupview": {
            "title": "部门数据选择视图",
            "caption": "部门",
            "viewtype": "DEPICKUPVIEW",
            "viewmodule": "r7rt_org",
            "viewname": "OrgDeptPickupView",
            "viewtag": "517b40c4b9c6b28be806a4b5d0f85222"
        },
        "orgdeptwfvercurorgdeptgridview": {
            "title": "部门流程版本表格视图",
            "caption": "部门流程版本",
            "viewtype": "DEGRIDVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "OrgDeptWFVerCurOrgDeptGridView",
            "viewtag": "582296a7dbe318e725c2a654bee90936"
        },
        "pswfrolecurorgdeptgridview": {
            "title": "平台流程角色表格视图",
            "caption": "平台流程角色",
            "viewtype": "DEGRIDVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "PSWFRoleCurOrgDeptGridView",
            "viewtag": "65e0f149407f5506f82a3eca5e6488ce"
        },
        "orggridview": {
            "title": "组织（公司）表格视图",
            "caption": "组织",
            "viewtype": "DEGRIDVIEW",
            "viewmodule": "r7rt_org",
            "viewname": "OrgGridView",
            "viewtag": "6b6eee275b2b094ede8a87c2efeeda79"
        },
        "orgdeptpickupgridview": {
            "title": "部门选择表格视图",
            "caption": "部门",
            "viewtype": "DEPICKUPGRIDVIEW",
            "viewmodule": "r7rt_org",
            "viewname": "OrgDeptPickupGridView",
            "viewtag": "7382082a6cf39f474cfea6b993a069dd"
        },
        "indexview": {
            "title": "工作流平台首页",
            "caption": "工作流平台首页",
            "viewtype": "APPINDEXVIEW",
            "viewmodule": "Ungroup",
            "viewname": "IndexView",
            "viewtag": "75c1ce2bb6d3d4868f790585c4ef32f0"
        },
        "orgusergridview": {
            "title": "组织用户表格视图",
            "caption": "组织用户",
            "viewtype": "DEGRIDVIEW",
            "viewmodule": "r7rt_org",
            "viewname": "OrgUserGridView",
            "viewtag": "76076f07c06c3e3c65d8c0f1c31bec75"
        },
        "orgdeptusereditview": {
            "title": "部门用户编辑视图",
            "caption": "部门用户",
            "viewtype": "DEEDITVIEW",
            "viewmodule": "r7rt_org",
            "viewname": "OrgDeptUserEditView",
            "viewtag": "80ac21c88fe2c4dca200aaaf25f5be1a"
        },
        "orgpickupview": {
            "title": "组织（公司）数据选择视图",
            "caption": "组织",
            "viewtype": "DEPICKUPVIEW",
            "viewmodule": "r7rt_org",
            "viewname": "OrgPickupView",
            "viewtag": "814bf0933c3c768da21b2421e4006ff1"
        },
        "orguserpickupgridview": {
            "title": "组织用户选择表格视图",
            "caption": "组织用户",
            "viewtype": "DEPICKUPGRIDVIEW",
            "viewmodule": "r7rt_org",
            "viewname": "OrgUserPickupGridView",
            "viewtag": "82bf3b27b07d3330ac31284132f2232f"
        },
        "orguserpickupview": {
            "title": "组织用户数据选择视图",
            "caption": "组织用户",
            "viewtype": "DEPICKUPVIEW",
            "viewmodule": "r7rt_org",
            "viewname": "OrgUserPickupView",
            "viewtag": "8ecff770ed9c413f75721c1958f49e2d"
        },
        "pswfroledetaileditview": {
            "title": "平台流程角色成员编辑视图",
            "caption": "平台流程角色成员",
            "viewtype": "DEEDITVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "PSWFRoleDetailEditView",
            "viewtag": "93cebef6c377caf55632af047c6aab32"
        },
        "pswfroledetailgridview": {
            "title": "平台流程角色成员表格视图",
            "caption": "平台流程角色成员",
            "viewtype": "DEGRIDVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "PSWFRoleDetailGridView",
            "viewtag": "a71bf778908e4dd566ca6d1427005256"
        },
        "orgdeptgridview": {
            "title": "部门表格视图",
            "caption": "部门",
            "viewtype": "DEGRIDVIEW",
            "viewmodule": "r7rt_org",
            "viewname": "OrgDeptGridView",
            "viewtag": "b1e4d169d98d40910a7673cc3ff24853"
        },
        "psworkflowcurorgdeptgridview": {
            "title": "业务工作流表格视图",
            "caption": "业务工作流",
            "viewtype": "DEGRIDVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "PSWorkflowCurOrgDeptGridView",
            "viewtag": "b432c22567d14b787a5d8cda5a9b3539"
        },
        "pswfrolegridview": {
            "title": "平台流程角色表格视图",
            "caption": "平台流程角色",
            "viewtype": "DEGRIDVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "PSWFRoleGridView",
            "viewtag": "bc5620c228a9492ffdbec77c3fb2bd8b"
        },
        "pswfversionpickupgridview": {
            "title": "业务流程版本选择表格视图",
            "caption": "业务流程版本",
            "viewtype": "DEPICKUPGRIDVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "PSWFVersionPickupGridView",
            "viewtag": "c54210054d1d6078ce1de7ff94b8d754"
        },
        "psworkflowpickupview": {
            "title": "业务工作流数据选择视图",
            "caption": "业务工作流",
            "viewtype": "DEPICKUPVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "PSWorkflowPickupView",
            "viewtag": "c67105b6d2a193144ae9c9a3b8f1cdc0"
        },
        "pswfroleeditview": {
            "title": "平台流程角色编辑视图",
            "caption": "平台流程角色",
            "viewtype": "DEEDITVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "PSWFRoleEditView",
            "viewtag": "cbd54543048cfc64a63024e318bd5d4f"
        },
        "pswfrolecurorggridview": {
            "title": "平台流程角色表格视图",
            "caption": "平台流程角色",
            "viewtype": "DEGRIDVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "PSWFRoleCurOrgGridView",
            "viewtag": "d4eca407aab9f384888398971afb36a1"
        },
        "psworkfloweditview": {
            "title": "业务工作流编辑视图",
            "caption": "业务工作流",
            "viewtype": "DEEDITVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "PSWorkflowEditView",
            "viewtag": "d6b7d25a18608eab14d7f42975ea6791"
        },
        "orgdepteditview": {
            "title": "部门编辑视图",
            "caption": "部门",
            "viewtype": "DEEDITVIEW",
            "viewmodule": "r7rt_org",
            "viewname": "OrgDeptEditView",
            "viewtag": "d9374f5d91d97de220b782c649fb53fa"
        },
        "workfloweditview": {
            "title": "统一工作流编辑视图",
            "caption": "统一工作流",
            "viewtype": "DEEDITVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "WorkflowEditView",
            "viewtag": "e40921fb444ef00c363be7032462c0a6"
        },
        "orgdeptusergridview": {
            "title": "部门用户表格视图",
            "caption": "部门用户",
            "viewtype": "DEGRIDVIEW",
            "viewmodule": "r7rt_org",
            "viewname": "OrgDeptUserGridView",
            "viewtag": "efd78d7c338a3f8941ef598dbb1dd4dc"
        },
        "pswfversioneditview": {
            "title": "业务流程版本编辑视图",
            "caption": "业务流程版本",
            "viewtype": "DEEDITVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "PSWFVersionEditView",
            "viewtag": "f291220dd7b0a105fffdccdbeac6cf2a"
        },
        "psworkflowgridview": {
            "title": "业务工作流表格视图",
            "caption": "业务工作流",
            "viewtype": "DEGRIDVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "PSWorkflowGridView",
            "viewtag": "f8681a65f8fdcc0e98943de6d0b574b0"
        },
        "pswfversiongridview": {
            "title": "业务流程版本表格视图",
            "caption": "业务流程版本",
            "viewtype": "DEGRIDVIEW",
            "viewmodule": "r7rt_wf",
            "viewname": "PSWFVersionGridView",
            "viewtag": "fa5293339f568e63015269cd2458617b"
        }
    }];
});