package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import java.io.Serializable;

/**
 * 实体[流程连接]
 */
public class PSWFLink implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 更新时间
     */
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp updateDate;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean updateDateDirtyFlag;

    /**
     * 逻辑名称
     */
    private String logicName;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean logicNameDirtyFlag;

    /**
     * 建立时间
     */
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp createDate;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean createDateDirtyFlag;

    /**
     * 流程连接标识
     */
    private String pSWFLinkId;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean pSWFLinkIdDirtyFlag;

    /**
     * 更新人
     */
    private String updateMan;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean updateManDirtyFlag;

    /**
     * 建立人
     */
    private String createMan;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean createManDirtyFlag;

    /**
     * 流程连接名称
     */
    private String pSWFLinkName;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean pSWFLinkNameDirtyFlag;

    /**
     * 流程处理标识
     */
    private String frompswfprocid;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean frompswfprocidDirtyFlag;

    /**
     * 业务流程版本标识
     */
    private String pSWFVersionId;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean pSWFVersionIdDirtyFlag;

    /**
     * 流程处理标识
     */
    private String topswfprocid;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean topswfprocidDirtyFlag;


    /**
     * 获取 [更新时间]
     */
    @JsonProperty("updatedate")
    @JSONField(name="updatedate")
    public Timestamp getUpdateDate(){
        return this.updateDate ;
    }

    /**
     * 设置 [更新时间]
     */
    @JsonProperty("updatedate")
    @JSONField(name="updatedate")
    public void setUpdateDate(Timestamp updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [更新时间]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getUpdateDateDirtyFlag(){
        return this.updateDateDirtyFlag ;
    }
    /**
     * 获取 [逻辑名称]
     */
    @JsonProperty("logicname")
    @JSONField(name="logicname")
    public String getLogicName(){
        return this.logicName ;
    }

    /**
     * 设置 [逻辑名称]
     */
    @JsonProperty("logicname")
    @JSONField(name="logicname")
    public void setLogicName(String logicName){
        this.logicName = logicName ;
        this.logicNameDirtyFlag = true ;
    }

    /**
     * 获取 [逻辑名称]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getLogicNameDirtyFlag(){
        return this.logicNameDirtyFlag ;
    }
    /**
     * 获取 [建立时间]
     */
    @JsonProperty("createdate")
    @JSONField(name="createdate")
    public Timestamp getCreateDate(){
        return this.createDate ;
    }

    /**
     * 设置 [建立时间]
     */
    @JsonProperty("createdate")
    @JSONField(name="createdate")
    public void setCreateDate(Timestamp createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [建立时间]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getCreateDateDirtyFlag(){
        return this.createDateDirtyFlag ;
    }
    /**
     * 获取 [流程连接标识]
     */
    @JsonProperty("pswflinkid")
    @JSONField(name="pswflinkid")
    public String getPSWFLinkId(){
        return this.pSWFLinkId ;
    }

    /**
     * 设置 [流程连接标识]
     */
    @JsonProperty("pswflinkid")
    @JSONField(name="pswflinkid")
    public void setPSWFLinkId(String pSWFLinkId){
        this.pSWFLinkId = pSWFLinkId ;
        this.pSWFLinkIdDirtyFlag = true ;
    }

    /**
     * 获取 [流程连接标识]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getPSWFLinkIdDirtyFlag(){
        return this.pSWFLinkIdDirtyFlag ;
    }
    /**
     * 获取 [更新人]
     */
    @JsonProperty("updateman")
    @JSONField(name="updateman")
    public String getUpdateMan(){
        return this.updateMan ;
    }

    /**
     * 设置 [更新人]
     */
    @JsonProperty("updateman")
    @JSONField(name="updateman")
    public void setUpdateMan(String updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [更新人]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getUpdateManDirtyFlag(){
        return this.updateManDirtyFlag ;
    }
    /**
     * 获取 [建立人]
     */
    @JsonProperty("createman")
    @JSONField(name="createman")
    public String getCreateMan(){
        return this.createMan ;
    }

    /**
     * 设置 [建立人]
     */
    @JsonProperty("createman")
    @JSONField(name="createman")
    public void setCreateMan(String createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [建立人]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getCreateManDirtyFlag(){
        return this.createManDirtyFlag ;
    }
    /**
     * 获取 [流程连接名称]
     */
    @JsonProperty("pswflinkname")
    @JSONField(name="pswflinkname")
    public String getPSWFLinkName(){
        return this.pSWFLinkName ;
    }

    /**
     * 设置 [流程连接名称]
     */
    @JsonProperty("pswflinkname")
    @JSONField(name="pswflinkname")
    public void setPSWFLinkName(String pSWFLinkName){
        this.pSWFLinkName = pSWFLinkName ;
        this.pSWFLinkNameDirtyFlag = true ;
    }

    /**
     * 获取 [流程连接名称]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getPSWFLinkNameDirtyFlag(){
        return this.pSWFLinkNameDirtyFlag ;
    }
    /**
     * 获取 [流程处理标识]
     */
    @JsonProperty("frompswfprocid")
    @JSONField(name="frompswfprocid")
    public String getFrompswfprocid(){
        return this.frompswfprocid ;
    }

    /**
     * 设置 [流程处理标识]
     */
    @JsonProperty("frompswfprocid")
    @JSONField(name="frompswfprocid")
    public void setFrompswfprocid(String frompswfprocid){
        this.frompswfprocid = frompswfprocid ;
        this.frompswfprocidDirtyFlag = true ;
    }

    /**
     * 获取 [流程处理标识]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getFrompswfprocidDirtyFlag(){
        return this.frompswfprocidDirtyFlag ;
    }
    /**
     * 获取 [业务流程版本标识]
     */
    @JsonProperty("pswfversionid")
    @JSONField(name="pswfversionid")
    public String getPSWFVersionId(){
        return this.pSWFVersionId ;
    }

    /**
     * 设置 [业务流程版本标识]
     */
    @JsonProperty("pswfversionid")
    @JSONField(name="pswfversionid")
    public void setPSWFVersionId(String pSWFVersionId){
        this.pSWFVersionId = pSWFVersionId ;
        this.pSWFVersionIdDirtyFlag = true ;
    }

    /**
     * 获取 [业务流程版本标识]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getPSWFVersionIdDirtyFlag(){
        return this.pSWFVersionIdDirtyFlag ;
    }
    /**
     * 获取 [流程处理标识]
     */
    @JsonProperty("topswfprocid")
    @JSONField(name="topswfprocid")
    public String getTopswfprocid(){
        return this.topswfprocid ;
    }

    /**
     * 设置 [流程处理标识]
     */
    @JsonProperty("topswfprocid")
    @JSONField(name="topswfprocid")
    public void setTopswfprocid(String topswfprocid){
        this.topswfprocid = topswfprocid ;
        this.topswfprocidDirtyFlag = true ;
    }

    /**
     * 获取 [流程处理标识]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getTopswfprocidDirtyFlag(){
        return this.topswfprocidDirtyFlag ;
    }

}

