package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import java.io.Serializable;

/**
 * 实体[流程处理]
 */
public class PSWFProcess implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 更新人
     */
    private String updateMan;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean updateManDirtyFlag;

    /**
     * 建立人
     */
    private String createMan;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean createManDirtyFlag;

    /**
     * 预定义行为
     */
    private String preDefinedActions;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean preDefinedActionsDirtyFlag;

    /**
     * 处理类型
     */
    private String wFProcessType;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean wFProcessTypeDirtyFlag;

    /**
     * 流程处理名称
     */
    private String pSWFProcessName;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean pSWFProcessNameDirtyFlag;

    /**
     * 流程处理标识
     */
    private String pSWFProcessId;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean pSWFProcessIdDirtyFlag;

    /**
     * 更新时间
     */
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp updateDate;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean updateDateDirtyFlag;

    /**
     * 步骤值
     */
    private String wFStepValue;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean wFStepValueDirtyFlag;

    /**
     * 多实例模式
     */
    private String multiInstMode;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean multiInstModeDirtyFlag;

    /**
     * 建立时间
     */
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp createDate;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean createDateDirtyFlag;

    /**
     * 步骤名称
     */
    private String wFStepName;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean wFStepNameDirtyFlag;

    /**
     * 业务流程版本名称
     */
    private String pSWFVersionName;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean pSWFVersionNameDirtyFlag;

    /**
     * 业务工作流标识
     */
    private String targetpswfid;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean targetpswfidDirtyFlag;

    /**
     * 业务流程版本标识
     */
    private String pSWFVersionId;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean pSWFVersionIdDirtyFlag;


    /**
     * 获取 [更新人]
     */
    @JsonProperty("updateman")
    @JSONField(name="updateman")
    public String getUpdateMan(){
        return this.updateMan ;
    }

    /**
     * 设置 [更新人]
     */
    @JsonProperty("updateman")
    @JSONField(name="updateman")
    public void setUpdateMan(String updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [更新人]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getUpdateManDirtyFlag(){
        return this.updateManDirtyFlag ;
    }
    /**
     * 获取 [建立人]
     */
    @JsonProperty("createman")
    @JSONField(name="createman")
    public String getCreateMan(){
        return this.createMan ;
    }

    /**
     * 设置 [建立人]
     */
    @JsonProperty("createman")
    @JSONField(name="createman")
    public void setCreateMan(String createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [建立人]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getCreateManDirtyFlag(){
        return this.createManDirtyFlag ;
    }
    /**
     * 获取 [预定义行为]
     */
    @JsonProperty("predefinedactions")
    @JSONField(name="predefinedactions")
    public String getPreDefinedActions(){
        return this.preDefinedActions ;
    }

    /**
     * 设置 [预定义行为]
     */
    @JsonProperty("predefinedactions")
    @JSONField(name="predefinedactions")
    public void setPreDefinedActions(String preDefinedActions){
        this.preDefinedActions = preDefinedActions ;
        this.preDefinedActionsDirtyFlag = true ;
    }

    /**
     * 获取 [预定义行为]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getPreDefinedActionsDirtyFlag(){
        return this.preDefinedActionsDirtyFlag ;
    }
    /**
     * 获取 [处理类型]
     */
    @JsonProperty("wfprocesstype")
    @JSONField(name="wfprocesstype")
    public String getWFProcessType(){
        return this.wFProcessType ;
    }

    /**
     * 设置 [处理类型]
     */
    @JsonProperty("wfprocesstype")
    @JSONField(name="wfprocesstype")
    public void setWFProcessType(String wFProcessType){
        this.wFProcessType = wFProcessType ;
        this.wFProcessTypeDirtyFlag = true ;
    }

    /**
     * 获取 [处理类型]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getWFProcessTypeDirtyFlag(){
        return this.wFProcessTypeDirtyFlag ;
    }
    /**
     * 获取 [流程处理名称]
     */
    @JsonProperty("pswfprocessname")
    @JSONField(name="pswfprocessname")
    public String getPSWFProcessName(){
        return this.pSWFProcessName ;
    }

    /**
     * 设置 [流程处理名称]
     */
    @JsonProperty("pswfprocessname")
    @JSONField(name="pswfprocessname")
    public void setPSWFProcessName(String pSWFProcessName){
        this.pSWFProcessName = pSWFProcessName ;
        this.pSWFProcessNameDirtyFlag = true ;
    }

    /**
     * 获取 [流程处理名称]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getPSWFProcessNameDirtyFlag(){
        return this.pSWFProcessNameDirtyFlag ;
    }
    /**
     * 获取 [流程处理标识]
     */
    @JsonProperty("pswfprocessid")
    @JSONField(name="pswfprocessid")
    public String getPSWFProcessId(){
        return this.pSWFProcessId ;
    }

    /**
     * 设置 [流程处理标识]
     */
    @JsonProperty("pswfprocessid")
    @JSONField(name="pswfprocessid")
    public void setPSWFProcessId(String pSWFProcessId){
        this.pSWFProcessId = pSWFProcessId ;
        this.pSWFProcessIdDirtyFlag = true ;
    }

    /**
     * 获取 [流程处理标识]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getPSWFProcessIdDirtyFlag(){
        return this.pSWFProcessIdDirtyFlag ;
    }
    /**
     * 获取 [更新时间]
     */
    @JsonProperty("updatedate")
    @JSONField(name="updatedate")
    public Timestamp getUpdateDate(){
        return this.updateDate ;
    }

    /**
     * 设置 [更新时间]
     */
    @JsonProperty("updatedate")
    @JSONField(name="updatedate")
    public void setUpdateDate(Timestamp updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [更新时间]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getUpdateDateDirtyFlag(){
        return this.updateDateDirtyFlag ;
    }
    /**
     * 获取 [步骤值]
     */
    @JsonProperty("wfstepvalue")
    @JSONField(name="wfstepvalue")
    public String getWFStepValue(){
        return this.wFStepValue ;
    }

    /**
     * 设置 [步骤值]
     */
    @JsonProperty("wfstepvalue")
    @JSONField(name="wfstepvalue")
    public void setWFStepValue(String wFStepValue){
        this.wFStepValue = wFStepValue ;
        this.wFStepValueDirtyFlag = true ;
    }

    /**
     * 获取 [步骤值]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getWFStepValueDirtyFlag(){
        return this.wFStepValueDirtyFlag ;
    }
    /**
     * 获取 [多实例模式]
     */
    @JsonProperty("multiinstmode")
    @JSONField(name="multiinstmode")
    public String getMultiInstMode(){
        return this.multiInstMode ;
    }

    /**
     * 设置 [多实例模式]
     */
    @JsonProperty("multiinstmode")
    @JSONField(name="multiinstmode")
    public void setMultiInstMode(String multiInstMode){
        this.multiInstMode = multiInstMode ;
        this.multiInstModeDirtyFlag = true ;
    }

    /**
     * 获取 [多实例模式]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getMultiInstModeDirtyFlag(){
        return this.multiInstModeDirtyFlag ;
    }
    /**
     * 获取 [建立时间]
     */
    @JsonProperty("createdate")
    @JSONField(name="createdate")
    public Timestamp getCreateDate(){
        return this.createDate ;
    }

    /**
     * 设置 [建立时间]
     */
    @JsonProperty("createdate")
    @JSONField(name="createdate")
    public void setCreateDate(Timestamp createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [建立时间]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getCreateDateDirtyFlag(){
        return this.createDateDirtyFlag ;
    }
    /**
     * 获取 [步骤名称]
     */
    @JsonProperty("wfstepname")
    @JSONField(name="wfstepname")
    public String getWFStepName(){
        return this.wFStepName ;
    }

    /**
     * 设置 [步骤名称]
     */
    @JsonProperty("wfstepname")
    @JSONField(name="wfstepname")
    public void setWFStepName(String wFStepName){
        this.wFStepName = wFStepName ;
        this.wFStepNameDirtyFlag = true ;
    }

    /**
     * 获取 [步骤名称]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getWFStepNameDirtyFlag(){
        return this.wFStepNameDirtyFlag ;
    }
    /**
     * 获取 [业务流程版本名称]
     */
    @JsonProperty("pswfversionname")
    @JSONField(name="pswfversionname")
    public String getPSWFVersionName(){
        return this.pSWFVersionName ;
    }

    /**
     * 设置 [业务流程版本名称]
     */
    @JsonProperty("pswfversionname")
    @JSONField(name="pswfversionname")
    public void setPSWFVersionName(String pSWFVersionName){
        this.pSWFVersionName = pSWFVersionName ;
        this.pSWFVersionNameDirtyFlag = true ;
    }

    /**
     * 获取 [业务流程版本名称]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getPSWFVersionNameDirtyFlag(){
        return this.pSWFVersionNameDirtyFlag ;
    }
    /**
     * 获取 [业务工作流标识]
     */
    @JsonProperty("targetpswfid")
    @JSONField(name="targetpswfid")
    public String getTargetpswfid(){
        return this.targetpswfid ;
    }

    /**
     * 设置 [业务工作流标识]
     */
    @JsonProperty("targetpswfid")
    @JSONField(name="targetpswfid")
    public void setTargetpswfid(String targetpswfid){
        this.targetpswfid = targetpswfid ;
        this.targetpswfidDirtyFlag = true ;
    }

    /**
     * 获取 [业务工作流标识]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getTargetpswfidDirtyFlag(){
        return this.targetpswfidDirtyFlag ;
    }
    /**
     * 获取 [业务流程版本标识]
     */
    @JsonProperty("pswfversionid")
    @JSONField(name="pswfversionid")
    public String getPSWFVersionId(){
        return this.pSWFVersionId ;
    }

    /**
     * 设置 [业务流程版本标识]
     */
    @JsonProperty("pswfversionid")
    @JSONField(name="pswfversionid")
    public void setPSWFVersionId(String pSWFVersionId){
        this.pSWFVersionId = pSWFVersionId ;
        this.pSWFVersionIdDirtyFlag = true ;
    }

    /**
     * 获取 [业务流程版本标识]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getPSWFVersionIdDirtyFlag(){
        return this.pSWFVersionIdDirtyFlag ;
    }

}

