package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import java.io.Serializable;

/**
 * 实体[业务工作流]
 */
public class PSWorkflow implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 引擎类型
     */
    private String wfenginetype;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean wfenginetypeDirtyFlag;

    /**
     * 更新人
     */
    private String updateMan;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean updateManDirtyFlag;

    /**
     * 建立时间
     */
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp createDate;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean createDateDirtyFlag;

    /**
     * 工作流类型
     */
    private String wftype;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean wftypeDirtyFlag;

    /**
     * 建立人
     */
    private String createMan;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean createManDirtyFlag;

    /**
     * 业务工作流标识
     */
    private String pSWorkflowId;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean pSWorkflowIdDirtyFlag;

    /**
     * 更新时间
     */
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp updateDate;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean updateDateDirtyFlag;

    /**
     * 工作流名称
     */
    private String pSWFWorkflowName;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean pSWFWorkflowNameDirtyFlag;

    /**
     * 工作流名称
     */
    private String logicName;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean logicNameDirtyFlag;

    /**
     * 部门名称
     */
    private String orgDeptName;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean orgDeptNameDirtyFlag;

    /**
     * 组织名称
     */
    private String orgName;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean orgNameDirtyFlag;

    /**
     * 部门标识
     */
    private String orgDeptId;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean orgDeptIdDirtyFlag;

    /**
     * 组织标识
     */
    private String orgId;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean orgIdDirtyFlag;

    /**
     * 业务系统标识
     */
    private String pSSystemId;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean pSSystemIdDirtyFlag;


    /**
     * 获取 [引擎类型]
     */
    @JsonProperty("wfenginetype")
    @JSONField(name="wfenginetype")
    public String getWfenginetype(){
        return this.wfenginetype ;
    }

    /**
     * 设置 [引擎类型]
     */
    @JsonProperty("wfenginetype")
    @JSONField(name="wfenginetype")
    public void setWfenginetype(String wfenginetype){
        this.wfenginetype = wfenginetype ;
        this.wfenginetypeDirtyFlag = true ;
    }

    /**
     * 获取 [引擎类型]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getWfenginetypeDirtyFlag(){
        return this.wfenginetypeDirtyFlag ;
    }
    /**
     * 获取 [更新人]
     */
    @JsonProperty("updateman")
    @JSONField(name="updateman")
    public String getUpdateMan(){
        return this.updateMan ;
    }

    /**
     * 设置 [更新人]
     */
    @JsonProperty("updateman")
    @JSONField(name="updateman")
    public void setUpdateMan(String updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [更新人]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getUpdateManDirtyFlag(){
        return this.updateManDirtyFlag ;
    }
    /**
     * 获取 [建立时间]
     */
    @JsonProperty("createdate")
    @JSONField(name="createdate")
    public Timestamp getCreateDate(){
        return this.createDate ;
    }

    /**
     * 设置 [建立时间]
     */
    @JsonProperty("createdate")
    @JSONField(name="createdate")
    public void setCreateDate(Timestamp createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [建立时间]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getCreateDateDirtyFlag(){
        return this.createDateDirtyFlag ;
    }
    /**
     * 获取 [工作流类型]
     */
    @JsonProperty("wftype")
    @JSONField(name="wftype")
    public String getWftype(){
        return this.wftype ;
    }

    /**
     * 设置 [工作流类型]
     */
    @JsonProperty("wftype")
    @JSONField(name="wftype")
    public void setWftype(String wftype){
        this.wftype = wftype ;
        this.wftypeDirtyFlag = true ;
    }

    /**
     * 获取 [工作流类型]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getWftypeDirtyFlag(){
        return this.wftypeDirtyFlag ;
    }
    /**
     * 获取 [建立人]
     */
    @JsonProperty("createman")
    @JSONField(name="createman")
    public String getCreateMan(){
        return this.createMan ;
    }

    /**
     * 设置 [建立人]
     */
    @JsonProperty("createman")
    @JSONField(name="createman")
    public void setCreateMan(String createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [建立人]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getCreateManDirtyFlag(){
        return this.createManDirtyFlag ;
    }
    /**
     * 获取 [业务工作流标识]
     */
    @JsonProperty("psworkflowid")
    @JSONField(name="psworkflowid")
    public String getPSWorkflowId(){
        return this.pSWorkflowId ;
    }

    /**
     * 设置 [业务工作流标识]
     */
    @JsonProperty("psworkflowid")
    @JSONField(name="psworkflowid")
    public void setPSWorkflowId(String pSWorkflowId){
        this.pSWorkflowId = pSWorkflowId ;
        this.pSWorkflowIdDirtyFlag = true ;
    }

    /**
     * 获取 [业务工作流标识]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getPSWorkflowIdDirtyFlag(){
        return this.pSWorkflowIdDirtyFlag ;
    }
    /**
     * 获取 [更新时间]
     */
    @JsonProperty("updatedate")
    @JSONField(name="updatedate")
    public Timestamp getUpdateDate(){
        return this.updateDate ;
    }

    /**
     * 设置 [更新时间]
     */
    @JsonProperty("updatedate")
    @JSONField(name="updatedate")
    public void setUpdateDate(Timestamp updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [更新时间]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getUpdateDateDirtyFlag(){
        return this.updateDateDirtyFlag ;
    }
    /**
     * 获取 [工作流名称]
     */
    @JsonProperty("pswfworkflowname")
    @JSONField(name="pswfworkflowname")
    public String getPSWFWorkflowName(){
        return this.pSWFWorkflowName ;
    }

    /**
     * 设置 [工作流名称]
     */
    @JsonProperty("pswfworkflowname")
    @JSONField(name="pswfworkflowname")
    public void setPSWFWorkflowName(String pSWFWorkflowName){
        this.pSWFWorkflowName = pSWFWorkflowName ;
        this.pSWFWorkflowNameDirtyFlag = true ;
    }

    /**
     * 获取 [工作流名称]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getPSWFWorkflowNameDirtyFlag(){
        return this.pSWFWorkflowNameDirtyFlag ;
    }
    /**
     * 获取 [工作流名称]
     */
    @JsonProperty("logicname")
    @JSONField(name="logicname")
    public String getLogicName(){
        return this.logicName ;
    }

    /**
     * 设置 [工作流名称]
     */
    @JsonProperty("logicname")
    @JSONField(name="logicname")
    public void setLogicName(String logicName){
        this.logicName = logicName ;
        this.logicNameDirtyFlag = true ;
    }

    /**
     * 获取 [工作流名称]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getLogicNameDirtyFlag(){
        return this.logicNameDirtyFlag ;
    }
    /**
     * 获取 [部门名称]
     */
    @JsonProperty("orgdeptname")
    @JSONField(name="orgdeptname")
    public String getOrgDeptName(){
        return this.orgDeptName ;
    }

    /**
     * 设置 [部门名称]
     */
    @JsonProperty("orgdeptname")
    @JSONField(name="orgdeptname")
    public void setOrgDeptName(String orgDeptName){
        this.orgDeptName = orgDeptName ;
        this.orgDeptNameDirtyFlag = true ;
    }

    /**
     * 获取 [部门名称]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getOrgDeptNameDirtyFlag(){
        return this.orgDeptNameDirtyFlag ;
    }
    /**
     * 获取 [组织名称]
     */
    @JsonProperty("orgname")
    @JSONField(name="orgname")
    public String getOrgName(){
        return this.orgName ;
    }

    /**
     * 设置 [组织名称]
     */
    @JsonProperty("orgname")
    @JSONField(name="orgname")
    public void setOrgName(String orgName){
        this.orgName = orgName ;
        this.orgNameDirtyFlag = true ;
    }

    /**
     * 获取 [组织名称]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getOrgNameDirtyFlag(){
        return this.orgNameDirtyFlag ;
    }
    /**
     * 获取 [部门标识]
     */
    @JsonProperty("orgdeptid")
    @JSONField(name="orgdeptid")
    public String getOrgDeptId(){
        return this.orgDeptId ;
    }

    /**
     * 设置 [部门标识]
     */
    @JsonProperty("orgdeptid")
    @JSONField(name="orgdeptid")
    public void setOrgDeptId(String orgDeptId){
        this.orgDeptId = orgDeptId ;
        this.orgDeptIdDirtyFlag = true ;
    }

    /**
     * 获取 [部门标识]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getOrgDeptIdDirtyFlag(){
        return this.orgDeptIdDirtyFlag ;
    }
    /**
     * 获取 [组织标识]
     */
    @JsonProperty("orgid")
    @JSONField(name="orgid")
    public String getOrgId(){
        return this.orgId ;
    }

    /**
     * 设置 [组织标识]
     */
    @JsonProperty("orgid")
    @JSONField(name="orgid")
    public void setOrgId(String orgId){
        this.orgId = orgId ;
        this.orgIdDirtyFlag = true ;
    }

    /**
     * 获取 [组织标识]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getOrgIdDirtyFlag(){
        return this.orgIdDirtyFlag ;
    }
    /**
     * 获取 [业务系统标识]
     */
    @JsonProperty("pssystemid")
    @JSONField(name="pssystemid")
    public String getPSSystemId(){
        return this.pSSystemId ;
    }

    /**
     * 设置 [业务系统标识]
     */
    @JsonProperty("pssystemid")
    @JSONField(name="pssystemid")
    public void setPSSystemId(String pSSystemId){
        this.pSSystemId = pSSystemId ;
        this.pSSystemIdDirtyFlag = true ;
    }

    /**
     * 获取 [业务系统标识]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getPSSystemIdDirtyFlag(){
        return this.pSSystemIdDirtyFlag ;
    }

}

