package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import java.io.Serializable;

/**
 * 实体[工作流模式]
 */
public class WFMode implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 逻辑名称
     */
    private String logicName;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean logicNameDirtyFlag;

    /**
     * 建立时间
     */
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp createDate;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean createDateDirtyFlag;

    /**
     * 工作流模式标识
     */
    private String wFModeId;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean wFModeIdDirtyFlag;

    /**
     * 更新人
     */
    private String updateMan;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean updateManDirtyFlag;

    /**
     * 更新时间
     */
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp updateDate;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean updateDateDirtyFlag;

    /**
     * 建立人
     */
    private String createMan;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean createManDirtyFlag;

    /**
     * 工作流模式名称
     */
    private String wFModeName;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean wFModeNameDirtyFlag;

    /**
     * 业务系统标识
     */
    private String pSSystemId;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean pSSystemIdDirtyFlag;


    /**
     * 获取 [逻辑名称]
     */
    @JsonProperty("logicname")
    @JSONField(name="logicname")
    public String getLogicName(){
        return this.logicName ;
    }

    /**
     * 设置 [逻辑名称]
     */
    @JsonProperty("logicname")
    @JSONField(name="logicname")
    public void setLogicName(String logicName){
        this.logicName = logicName ;
        this.logicNameDirtyFlag = true ;
    }

    /**
     * 获取 [逻辑名称]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getLogicNameDirtyFlag(){
        return this.logicNameDirtyFlag ;
    }
    /**
     * 获取 [建立时间]
     */
    @JsonProperty("createdate")
    @JSONField(name="createdate")
    public Timestamp getCreateDate(){
        return this.createDate ;
    }

    /**
     * 设置 [建立时间]
     */
    @JsonProperty("createdate")
    @JSONField(name="createdate")
    public void setCreateDate(Timestamp createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [建立时间]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getCreateDateDirtyFlag(){
        return this.createDateDirtyFlag ;
    }
    /**
     * 获取 [工作流模式标识]
     */
    @JsonProperty("wfmodeid")
    @JSONField(name="wfmodeid")
    public String getWFModeId(){
        return this.wFModeId ;
    }

    /**
     * 设置 [工作流模式标识]
     */
    @JsonProperty("wfmodeid")
    @JSONField(name="wfmodeid")
    public void setWFModeId(String wFModeId){
        this.wFModeId = wFModeId ;
        this.wFModeIdDirtyFlag = true ;
    }

    /**
     * 获取 [工作流模式标识]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getWFModeIdDirtyFlag(){
        return this.wFModeIdDirtyFlag ;
    }
    /**
     * 获取 [更新人]
     */
    @JsonProperty("updateman")
    @JSONField(name="updateman")
    public String getUpdateMan(){
        return this.updateMan ;
    }

    /**
     * 设置 [更新人]
     */
    @JsonProperty("updateman")
    @JSONField(name="updateman")
    public void setUpdateMan(String updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [更新人]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getUpdateManDirtyFlag(){
        return this.updateManDirtyFlag ;
    }
    /**
     * 获取 [更新时间]
     */
    @JsonProperty("updatedate")
    @JSONField(name="updatedate")
    public Timestamp getUpdateDate(){
        return this.updateDate ;
    }

    /**
     * 设置 [更新时间]
     */
    @JsonProperty("updatedate")
    @JSONField(name="updatedate")
    public void setUpdateDate(Timestamp updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [更新时间]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getUpdateDateDirtyFlag(){
        return this.updateDateDirtyFlag ;
    }
    /**
     * 获取 [建立人]
     */
    @JsonProperty("createman")
    @JSONField(name="createman")
    public String getCreateMan(){
        return this.createMan ;
    }

    /**
     * 设置 [建立人]
     */
    @JsonProperty("createman")
    @JSONField(name="createman")
    public void setCreateMan(String createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [建立人]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getCreateManDirtyFlag(){
        return this.createManDirtyFlag ;
    }
    /**
     * 获取 [工作流模式名称]
     */
    @JsonProperty("wfmodename")
    @JSONField(name="wfmodename")
    public String getWFModeName(){
        return this.wFModeName ;
    }

    /**
     * 设置 [工作流模式名称]
     */
    @JsonProperty("wfmodename")
    @JSONField(name="wfmodename")
    public void setWFModeName(String wFModeName){
        this.wFModeName = wFModeName ;
        this.wFModeNameDirtyFlag = true ;
    }

    /**
     * 获取 [工作流模式名称]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getWFModeNameDirtyFlag(){
        return this.wFModeNameDirtyFlag ;
    }
    /**
     * 获取 [业务系统标识]
     */
    @JsonProperty("pssystemid")
    @JSONField(name="pssystemid")
    public String getPSSystemId(){
        return this.pSSystemId ;
    }

    /**
     * 设置 [业务系统标识]
     */
    @JsonProperty("pssystemid")
    @JSONField(name="pssystemid")
    public void setPSSystemId(String pSSystemId){
        this.pSSystemId = pSSystemId ;
        this.pSSystemIdDirtyFlag = true ;
    }

    /**
     * 获取 [业务系统标识]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getPSSystemIdDirtyFlag(){
        return this.pSSystemIdDirtyFlag ;
    }

}

