package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import java.io.Serializable;

/**
 * 实体[流程步骤信息]
 */
public class WFStepData implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 流程步骤信息标识
     */
    private String wFStepDataId;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean wFStepDataIdDirtyFlag;

    /**
     * 操作人
     */
    private String actionPerson;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean actionPersonDirtyFlag;

    /**
     * 操作信息
     */
    private String actionInfo;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean actionInfoDirtyFlag;

    /**
     * 主实例标识
     */
    private String majorInstId;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean majorInstIdDirtyFlag;

    /**
     * 操作时间
     */
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp actionTime;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean actionTimeDirtyFlag;

    /**
     * 建立人
     */
    private String createMan;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean createManDirtyFlag;

    /**
     * 更新时间
     */
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp updateDate;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean updateDateDirtyFlag;

    /**
     * 操作
     */
    private String action;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean actionDirtyFlag;

    /**
     * 建立时间
     */
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp createDate;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean createDateDirtyFlag;

    /**
     * 父实例标识
     */
    private String parentInstId;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean parentInstIdDirtyFlag;

    /**
     * 更新人
     */
    private String updateMan;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean updateManDirtyFlag;

    /**
     * 流程步骤信息名称
     */
    private String wFStepDataName;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean wFStepDataNameDirtyFlag;

    /**
     * 工作流步骤名称
     */
    private String wFStepName;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean wFStepNameDirtyFlag;

    /**
     * 工作流步骤标识
     */
    private String wFStepId;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean wFStepIdDirtyFlag;

    /**
     * 工作流实例标识
     */
    private String wFInstanceId;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean wFInstanceIdDirtyFlag;

    /**
     * 工作流步骤操作标识
     */
    private String wFIAActionId;

    @JsonIgnore
    @JSONField(serialize=false)
    private boolean wFIAActionIdDirtyFlag;


    /**
     * 获取 [流程步骤信息标识]
     */
    @JsonProperty("wfstepdataid")
    @JSONField(name="wfstepdataid")
    public String getWFStepDataId(){
        return this.wFStepDataId ;
    }

    /**
     * 设置 [流程步骤信息标识]
     */
    @JsonProperty("wfstepdataid")
    @JSONField(name="wfstepdataid")
    public void setWFStepDataId(String wFStepDataId){
        this.wFStepDataId = wFStepDataId ;
        this.wFStepDataIdDirtyFlag = true ;
    }

    /**
     * 获取 [流程步骤信息标识]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getWFStepDataIdDirtyFlag(){
        return this.wFStepDataIdDirtyFlag ;
    }
    /**
     * 获取 [操作人]
     */
    @JsonProperty("actionperson")
    @JSONField(name="actionperson")
    public String getActionPerson(){
        return this.actionPerson ;
    }

    /**
     * 设置 [操作人]
     */
    @JsonProperty("actionperson")
    @JSONField(name="actionperson")
    public void setActionPerson(String actionPerson){
        this.actionPerson = actionPerson ;
        this.actionPersonDirtyFlag = true ;
    }

    /**
     * 获取 [操作人]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getActionPersonDirtyFlag(){
        return this.actionPersonDirtyFlag ;
    }
    /**
     * 获取 [操作信息]
     */
    @JsonProperty("actioninfo")
    @JSONField(name="actioninfo")
    public String getActionInfo(){
        return this.actionInfo ;
    }

    /**
     * 设置 [操作信息]
     */
    @JsonProperty("actioninfo")
    @JSONField(name="actioninfo")
    public void setActionInfo(String actionInfo){
        this.actionInfo = actionInfo ;
        this.actionInfoDirtyFlag = true ;
    }

    /**
     * 获取 [操作信息]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getActionInfoDirtyFlag(){
        return this.actionInfoDirtyFlag ;
    }
    /**
     * 获取 [主实例标识]
     */
    @JsonProperty("majorinstid")
    @JSONField(name="majorinstid")
    public String getMajorInstId(){
        return this.majorInstId ;
    }

    /**
     * 设置 [主实例标识]
     */
    @JsonProperty("majorinstid")
    @JSONField(name="majorinstid")
    public void setMajorInstId(String majorInstId){
        this.majorInstId = majorInstId ;
        this.majorInstIdDirtyFlag = true ;
    }

    /**
     * 获取 [主实例标识]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getMajorInstIdDirtyFlag(){
        return this.majorInstIdDirtyFlag ;
    }
    /**
     * 获取 [操作时间]
     */
    @JsonProperty("actiontime")
    @JSONField(name="actiontime")
    public Timestamp getActionTime(){
        return this.actionTime ;
    }

    /**
     * 设置 [操作时间]
     */
    @JsonProperty("actiontime")
    @JSONField(name="actiontime")
    public void setActionTime(Timestamp actionTime){
        this.actionTime = actionTime ;
        this.actionTimeDirtyFlag = true ;
    }

    /**
     * 获取 [操作时间]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getActionTimeDirtyFlag(){
        return this.actionTimeDirtyFlag ;
    }
    /**
     * 获取 [建立人]
     */
    @JsonProperty("createman")
    @JSONField(name="createman")
    public String getCreateMan(){
        return this.createMan ;
    }

    /**
     * 设置 [建立人]
     */
    @JsonProperty("createman")
    @JSONField(name="createman")
    public void setCreateMan(String createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [建立人]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getCreateManDirtyFlag(){
        return this.createManDirtyFlag ;
    }
    /**
     * 获取 [更新时间]
     */
    @JsonProperty("updatedate")
    @JSONField(name="updatedate")
    public Timestamp getUpdateDate(){
        return this.updateDate ;
    }

    /**
     * 设置 [更新时间]
     */
    @JsonProperty("updatedate")
    @JSONField(name="updatedate")
    public void setUpdateDate(Timestamp updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [更新时间]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getUpdateDateDirtyFlag(){
        return this.updateDateDirtyFlag ;
    }
    /**
     * 获取 [操作]
     */
    @JsonProperty("action")
    @JSONField(name="action")
    public String getAction(){
        return this.action ;
    }

    /**
     * 设置 [操作]
     */
    @JsonProperty("action")
    @JSONField(name="action")
    public void setAction(String action){
        this.action = action ;
        this.actionDirtyFlag = true ;
    }

    /**
     * 获取 [操作]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getActionDirtyFlag(){
        return this.actionDirtyFlag ;
    }
    /**
     * 获取 [建立时间]
     */
    @JsonProperty("createdate")
    @JSONField(name="createdate")
    public Timestamp getCreateDate(){
        return this.createDate ;
    }

    /**
     * 设置 [建立时间]
     */
    @JsonProperty("createdate")
    @JSONField(name="createdate")
    public void setCreateDate(Timestamp createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [建立时间]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getCreateDateDirtyFlag(){
        return this.createDateDirtyFlag ;
    }
    /**
     * 获取 [父实例标识]
     */
    @JsonProperty("parentinstid")
    @JSONField(name="parentinstid")
    public String getParentInstId(){
        return this.parentInstId ;
    }

    /**
     * 设置 [父实例标识]
     */
    @JsonProperty("parentinstid")
    @JSONField(name="parentinstid")
    public void setParentInstId(String parentInstId){
        this.parentInstId = parentInstId ;
        this.parentInstIdDirtyFlag = true ;
    }

    /**
     * 获取 [父实例标识]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getParentInstIdDirtyFlag(){
        return this.parentInstIdDirtyFlag ;
    }
    /**
     * 获取 [更新人]
     */
    @JsonProperty("updateman")
    @JSONField(name="updateman")
    public String getUpdateMan(){
        return this.updateMan ;
    }

    /**
     * 设置 [更新人]
     */
    @JsonProperty("updateman")
    @JSONField(name="updateman")
    public void setUpdateMan(String updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [更新人]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getUpdateManDirtyFlag(){
        return this.updateManDirtyFlag ;
    }
    /**
     * 获取 [流程步骤信息名称]
     */
    @JsonProperty("wfstepdataname")
    @JSONField(name="wfstepdataname")
    public String getWFStepDataName(){
        return this.wFStepDataName ;
    }

    /**
     * 设置 [流程步骤信息名称]
     */
    @JsonProperty("wfstepdataname")
    @JSONField(name="wfstepdataname")
    public void setWFStepDataName(String wFStepDataName){
        this.wFStepDataName = wFStepDataName ;
        this.wFStepDataNameDirtyFlag = true ;
    }

    /**
     * 获取 [流程步骤信息名称]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getWFStepDataNameDirtyFlag(){
        return this.wFStepDataNameDirtyFlag ;
    }
    /**
     * 获取 [工作流步骤名称]
     */
    @JsonProperty("wfstepname")
    @JSONField(name="wfstepname")
    public String getWFStepName(){
        return this.wFStepName ;
    }

    /**
     * 设置 [工作流步骤名称]
     */
    @JsonProperty("wfstepname")
    @JSONField(name="wfstepname")
    public void setWFStepName(String wFStepName){
        this.wFStepName = wFStepName ;
        this.wFStepNameDirtyFlag = true ;
    }

    /**
     * 获取 [工作流步骤名称]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getWFStepNameDirtyFlag(){
        return this.wFStepNameDirtyFlag ;
    }
    /**
     * 获取 [工作流步骤标识]
     */
    @JsonProperty("wfstepid")
    @JSONField(name="wfstepid")
    public String getWFStepId(){
        return this.wFStepId ;
    }

    /**
     * 设置 [工作流步骤标识]
     */
    @JsonProperty("wfstepid")
    @JSONField(name="wfstepid")
    public void setWFStepId(String wFStepId){
        this.wFStepId = wFStepId ;
        this.wFStepIdDirtyFlag = true ;
    }

    /**
     * 获取 [工作流步骤标识]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getWFStepIdDirtyFlag(){
        return this.wFStepIdDirtyFlag ;
    }
    /**
     * 获取 [工作流实例标识]
     */
    @JsonProperty("wfinstanceid")
    @JSONField(name="wfinstanceid")
    public String getWFInstanceId(){
        return this.wFInstanceId ;
    }

    /**
     * 设置 [工作流实例标识]
     */
    @JsonProperty("wfinstanceid")
    @JSONField(name="wfinstanceid")
    public void setWFInstanceId(String wFInstanceId){
        this.wFInstanceId = wFInstanceId ;
        this.wFInstanceIdDirtyFlag = true ;
    }

    /**
     * 获取 [工作流实例标识]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getWFInstanceIdDirtyFlag(){
        return this.wFInstanceIdDirtyFlag ;
    }
    /**
     * 获取 [工作流步骤操作标识]
     */
    @JsonProperty("wfiaactionid")
    @JSONField(name="wfiaactionid")
    public String getWFIAActionId(){
        return this.wFIAActionId ;
    }

    /**
     * 设置 [工作流步骤操作标识]
     */
    @JsonProperty("wfiaactionid")
    @JSONField(name="wfiaactionid")
    public void setWFIAActionId(String wFIAActionId){
        this.wFIAActionId = wFIAActionId ;
        this.wFIAActionIdDirtyFlag = true ;
    }

    /**
     * 获取 [工作流步骤操作标识]脏标记
     */
    @JsonIgnore
    @JSONField(serialize=false)
    public boolean getWFIAActionIdDirtyFlag(){
        return this.wFIAActionIdDirtyFlag ;
    }

}

