package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter;

import java.math.BigDecimal;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import cn.ibizlab.r7.runtime.wf.util.ISearchFilter;
import cn.ibizlab.r7.runtime.wf.util.domain.DataObj;
import com.fasterxml.jackson.annotation.JsonFormat;
import cn.ibizlab.r7.runtime.wf.util.SearchContext;
import cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter;
import cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType;
import cn.ibizlab.r7.runtime.wf.util.enums.SearchGroupType;
import cn.ibizlab.r7.runtime.wf.util.SearchGroupFilter;
import lombok.Data;

/**
 * 关系型数据实体[OrgDeptWFVer] 查询条件对象
 */
@Data
public class OrgDeptWFVerSearchContext extends SearchContext {

	   public String n_orgdeptwfvername_like;//[部门流程版本名称]
       public void setN_orgdeptwfvername_like(String n_orgdeptwfvername_like) {
            this.n_orgdeptwfvername_like=n_orgdeptwfvername_like;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("orgdeptwfvername");
            searchField.setCondition(SearchFieldType.LIKE);
            searchField.setValue(n_orgdeptwfvername_like);
            this.getCondition().add(searchField);
       }
	   public String n_orgdeptname_eq;//[部门名称]
       public void setN_orgdeptname_eq(String n_orgdeptname_eq) {
            this.n_orgdeptname_eq=n_orgdeptname_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("orgdeptname");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_orgdeptname_eq);
            this.getCondition().add(searchField);
       }
	   public String n_orgdeptname_like;//[部门名称]
       public void setN_orgdeptname_like(String n_orgdeptname_like) {
            this.n_orgdeptname_like=n_orgdeptname_like;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("orgdeptname");
            searchField.setCondition(SearchFieldType.LIKE);
            searchField.setValue(n_orgdeptname_like);
            this.getCondition().add(searchField);
       }
	   public String n_pswfversionname_eq;//[业务流程版本名称]
       public void setN_pswfversionname_eq(String n_pswfversionname_eq) {
            this.n_pswfversionname_eq=n_pswfversionname_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("pswfversionname");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_pswfversionname_eq);
            this.getCondition().add(searchField);
       }
	   public String n_pswfversionname_like;//[业务流程版本名称]
       public void setN_pswfversionname_like(String n_pswfversionname_like) {
            this.n_pswfversionname_like=n_pswfversionname_like;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("pswfversionname");
            searchField.setCondition(SearchFieldType.LIKE);
            searchField.setValue(n_pswfversionname_like);
            this.getCondition().add(searchField);
       }
	   public String n_psworkflowname_eq;//[业务工作流名称]
       public void setN_psworkflowname_eq(String n_psworkflowname_eq) {
            this.n_psworkflowname_eq=n_psworkflowname_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("psworkflowname");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_psworkflowname_eq);
            this.getCondition().add(searchField);
       }
	   public String n_psworkflowname_like;//[业务工作流名称]
       public void setN_psworkflowname_like(String n_psworkflowname_like) {
            this.n_psworkflowname_like=n_psworkflowname_like;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("psworkflowname");
            searchField.setCondition(SearchFieldType.LIKE);
            searchField.setValue(n_psworkflowname_like);
            this.getCondition().add(searchField);
       }
	   public String n_orgdeptid_eq;//[部门标识]
       public void setN_orgdeptid_eq(String n_orgdeptid_eq) {
            this.n_orgdeptid_eq=n_orgdeptid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("orgdeptid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_orgdeptid_eq);
            this.getCondition().add(searchField);
       }
	   public String n_psworkflowid_eq;//[业务工作流标识]
       public void setN_psworkflowid_eq(String n_psworkflowid_eq) {
            this.n_psworkflowid_eq=n_psworkflowid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("psworkflowid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_psworkflowid_eq);
            this.getCondition().add(searchField);
       }
	   public String n_pswfversionid_eq;//[业务流程版本标识]
       public void setN_pswfversionid_eq(String n_pswfversionid_eq) {
            this.n_pswfversionid_eq=n_pswfversionid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("pswfversionid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_pswfversionid_eq);
            this.getCondition().add(searchField);
       }

	/**
	 * 启用快速搜索
	 */
	public void setQuery(String strQuery)
	{
		 this.query=strQuery;
         if(!org.springframework.util.StringUtils.isEmpty(strQuery)){
           SearchGroupFilter searchGroupFilter=new SearchGroupFilter();
           searchGroupFilter.setSearchGroupType(SearchGroupType.OR);

           SearchFieldFilter orgdeptwfvername=new SearchFieldFilter();
           orgdeptwfvername.setParam("orgdeptwfvername");
           orgdeptwfvername.setCondition(SearchFieldType.LIKE);
           orgdeptwfvername.setValue(strQuery);
           searchGroupFilter.getCondition().add(orgdeptwfvername);
        this.getCondition().add(searchGroupFilter);   

           
           
        }
	}
}
