package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter;

import java.math.BigDecimal;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import cn.ibizlab.r7.runtime.wf.util.ISearchFilter;
import cn.ibizlab.r7.runtime.wf.util.domain.DataObj;
import com.fasterxml.jackson.annotation.JsonFormat;
import cn.ibizlab.r7.runtime.wf.util.SearchContext;
import cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter;
import cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType;
import cn.ibizlab.r7.runtime.wf.util.enums.SearchGroupType;
import cn.ibizlab.r7.runtime.wf.util.SearchGroupFilter;
import lombok.Data;

/**
 * 关系型数据实体[PSDEWF] 查询条件对象
 */
@Data
public class PSDEWFSearchContext extends SearchContext {

	   public String n_psdewfname_like;//[业务实体工作流名称]
       public void setN_psdewfname_like(String n_psdewfname_like) {
            this.n_psdewfname_like=n_psdewfname_like;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("psdewfname");
            searchField.setCondition(SearchFieldType.LIKE);
            searchField.setValue(n_psdewfname_like);
            this.getCondition().add(searchField);
       }
	   public Integer n_wfproxymode_eq;//[工作流代理模式]
       public void setN_wfproxymode_eq(Integer n_wfproxymode_eq) {
            this.n_wfproxymode_eq=n_wfproxymode_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("wfproxymode");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_wfproxymode_eq);
            this.getCondition().add(searchField);
       }
	   public String n_psdecodename_eq;//[实体代码名]
       public void setN_psdecodename_eq(String n_psdecodename_eq) {
            this.n_psdecodename_eq=n_psdecodename_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("psdecodename");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_psdecodename_eq);
            this.getCondition().add(searchField);
       }
	   public String n_psworkflowid_eq;//[业务工作流标识]
       public void setN_psworkflowid_eq(String n_psworkflowid_eq) {
            this.n_psworkflowid_eq=n_psworkflowid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("psworkflowid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_psworkflowid_eq);
            this.getCondition().add(searchField);
       }
	   public String n_psdataentityid_eq;//[业务实体标识]
       public void setN_psdataentityid_eq(String n_psdataentityid_eq) {
            this.n_psdataentityid_eq=n_psdataentityid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("psdataentityid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_psdataentityid_eq);
            this.getCondition().add(searchField);
       }

	/**
	 * 启用快速搜索
	 */
	public void setQuery(String strQuery)
	{
		 this.query=strQuery;
         if(!org.springframework.util.StringUtils.isEmpty(strQuery)){
           SearchGroupFilter searchGroupFilter=new SearchGroupFilter();
           searchGroupFilter.setSearchGroupType(SearchGroupType.OR);

           SearchFieldFilter psdewfname=new SearchFieldFilter();
           psdewfname.setParam("psdewfname");
           psdewfname.setCondition(SearchFieldType.LIKE);
           psdewfname.setValue(strQuery);
           searchGroupFilter.getCondition().add(psdewfname);
        this.getCondition().add(searchGroupFilter);   

           
           
        }
	}
}
