package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter;

import java.math.BigDecimal;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import cn.ibizlab.r7.runtime.wf.util.ISearchFilter;
import cn.ibizlab.r7.runtime.wf.util.domain.DataObj;
import com.fasterxml.jackson.annotation.JsonFormat;
import cn.ibizlab.r7.runtime.wf.util.SearchContext;
import cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter;
import cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType;
import cn.ibizlab.r7.runtime.wf.util.enums.SearchGroupType;
import cn.ibizlab.r7.runtime.wf.util.SearchGroupFilter;
import lombok.Data;

/**
 * 关系型数据实体[PSSysApp] 查询条件对象
 */
@Data
public class PSSysAppSearchContext extends SearchContext {

	   public String n_pssysappname_like;//[业务系统应用名称]
       public void setN_pssysappname_like(String n_pssysappname_like) {
            this.n_pssysappname_like=n_pssysappname_like;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("pssysappname");
            searchField.setCondition(SearchFieldType.LIKE);
            searchField.setValue(n_pssysappname_like);
            this.getCondition().add(searchField);
       }
	   public String n_pssystemid_eq;//[业务系统标识]
       public void setN_pssystemid_eq(String n_pssystemid_eq) {
            this.n_pssystemid_eq=n_pssystemid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("pssystemid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_pssystemid_eq);
            this.getCondition().add(searchField);
       }

	/**
	 * 启用快速搜索
	 */
	public void setQuery(String strQuery)
	{
		 this.query=strQuery;
         if(!org.springframework.util.StringUtils.isEmpty(strQuery)){
           SearchGroupFilter searchGroupFilter=new SearchGroupFilter();
           searchGroupFilter.setSearchGroupType(SearchGroupType.OR);

           SearchFieldFilter pssysappname=new SearchFieldFilter();
           pssysappname.setParam("pssysappname");
           pssysappname.setCondition(SearchFieldType.LIKE);
           pssysappname.setValue(strQuery);
           searchGroupFilter.getCondition().add(pssysappname);
        this.getCondition().add(searchGroupFilter);   

           
           
        }
	}
}
