package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter;

import java.math.BigDecimal;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import cn.ibizlab.r7.runtime.wf.util.ISearchFilter;
import cn.ibizlab.r7.runtime.wf.util.domain.DataObj;
import com.fasterxml.jackson.annotation.JsonFormat;
import cn.ibizlab.r7.runtime.wf.util.SearchContext;
import cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter;
import cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType;
import cn.ibizlab.r7.runtime.wf.util.enums.SearchGroupType;
import cn.ibizlab.r7.runtime.wf.util.SearchGroupFilter;
import lombok.Data;

/**
 * 关系型数据实体[PSSystem] 查询条件对象
 */
@Data
public class PSSystemSearchContext extends SearchContext {

	   public String n_pssystemname_like;//[业务系统名称]
       public void setN_pssystemname_like(String n_pssystemname_like) {
            this.n_pssystemname_like=n_pssystemname_like;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("pssystemname");
            searchField.setCondition(SearchFieldType.LIKE);
            searchField.setValue(n_pssystemname_like);
            this.getCondition().add(searchField);
       }
	   public String n_workflowname_eq;//[统一工作流名称]
       public void setN_workflowname_eq(String n_workflowname_eq) {
            this.n_workflowname_eq=n_workflowname_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("workflowname");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_workflowname_eq);
            this.getCondition().add(searchField);
       }
	   public String n_workflowname_like;//[统一工作流名称]
       public void setN_workflowname_like(String n_workflowname_like) {
            this.n_workflowname_like=n_workflowname_like;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("workflowname");
            searchField.setCondition(SearchFieldType.LIKE);
            searchField.setValue(n_workflowname_like);
            this.getCondition().add(searchField);
       }
	   public String n_orgdeptid_eq;//[部门标识]
       public void setN_orgdeptid_eq(String n_orgdeptid_eq) {
            this.n_orgdeptid_eq=n_orgdeptid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("orgdeptid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_orgdeptid_eq);
            this.getCondition().add(searchField);
       }
	   public String n_workflowid_eq;//[统一工作流标识]
       public void setN_workflowid_eq(String n_workflowid_eq) {
            this.n_workflowid_eq=n_workflowid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("workflowid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_workflowid_eq);
            this.getCondition().add(searchField);
       }
	   public String n_orgid_eq;//[组织标识]
       public void setN_orgid_eq(String n_orgid_eq) {
            this.n_orgid_eq=n_orgid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("orgid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_orgid_eq);
            this.getCondition().add(searchField);
       }

	/**
	 * 启用快速搜索
	 */
	public void setQuery(String strQuery)
	{
		 this.query=strQuery;
         if(!org.springframework.util.StringUtils.isEmpty(strQuery)){
           SearchGroupFilter searchGroupFilter=new SearchGroupFilter();
           searchGroupFilter.setSearchGroupType(SearchGroupType.OR);

           SearchFieldFilter pssystemname=new SearchFieldFilter();
           pssystemname.setParam("pssystemname");
           pssystemname.setCondition(SearchFieldType.LIKE);
           pssystemname.setValue(strQuery);
           searchGroupFilter.getCondition().add(pssystemname);
        this.getCondition().add(searchGroupFilter);   

           
           
        }
	}
}
