package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter;

import java.math.BigDecimal;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import cn.ibizlab.r7.runtime.wf.util.ISearchFilter;
import cn.ibizlab.r7.runtime.wf.util.domain.DataObj;
import com.fasterxml.jackson.annotation.JsonFormat;
import cn.ibizlab.r7.runtime.wf.util.SearchContext;
import cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter;
import cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType;
import cn.ibizlab.r7.runtime.wf.util.enums.SearchGroupType;
import cn.ibizlab.r7.runtime.wf.util.SearchGroupFilter;
import lombok.Data;

/**
 * 关系型数据实体[PSWFLink] 查询条件对象
 */
@Data
public class PSWFLinkSearchContext extends SearchContext {

	   public String n_pswflinkname_like;//[流程连接名称]
       public void setN_pswflinkname_like(String n_pswflinkname_like) {
            this.n_pswflinkname_like=n_pswflinkname_like;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("pswflinkname");
            searchField.setCondition(SearchFieldType.LIKE);
            searchField.setValue(n_pswflinkname_like);
            this.getCondition().add(searchField);
       }
	   public String n_frompswfprocid_eq;//[流程处理标识]
       public void setN_frompswfprocid_eq(String n_frompswfprocid_eq) {
            this.n_frompswfprocid_eq=n_frompswfprocid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("frompswfprocid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_frompswfprocid_eq);
            this.getCondition().add(searchField);
       }
	   public String n_pswfversionid_eq;//[业务流程版本标识]
       public void setN_pswfversionid_eq(String n_pswfversionid_eq) {
            this.n_pswfversionid_eq=n_pswfversionid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("pswfversionid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_pswfversionid_eq);
            this.getCondition().add(searchField);
       }
	   public String n_topswfprocid_eq;//[流程处理标识]
       public void setN_topswfprocid_eq(String n_topswfprocid_eq) {
            this.n_topswfprocid_eq=n_topswfprocid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("topswfprocid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_topswfprocid_eq);
            this.getCondition().add(searchField);
       }

	/**
	 * 启用快速搜索
	 */
	public void setQuery(String strQuery)
	{
		 this.query=strQuery;
         if(!org.springframework.util.StringUtils.isEmpty(strQuery)){
           SearchGroupFilter searchGroupFilter=new SearchGroupFilter();
           searchGroupFilter.setSearchGroupType(SearchGroupType.OR);

           SearchFieldFilter pswflinkname=new SearchFieldFilter();
           pswflinkname.setParam("pswflinkname");
           pswflinkname.setCondition(SearchFieldType.LIKE);
           pswflinkname.setValue(strQuery);
           searchGroupFilter.getCondition().add(pswflinkname);
        this.getCondition().add(searchGroupFilter);   

           
           
        }
	}
}
