package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter;

import java.math.BigDecimal;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import cn.ibizlab.r7.runtime.wf.util.ISearchFilter;
import cn.ibizlab.r7.runtime.wf.util.domain.DataObj;
import com.fasterxml.jackson.annotation.JsonFormat;
import cn.ibizlab.r7.runtime.wf.util.SearchContext;
import cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter;
import cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType;
import cn.ibizlab.r7.runtime.wf.util.enums.SearchGroupType;
import cn.ibizlab.r7.runtime.wf.util.SearchGroupFilter;
import lombok.Data;

/**
 * 关系型数据实体[PSWFPROCSUBWF] 查询条件对象
 */
@Data
public class PSWFPROCSUBWFSearchContext extends SearchContext {

	   public String n_pswfprocsubwfname_like;//[嵌套流程名称]
       public void setN_pswfprocsubwfname_like(String n_pswfprocsubwfname_like) {
            this.n_pswfprocsubwfname_like=n_pswfprocsubwfname_like;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("pswfprocsubwfname");
            searchField.setCondition(SearchFieldType.LIKE);
            searchField.setValue(n_pswfprocsubwfname_like);
            this.getCondition().add(searchField);
       }
	   public String n_pswfversionid_eq;//[业务流程版本标识]
       public void setN_pswfversionid_eq(String n_pswfversionid_eq) {
            this.n_pswfversionid_eq=n_pswfversionid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("pswfversionid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_pswfversionid_eq);
            this.getCondition().add(searchField);
       }
	   public String n_subwfdeid_eq;//[流程嵌套实体标识]
       public void setN_subwfdeid_eq(String n_subwfdeid_eq) {
            this.n_subwfdeid_eq=n_subwfdeid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("subwfdeid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_subwfdeid_eq);
            this.getCondition().add(searchField);
       }
	   public String n_pswfprocessid_eq;//[流程处理标识]
       public void setN_pswfprocessid_eq(String n_pswfprocessid_eq) {
            this.n_pswfprocessid_eq=n_pswfprocessid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("pswfprocessid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_pswfprocessid_eq);
            this.getCondition().add(searchField);
       }
	   public String n_psworkflowid_eq;//[业务工作流标识]
       public void setN_psworkflowid_eq(String n_psworkflowid_eq) {
            this.n_psworkflowid_eq=n_psworkflowid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("psworkflowid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_psworkflowid_eq);
            this.getCondition().add(searchField);
       }

	/**
	 * 启用快速搜索
	 */
	public void setQuery(String strQuery)
	{
		 this.query=strQuery;
         if(!org.springframework.util.StringUtils.isEmpty(strQuery)){
           SearchGroupFilter searchGroupFilter=new SearchGroupFilter();
           searchGroupFilter.setSearchGroupType(SearchGroupType.OR);

           SearchFieldFilter pswfprocsubwfname=new SearchFieldFilter();
           pswfprocsubwfname.setParam("pswfprocsubwfname");
           pswfprocsubwfname.setCondition(SearchFieldType.LIKE);
           pswfprocsubwfname.setValue(strQuery);
           searchGroupFilter.getCondition().add(pswfprocsubwfname);
        this.getCondition().add(searchGroupFilter);   

           
           
        }
	}
}
