package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter;

import java.math.BigDecimal;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import cn.ibizlab.r7.runtime.wf.util.ISearchFilter;
import cn.ibizlab.r7.runtime.wf.util.domain.DataObj;
import com.fasterxml.jackson.annotation.JsonFormat;
import cn.ibizlab.r7.runtime.wf.util.SearchContext;
import cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter;
import cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType;
import cn.ibizlab.r7.runtime.wf.util.enums.SearchGroupType;
import cn.ibizlab.r7.runtime.wf.util.SearchGroupFilter;
import lombok.Data;

/**
 * 关系型数据实体[PSWFProcRole] 查询条件对象
 */
@Data
public class PSWFProcRoleSearchContext extends SearchContext {

	   public String n_pswfprocrolename_like;//[流程处理角色名称]
       public void setN_pswfprocrolename_like(String n_pswfprocrolename_like) {
            this.n_pswfprocrolename_like=n_pswfprocrolename_like;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("pswfprocrolename");
            searchField.setCondition(SearchFieldType.LIKE);
            searchField.setValue(n_pswfprocrolename_like);
            this.getCondition().add(searchField);
       }
	   public String n_pswfprocessname_eq;//[流程处理名称]
       public void setN_pswfprocessname_eq(String n_pswfprocessname_eq) {
            this.n_pswfprocessname_eq=n_pswfprocessname_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("pswfprocessname");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_pswfprocessname_eq);
            this.getCondition().add(searchField);
       }
	   public String n_pswfprocessname_like;//[流程处理名称]
       public void setN_pswfprocessname_like(String n_pswfprocessname_like) {
            this.n_pswfprocessname_like=n_pswfprocessname_like;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("pswfprocessname");
            searchField.setCondition(SearchFieldType.LIKE);
            searchField.setValue(n_pswfprocessname_like);
            this.getCondition().add(searchField);
       }
	   public String n_pswfprocessid_eq;//[流程处理标识]
       public void setN_pswfprocessid_eq(String n_pswfprocessid_eq) {
            this.n_pswfprocessid_eq=n_pswfprocessid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("pswfprocessid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_pswfprocessid_eq);
            this.getCondition().add(searchField);
       }
	   public String n_pswfroleid_eq;//[平台流程角色标识]
       public void setN_pswfroleid_eq(String n_pswfroleid_eq) {
            this.n_pswfroleid_eq=n_pswfroleid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("pswfroleid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_pswfroleid_eq);
            this.getCondition().add(searchField);
       }

	/**
	 * 启用快速搜索
	 */
	public void setQuery(String strQuery)
	{
		 this.query=strQuery;
         if(!org.springframework.util.StringUtils.isEmpty(strQuery)){
           SearchGroupFilter searchGroupFilter=new SearchGroupFilter();
           searchGroupFilter.setSearchGroupType(SearchGroupType.OR);

           SearchFieldFilter pswfprocrolename=new SearchFieldFilter();
           pswfprocrolename.setParam("pswfprocrolename");
           pswfprocrolename.setCondition(SearchFieldType.LIKE);
           pswfprocrolename.setValue(strQuery);
           searchGroupFilter.getCondition().add(pswfprocrolename);
        this.getCondition().add(searchGroupFilter);   

           
           
        }
	}
}
