package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter;

import java.math.BigDecimal;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import cn.ibizlab.r7.runtime.wf.util.ISearchFilter;
import cn.ibizlab.r7.runtime.wf.util.domain.DataObj;
import com.fasterxml.jackson.annotation.JsonFormat;
import cn.ibizlab.r7.runtime.wf.util.SearchContext;
import cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter;
import cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType;
import cn.ibizlab.r7.runtime.wf.util.enums.SearchGroupType;
import cn.ibizlab.r7.runtime.wf.util.SearchGroupFilter;
import lombok.Data;

/**
 * 关系型数据实体[PSWFProcess] 查询条件对象
 */
@Data
public class PSWFProcessSearchContext extends SearchContext {

	   public String n_pswfprocessname_like;//[流程处理名称]
       public void setN_pswfprocessname_like(String n_pswfprocessname_like) {
            this.n_pswfprocessname_like=n_pswfprocessname_like;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("pswfprocessname");
            searchField.setCondition(SearchFieldType.LIKE);
            searchField.setValue(n_pswfprocessname_like);
            this.getCondition().add(searchField);
       }
	   public String n_pswfversionname_eq;//[业务流程版本名称]
       public void setN_pswfversionname_eq(String n_pswfversionname_eq) {
            this.n_pswfversionname_eq=n_pswfversionname_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("pswfversionname");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_pswfversionname_eq);
            this.getCondition().add(searchField);
       }
	   public String n_pswfversionname_like;//[业务流程版本名称]
       public void setN_pswfversionname_like(String n_pswfversionname_like) {
            this.n_pswfversionname_like=n_pswfversionname_like;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("pswfversionname");
            searchField.setCondition(SearchFieldType.LIKE);
            searchField.setValue(n_pswfversionname_like);
            this.getCondition().add(searchField);
       }
	   public String n_targetpswfid_eq;//[业务工作流标识]
       public void setN_targetpswfid_eq(String n_targetpswfid_eq) {
            this.n_targetpswfid_eq=n_targetpswfid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("targetpswfid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_targetpswfid_eq);
            this.getCondition().add(searchField);
       }
	   public String n_pswfversionid_eq;//[业务流程版本标识]
       public void setN_pswfversionid_eq(String n_pswfversionid_eq) {
            this.n_pswfversionid_eq=n_pswfversionid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("pswfversionid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_pswfversionid_eq);
            this.getCondition().add(searchField);
       }

	/**
	 * 启用快速搜索
	 */
	public void setQuery(String strQuery)
	{
		 this.query=strQuery;
         if(!org.springframework.util.StringUtils.isEmpty(strQuery)){
           SearchGroupFilter searchGroupFilter=new SearchGroupFilter();
           searchGroupFilter.setSearchGroupType(SearchGroupType.OR);

           SearchFieldFilter pswfprocessname=new SearchFieldFilter();
           pswfprocessname.setParam("pswfprocessname");
           pswfprocessname.setCondition(SearchFieldType.LIKE);
           pswfprocessname.setValue(strQuery);
           searchGroupFilter.getCondition().add(pswfprocessname);
        this.getCondition().add(searchGroupFilter);   

           
           
        }
	}
}
