package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter;

import java.math.BigDecimal;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import cn.ibizlab.r7.runtime.wf.util.ISearchFilter;
import cn.ibizlab.r7.runtime.wf.util.domain.DataObj;
import com.fasterxml.jackson.annotation.JsonFormat;
import cn.ibizlab.r7.runtime.wf.util.SearchContext;
import cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter;
import cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType;
import cn.ibizlab.r7.runtime.wf.util.enums.SearchGroupType;
import cn.ibizlab.r7.runtime.wf.util.SearchGroupFilter;
import lombok.Data;

/**
 * 关系型数据实体[WFEngine] 查询条件对象
 */
@Data
public class WFEngineSearchContext extends SearchContext {

	   public String n_wfenginename_like;//[工作流引擎名称]
       public void setN_wfenginename_like(String n_wfenginename_like) {
            this.n_wfenginename_like=n_wfenginename_like;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("wfenginename");
            searchField.setCondition(SearchFieldType.LIKE);
            searchField.setValue(n_wfenginename_like);
            this.getCondition().add(searchField);
       }
	   public String n_enginetype_eq;//[引擎类型]
       public void setN_enginetype_eq(String n_enginetype_eq) {
            this.n_enginetype_eq=n_enginetype_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("enginetype");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_enginetype_eq);
            this.getCondition().add(searchField);
       }
	   public String n_workflowid_eq;//[统一工作流标识]
       public void setN_workflowid_eq(String n_workflowid_eq) {
            this.n_workflowid_eq=n_workflowid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("workflowid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_workflowid_eq);
            this.getCondition().add(searchField);
       }

	/**
	 * 启用快速搜索
	 */
	public void setQuery(String strQuery)
	{
		 this.query=strQuery;
         if(!org.springframework.util.StringUtils.isEmpty(strQuery)){
           SearchGroupFilter searchGroupFilter=new SearchGroupFilter();
           searchGroupFilter.setSearchGroupType(SearchGroupType.OR);

           SearchFieldFilter wfenginename=new SearchFieldFilter();
           wfenginename.setParam("wfenginename");
           wfenginename.setCondition(SearchFieldType.LIKE);
           wfenginename.setValue(strQuery);
           searchGroupFilter.getCondition().add(wfenginename);
        this.getCondition().add(searchGroupFilter);   

           
           
        }
	}
}
