package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter;

import java.math.BigDecimal;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import cn.ibizlab.r7.runtime.wf.util.ISearchFilter;
import cn.ibizlab.r7.runtime.wf.util.domain.DataObj;
import com.fasterxml.jackson.annotation.JsonFormat;
import cn.ibizlab.r7.runtime.wf.util.SearchContext;
import cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter;
import cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType;
import cn.ibizlab.r7.runtime.wf.util.enums.SearchGroupType;
import cn.ibizlab.r7.runtime.wf.util.SearchGroupFilter;
import lombok.Data;

/**
 * 关系型数据实体[WFIAAction] 查询条件对象
 */
@Data
public class WFIAActionSearchContext extends SearchContext {

	   public String n_actiontype_eq;//[操作类型]
       public void setN_actiontype_eq(String n_actiontype_eq) {
            this.n_actiontype_eq=n_actiontype_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("actiontype");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_actiontype_eq);
            this.getCondition().add(searchField);
       }
	   public String n_wfiaactionname_like;//[工作流步骤操作名称]
       public void setN_wfiaactionname_like(String n_wfiaactionname_like) {
            this.n_wfiaactionname_like=n_wfiaactionname_like;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("wfiaactionname");
            searchField.setCondition(SearchFieldType.LIKE);
            searchField.setValue(n_wfiaactionname_like);
            this.getCondition().add(searchField);
       }
	   public String n_wfstepid_eq;//[工作流步骤标识]
       public void setN_wfstepid_eq(String n_wfstepid_eq) {
            this.n_wfstepid_eq=n_wfstepid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("wfstepid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_wfstepid_eq);
            this.getCondition().add(searchField);
       }

	/**
	 * 启用快速搜索
	 */
	public void setQuery(String strQuery)
	{
		 this.query=strQuery;
         if(!org.springframework.util.StringUtils.isEmpty(strQuery)){
           SearchGroupFilter searchGroupFilter=new SearchGroupFilter();
           searchGroupFilter.setSearchGroupType(SearchGroupType.OR);

           SearchFieldFilter wfiaactionname=new SearchFieldFilter();
           wfiaactionname.setParam("wfiaactionname");
           wfiaactionname.setCondition(SearchFieldType.LIKE);
           wfiaactionname.setValue(strQuery);
           searchGroupFilter.getCondition().add(wfiaactionname);
        this.getCondition().add(searchGroupFilter);   

           
           
        }
	}
}
