package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter;

import java.math.BigDecimal;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import cn.ibizlab.r7.runtime.wf.util.ISearchFilter;
import cn.ibizlab.r7.runtime.wf.util.domain.DataObj;
import com.fasterxml.jackson.annotation.JsonFormat;
import cn.ibizlab.r7.runtime.wf.util.SearchContext;
import cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter;
import cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType;
import cn.ibizlab.r7.runtime.wf.util.enums.SearchGroupType;
import cn.ibizlab.r7.runtime.wf.util.SearchGroupFilter;
import lombok.Data;

/**
 * 关系型数据实体[WFInstance] 查询条件对象
 */
@Data
public class WFInstanceSearchContext extends SearchContext {

	   public String n_parentinstid_eq;//[父实例标识]
       public void setN_parentinstid_eq(String n_parentinstid_eq) {
            this.n_parentinstid_eq=n_parentinstid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("parentinstid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_parentinstid_eq);
            this.getCondition().add(searchField);
       }
	   public Integer n_isclosed_eq;//[是否关闭]
       public void setN_isclosed_eq(Integer n_isclosed_eq) {
            this.n_isclosed_eq=n_isclosed_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("isclosed");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_isclosed_eq);
            this.getCondition().add(searchField);
       }
	   public String n_wfinstancename_like;//[工作流实例名称]
       public void setN_wfinstancename_like(String n_wfinstancename_like) {
            this.n_wfinstancename_like=n_wfinstancename_like;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("wfinstancename");
            searchField.setCondition(SearchFieldType.LIKE);
            searchField.setValue(n_wfinstancename_like);
            this.getCondition().add(searchField);
       }
	   public String n_wfstate_eq;//[流程状态]
       public void setN_wfstate_eq(String n_wfstate_eq) {
            this.n_wfstate_eq=n_wfstate_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("wfstate");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_wfstate_eq);
            this.getCondition().add(searchField);
       }
	   public String n_orgdeptid_eq;//[部门标识]
       public void setN_orgdeptid_eq(String n_orgdeptid_eq) {
            this.n_orgdeptid_eq=n_orgdeptid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("orgdeptid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_orgdeptid_eq);
            this.getCondition().add(searchField);
       }
	   public String n_wfengineid_eq;//[工作流引擎标识]
       public void setN_wfengineid_eq(String n_wfengineid_eq) {
            this.n_wfengineid_eq=n_wfengineid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("wfengineid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_wfengineid_eq);
            this.getCondition().add(searchField);
       }
	   public String n_psworkflowid_eq;//[业务工作流标识]
       public void setN_psworkflowid_eq(String n_psworkflowid_eq) {
            this.n_psworkflowid_eq=n_psworkflowid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("psworkflowid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_psworkflowid_eq);
            this.getCondition().add(searchField);
       }
	   public String n_orgid_eq;//[组织标识]
       public void setN_orgid_eq(String n_orgid_eq) {
            this.n_orgid_eq=n_orgid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("orgid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_orgid_eq);
            this.getCondition().add(searchField);
       }
	   public String n_pswfversionid_eq;//[业务流程版本标识]
       public void setN_pswfversionid_eq(String n_pswfversionid_eq) {
            this.n_pswfversionid_eq=n_pswfversionid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("pswfversionid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_pswfversionid_eq);
            this.getCondition().add(searchField);
       }

	/**
	 * 启用快速搜索
	 */
	public void setQuery(String strQuery)
	{
		 this.query=strQuery;
         if(!org.springframework.util.StringUtils.isEmpty(strQuery)){
           SearchGroupFilter searchGroupFilter=new SearchGroupFilter();
           searchGroupFilter.setSearchGroupType(SearchGroupType.OR);

           SearchFieldFilter wfinstancename=new SearchFieldFilter();
           wfinstancename.setParam("wfinstancename");
           wfinstancename.setCondition(SearchFieldType.LIKE);
           wfinstancename.setValue(strQuery);
           searchGroupFilter.getCondition().add(wfinstancename);
        this.getCondition().add(searchGroupFilter);   

           
           
        }
	}
}
