package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter;

import java.math.BigDecimal;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import cn.ibizlab.r7.runtime.wf.util.ISearchFilter;
import cn.ibizlab.r7.runtime.wf.util.domain.DataObj;
import com.fasterxml.jackson.annotation.JsonFormat;
import cn.ibizlab.r7.runtime.wf.util.SearchContext;
import cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter;
import cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType;
import cn.ibizlab.r7.runtime.wf.util.enums.SearchGroupType;
import cn.ibizlab.r7.runtime.wf.util.SearchGroupFilter;
import lombok.Data;

/**
 * 关系型数据实体[WFRole] 查询条件对象
 */
@Data
public class WFRoleSearchContext extends SearchContext {

	   public String n_wfrolename_like;//[流程角色名称]
       public void setN_wfrolename_like(String n_wfrolename_like) {
            this.n_wfrolename_like=n_wfrolename_like;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("wfrolename");
            searchField.setCondition(SearchFieldType.LIKE);
            searchField.setValue(n_wfrolename_like);
            this.getCondition().add(searchField);
       }

	/**
	 * 启用快速搜索
	 */
	public void setQuery(String strQuery)
	{
		 this.query=strQuery;
         if(!org.springframework.util.StringUtils.isEmpty(strQuery)){
           SearchGroupFilter searchGroupFilter=new SearchGroupFilter();
           searchGroupFilter.setSearchGroupType(SearchGroupType.OR);

           SearchFieldFilter wfrolename=new SearchFieldFilter();
           wfrolename.setParam("wfrolename");
           wfrolename.setCondition(SearchFieldType.LIKE);
           wfrolename.setValue(strQuery);
           searchGroupFilter.getCondition().add(wfrolename);
        this.getCondition().add(searchGroupFilter);   

           
           
        }
	}
}
