package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter;

import java.math.BigDecimal;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import cn.ibizlab.r7.runtime.wf.util.ISearchFilter;
import cn.ibizlab.r7.runtime.wf.util.domain.DataObj;
import com.fasterxml.jackson.annotation.JsonFormat;
import cn.ibizlab.r7.runtime.wf.util.SearchContext;
import cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter;
import cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType;
import cn.ibizlab.r7.runtime.wf.util.enums.SearchGroupType;
import cn.ibizlab.r7.runtime.wf.util.SearchGroupFilter;
import lombok.Data;

/**
 * 关系型数据实体[WFStepActor] 查询条件对象
 */
@Data
public class WFStepActorSearchContext extends SearchContext {

	   public String n_wfstepactorname_like;//[工作流步骤操作者名称]
       public void setN_wfstepactorname_like(String n_wfstepactorname_like) {
            this.n_wfstepactorname_like=n_wfstepactorname_like;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("wfstepactorname");
            searchField.setCondition(SearchFieldType.LIKE);
            searchField.setValue(n_wfstepactorname_like);
            this.getCondition().add(searchField);
       }
	   public String n_wfusername_eq;//[工作流用户名称]
       public void setN_wfusername_eq(String n_wfusername_eq) {
            this.n_wfusername_eq=n_wfusername_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("wfusername");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_wfusername_eq);
            this.getCondition().add(searchField);
       }
	   public String n_wfusername_like;//[工作流用户名称]
       public void setN_wfusername_like(String n_wfusername_like) {
            this.n_wfusername_like=n_wfusername_like;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("wfusername");
            searchField.setCondition(SearchFieldType.LIKE);
            searchField.setValue(n_wfusername_like);
            this.getCondition().add(searchField);
       }
	   public String n_wfuserid_eq;//[工作流用户标识]
       public void setN_wfuserid_eq(String n_wfuserid_eq) {
            this.n_wfuserid_eq=n_wfuserid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("wfuserid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_wfuserid_eq);
            this.getCondition().add(searchField);
       }
	   public String n_wfstepid_eq;//[工作流步骤标识]
       public void setN_wfstepid_eq(String n_wfstepid_eq) {
            this.n_wfstepid_eq=n_wfstepid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("wfstepid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_wfstepid_eq);
            this.getCondition().add(searchField);
       }
	   public String n_pswfprocessid_eq;//[流程处理标识]
       public void setN_pswfprocessid_eq(String n_pswfprocessid_eq) {
            this.n_pswfprocessid_eq=n_pswfprocessid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("pswfprocessid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_pswfprocessid_eq);
            this.getCondition().add(searchField);
       }
	   public String n_wfinstanceid_eq;//[工作流实例标识]
       public void setN_wfinstanceid_eq(String n_wfinstanceid_eq) {
            this.n_wfinstanceid_eq=n_wfinstanceid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("wfinstanceid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_wfinstanceid_eq);
            this.getCondition().add(searchField);
       }
	   public String n_pswfversionid_eq;//[业务流程版本标识]
       public void setN_pswfversionid_eq(String n_pswfversionid_eq) {
            this.n_pswfversionid_eq=n_pswfversionid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("pswfversionid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_pswfversionid_eq);
            this.getCondition().add(searchField);
       }

	/**
	 * 启用快速搜索
	 */
	public void setQuery(String strQuery)
	{
		 this.query=strQuery;
         if(!org.springframework.util.StringUtils.isEmpty(strQuery)){
           SearchGroupFilter searchGroupFilter=new SearchGroupFilter();
           searchGroupFilter.setSearchGroupType(SearchGroupType.OR);

           SearchFieldFilter wfstepactorname=new SearchFieldFilter();
           wfstepactorname.setParam("wfstepactorname");
           wfstepactorname.setCondition(SearchFieldType.LIKE);
           wfstepactorname.setValue(strQuery);
           searchGroupFilter.getCondition().add(wfstepactorname);
        this.getCondition().add(searchGroupFilter);   

           
           
        }
	}
}
