package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter;

import java.math.BigDecimal;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import cn.ibizlab.r7.runtime.wf.util.ISearchFilter;
import cn.ibizlab.r7.runtime.wf.util.domain.DataObj;
import com.fasterxml.jackson.annotation.JsonFormat;
import cn.ibizlab.r7.runtime.wf.util.SearchContext;
import cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter;
import cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType;
import cn.ibizlab.r7.runtime.wf.util.enums.SearchGroupType;
import cn.ibizlab.r7.runtime.wf.util.SearchGroupFilter;
import lombok.Data;

/**
 * 关系型数据实体[WFStepData] 查询条件对象
 */
@Data
public class WFStepDataSearchContext extends SearchContext {

	   public String n_wfstepdataname_like;//[流程步骤信息名称]
       public void setN_wfstepdataname_like(String n_wfstepdataname_like) {
            this.n_wfstepdataname_like=n_wfstepdataname_like;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("wfstepdataname");
            searchField.setCondition(SearchFieldType.LIKE);
            searchField.setValue(n_wfstepdataname_like);
            this.getCondition().add(searchField);
       }
	   public String n_wfstepname_eq;//[工作流步骤名称]
       public void setN_wfstepname_eq(String n_wfstepname_eq) {
            this.n_wfstepname_eq=n_wfstepname_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("wfstepname");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_wfstepname_eq);
            this.getCondition().add(searchField);
       }
	   public String n_wfstepname_like;//[工作流步骤名称]
       public void setN_wfstepname_like(String n_wfstepname_like) {
            this.n_wfstepname_like=n_wfstepname_like;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("wfstepname");
            searchField.setCondition(SearchFieldType.LIKE);
            searchField.setValue(n_wfstepname_like);
            this.getCondition().add(searchField);
       }
	   public String n_wfstepid_eq;//[工作流步骤标识]
       public void setN_wfstepid_eq(String n_wfstepid_eq) {
            this.n_wfstepid_eq=n_wfstepid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("wfstepid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_wfstepid_eq);
            this.getCondition().add(searchField);
       }
	   public String n_wfinstanceid_eq;//[工作流实例标识]
       public void setN_wfinstanceid_eq(String n_wfinstanceid_eq) {
            this.n_wfinstanceid_eq=n_wfinstanceid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("wfinstanceid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_wfinstanceid_eq);
            this.getCondition().add(searchField);
       }
	   public String n_wfiaactionid_eq;//[工作流步骤操作标识]
       public void setN_wfiaactionid_eq(String n_wfiaactionid_eq) {
            this.n_wfiaactionid_eq=n_wfiaactionid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("wfiaactionid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_wfiaactionid_eq);
            this.getCondition().add(searchField);
       }

	/**
	 * 启用快速搜索
	 */
	public void setQuery(String strQuery)
	{
		 this.query=strQuery;
         if(!org.springframework.util.StringUtils.isEmpty(strQuery)){
           SearchGroupFilter searchGroupFilter=new SearchGroupFilter();
           searchGroupFilter.setSearchGroupType(SearchGroupType.OR);

           SearchFieldFilter wfstepdataname=new SearchFieldFilter();
           wfstepdataname.setParam("wfstepdataname");
           wfstepdataname.setCondition(SearchFieldType.LIKE);
           wfstepdataname.setValue(strQuery);
           searchGroupFilter.getCondition().add(wfstepdataname);
        this.getCondition().add(searchGroupFilter);   

           
           
        }
	}
}
