package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter;

import java.math.BigDecimal;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import cn.ibizlab.r7.runtime.wf.util.ISearchFilter;
import cn.ibizlab.r7.runtime.wf.util.domain.DataObj;
import com.fasterxml.jackson.annotation.JsonFormat;
import cn.ibizlab.r7.runtime.wf.util.SearchContext;
import cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter;
import cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType;
import cn.ibizlab.r7.runtime.wf.util.enums.SearchGroupType;
import cn.ibizlab.r7.runtime.wf.util.SearchGroupFilter;
import lombok.Data;

/**
 * 关系型数据实体[WFWorklist] 查询条件对象
 */
@Data
public class WFWorklistSearchContext extends SearchContext {

	   public Integer n_isclosed_eq;//[是否关闭]
       public void setN_isclosed_eq(Integer n_isclosed_eq) {
            this.n_isclosed_eq=n_isclosed_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("isclosed");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_isclosed_eq);
            this.getCondition().add(searchField);
       }
	   public Integer n_isclosed_noteq;//[是否关闭]
       public void setN_isclosed_noteq(Integer n_isclosed_noteq) {
            this.n_isclosed_noteq=n_isclosed_noteq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("isclosed");
            searchField.setCondition(SearchFieldType.NOTEQ);
            searchField.setValue(n_isclosed_noteq);
            this.getCondition().add(searchField);
       }
	   public String n_wfworklistname_like;//[处理环节]
       public void setN_wfworklistname_like(String n_wfworklistname_like) {
            this.n_wfworklistname_like=n_wfworklistname_like;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("wfworklistname");
            searchField.setCondition(SearchFieldType.LIKE);
            searchField.setValue(n_wfworklistname_like);
            this.getCondition().add(searchField);
       }
	   public Integer n_done_eq;//[已处理]
       public void setN_done_eq(Integer n_done_eq) {
            this.n_done_eq=n_done_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("done");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_done_eq);
            this.getCondition().add(searchField);
       }
	   public Integer n_done_noteq;//[已处理]
       public void setN_done_noteq(Integer n_done_noteq) {
            this.n_done_noteq=n_done_noteq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("done");
            searchField.setCondition(SearchFieldType.NOTEQ);
            searchField.setValue(n_done_noteq);
            this.getCondition().add(searchField);
       }
	   public String n_orgdeptname_eq;//[部门名称]
       public void setN_orgdeptname_eq(String n_orgdeptname_eq) {
            this.n_orgdeptname_eq=n_orgdeptname_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("orgdeptname");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_orgdeptname_eq);
            this.getCondition().add(searchField);
       }
	   public String n_orgdeptname_like;//[部门名称]
       public void setN_orgdeptname_like(String n_orgdeptname_like) {
            this.n_orgdeptname_like=n_orgdeptname_like;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("orgdeptname");
            searchField.setCondition(SearchFieldType.LIKE);
            searchField.setValue(n_orgdeptname_like);
            this.getCondition().add(searchField);
       }
	   public String n_wfuserid_eq;//[工作流用户标识]
       public void setN_wfuserid_eq(String n_wfuserid_eq) {
            this.n_wfuserid_eq=n_wfuserid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("wfuserid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_wfuserid_eq);
            this.getCondition().add(searchField);
       }
	   public String n_pswfroleid_eq;//[平台流程角色标识]
       public void setN_pswfroleid_eq(String n_pswfroleid_eq) {
            this.n_pswfroleid_eq=n_pswfroleid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("pswfroleid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_pswfroleid_eq);
            this.getCondition().add(searchField);
       }
	   public String n_orgdeptid_eq;//[部门标识]
       public void setN_orgdeptid_eq(String n_orgdeptid_eq) {
            this.n_orgdeptid_eq=n_orgdeptid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("orgdeptid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_orgdeptid_eq);
            this.getCondition().add(searchField);
       }
	   public String n_orgdeptuserid_eq;//[部门用户标识]
       public void setN_orgdeptuserid_eq(String n_orgdeptuserid_eq) {
            this.n_orgdeptuserid_eq=n_orgdeptuserid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("orgdeptuserid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_orgdeptuserid_eq);
            this.getCondition().add(searchField);
       }
	   public String n_wfinstanceid_eq;//[工作流实例标识]
       public void setN_wfinstanceid_eq(String n_wfinstanceid_eq) {
            this.n_wfinstanceid_eq=n_wfinstanceid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("wfinstanceid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_wfinstanceid_eq);
            this.getCondition().add(searchField);
       }
	   public String n_orgid_eq;//[组织标识]
       public void setN_orgid_eq(String n_orgid_eq) {
            this.n_orgid_eq=n_orgid_eq;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("orgid");
            searchField.setCondition(SearchFieldType.EQ);
            searchField.setValue(n_orgid_eq);
            this.getCondition().add(searchField);
       }

	/**
	 * 启用快速搜索
	 */
	public void setQuery(String strQuery)
	{
		 this.query=strQuery;
         if(!org.springframework.util.StringUtils.isEmpty(strQuery)){
           SearchGroupFilter searchGroupFilter=new SearchGroupFilter();
           searchGroupFilter.setSearchGroupType(SearchGroupType.OR);

           SearchFieldFilter wfworklistname=new SearchFieldFilter();
           wfworklistname.setParam("wfworklistname");
           wfworklistname.setCondition(SearchFieldType.LIKE);
           wfworklistname.setValue(strQuery);
           searchGroupFilter.getCondition().add(wfworklistname);
        this.getCondition().add(searchGroupFilter);   

           
           
        }
	}
}
