package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter;

import java.math.BigDecimal;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import cn.ibizlab.r7.runtime.wf.util.ISearchFilter;
import cn.ibizlab.r7.runtime.wf.util.domain.DataObj;
import com.fasterxml.jackson.annotation.JsonFormat;
import cn.ibizlab.r7.runtime.wf.util.SearchContext;
import cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter;
import cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType;
import cn.ibizlab.r7.runtime.wf.util.enums.SearchGroupType;
import cn.ibizlab.r7.runtime.wf.util.SearchGroupFilter;
import lombok.Data;

/**
 * 关系型数据实体[Workflow] 查询条件对象
 */
@Data
public class WorkflowSearchContext extends SearchContext {

	   public String n_workflowname_like;//[统一工作流名称]
       public void setN_workflowname_like(String n_workflowname_like) {
            this.n_workflowname_like=n_workflowname_like;
            SearchFieldFilter searchField = new SearchFieldFilter();
            searchField.setParam("workflowname");
            searchField.setCondition(SearchFieldType.LIKE);
            searchField.setValue(n_workflowname_like);
            this.getCondition().add(searchField);
       }

	/**
	 * 启用快速搜索
	 */
	public void setQuery(String strQuery)
	{
		 this.query=strQuery;
         if(!org.springframework.util.StringUtils.isEmpty(strQuery)){
           SearchGroupFilter searchGroupFilter=new SearchGroupFilter();
           searchGroupFilter.setSearchGroupType(SearchGroupType.OR);

           SearchFieldFilter workflowname=new SearchFieldFilter();
           workflowname.setParam("workflowname");
           workflowname.setCondition(SearchFieldType.LIKE);
           workflowname.setValue(strQuery);
           searchGroupFilter.getCondition().add(workflowname);
        this.getCondition().add(searchGroupFilter);   

           
           
        }
	}
}
