package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.OrgDeptWFVer;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.OrgDeptWFVerSearchContext;

/**
 * 实体[OrgDeptWFVer] 服务对象接口
 */

public interface IOrgDeptWFVerService{
     OrgDeptWFVer getDraft(OrgDeptWFVer orgDeptWFVer) ;
     boolean save(OrgDeptWFVer orgDeptWFVer) ;
     boolean remove(String orgDeptWFVerId) ;
     boolean create(OrgDeptWFVer orgDeptWFVer) ;
     boolean update(OrgDeptWFVer orgDeptWFVer) ;
     boolean checkKey(OrgDeptWFVer orgDeptWFVer) ;
     OrgDeptWFVer get(String orgDeptWFVerId) ;
     OrgDeptWFVer get(OrgDeptWFVer orgDeptWFVer) ;

    /**
     * 查询集合 DEFAULT
     */
    Page<OrgDeptWFVer> searchDefault(OrgDeptWFVerSearchContext context) ;

    /**
     * 查询集合 当前部门
     */
    Page<OrgDeptWFVer> searchCurOrgDept(OrgDeptWFVerSearchContext context) ;

    /**
     * 根据部门查询
     */
     Page<OrgDeptWFVer> selectByOrgDept(String orgdeptid) ;
     List<OrgDeptWFVer> selectByOrgDept2(String orgdeptid);

    /**
     * 根据业务流程版本查询
     */
     Page<OrgDeptWFVer> selectByPSWFVersion(String pswfversionid) ;
     List<OrgDeptWFVer> selectByPSWFVersion2(String pswfversionid);

    /**
     * 根据业务工作流查询
     */
     Page<OrgDeptWFVer> selectByPSWorkflow(String psworkflowid) ;
     List<OrgDeptWFVer> selectByPSWorkflow2(String psworkflowid);

}
