package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSDEWF;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSDEWFSearchContext;

/**
 * 实体[PSDEWF] 服务对象接口
 */

public interface IPSDEWFService{
     PSDEWF getDraft(PSDEWF pSDEWF) ;
     boolean update(PSDEWF pSDEWF) ;
     boolean checkKey(PSDEWF pSDEWF) ;
     PSDEWF get(String pSDEWFId) ;
     PSDEWF get(PSDEWF pSDEWF) ;
     boolean create(PSDEWF pSDEWF) ;
     boolean remove(String pSDEWFId) ;
     PSDEWF regist(PSDEWF pSDEWF) ;
     boolean save(PSDEWF pSDEWF) ;

    /**
     * 查询集合 DEFAULT
     */
    Page<PSDEWF> searchDefault(PSDEWFSearchContext context) ;

    /**
     * 根据业务实体查询
     */
     Page<PSDEWF> selectByPsdataentity(String psdataentityid) ;
     List<PSDEWF> selectByPsdataentity2(String psdataentityid);

    /**
     * 根据业务工作流查询
     */
     Page<PSDEWF> selectByPsworkflow(String psworkflowid) ;
     List<PSDEWF> selectByPsworkflow2(String psworkflowid);

}
