package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSSystem;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSSystemSearchContext;

/**
 * 实体[PSSystem] 服务对象接口
 */

public interface IPSSystemService{
     boolean remove(String pSSystemId) ;
     boolean save(PSSystem pSSystem) ;
     PSSystem get(String pSSystemId) ;
     PSSystem get(PSSystem pSSystem) ;
     boolean create(PSSystem pSSystem) ;
     boolean update(PSSystem pSSystem) ;
     boolean checkKey(PSSystem pSSystem) ;
     PSSystem regist(PSSystem pSSystem) ;
     PSSystem getDraft(PSSystem pSSystem) ;

    /**
     * 查询集合 DEFAULT
     */
    Page<PSSystem> searchDefault(PSSystemSearchContext context) ;

    /**
     * 根据部门查询
     */
     Page<PSSystem> selectByORGDEPT(String orgdeptid) ;
     List<PSSystem> selectByORGDEPT2(String orgdeptid);

    /**
     * 根据组织查询
     */
     Page<PSSystem> selectByORG(String orgid) ;
     List<PSSystem> selectByORG2(String orgid);

    /**
     * 根据统一工作流查询
     */
     Page<PSSystem> selectByWorkflow(String workflowid) ;
     List<PSSystem> selectByWorkflow2(String workflowid);

}
