package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFLink;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSWFLinkSearchContext;

/**
 * 实体[PSWFLink] 服务对象接口
 */

public interface IPSWFLinkService{
     boolean checkKey(PSWFLink pSWFLink) ;
     boolean remove(String pSWFLinkId) ;
     PSWFLink get(String pSWFLinkId) ;
     PSWFLink get(PSWFLink pSWFLink) ;
     PSWFLink regist(PSWFLink pSWFLink) ;
     boolean save(PSWFLink pSWFLink) ;
     boolean create(PSWFLink pSWFLink) ;
     PSWFLink getDraft(PSWFLink pSWFLink) ;
     boolean update(PSWFLink pSWFLink) ;

    /**
     * 查询集合 DEFAULT
     */
    Page<PSWFLink> searchDefault(PSWFLinkSearchContext context) ;

    /**
     * 根据流程处理查询
     */
     Page<PSWFLink> selectByFromPSWFProc(String pswfprocessid) ;
     List<PSWFLink> selectByFromPSWFProc2(String pswfprocessid);

    /**
     * 根据流程处理查询
     */
     Page<PSWFLink> selectByTOPSWFProc(String pswfprocessid) ;
     List<PSWFLink> selectByTOPSWFProc2(String pswfprocessid);

    /**
     * 根据业务流程版本查询
     */
     Page<PSWFLink> selectByPSWFVersion(String pswfversionid) ;
     List<PSWFLink> selectByPSWFVersion2(String pswfversionid);

}
