package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFPROCSUBWF;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSWFPROCSUBWFSearchContext;

/**
 * 实体[PSWFPROCSUBWF] 服务对象接口
 */

public interface IPSWFPROCSUBWFService{
     boolean create(PSWFPROCSUBWF pSWFPROCSUBWF) ;
     boolean remove(String pSWFPROCSUBWFId) ;
     boolean save(PSWFPROCSUBWF pSWFPROCSUBWF) ;
     PSWFPROCSUBWF getDraft(PSWFPROCSUBWF pSWFPROCSUBWF) ;
     boolean update(PSWFPROCSUBWF pSWFPROCSUBWF) ;
     PSWFPROCSUBWF get(String pSWFPROCSUBWFId) ;
     PSWFPROCSUBWF get(PSWFPROCSUBWF pSWFPROCSUBWF) ;
     boolean checkKey(PSWFPROCSUBWF pSWFPROCSUBWF) ;
     PSWFPROCSUBWF clearByProc(PSWFPROCSUBWF pSWFPROCSUBWF) ;
     PSWFPROCSUBWF regist(PSWFPROCSUBWF pSWFPROCSUBWF) ;

    /**
     * 查询集合 DEFAULT
     */
    Page<PSWFPROCSUBWF> searchDefault(PSWFPROCSUBWFSearchContext context) ;

    /**
     * 根据业务实体查询
     */
     Page<PSWFPROCSUBWF> selectBySUBWFDE(String psdataentityid) ;
     List<PSWFPROCSUBWF> selectBySUBWFDE2(String psdataentityid);

    /**
     * 根据流程处理查询
     */
     Page<PSWFPROCSUBWF> selectByPSWFPROCESS(String pswfprocessid) ;
     List<PSWFPROCSUBWF> selectByPSWFPROCESS2(String pswfprocessid);

    /**
     * 根据业务流程版本查询
     */
     Page<PSWFPROCSUBWF> selectByPSWFVERSION(String pswfversionid) ;
     List<PSWFPROCSUBWF> selectByPSWFVERSION2(String pswfversionid);

    /**
     * 根据业务工作流查询
     */
     Page<PSWFPROCSUBWF> selectByPSWORKFLOW(String psworkflowid) ;
     List<PSWFPROCSUBWF> selectByPSWORKFLOW2(String psworkflowid);

}
