package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFProcRole;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSWFProcRoleSearchContext;

/**
 * 实体[PSWFProcRole] 服务对象接口
 */

public interface IPSWFProcRoleService{
     boolean create(PSWFProcRole pSWFProcRole) ;
     PSWFProcRole getDraft(PSWFProcRole pSWFProcRole) ;
     PSWFProcRole clearByProc(PSWFProcRole pSWFProcRole) ;
     boolean remove(String pSWFProcRoleId) ;
     PSWFProcRole regist(PSWFProcRole pSWFProcRole) ;
     boolean checkKey(PSWFProcRole pSWFProcRole) ;
     PSWFProcRole get(String pSWFProcRoleId) ;
     PSWFProcRole get(PSWFProcRole pSWFProcRole) ;
     boolean save(PSWFProcRole pSWFProcRole) ;
     boolean update(PSWFProcRole pSWFProcRole) ;

    /**
     * 查询集合 DEFAULT
     */
    Page<PSWFProcRole> searchDefault(PSWFProcRoleSearchContext context) ;

    /**
     * 根据流程处理查询
     */
     Page<PSWFProcRole> selectByPSWFProcess(String pswfprocessid) ;
     List<PSWFProcRole> selectByPSWFProcess2(String pswfprocessid);

    /**
     * 根据平台流程角色查询
     */
     Page<PSWFProcRole> selectByPSWFRole(String pswfroleid) ;
     List<PSWFProcRole> selectByPSWFRole2(String pswfroleid);

}
