package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFProcess;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSWFProcessSearchContext;

/**
 * 实体[PSWFProcess] 服务对象接口
 */

public interface IPSWFProcessService{
     PSWFProcess regist(PSWFProcess pSWFProcess) ;
     boolean checkKey(PSWFProcess pSWFProcess) ;
     boolean update(PSWFProcess pSWFProcess) ;
     boolean save(PSWFProcess pSWFProcess) ;
     boolean remove(String pSWFProcessId) ;
     PSWFProcess getDraft(PSWFProcess pSWFProcess) ;
     PSWFProcess get(String pSWFProcessId) ;
     PSWFProcess get(PSWFProcess pSWFProcess) ;
     boolean create(PSWFProcess pSWFProcess) ;

    /**
     * 查询集合 DEFAULT
     */
    Page<PSWFProcess> searchDefault(PSWFProcessSearchContext context) ;

    /**
     * 根据业务流程版本查询
     */
     Page<PSWFProcess> selectByPSWFVersion(String pswfversionid) ;
     List<PSWFProcess> selectByPSWFVersion2(String pswfversionid);

    /**
     * 根据业务工作流查询
     */
     Page<PSWFProcess> selectByTargetPSWF(String psworkflowid) ;
     List<PSWFProcess> selectByTargetPSWF2(String psworkflowid);

}
