package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFRoleDetail;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSWFRoleDetailSearchContext;

/**
 * 实体[PSWFRoleDetail] 服务对象接口
 */

public interface IPSWFRoleDetailService{
     boolean save(PSWFRoleDetail pSWFRoleDetail) ;
     boolean update(PSWFRoleDetail pSWFRoleDetail) ;
     PSWFRoleDetail get(String pSWFRoleDetailId) ;
     PSWFRoleDetail get(PSWFRoleDetail pSWFRoleDetail) ;
     boolean checkKey(PSWFRoleDetail pSWFRoleDetail) ;
     boolean create(PSWFRoleDetail pSWFRoleDetail) ;
     PSWFRoleDetail getDraft(PSWFRoleDetail pSWFRoleDetail) ;
     boolean remove(String pSWFRoleDetailId) ;

    /**
     * 查询集合 DEFAULT
     */
    Page<PSWFRoleDetail> searchDefault(PSWFRoleDetailSearchContext context) ;

    /**
     * 根据部门查询
     */
     Page<PSWFRoleDetail> selectByOrgDept(String orgdeptid) ;
     List<PSWFRoleDetail> selectByOrgDept2(String orgdeptid);

    /**
     * 根据组织用户查询
     */
     Page<PSWFRoleDetail> selectByOrgUser(String orguserid) ;
     List<PSWFRoleDetail> selectByOrgUser2(String orguserid);

    /**
     * 根据组织查询
     */
     Page<PSWFRoleDetail> selectByOrg(String orgid) ;
     List<PSWFRoleDetail> selectByOrg2(String orgid);

    /**
     * 根据平台流程角色查询
     */
     Page<PSWFRoleDetail> selectByPSWFRole(String pswfroleid) ;
     List<PSWFRoleDetail> selectByPSWFRole2(String pswfroleid);

}
