package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFRole;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSWFRoleSearchContext;

/**
 * 实体[PSWFRole] 服务对象接口
 */

public interface IPSWFRoleService{
     boolean checkKey(PSWFRole pSWFRole) ;
     boolean update(PSWFRole pSWFRole) ;
     PSWFRole get(String pSWFRoleId) ;
     PSWFRole get(PSWFRole pSWFRole) ;
     PSWFRole regist(PSWFRole pSWFRole) ;
     PSWFRole getDraft(PSWFRole pSWFRole) ;
     boolean remove(String pSWFRoleId) ;
     boolean create(PSWFRole pSWFRole) ;
     boolean save(PSWFRole pSWFRole) ;

    /**
     * 查询集合 当前组织
     */
    Page<PSWFRole> searchCurOrg(PSWFRoleSearchContext context) ;

    /**
     * 查询集合 当前部门
     */
    Page<PSWFRole> searchCurOrgDept(PSWFRoleSearchContext context) ;

    /**
     * 查询集合 DEFAULT
     */
    Page<PSWFRole> searchDefault(PSWFRoleSearchContext context) ;

    /**
     * 根据部门查询
     */
     Page<PSWFRole> selectByORGDEPT(String orgdeptid) ;
     List<PSWFRole> selectByORGDEPT2(String orgdeptid);

    /**
     * 根据组织查询
     */
     Page<PSWFRole> selectByORG(String orgid) ;
     List<PSWFRole> selectByORG2(String orgid);

}
