package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFVersion;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSWFVersionSearchContext;

/**
 * 实体[PSWFVersion] 服务对象接口
 */

public interface IPSWFVersionService{
     boolean checkKey(PSWFVersion pSWFVersion) ;
     PSWFVersion getDraft(PSWFVersion pSWFVersion) ;
     boolean update(PSWFVersion pSWFVersion) ;
     PSWFVersion regist(PSWFVersion pSWFVersion) ;
     PSWFVersion get(String pSWFVersionId) ;
     PSWFVersion get(PSWFVersion pSWFVersion) ;
     boolean create(PSWFVersion pSWFVersion) ;
     boolean remove(String pSWFVersionId) ;
     boolean save(PSWFVersion pSWFVersion) ;

    /**
     * 查询集合 DEFAULT
     */
    Page<PSWFVersion> searchDefault(PSWFVersionSearchContext context) ;

    /**
     * 根据部门查询
     */
     Page<PSWFVersion> selectByORGDEPT(String orgdeptid) ;
     List<PSWFVersion> selectByORGDEPT2(String orgdeptid);

    /**
     * 根据组织查询
     */
     Page<PSWFVersion> selectByORG(String orgid) ;
     List<PSWFVersion> selectByORG2(String orgid);

    /**
     * 根据业务工作流查询
     */
     Page<PSWFVersion> selectByPsworkflow(String psworkflowid) ;
     List<PSWFVersion> selectByPsworkflow2(String psworkflowid);

    /**
     * 根据工作流应用查询
     */
     Page<PSWFVersion> selectByWfapp(String wfappid) ;
     List<PSWFVersion> selectByWfapp2(String wfappid);

    /**
     * 根据工作流模式查询
     */
     Page<PSWFVersion> selectByWfmode(String wfmodeid) ;
     List<PSWFVersion> selectByWfmode2(String wfmodeid);

}
