package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWorkflow;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSWorkflowSearchContext;

/**
 * 实体[PSWorkflow] 服务对象接口
 */

public interface IPSWorkflowService{
     boolean save(PSWorkflow pSWorkflow) ;
     boolean remove(String pSWorkflowId) ;
     boolean update(PSWorkflow pSWorkflow) ;
     boolean checkKey(PSWorkflow pSWorkflow) ;
     boolean create(PSWorkflow pSWorkflow) ;
     PSWorkflow getDraft(PSWorkflow pSWorkflow) ;
     PSWorkflow get(String pSWorkflowId) ;
     PSWorkflow get(PSWorkflow pSWorkflow) ;
     PSWorkflow regist(PSWorkflow pSWorkflow) ;

    /**
     * 查询集合 当前组织
     */
    Page<PSWorkflow> searchCurOrg(PSWorkflowSearchContext context) ;

    /**
     * 查询集合 当前部门
     */
    Page<PSWorkflow> searchCurOrgDept(PSWorkflowSearchContext context) ;

    /**
     * 查询集合 DEFAULT
     */
    Page<PSWorkflow> searchDefault(PSWorkflowSearchContext context) ;

    /**
     * 根据部门查询
     */
     Page<PSWorkflow> selectByORGDEPT(String orgdeptid) ;
     List<PSWorkflow> selectByORGDEPT2(String orgdeptid);

    /**
     * 根据组织查询
     */
     Page<PSWorkflow> selectByORG(String orgid) ;
     List<PSWorkflow> selectByORG2(String orgid);

    /**
     * 根据业务系统查询
     */
     Page<PSWorkflow> selectByPssystem(String pssystemid) ;
     List<PSWorkflow> selectByPssystem2(String pssystemid);

}
