package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFInstance;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WFInstanceSearchContext;

/**
 * 实体[WFInstance] 服务对象接口
 */

public interface IWFInstanceService{
     WFInstance get(String wFInstanceId) ;
     WFInstance get(WFInstance wFInstance) ;
     boolean checkKey(WFInstance wFInstance) ;
     boolean remove(String wFInstanceId) ;
     boolean create(WFInstance wFInstance) ;
     WFInstance getDraft(WFInstance wFInstance) ;
     boolean save(WFInstance wFInstance) ;
     boolean update(WFInstance wFInstance) ;

    /**
     * 查询集合 DEFAULT
     */
    Page<WFInstance> searchDefault(WFInstanceSearchContext context) ;

    /**
     * 根据部门查询
     */
     Page<WFInstance> selectByOrgDept(String orgdeptid) ;
     List<WFInstance> selectByOrgDept2(String orgdeptid);

    /**
     * 根据组织查询
     */
     Page<WFInstance> selectByOrg(String orgid) ;
     List<WFInstance> selectByOrg2(String orgid);

    /**
     * 根据业务流程版本查询
     */
     Page<WFInstance> selectByPswfversion(String pswfversionid) ;
     List<WFInstance> selectByPswfversion2(String pswfversionid);

    /**
     * 根据业务工作流查询
     */
     Page<WFInstance> selectByPsworkflow(String psworkflowid) ;
     List<WFInstance> selectByPsworkflow2(String psworkflowid);

    /**
     * 根据工作流引擎查询
     */
     Page<WFInstance> selectByWfengine(String wfengineid) ;
     List<WFInstance> selectByWfengine2(String wfengineid);

}
