package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFStepActor;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WFStepActorSearchContext;

/**
 * 实体[WFStepActor] 服务对象接口
 */

public interface IWFStepActorService{
     boolean checkKey(WFStepActor wFStepActor) ;
     WFStepActor get(String wFStepActorId) ;
     WFStepActor get(WFStepActor wFStepActor) ;
     boolean create(WFStepActor wFStepActor) ;
     boolean remove(String wFStepActorId) ;
     boolean save(WFStepActor wFStepActor) ;
     boolean update(WFStepActor wFStepActor) ;
     WFStepActor getDraft(WFStepActor wFStepActor) ;
     WFStepActor calculateNext(WFStepActor wFStepActor) ;

    /**
     * 查询集合 DEFAULT
     */
    Page<WFStepActor> searchDefault(WFStepActorSearchContext context) ;

    /**
     * 根据流程处理查询
     */
     Page<WFStepActor> selectByPSWFProcess(String pswfprocessid) ;
     List<WFStepActor> selectByPSWFProcess2(String pswfprocessid);

    /**
     * 根据业务流程版本查询
     */
     Page<WFStepActor> selectByPSWFVersion(String pswfversionid) ;
     List<WFStepActor> selectByPSWFVersion2(String pswfversionid);

    /**
     * 根据工作流实例查询
     */
     Page<WFStepActor> selectByWFInstance(String wfinstanceid) ;
     List<WFStepActor> selectByWFInstance2(String wfinstanceid);

    /**
     * 根据工作流步骤查询
     */
     Page<WFStepActor> selectByWfstep(String wfstepid) ;
     List<WFStepActor> selectByWfstep2(String wfstepid);

    /**
     * 根据工作流用户查询
     */
     Page<WFStepActor> selectByWfuser(String wfuserid) ;
     List<WFStepActor> selectByWfuser2(String wfuserid);

}
