package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFStepData;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WFStepDataSearchContext;

/**
 * 实体[WFStepData] 服务对象接口
 */

public interface IWFStepDataService{
     boolean create(WFStepData wFStepData) ;
     WFStepData get(String wFStepDataId) ;
     WFStepData get(WFStepData wFStepData) ;
     boolean checkKey(WFStepData wFStepData) ;
     boolean update(WFStepData wFStepData) ;
     boolean remove(String wFStepDataId) ;
     WFStepData getDraft(WFStepData wFStepData) ;
     boolean save(WFStepData wFStepData) ;

    /**
     * 查询集合 ByBswfdata
     */
    Page<WFStepData> searchByBswfdata(WFStepDataSearchContext context) ;

    /**
     * 查询集合 ByBsdata
     */
    Page<WFStepData> searchByBsdata(WFStepDataSearchContext context) ;

    /**
     * 查询集合 DEFAULT
     */
    Page<WFStepData> searchDefault(WFStepDataSearchContext context) ;

    /**
     * 根据工作流步骤操作查询
     */
     Page<WFStepData> selectByWFIAAction(String wfiaactionid) ;
     List<WFStepData> selectByWFIAAction2(String wfiaactionid);

    /**
     * 根据工作流实例查询
     */
     Page<WFStepData> selectByWFINSTANCE(String wfinstanceid) ;
     List<WFStepData> selectByWFINSTANCE2(String wfinstanceid);

    /**
     * 根据工作流步骤查询
     */
     Page<WFStepData> selectByWFStep(String wfstepid) ;
     List<WFStepData> selectByWFStep2(String wfstepid);

}
