package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFStep;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WFStepSearchContext;

/**
 * 实体[WFStep] 服务对象接口
 */

public interface IWFStepService{
     WFStep getDraft(WFStep wFStep) ;
     boolean create(WFStep wFStep) ;
     boolean save(WFStep wFStep) ;
     boolean checkKey(WFStep wFStep) ;
     WFStep get(String wFStepId) ;
     WFStep get(WFStep wFStep) ;
     boolean update(WFStep wFStep) ;
     boolean remove(String wFStepId) ;

    /**
     * 查询集合 DEFAULT
     */
    Page<WFStep> searchDefault(WFStepSearchContext context) ;

    /**
     * 根据流程处理查询
     */
     Page<WFStep> selectByPSWFProcess(String pswfprocessid) ;
     List<WFStep> selectByPSWFProcess2(String pswfprocessid);

    /**
     * 根据业务流程版本查询
     */
     Page<WFStep> selectByPSWFVersion(String pswfversionid) ;
     List<WFStep> selectByPSWFVersion2(String pswfversionid);

    /**
     * 根据工作流实例查询
     */
     Page<WFStep> selectByWFInstance(String wfinstanceid) ;
     List<WFStep> selectByWFInstance2(String wfinstanceid);

}
