package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFWorklist;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WFWorklistSearchContext;

/**
 * 实体[WFWorklist] 服务对象接口
 */

public interface IWFWorklistService{
     void updateBatch(List<WFWorklist> wfworklists) ;
     boolean checkKey(WFWorklist wFWorklist) ;
     WFWorklist getDraft(WFWorklist wFWorklist) ;
     boolean update(WFWorklist wFWorklist) ;
     void createBatch(List<WFWorklist> wfworklists) ;
     boolean remove(String wFWorklistId) ;
     WFWorklist get(String wFWorklistId) ;
     WFWorklist get(WFWorklist wFWorklist) ;
     boolean save(WFWorklist wFWorklist) ;
     boolean create(WFWorklist wFWorklist) ;

    /**
     * 查询集合 DEFAULT
     */
    Page<WFWorklist> searchDefault(WFWorklistSearchContext context) ;

    /**
     * 查询集合 我的已办查询
     */
    Page<WFWorklist> searchDoneTask(WFWorklistSearchContext context) ;

    /**
     * 查询集合 我的待办查询
     */
    Page<WFWorklist> searchTodoTask(WFWorklistSearchContext context) ;

    /**
     * 根据部门用户查询
     */
     Page<WFWorklist> selectByORGDEPTUSER(String orgdeptuserid) ;
     List<WFWorklist> selectByORGDEPTUSER2(String orgdeptuserid);

    /**
     * 根据部门查询
     */
     Page<WFWorklist> selectByORGDEPT(String orgdeptid) ;
     List<WFWorklist> selectByORGDEPT2(String orgdeptid);

    /**
     * 根据组织查询
     */
     Page<WFWorklist> selectByORG(String orgid) ;
     List<WFWorklist> selectByORG2(String orgid);

    /**
     * 根据平台流程角色查询
     */
     Page<WFWorklist> selectByPSWFROLE(String pswfroleid) ;
     List<WFWorklist> selectByPSWFROLE2(String pswfroleid);

    /**
     * 根据工作流实例查询
     */
     Page<WFWorklist> selectByWFInstance(String wfinstanceid) ;
     List<WFWorklist> selectByWFInstance2(String wfinstanceid);

    /**
     * 根据工作流用户查询
     */
     Page<WFWorklist> selectByWFUser(String wfuserid) ;
     List<WFWorklist> selectByWFUser2(String wfuserid);

}
