package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.transaction.annotation.Transactional;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.Entity;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.EntitySearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IEntityService;
import org.springframework.beans.factory.annotation.Autowired;
import cn.ibizlab.r7.runtime.wf.util.SearchResult;

/**
 * 实体[实体] 服务对象接口实现
 */
@Service
public class EntityServiceImpl implements IEntityService {

    @Autowired
    cn.ibizlab.r7.runtime.wf.core.repository.EntityRepository entityRepository;

    @Override
    @Transactional
    public Entity get(String entityid) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.Entity _t_ENTITY = entityRepository.get(entityid);
        if(_t_ENTITY == null)
            return null ;

        Entity _entity = entityRepository.convert2Domain(_t_ENTITY,null) ;

        return _entity;
    }

    @Override
    @Transactional
    public Entity get(Entity entity) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.Entity t_ENTITY = entityRepository.get(entity.getEntityId());
        entityRepository.convert2Domain(t_ENTITY,entity);
        return entity;
    }

    @Override
    @Transactional
    public boolean save(Entity entity) {
        if(entity.getEntityId()==null){
    		return create(entity);
    	}else{
            if(this.get(entity.getEntityId())!=null){
    			return update(entity);
    		}
    		return create(entity);
    	}
    }

    @Override
    @Transactional
    public boolean create(Entity entity) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.Entity t_ENTITY = entityRepository.convert2PO(entity,null);
        bOk = entityRepository.create(t_ENTITY);
        entityRepository.convert2Domain(t_ENTITY,entity);


        return bOk ;
    }

    @Override
    @Transactional
    public boolean remove(String entityid) {
        boolean bOk = false ;

        Entity _entity = this.get(entityid);
        bOk = entityRepository.remove(entityid);

        return bOk ;
    }

    @Override
    public boolean checkKey(Entity entity) {
        return true;
    }

    @Override
    @Transactional
    public boolean update(Entity entity) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.Entity t_ENTITY = entityRepository.convert2PO(entity,null);
        bOk = entityRepository.update(t_ENTITY);
        entityRepository.convert2Domain(t_ENTITY,entity) ;
        return bOk ;
    }

    @Override
    public Entity getDraft(Entity entity) {
        return entity;
    }

    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<Entity> searchDefault(EntitySearchContext context) {
        List<Entity> list = new ArrayList<Entity>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.Entity> t_ENTITYs = entityRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.Entity t_ENTITY : t_ENTITYs){
            list.add(entityRepository.convert2Domain(t_ENTITY,null));
        }
        return new PageImpl<Entity>(list, context.getPageable(), t_ENTITYs.getTotalElements());
    }






}
