package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.transaction.annotation.Transactional;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.OrgDeptWFVer;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.OrgDeptWFVerSearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IOrgDeptWFVerService;
import org.springframework.beans.factory.annotation.Autowired;
import cn.ibizlab.r7.runtime.wf.util.SearchResult;

/**
 * 实体[部门流程版本] 服务对象接口实现
 */
@Service
public class OrgDeptWFVerServiceImpl implements IOrgDeptWFVerService {

    @Autowired
    cn.ibizlab.r7.runtime.wf.core.repository.OrgDeptWFVerRepository orgDeptWFVerRepository;

    @Override
    public OrgDeptWFVer getDraft(OrgDeptWFVer orgdeptwfver) {
        return orgdeptwfver;
    }

    @Override
    @Transactional
    public boolean save(OrgDeptWFVer orgdeptwfver) {
        if(orgdeptwfver.getOrgDeptWFVerId()==null){
    		return create(orgdeptwfver);
    	}else{
            if(this.get(orgdeptwfver.getOrgDeptWFVerId())!=null){
    			return update(orgdeptwfver);
    		}
    		return create(orgdeptwfver);
    	}
    }

    @Override
    @Transactional
    public boolean remove(String orgdeptwfverid) {
        boolean bOk = false ;

        OrgDeptWFVer _orgDeptWFVer = this.get(orgdeptwfverid);
        bOk = orgDeptWFVerRepository.remove(orgdeptwfverid);

        return bOk ;
    }

    @Override
    @Transactional
    public boolean create(OrgDeptWFVer orgdeptwfver) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.OrgDeptWFVer t_ORGDEPTWFVER = orgDeptWFVerRepository.convert2PO(orgdeptwfver,null);
        bOk = orgDeptWFVerRepository.create(t_ORGDEPTWFVER);
        orgDeptWFVerRepository.convert2Domain(t_ORGDEPTWFVER,orgdeptwfver);


        return bOk ;
    }

    @Override
    @Transactional
    public boolean update(OrgDeptWFVer orgdeptwfver) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.OrgDeptWFVer t_ORGDEPTWFVER = orgDeptWFVerRepository.convert2PO(orgdeptwfver,null);
        bOk = orgDeptWFVerRepository.update(t_ORGDEPTWFVER);
        orgDeptWFVerRepository.convert2Domain(t_ORGDEPTWFVER,orgdeptwfver) ;
        return bOk ;
    }

    @Override
    public boolean checkKey(OrgDeptWFVer orgdeptwfver) {
        return true;
    }

    @Override
    @Transactional
    public OrgDeptWFVer get(String orgdeptwfverid) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.OrgDeptWFVer _t_ORGDEPTWFVER = orgDeptWFVerRepository.get(orgdeptwfverid);
        if(_t_ORGDEPTWFVER == null)
            return null ;

        OrgDeptWFVer _orgDeptWFVer = orgDeptWFVerRepository.convert2Domain(_t_ORGDEPTWFVER,null) ;

        return _orgDeptWFVer;
    }

    @Override
    @Transactional
    public OrgDeptWFVer get(OrgDeptWFVer orgdeptwfver) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.OrgDeptWFVer t_ORGDEPTWFVER = orgDeptWFVerRepository.get(orgdeptwfver.getOrgDeptWFVerId());
        orgDeptWFVerRepository.convert2Domain(t_ORGDEPTWFVER,orgdeptwfver);
        return orgdeptwfver;
    }

    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<OrgDeptWFVer> searchDefault(OrgDeptWFVerSearchContext context) {
        List<OrgDeptWFVer> list = new ArrayList<OrgDeptWFVer>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.OrgDeptWFVer> t_ORGDEPTWFVERs = orgDeptWFVerRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.OrgDeptWFVer t_ORGDEPTWFVER : t_ORGDEPTWFVERs){
            list.add(orgDeptWFVerRepository.convert2Domain(t_ORGDEPTWFVER,null));
        }
        return new PageImpl<OrgDeptWFVer>(list, context.getPageable(), t_ORGDEPTWFVERs.getTotalElements());
    }

    /**
     * 查询集合 当前部门
     */
    @Override
    public Page<OrgDeptWFVer> searchCurOrgDept(OrgDeptWFVerSearchContext context) {
        List<OrgDeptWFVer> list = new ArrayList<OrgDeptWFVer>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.OrgDeptWFVer> t_ORGDEPTWFVERs = orgDeptWFVerRepository.searchCurOrgDept(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.OrgDeptWFVer t_ORGDEPTWFVER : t_ORGDEPTWFVERs){
            list.add(orgDeptWFVerRepository.convert2Domain(t_ORGDEPTWFVER,null));
        }
        return new PageImpl<OrgDeptWFVer>(list, context.getPageable(), t_ORGDEPTWFVERs.getTotalElements());
    }


    /**
     * 根据部门查询
     */
    @Override
    public Page<OrgDeptWFVer> selectByOrgDept(String orgdeptid){
        OrgDeptWFVerSearchContext context = new OrgDeptWFVerSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgdeptid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("orgdeptid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgdeptid);
            context.getCondition().add(fieldFilter);
        }
        List<OrgDeptWFVer> list = new ArrayList<OrgDeptWFVer>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.OrgDeptWFVer> t_ORGDEPTWFVERs = orgDeptWFVerRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.OrgDeptWFVer t_ORGDEPTWFVER : t_ORGDEPTWFVERs){
            list.add(orgDeptWFVerRepository.convert2Domain(t_ORGDEPTWFVER,null));
        }
        return new PageImpl<OrgDeptWFVer>(list, context.getPageable(), t_ORGDEPTWFVERs.getTotalElements());
    }

    /**
     * 根据部门查询
     */
    @Override
    public List<OrgDeptWFVer> selectByOrgDept2(String orgdeptid){
        OrgDeptWFVerSearchContext context = new OrgDeptWFVerSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgdeptid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("orgdeptid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgdeptid);
            context.getCondition().add(fieldFilter);
        }
        List<OrgDeptWFVer> list = new ArrayList<OrgDeptWFVer>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.OrgDeptWFVer> t_ORGDEPTWFVERs = orgDeptWFVerRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.OrgDeptWFVer t_ORGDEPTWFVER : t_ORGDEPTWFVERs){
            list.add(orgDeptWFVerRepository.convert2Domain(t_ORGDEPTWFVER,null));
        }
        return list;
    }
    /**
     * 根据业务流程版本查询
     */
    @Override
    public Page<OrgDeptWFVer> selectByPSWFVersion(String pswfversionid){
        OrgDeptWFVerSearchContext context = new OrgDeptWFVerSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pswfversionid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pswfversionid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pswfversionid);
            context.getCondition().add(fieldFilter);
        }
        List<OrgDeptWFVer> list = new ArrayList<OrgDeptWFVer>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.OrgDeptWFVer> t_ORGDEPTWFVERs = orgDeptWFVerRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.OrgDeptWFVer t_ORGDEPTWFVER : t_ORGDEPTWFVERs){
            list.add(orgDeptWFVerRepository.convert2Domain(t_ORGDEPTWFVER,null));
        }
        return new PageImpl<OrgDeptWFVer>(list, context.getPageable(), t_ORGDEPTWFVERs.getTotalElements());
    }

    /**
     * 根据业务流程版本查询
     */
    @Override
    public List<OrgDeptWFVer> selectByPSWFVersion2(String pswfversionid){
        OrgDeptWFVerSearchContext context = new OrgDeptWFVerSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pswfversionid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pswfversionid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pswfversionid);
            context.getCondition().add(fieldFilter);
        }
        List<OrgDeptWFVer> list = new ArrayList<OrgDeptWFVer>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.OrgDeptWFVer> t_ORGDEPTWFVERs = orgDeptWFVerRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.OrgDeptWFVer t_ORGDEPTWFVER : t_ORGDEPTWFVERs){
            list.add(orgDeptWFVerRepository.convert2Domain(t_ORGDEPTWFVER,null));
        }
        return list;
    }
    /**
     * 根据业务工作流查询
     */
    @Override
    public Page<OrgDeptWFVer> selectByPSWorkflow(String psworkflowid){
        OrgDeptWFVerSearchContext context = new OrgDeptWFVerSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(psworkflowid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("psworkflowid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(psworkflowid);
            context.getCondition().add(fieldFilter);
        }
        List<OrgDeptWFVer> list = new ArrayList<OrgDeptWFVer>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.OrgDeptWFVer> t_ORGDEPTWFVERs = orgDeptWFVerRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.OrgDeptWFVer t_ORGDEPTWFVER : t_ORGDEPTWFVERs){
            list.add(orgDeptWFVerRepository.convert2Domain(t_ORGDEPTWFVER,null));
        }
        return new PageImpl<OrgDeptWFVer>(list, context.getPageable(), t_ORGDEPTWFVERs.getTotalElements());
    }

    /**
     * 根据业务工作流查询
     */
    @Override
    public List<OrgDeptWFVer> selectByPSWorkflow2(String psworkflowid){
        OrgDeptWFVerSearchContext context = new OrgDeptWFVerSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(psworkflowid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("psworkflowid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(psworkflowid);
            context.getCondition().add(fieldFilter);
        }
        List<OrgDeptWFVer> list = new ArrayList<OrgDeptWFVer>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.OrgDeptWFVer> t_ORGDEPTWFVERs = orgDeptWFVerRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.OrgDeptWFVer t_ORGDEPTWFVER : t_ORGDEPTWFVERs){
            list.add(orgDeptWFVerRepository.convert2Domain(t_ORGDEPTWFVER,null));
        }
        return list;
    }




}
