package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.transaction.annotation.Transactional;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSDEWF;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSDEWFSearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IPSDEWFService;
import org.springframework.beans.factory.annotation.Autowired;
import cn.ibizlab.r7.runtime.wf.util.SearchResult;

/**
 * 实体[业务实体工作流] 服务对象接口实现
 */
@Service
public class PSDEWFServiceImpl implements IPSDEWFService {

    @Autowired
    cn.ibizlab.r7.runtime.wf.core.repository.PSDEWFRepository pSDEWFRepository;

    @Override
    public PSDEWF getDraft(PSDEWF psdewf) {
        return psdewf;
    }

    @Override
    @Transactional
    public boolean update(PSDEWF psdewf) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSDEWF t_PSDEWF = pSDEWFRepository.convert2PO(psdewf,null);
        bOk = pSDEWFRepository.update(t_PSDEWF);
        pSDEWFRepository.convert2Domain(t_PSDEWF,psdewf) ;
        return bOk ;
    }

    @Override
    public boolean checkKey(PSDEWF psdewf) {
        return true;
    }

    @Override
    @Transactional
    public PSDEWF get(String psdewfid) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSDEWF _t_PSDEWF = pSDEWFRepository.get(psdewfid);
        if(_t_PSDEWF == null)
            return null ;

        PSDEWF _pSDEWF = pSDEWFRepository.convert2Domain(_t_PSDEWF,null) ;

        return _pSDEWF;
    }

    @Override
    @Transactional
    public PSDEWF get(PSDEWF psdewf) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSDEWF t_PSDEWF = pSDEWFRepository.get(psdewf.getPSDEWFId());
        pSDEWFRepository.convert2Domain(t_PSDEWF,psdewf);
        return psdewf;
    }

    @Override
    @Transactional
    public boolean create(PSDEWF psdewf) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSDEWF t_PSDEWF = pSDEWFRepository.convert2PO(psdewf,null);
        bOk = pSDEWFRepository.create(t_PSDEWF);
        pSDEWFRepository.convert2Domain(t_PSDEWF,psdewf);


        return bOk ;
    }

    @Override
    @Transactional
    public boolean remove(String psdewfid) {
        boolean bOk = false ;

        PSDEWF _pSDEWF = this.get(psdewfid);
        bOk = pSDEWFRepository.remove(psdewfid);

        return bOk ;
    }

    @Override
    @Transactional
    public PSDEWF regist(PSDEWF psdewf) {
         return psdewf;
    }

    @Override
    @Transactional
    public boolean save(PSDEWF psdewf) {
        if(psdewf.getPSDEWFId()==null){
    		return create(psdewf);
    	}else{
            if(this.get(psdewf.getPSDEWFId())!=null){
    			return update(psdewf);
    		}
    		return create(psdewf);
    	}
    }

    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<PSDEWF> searchDefault(PSDEWFSearchContext context) {
        List<PSDEWF> list = new ArrayList<PSDEWF>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSDEWF> t_PSDEWFs = pSDEWFRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSDEWF t_PSDEWF : t_PSDEWFs){
            list.add(pSDEWFRepository.convert2Domain(t_PSDEWF,null));
        }
        return new PageImpl<PSDEWF>(list, context.getPageable(), t_PSDEWFs.getTotalElements());
    }


    /**
     * 根据业务实体查询
     */
    @Override
    public Page<PSDEWF> selectByPsdataentity(String psdataentityid){
        PSDEWFSearchContext context = new PSDEWFSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(psdataentityid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("psdataentityid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(psdataentityid);
            context.getCondition().add(fieldFilter);
        }
        List<PSDEWF> list = new ArrayList<PSDEWF>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSDEWF> t_PSDEWFs = pSDEWFRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSDEWF t_PSDEWF : t_PSDEWFs){
            list.add(pSDEWFRepository.convert2Domain(t_PSDEWF,null));
        }
        return new PageImpl<PSDEWF>(list, context.getPageable(), t_PSDEWFs.getTotalElements());
    }

    /**
     * 根据业务实体查询
     */
    @Override
    public List<PSDEWF> selectByPsdataentity2(String psdataentityid){
        PSDEWFSearchContext context = new PSDEWFSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(psdataentityid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("psdataentityid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(psdataentityid);
            context.getCondition().add(fieldFilter);
        }
        List<PSDEWF> list = new ArrayList<PSDEWF>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSDEWF> t_PSDEWFs = pSDEWFRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSDEWF t_PSDEWF : t_PSDEWFs){
            list.add(pSDEWFRepository.convert2Domain(t_PSDEWF,null));
        }
        return list;
    }
    /**
     * 根据业务工作流查询
     */
    @Override
    public Page<PSDEWF> selectByPsworkflow(String psworkflowid){
        PSDEWFSearchContext context = new PSDEWFSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(psworkflowid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("psworkflowid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(psworkflowid);
            context.getCondition().add(fieldFilter);
        }
        List<PSDEWF> list = new ArrayList<PSDEWF>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSDEWF> t_PSDEWFs = pSDEWFRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSDEWF t_PSDEWF : t_PSDEWFs){
            list.add(pSDEWFRepository.convert2Domain(t_PSDEWF,null));
        }
        return new PageImpl<PSDEWF>(list, context.getPageable(), t_PSDEWFs.getTotalElements());
    }

    /**
     * 根据业务工作流查询
     */
    @Override
    public List<PSDEWF> selectByPsworkflow2(String psworkflowid){
        PSDEWFSearchContext context = new PSDEWFSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(psworkflowid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("psworkflowid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(psworkflowid);
            context.getCondition().add(fieldFilter);
        }
        List<PSDEWF> list = new ArrayList<PSDEWF>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSDEWF> t_PSDEWFs = pSDEWFRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSDEWF t_PSDEWF : t_PSDEWFs){
            list.add(pSDEWFRepository.convert2Domain(t_PSDEWF,null));
        }
        return list;
    }




}
