package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.transaction.annotation.Transactional;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSDataEntity;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSDataEntitySearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IPSDataEntityService;
import org.springframework.beans.factory.annotation.Autowired;
import cn.ibizlab.r7.runtime.wf.util.SearchResult;

/**
 * 实体[业务实体] 服务对象接口实现
 */
@Service
public class PSDataEntityServiceImpl implements IPSDataEntityService {

    @Autowired
    cn.ibizlab.r7.runtime.wf.core.repository.PSDataEntityRepository pSDataEntityRepository;

    @Override
    public PSDataEntity getDraft(PSDataEntity psdataentity) {
        return psdataentity;
    }

    @Override
    @Transactional
    public boolean update(PSDataEntity psdataentity) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSDataEntity t_PSDATAENTITY = pSDataEntityRepository.convert2PO(psdataentity,null);
        bOk = pSDataEntityRepository.update(t_PSDATAENTITY);
        pSDataEntityRepository.convert2Domain(t_PSDATAENTITY,psdataentity) ;
        return bOk ;
    }

    @Override
    @Transactional
    public boolean remove(String psdataentityid) {
        boolean bOk = false ;

        PSDataEntity _pSDataEntity = this.get(psdataentityid);
        bOk = pSDataEntityRepository.remove(psdataentityid);

        return bOk ;
    }

    @Override
    @Transactional
    public PSDataEntity regist(PSDataEntity psdataentity) {
         return psdataentity;
    }

    @Override
    @Transactional
    public boolean create(PSDataEntity psdataentity) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSDataEntity t_PSDATAENTITY = pSDataEntityRepository.convert2PO(psdataentity,null);
        bOk = pSDataEntityRepository.create(t_PSDATAENTITY);
        pSDataEntityRepository.convert2Domain(t_PSDATAENTITY,psdataentity);


        return bOk ;
    }

    @Override
    @Transactional
    public boolean save(PSDataEntity psdataentity) {
        if(psdataentity.getPSDataEntityId()==null){
    		return create(psdataentity);
    	}else{
            if(this.get(psdataentity.getPSDataEntityId())!=null){
    			return update(psdataentity);
    		}
    		return create(psdataentity);
    	}
    }

    @Override
    @Transactional
    public PSDataEntity get(String psdataentityid) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSDataEntity _t_PSDATAENTITY = pSDataEntityRepository.get(psdataentityid);
        if(_t_PSDATAENTITY == null)
            return null ;

        PSDataEntity _pSDataEntity = pSDataEntityRepository.convert2Domain(_t_PSDATAENTITY,null) ;

        return _pSDataEntity;
    }

    @Override
    @Transactional
    public PSDataEntity get(PSDataEntity psdataentity) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSDataEntity t_PSDATAENTITY = pSDataEntityRepository.get(psdataentity.getPSDataEntityId());
        pSDataEntityRepository.convert2Domain(t_PSDATAENTITY,psdataentity);
        return psdataentity;
    }

    @Override
    public boolean checkKey(PSDataEntity psdataentity) {
        return true;
    }

    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<PSDataEntity> searchDefault(PSDataEntitySearchContext context) {
        List<PSDataEntity> list = new ArrayList<PSDataEntity>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSDataEntity> t_PSDATAENTITYs = pSDataEntityRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSDataEntity t_PSDATAENTITY : t_PSDATAENTITYs){
            list.add(pSDataEntityRepository.convert2Domain(t_PSDATAENTITY,null));
        }
        return new PageImpl<PSDataEntity>(list, context.getPageable(), t_PSDATAENTITYs.getTotalElements());
    }


    /**
     * 根据业务系统查询
     */
    @Override
    public Page<PSDataEntity> selectByPssystem(String pssystemid){
        PSDataEntitySearchContext context = new PSDataEntitySearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pssystemid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pssystemid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pssystemid);
            context.getCondition().add(fieldFilter);
        }
        List<PSDataEntity> list = new ArrayList<PSDataEntity>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSDataEntity> t_PSDATAENTITYs = pSDataEntityRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSDataEntity t_PSDATAENTITY : t_PSDATAENTITYs){
            list.add(pSDataEntityRepository.convert2Domain(t_PSDATAENTITY,null));
        }
        return new PageImpl<PSDataEntity>(list, context.getPageable(), t_PSDATAENTITYs.getTotalElements());
    }

    /**
     * 根据业务系统查询
     */
    @Override
    public List<PSDataEntity> selectByPssystem2(String pssystemid){
        PSDataEntitySearchContext context = new PSDataEntitySearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pssystemid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pssystemid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pssystemid);
            context.getCondition().add(fieldFilter);
        }
        List<PSDataEntity> list = new ArrayList<PSDataEntity>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSDataEntity> t_PSDATAENTITYs = pSDataEntityRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSDataEntity t_PSDATAENTITY : t_PSDATAENTITYs){
            list.add(pSDataEntityRepository.convert2Domain(t_PSDATAENTITY,null));
        }
        return list;
    }




}
