package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.transaction.annotation.Transactional;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSSysApp;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSSysAppSearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IPSSysAppService;
import org.springframework.beans.factory.annotation.Autowired;
import cn.ibizlab.r7.runtime.wf.util.SearchResult;

/**
 * 实体[业务系统应用] 服务对象接口实现
 */
@Service
public class PSSysAppServiceImpl implements IPSSysAppService {

    @Autowired
    cn.ibizlab.r7.runtime.wf.core.repository.PSSysAppRepository pSSysAppRepository;

    @Override
    @Transactional
    public PSSysApp get(String pssysappid) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSSysApp _t_PSSYSAPP = pSSysAppRepository.get(pssysappid);
        if(_t_PSSYSAPP == null)
            return null ;

        PSSysApp _pSSysApp = pSSysAppRepository.convert2Domain(_t_PSSYSAPP,null) ;

        return _pSSysApp;
    }

    @Override
    @Transactional
    public PSSysApp get(PSSysApp pssysapp) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSSysApp t_PSSYSAPP = pSSysAppRepository.get(pssysapp.getPSSysAppId());
        pSSysAppRepository.convert2Domain(t_PSSYSAPP,pssysapp);
        return pssysapp;
    }

    @Override
    @Transactional
    public boolean save(PSSysApp pssysapp) {
        if(pssysapp.getPSSysAppId()==null){
    		return create(pssysapp);
    	}else{
            if(this.get(pssysapp.getPSSysAppId())!=null){
    			return update(pssysapp);
    		}
    		return create(pssysapp);
    	}
    }

    @Override
    @Transactional
    public boolean create(PSSysApp pssysapp) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSSysApp t_PSSYSAPP = pSSysAppRepository.convert2PO(pssysapp,null);
        bOk = pSSysAppRepository.create(t_PSSYSAPP);
        pSSysAppRepository.convert2Domain(t_PSSYSAPP,pssysapp);


        return bOk ;
    }

    @Override
    public PSSysApp getDraft(PSSysApp pssysapp) {
        return pssysapp;
    }

    @Override
    @Transactional
    public boolean remove(String pssysappid) {
        boolean bOk = false ;

        PSSysApp _pSSysApp = this.get(pssysappid);
        bOk = pSSysAppRepository.remove(pssysappid);

        return bOk ;
    }

    @Override
    public boolean checkKey(PSSysApp pssysapp) {
        return true;
    }

    @Override
    @Transactional
    public boolean update(PSSysApp pssysapp) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSSysApp t_PSSYSAPP = pSSysAppRepository.convert2PO(pssysapp,null);
        bOk = pSSysAppRepository.update(t_PSSYSAPP);
        pSSysAppRepository.convert2Domain(t_PSSYSAPP,pssysapp) ;
        return bOk ;
    }

    @Override
    @Transactional
    public PSSysApp regist(PSSysApp pssysapp) {
         return pssysapp;
    }

    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<PSSysApp> searchDefault(PSSysAppSearchContext context) {
        List<PSSysApp> list = new ArrayList<PSSysApp>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSSysApp> t_PSSYSAPPs = pSSysAppRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSSysApp t_PSSYSAPP : t_PSSYSAPPs){
            list.add(pSSysAppRepository.convert2Domain(t_PSSYSAPP,null));
        }
        return new PageImpl<PSSysApp>(list, context.getPageable(), t_PSSYSAPPs.getTotalElements());
    }


    /**
     * 根据业务系统查询
     */
    @Override
    public Page<PSSysApp> selectByPssystem(String pssystemid){
        PSSysAppSearchContext context = new PSSysAppSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pssystemid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pssystemid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pssystemid);
            context.getCondition().add(fieldFilter);
        }
        List<PSSysApp> list = new ArrayList<PSSysApp>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSSysApp> t_PSSYSAPPs = pSSysAppRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSSysApp t_PSSYSAPP : t_PSSYSAPPs){
            list.add(pSSysAppRepository.convert2Domain(t_PSSYSAPP,null));
        }
        return new PageImpl<PSSysApp>(list, context.getPageable(), t_PSSYSAPPs.getTotalElements());
    }

    /**
     * 根据业务系统查询
     */
    @Override
    public List<PSSysApp> selectByPssystem2(String pssystemid){
        PSSysAppSearchContext context = new PSSysAppSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pssystemid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pssystemid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pssystemid);
            context.getCondition().add(fieldFilter);
        }
        List<PSSysApp> list = new ArrayList<PSSysApp>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSSysApp> t_PSSYSAPPs = pSSysAppRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSSysApp t_PSSYSAPP : t_PSSYSAPPs){
            list.add(pSSysAppRepository.convert2Domain(t_PSSYSAPP,null));
        }
        return list;
    }




}
