package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.transaction.annotation.Transactional;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSSysWFCat;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSSysWFCatSearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IPSSysWFCatService;
import org.springframework.beans.factory.annotation.Autowired;
import cn.ibizlab.r7.runtime.wf.util.SearchResult;

/**
 * 实体[系统流程分类] 服务对象接口实现
 */
@Service
public class PSSysWFCatServiceImpl implements IPSSysWFCatService {

    @Autowired
    cn.ibizlab.r7.runtime.wf.core.repository.PSSysWFCatRepository pSSysWFCatRepository;

    @Override
    @Transactional
    public PSSysWFCat get(String pssyswfcatid) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSSysWFCat _t_PSSYSWFCAT = pSSysWFCatRepository.get(pssyswfcatid);
        if(_t_PSSYSWFCAT == null)
            return null ;

        PSSysWFCat _pSSysWFCat = pSSysWFCatRepository.convert2Domain(_t_PSSYSWFCAT,null) ;

        return _pSSysWFCat;
    }

    @Override
    @Transactional
    public PSSysWFCat get(PSSysWFCat pssyswfcat) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSSysWFCat t_PSSYSWFCAT = pSSysWFCatRepository.get(pssyswfcat.getPSSysWFCatId());
        pSSysWFCatRepository.convert2Domain(t_PSSYSWFCAT,pssyswfcat);
        return pssyswfcat;
    }

    @Override
    public boolean checkKey(PSSysWFCat pssyswfcat) {
        return true;
    }

    @Override
    @Transactional
    public boolean update(PSSysWFCat pssyswfcat) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSSysWFCat t_PSSYSWFCAT = pSSysWFCatRepository.convert2PO(pssyswfcat,null);
        bOk = pSSysWFCatRepository.update(t_PSSYSWFCAT);
        pSSysWFCatRepository.convert2Domain(t_PSSYSWFCAT,pssyswfcat) ;
        return bOk ;
    }

    @Override
    @Transactional
    public boolean save(PSSysWFCat pssyswfcat) {
        if(pssyswfcat.getPSSysWFCatId()==null){
    		return create(pssyswfcat);
    	}else{
            if(this.get(pssyswfcat.getPSSysWFCatId())!=null){
    			return update(pssyswfcat);
    		}
    		return create(pssyswfcat);
    	}
    }

    @Override
    @Transactional
    public boolean create(PSSysWFCat pssyswfcat) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSSysWFCat t_PSSYSWFCAT = pSSysWFCatRepository.convert2PO(pssyswfcat,null);
        bOk = pSSysWFCatRepository.create(t_PSSYSWFCAT);
        pSSysWFCatRepository.convert2Domain(t_PSSYSWFCAT,pssyswfcat);


        return bOk ;
    }

    @Override
    public PSSysWFCat getDraft(PSSysWFCat pssyswfcat) {
        return pssyswfcat;
    }

    @Override
    @Transactional
    public boolean remove(String pssyswfcatid) {
        boolean bOk = false ;

        PSSysWFCat _pSSysWFCat = this.get(pssyswfcatid);
        bOk = pSSysWFCatRepository.remove(pssyswfcatid);

        return bOk ;
    }

    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<PSSysWFCat> searchDefault(PSSysWFCatSearchContext context) {
        List<PSSysWFCat> list = new ArrayList<PSSysWFCat>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSSysWFCat> t_PSSYSWFCATs = pSSysWFCatRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSSysWFCat t_PSSYSWFCAT : t_PSSYSWFCATs){
            list.add(pSSysWFCatRepository.convert2Domain(t_PSSYSWFCAT,null));
        }
        return new PageImpl<PSSysWFCat>(list, context.getPageable(), t_PSSYSWFCATs.getTotalElements());
    }






}
