package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.transaction.annotation.Transactional;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSSystem;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSSystemSearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IPSSystemService;
import org.springframework.beans.factory.annotation.Autowired;
import cn.ibizlab.r7.runtime.wf.util.SearchResult;

/**
 * 实体[业务系统] 服务对象接口实现
 */
@Service
public class PSSystemServiceImpl implements IPSSystemService {

    @Autowired
    cn.ibizlab.r7.runtime.wf.core.repository.PSSystemRepository pSSystemRepository;

    @Override
    @Transactional
    public boolean remove(String pssystemid) {
        boolean bOk = false ;

        PSSystem _pSSystem = this.get(pssystemid);
        bOk = pSSystemRepository.remove(pssystemid);

        return bOk ;
    }

    @Override
    @Transactional
    public boolean save(PSSystem pssystem) {
        if(pssystem.getPSSystemId()==null){
    		return create(pssystem);
    	}else{
            if(this.get(pssystem.getPSSystemId())!=null){
    			return update(pssystem);
    		}
    		return create(pssystem);
    	}
    }

    @Override
    @Transactional
    public PSSystem get(String pssystemid) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSSystem _t_PSSYSTEM = pSSystemRepository.get(pssystemid);
        if(_t_PSSYSTEM == null)
            return null ;

        PSSystem _pSSystem = pSSystemRepository.convert2Domain(_t_PSSYSTEM,null) ;

        return _pSSystem;
    }

    @Override
    @Transactional
    public PSSystem get(PSSystem pssystem) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSSystem t_PSSYSTEM = pSSystemRepository.get(pssystem.getPSSystemId());
        pSSystemRepository.convert2Domain(t_PSSYSTEM,pssystem);
        return pssystem;
    }

    @Override
    @Transactional
    public boolean create(PSSystem pssystem) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSSystem t_PSSYSTEM = pSSystemRepository.convert2PO(pssystem,null);
        bOk = pSSystemRepository.create(t_PSSYSTEM);
        pSSystemRepository.convert2Domain(t_PSSYSTEM,pssystem);


        return bOk ;
    }

    @Override
    @Transactional
    public boolean update(PSSystem pssystem) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSSystem t_PSSYSTEM = pSSystemRepository.convert2PO(pssystem,null);
        bOk = pSSystemRepository.update(t_PSSYSTEM);
        pSSystemRepository.convert2Domain(t_PSSYSTEM,pssystem) ;
        return bOk ;
    }

    @Override
    public boolean checkKey(PSSystem pssystem) {
        return true;
    }

    @Override
    @Transactional
    public PSSystem regist(PSSystem pssystem) {
         return pssystem;
    }

    @Override
    public PSSystem getDraft(PSSystem pssystem) {
        return pssystem;
    }

    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<PSSystem> searchDefault(PSSystemSearchContext context) {
        List<PSSystem> list = new ArrayList<PSSystem>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSSystem> t_PSSYSTEMs = pSSystemRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSSystem t_PSSYSTEM : t_PSSYSTEMs){
            list.add(pSSystemRepository.convert2Domain(t_PSSYSTEM,null));
        }
        return new PageImpl<PSSystem>(list, context.getPageable(), t_PSSYSTEMs.getTotalElements());
    }


    /**
     * 根据部门查询
     */
    @Override
    public Page<PSSystem> selectByORGDEPT(String orgdeptid){
        PSSystemSearchContext context = new PSSystemSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgdeptid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("orgdeptid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgdeptid);
            context.getCondition().add(fieldFilter);
        }
        List<PSSystem> list = new ArrayList<PSSystem>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSSystem> t_PSSYSTEMs = pSSystemRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSSystem t_PSSYSTEM : t_PSSYSTEMs){
            list.add(pSSystemRepository.convert2Domain(t_PSSYSTEM,null));
        }
        return new PageImpl<PSSystem>(list, context.getPageable(), t_PSSYSTEMs.getTotalElements());
    }

    /**
     * 根据部门查询
     */
    @Override
    public List<PSSystem> selectByORGDEPT2(String orgdeptid){
        PSSystemSearchContext context = new PSSystemSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgdeptid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("orgdeptid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgdeptid);
            context.getCondition().add(fieldFilter);
        }
        List<PSSystem> list = new ArrayList<PSSystem>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSSystem> t_PSSYSTEMs = pSSystemRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSSystem t_PSSYSTEM : t_PSSYSTEMs){
            list.add(pSSystemRepository.convert2Domain(t_PSSYSTEM,null));
        }
        return list;
    }
    /**
     * 根据组织查询
     */
    @Override
    public Page<PSSystem> selectByORG(String orgid){
        PSSystemSearchContext context = new PSSystemSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("orgid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgid);
            context.getCondition().add(fieldFilter);
        }
        List<PSSystem> list = new ArrayList<PSSystem>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSSystem> t_PSSYSTEMs = pSSystemRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSSystem t_PSSYSTEM : t_PSSYSTEMs){
            list.add(pSSystemRepository.convert2Domain(t_PSSYSTEM,null));
        }
        return new PageImpl<PSSystem>(list, context.getPageable(), t_PSSYSTEMs.getTotalElements());
    }

    /**
     * 根据组织查询
     */
    @Override
    public List<PSSystem> selectByORG2(String orgid){
        PSSystemSearchContext context = new PSSystemSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("orgid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgid);
            context.getCondition().add(fieldFilter);
        }
        List<PSSystem> list = new ArrayList<PSSystem>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSSystem> t_PSSYSTEMs = pSSystemRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSSystem t_PSSYSTEM : t_PSSYSTEMs){
            list.add(pSSystemRepository.convert2Domain(t_PSSYSTEM,null));
        }
        return list;
    }
    /**
     * 根据统一工作流查询
     */
    @Override
    public Page<PSSystem> selectByWorkflow(String workflowid){
        PSSystemSearchContext context = new PSSystemSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(workflowid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("workflowid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(workflowid);
            context.getCondition().add(fieldFilter);
        }
        List<PSSystem> list = new ArrayList<PSSystem>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSSystem> t_PSSYSTEMs = pSSystemRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSSystem t_PSSYSTEM : t_PSSYSTEMs){
            list.add(pSSystemRepository.convert2Domain(t_PSSYSTEM,null));
        }
        return new PageImpl<PSSystem>(list, context.getPageable(), t_PSSYSTEMs.getTotalElements());
    }

    /**
     * 根据统一工作流查询
     */
    @Override
    public List<PSSystem> selectByWorkflow2(String workflowid){
        PSSystemSearchContext context = new PSSystemSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(workflowid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("workflowid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(workflowid);
            context.getCondition().add(fieldFilter);
        }
        List<PSSystem> list = new ArrayList<PSSystem>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSSystem> t_PSSYSTEMs = pSSystemRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSSystem t_PSSYSTEM : t_PSSYSTEMs){
            list.add(pSSystemRepository.convert2Domain(t_PSSYSTEM,null));
        }
        return list;
    }




}
