package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.transaction.annotation.Transactional;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFLink;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSWFLinkSearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IPSWFLinkService;
import org.springframework.beans.factory.annotation.Autowired;
import cn.ibizlab.r7.runtime.wf.util.SearchResult;

/**
 * 实体[流程连接] 服务对象接口实现
 */
@Service
public class PSWFLinkServiceImpl implements IPSWFLinkService {

    @Autowired
    cn.ibizlab.r7.runtime.wf.core.repository.PSWFLinkRepository pSWFLinkRepository;

    @Override
    public boolean checkKey(PSWFLink pswflink) {
        return true;
    }

    @Override
    @Transactional
    public boolean remove(String pswflinkid) {
        boolean bOk = false ;

        PSWFLink _pSWFLink = this.get(pswflinkid);
        bOk = pSWFLinkRepository.remove(pswflinkid);

        return bOk ;
    }

    @Override
    @Transactional
    public PSWFLink get(String pswflinkid) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFLink _t_PSWFLINK = pSWFLinkRepository.get(pswflinkid);
        if(_t_PSWFLINK == null)
            return null ;

        PSWFLink _pSWFLink = pSWFLinkRepository.convert2Domain(_t_PSWFLINK,null) ;

        return _pSWFLink;
    }

    @Override
    @Transactional
    public PSWFLink get(PSWFLink pswflink) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFLink t_PSWFLINK = pSWFLinkRepository.get(pswflink.getPSWFLinkId());
        pSWFLinkRepository.convert2Domain(t_PSWFLINK,pswflink);
        return pswflink;
    }

    @Override
    @Transactional
    public PSWFLink regist(PSWFLink pswflink) {
         return pswflink;
    }

    @Override
    @Transactional
    public boolean save(PSWFLink pswflink) {
        if(pswflink.getPSWFLinkId()==null){
    		return create(pswflink);
    	}else{
            if(this.get(pswflink.getPSWFLinkId())!=null){
    			return update(pswflink);
    		}
    		return create(pswflink);
    	}
    }

    @Override
    @Transactional
    public boolean create(PSWFLink pswflink) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFLink t_PSWFLINK = pSWFLinkRepository.convert2PO(pswflink,null);
        bOk = pSWFLinkRepository.create(t_PSWFLINK);
        pSWFLinkRepository.convert2Domain(t_PSWFLINK,pswflink);


        return bOk ;
    }

    @Override
    public PSWFLink getDraft(PSWFLink pswflink) {
        return pswflink;
    }

    @Override
    @Transactional
    public boolean update(PSWFLink pswflink) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFLink t_PSWFLINK = pSWFLinkRepository.convert2PO(pswflink,null);
        bOk = pSWFLinkRepository.update(t_PSWFLINK);
        pSWFLinkRepository.convert2Domain(t_PSWFLINK,pswflink) ;
        return bOk ;
    }

    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<PSWFLink> searchDefault(PSWFLinkSearchContext context) {
        List<PSWFLink> list = new ArrayList<PSWFLink>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFLink> t_PSWFLINKs = pSWFLinkRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFLink t_PSWFLINK : t_PSWFLINKs){
            list.add(pSWFLinkRepository.convert2Domain(t_PSWFLINK,null));
        }
        return new PageImpl<PSWFLink>(list, context.getPageable(), t_PSWFLINKs.getTotalElements());
    }


    /**
     * 根据流程处理查询
     */
    @Override
    public Page<PSWFLink> selectByFromPSWFProc(String pswfprocessid){
        PSWFLinkSearchContext context = new PSWFLinkSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pswfprocessid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pswfprocessid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pswfprocessid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFLink> list = new ArrayList<PSWFLink>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFLink> t_PSWFLINKs = pSWFLinkRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFLink t_PSWFLINK : t_PSWFLINKs){
            list.add(pSWFLinkRepository.convert2Domain(t_PSWFLINK,null));
        }
        return new PageImpl<PSWFLink>(list, context.getPageable(), t_PSWFLINKs.getTotalElements());
    }

    /**
     * 根据流程处理查询
     */
    @Override
    public List<PSWFLink> selectByFromPSWFProc2(String pswfprocessid){
        PSWFLinkSearchContext context = new PSWFLinkSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pswfprocessid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pswfprocessid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pswfprocessid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFLink> list = new ArrayList<PSWFLink>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFLink> t_PSWFLINKs = pSWFLinkRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFLink t_PSWFLINK : t_PSWFLINKs){
            list.add(pSWFLinkRepository.convert2Domain(t_PSWFLINK,null));
        }
        return list;
    }
    /**
     * 根据流程处理查询
     */
    @Override
    public Page<PSWFLink> selectByTOPSWFProc(String pswfprocessid){
        PSWFLinkSearchContext context = new PSWFLinkSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pswfprocessid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pswfprocessid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pswfprocessid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFLink> list = new ArrayList<PSWFLink>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFLink> t_PSWFLINKs = pSWFLinkRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFLink t_PSWFLINK : t_PSWFLINKs){
            list.add(pSWFLinkRepository.convert2Domain(t_PSWFLINK,null));
        }
        return new PageImpl<PSWFLink>(list, context.getPageable(), t_PSWFLINKs.getTotalElements());
    }

    /**
     * 根据流程处理查询
     */
    @Override
    public List<PSWFLink> selectByTOPSWFProc2(String pswfprocessid){
        PSWFLinkSearchContext context = new PSWFLinkSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pswfprocessid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pswfprocessid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pswfprocessid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFLink> list = new ArrayList<PSWFLink>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFLink> t_PSWFLINKs = pSWFLinkRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFLink t_PSWFLINK : t_PSWFLINKs){
            list.add(pSWFLinkRepository.convert2Domain(t_PSWFLINK,null));
        }
        return list;
    }
    /**
     * 根据业务流程版本查询
     */
    @Override
    public Page<PSWFLink> selectByPSWFVersion(String pswfversionid){
        PSWFLinkSearchContext context = new PSWFLinkSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pswfversionid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pswfversionid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pswfversionid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFLink> list = new ArrayList<PSWFLink>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFLink> t_PSWFLINKs = pSWFLinkRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFLink t_PSWFLINK : t_PSWFLINKs){
            list.add(pSWFLinkRepository.convert2Domain(t_PSWFLINK,null));
        }
        return new PageImpl<PSWFLink>(list, context.getPageable(), t_PSWFLINKs.getTotalElements());
    }

    /**
     * 根据业务流程版本查询
     */
    @Override
    public List<PSWFLink> selectByPSWFVersion2(String pswfversionid){
        PSWFLinkSearchContext context = new PSWFLinkSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pswfversionid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pswfversionid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pswfversionid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFLink> list = new ArrayList<PSWFLink>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFLink> t_PSWFLINKs = pSWFLinkRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFLink t_PSWFLINK : t_PSWFLINKs){
            list.add(pSWFLinkRepository.convert2Domain(t_PSWFLINK,null));
        }
        return list;
    }




}
