package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.transaction.annotation.Transactional;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFPROCSUBWF;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSWFPROCSUBWFSearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IPSWFPROCSUBWFService;
import org.springframework.beans.factory.annotation.Autowired;
import cn.ibizlab.r7.runtime.wf.util.SearchResult;

/**
 * 实体[嵌套流程] 服务对象接口实现
 */
@Service
public class PSWFPROCSUBWFServiceImpl implements IPSWFPROCSUBWFService {

    @Autowired
    cn.ibizlab.r7.runtime.wf.core.repository.PSWFPROCSUBWFRepository pSWFPROCSUBWFRepository;

    @Override
    @Transactional
    public boolean create(PSWFPROCSUBWF pswfprocsubwf) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFPROCSUBWF t_PSWFPROCSUBWF = pSWFPROCSUBWFRepository.convert2PO(pswfprocsubwf,null);
        bOk = pSWFPROCSUBWFRepository.create(t_PSWFPROCSUBWF);
        pSWFPROCSUBWFRepository.convert2Domain(t_PSWFPROCSUBWF,pswfprocsubwf);


        return bOk ;
    }

    @Override
    @Transactional
    public boolean remove(String pswfprocsubwfid) {
        boolean bOk = false ;

        PSWFPROCSUBWF _pSWFPROCSUBWF = this.get(pswfprocsubwfid);
        bOk = pSWFPROCSUBWFRepository.remove(pswfprocsubwfid);

        return bOk ;
    }

    @Override
    @Transactional
    public boolean save(PSWFPROCSUBWF pswfprocsubwf) {
        if(pswfprocsubwf.getPSWFPROCSUBWFId()==null){
    		return create(pswfprocsubwf);
    	}else{
            if(this.get(pswfprocsubwf.getPSWFPROCSUBWFId())!=null){
    			return update(pswfprocsubwf);
    		}
    		return create(pswfprocsubwf);
    	}
    }

    @Override
    public PSWFPROCSUBWF getDraft(PSWFPROCSUBWF pswfprocsubwf) {
        return pswfprocsubwf;
    }

    @Override
    @Transactional
    public boolean update(PSWFPROCSUBWF pswfprocsubwf) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFPROCSUBWF t_PSWFPROCSUBWF = pSWFPROCSUBWFRepository.convert2PO(pswfprocsubwf,null);
        bOk = pSWFPROCSUBWFRepository.update(t_PSWFPROCSUBWF);
        pSWFPROCSUBWFRepository.convert2Domain(t_PSWFPROCSUBWF,pswfprocsubwf) ;
        return bOk ;
    }

    @Override
    @Transactional
    public PSWFPROCSUBWF get(String pswfprocsubwfid) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFPROCSUBWF _t_PSWFPROCSUBWF = pSWFPROCSUBWFRepository.get(pswfprocsubwfid);
        if(_t_PSWFPROCSUBWF == null)
            return null ;

        PSWFPROCSUBWF _pSWFPROCSUBWF = pSWFPROCSUBWFRepository.convert2Domain(_t_PSWFPROCSUBWF,null) ;

        return _pSWFPROCSUBWF;
    }

    @Override
    @Transactional
    public PSWFPROCSUBWF get(PSWFPROCSUBWF pswfprocsubwf) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFPROCSUBWF t_PSWFPROCSUBWF = pSWFPROCSUBWFRepository.get(pswfprocsubwf.getPSWFPROCSUBWFId());
        pSWFPROCSUBWFRepository.convert2Domain(t_PSWFPROCSUBWF,pswfprocsubwf);
        return pswfprocsubwf;
    }

    @Override
    public boolean checkKey(PSWFPROCSUBWF pswfprocsubwf) {
        return true;
    }

    @Override
    @Transactional
    public PSWFPROCSUBWF clearByProc(PSWFPROCSUBWF pswfprocsubwf) {
        
        return pswfprocsubwf;
    }

    @Override
    @Transactional
    public PSWFPROCSUBWF regist(PSWFPROCSUBWF pswfprocsubwf) {
         return pswfprocsubwf;
    }

    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<PSWFPROCSUBWF> searchDefault(PSWFPROCSUBWFSearchContext context) {
        List<PSWFPROCSUBWF> list = new ArrayList<PSWFPROCSUBWF>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFPROCSUBWF> t_PSWFPROCSUBWFs = pSWFPROCSUBWFRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFPROCSUBWF t_PSWFPROCSUBWF : t_PSWFPROCSUBWFs){
            list.add(pSWFPROCSUBWFRepository.convert2Domain(t_PSWFPROCSUBWF,null));
        }
        return new PageImpl<PSWFPROCSUBWF>(list, context.getPageable(), t_PSWFPROCSUBWFs.getTotalElements());
    }


    /**
     * 根据业务实体查询
     */
    @Override
    public Page<PSWFPROCSUBWF> selectBySUBWFDE(String psdataentityid){
        PSWFPROCSUBWFSearchContext context = new PSWFPROCSUBWFSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(psdataentityid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("psdataentityid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(psdataentityid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFPROCSUBWF> list = new ArrayList<PSWFPROCSUBWF>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFPROCSUBWF> t_PSWFPROCSUBWFs = pSWFPROCSUBWFRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFPROCSUBWF t_PSWFPROCSUBWF : t_PSWFPROCSUBWFs){
            list.add(pSWFPROCSUBWFRepository.convert2Domain(t_PSWFPROCSUBWF,null));
        }
        return new PageImpl<PSWFPROCSUBWF>(list, context.getPageable(), t_PSWFPROCSUBWFs.getTotalElements());
    }

    /**
     * 根据业务实体查询
     */
    @Override
    public List<PSWFPROCSUBWF> selectBySUBWFDE2(String psdataentityid){
        PSWFPROCSUBWFSearchContext context = new PSWFPROCSUBWFSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(psdataentityid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("psdataentityid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(psdataentityid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFPROCSUBWF> list = new ArrayList<PSWFPROCSUBWF>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFPROCSUBWF> t_PSWFPROCSUBWFs = pSWFPROCSUBWFRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFPROCSUBWF t_PSWFPROCSUBWF : t_PSWFPROCSUBWFs){
            list.add(pSWFPROCSUBWFRepository.convert2Domain(t_PSWFPROCSUBWF,null));
        }
        return list;
    }
    /**
     * 根据流程处理查询
     */
    @Override
    public Page<PSWFPROCSUBWF> selectByPSWFPROCESS(String pswfprocessid){
        PSWFPROCSUBWFSearchContext context = new PSWFPROCSUBWFSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pswfprocessid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pswfprocessid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pswfprocessid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFPROCSUBWF> list = new ArrayList<PSWFPROCSUBWF>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFPROCSUBWF> t_PSWFPROCSUBWFs = pSWFPROCSUBWFRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFPROCSUBWF t_PSWFPROCSUBWF : t_PSWFPROCSUBWFs){
            list.add(pSWFPROCSUBWFRepository.convert2Domain(t_PSWFPROCSUBWF,null));
        }
        return new PageImpl<PSWFPROCSUBWF>(list, context.getPageable(), t_PSWFPROCSUBWFs.getTotalElements());
    }

    /**
     * 根据流程处理查询
     */
    @Override
    public List<PSWFPROCSUBWF> selectByPSWFPROCESS2(String pswfprocessid){
        PSWFPROCSUBWFSearchContext context = new PSWFPROCSUBWFSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pswfprocessid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pswfprocessid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pswfprocessid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFPROCSUBWF> list = new ArrayList<PSWFPROCSUBWF>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFPROCSUBWF> t_PSWFPROCSUBWFs = pSWFPROCSUBWFRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFPROCSUBWF t_PSWFPROCSUBWF : t_PSWFPROCSUBWFs){
            list.add(pSWFPROCSUBWFRepository.convert2Domain(t_PSWFPROCSUBWF,null));
        }
        return list;
    }
    /**
     * 根据业务流程版本查询
     */
    @Override
    public Page<PSWFPROCSUBWF> selectByPSWFVERSION(String pswfversionid){
        PSWFPROCSUBWFSearchContext context = new PSWFPROCSUBWFSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pswfversionid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pswfversionid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pswfversionid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFPROCSUBWF> list = new ArrayList<PSWFPROCSUBWF>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFPROCSUBWF> t_PSWFPROCSUBWFs = pSWFPROCSUBWFRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFPROCSUBWF t_PSWFPROCSUBWF : t_PSWFPROCSUBWFs){
            list.add(pSWFPROCSUBWFRepository.convert2Domain(t_PSWFPROCSUBWF,null));
        }
        return new PageImpl<PSWFPROCSUBWF>(list, context.getPageable(), t_PSWFPROCSUBWFs.getTotalElements());
    }

    /**
     * 根据业务流程版本查询
     */
    @Override
    public List<PSWFPROCSUBWF> selectByPSWFVERSION2(String pswfversionid){
        PSWFPROCSUBWFSearchContext context = new PSWFPROCSUBWFSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pswfversionid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pswfversionid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pswfversionid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFPROCSUBWF> list = new ArrayList<PSWFPROCSUBWF>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFPROCSUBWF> t_PSWFPROCSUBWFs = pSWFPROCSUBWFRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFPROCSUBWF t_PSWFPROCSUBWF : t_PSWFPROCSUBWFs){
            list.add(pSWFPROCSUBWFRepository.convert2Domain(t_PSWFPROCSUBWF,null));
        }
        return list;
    }
    /**
     * 根据业务工作流查询
     */
    @Override
    public Page<PSWFPROCSUBWF> selectByPSWORKFLOW(String psworkflowid){
        PSWFPROCSUBWFSearchContext context = new PSWFPROCSUBWFSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(psworkflowid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("psworkflowid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(psworkflowid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFPROCSUBWF> list = new ArrayList<PSWFPROCSUBWF>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFPROCSUBWF> t_PSWFPROCSUBWFs = pSWFPROCSUBWFRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFPROCSUBWF t_PSWFPROCSUBWF : t_PSWFPROCSUBWFs){
            list.add(pSWFPROCSUBWFRepository.convert2Domain(t_PSWFPROCSUBWF,null));
        }
        return new PageImpl<PSWFPROCSUBWF>(list, context.getPageable(), t_PSWFPROCSUBWFs.getTotalElements());
    }

    /**
     * 根据业务工作流查询
     */
    @Override
    public List<PSWFPROCSUBWF> selectByPSWORKFLOW2(String psworkflowid){
        PSWFPROCSUBWFSearchContext context = new PSWFPROCSUBWFSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(psworkflowid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("psworkflowid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(psworkflowid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFPROCSUBWF> list = new ArrayList<PSWFPROCSUBWF>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFPROCSUBWF> t_PSWFPROCSUBWFs = pSWFPROCSUBWFRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFPROCSUBWF t_PSWFPROCSUBWF : t_PSWFPROCSUBWFs){
            list.add(pSWFPROCSUBWFRepository.convert2Domain(t_PSWFPROCSUBWF,null));
        }
        return list;
    }




}
