package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.transaction.annotation.Transactional;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFProcRole;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSWFProcRoleSearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IPSWFProcRoleService;
import org.springframework.beans.factory.annotation.Autowired;
import cn.ibizlab.r7.runtime.wf.util.SearchResult;

/**
 * 实体[流程处理角色] 服务对象接口实现
 */
@Service
public class PSWFProcRoleServiceImpl implements IPSWFProcRoleService {

    @Autowired
    cn.ibizlab.r7.runtime.wf.core.repository.PSWFProcRoleRepository pSWFProcRoleRepository;

    @Override
    @Transactional
    public boolean create(PSWFProcRole pswfprocrole) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFProcRole t_PSWFPROCROLE = pSWFProcRoleRepository.convert2PO(pswfprocrole,null);
        bOk = pSWFProcRoleRepository.create(t_PSWFPROCROLE);
        pSWFProcRoleRepository.convert2Domain(t_PSWFPROCROLE,pswfprocrole);


        return bOk ;
    }

    @Override
    public PSWFProcRole getDraft(PSWFProcRole pswfprocrole) {
        return pswfprocrole;
    }

    @Override
    @Transactional
    public PSWFProcRole clearByProc(PSWFProcRole pswfprocrole) {
        
        return pswfprocrole;
    }

    @Override
    @Transactional
    public boolean remove(String pswfprocroleid) {
        boolean bOk = false ;

        PSWFProcRole _pSWFProcRole = this.get(pswfprocroleid);
        bOk = pSWFProcRoleRepository.remove(pswfprocroleid);

        return bOk ;
    }

    @Override
    @Transactional
    public PSWFProcRole regist(PSWFProcRole pswfprocrole) {
         return pswfprocrole;
    }

    @Override
    public boolean checkKey(PSWFProcRole pswfprocrole) {
        return true;
    }

    @Override
    @Transactional
    public PSWFProcRole get(String pswfprocroleid) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFProcRole _t_PSWFPROCROLE = pSWFProcRoleRepository.get(pswfprocroleid);
        if(_t_PSWFPROCROLE == null)
            return null ;

        PSWFProcRole _pSWFProcRole = pSWFProcRoleRepository.convert2Domain(_t_PSWFPROCROLE,null) ;

        return _pSWFProcRole;
    }

    @Override
    @Transactional
    public PSWFProcRole get(PSWFProcRole pswfprocrole) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFProcRole t_PSWFPROCROLE = pSWFProcRoleRepository.get(pswfprocrole.getPSWFProcRoleId());
        pSWFProcRoleRepository.convert2Domain(t_PSWFPROCROLE,pswfprocrole);
        return pswfprocrole;
    }

    @Override
    @Transactional
    public boolean save(PSWFProcRole pswfprocrole) {
        if(pswfprocrole.getPSWFProcRoleId()==null){
    		return create(pswfprocrole);
    	}else{
            if(this.get(pswfprocrole.getPSWFProcRoleId())!=null){
    			return update(pswfprocrole);
    		}
    		return create(pswfprocrole);
    	}
    }

    @Override
    @Transactional
    public boolean update(PSWFProcRole pswfprocrole) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFProcRole t_PSWFPROCROLE = pSWFProcRoleRepository.convert2PO(pswfprocrole,null);
        bOk = pSWFProcRoleRepository.update(t_PSWFPROCROLE);
        pSWFProcRoleRepository.convert2Domain(t_PSWFPROCROLE,pswfprocrole) ;
        return bOk ;
    }

    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<PSWFProcRole> searchDefault(PSWFProcRoleSearchContext context) {
        List<PSWFProcRole> list = new ArrayList<PSWFProcRole>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFProcRole> t_PSWFPROCROLEs = pSWFProcRoleRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFProcRole t_PSWFPROCROLE : t_PSWFPROCROLEs){
            list.add(pSWFProcRoleRepository.convert2Domain(t_PSWFPROCROLE,null));
        }
        return new PageImpl<PSWFProcRole>(list, context.getPageable(), t_PSWFPROCROLEs.getTotalElements());
    }


    /**
     * 根据流程处理查询
     */
    @Override
    public Page<PSWFProcRole> selectByPSWFProcess(String pswfprocessid){
        PSWFProcRoleSearchContext context = new PSWFProcRoleSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pswfprocessid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pswfprocessid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pswfprocessid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFProcRole> list = new ArrayList<PSWFProcRole>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFProcRole> t_PSWFPROCROLEs = pSWFProcRoleRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFProcRole t_PSWFPROCROLE : t_PSWFPROCROLEs){
            list.add(pSWFProcRoleRepository.convert2Domain(t_PSWFPROCROLE,null));
        }
        return new PageImpl<PSWFProcRole>(list, context.getPageable(), t_PSWFPROCROLEs.getTotalElements());
    }

    /**
     * 根据流程处理查询
     */
    @Override
    public List<PSWFProcRole> selectByPSWFProcess2(String pswfprocessid){
        PSWFProcRoleSearchContext context = new PSWFProcRoleSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pswfprocessid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pswfprocessid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pswfprocessid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFProcRole> list = new ArrayList<PSWFProcRole>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFProcRole> t_PSWFPROCROLEs = pSWFProcRoleRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFProcRole t_PSWFPROCROLE : t_PSWFPROCROLEs){
            list.add(pSWFProcRoleRepository.convert2Domain(t_PSWFPROCROLE,null));
        }
        return list;
    }
    /**
     * 根据平台流程角色查询
     */
    @Override
    public Page<PSWFProcRole> selectByPSWFRole(String pswfroleid){
        PSWFProcRoleSearchContext context = new PSWFProcRoleSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pswfroleid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pswfroleid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pswfroleid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFProcRole> list = new ArrayList<PSWFProcRole>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFProcRole> t_PSWFPROCROLEs = pSWFProcRoleRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFProcRole t_PSWFPROCROLE : t_PSWFPROCROLEs){
            list.add(pSWFProcRoleRepository.convert2Domain(t_PSWFPROCROLE,null));
        }
        return new PageImpl<PSWFProcRole>(list, context.getPageable(), t_PSWFPROCROLEs.getTotalElements());
    }

    /**
     * 根据平台流程角色查询
     */
    @Override
    public List<PSWFProcRole> selectByPSWFRole2(String pswfroleid){
        PSWFProcRoleSearchContext context = new PSWFProcRoleSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pswfroleid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pswfroleid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pswfroleid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFProcRole> list = new ArrayList<PSWFProcRole>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFProcRole> t_PSWFPROCROLEs = pSWFProcRoleRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFProcRole t_PSWFPROCROLE : t_PSWFPROCROLEs){
            list.add(pSWFProcRoleRepository.convert2Domain(t_PSWFPROCROLE,null));
        }
        return list;
    }




}
