package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.transaction.annotation.Transactional;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFProcess;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSWFProcessSearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IPSWFProcessService;
import org.springframework.beans.factory.annotation.Autowired;
import cn.ibizlab.r7.runtime.wf.util.SearchResult;

/**
 * 实体[流程处理] 服务对象接口实现
 */
@Service
public class PSWFProcessServiceImpl implements IPSWFProcessService {

    @Autowired
    cn.ibizlab.r7.runtime.wf.core.repository.PSWFProcessRepository pSWFProcessRepository;

    @Override
    @Transactional
    public PSWFProcess regist(PSWFProcess pswfprocess) {
         return pswfprocess;
    }

    @Override
    public boolean checkKey(PSWFProcess pswfprocess) {
        return true;
    }

    @Override
    @Transactional
    public boolean update(PSWFProcess pswfprocess) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFProcess t_PSWFPROCESS = pSWFProcessRepository.convert2PO(pswfprocess,null);
        bOk = pSWFProcessRepository.update(t_PSWFPROCESS);
        pSWFProcessRepository.convert2Domain(t_PSWFPROCESS,pswfprocess) ;
        return bOk ;
    }

    @Override
    @Transactional
    public boolean save(PSWFProcess pswfprocess) {
        if(pswfprocess.getPSWFProcessId()==null){
    		return create(pswfprocess);
    	}else{
            if(this.get(pswfprocess.getPSWFProcessId())!=null){
    			return update(pswfprocess);
    		}
    		return create(pswfprocess);
    	}
    }

    @Override
    @Transactional
    public boolean remove(String pswfprocessid) {
        boolean bOk = false ;

        PSWFProcess _pSWFProcess = this.get(pswfprocessid);
        bOk = pSWFProcessRepository.remove(pswfprocessid);

        return bOk ;
    }

    @Override
    public PSWFProcess getDraft(PSWFProcess pswfprocess) {
        return pswfprocess;
    }

    @Override
    @Transactional
    public PSWFProcess get(String pswfprocessid) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFProcess _t_PSWFPROCESS = pSWFProcessRepository.get(pswfprocessid);
        if(_t_PSWFPROCESS == null)
            return null ;

        PSWFProcess _pSWFProcess = pSWFProcessRepository.convert2Domain(_t_PSWFPROCESS,null) ;

        return _pSWFProcess;
    }

    @Override
    @Transactional
    public PSWFProcess get(PSWFProcess pswfprocess) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFProcess t_PSWFPROCESS = pSWFProcessRepository.get(pswfprocess.getPSWFProcessId());
        pSWFProcessRepository.convert2Domain(t_PSWFPROCESS,pswfprocess);
        return pswfprocess;
    }

    @Override
    @Transactional
    public boolean create(PSWFProcess pswfprocess) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFProcess t_PSWFPROCESS = pSWFProcessRepository.convert2PO(pswfprocess,null);
        bOk = pSWFProcessRepository.create(t_PSWFPROCESS);
        pSWFProcessRepository.convert2Domain(t_PSWFPROCESS,pswfprocess);


        return bOk ;
    }

    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<PSWFProcess> searchDefault(PSWFProcessSearchContext context) {
        List<PSWFProcess> list = new ArrayList<PSWFProcess>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFProcess> t_PSWFPROCESSs = pSWFProcessRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFProcess t_PSWFPROCESS : t_PSWFPROCESSs){
            list.add(pSWFProcessRepository.convert2Domain(t_PSWFPROCESS,null));
        }
        return new PageImpl<PSWFProcess>(list, context.getPageable(), t_PSWFPROCESSs.getTotalElements());
    }


    /**
     * 根据业务流程版本查询
     */
    @Override
    public Page<PSWFProcess> selectByPSWFVersion(String pswfversionid){
        PSWFProcessSearchContext context = new PSWFProcessSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pswfversionid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pswfversionid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pswfversionid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFProcess> list = new ArrayList<PSWFProcess>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFProcess> t_PSWFPROCESSs = pSWFProcessRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFProcess t_PSWFPROCESS : t_PSWFPROCESSs){
            list.add(pSWFProcessRepository.convert2Domain(t_PSWFPROCESS,null));
        }
        return new PageImpl<PSWFProcess>(list, context.getPageable(), t_PSWFPROCESSs.getTotalElements());
    }

    /**
     * 根据业务流程版本查询
     */
    @Override
    public List<PSWFProcess> selectByPSWFVersion2(String pswfversionid){
        PSWFProcessSearchContext context = new PSWFProcessSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pswfversionid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pswfversionid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pswfversionid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFProcess> list = new ArrayList<PSWFProcess>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFProcess> t_PSWFPROCESSs = pSWFProcessRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFProcess t_PSWFPROCESS : t_PSWFPROCESSs){
            list.add(pSWFProcessRepository.convert2Domain(t_PSWFPROCESS,null));
        }
        return list;
    }
    /**
     * 根据业务工作流查询
     */
    @Override
    public Page<PSWFProcess> selectByTargetPSWF(String psworkflowid){
        PSWFProcessSearchContext context = new PSWFProcessSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(psworkflowid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("psworkflowid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(psworkflowid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFProcess> list = new ArrayList<PSWFProcess>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFProcess> t_PSWFPROCESSs = pSWFProcessRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFProcess t_PSWFPROCESS : t_PSWFPROCESSs){
            list.add(pSWFProcessRepository.convert2Domain(t_PSWFPROCESS,null));
        }
        return new PageImpl<PSWFProcess>(list, context.getPageable(), t_PSWFPROCESSs.getTotalElements());
    }

    /**
     * 根据业务工作流查询
     */
    @Override
    public List<PSWFProcess> selectByTargetPSWF2(String psworkflowid){
        PSWFProcessSearchContext context = new PSWFProcessSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(psworkflowid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("psworkflowid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(psworkflowid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFProcess> list = new ArrayList<PSWFProcess>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFProcess> t_PSWFPROCESSs = pSWFProcessRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFProcess t_PSWFPROCESS : t_PSWFPROCESSs){
            list.add(pSWFProcessRepository.convert2Domain(t_PSWFPROCESS,null));
        }
        return list;
    }




}
