package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.transaction.annotation.Transactional;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFRoleDetail;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSWFRoleDetailSearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IPSWFRoleDetailService;
import org.springframework.beans.factory.annotation.Autowired;
import cn.ibizlab.r7.runtime.wf.util.SearchResult;

/**
 * 实体[平台流程角色成员] 服务对象接口实现
 */
@Service
public class PSWFRoleDetailServiceImpl implements IPSWFRoleDetailService {

    @Autowired
    cn.ibizlab.r7.runtime.wf.core.repository.PSWFRoleDetailRepository pSWFRoleDetailRepository;

    @Override
    @Transactional
    public boolean save(PSWFRoleDetail pswfroledetail) {
        if(pswfroledetail.getPSWFRoleDetailId()==null){
    		return create(pswfroledetail);
    	}else{
            if(this.get(pswfroledetail.getPSWFRoleDetailId())!=null){
    			return update(pswfroledetail);
    		}
    		return create(pswfroledetail);
    	}
    }

    @Override
    @Transactional
    public boolean update(PSWFRoleDetail pswfroledetail) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRoleDetail t_PSWFROLEDETAIL = pSWFRoleDetailRepository.convert2PO(pswfroledetail,null);
        bOk = pSWFRoleDetailRepository.update(t_PSWFROLEDETAIL);
        pSWFRoleDetailRepository.convert2Domain(t_PSWFROLEDETAIL,pswfroledetail) ;
        return bOk ;
    }

    @Override
    @Transactional
    public PSWFRoleDetail get(String pswfroledetailid) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRoleDetail _t_PSWFROLEDETAIL = pSWFRoleDetailRepository.get(pswfroledetailid);
        if(_t_PSWFROLEDETAIL == null)
            return null ;

        PSWFRoleDetail _pSWFRoleDetail = pSWFRoleDetailRepository.convert2Domain(_t_PSWFROLEDETAIL,null) ;

        return _pSWFRoleDetail;
    }

    @Override
    @Transactional
    public PSWFRoleDetail get(PSWFRoleDetail pswfroledetail) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRoleDetail t_PSWFROLEDETAIL = pSWFRoleDetailRepository.get(pswfroledetail.getPSWFRoleDetailId());
        pSWFRoleDetailRepository.convert2Domain(t_PSWFROLEDETAIL,pswfroledetail);
        return pswfroledetail;
    }

    @Override
    public boolean checkKey(PSWFRoleDetail pswfroledetail) {
        return true;
    }

    @Override
    @Transactional
    public boolean create(PSWFRoleDetail pswfroledetail) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRoleDetail t_PSWFROLEDETAIL = pSWFRoleDetailRepository.convert2PO(pswfroledetail,null);
        bOk = pSWFRoleDetailRepository.create(t_PSWFROLEDETAIL);
        pSWFRoleDetailRepository.convert2Domain(t_PSWFROLEDETAIL,pswfroledetail);


        return bOk ;
    }

    @Override
    public PSWFRoleDetail getDraft(PSWFRoleDetail pswfroledetail) {
        return pswfroledetail;
    }

    @Override
    @Transactional
    public boolean remove(String pswfroledetailid) {
        boolean bOk = false ;

        PSWFRoleDetail _pSWFRoleDetail = this.get(pswfroledetailid);
        bOk = pSWFRoleDetailRepository.remove(pswfroledetailid);

        return bOk ;
    }

    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<PSWFRoleDetail> searchDefault(PSWFRoleDetailSearchContext context) {
        List<PSWFRoleDetail> list = new ArrayList<PSWFRoleDetail>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRoleDetail> t_PSWFROLEDETAILs = pSWFRoleDetailRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRoleDetail t_PSWFROLEDETAIL : t_PSWFROLEDETAILs){
            list.add(pSWFRoleDetailRepository.convert2Domain(t_PSWFROLEDETAIL,null));
        }
        return new PageImpl<PSWFRoleDetail>(list, context.getPageable(), t_PSWFROLEDETAILs.getTotalElements());
    }


    /**
     * 根据部门查询
     */
    @Override
    public Page<PSWFRoleDetail> selectByOrgDept(String orgdeptid){
        PSWFRoleDetailSearchContext context = new PSWFRoleDetailSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgdeptid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("orgdeptid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgdeptid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFRoleDetail> list = new ArrayList<PSWFRoleDetail>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRoleDetail> t_PSWFROLEDETAILs = pSWFRoleDetailRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRoleDetail t_PSWFROLEDETAIL : t_PSWFROLEDETAILs){
            list.add(pSWFRoleDetailRepository.convert2Domain(t_PSWFROLEDETAIL,null));
        }
        return new PageImpl<PSWFRoleDetail>(list, context.getPageable(), t_PSWFROLEDETAILs.getTotalElements());
    }

    /**
     * 根据部门查询
     */
    @Override
    public List<PSWFRoleDetail> selectByOrgDept2(String orgdeptid){
        PSWFRoleDetailSearchContext context = new PSWFRoleDetailSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgdeptid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("orgdeptid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgdeptid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFRoleDetail> list = new ArrayList<PSWFRoleDetail>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRoleDetail> t_PSWFROLEDETAILs = pSWFRoleDetailRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRoleDetail t_PSWFROLEDETAIL : t_PSWFROLEDETAILs){
            list.add(pSWFRoleDetailRepository.convert2Domain(t_PSWFROLEDETAIL,null));
        }
        return list;
    }
    /**
     * 根据组织用户查询
     */
    @Override
    public Page<PSWFRoleDetail> selectByOrgUser(String orguserid){
        PSWFRoleDetailSearchContext context = new PSWFRoleDetailSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orguserid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("orguserid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orguserid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFRoleDetail> list = new ArrayList<PSWFRoleDetail>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRoleDetail> t_PSWFROLEDETAILs = pSWFRoleDetailRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRoleDetail t_PSWFROLEDETAIL : t_PSWFROLEDETAILs){
            list.add(pSWFRoleDetailRepository.convert2Domain(t_PSWFROLEDETAIL,null));
        }
        return new PageImpl<PSWFRoleDetail>(list, context.getPageable(), t_PSWFROLEDETAILs.getTotalElements());
    }

    /**
     * 根据组织用户查询
     */
    @Override
    public List<PSWFRoleDetail> selectByOrgUser2(String orguserid){
        PSWFRoleDetailSearchContext context = new PSWFRoleDetailSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orguserid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("orguserid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orguserid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFRoleDetail> list = new ArrayList<PSWFRoleDetail>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRoleDetail> t_PSWFROLEDETAILs = pSWFRoleDetailRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRoleDetail t_PSWFROLEDETAIL : t_PSWFROLEDETAILs){
            list.add(pSWFRoleDetailRepository.convert2Domain(t_PSWFROLEDETAIL,null));
        }
        return list;
    }
    /**
     * 根据组织查询
     */
    @Override
    public Page<PSWFRoleDetail> selectByOrg(String orgid){
        PSWFRoleDetailSearchContext context = new PSWFRoleDetailSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("orgid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFRoleDetail> list = new ArrayList<PSWFRoleDetail>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRoleDetail> t_PSWFROLEDETAILs = pSWFRoleDetailRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRoleDetail t_PSWFROLEDETAIL : t_PSWFROLEDETAILs){
            list.add(pSWFRoleDetailRepository.convert2Domain(t_PSWFROLEDETAIL,null));
        }
        return new PageImpl<PSWFRoleDetail>(list, context.getPageable(), t_PSWFROLEDETAILs.getTotalElements());
    }

    /**
     * 根据组织查询
     */
    @Override
    public List<PSWFRoleDetail> selectByOrg2(String orgid){
        PSWFRoleDetailSearchContext context = new PSWFRoleDetailSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("orgid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFRoleDetail> list = new ArrayList<PSWFRoleDetail>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRoleDetail> t_PSWFROLEDETAILs = pSWFRoleDetailRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRoleDetail t_PSWFROLEDETAIL : t_PSWFROLEDETAILs){
            list.add(pSWFRoleDetailRepository.convert2Domain(t_PSWFROLEDETAIL,null));
        }
        return list;
    }
    /**
     * 根据平台流程角色查询
     */
    @Override
    public Page<PSWFRoleDetail> selectByPSWFRole(String pswfroleid){
        PSWFRoleDetailSearchContext context = new PSWFRoleDetailSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pswfroleid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pswfroleid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pswfroleid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFRoleDetail> list = new ArrayList<PSWFRoleDetail>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRoleDetail> t_PSWFROLEDETAILs = pSWFRoleDetailRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRoleDetail t_PSWFROLEDETAIL : t_PSWFROLEDETAILs){
            list.add(pSWFRoleDetailRepository.convert2Domain(t_PSWFROLEDETAIL,null));
        }
        return new PageImpl<PSWFRoleDetail>(list, context.getPageable(), t_PSWFROLEDETAILs.getTotalElements());
    }

    /**
     * 根据平台流程角色查询
     */
    @Override
    public List<PSWFRoleDetail> selectByPSWFRole2(String pswfroleid){
        PSWFRoleDetailSearchContext context = new PSWFRoleDetailSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pswfroleid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pswfroleid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pswfroleid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFRoleDetail> list = new ArrayList<PSWFRoleDetail>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRoleDetail> t_PSWFROLEDETAILs = pSWFRoleDetailRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRoleDetail t_PSWFROLEDETAIL : t_PSWFROLEDETAILs){
            list.add(pSWFRoleDetailRepository.convert2Domain(t_PSWFROLEDETAIL,null));
        }
        return list;
    }




}
