package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.transaction.annotation.Transactional;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFRole;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSWFRoleSearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IPSWFRoleService;
import org.springframework.beans.factory.annotation.Autowired;
import cn.ibizlab.r7.runtime.wf.util.SearchResult;

/**
 * 实体[平台流程角色] 服务对象接口实现
 */
@Service
public class PSWFRoleServiceImpl implements IPSWFRoleService {

    @Autowired
    cn.ibizlab.r7.runtime.wf.core.repository.PSWFRoleRepository pSWFRoleRepository;

    @Override
    public boolean checkKey(PSWFRole pswfrole) {
        return true;
    }

    @Override
    @Transactional
    public boolean update(PSWFRole pswfrole) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRole t_PSWFROLE = pSWFRoleRepository.convert2PO(pswfrole,null);
        bOk = pSWFRoleRepository.update(t_PSWFROLE);
        pSWFRoleRepository.convert2Domain(t_PSWFROLE,pswfrole) ;
        return bOk ;
    }

    @Override
    @Transactional
    public PSWFRole get(String pswfroleid) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRole _t_PSWFROLE = pSWFRoleRepository.get(pswfroleid);
        if(_t_PSWFROLE == null)
            return null ;

        PSWFRole _pSWFRole = pSWFRoleRepository.convert2Domain(_t_PSWFROLE,null) ;

        return _pSWFRole;
    }

    @Override
    @Transactional
    public PSWFRole get(PSWFRole pswfrole) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRole t_PSWFROLE = pSWFRoleRepository.get(pswfrole.getPSWFRoleId());
        pSWFRoleRepository.convert2Domain(t_PSWFROLE,pswfrole);
        return pswfrole;
    }

    @Override
    @Transactional
    public PSWFRole regist(PSWFRole pswfrole) {
         return pswfrole;
    }

    @Override
    public PSWFRole getDraft(PSWFRole pswfrole) {
        return pswfrole;
    }

    @Override
    @Transactional
    public boolean remove(String pswfroleid) {
        boolean bOk = false ;

        PSWFRole _pSWFRole = this.get(pswfroleid);
        bOk = pSWFRoleRepository.remove(pswfroleid);

        return bOk ;
    }

    @Override
    @Transactional
    public boolean create(PSWFRole pswfrole) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRole t_PSWFROLE = pSWFRoleRepository.convert2PO(pswfrole,null);
        bOk = pSWFRoleRepository.create(t_PSWFROLE);
        pSWFRoleRepository.convert2Domain(t_PSWFROLE,pswfrole);


        return bOk ;
    }

    @Override
    @Transactional
    public boolean save(PSWFRole pswfrole) {
        if(pswfrole.getPSWFRoleId()==null){
    		return create(pswfrole);
    	}else{
            if(this.get(pswfrole.getPSWFRoleId())!=null){
    			return update(pswfrole);
    		}
    		return create(pswfrole);
    	}
    }

    /**
     * 查询集合 当前组织
     */
    @Override
    public Page<PSWFRole> searchCurOrg(PSWFRoleSearchContext context) {
        List<PSWFRole> list = new ArrayList<PSWFRole>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRole> t_PSWFROLEs = pSWFRoleRepository.searchCurOrg(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRole t_PSWFROLE : t_PSWFROLEs){
            list.add(pSWFRoleRepository.convert2Domain(t_PSWFROLE,null));
        }
        return new PageImpl<PSWFRole>(list, context.getPageable(), t_PSWFROLEs.getTotalElements());
    }

    /**
     * 查询集合 当前部门
     */
    @Override
    public Page<PSWFRole> searchCurOrgDept(PSWFRoleSearchContext context) {
        List<PSWFRole> list = new ArrayList<PSWFRole>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRole> t_PSWFROLEs = pSWFRoleRepository.searchCurOrgDept(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRole t_PSWFROLE : t_PSWFROLEs){
            list.add(pSWFRoleRepository.convert2Domain(t_PSWFROLE,null));
        }
        return new PageImpl<PSWFRole>(list, context.getPageable(), t_PSWFROLEs.getTotalElements());
    }

    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<PSWFRole> searchDefault(PSWFRoleSearchContext context) {
        List<PSWFRole> list = new ArrayList<PSWFRole>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRole> t_PSWFROLEs = pSWFRoleRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRole t_PSWFROLE : t_PSWFROLEs){
            list.add(pSWFRoleRepository.convert2Domain(t_PSWFROLE,null));
        }
        return new PageImpl<PSWFRole>(list, context.getPageable(), t_PSWFROLEs.getTotalElements());
    }


    /**
     * 根据部门查询
     */
    @Override
    public Page<PSWFRole> selectByORGDEPT(String orgdeptid){
        PSWFRoleSearchContext context = new PSWFRoleSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgdeptid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("orgdeptid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgdeptid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFRole> list = new ArrayList<PSWFRole>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRole> t_PSWFROLEs = pSWFRoleRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRole t_PSWFROLE : t_PSWFROLEs){
            list.add(pSWFRoleRepository.convert2Domain(t_PSWFROLE,null));
        }
        return new PageImpl<PSWFRole>(list, context.getPageable(), t_PSWFROLEs.getTotalElements());
    }

    /**
     * 根据部门查询
     */
    @Override
    public List<PSWFRole> selectByORGDEPT2(String orgdeptid){
        PSWFRoleSearchContext context = new PSWFRoleSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgdeptid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("orgdeptid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgdeptid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFRole> list = new ArrayList<PSWFRole>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRole> t_PSWFROLEs = pSWFRoleRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRole t_PSWFROLE : t_PSWFROLEs){
            list.add(pSWFRoleRepository.convert2Domain(t_PSWFROLE,null));
        }
        return list;
    }
    /**
     * 根据组织查询
     */
    @Override
    public Page<PSWFRole> selectByORG(String orgid){
        PSWFRoleSearchContext context = new PSWFRoleSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("orgid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFRole> list = new ArrayList<PSWFRole>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRole> t_PSWFROLEs = pSWFRoleRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRole t_PSWFROLE : t_PSWFROLEs){
            list.add(pSWFRoleRepository.convert2Domain(t_PSWFROLE,null));
        }
        return new PageImpl<PSWFRole>(list, context.getPageable(), t_PSWFROLEs.getTotalElements());
    }

    /**
     * 根据组织查询
     */
    @Override
    public List<PSWFRole> selectByORG2(String orgid){
        PSWFRoleSearchContext context = new PSWFRoleSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("orgid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFRole> list = new ArrayList<PSWFRole>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRole> t_PSWFROLEs = pSWFRoleRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRole t_PSWFROLE : t_PSWFROLEs){
            list.add(pSWFRoleRepository.convert2Domain(t_PSWFROLE,null));
        }
        return list;
    }




}
