package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.transaction.annotation.Transactional;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFVersion;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSWFVersionSearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IPSWFVersionService;
import org.springframework.beans.factory.annotation.Autowired;
import cn.ibizlab.r7.runtime.wf.util.SearchResult;

/**
 * 实体[业务流程版本] 服务对象接口实现
 */
@Service
public class PSWFVersionServiceImpl implements IPSWFVersionService {

    @Autowired
    cn.ibizlab.r7.runtime.wf.core.repository.PSWFVersionRepository pSWFVersionRepository;

    @Override
    public boolean checkKey(PSWFVersion pswfversion) {
        return true;
    }

    @Override
    public PSWFVersion getDraft(PSWFVersion pswfversion) {
        return pswfversion;
    }

    @Override
    @Transactional
    public boolean update(PSWFVersion pswfversion) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFVersion t_PSWFVERSION = pSWFVersionRepository.convert2PO(pswfversion,null);
        bOk = pSWFVersionRepository.update(t_PSWFVERSION);
        pSWFVersionRepository.convert2Domain(t_PSWFVERSION,pswfversion) ;
        return bOk ;
    }

    @Override
    @Transactional
    public PSWFVersion regist(PSWFVersion pswfversion) {
         return pswfversion;
    }

    @Override
    @Transactional
    public PSWFVersion get(String pswfversionid) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFVersion _t_PSWFVERSION = pSWFVersionRepository.get(pswfversionid);
        if(_t_PSWFVERSION == null)
            return null ;

        PSWFVersion _pSWFVersion = pSWFVersionRepository.convert2Domain(_t_PSWFVERSION,null) ;

        return _pSWFVersion;
    }

    @Override
    @Transactional
    public PSWFVersion get(PSWFVersion pswfversion) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFVersion t_PSWFVERSION = pSWFVersionRepository.get(pswfversion.getPSWFVersionId());
        pSWFVersionRepository.convert2Domain(t_PSWFVERSION,pswfversion);
        return pswfversion;
    }

    @Override
    @Transactional
    public boolean create(PSWFVersion pswfversion) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFVersion t_PSWFVERSION = pSWFVersionRepository.convert2PO(pswfversion,null);
        bOk = pSWFVersionRepository.create(t_PSWFVERSION);
        pSWFVersionRepository.convert2Domain(t_PSWFVERSION,pswfversion);


        return bOk ;
    }

    @Override
    @Transactional
    public boolean remove(String pswfversionid) {
        boolean bOk = false ;

        PSWFVersion _pSWFVersion = this.get(pswfversionid);
        bOk = pSWFVersionRepository.remove(pswfversionid);

        return bOk ;
    }

    @Override
    @Transactional
    public boolean save(PSWFVersion pswfversion) {
        if(pswfversion.getPSWFVersionId()==null){
    		return create(pswfversion);
    	}else{
            if(this.get(pswfversion.getPSWFVersionId())!=null){
    			return update(pswfversion);
    		}
    		return create(pswfversion);
    	}
    }

    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<PSWFVersion> searchDefault(PSWFVersionSearchContext context) {
        List<PSWFVersion> list = new ArrayList<PSWFVersion>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFVersion> t_PSWFVERSIONs = pSWFVersionRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFVersion t_PSWFVERSION : t_PSWFVERSIONs){
            list.add(pSWFVersionRepository.convert2Domain(t_PSWFVERSION,null));
        }
        return new PageImpl<PSWFVersion>(list, context.getPageable(), t_PSWFVERSIONs.getTotalElements());
    }


    /**
     * 根据部门查询
     */
    @Override
    public Page<PSWFVersion> selectByORGDEPT(String orgdeptid){
        PSWFVersionSearchContext context = new PSWFVersionSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgdeptid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("orgdeptid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgdeptid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFVersion> list = new ArrayList<PSWFVersion>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFVersion> t_PSWFVERSIONs = pSWFVersionRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFVersion t_PSWFVERSION : t_PSWFVERSIONs){
            list.add(pSWFVersionRepository.convert2Domain(t_PSWFVERSION,null));
        }
        return new PageImpl<PSWFVersion>(list, context.getPageable(), t_PSWFVERSIONs.getTotalElements());
    }

    /**
     * 根据部门查询
     */
    @Override
    public List<PSWFVersion> selectByORGDEPT2(String orgdeptid){
        PSWFVersionSearchContext context = new PSWFVersionSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgdeptid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("orgdeptid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgdeptid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFVersion> list = new ArrayList<PSWFVersion>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFVersion> t_PSWFVERSIONs = pSWFVersionRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFVersion t_PSWFVERSION : t_PSWFVERSIONs){
            list.add(pSWFVersionRepository.convert2Domain(t_PSWFVERSION,null));
        }
        return list;
    }
    /**
     * 根据组织查询
     */
    @Override
    public Page<PSWFVersion> selectByORG(String orgid){
        PSWFVersionSearchContext context = new PSWFVersionSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("orgid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFVersion> list = new ArrayList<PSWFVersion>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFVersion> t_PSWFVERSIONs = pSWFVersionRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFVersion t_PSWFVERSION : t_PSWFVERSIONs){
            list.add(pSWFVersionRepository.convert2Domain(t_PSWFVERSION,null));
        }
        return new PageImpl<PSWFVersion>(list, context.getPageable(), t_PSWFVERSIONs.getTotalElements());
    }

    /**
     * 根据组织查询
     */
    @Override
    public List<PSWFVersion> selectByORG2(String orgid){
        PSWFVersionSearchContext context = new PSWFVersionSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("orgid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFVersion> list = new ArrayList<PSWFVersion>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFVersion> t_PSWFVERSIONs = pSWFVersionRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFVersion t_PSWFVERSION : t_PSWFVERSIONs){
            list.add(pSWFVersionRepository.convert2Domain(t_PSWFVERSION,null));
        }
        return list;
    }
    /**
     * 根据业务工作流查询
     */
    @Override
    public Page<PSWFVersion> selectByPsworkflow(String psworkflowid){
        PSWFVersionSearchContext context = new PSWFVersionSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(psworkflowid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("psworkflowid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(psworkflowid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFVersion> list = new ArrayList<PSWFVersion>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFVersion> t_PSWFVERSIONs = pSWFVersionRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFVersion t_PSWFVERSION : t_PSWFVERSIONs){
            list.add(pSWFVersionRepository.convert2Domain(t_PSWFVERSION,null));
        }
        return new PageImpl<PSWFVersion>(list, context.getPageable(), t_PSWFVERSIONs.getTotalElements());
    }

    /**
     * 根据业务工作流查询
     */
    @Override
    public List<PSWFVersion> selectByPsworkflow2(String psworkflowid){
        PSWFVersionSearchContext context = new PSWFVersionSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(psworkflowid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("psworkflowid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(psworkflowid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFVersion> list = new ArrayList<PSWFVersion>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFVersion> t_PSWFVERSIONs = pSWFVersionRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFVersion t_PSWFVERSION : t_PSWFVERSIONs){
            list.add(pSWFVersionRepository.convert2Domain(t_PSWFVERSION,null));
        }
        return list;
    }
    /**
     * 根据工作流应用查询
     */
    @Override
    public Page<PSWFVersion> selectByWfapp(String wfappid){
        PSWFVersionSearchContext context = new PSWFVersionSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(wfappid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("wfappid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(wfappid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFVersion> list = new ArrayList<PSWFVersion>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFVersion> t_PSWFVERSIONs = pSWFVersionRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFVersion t_PSWFVERSION : t_PSWFVERSIONs){
            list.add(pSWFVersionRepository.convert2Domain(t_PSWFVERSION,null));
        }
        return new PageImpl<PSWFVersion>(list, context.getPageable(), t_PSWFVERSIONs.getTotalElements());
    }

    /**
     * 根据工作流应用查询
     */
    @Override
    public List<PSWFVersion> selectByWfapp2(String wfappid){
        PSWFVersionSearchContext context = new PSWFVersionSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(wfappid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("wfappid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(wfappid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFVersion> list = new ArrayList<PSWFVersion>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFVersion> t_PSWFVERSIONs = pSWFVersionRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFVersion t_PSWFVERSION : t_PSWFVERSIONs){
            list.add(pSWFVersionRepository.convert2Domain(t_PSWFVERSION,null));
        }
        return list;
    }
    /**
     * 根据工作流模式查询
     */
    @Override
    public Page<PSWFVersion> selectByWfmode(String wfmodeid){
        PSWFVersionSearchContext context = new PSWFVersionSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(wfmodeid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("wfmodeid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(wfmodeid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFVersion> list = new ArrayList<PSWFVersion>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFVersion> t_PSWFVERSIONs = pSWFVersionRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFVersion t_PSWFVERSION : t_PSWFVERSIONs){
            list.add(pSWFVersionRepository.convert2Domain(t_PSWFVERSION,null));
        }
        return new PageImpl<PSWFVersion>(list, context.getPageable(), t_PSWFVERSIONs.getTotalElements());
    }

    /**
     * 根据工作流模式查询
     */
    @Override
    public List<PSWFVersion> selectByWfmode2(String wfmodeid){
        PSWFVersionSearchContext context = new PSWFVersionSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(wfmodeid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("wfmodeid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(wfmodeid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWFVersion> list = new ArrayList<PSWFVersion>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFVersion> t_PSWFVERSIONs = pSWFVersionRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFVersion t_PSWFVERSION : t_PSWFVERSIONs){
            list.add(pSWFVersionRepository.convert2Domain(t_PSWFVERSION,null));
        }
        return list;
    }




}
