package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.transaction.annotation.Transactional;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWorkflow;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSWorkflowSearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IPSWorkflowService;
import org.springframework.beans.factory.annotation.Autowired;
import cn.ibizlab.r7.runtime.wf.util.SearchResult;

/**
 * 实体[业务工作流] 服务对象接口实现
 */
@Service
public class PSWorkflowServiceImpl implements IPSWorkflowService {

    @Autowired
    cn.ibizlab.r7.runtime.wf.core.repository.PSWorkflowRepository pSWorkflowRepository;

    @Override
    @Transactional
    public boolean save(PSWorkflow psworkflow) {
        if(psworkflow.getPSWorkflowId()==null){
    		return create(psworkflow);
    	}else{
            if(this.get(psworkflow.getPSWorkflowId())!=null){
    			return update(psworkflow);
    		}
    		return create(psworkflow);
    	}
    }

    @Override
    @Transactional
    public boolean remove(String psworkflowid) {
        boolean bOk = false ;

        PSWorkflow _pSWorkflow = this.get(psworkflowid);
        bOk = pSWorkflowRepository.remove(psworkflowid);

        return bOk ;
    }

    @Override
    @Transactional
    public boolean update(PSWorkflow psworkflow) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSWorkflow t_PSWORKFLOW = pSWorkflowRepository.convert2PO(psworkflow,null);
        bOk = pSWorkflowRepository.update(t_PSWORKFLOW);
        pSWorkflowRepository.convert2Domain(t_PSWORKFLOW,psworkflow) ;
        return bOk ;
    }

    @Override
    public boolean checkKey(PSWorkflow psworkflow) {
        return true;
    }

    @Override
    @Transactional
    public boolean create(PSWorkflow psworkflow) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSWorkflow t_PSWORKFLOW = pSWorkflowRepository.convert2PO(psworkflow,null);
        bOk = pSWorkflowRepository.create(t_PSWORKFLOW);
        pSWorkflowRepository.convert2Domain(t_PSWORKFLOW,psworkflow);


        return bOk ;
    }

    @Override
    public PSWorkflow getDraft(PSWorkflow psworkflow) {
        return psworkflow;
    }

    @Override
    @Transactional
    public PSWorkflow get(String psworkflowid) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSWorkflow _t_PSWORKFLOW = pSWorkflowRepository.get(psworkflowid);
        if(_t_PSWORKFLOW == null)
            return null ;

        PSWorkflow _pSWorkflow = pSWorkflowRepository.convert2Domain(_t_PSWORKFLOW,null) ;

        return _pSWorkflow;
    }

    @Override
    @Transactional
    public PSWorkflow get(PSWorkflow psworkflow) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.PSWorkflow t_PSWORKFLOW = pSWorkflowRepository.get(psworkflow.getPSWorkflowId());
        pSWorkflowRepository.convert2Domain(t_PSWORKFLOW,psworkflow);
        return psworkflow;
    }

    @Override
    @Transactional
    public PSWorkflow regist(PSWorkflow psworkflow) {
         return psworkflow;
    }

    /**
     * 查询集合 当前组织
     */
    @Override
    public Page<PSWorkflow> searchCurOrg(PSWorkflowSearchContext context) {
        List<PSWorkflow> list = new ArrayList<PSWorkflow>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWorkflow> t_PSWORKFLOWs = pSWorkflowRepository.searchCurOrg(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWorkflow t_PSWORKFLOW : t_PSWORKFLOWs){
            list.add(pSWorkflowRepository.convert2Domain(t_PSWORKFLOW,null));
        }
        return new PageImpl<PSWorkflow>(list, context.getPageable(), t_PSWORKFLOWs.getTotalElements());
    }

    /**
     * 查询集合 当前部门
     */
    @Override
    public Page<PSWorkflow> searchCurOrgDept(PSWorkflowSearchContext context) {
        List<PSWorkflow> list = new ArrayList<PSWorkflow>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWorkflow> t_PSWORKFLOWs = pSWorkflowRepository.searchCurOrgDept(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWorkflow t_PSWORKFLOW : t_PSWORKFLOWs){
            list.add(pSWorkflowRepository.convert2Domain(t_PSWORKFLOW,null));
        }
        return new PageImpl<PSWorkflow>(list, context.getPageable(), t_PSWORKFLOWs.getTotalElements());
    }

    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<PSWorkflow> searchDefault(PSWorkflowSearchContext context) {
        List<PSWorkflow> list = new ArrayList<PSWorkflow>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWorkflow> t_PSWORKFLOWs = pSWorkflowRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWorkflow t_PSWORKFLOW : t_PSWORKFLOWs){
            list.add(pSWorkflowRepository.convert2Domain(t_PSWORKFLOW,null));
        }
        return new PageImpl<PSWorkflow>(list, context.getPageable(), t_PSWORKFLOWs.getTotalElements());
    }


    /**
     * 根据部门查询
     */
    @Override
    public Page<PSWorkflow> selectByORGDEPT(String orgdeptid){
        PSWorkflowSearchContext context = new PSWorkflowSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgdeptid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("orgdeptid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgdeptid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWorkflow> list = new ArrayList<PSWorkflow>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWorkflow> t_PSWORKFLOWs = pSWorkflowRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWorkflow t_PSWORKFLOW : t_PSWORKFLOWs){
            list.add(pSWorkflowRepository.convert2Domain(t_PSWORKFLOW,null));
        }
        return new PageImpl<PSWorkflow>(list, context.getPageable(), t_PSWORKFLOWs.getTotalElements());
    }

    /**
     * 根据部门查询
     */
    @Override
    public List<PSWorkflow> selectByORGDEPT2(String orgdeptid){
        PSWorkflowSearchContext context = new PSWorkflowSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgdeptid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("orgdeptid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgdeptid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWorkflow> list = new ArrayList<PSWorkflow>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWorkflow> t_PSWORKFLOWs = pSWorkflowRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWorkflow t_PSWORKFLOW : t_PSWORKFLOWs){
            list.add(pSWorkflowRepository.convert2Domain(t_PSWORKFLOW,null));
        }
        return list;
    }
    /**
     * 根据组织查询
     */
    @Override
    public Page<PSWorkflow> selectByORG(String orgid){
        PSWorkflowSearchContext context = new PSWorkflowSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("orgid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWorkflow> list = new ArrayList<PSWorkflow>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWorkflow> t_PSWORKFLOWs = pSWorkflowRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWorkflow t_PSWORKFLOW : t_PSWORKFLOWs){
            list.add(pSWorkflowRepository.convert2Domain(t_PSWORKFLOW,null));
        }
        return new PageImpl<PSWorkflow>(list, context.getPageable(), t_PSWORKFLOWs.getTotalElements());
    }

    /**
     * 根据组织查询
     */
    @Override
    public List<PSWorkflow> selectByORG2(String orgid){
        PSWorkflowSearchContext context = new PSWorkflowSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("orgid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWorkflow> list = new ArrayList<PSWorkflow>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWorkflow> t_PSWORKFLOWs = pSWorkflowRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWorkflow t_PSWORKFLOW : t_PSWORKFLOWs){
            list.add(pSWorkflowRepository.convert2Domain(t_PSWORKFLOW,null));
        }
        return list;
    }
    /**
     * 根据业务系统查询
     */
    @Override
    public Page<PSWorkflow> selectByPssystem(String pssystemid){
        PSWorkflowSearchContext context = new PSWorkflowSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pssystemid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pssystemid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pssystemid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWorkflow> list = new ArrayList<PSWorkflow>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWorkflow> t_PSWORKFLOWs = pSWorkflowRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWorkflow t_PSWORKFLOW : t_PSWORKFLOWs){
            list.add(pSWorkflowRepository.convert2Domain(t_PSWORKFLOW,null));
        }
        return new PageImpl<PSWorkflow>(list, context.getPageable(), t_PSWORKFLOWs.getTotalElements());
    }

    /**
     * 根据业务系统查询
     */
    @Override
    public List<PSWorkflow> selectByPssystem2(String pssystemid){
        PSWorkflowSearchContext context = new PSWorkflowSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pssystemid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pssystemid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pssystemid);
            context.getCondition().add(fieldFilter);
        }
        List<PSWorkflow> list = new ArrayList<PSWorkflow>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.PSWorkflow> t_PSWORKFLOWs = pSWorkflowRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.PSWorkflow t_PSWORKFLOW : t_PSWORKFLOWs){
            list.add(pSWorkflowRepository.convert2Domain(t_PSWORKFLOW,null));
        }
        return list;
    }




}
