package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.transaction.annotation.Transactional;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFApp;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WFAppSearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IWFAppService;
import org.springframework.beans.factory.annotation.Autowired;
import cn.ibizlab.r7.runtime.wf.util.SearchResult;

/**
 * 实体[工作流应用] 服务对象接口实现
 */
@Service
public class WFAppServiceImpl implements IWFAppService {

    @Autowired
    cn.ibizlab.r7.runtime.wf.core.repository.WFAppRepository wFAppRepository;

    @Override
    public boolean checkKey(WFApp wfapp) {
        return true;
    }

    @Override
    public WFApp getDraft(WFApp wfapp) {
        return wfapp;
    }

    @Override
    @Transactional
    public boolean update(WFApp wfapp) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFApp t_WFAPP = wFAppRepository.convert2PO(wfapp,null);
        bOk = wFAppRepository.update(t_WFAPP);
        wFAppRepository.convert2Domain(t_WFAPP,wfapp) ;
        return bOk ;
    }

    @Override
    @Transactional
    public boolean save(WFApp wfapp) {
        if(wfapp.getWFAppId()==null){
    		return create(wfapp);
    	}else{
            if(this.get(wfapp.getWFAppId())!=null){
    			return update(wfapp);
    		}
    		return create(wfapp);
    	}
    }

    @Override
    @Transactional
    public WFApp queryWFApp(WFApp wfapp) {
        
        return wfapp;
    }

    @Override
    @Transactional
    public WFApp regist(WFApp wfapp) {
         return wfapp;
    }

    @Override
    @Transactional
    public WFApp get(String wfappid) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFApp _t_WFAPP = wFAppRepository.get(wfappid);
        if(_t_WFAPP == null)
            return null ;

        WFApp _wFApp = wFAppRepository.convert2Domain(_t_WFAPP,null) ;

        return _wFApp;
    }

    @Override
    @Transactional
    public WFApp get(WFApp wfapp) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFApp t_WFAPP = wFAppRepository.get(wfapp.getWFAppId());
        wFAppRepository.convert2Domain(t_WFAPP,wfapp);
        return wfapp;
    }

    @Override
    @Transactional
    public boolean remove(String wfappid) {
        boolean bOk = false ;

        WFApp _wFApp = this.get(wfappid);
        bOk = wFAppRepository.remove(wfappid);

        return bOk ;
    }

    @Override
    @Transactional
    public boolean create(WFApp wfapp) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFApp t_WFAPP = wFAppRepository.convert2PO(wfapp,null);
        bOk = wFAppRepository.create(t_WFAPP);
        wFAppRepository.convert2Domain(t_WFAPP,wfapp);


        return bOk ;
    }

    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<WFApp> searchDefault(WFAppSearchContext context) {
        List<WFApp> list = new ArrayList<WFApp>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFApp> t_WFAPPs = wFAppRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFApp t_WFAPP : t_WFAPPs){
            list.add(wFAppRepository.convert2Domain(t_WFAPP,null));
        }
        return new PageImpl<WFApp>(list, context.getPageable(), t_WFAPPs.getTotalElements());
    }


    /**
     * 根据业务系统查询
     */
    @Override
    public Page<WFApp> selectByPssystem(String pssystemid){
        WFAppSearchContext context = new WFAppSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pssystemid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pssystemid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pssystemid);
            context.getCondition().add(fieldFilter);
        }
        List<WFApp> list = new ArrayList<WFApp>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFApp> t_WFAPPs = wFAppRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFApp t_WFAPP : t_WFAPPs){
            list.add(wFAppRepository.convert2Domain(t_WFAPP,null));
        }
        return new PageImpl<WFApp>(list, context.getPageable(), t_WFAPPs.getTotalElements());
    }

    /**
     * 根据业务系统查询
     */
    @Override
    public List<WFApp> selectByPssystem2(String pssystemid){
        WFAppSearchContext context = new WFAppSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pssystemid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pssystemid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pssystemid);
            context.getCondition().add(fieldFilter);
        }
        List<WFApp> list = new ArrayList<WFApp>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFApp> t_WFAPPs = wFAppRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFApp t_WFAPP : t_WFAPPs){
            list.add(wFAppRepository.convert2Domain(t_WFAPP,null));
        }
        return list;
    }




}
