package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.transaction.annotation.Transactional;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFEngine;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WFEngineSearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IWFEngineService;
import org.springframework.beans.factory.annotation.Autowired;
import cn.ibizlab.r7.runtime.wf.util.SearchResult;

/**
 * 实体[工作流引擎] 服务对象接口实现
 */
@Service
public class WFEngineServiceImpl implements IWFEngineService {

    @Autowired
    cn.ibizlab.r7.runtime.wf.core.repository.WFEngineRepository wFEngineRepository;

    @Override
    public WFEngine getDraft(WFEngine wfengine) {
        return wfengine;
    }

    @Override
    @Transactional
    public WFEngine regist(WFEngine wfengine) {
         return wfengine;
    }

    @Override
    public boolean checkKey(WFEngine wfengine) {
        return true;
    }

    @Override
    @Transactional
    public boolean update(WFEngine wfengine) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFEngine t_WFENGINE = wFEngineRepository.convert2PO(wfengine,null);
        bOk = wFEngineRepository.update(t_WFENGINE);
        wFEngineRepository.convert2Domain(t_WFENGINE,wfengine) ;
        return bOk ;
    }

    @Override
    @Transactional
    public boolean remove(String wfengineid) {
        boolean bOk = false ;

        WFEngine _wFEngine = this.get(wfengineid);
        bOk = wFEngineRepository.remove(wfengineid);

        return bOk ;
    }

    @Override
    @Transactional
    public boolean create(WFEngine wfengine) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFEngine t_WFENGINE = wFEngineRepository.convert2PO(wfengine,null);
        bOk = wFEngineRepository.create(t_WFENGINE);
        wFEngineRepository.convert2Domain(t_WFENGINE,wfengine);


        return bOk ;
    }

    @Override
    @Transactional
    public boolean save(WFEngine wfengine) {
        if(wfengine.getWFEngineId()==null){
    		return create(wfengine);
    	}else{
            if(this.get(wfengine.getWFEngineId())!=null){
    			return update(wfengine);
    		}
    		return create(wfengine);
    	}
    }

    @Override
    @Transactional
    public WFEngine get(String wfengineid) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFEngine _t_WFENGINE = wFEngineRepository.get(wfengineid);
        if(_t_WFENGINE == null)
            return null ;

        WFEngine _wFEngine = wFEngineRepository.convert2Domain(_t_WFENGINE,null) ;

        return _wFEngine;
    }

    @Override
    @Transactional
    public WFEngine get(WFEngine wfengine) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFEngine t_WFENGINE = wFEngineRepository.get(wfengine.getWFEngineId());
        wFEngineRepository.convert2Domain(t_WFENGINE,wfengine);
        return wfengine;
    }

    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<WFEngine> searchDefault(WFEngineSearchContext context) {
        List<WFEngine> list = new ArrayList<WFEngine>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFEngine> t_WFENGINEs = wFEngineRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFEngine t_WFENGINE : t_WFENGINEs){
            list.add(wFEngineRepository.convert2Domain(t_WFENGINE,null));
        }
        return new PageImpl<WFEngine>(list, context.getPageable(), t_WFENGINEs.getTotalElements());
    }


    /**
     * 根据统一工作流查询
     */
    @Override
    public Page<WFEngine> selectByWorkflow(String workflowid){
        WFEngineSearchContext context = new WFEngineSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(workflowid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("workflowid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(workflowid);
            context.getCondition().add(fieldFilter);
        }
        List<WFEngine> list = new ArrayList<WFEngine>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFEngine> t_WFENGINEs = wFEngineRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFEngine t_WFENGINE : t_WFENGINEs){
            list.add(wFEngineRepository.convert2Domain(t_WFENGINE,null));
        }
        return new PageImpl<WFEngine>(list, context.getPageable(), t_WFENGINEs.getTotalElements());
    }

    /**
     * 根据统一工作流查询
     */
    @Override
    public List<WFEngine> selectByWorkflow2(String workflowid){
        WFEngineSearchContext context = new WFEngineSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(workflowid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("workflowid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(workflowid);
            context.getCondition().add(fieldFilter);
        }
        List<WFEngine> list = new ArrayList<WFEngine>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFEngine> t_WFENGINEs = wFEngineRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFEngine t_WFENGINE : t_WFENGINEs){
            list.add(wFEngineRepository.convert2Domain(t_WFENGINE,null));
        }
        return list;
    }




}
