package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.transaction.annotation.Transactional;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFIAAction;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WFIAActionSearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IWFIAActionService;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.logic.IWFIAActionProcLogic;
import org.springframework.beans.factory.annotation.Autowired;
import cn.ibizlab.r7.runtime.wf.util.SearchResult;

/**
 * 实体[工作流步骤操作] 服务对象接口实现
 */
@Service
public class WFIAActionServiceImpl implements IWFIAActionService {

    @Autowired
    cn.ibizlab.r7.runtime.wf.core.repository.WFIAActionRepository wFIAActionRepository;

    @Autowired
    private IWFIAActionProcLogic procLogic ;

    @Override
    @Transactional
    public WFIAAction proc(WFIAAction wfiaaction) {
        
        return wfiaaction;
    }

    @Override
    public WFIAAction getDraft(WFIAAction wfiaaction) {
        return wfiaaction;
    }

    @Override
    @Transactional
    public boolean remove(String wfiaactionid) {
        boolean bOk = false ;

        WFIAAction _wFIAAction = this.get(wfiaactionid);
        bOk = wFIAActionRepository.remove(wfiaactionid);

        return bOk ;
    }

    @Override
    @Transactional
    public boolean update(WFIAAction wfiaaction) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFIAAction t_WFIAACTION = wFIAActionRepository.convert2PO(wfiaaction,null);
        bOk = wFIAActionRepository.update(t_WFIAACTION);
        wFIAActionRepository.convert2Domain(t_WFIAACTION,wfiaaction) ;
        return bOk ;
    }

    @Override
    public boolean checkKey(WFIAAction wfiaaction) {
        return true;
    }

    @Override
    @Transactional
    public WFIAAction get(String wfiaactionid) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFIAAction _t_WFIAACTION = wFIAActionRepository.get(wfiaactionid);
        if(_t_WFIAACTION == null)
            return null ;

        WFIAAction _wFIAAction = wFIAActionRepository.convert2Domain(_t_WFIAACTION,null) ;

        return _wFIAAction;
    }

    @Override
    @Transactional
    public WFIAAction get(WFIAAction wfiaaction) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFIAAction t_WFIAACTION = wFIAActionRepository.get(wfiaaction.getWFIAActionId());
        wFIAActionRepository.convert2Domain(t_WFIAACTION,wfiaaction);
        return wfiaaction;
    }

    @Override
    @Transactional
    public boolean save(WFIAAction wfiaaction) {
        if(wfiaaction.getWFIAActionId()==null){
    		return create(wfiaaction);
    	}else{
            if(this.get(wfiaaction.getWFIAActionId())!=null){
    			return update(wfiaaction);
    		}
    		return create(wfiaaction);
    	}
    }

    @Override
    @Transactional
    public boolean create(WFIAAction wfiaaction) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFIAAction t_WFIAACTION = wFIAActionRepository.convert2PO(wfiaaction,null);
        bOk = wFIAActionRepository.create(t_WFIAACTION);
        wFIAActionRepository.convert2Domain(t_WFIAACTION,wfiaaction);

        procLogic.execute(wfiaaction);

        return bOk ;
    }

    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<WFIAAction> searchDefault(WFIAActionSearchContext context) {
        List<WFIAAction> list = new ArrayList<WFIAAction>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFIAAction> t_WFIAACTIONs = wFIAActionRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFIAAction t_WFIAACTION : t_WFIAACTIONs){
            list.add(wFIAActionRepository.convert2Domain(t_WFIAACTION,null));
        }
        return new PageImpl<WFIAAction>(list, context.getPageable(), t_WFIAACTIONs.getTotalElements());
    }


    /**
     * 根据工作流步骤查询
     */
    @Override
    public Page<WFIAAction> selectByWfstep(String wfstepid){
        WFIAActionSearchContext context = new WFIAActionSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(wfstepid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("wfstepid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(wfstepid);
            context.getCondition().add(fieldFilter);
        }
        List<WFIAAction> list = new ArrayList<WFIAAction>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFIAAction> t_WFIAACTIONs = wFIAActionRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFIAAction t_WFIAACTION : t_WFIAACTIONs){
            list.add(wFIAActionRepository.convert2Domain(t_WFIAACTION,null));
        }
        return new PageImpl<WFIAAction>(list, context.getPageable(), t_WFIAACTIONs.getTotalElements());
    }

    /**
     * 根据工作流步骤查询
     */
    @Override
    public List<WFIAAction> selectByWfstep2(String wfstepid){
        WFIAActionSearchContext context = new WFIAActionSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(wfstepid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("wfstepid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(wfstepid);
            context.getCondition().add(fieldFilter);
        }
        List<WFIAAction> list = new ArrayList<WFIAAction>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFIAAction> t_WFIAACTIONs = wFIAActionRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFIAAction t_WFIAACTION : t_WFIAACTIONs){
            list.add(wFIAActionRepository.convert2Domain(t_WFIAACTION,null));
        }
        return list;
    }




}
