package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.transaction.annotation.Transactional;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFInstance;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WFInstanceSearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IWFInstanceService;
import org.springframework.beans.factory.annotation.Autowired;
import cn.ibizlab.r7.runtime.wf.util.SearchResult;

/**
 * 实体[工作流实例] 服务对象接口实现
 */
@Service
public class WFInstanceServiceImpl implements IWFInstanceService {

    @Autowired
    cn.ibizlab.r7.runtime.wf.core.repository.WFInstanceRepository wFInstanceRepository;

    @Override
    @Transactional
    public WFInstance get(String wfinstanceid) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFInstance _t_WFINSTANCE = wFInstanceRepository.get(wfinstanceid);
        if(_t_WFINSTANCE == null)
            return null ;

        WFInstance _wFInstance = wFInstanceRepository.convert2Domain(_t_WFINSTANCE,null) ;

        return _wFInstance;
    }

    @Override
    @Transactional
    public WFInstance get(WFInstance wfinstance) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFInstance t_WFINSTANCE = wFInstanceRepository.get(wfinstance.getWFInstanceId());
        wFInstanceRepository.convert2Domain(t_WFINSTANCE,wfinstance);
        return wfinstance;
    }

    @Override
    public boolean checkKey(WFInstance wfinstance) {
        return true;
    }

    @Override
    @Transactional
    public boolean remove(String wfinstanceid) {
        boolean bOk = false ;

        WFInstance _wFInstance = this.get(wfinstanceid);
        bOk = wFInstanceRepository.remove(wfinstanceid);

        return bOk ;
    }

    @Override
    @Transactional
    public boolean create(WFInstance wfinstance) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFInstance t_WFINSTANCE = wFInstanceRepository.convert2PO(wfinstance,null);
        bOk = wFInstanceRepository.create(t_WFINSTANCE);
        wFInstanceRepository.convert2Domain(t_WFINSTANCE,wfinstance);


        return bOk ;
    }

    @Override
    public WFInstance getDraft(WFInstance wfinstance) {
        return wfinstance;
    }

    @Override
    @Transactional
    public boolean save(WFInstance wfinstance) {
        if(wfinstance.getWFInstanceId()==null){
    		return create(wfinstance);
    	}else{
            if(this.get(wfinstance.getWFInstanceId())!=null){
    			return update(wfinstance);
    		}
    		return create(wfinstance);
    	}
    }

    @Override
    @Transactional
    public boolean update(WFInstance wfinstance) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFInstance t_WFINSTANCE = wFInstanceRepository.convert2PO(wfinstance,null);
        bOk = wFInstanceRepository.update(t_WFINSTANCE);
        wFInstanceRepository.convert2Domain(t_WFINSTANCE,wfinstance) ;
        return bOk ;
    }

    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<WFInstance> searchDefault(WFInstanceSearchContext context) {
        List<WFInstance> list = new ArrayList<WFInstance>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFInstance> t_WFINSTANCEs = wFInstanceRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFInstance t_WFINSTANCE : t_WFINSTANCEs){
            list.add(wFInstanceRepository.convert2Domain(t_WFINSTANCE,null));
        }
        return new PageImpl<WFInstance>(list, context.getPageable(), t_WFINSTANCEs.getTotalElements());
    }


    /**
     * 根据部门查询
     */
    @Override
    public Page<WFInstance> selectByOrgDept(String orgdeptid){
        WFInstanceSearchContext context = new WFInstanceSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgdeptid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("orgdeptid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgdeptid);
            context.getCondition().add(fieldFilter);
        }
        List<WFInstance> list = new ArrayList<WFInstance>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFInstance> t_WFINSTANCEs = wFInstanceRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFInstance t_WFINSTANCE : t_WFINSTANCEs){
            list.add(wFInstanceRepository.convert2Domain(t_WFINSTANCE,null));
        }
        return new PageImpl<WFInstance>(list, context.getPageable(), t_WFINSTANCEs.getTotalElements());
    }

    /**
     * 根据部门查询
     */
    @Override
    public List<WFInstance> selectByOrgDept2(String orgdeptid){
        WFInstanceSearchContext context = new WFInstanceSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgdeptid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("orgdeptid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgdeptid);
            context.getCondition().add(fieldFilter);
        }
        List<WFInstance> list = new ArrayList<WFInstance>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFInstance> t_WFINSTANCEs = wFInstanceRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFInstance t_WFINSTANCE : t_WFINSTANCEs){
            list.add(wFInstanceRepository.convert2Domain(t_WFINSTANCE,null));
        }
        return list;
    }
    /**
     * 根据组织查询
     */
    @Override
    public Page<WFInstance> selectByOrg(String orgid){
        WFInstanceSearchContext context = new WFInstanceSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("orgid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgid);
            context.getCondition().add(fieldFilter);
        }
        List<WFInstance> list = new ArrayList<WFInstance>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFInstance> t_WFINSTANCEs = wFInstanceRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFInstance t_WFINSTANCE : t_WFINSTANCEs){
            list.add(wFInstanceRepository.convert2Domain(t_WFINSTANCE,null));
        }
        return new PageImpl<WFInstance>(list, context.getPageable(), t_WFINSTANCEs.getTotalElements());
    }

    /**
     * 根据组织查询
     */
    @Override
    public List<WFInstance> selectByOrg2(String orgid){
        WFInstanceSearchContext context = new WFInstanceSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("orgid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgid);
            context.getCondition().add(fieldFilter);
        }
        List<WFInstance> list = new ArrayList<WFInstance>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFInstance> t_WFINSTANCEs = wFInstanceRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFInstance t_WFINSTANCE : t_WFINSTANCEs){
            list.add(wFInstanceRepository.convert2Domain(t_WFINSTANCE,null));
        }
        return list;
    }
    /**
     * 根据业务流程版本查询
     */
    @Override
    public Page<WFInstance> selectByPswfversion(String pswfversionid){
        WFInstanceSearchContext context = new WFInstanceSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pswfversionid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pswfversionid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pswfversionid);
            context.getCondition().add(fieldFilter);
        }
        List<WFInstance> list = new ArrayList<WFInstance>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFInstance> t_WFINSTANCEs = wFInstanceRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFInstance t_WFINSTANCE : t_WFINSTANCEs){
            list.add(wFInstanceRepository.convert2Domain(t_WFINSTANCE,null));
        }
        return new PageImpl<WFInstance>(list, context.getPageable(), t_WFINSTANCEs.getTotalElements());
    }

    /**
     * 根据业务流程版本查询
     */
    @Override
    public List<WFInstance> selectByPswfversion2(String pswfversionid){
        WFInstanceSearchContext context = new WFInstanceSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pswfversionid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pswfversionid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pswfversionid);
            context.getCondition().add(fieldFilter);
        }
        List<WFInstance> list = new ArrayList<WFInstance>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFInstance> t_WFINSTANCEs = wFInstanceRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFInstance t_WFINSTANCE : t_WFINSTANCEs){
            list.add(wFInstanceRepository.convert2Domain(t_WFINSTANCE,null));
        }
        return list;
    }
    /**
     * 根据业务工作流查询
     */
    @Override
    public Page<WFInstance> selectByPsworkflow(String psworkflowid){
        WFInstanceSearchContext context = new WFInstanceSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(psworkflowid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("psworkflowid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(psworkflowid);
            context.getCondition().add(fieldFilter);
        }
        List<WFInstance> list = new ArrayList<WFInstance>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFInstance> t_WFINSTANCEs = wFInstanceRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFInstance t_WFINSTANCE : t_WFINSTANCEs){
            list.add(wFInstanceRepository.convert2Domain(t_WFINSTANCE,null));
        }
        return new PageImpl<WFInstance>(list, context.getPageable(), t_WFINSTANCEs.getTotalElements());
    }

    /**
     * 根据业务工作流查询
     */
    @Override
    public List<WFInstance> selectByPsworkflow2(String psworkflowid){
        WFInstanceSearchContext context = new WFInstanceSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(psworkflowid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("psworkflowid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(psworkflowid);
            context.getCondition().add(fieldFilter);
        }
        List<WFInstance> list = new ArrayList<WFInstance>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFInstance> t_WFINSTANCEs = wFInstanceRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFInstance t_WFINSTANCE : t_WFINSTANCEs){
            list.add(wFInstanceRepository.convert2Domain(t_WFINSTANCE,null));
        }
        return list;
    }
    /**
     * 根据工作流引擎查询
     */
    @Override
    public Page<WFInstance> selectByWfengine(String wfengineid){
        WFInstanceSearchContext context = new WFInstanceSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(wfengineid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("wfengineid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(wfengineid);
            context.getCondition().add(fieldFilter);
        }
        List<WFInstance> list = new ArrayList<WFInstance>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFInstance> t_WFINSTANCEs = wFInstanceRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFInstance t_WFINSTANCE : t_WFINSTANCEs){
            list.add(wFInstanceRepository.convert2Domain(t_WFINSTANCE,null));
        }
        return new PageImpl<WFInstance>(list, context.getPageable(), t_WFINSTANCEs.getTotalElements());
    }

    /**
     * 根据工作流引擎查询
     */
    @Override
    public List<WFInstance> selectByWfengine2(String wfengineid){
        WFInstanceSearchContext context = new WFInstanceSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(wfengineid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("wfengineid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(wfengineid);
            context.getCondition().add(fieldFilter);
        }
        List<WFInstance> list = new ArrayList<WFInstance>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFInstance> t_WFINSTANCEs = wFInstanceRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFInstance t_WFINSTANCE : t_WFINSTANCEs){
            list.add(wFInstanceRepository.convert2Domain(t_WFINSTANCE,null));
        }
        return list;
    }




}
