package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.transaction.annotation.Transactional;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFMode;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WFModeSearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IWFModeService;
import org.springframework.beans.factory.annotation.Autowired;
import cn.ibizlab.r7.runtime.wf.util.SearchResult;

/**
 * 实体[工作流模式] 服务对象接口实现
 */
@Service
public class WFModeServiceImpl implements IWFModeService {

    @Autowired
    cn.ibizlab.r7.runtime.wf.core.repository.WFModeRepository wFModeRepository;

    @Override
    public boolean checkKey(WFMode wfmode) {
        return true;
    }

    @Override
    @Transactional
    public WFMode regist(WFMode wfmode) {
         return wfmode;
    }

    @Override
    @Transactional
    public boolean remove(String wfmodeid) {
        boolean bOk = false ;

        WFMode _wFMode = this.get(wfmodeid);
        bOk = wFModeRepository.remove(wfmodeid);

        return bOk ;
    }

    @Override
    @Transactional
    public WFMode get(String wfmodeid) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFMode _t_WFMODE = wFModeRepository.get(wfmodeid);
        if(_t_WFMODE == null)
            return null ;

        WFMode _wFMode = wFModeRepository.convert2Domain(_t_WFMODE,null) ;

        return _wFMode;
    }

    @Override
    @Transactional
    public WFMode get(WFMode wfmode) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFMode t_WFMODE = wFModeRepository.get(wfmode.getWFModeId());
        wFModeRepository.convert2Domain(t_WFMODE,wfmode);
        return wfmode;
    }

    @Override
    @Transactional
    public boolean update(WFMode wfmode) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFMode t_WFMODE = wFModeRepository.convert2PO(wfmode,null);
        bOk = wFModeRepository.update(t_WFMODE);
        wFModeRepository.convert2Domain(t_WFMODE,wfmode) ;
        return bOk ;
    }

    @Override
    public WFMode getDraft(WFMode wfmode) {
        return wfmode;
    }

    @Override
    @Transactional
    public boolean save(WFMode wfmode) {
        if(wfmode.getWFModeId()==null){
    		return create(wfmode);
    	}else{
            if(this.get(wfmode.getWFModeId())!=null){
    			return update(wfmode);
    		}
    		return create(wfmode);
    	}
    }

    @Override
    @Transactional
    public boolean create(WFMode wfmode) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFMode t_WFMODE = wFModeRepository.convert2PO(wfmode,null);
        bOk = wFModeRepository.create(t_WFMODE);
        wFModeRepository.convert2Domain(t_WFMODE,wfmode);


        return bOk ;
    }

    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<WFMode> searchDefault(WFModeSearchContext context) {
        List<WFMode> list = new ArrayList<WFMode>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFMode> t_WFMODEs = wFModeRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFMode t_WFMODE : t_WFMODEs){
            list.add(wFModeRepository.convert2Domain(t_WFMODE,null));
        }
        return new PageImpl<WFMode>(list, context.getPageable(), t_WFMODEs.getTotalElements());
    }


    /**
     * 根据业务系统查询
     */
    @Override
    public Page<WFMode> selectByPssystem(String pssystemid){
        WFModeSearchContext context = new WFModeSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pssystemid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pssystemid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pssystemid);
            context.getCondition().add(fieldFilter);
        }
        List<WFMode> list = new ArrayList<WFMode>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFMode> t_WFMODEs = wFModeRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFMode t_WFMODE : t_WFMODEs){
            list.add(wFModeRepository.convert2Domain(t_WFMODE,null));
        }
        return new PageImpl<WFMode>(list, context.getPageable(), t_WFMODEs.getTotalElements());
    }

    /**
     * 根据业务系统查询
     */
    @Override
    public List<WFMode> selectByPssystem2(String pssystemid){
        WFModeSearchContext context = new WFModeSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pssystemid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pssystemid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pssystemid);
            context.getCondition().add(fieldFilter);
        }
        List<WFMode> list = new ArrayList<WFMode>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFMode> t_WFMODEs = wFModeRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFMode t_WFMODE : t_WFMODEs){
            list.add(wFModeRepository.convert2Domain(t_WFMODE,null));
        }
        return list;
    }




}
