package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.transaction.annotation.Transactional;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFRole;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WFRoleSearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IWFRoleService;
import org.springframework.beans.factory.annotation.Autowired;
import cn.ibizlab.r7.runtime.wf.util.SearchResult;

/**
 * 实体[流程角色] 服务对象接口实现
 */
@Service
public class WFRoleServiceImpl implements IWFRoleService {

    @Autowired
    cn.ibizlab.r7.runtime.wf.core.repository.WFRoleRepository wFRoleRepository;

    @Override
    public WFRole getDraft(WFRole wfrole) {
        return wfrole;
    }

    @Override
    @Transactional
    public WFRole get(String wfroleid) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFRole _t_WFROLE = wFRoleRepository.get(wfroleid);
        if(_t_WFROLE == null)
            return null ;

        WFRole _wFRole = wFRoleRepository.convert2Domain(_t_WFROLE,null) ;

        return _wFRole;
    }

    @Override
    @Transactional
    public WFRole get(WFRole wfrole) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFRole t_WFROLE = wFRoleRepository.get(wfrole.getWFRoleId());
        wFRoleRepository.convert2Domain(t_WFROLE,wfrole);
        return wfrole;
    }

    @Override
    @Transactional
    public boolean create(WFRole wfrole) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFRole t_WFROLE = wFRoleRepository.convert2PO(wfrole,null);
        bOk = wFRoleRepository.create(t_WFROLE);
        wFRoleRepository.convert2Domain(t_WFROLE,wfrole);


        return bOk ;
    }

    @Override
    @Transactional
    public boolean remove(String wfroleid) {
        boolean bOk = false ;

        WFRole _wFRole = this.get(wfroleid);
        bOk = wFRoleRepository.remove(wfroleid);

        return bOk ;
    }

    @Override
    @Transactional
    public boolean update(WFRole wfrole) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFRole t_WFROLE = wFRoleRepository.convert2PO(wfrole,null);
        bOk = wFRoleRepository.update(t_WFROLE);
        wFRoleRepository.convert2Domain(t_WFROLE,wfrole) ;
        return bOk ;
    }

    @Override
    public boolean checkKey(WFRole wfrole) {
        return true;
    }

    @Override
    @Transactional
    public boolean save(WFRole wfrole) {
        if(wfrole.getWFRoleId()==null){
    		return create(wfrole);
    	}else{
            if(this.get(wfrole.getWFRoleId())!=null){
    			return update(wfrole);
    		}
    		return create(wfrole);
    	}
    }

    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<WFRole> searchDefault(WFRoleSearchContext context) {
        List<WFRole> list = new ArrayList<WFRole>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFRole> t_WFROLEs = wFRoleRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFRole t_WFROLE : t_WFROLEs){
            list.add(wFRoleRepository.convert2Domain(t_WFROLE,null));
        }
        return new PageImpl<WFRole>(list, context.getPageable(), t_WFROLEs.getTotalElements());
    }






}
