package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.transaction.annotation.Transactional;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFStepActor;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WFStepActorSearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IWFStepActorService;
import org.springframework.beans.factory.annotation.Autowired;
import cn.ibizlab.r7.runtime.wf.util.SearchResult;

/**
 * 实体[工作流步骤操作者] 服务对象接口实现
 */
@Service
public class WFStepActorServiceImpl implements IWFStepActorService {

    @Autowired
    cn.ibizlab.r7.runtime.wf.core.repository.WFStepActorRepository wFStepActorRepository;

    @Override
    public boolean checkKey(WFStepActor wfstepactor) {
        return true;
    }

    @Override
    @Transactional
    public WFStepActor get(String wfstepactorid) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepActor _t_WFSTEPACTOR = wFStepActorRepository.get(wfstepactorid);
        if(_t_WFSTEPACTOR == null)
            return null ;

        WFStepActor _wFStepActor = wFStepActorRepository.convert2Domain(_t_WFSTEPACTOR,null) ;

        return _wFStepActor;
    }

    @Override
    @Transactional
    public WFStepActor get(WFStepActor wfstepactor) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepActor t_WFSTEPACTOR = wFStepActorRepository.get(wfstepactor.getWFStepActorId());
        wFStepActorRepository.convert2Domain(t_WFSTEPACTOR,wfstepactor);
        return wfstepactor;
    }

    @Override
    @Transactional
    public boolean create(WFStepActor wfstepactor) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepActor t_WFSTEPACTOR = wFStepActorRepository.convert2PO(wfstepactor,null);
        bOk = wFStepActorRepository.create(t_WFSTEPACTOR);
        wFStepActorRepository.convert2Domain(t_WFSTEPACTOR,wfstepactor);


        return bOk ;
    }

    @Override
    @Transactional
    public boolean remove(String wfstepactorid) {
        boolean bOk = false ;

        WFStepActor _wFStepActor = this.get(wfstepactorid);
        bOk = wFStepActorRepository.remove(wfstepactorid);

        return bOk ;
    }

    @Override
    @Transactional
    public boolean save(WFStepActor wfstepactor) {
        if(wfstepactor.getWFStepActorId()==null){
    		return create(wfstepactor);
    	}else{
            if(this.get(wfstepactor.getWFStepActorId())!=null){
    			return update(wfstepactor);
    		}
    		return create(wfstepactor);
    	}
    }

    @Override
    @Transactional
    public boolean update(WFStepActor wfstepactor) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepActor t_WFSTEPACTOR = wFStepActorRepository.convert2PO(wfstepactor,null);
        bOk = wFStepActorRepository.update(t_WFSTEPACTOR);
        wFStepActorRepository.convert2Domain(t_WFSTEPACTOR,wfstepactor) ;
        return bOk ;
    }

    @Override
    public WFStepActor getDraft(WFStepActor wfstepactor) {
        return wfstepactor;
    }

    @Override
    @Transactional
    public WFStepActor calculateNext(WFStepActor wfstepactor) {
        
        return wfstepactor;
    }

    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<WFStepActor> searchDefault(WFStepActorSearchContext context) {
        List<WFStepActor> list = new ArrayList<WFStepActor>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepActor> t_WFSTEPACTORs = wFStepActorRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepActor t_WFSTEPACTOR : t_WFSTEPACTORs){
            list.add(wFStepActorRepository.convert2Domain(t_WFSTEPACTOR,null));
        }
        return new PageImpl<WFStepActor>(list, context.getPageable(), t_WFSTEPACTORs.getTotalElements());
    }


    /**
     * 根据流程处理查询
     */
    @Override
    public Page<WFStepActor> selectByPSWFProcess(String pswfprocessid){
        WFStepActorSearchContext context = new WFStepActorSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pswfprocessid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pswfprocessid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pswfprocessid);
            context.getCondition().add(fieldFilter);
        }
        List<WFStepActor> list = new ArrayList<WFStepActor>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepActor> t_WFSTEPACTORs = wFStepActorRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepActor t_WFSTEPACTOR : t_WFSTEPACTORs){
            list.add(wFStepActorRepository.convert2Domain(t_WFSTEPACTOR,null));
        }
        return new PageImpl<WFStepActor>(list, context.getPageable(), t_WFSTEPACTORs.getTotalElements());
    }

    /**
     * 根据流程处理查询
     */
    @Override
    public List<WFStepActor> selectByPSWFProcess2(String pswfprocessid){
        WFStepActorSearchContext context = new WFStepActorSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pswfprocessid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pswfprocessid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pswfprocessid);
            context.getCondition().add(fieldFilter);
        }
        List<WFStepActor> list = new ArrayList<WFStepActor>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepActor> t_WFSTEPACTORs = wFStepActorRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepActor t_WFSTEPACTOR : t_WFSTEPACTORs){
            list.add(wFStepActorRepository.convert2Domain(t_WFSTEPACTOR,null));
        }
        return list;
    }
    /**
     * 根据业务流程版本查询
     */
    @Override
    public Page<WFStepActor> selectByPSWFVersion(String pswfversionid){
        WFStepActorSearchContext context = new WFStepActorSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pswfversionid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pswfversionid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pswfversionid);
            context.getCondition().add(fieldFilter);
        }
        List<WFStepActor> list = new ArrayList<WFStepActor>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepActor> t_WFSTEPACTORs = wFStepActorRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepActor t_WFSTEPACTOR : t_WFSTEPACTORs){
            list.add(wFStepActorRepository.convert2Domain(t_WFSTEPACTOR,null));
        }
        return new PageImpl<WFStepActor>(list, context.getPageable(), t_WFSTEPACTORs.getTotalElements());
    }

    /**
     * 根据业务流程版本查询
     */
    @Override
    public List<WFStepActor> selectByPSWFVersion2(String pswfversionid){
        WFStepActorSearchContext context = new WFStepActorSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pswfversionid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pswfversionid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pswfversionid);
            context.getCondition().add(fieldFilter);
        }
        List<WFStepActor> list = new ArrayList<WFStepActor>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepActor> t_WFSTEPACTORs = wFStepActorRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepActor t_WFSTEPACTOR : t_WFSTEPACTORs){
            list.add(wFStepActorRepository.convert2Domain(t_WFSTEPACTOR,null));
        }
        return list;
    }
    /**
     * 根据工作流实例查询
     */
    @Override
    public Page<WFStepActor> selectByWFInstance(String wfinstanceid){
        WFStepActorSearchContext context = new WFStepActorSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(wfinstanceid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("wfinstanceid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(wfinstanceid);
            context.getCondition().add(fieldFilter);
        }
        List<WFStepActor> list = new ArrayList<WFStepActor>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepActor> t_WFSTEPACTORs = wFStepActorRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepActor t_WFSTEPACTOR : t_WFSTEPACTORs){
            list.add(wFStepActorRepository.convert2Domain(t_WFSTEPACTOR,null));
        }
        return new PageImpl<WFStepActor>(list, context.getPageable(), t_WFSTEPACTORs.getTotalElements());
    }

    /**
     * 根据工作流实例查询
     */
    @Override
    public List<WFStepActor> selectByWFInstance2(String wfinstanceid){
        WFStepActorSearchContext context = new WFStepActorSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(wfinstanceid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("wfinstanceid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(wfinstanceid);
            context.getCondition().add(fieldFilter);
        }
        List<WFStepActor> list = new ArrayList<WFStepActor>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepActor> t_WFSTEPACTORs = wFStepActorRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepActor t_WFSTEPACTOR : t_WFSTEPACTORs){
            list.add(wFStepActorRepository.convert2Domain(t_WFSTEPACTOR,null));
        }
        return list;
    }
    /**
     * 根据工作流步骤查询
     */
    @Override
    public Page<WFStepActor> selectByWfstep(String wfstepid){
        WFStepActorSearchContext context = new WFStepActorSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(wfstepid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("wfstepid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(wfstepid);
            context.getCondition().add(fieldFilter);
        }
        List<WFStepActor> list = new ArrayList<WFStepActor>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepActor> t_WFSTEPACTORs = wFStepActorRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepActor t_WFSTEPACTOR : t_WFSTEPACTORs){
            list.add(wFStepActorRepository.convert2Domain(t_WFSTEPACTOR,null));
        }
        return new PageImpl<WFStepActor>(list, context.getPageable(), t_WFSTEPACTORs.getTotalElements());
    }

    /**
     * 根据工作流步骤查询
     */
    @Override
    public List<WFStepActor> selectByWfstep2(String wfstepid){
        WFStepActorSearchContext context = new WFStepActorSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(wfstepid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("wfstepid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(wfstepid);
            context.getCondition().add(fieldFilter);
        }
        List<WFStepActor> list = new ArrayList<WFStepActor>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepActor> t_WFSTEPACTORs = wFStepActorRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepActor t_WFSTEPACTOR : t_WFSTEPACTORs){
            list.add(wFStepActorRepository.convert2Domain(t_WFSTEPACTOR,null));
        }
        return list;
    }
    /**
     * 根据工作流用户查询
     */
    @Override
    public Page<WFStepActor> selectByWfuser(String wfuserid){
        WFStepActorSearchContext context = new WFStepActorSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(wfuserid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("wfuserid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(wfuserid);
            context.getCondition().add(fieldFilter);
        }
        List<WFStepActor> list = new ArrayList<WFStepActor>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepActor> t_WFSTEPACTORs = wFStepActorRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepActor t_WFSTEPACTOR : t_WFSTEPACTORs){
            list.add(wFStepActorRepository.convert2Domain(t_WFSTEPACTOR,null));
        }
        return new PageImpl<WFStepActor>(list, context.getPageable(), t_WFSTEPACTORs.getTotalElements());
    }

    /**
     * 根据工作流用户查询
     */
    @Override
    public List<WFStepActor> selectByWfuser2(String wfuserid){
        WFStepActorSearchContext context = new WFStepActorSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(wfuserid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("wfuserid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(wfuserid);
            context.getCondition().add(fieldFilter);
        }
        List<WFStepActor> list = new ArrayList<WFStepActor>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepActor> t_WFSTEPACTORs = wFStepActorRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepActor t_WFSTEPACTOR : t_WFSTEPACTORs){
            list.add(wFStepActorRepository.convert2Domain(t_WFSTEPACTOR,null));
        }
        return list;
    }




}
