package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.transaction.annotation.Transactional;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFStepData;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WFStepDataSearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IWFStepDataService;
import org.springframework.beans.factory.annotation.Autowired;
import cn.ibizlab.r7.runtime.wf.util.SearchResult;

/**
 * 实体[流程步骤信息] 服务对象接口实现
 */
@Service
public class WFStepDataServiceImpl implements IWFStepDataService {

    @Autowired
    cn.ibizlab.r7.runtime.wf.core.repository.WFStepDataRepository wFStepDataRepository;

    @Override
    @Transactional
    public boolean create(WFStepData wfstepdata) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepData t_WFSTEPDATA = wFStepDataRepository.convert2PO(wfstepdata,null);
        bOk = wFStepDataRepository.create(t_WFSTEPDATA);
        wFStepDataRepository.convert2Domain(t_WFSTEPDATA,wfstepdata);


        return bOk ;
    }

    @Override
    @Transactional
    public WFStepData get(String wfstepdataid) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepData _t_WFSTEPDATA = wFStepDataRepository.get(wfstepdataid);
        if(_t_WFSTEPDATA == null)
            return null ;

        WFStepData _wFStepData = wFStepDataRepository.convert2Domain(_t_WFSTEPDATA,null) ;

        return _wFStepData;
    }

    @Override
    @Transactional
    public WFStepData get(WFStepData wfstepdata) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepData t_WFSTEPDATA = wFStepDataRepository.get(wfstepdata.getWFStepDataId());
        wFStepDataRepository.convert2Domain(t_WFSTEPDATA,wfstepdata);
        return wfstepdata;
    }

    @Override
    public boolean checkKey(WFStepData wfstepdata) {
        return true;
    }

    @Override
    @Transactional
    public boolean update(WFStepData wfstepdata) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepData t_WFSTEPDATA = wFStepDataRepository.convert2PO(wfstepdata,null);
        bOk = wFStepDataRepository.update(t_WFSTEPDATA);
        wFStepDataRepository.convert2Domain(t_WFSTEPDATA,wfstepdata) ;
        return bOk ;
    }

    @Override
    @Transactional
    public boolean remove(String wfstepdataid) {
        boolean bOk = false ;

        WFStepData _wFStepData = this.get(wfstepdataid);
        bOk = wFStepDataRepository.remove(wfstepdataid);

        return bOk ;
    }

    @Override
    public WFStepData getDraft(WFStepData wfstepdata) {
        return wfstepdata;
    }

    @Override
    @Transactional
    public boolean save(WFStepData wfstepdata) {
        if(wfstepdata.getWFStepDataId()==null){
    		return create(wfstepdata);
    	}else{
            if(this.get(wfstepdata.getWFStepDataId())!=null){
    			return update(wfstepdata);
    		}
    		return create(wfstepdata);
    	}
    }

    /**
     * 查询集合 ByBswfdata
     */
    @Override
    public Page<WFStepData> searchByBswfdata(WFStepDataSearchContext context) {
        List<WFStepData> list = new ArrayList<WFStepData>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepData> t_WFSTEPDATAs = wFStepDataRepository.searchByBswfdata(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepData t_WFSTEPDATA : t_WFSTEPDATAs){
            list.add(wFStepDataRepository.convert2Domain(t_WFSTEPDATA,null));
        }
        return new PageImpl<WFStepData>(list, context.getPageable(), t_WFSTEPDATAs.getTotalElements());
    }

    /**
     * 查询集合 ByBsdata
     */
    @Override
    public Page<WFStepData> searchByBsdata(WFStepDataSearchContext context) {
        List<WFStepData> list = new ArrayList<WFStepData>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepData> t_WFSTEPDATAs = wFStepDataRepository.searchByBsdata(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepData t_WFSTEPDATA : t_WFSTEPDATAs){
            list.add(wFStepDataRepository.convert2Domain(t_WFSTEPDATA,null));
        }
        return new PageImpl<WFStepData>(list, context.getPageable(), t_WFSTEPDATAs.getTotalElements());
    }

    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<WFStepData> searchDefault(WFStepDataSearchContext context) {
        List<WFStepData> list = new ArrayList<WFStepData>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepData> t_WFSTEPDATAs = wFStepDataRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepData t_WFSTEPDATA : t_WFSTEPDATAs){
            list.add(wFStepDataRepository.convert2Domain(t_WFSTEPDATA,null));
        }
        return new PageImpl<WFStepData>(list, context.getPageable(), t_WFSTEPDATAs.getTotalElements());
    }


    /**
     * 根据工作流步骤操作查询
     */
    @Override
    public Page<WFStepData> selectByWFIAAction(String wfiaactionid){
        WFStepDataSearchContext context = new WFStepDataSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(wfiaactionid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("wfiaactionid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(wfiaactionid);
            context.getCondition().add(fieldFilter);
        }
        List<WFStepData> list = new ArrayList<WFStepData>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepData> t_WFSTEPDATAs = wFStepDataRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepData t_WFSTEPDATA : t_WFSTEPDATAs){
            list.add(wFStepDataRepository.convert2Domain(t_WFSTEPDATA,null));
        }
        return new PageImpl<WFStepData>(list, context.getPageable(), t_WFSTEPDATAs.getTotalElements());
    }

    /**
     * 根据工作流步骤操作查询
     */
    @Override
    public List<WFStepData> selectByWFIAAction2(String wfiaactionid){
        WFStepDataSearchContext context = new WFStepDataSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(wfiaactionid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("wfiaactionid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(wfiaactionid);
            context.getCondition().add(fieldFilter);
        }
        List<WFStepData> list = new ArrayList<WFStepData>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepData> t_WFSTEPDATAs = wFStepDataRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepData t_WFSTEPDATA : t_WFSTEPDATAs){
            list.add(wFStepDataRepository.convert2Domain(t_WFSTEPDATA,null));
        }
        return list;
    }
    /**
     * 根据工作流实例查询
     */
    @Override
    public Page<WFStepData> selectByWFINSTANCE(String wfinstanceid){
        WFStepDataSearchContext context = new WFStepDataSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(wfinstanceid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("wfinstanceid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(wfinstanceid);
            context.getCondition().add(fieldFilter);
        }
        List<WFStepData> list = new ArrayList<WFStepData>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepData> t_WFSTEPDATAs = wFStepDataRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepData t_WFSTEPDATA : t_WFSTEPDATAs){
            list.add(wFStepDataRepository.convert2Domain(t_WFSTEPDATA,null));
        }
        return new PageImpl<WFStepData>(list, context.getPageable(), t_WFSTEPDATAs.getTotalElements());
    }

    /**
     * 根据工作流实例查询
     */
    @Override
    public List<WFStepData> selectByWFINSTANCE2(String wfinstanceid){
        WFStepDataSearchContext context = new WFStepDataSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(wfinstanceid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("wfinstanceid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(wfinstanceid);
            context.getCondition().add(fieldFilter);
        }
        List<WFStepData> list = new ArrayList<WFStepData>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepData> t_WFSTEPDATAs = wFStepDataRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepData t_WFSTEPDATA : t_WFSTEPDATAs){
            list.add(wFStepDataRepository.convert2Domain(t_WFSTEPDATA,null));
        }
        return list;
    }
    /**
     * 根据工作流步骤查询
     */
    @Override
    public Page<WFStepData> selectByWFStep(String wfstepid){
        WFStepDataSearchContext context = new WFStepDataSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(wfstepid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("wfstepid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(wfstepid);
            context.getCondition().add(fieldFilter);
        }
        List<WFStepData> list = new ArrayList<WFStepData>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepData> t_WFSTEPDATAs = wFStepDataRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepData t_WFSTEPDATA : t_WFSTEPDATAs){
            list.add(wFStepDataRepository.convert2Domain(t_WFSTEPDATA,null));
        }
        return new PageImpl<WFStepData>(list, context.getPageable(), t_WFSTEPDATAs.getTotalElements());
    }

    /**
     * 根据工作流步骤查询
     */
    @Override
    public List<WFStepData> selectByWFStep2(String wfstepid){
        WFStepDataSearchContext context = new WFStepDataSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(wfstepid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("wfstepid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(wfstepid);
            context.getCondition().add(fieldFilter);
        }
        List<WFStepData> list = new ArrayList<WFStepData>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepData> t_WFSTEPDATAs = wFStepDataRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepData t_WFSTEPDATA : t_WFSTEPDATAs){
            list.add(wFStepDataRepository.convert2Domain(t_WFSTEPDATA,null));
        }
        return list;
    }




}
