package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.transaction.annotation.Transactional;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFStep;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WFStepSearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IWFStepService;
import org.springframework.beans.factory.annotation.Autowired;
import cn.ibizlab.r7.runtime.wf.util.SearchResult;

/**
 * 实体[工作流步骤] 服务对象接口实现
 */
@Service
public class WFStepServiceImpl implements IWFStepService {

    @Autowired
    cn.ibizlab.r7.runtime.wf.core.repository.WFStepRepository wFStepRepository;

    @Override
    public WFStep getDraft(WFStep wfstep) {
        return wfstep;
    }

    @Override
    @Transactional
    public boolean create(WFStep wfstep) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFStep t_WFSTEP = wFStepRepository.convert2PO(wfstep,null);
        bOk = wFStepRepository.create(t_WFSTEP);
        wFStepRepository.convert2Domain(t_WFSTEP,wfstep);


        return bOk ;
    }

    @Override
    @Transactional
    public boolean save(WFStep wfstep) {
        if(wfstep.getWFStepId()==null){
    		return create(wfstep);
    	}else{
            if(this.get(wfstep.getWFStepId())!=null){
    			return update(wfstep);
    		}
    		return create(wfstep);
    	}
    }

    @Override
    public boolean checkKey(WFStep wfstep) {
        return true;
    }

    @Override
    @Transactional
    public WFStep get(String wfstepid) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFStep _t_WFSTEP = wFStepRepository.get(wfstepid);
        if(_t_WFSTEP == null)
            return null ;

        WFStep _wFStep = wFStepRepository.convert2Domain(_t_WFSTEP,null) ;

        return _wFStep;
    }

    @Override
    @Transactional
    public WFStep get(WFStep wfstep) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFStep t_WFSTEP = wFStepRepository.get(wfstep.getWFStepId());
        wFStepRepository.convert2Domain(t_WFSTEP,wfstep);
        return wfstep;
    }

    @Override
    @Transactional
    public boolean update(WFStep wfstep) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFStep t_WFSTEP = wFStepRepository.convert2PO(wfstep,null);
        bOk = wFStepRepository.update(t_WFSTEP);
        wFStepRepository.convert2Domain(t_WFSTEP,wfstep) ;
        return bOk ;
    }

    @Override
    @Transactional
    public boolean remove(String wfstepid) {
        boolean bOk = false ;

        WFStep _wFStep = this.get(wfstepid);
        bOk = wFStepRepository.remove(wfstepid);

        return bOk ;
    }

    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<WFStep> searchDefault(WFStepSearchContext context) {
        List<WFStep> list = new ArrayList<WFStep>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFStep> t_WFSTEPs = wFStepRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFStep t_WFSTEP : t_WFSTEPs){
            list.add(wFStepRepository.convert2Domain(t_WFSTEP,null));
        }
        return new PageImpl<WFStep>(list, context.getPageable(), t_WFSTEPs.getTotalElements());
    }


    /**
     * 根据流程处理查询
     */
    @Override
    public Page<WFStep> selectByPSWFProcess(String pswfprocessid){
        WFStepSearchContext context = new WFStepSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pswfprocessid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pswfprocessid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pswfprocessid);
            context.getCondition().add(fieldFilter);
        }
        List<WFStep> list = new ArrayList<WFStep>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFStep> t_WFSTEPs = wFStepRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFStep t_WFSTEP : t_WFSTEPs){
            list.add(wFStepRepository.convert2Domain(t_WFSTEP,null));
        }
        return new PageImpl<WFStep>(list, context.getPageable(), t_WFSTEPs.getTotalElements());
    }

    /**
     * 根据流程处理查询
     */
    @Override
    public List<WFStep> selectByPSWFProcess2(String pswfprocessid){
        WFStepSearchContext context = new WFStepSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pswfprocessid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pswfprocessid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pswfprocessid);
            context.getCondition().add(fieldFilter);
        }
        List<WFStep> list = new ArrayList<WFStep>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFStep> t_WFSTEPs = wFStepRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFStep t_WFSTEP : t_WFSTEPs){
            list.add(wFStepRepository.convert2Domain(t_WFSTEP,null));
        }
        return list;
    }
    /**
     * 根据业务流程版本查询
     */
    @Override
    public Page<WFStep> selectByPSWFVersion(String pswfversionid){
        WFStepSearchContext context = new WFStepSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pswfversionid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pswfversionid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pswfversionid);
            context.getCondition().add(fieldFilter);
        }
        List<WFStep> list = new ArrayList<WFStep>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFStep> t_WFSTEPs = wFStepRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFStep t_WFSTEP : t_WFSTEPs){
            list.add(wFStepRepository.convert2Domain(t_WFSTEP,null));
        }
        return new PageImpl<WFStep>(list, context.getPageable(), t_WFSTEPs.getTotalElements());
    }

    /**
     * 根据业务流程版本查询
     */
    @Override
    public List<WFStep> selectByPSWFVersion2(String pswfversionid){
        WFStepSearchContext context = new WFStepSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pswfversionid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pswfversionid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pswfversionid);
            context.getCondition().add(fieldFilter);
        }
        List<WFStep> list = new ArrayList<WFStep>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFStep> t_WFSTEPs = wFStepRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFStep t_WFSTEP : t_WFSTEPs){
            list.add(wFStepRepository.convert2Domain(t_WFSTEP,null));
        }
        return list;
    }
    /**
     * 根据工作流实例查询
     */
    @Override
    public Page<WFStep> selectByWFInstance(String wfinstanceid){
        WFStepSearchContext context = new WFStepSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(wfinstanceid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("wfinstanceid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(wfinstanceid);
            context.getCondition().add(fieldFilter);
        }
        List<WFStep> list = new ArrayList<WFStep>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFStep> t_WFSTEPs = wFStepRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFStep t_WFSTEP : t_WFSTEPs){
            list.add(wFStepRepository.convert2Domain(t_WFSTEP,null));
        }
        return new PageImpl<WFStep>(list, context.getPageable(), t_WFSTEPs.getTotalElements());
    }

    /**
     * 根据工作流实例查询
     */
    @Override
    public List<WFStep> selectByWFInstance2(String wfinstanceid){
        WFStepSearchContext context = new WFStepSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(wfinstanceid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("wfinstanceid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(wfinstanceid);
            context.getCondition().add(fieldFilter);
        }
        List<WFStep> list = new ArrayList<WFStep>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFStep> t_WFSTEPs = wFStepRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFStep t_WFSTEP : t_WFSTEPs){
            list.add(wFStepRepository.convert2Domain(t_WFSTEP,null));
        }
        return list;
    }




}
