package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.transaction.annotation.Transactional;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFUser;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WFUserSearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IWFUserService;
import org.springframework.beans.factory.annotation.Autowired;
import cn.ibizlab.r7.runtime.wf.util.SearchResult;

/**
 * 实体[工作流用户] 服务对象接口实现
 */
@Service
public class WFUserServiceImpl implements IWFUserService {

    @Autowired
    cn.ibizlab.r7.runtime.wf.core.repository.WFUserRepository wFUserRepository;

    @Override
    @Transactional
    public boolean update(WFUser wfuser) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFUser t_WFUSER = wFUserRepository.convert2PO(wfuser,null);
        bOk = wFUserRepository.update(t_WFUSER);
        wFUserRepository.convert2Domain(t_WFUSER,wfuser) ;
        return bOk ;
    }

    @Override
    @Transactional
    public boolean remove(String wfuserid) {
        boolean bOk = false ;

        WFUser _wFUser = this.get(wfuserid);
        bOk = wFUserRepository.remove(wfuserid);

        return bOk ;
    }

    @Override
    @Transactional
    public boolean save(WFUser wfuser) {
        if(wfuser.getWFUserId()==null){
    		return create(wfuser);
    	}else{
            if(this.get(wfuser.getWFUserId())!=null){
    			return update(wfuser);
    		}
    		return create(wfuser);
    	}
    }

    @Override
    public WFUser getDraft(WFUser wfuser) {
        return wfuser;
    }

    @Override
    public boolean checkKey(WFUser wfuser) {
        return true;
    }

    @Override
    @Transactional
    public boolean create(WFUser wfuser) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFUser t_WFUSER = wFUserRepository.convert2PO(wfuser,null);
        bOk = wFUserRepository.create(t_WFUSER);
        wFUserRepository.convert2Domain(t_WFUSER,wfuser);


        return bOk ;
    }

    @Override
    @Transactional
    public WFUser get(String wfuserid) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFUser _t_WFUSER = wFUserRepository.get(wfuserid);
        if(_t_WFUSER == null)
            return null ;

        WFUser _wFUser = wFUserRepository.convert2Domain(_t_WFUSER,null) ;

        return _wFUser;
    }

    @Override
    @Transactional
    public WFUser get(WFUser wfuser) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFUser t_WFUSER = wFUserRepository.get(wfuser.getWFUserId());
        wFUserRepository.convert2Domain(t_WFUSER,wfuser);
        return wfuser;
    }

    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<WFUser> searchDefault(WFUserSearchContext context) {
        List<WFUser> list = new ArrayList<WFUser>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFUser> t_WFUSERs = wFUserRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFUser t_WFUSER : t_WFUSERs){
            list.add(wFUserRepository.convert2Domain(t_WFUSER,null));
        }
        return new PageImpl<WFUser>(list, context.getPageable(), t_WFUSERs.getTotalElements());
    }






}
