package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.transaction.annotation.Transactional;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFWorklist;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WFWorklistSearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IWFWorklistService;
import org.springframework.beans.factory.annotation.Autowired;
import cn.ibizlab.r7.runtime.wf.util.SearchResult;

/**
 * 实体[工作流工作列表] 服务对象接口实现
 */
@Service
public class WFWorklistServiceImpl implements IWFWorklistService {

    @Autowired
    cn.ibizlab.r7.runtime.wf.core.repository.WFWorklistRepository wFWorklistRepository;

    @Override
    @Transactional
    public void updateBatch(List<WFWorklist> wfworklists) {

    }

    @Override
    public boolean checkKey(WFWorklist wfworklist) {
        return true;
    }

    @Override
    public WFWorklist getDraft(WFWorklist wfworklist) {
        return wfworklist;
    }

    @Override
    @Transactional
    public boolean update(WFWorklist wfworklist) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFWorklist t_WFWORKLIST = wFWorklistRepository.convert2PO(wfworklist,null);
        bOk = wFWorklistRepository.update(t_WFWORKLIST);
        wFWorklistRepository.convert2Domain(t_WFWORKLIST,wfworklist) ;
        return bOk ;
    }

    @Override
    @Transactional
    public void createBatch(List<WFWorklist> wfworklists) {

    }

    @Override
    @Transactional
    public boolean remove(String wfworklistid) {
        boolean bOk = false ;

        WFWorklist _wFWorklist = this.get(wfworklistid);
        bOk = wFWorklistRepository.remove(wfworklistid);

        return bOk ;
    }

    @Override
    @Transactional
    public WFWorklist get(String wfworklistid) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFWorklist _t_WFWORKLIST = wFWorklistRepository.get(wfworklistid);
        if(_t_WFWORKLIST == null)
            return null ;

        WFWorklist _wFWorklist = wFWorklistRepository.convert2Domain(_t_WFWORKLIST,null) ;

        return _wFWorklist;
    }

    @Override
    @Transactional
    public WFWorklist get(WFWorklist wfworklist) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFWorklist t_WFWORKLIST = wFWorklistRepository.get(wfworklist.getWFWorklistId());
        wFWorklistRepository.convert2Domain(t_WFWORKLIST,wfworklist);
        return wfworklist;
    }

    @Override
    @Transactional
    public boolean save(WFWorklist wfworklist) {
        if(wfworklist.getWFWorklistId()==null){
    		return create(wfworklist);
    	}else{
            if(this.get(wfworklist.getWFWorklistId())!=null){
    			return update(wfworklist);
    		}
    		return create(wfworklist);
    	}
    }

    @Override
    @Transactional
    public boolean create(WFWorklist wfworklist) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.WFWorklist t_WFWORKLIST = wFWorklistRepository.convert2PO(wfworklist,null);
        bOk = wFWorklistRepository.create(t_WFWORKLIST);
        wFWorklistRepository.convert2Domain(t_WFWORKLIST,wfworklist);


        return bOk ;
    }

    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<WFWorklist> searchDefault(WFWorklistSearchContext context) {
        List<WFWorklist> list = new ArrayList<WFWorklist>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFWorklist> t_WFWORKLISTs = wFWorklistRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFWorklist t_WFWORKLIST : t_WFWORKLISTs){
            list.add(wFWorklistRepository.convert2Domain(t_WFWORKLIST,null));
        }
        return new PageImpl<WFWorklist>(list, context.getPageable(), t_WFWORKLISTs.getTotalElements());
    }

    /**
     * 查询集合 我的已办查询
     */
    @Override
    public Page<WFWorklist> searchDoneTask(WFWorklistSearchContext context) {
        List<WFWorklist> list = new ArrayList<WFWorklist>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFWorklist> t_WFWORKLISTs = wFWorklistRepository.searchDoneTask(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFWorklist t_WFWORKLIST : t_WFWORKLISTs){
            list.add(wFWorklistRepository.convert2Domain(t_WFWORKLIST,null));
        }
        return new PageImpl<WFWorklist>(list, context.getPageable(), t_WFWORKLISTs.getTotalElements());
    }

    /**
     * 查询集合 我的待办查询
     */
    @Override
    public Page<WFWorklist> searchTodoTask(WFWorklistSearchContext context) {
        List<WFWorklist> list = new ArrayList<WFWorklist>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFWorklist> t_WFWORKLISTs = wFWorklistRepository.searchTodoTask(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFWorklist t_WFWORKLIST : t_WFWORKLISTs){
            list.add(wFWorklistRepository.convert2Domain(t_WFWORKLIST,null));
        }
        return new PageImpl<WFWorklist>(list, context.getPageable(), t_WFWORKLISTs.getTotalElements());
    }


    /**
     * 根据部门用户查询
     */
    @Override
    public Page<WFWorklist> selectByORGDEPTUSER(String orgdeptuserid){
        WFWorklistSearchContext context = new WFWorklistSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgdeptuserid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("orgdeptuserid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgdeptuserid);
            context.getCondition().add(fieldFilter);
        }
        List<WFWorklist> list = new ArrayList<WFWorklist>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFWorklist> t_WFWORKLISTs = wFWorklistRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFWorklist t_WFWORKLIST : t_WFWORKLISTs){
            list.add(wFWorklistRepository.convert2Domain(t_WFWORKLIST,null));
        }
        return new PageImpl<WFWorklist>(list, context.getPageable(), t_WFWORKLISTs.getTotalElements());
    }

    /**
     * 根据部门用户查询
     */
    @Override
    public List<WFWorklist> selectByORGDEPTUSER2(String orgdeptuserid){
        WFWorklistSearchContext context = new WFWorklistSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgdeptuserid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("orgdeptuserid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgdeptuserid);
            context.getCondition().add(fieldFilter);
        }
        List<WFWorklist> list = new ArrayList<WFWorklist>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFWorklist> t_WFWORKLISTs = wFWorklistRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFWorklist t_WFWORKLIST : t_WFWORKLISTs){
            list.add(wFWorklistRepository.convert2Domain(t_WFWORKLIST,null));
        }
        return list;
    }
    /**
     * 根据部门查询
     */
    @Override
    public Page<WFWorklist> selectByORGDEPT(String orgdeptid){
        WFWorklistSearchContext context = new WFWorklistSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgdeptid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("orgdeptid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgdeptid);
            context.getCondition().add(fieldFilter);
        }
        List<WFWorklist> list = new ArrayList<WFWorklist>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFWorklist> t_WFWORKLISTs = wFWorklistRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFWorklist t_WFWORKLIST : t_WFWORKLISTs){
            list.add(wFWorklistRepository.convert2Domain(t_WFWORKLIST,null));
        }
        return new PageImpl<WFWorklist>(list, context.getPageable(), t_WFWORKLISTs.getTotalElements());
    }

    /**
     * 根据部门查询
     */
    @Override
    public List<WFWorklist> selectByORGDEPT2(String orgdeptid){
        WFWorklistSearchContext context = new WFWorklistSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgdeptid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("orgdeptid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgdeptid);
            context.getCondition().add(fieldFilter);
        }
        List<WFWorklist> list = new ArrayList<WFWorklist>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFWorklist> t_WFWORKLISTs = wFWorklistRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFWorklist t_WFWORKLIST : t_WFWORKLISTs){
            list.add(wFWorklistRepository.convert2Domain(t_WFWORKLIST,null));
        }
        return list;
    }
    /**
     * 根据组织查询
     */
    @Override
    public Page<WFWorklist> selectByORG(String orgid){
        WFWorklistSearchContext context = new WFWorklistSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("orgid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgid);
            context.getCondition().add(fieldFilter);
        }
        List<WFWorklist> list = new ArrayList<WFWorklist>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFWorklist> t_WFWORKLISTs = wFWorklistRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFWorklist t_WFWORKLIST : t_WFWORKLISTs){
            list.add(wFWorklistRepository.convert2Domain(t_WFWORKLIST,null));
        }
        return new PageImpl<WFWorklist>(list, context.getPageable(), t_WFWORKLISTs.getTotalElements());
    }

    /**
     * 根据组织查询
     */
    @Override
    public List<WFWorklist> selectByORG2(String orgid){
        WFWorklistSearchContext context = new WFWorklistSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(orgid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("orgid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(orgid);
            context.getCondition().add(fieldFilter);
        }
        List<WFWorklist> list = new ArrayList<WFWorklist>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFWorklist> t_WFWORKLISTs = wFWorklistRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFWorklist t_WFWORKLIST : t_WFWORKLISTs){
            list.add(wFWorklistRepository.convert2Domain(t_WFWORKLIST,null));
        }
        return list;
    }
    /**
     * 根据平台流程角色查询
     */
    @Override
    public Page<WFWorklist> selectByPSWFROLE(String pswfroleid){
        WFWorklistSearchContext context = new WFWorklistSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pswfroleid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pswfroleid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pswfroleid);
            context.getCondition().add(fieldFilter);
        }
        List<WFWorklist> list = new ArrayList<WFWorklist>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFWorklist> t_WFWORKLISTs = wFWorklistRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFWorklist t_WFWORKLIST : t_WFWORKLISTs){
            list.add(wFWorklistRepository.convert2Domain(t_WFWORKLIST,null));
        }
        return new PageImpl<WFWorklist>(list, context.getPageable(), t_WFWORKLISTs.getTotalElements());
    }

    /**
     * 根据平台流程角色查询
     */
    @Override
    public List<WFWorklist> selectByPSWFROLE2(String pswfroleid){
        WFWorklistSearchContext context = new WFWorklistSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(pswfroleid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("pswfroleid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(pswfroleid);
            context.getCondition().add(fieldFilter);
        }
        List<WFWorklist> list = new ArrayList<WFWorklist>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFWorklist> t_WFWORKLISTs = wFWorklistRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFWorklist t_WFWORKLIST : t_WFWORKLISTs){
            list.add(wFWorklistRepository.convert2Domain(t_WFWORKLIST,null));
        }
        return list;
    }
    /**
     * 根据工作流实例查询
     */
    @Override
    public Page<WFWorklist> selectByWFInstance(String wfinstanceid){
        WFWorklistSearchContext context = new WFWorklistSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(wfinstanceid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("wfinstanceid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(wfinstanceid);
            context.getCondition().add(fieldFilter);
        }
        List<WFWorklist> list = new ArrayList<WFWorklist>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFWorklist> t_WFWORKLISTs = wFWorklistRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFWorklist t_WFWORKLIST : t_WFWORKLISTs){
            list.add(wFWorklistRepository.convert2Domain(t_WFWORKLIST,null));
        }
        return new PageImpl<WFWorklist>(list, context.getPageable(), t_WFWORKLISTs.getTotalElements());
    }

    /**
     * 根据工作流实例查询
     */
    @Override
    public List<WFWorklist> selectByWFInstance2(String wfinstanceid){
        WFWorklistSearchContext context = new WFWorklistSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(wfinstanceid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("wfinstanceid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(wfinstanceid);
            context.getCondition().add(fieldFilter);
        }
        List<WFWorklist> list = new ArrayList<WFWorklist>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFWorklist> t_WFWORKLISTs = wFWorklistRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFWorklist t_WFWORKLIST : t_WFWORKLISTs){
            list.add(wFWorklistRepository.convert2Domain(t_WFWORKLIST,null));
        }
        return list;
    }
    /**
     * 根据工作流用户查询
     */
    @Override
    public Page<WFWorklist> selectByWFUser(String wfuserid){
        WFWorklistSearchContext context = new WFWorklistSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(wfuserid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("wfuserid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(wfuserid);
            context.getCondition().add(fieldFilter);
        }
        List<WFWorklist> list = new ArrayList<WFWorklist>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFWorklist> t_WFWORKLISTs = wFWorklistRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFWorklist t_WFWORKLIST : t_WFWORKLISTs){
            list.add(wFWorklistRepository.convert2Domain(t_WFWORKLIST,null));
        }
        return new PageImpl<WFWorklist>(list, context.getPageable(), t_WFWORKLISTs.getTotalElements());
    }

    /**
     * 根据工作流用户查询
     */
    @Override
    public List<WFWorklist> selectByWFUser2(String wfuserid){
        WFWorklistSearchContext context = new WFWorklistSearchContext();
        if(!org.springframework.util.StringUtils.isEmpty(wfuserid)){
            cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter fieldFilter=new cn.ibizlab.r7.runtime.wf.util.SearchFieldFilter();
            fieldFilter.setParam("wfuserid");
            fieldFilter.setCondition(cn.ibizlab.r7.runtime.wf.util.enums.SearchFieldType.EQ);
            fieldFilter.setValue(wfuserid);
            context.getCondition().add(fieldFilter);
        }
        List<WFWorklist> list = new ArrayList<WFWorklist>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.WFWorklist> t_WFWORKLISTs = wFWorklistRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.WFWorklist t_WFWORKLIST : t_WFWORKLISTs){
            list.add(wFWorklistRepository.convert2Domain(t_WFWORKLIST,null));
        }
        return list;
    }




}
