package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.transaction.annotation.Transactional;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.Workflow;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WorkflowSearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IWorkflowService;
import org.springframework.beans.factory.annotation.Autowired;
import cn.ibizlab.r7.runtime.wf.util.SearchResult;

/**
 * 实体[统一工作流] 服务对象接口实现
 */
@Service
public class WorkflowServiceImpl implements IWorkflowService {

    @Autowired
    cn.ibizlab.r7.runtime.wf.core.repository.WorkflowRepository workflowRepository;

    @Override
    public Workflow getDraft(Workflow workflow) {
        return workflow;
    }

    @Override
    @Transactional
    public boolean create(Workflow workflow) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.Workflow t_WORKFLOW = workflowRepository.convert2PO(workflow,null);
        bOk = workflowRepository.create(t_WORKFLOW);
        workflowRepository.convert2Domain(t_WORKFLOW,workflow);


        return bOk ;
    }

    @Override
    @Transactional
    public Workflow regist(Workflow workflow) {
         return workflow;
    }

    @Override
    public boolean checkKey(Workflow workflow) {
        return true;
    }

    @Override
    @Transactional
    public Workflow get(String workflowid) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.Workflow _t_WORKFLOW = workflowRepository.get(workflowid);
        if(_t_WORKFLOW == null)
            return null ;

        Workflow _workflow = workflowRepository.convert2Domain(_t_WORKFLOW,null) ;

        return _workflow;
    }

    @Override
    @Transactional
    public Workflow get(Workflow workflow) {
        cn.ibizlab.r7.runtime.wf.core.repository.po.Workflow t_WORKFLOW = workflowRepository.get(workflow.getWorkflowId());
        workflowRepository.convert2Domain(t_WORKFLOW,workflow);
        return workflow;
    }

    @Override
    @Transactional
    public boolean save(Workflow workflow) {
        if(workflow.getWorkflowId()==null){
    		return create(workflow);
    	}else{
            if(this.get(workflow.getWorkflowId())!=null){
    			return update(workflow);
    		}
    		return create(workflow);
    	}
    }

    @Override
    @Transactional
    public boolean remove(String workflowid) {
        boolean bOk = false ;

        Workflow _workflow = this.get(workflowid);
        bOk = workflowRepository.remove(workflowid);

        return bOk ;
    }

    @Override
    @Transactional
    public boolean update(Workflow workflow) {
        boolean bOk = false ;
        cn.ibizlab.r7.runtime.wf.core.repository.po.Workflow t_WORKFLOW = workflowRepository.convert2PO(workflow,null);
        bOk = workflowRepository.update(t_WORKFLOW);
        workflowRepository.convert2Domain(t_WORKFLOW,workflow) ;
        return bOk ;
    }

    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<Workflow> searchDefault(WorkflowSearchContext context) {
        List<Workflow> list = new ArrayList<Workflow>();
        Page<cn.ibizlab.r7.runtime.wf.core.repository.po.Workflow> t_WORKFLOWs = workflowRepository.searchDefault(context) ;
        for(cn.ibizlab.r7.runtime.wf.core.repository.po.Workflow t_WORKFLOW : t_WORKFLOWs){
            list.add(workflowRepository.convert2Domain(t_WORKFLOW,null));
        }
        return new PageImpl<Workflow>(list, context.getPageable(), t_WORKFLOWs.getTotalElements());
    }






}
