package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.logic.impl;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;

import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.logic.IWFIAActionProcLogic;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFIAAction;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.kie.api.runtime.KieSession;
import org.kie.api.runtime.KieContainer;

/**
 * 关系型数据实体[Proc] 对象
 */
@Service
public class WFIAActionProcLogicImpl implements IWFIAActionProcLogic{

    @Autowired
    private KieContainer kieContainer;

    @Autowired
    private cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IWFIAActionService wfiaactionservice;

    @Autowired
    private cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IWFIAActionService iBzSysDefaultService;

    public void execute(WFIAAction et){

          KieSession kieSession = null;
        try{
           kieSession=kieContainer.newKieSession();
           kieSession.insert(et); 
           kieSession.setGlobal("wfiaactionprocdefault",et);
           kieSession.setGlobal("wfiaactionservice",wfiaactionservice);
           kieSession.setGlobal("iBzSysWfiaactionDefaultService",iBzSysDefaultService);
           kieSession.startProcess("cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.logic.wfiaactionproc");

        }catch(Exception e){
            System.out.println("执行[Proc]处理逻辑发生异常"+e);
        }finally {
            if(kieSession!=null)
            kieSession.destroy();
        }
    }

}
