package cn.ibizlab.r7.runtime.wf.core.r7rt_wf.valuerule.anno.wfapp;

import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.valuerule.validator.wfapp.WFAppWFAppNameDefaultValidator;

import javax.validation.Constraint;
import javax.validation.Payload;
import java.lang.annotation.*;

/**
 * 值规则注解
 * 实体：WFApp
 * 属性：WFAppName
 * 值规则：Default
 */
@Target({ElementType.METHOD, ElementType.FIELD, ElementType.PARAMETER})
@Retention(RetentionPolicy.RUNTIME)
@Documented
@Constraint(validatedBy = {WFAppWFAppNameDefaultValidator.class})
public @interface WFAppWFAppNameDefault {
    //是否默认检查
    boolean flag() default true;

    //值规则名称
    String info() default "默认规则";

    //值规则信息，如果为空，使用值规则名称。
    String message() default "内容长度必须小于等于[200]";

    Class<?>[] groups() default {};

    Class<? extends Payload>[] payload() default {};
}
