package cn.ibizlab.r7.runtime.wf.core.repository ;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

import cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRole;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSWFRoleSearchContext;

/**
 * 实体 [平台流程角色] 存储对象
 */
public interface PSWFRoleRepository extends Repository<PSWFRole> {

    /**
	 * 查询集合 [当前组织]
	 * @param context
	 * @return
	 */
    Page<PSWFRole> searchCurOrg(PSWFRoleSearchContext context);
    /**
	 * 查询集合 [当前部门]
	 * @param context
	 * @return
	 */
    Page<PSWFRole> searchCurOrgDept(PSWFRoleSearchContext context);
    /**
	 * 查询集合 [DEFAULT]
	 * @param context
	 * @return
	 */
    Page<PSWFRole> searchDefault(PSWFRoleSearchContext context);

    PSWFRole convert2PO(cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFRole domain , PSWFRole po) ;

    cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFRole convert2Domain( PSWFRole po ,cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFRole domain) ;

}
