package cn.ibizlab.r7.runtime.wf.core.repository ;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

import cn.ibizlab.r7.runtime.wf.core.repository.po.PSWorkflow;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSWorkflowSearchContext;

/**
 * 实体 [业务工作流] 存储对象
 */
public interface PSWorkflowRepository extends Repository<PSWorkflow> {

    /**
	 * 查询集合 [当前组织]
	 * @param context
	 * @return
	 */
    Page<PSWorkflow> searchCurOrg(PSWorkflowSearchContext context);
    /**
	 * 查询集合 [当前部门]
	 * @param context
	 * @return
	 */
    Page<PSWorkflow> searchCurOrgDept(PSWorkflowSearchContext context);
    /**
	 * 查询集合 [DEFAULT]
	 * @param context
	 * @return
	 */
    Page<PSWorkflow> searchDefault(PSWorkflowSearchContext context);

    PSWorkflow convert2PO(cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWorkflow domain , PSWorkflow po) ;

    cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWorkflow convert2Domain( PSWorkflow po ,cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWorkflow domain) ;

}
