package cn.ibizlab.r7.runtime.wf.core.repository ;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

import cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepData;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WFStepDataSearchContext;

/**
 * 实体 [流程步骤信息] 存储对象
 */
public interface WFStepDataRepository extends Repository<WFStepData> {

    /**
	 * 查询集合 [ByBswfdata]
	 * @param context
	 * @return
	 */
    Page<WFStepData> searchByBswfdata(WFStepDataSearchContext context);
    /**
	 * 查询集合 [ByBsdata]
	 * @param context
	 * @return
	 */
    Page<WFStepData> searchByBsdata(WFStepDataSearchContext context);
    /**
	 * 查询集合 [DEFAULT]
	 * @param context
	 * @return
	 */
    Page<WFStepData> searchDefault(WFStepDataSearchContext context);

    WFStepData convert2PO(cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFStepData domain , WFStepData po) ;

    cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFStepData convert2Domain( WFStepData po ,cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFStepData domain) ;

}
