package cn.ibizlab.r7.runtime.wf.core.repository ;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

import cn.ibizlab.r7.runtime.wf.core.repository.po.WFWorklist;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WFWorklistSearchContext;

/**
 * 实体 [工作流工作列表] 存储对象
 */
public interface WFWorklistRepository extends Repository<WFWorklist> {

    /**
	 * 查询集合 [DEFAULT]
	 * @param context
	 * @return
	 */
    Page<WFWorklist> searchDefault(WFWorklistSearchContext context);
    /**
	 * 查询集合 [我的已办查询]
	 * @param context
	 * @return
	 */
    Page<WFWorklist> searchDoneTask(WFWorklistSearchContext context);
    /**
	 * 查询集合 [我的待办查询]
	 * @param context
	 * @return
	 */
    Page<WFWorklist> searchTodoTask(WFWorklistSearchContext context);

    WFWorklist convert2PO(cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFWorklist domain , WFWorklist po) ;

    cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFWorklist convert2Domain( WFWorklist po ,cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFWorklist domain) ;

}
