package cn.ibizlab.r7.runtime.wf.core.repository.po ;

import java.math.BigDecimal;
import java.sql.Timestamp;
import java.math.BigInteger;

import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSWFVersionSearchContext;

/**
 * 实体 [业务流程版本] 存储模型
 */
public interface PSWFVersion{

    /**
     * 建立时间
     */
    Timestamp getCreateDate();

    void setCreateDate(Timestamp createDate);

    /**
     * 获取 [建立时间]脏标记
     */
    boolean getCreateDateDirtyFlag();

    /**
     * 版本
     */
    Integer getVersion();

    void setVersion(Integer version);

    /**
     * 获取 [版本]脏标记
     */
    boolean getVersionDirtyFlag();

    /**
     * 业务流程版本标识
     */
    String getPSWFVersionId();

    void setPSWFVersionId(String pSWFVersionId);

    /**
     * 获取 [业务流程版本标识]脏标记
     */
    boolean getPSWFVersionIdDirtyFlag();

    /**
     * 流程文件名
     */
    String getFileName();

    void setFileName(String fileName);

    /**
     * 获取 [流程文件名]脏标记
     */
    boolean getFileNameDirtyFlag();

    /**
     * 更新人
     */
    String getUpdateMan();

    void setUpdateMan(String updateMan);

    /**
     * 获取 [更新人]脏标记
     */
    boolean getUpdateManDirtyFlag();

    /**
     * 逻辑名称
     */
    String getLogicName();

    void setLogicName(String logicName);

    /**
     * 获取 [逻辑名称]脏标记
     */
    boolean getLogicNameDirtyFlag();

    /**
     * 查看流程页面
     */
    String getViewurl();

    void setViewurl(String viewurl);

    /**
     * 获取 [查看流程页面]脏标记
     */
    boolean getViewurlDirtyFlag();

    /**
     * 启动流程Api
     */
    String getStartApi();

    void setStartApi(String startApi);

    /**
     * 获取 [启动流程Api]脏标记
     */
    boolean getStartApiDirtyFlag();

    /**
     * 版本名称
     */
    String getPSWFVersionName();

    void setPSWFVersionName(String pSWFVersionName);

    /**
     * 获取 [版本名称]脏标记
     */
    boolean getPSWFVersionNameDirtyFlag();

    /**
     * 流程实体
     */
    String getModuleId();

    void setModuleId(String moduleId);

    /**
     * 获取 [流程实体]脏标记
     */
    boolean getModuleIdDirtyFlag();

    /**
     * 流程文件内容
     */
    byte[] getFileContent();

    void setFileContent(byte[] fileContent);

    /**
     * 获取 [流程文件内容]脏标记
     */
    boolean getFileContentDirtyFlag();

    /**
     * 更新时间
     */
    Timestamp getUpdateDate();

    void setUpdateDate(Timestamp updateDate);

    /**
     * 获取 [更新时间]脏标记
     */
    boolean getUpdateDateDirtyFlag();

    /**
     * 启动流程页面
     */
    String getStartUrl();

    void setStartUrl(String startUrl);

    /**
     * 获取 [启动流程页面]脏标记
     */
    boolean getStartUrlDirtyFlag();

    /**
     * 引擎部署标识
     */
    String getWFEngineDeployId();

    void setWFEngineDeployId(String wFEngineDeployId);

    /**
     * 获取 [引擎部署标识]脏标记
     */
    boolean getWFEngineDeployIdDirtyFlag();

    /**
     * 建立人
     */
    String getCreateMan();

    void setCreateMan(String createMan);

    /**
     * 获取 [建立人]脏标记
     */
    boolean getCreateManDirtyFlag();

    /**
     * 部门名称
     */
    String getOrgDeptName();

    void setOrgDeptName(String orgDeptName);

    /**
     * 获取 [部门名称]脏标记
     */
    boolean getOrgDeptNameDirtyFlag();

    /**
     * 组织名称
     */
    String getOrgName();

    void setOrgName(String orgName);

    /**
     * 获取 [组织名称]脏标记
     */
    boolean getOrgNameDirtyFlag();

    /**
     * 业务工作流名称
     */
    String getPSWFWorkflowName();

    void setPSWFWorkflowName(String pSWFWorkflowName);

    /**
     * 获取 [业务工作流名称]脏标记
     */
    boolean getPSWFWorkflowNameDirtyFlag();

    /**
     * 组织标识
     */
    String getOrgId();

    void setOrgId(String orgId);

    /**
     * 获取 [组织标识]脏标记
     */
    boolean getOrgIdDirtyFlag();

    /**
     * 业务工作流标识
     */
    String getPSWorkflowId();

    void setPSWorkflowId(String pSWorkflowId);

    /**
     * 获取 [业务工作流标识]脏标记
     */
    boolean getPSWorkflowIdDirtyFlag();

    /**
     * 工作流应用标识
     */
    String getWFAppId();

    void setWFAppId(String wFAppId);

    /**
     * 获取 [工作流应用标识]脏标记
     */
    boolean getWFAppIdDirtyFlag();

    /**
     * 工作流模式标识
     */
    String getWFModeId();

    void setWFModeId(String wFModeId);

    /**
     * 获取 [工作流模式标识]脏标记
     */
    boolean getWFModeIdDirtyFlag();

    /**
     * 部门标识
     */
    String getOrgDeptId();

    void setOrgDeptId(String orgDeptId);

    /**
     * 获取 [部门标识]脏标记
     */
    boolean getOrgDeptIdDirtyFlag();

}
