package cn.ibizlab.r7.runtime.wf.core.repository.po ;

import java.math.BigDecimal;
import java.sql.Timestamp;
import java.math.BigInteger;

import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WFInstanceSearchContext;

/**
 * 实体 [工作流实例] 存储模型
 */
public interface WFInstance{

    /**
     * 开始时间
     */
    Timestamp getStartTime();

    void setStartTime(Timestamp startTime);

    /**
     * 获取 [开始时间]脏标记
     */
    boolean getStartTimeDirtyFlag();

    /**
     * 业务数据
     */
    String getBsdata();

    void setBsdata(String bsdata);

    /**
     * 获取 [业务数据]脏标记
     */
    boolean getBsdataDirtyFlag();

    /**
     * 父实例标识
     */
    String getParentInstId();

    void setParentInstId(String parentInstId);

    /**
     * 获取 [父实例标识]脏标记
     */
    boolean getParentInstIdDirtyFlag();

    /**
     * 指定用户
     */
    String getWFUserId();

    void setWFUserId(String wFUserId);

    /**
     * 获取 [指定用户]脏标记
     */
    boolean getWFUserIdDirtyFlag();

    /**
     * 代理业务
     */
    String getProxyModuleId();

    void setProxyModuleId(String proxyModuleId);

    /**
     * 获取 [代理业务]脏标记
     */
    boolean getProxyModuleIdDirtyFlag();

    /**
     * 发起人部门
     */
    String getOriginOrgDeptId();

    void setOriginOrgDeptId(String originOrgDeptId);

    /**
     * 获取 [发起人部门]脏标记
     */
    boolean getOriginOrgDeptIdDirtyFlag();

    /**
     * 上一步骤值
     */
    String getPrevStepValue();

    void setPrevStepValue(String prevStepValue);

    /**
     * 获取 [上一步骤值]脏标记
     */
    boolean getPrevStepValueDirtyFlag();

    /**
     * 当前步骤值
     */
    String getCurStepValue();

    void setCurStepValue(String curStepValue);

    /**
     * 获取 [当前步骤值]脏标记
     */
    boolean getCurStepValueDirtyFlag();

    /**
     * 发起人
     */
    String getOriginPersonId();

    void setOriginPersonId(String originPersonId);

    /**
     * 获取 [发起人]脏标记
     */
    boolean getOriginPersonIdDirtyFlag();

    /**
     * 实例类型
     */
    String getInstanceType();

    void setInstanceType(String instanceType);

    /**
     * 获取 [实例类型]脏标记
     */
    boolean getInstanceTypeDirtyFlag();

    /**
     * 建立人
     */
    String getCreateMan();

    void setCreateMan(String createMan);

    /**
     * 获取 [建立人]脏标记
     */
    boolean getCreateManDirtyFlag();

    /**
     * 是否关闭
     */
    Integer getIsclosed();

    void setIsclosed(Integer isclosed);

    /**
     * 获取 [是否关闭]脏标记
     */
    boolean getIsclosedDirtyFlag();

    /**
     * 发起人组织
     */
    String getOriginOrgName();

    void setOriginOrgName(String originOrgName);

    /**
     * 获取 [发起人组织]脏标记
     */
    boolean getOriginOrgNameDirtyFlag();

    /**
     * 流程所有者
     */
    String getOwner();

    void setOwner(String owner);

    /**
     * 获取 [流程所有者]脏标记
     */
    boolean getOwnerDirtyFlag();

    /**
     * 父实例步骤
     */
    String getParentStep();

    void setParentStep(String parentStep);

    /**
     * 获取 [父实例步骤]脏标记
     */
    boolean getParentStepDirtyFlag();

    /**
     * 工作流实例标识
     */
    String getWFInstanceId();

    void setWFInstanceId(String wFInstanceId);

    /**
     * 获取 [工作流实例标识]脏标记
     */
    boolean getWFInstanceIdDirtyFlag();

    /**
     * 流程数据
     */
    String getBswfdata();

    void setBswfdata(String bswfdata);

    /**
     * 获取 [流程数据]脏标记
     */
    boolean getBswfdataDirtyFlag();

    /**
     * 工作流实例名称
     */
    String getWFInstanceName();

    void setWFInstanceName(String wFInstanceName);

    /**
     * 获取 [工作流实例名称]脏标记
     */
    boolean getWFInstanceNameDirtyFlag();

    /**
     * 发起人部门
     */
    String getOriginOrgDeptName();

    void setOriginOrgDeptName(String originOrgDeptName);

    /**
     * 获取 [发起人部门]脏标记
     */
    boolean getOriginOrgDeptNameDirtyFlag();

    /**
     * 结束时间
     */
    Timestamp getEndtime();

    void setEndtime(Timestamp endtime);

    /**
     * 获取 [结束时间]脏标记
     */
    boolean getEndtimeDirtyFlag();

    /**
     * 发起人组织
     */
    String getOriginOrgId();

    void setOriginOrgId(String originOrgId);

    /**
     * 获取 [发起人组织]脏标记
     */
    boolean getOriginOrgIdDirtyFlag();

    /**
     * 工作流引擎实例标识
     */
    String getWFEngineInstanceId();

    void setWFEngineInstanceId(String wFEngineInstanceId);

    /**
     * 获取 [工作流引擎实例标识]脏标记
     */
    boolean getWFEngineInstanceIdDirtyFlag();

    /**
     * 更新人
     */
    String getUpdateMan();

    void setUpdateMan(String updateMan);

    /**
     * 获取 [更新人]脏标记
     */
    boolean getUpdateManDirtyFlag();

    /**
     * 上一步流程处理
     */
    String getPrevProcess();

    void setPrevProcess(String prevProcess);

    /**
     * 获取 [上一步流程处理]脏标记
     */
    boolean getPrevProcessDirtyFlag();

    /**
     * 建立时间
     */
    Timestamp getCreateDate();

    void setCreateDate(Timestamp createDate);

    /**
     * 获取 [建立时间]脏标记
     */
    boolean getCreateDateDirtyFlag();

    /**
     * 发起人
     */
    String getOriginPersonName();

    void setOriginPersonName(String originPersonName);

    /**
     * 获取 [发起人]脏标记
     */
    boolean getOriginPersonNameDirtyFlag();

    /**
     * 流程状态
     */
    String getWFState();

    void setWFState(String wFState);

    /**
     * 获取 [流程状态]脏标记
     */
    boolean getWFStateDirtyFlag();

    /**
     * 上一步骤
     */
    String getPrevstep();

    void setPrevstep(String prevstep);

    /**
     * 获取 [上一步骤]脏标记
     */
    boolean getPrevstepDirtyFlag();

    /**
     * 更新时间
     */
    Timestamp getUpdateDate();

    void setUpdateDate(Timestamp updateDate);

    /**
     * 获取 [更新时间]脏标记
     */
    boolean getUpdateDateDirtyFlag();

    /**
     * 当前流程处理
     */
    String getCurProcess();

    void setCurProcess(String curProcess);

    /**
     * 获取 [当前流程处理]脏标记
     */
    boolean getCurProcessDirtyFlag();

    /**
     * 当前步骤
     */
    String getCurstep();

    void setCurstep(String curstep);

    /**
     * 获取 [当前步骤]脏标记
     */
    boolean getCurstepDirtyFlag();

    /**
     * 逻辑名称
     */
    String getLogicName();

    void setLogicName(String logicName);

    /**
     * 获取 [逻辑名称]脏标记
     */
    boolean getLogicNameDirtyFlag();

    /**
     * 主实例标识
     */
    String getMajorInstId();

    void setMajorInstId(String majorInstId);

    /**
     * 获取 [主实例标识]脏标记
     */
    boolean getMajorInstIdDirtyFlag();

    /**
     * 部门标识
     */
    String getOrgDeptId();

    void setOrgDeptId(String orgDeptId);

    /**
     * 获取 [部门标识]脏标记
     */
    boolean getOrgDeptIdDirtyFlag();

    /**
     * 工作流引擎标识
     */
    String getWFEngineId();

    void setWFEngineId(String wFEngineId);

    /**
     * 获取 [工作流引擎标识]脏标记
     */
    boolean getWFEngineIdDirtyFlag();

    /**
     * 业务工作流标识
     */
    String getPSWorkflowId();

    void setPSWorkflowId(String pSWorkflowId);

    /**
     * 获取 [业务工作流标识]脏标记
     */
    boolean getPSWorkflowIdDirtyFlag();

    /**
     * 组织标识
     */
    String getOrgId();

    void setOrgId(String orgId);

    /**
     * 获取 [组织标识]脏标记
     */
    boolean getOrgIdDirtyFlag();

    /**
     * 业务流程版本标识
     */
    String getPSWFVersionId();

    void setPSWFVersionId(String pSWFVersionId);

    /**
     * 获取 [业务流程版本标识]脏标记
     */
    boolean getPSWFVersionIdDirtyFlag();

}
