package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.stereotype.Repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;

import cn.ibizlab.r7.runtime.wf.core.repository.OrgDeptWFVerRepository;
import cn.ibizlab.r7.runtime.wf.core.repository.po.OrgDeptWFVer;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.OrgDeptWFVerSearchContext;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.mapper.T_ORGDEPTWFVERMapper;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po.T_ORGDEPTWFVERImpl;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.r7.runtime.wf.mybatis.util.helper.QueryBuilder;


/**
 * 关系型数据实体表[T_ORGDEPTWFVER]存储对象
 */
@Repository
@ConditionalOnProperty(prefix = "orgdeptwfver", value="store" , havingValue = "sql", matchIfMissing = true)
public class T_ORGDEPTWFVERRepositoryImpl extends ServiceImpl<T_ORGDEPTWFVERMapper, T_ORGDEPTWFVERImpl> implements OrgDeptWFVerRepository {

    
    /**
     * mybatis条件构造器
     */
    @Autowired
    QueryBuilder queryBuilder;
    /**
     * [T_ORGDEPTWFVER]持久层映射对象
     */
    @Autowired
	T_ORGDEPTWFVERMapper t_ORGDEPTWFVERMapper;

    /**
     * 创建持久层对象
     * @return
     */
    public OrgDeptWFVer createPO(){
        return new T_ORGDEPTWFVERImpl();
    }

    /**
     * 获取数据
     * @param key 业务数据主键
     * @return
     */
    public OrgDeptWFVer get(String key){
        return this.getById(key);
    }

    /**
     * 新建数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean create(OrgDeptWFVer po){
        boolean bOk = this.save((T_ORGDEPTWFVERImpl)po);
        return bOk;
    }

    /**
     * 更新数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean update(OrgDeptWFVer po){
        boolean bOk = this.updateById((T_ORGDEPTWFVERImpl)po);
        return bOk;
    }

    /**
     * 删除数据
     * @param key 业务数据主键
     * @return
     */
    public boolean remove(String key){
        return this.removeById(key);
    }

    /**
     * 查询集合[Default]
     * @param context 查询上下文对象
     * @return
     */
    public Page<OrgDeptWFVer> searchDefault(OrgDeptWFVerSearchContext context){
        QueryWrapper qw=queryBuilder.buildQueryWrapper(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page page=queryBuilder.buildPage(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<OrgDeptWFVer> page_datas=t_ORGDEPTWFVERMapper.searchDefault(page,context,qw);
        List<OrgDeptWFVer> list_datas=queryBuilder.page2List(page_datas);
        return new PageImpl<OrgDeptWFVer>(list_datas, context.getPageable(), page_datas.getTotal());
    }

    /**
     * 查询集合[CurOrgDept]
     * @param context 查询上下文对象
     * @return
     */
    public Page<OrgDeptWFVer> searchCurOrgDept(OrgDeptWFVerSearchContext context){
        QueryWrapper qw=queryBuilder.buildQueryWrapper(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page page=queryBuilder.buildPage(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<OrgDeptWFVer> page_datas=t_ORGDEPTWFVERMapper.searchCurOrgDept(page,context,qw);
        List<OrgDeptWFVer> list_datas=queryBuilder.page2List(page_datas);
        return new PageImpl<OrgDeptWFVer>(list_datas, context.getPageable(), page_datas.getTotal());
    }

    /**
     * 持久层对象转业务对象
     * @param po 持久层对象
     * @param domain 业务对象
     * @return
     */
    public cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.OrgDeptWFVer convert2Domain( OrgDeptWFVer po ,cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.OrgDeptWFVer domain){
        if(po == null)
            return domain ;
        if(domain == null){
            domain = new cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.OrgDeptWFVer();
        }
        //if(po.getCreateDateDirtyFlag())
        domain.setCreateDate(po.getCreateDate());
        //if(po.getUpdateManDirtyFlag())
        domain.setUpdateMan(po.getUpdateMan());
        //if(po.getOrgDeptWFVerNameDirtyFlag())
        domain.setOrgDeptWFVerName(po.getOrgDeptWFVerName());
        //if(po.getOrgDeptWFVerIdDirtyFlag())
        domain.setOrgDeptWFVerId(po.getOrgDeptWFVerId());
        //if(po.getStartTimeDirtyFlag())
        domain.setStartTime(po.getStartTime());
        //if(po.getUpdateDateDirtyFlag())
        domain.setUpdateDate(po.getUpdateDate());
        //if(po.getCreateManDirtyFlag())
        domain.setCreateMan(po.getCreateMan());
        //if(po.getEndtimeDirtyFlag())
        domain.setEndtime(po.getEndtime());
        //if(po.getOrgDeptNameDirtyFlag())
        domain.setOrgDeptName(po.getOrgDeptName());
        //if(po.getPSWFVersionNameDirtyFlag())
        domain.setPSWFVersionName(po.getPSWFVersionName());
        //if(po.getPSWFWorkflowNameDirtyFlag())
        domain.setPSWFWorkflowName(po.getPSWFWorkflowName());
        //if(po.getOrgDeptIdDirtyFlag())
        domain.setOrgDeptId(po.getOrgDeptId());
        //if(po.getPSWorkflowIdDirtyFlag())
        domain.setPSWorkflowId(po.getPSWorkflowId());
        //if(po.getPSWFVersionIdDirtyFlag())
        domain.setPSWFVersionId(po.getPSWFVersionId());
        return domain ;
    }

    /**
     * 业务对象转持久层对象
     * @param domain 业务对象
     * @param po 持久层对象
     * @return
     */
    public OrgDeptWFVer convert2PO(cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.OrgDeptWFVer domain , OrgDeptWFVer po){
        if(domain == null)
            return po ;
        if(po==null){
            po = createPO() ;
        }
        if(domain.getCreateDateDirtyFlag())
            po.setCreateDate(domain.getCreateDate());
        if(domain.getUpdateManDirtyFlag())
            po.setUpdateMan(domain.getUpdateMan());
        if(domain.getOrgDeptWFVerNameDirtyFlag())
            po.setOrgDeptWFVerName(domain.getOrgDeptWFVerName());
        if(domain.getOrgDeptWFVerIdDirtyFlag())
            po.setOrgDeptWFVerId(domain.getOrgDeptWFVerId());
        if(domain.getStartTimeDirtyFlag())
            po.setStartTime(domain.getStartTime());
        if(domain.getUpdateDateDirtyFlag())
            po.setUpdateDate(domain.getUpdateDate());
        if(domain.getCreateManDirtyFlag())
            po.setCreateMan(domain.getCreateMan());
        if(domain.getEndtimeDirtyFlag())
            po.setEndtime(domain.getEndtime());
        if(domain.getOrgDeptNameDirtyFlag())
            po.setOrgDeptName(domain.getOrgDeptName());
        if(domain.getPSWFVersionNameDirtyFlag())
            po.setPSWFVersionName(domain.getPSWFVersionName());
        if(domain.getPSWFWorkflowNameDirtyFlag())
            po.setPSWFWorkflowName(domain.getPSWFWorkflowName());
        if(domain.getOrgDeptIdDirtyFlag())
            po.setOrgDeptId(domain.getOrgDeptId());
        if(domain.getPSWorkflowIdDirtyFlag())
            po.setPSWorkflowId(domain.getPSWorkflowId());
        if(domain.getPSWFVersionIdDirtyFlag())
            po.setPSWFVersionId(domain.getPSWFVersionId());

        return po ;
    }
}
