package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.stereotype.Repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;

import cn.ibizlab.r7.runtime.wf.core.repository.PSDataEntityRepository;
import cn.ibizlab.r7.runtime.wf.core.repository.po.PSDataEntity;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSDataEntitySearchContext;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.mapper.T_PSDATAENTITYMapper;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po.T_PSDATAENTITYImpl;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.r7.runtime.wf.mybatis.util.helper.QueryBuilder;


/**
 * 关系型数据实体表[T_PSDATAENTITY]存储对象
 */
@Repository
@ConditionalOnProperty(prefix = "psdataentity", value="store" , havingValue = "sql", matchIfMissing = true)
public class T_PSDATAENTITYRepositoryImpl extends ServiceImpl<T_PSDATAENTITYMapper, T_PSDATAENTITYImpl> implements PSDataEntityRepository {

    
    /**
     * mybatis条件构造器
     */
    @Autowired
    QueryBuilder queryBuilder;
    /**
     * [T_PSDATAENTITY]持久层映射对象
     */
    @Autowired
	T_PSDATAENTITYMapper t_PSDATAENTITYMapper;

    /**
     * 创建持久层对象
     * @return
     */
    public PSDataEntity createPO(){
        return new T_PSDATAENTITYImpl();
    }

    /**
     * 获取数据
     * @param key 业务数据主键
     * @return
     */
    public PSDataEntity get(String key){
        return this.getById(key);
    }

    /**
     * 新建数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean create(PSDataEntity po){
        boolean bOk = this.save((T_PSDATAENTITYImpl)po);
        return bOk;
    }

    /**
     * 更新数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean update(PSDataEntity po){
        boolean bOk = this.updateById((T_PSDATAENTITYImpl)po);
        return bOk;
    }

    /**
     * 删除数据
     * @param key 业务数据主键
     * @return
     */
    public boolean remove(String key){
        return this.removeById(key);
    }

    /**
     * 查询集合[Default]
     * @param context 查询上下文对象
     * @return
     */
    public Page<PSDataEntity> searchDefault(PSDataEntitySearchContext context){
        QueryWrapper qw=queryBuilder.buildQueryWrapper(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page page=queryBuilder.buildPage(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<PSDataEntity> page_datas=t_PSDATAENTITYMapper.searchDefault(page,context,qw);
        List<PSDataEntity> list_datas=queryBuilder.page2List(page_datas);
        return new PageImpl<PSDataEntity>(list_datas, context.getPageable(), page_datas.getTotal());
    }

    /**
     * 持久层对象转业务对象
     * @param po 持久层对象
     * @param domain 业务对象
     * @return
     */
    public cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSDataEntity convert2Domain( PSDataEntity po ,cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSDataEntity domain){
        if(po == null)
            return domain ;
        if(domain == null){
            domain = new cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSDataEntity();
        }
        //if(po.getUpdateManDirtyFlag())
        domain.setUpdateMan(po.getUpdateMan());
        //if(po.getPSDataEntityNameDirtyFlag())
        domain.setPSDataEntityName(po.getPSDataEntityName());
        //if(po.getPSDataEntityIdDirtyFlag())
        domain.setPSDataEntityId(po.getPSDataEntityId());
        //if(po.getUpdateDateDirtyFlag())
        domain.setUpdateDate(po.getUpdateDate());
        //if(po.getCodenameDirtyFlag())
        domain.setCodename(po.getCodename());
        //if(po.getCreateDateDirtyFlag())
        domain.setCreateDate(po.getCreateDate());
        //if(po.getCreateManDirtyFlag())
        domain.setCreateMan(po.getCreateMan());
        //if(po.getLogicNameDirtyFlag())
        domain.setLogicName(po.getLogicName());
        //if(po.getPSSystemIdDirtyFlag())
        domain.setPSSystemId(po.getPSSystemId());
        return domain ;
    }

    /**
     * 业务对象转持久层对象
     * @param domain 业务对象
     * @param po 持久层对象
     * @return
     */
    public PSDataEntity convert2PO(cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSDataEntity domain , PSDataEntity po){
        if(domain == null)
            return po ;
        if(po==null){
            po = createPO() ;
        }
        if(domain.getUpdateManDirtyFlag())
            po.setUpdateMan(domain.getUpdateMan());
        if(domain.getPSDataEntityNameDirtyFlag())
            po.setPSDataEntityName(domain.getPSDataEntityName());
        if(domain.getPSDataEntityIdDirtyFlag())
            po.setPSDataEntityId(domain.getPSDataEntityId());
        if(domain.getUpdateDateDirtyFlag())
            po.setUpdateDate(domain.getUpdateDate());
        if(domain.getCodenameDirtyFlag())
            po.setCodename(domain.getCodename());
        if(domain.getCreateDateDirtyFlag())
            po.setCreateDate(domain.getCreateDate());
        if(domain.getCreateManDirtyFlag())
            po.setCreateMan(domain.getCreateMan());
        if(domain.getLogicNameDirtyFlag())
            po.setLogicName(domain.getLogicName());
        if(domain.getPSSystemIdDirtyFlag())
            po.setPSSystemId(domain.getPSSystemId());

        return po ;
    }
}
