package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.stereotype.Repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;

import cn.ibizlab.r7.runtime.wf.core.repository.PSDEWFRepository;
import cn.ibizlab.r7.runtime.wf.core.repository.po.PSDEWF;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSDEWFSearchContext;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.mapper.T_PSDEWFMapper;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po.T_PSDEWFImpl;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.r7.runtime.wf.mybatis.util.helper.QueryBuilder;


/**
 * 关系型数据实体表[T_PSDEWF]存储对象
 */
@Repository
@ConditionalOnProperty(prefix = "psdewf", value="store" , havingValue = "sql", matchIfMissing = true)
public class T_PSDEWFRepositoryImpl extends ServiceImpl<T_PSDEWFMapper, T_PSDEWFImpl> implements PSDEWFRepository {

    
    /**
     * mybatis条件构造器
     */
    @Autowired
    QueryBuilder queryBuilder;
    /**
     * [T_PSDEWF]持久层映射对象
     */
    @Autowired
	T_PSDEWFMapper t_PSDEWFMapper;

    /**
     * 创建持久层对象
     * @return
     */
    public PSDEWF createPO(){
        return new T_PSDEWFImpl();
    }

    /**
     * 获取数据
     * @param key 业务数据主键
     * @return
     */
    public PSDEWF get(String key){
        return this.getById(key);
    }

    /**
     * 新建数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean create(PSDEWF po){
        boolean bOk = this.save((T_PSDEWFImpl)po);
        return bOk;
    }

    /**
     * 更新数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean update(PSDEWF po){
        boolean bOk = this.updateById((T_PSDEWFImpl)po);
        return bOk;
    }

    /**
     * 删除数据
     * @param key 业务数据主键
     * @return
     */
    public boolean remove(String key){
        return this.removeById(key);
    }

    /**
     * 查询集合[Default]
     * @param context 查询上下文对象
     * @return
     */
    public Page<PSDEWF> searchDefault(PSDEWFSearchContext context){
        QueryWrapper qw=queryBuilder.buildQueryWrapper(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page page=queryBuilder.buildPage(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<PSDEWF> page_datas=t_PSDEWFMapper.searchDefault(page,context,qw);
        List<PSDEWF> list_datas=queryBuilder.page2List(page_datas);
        return new PageImpl<PSDEWF>(list_datas, context.getPageable(), page_datas.getTotal());
    }

    /**
     * 持久层对象转业务对象
     * @param po 持久层对象
     * @param domain 业务对象
     * @return
     */
    public cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSDEWF convert2Domain( PSDEWF po ,cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSDEWF domain){
        if(po == null)
            return domain ;
        if(domain == null){
            domain = new cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSDEWF();
        }
        //if(po.getErrorvalueDirtyFlag())
        domain.setErrorvalue(po.getErrorvalue());
        //if(po.getLogicNameDirtyFlag())
        domain.setLogicName(po.getLogicName());
        //if(po.getUdstatefieldDirtyFlag())
        domain.setUdstatefield(po.getUdstatefield());
        //if(po.getPSDEWFNameDirtyFlag())
        domain.setPSDEWFName(po.getPSDEWFName());
        //if(po.getWfstepfieldDirtyFlag())
        domain.setWfstepfield(po.getWfstepfield());
        //if(po.getPSDEWFIdDirtyFlag())
        domain.setPSDEWFId(po.getPSDEWFId());
        //if(po.getProcessvalueDirtyFlag())
        domain.setProcessvalue(po.getProcessvalue());
        //if(po.getWFProxyModeDirtyFlag())
        domain.setWFProxyMode(po.getWFProxyMode());
        //if(po.getWfstatefieldDirtyFlag())
        domain.setWfstatefield(po.getWfstatefield());
        //if(po.getCreateManDirtyFlag())
        domain.setCreateMan(po.getCreateMan());
        //if(po.getFinishvalueDirtyFlag())
        domain.setFinishvalue(po.getFinishvalue());
        //if(po.getUpdateDateDirtyFlag())
        domain.setUpdateDate(po.getUpdateDate());
        //if(po.getCreateDateDirtyFlag())
        domain.setCreateDate(po.getCreateDate());
        //if(po.getUpdateManDirtyFlag())
        domain.setUpdateMan(po.getUpdateMan());
        //if(po.getPSDECodeNameDirtyFlag())
        domain.setPSDECodeName(po.getPSDECodeName());
        //if(po.getPSWorkflowIdDirtyFlag())
        domain.setPSWorkflowId(po.getPSWorkflowId());
        //if(po.getPSDataEntityIdDirtyFlag())
        domain.setPSDataEntityId(po.getPSDataEntityId());
        return domain ;
    }

    /**
     * 业务对象转持久层对象
     * @param domain 业务对象
     * @param po 持久层对象
     * @return
     */
    public PSDEWF convert2PO(cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSDEWF domain , PSDEWF po){
        if(domain == null)
            return po ;
        if(po==null){
            po = createPO() ;
        }
        if(domain.getErrorvalueDirtyFlag())
            po.setErrorvalue(domain.getErrorvalue());
        if(domain.getLogicNameDirtyFlag())
            po.setLogicName(domain.getLogicName());
        if(domain.getUdstatefieldDirtyFlag())
            po.setUdstatefield(domain.getUdstatefield());
        if(domain.getPSDEWFNameDirtyFlag())
            po.setPSDEWFName(domain.getPSDEWFName());
        if(domain.getWfstepfieldDirtyFlag())
            po.setWfstepfield(domain.getWfstepfield());
        if(domain.getPSDEWFIdDirtyFlag())
            po.setPSDEWFId(domain.getPSDEWFId());
        if(domain.getProcessvalueDirtyFlag())
            po.setProcessvalue(domain.getProcessvalue());
        if(domain.getWFProxyModeDirtyFlag())
            po.setWFProxyMode(domain.getWFProxyMode());
        if(domain.getWfstatefieldDirtyFlag())
            po.setWfstatefield(domain.getWfstatefield());
        if(domain.getCreateManDirtyFlag())
            po.setCreateMan(domain.getCreateMan());
        if(domain.getFinishvalueDirtyFlag())
            po.setFinishvalue(domain.getFinishvalue());
        if(domain.getUpdateDateDirtyFlag())
            po.setUpdateDate(domain.getUpdateDate());
        if(domain.getCreateDateDirtyFlag())
            po.setCreateDate(domain.getCreateDate());
        if(domain.getUpdateManDirtyFlag())
            po.setUpdateMan(domain.getUpdateMan());
        if(domain.getPSDECodeNameDirtyFlag())
            po.setPSDECodeName(domain.getPSDECodeName());
        if(domain.getPSWorkflowIdDirtyFlag())
            po.setPSWorkflowId(domain.getPSWorkflowId());
        if(domain.getPSDataEntityIdDirtyFlag())
            po.setPSDataEntityId(domain.getPSDataEntityId());

        return po ;
    }
}
