package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.stereotype.Repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;

import cn.ibizlab.r7.runtime.wf.core.repository.PSSysAppRepository;
import cn.ibizlab.r7.runtime.wf.core.repository.po.PSSysApp;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSSysAppSearchContext;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.mapper.T_PSSYSAPPMapper;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po.T_PSSYSAPPImpl;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.r7.runtime.wf.mybatis.util.helper.QueryBuilder;


/**
 * 关系型数据实体表[T_PSSYSAPP]存储对象
 */
@Repository
@ConditionalOnProperty(prefix = "pssysapp", value="store" , havingValue = "sql", matchIfMissing = true)
public class T_PSSYSAPPRepositoryImpl extends ServiceImpl<T_PSSYSAPPMapper, T_PSSYSAPPImpl> implements PSSysAppRepository {

    
    /**
     * mybatis条件构造器
     */
    @Autowired
    QueryBuilder queryBuilder;
    /**
     * [T_PSSYSAPP]持久层映射对象
     */
    @Autowired
	T_PSSYSAPPMapper t_PSSYSAPPMapper;

    /**
     * 创建持久层对象
     * @return
     */
    public PSSysApp createPO(){
        return new T_PSSYSAPPImpl();
    }

    /**
     * 获取数据
     * @param key 业务数据主键
     * @return
     */
    public PSSysApp get(String key){
        return this.getById(key);
    }

    /**
     * 新建数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean create(PSSysApp po){
        boolean bOk = this.save((T_PSSYSAPPImpl)po);
        return bOk;
    }

    /**
     * 更新数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean update(PSSysApp po){
        boolean bOk = this.updateById((T_PSSYSAPPImpl)po);
        return bOk;
    }

    /**
     * 删除数据
     * @param key 业务数据主键
     * @return
     */
    public boolean remove(String key){
        return this.removeById(key);
    }

    /**
     * 查询集合[Default]
     * @param context 查询上下文对象
     * @return
     */
    public Page<PSSysApp> searchDefault(PSSysAppSearchContext context){
        QueryWrapper qw=queryBuilder.buildQueryWrapper(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page page=queryBuilder.buildPage(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<PSSysApp> page_datas=t_PSSYSAPPMapper.searchDefault(page,context,qw);
        List<PSSysApp> list_datas=queryBuilder.page2List(page_datas);
        return new PageImpl<PSSysApp>(list_datas, context.getPageable(), page_datas.getTotal());
    }

    /**
     * 持久层对象转业务对象
     * @param po 持久层对象
     * @param domain 业务对象
     * @return
     */
    public cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSSysApp convert2Domain( PSSysApp po ,cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSSysApp domain){
        if(po == null)
            return domain ;
        if(domain == null){
            domain = new cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSSysApp();
        }
        //if(po.getCreateDateDirtyFlag())
        domain.setCreateDate(po.getCreateDate());
        //if(po.getPSSysAppIdDirtyFlag())
        domain.setPSSysAppId(po.getPSSysAppId());
        //if(po.getUpdateManDirtyFlag())
        domain.setUpdateMan(po.getUpdateMan());
        //if(po.getProxyviewurlDirtyFlag())
        domain.setProxyviewurl(po.getProxyviewurl());
        //if(po.getCreateManDirtyFlag())
        domain.setCreateMan(po.getCreateMan());
        //if(po.getAppUrlDirtyFlag())
        domain.setAppUrl(po.getAppUrl());
        //if(po.getLogicNameDirtyFlag())
        domain.setLogicName(po.getLogicName());
        //if(po.getServiceUrlDirtyFlag())
        domain.setServiceUrl(po.getServiceUrl());
        //if(po.getPSSysAppNameDirtyFlag())
        domain.setPSSysAppName(po.getPSSysAppName());
        //if(po.getServiceIdDirtyFlag())
        domain.setServiceId(po.getServiceId());
        //if(po.getUpdateDateDirtyFlag())
        domain.setUpdateDate(po.getUpdateDate());
        //if(po.getPSSystemIdDirtyFlag())
        domain.setPSSystemId(po.getPSSystemId());
        return domain ;
    }

    /**
     * 业务对象转持久层对象
     * @param domain 业务对象
     * @param po 持久层对象
     * @return
     */
    public PSSysApp convert2PO(cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSSysApp domain , PSSysApp po){
        if(domain == null)
            return po ;
        if(po==null){
            po = createPO() ;
        }
        if(domain.getCreateDateDirtyFlag())
            po.setCreateDate(domain.getCreateDate());
        if(domain.getPSSysAppIdDirtyFlag())
            po.setPSSysAppId(domain.getPSSysAppId());
        if(domain.getUpdateManDirtyFlag())
            po.setUpdateMan(domain.getUpdateMan());
        if(domain.getProxyviewurlDirtyFlag())
            po.setProxyviewurl(domain.getProxyviewurl());
        if(domain.getCreateManDirtyFlag())
            po.setCreateMan(domain.getCreateMan());
        if(domain.getAppUrlDirtyFlag())
            po.setAppUrl(domain.getAppUrl());
        if(domain.getLogicNameDirtyFlag())
            po.setLogicName(domain.getLogicName());
        if(domain.getServiceUrlDirtyFlag())
            po.setServiceUrl(domain.getServiceUrl());
        if(domain.getPSSysAppNameDirtyFlag())
            po.setPSSysAppName(domain.getPSSysAppName());
        if(domain.getServiceIdDirtyFlag())
            po.setServiceId(domain.getServiceId());
        if(domain.getUpdateDateDirtyFlag())
            po.setUpdateDate(domain.getUpdateDate());
        if(domain.getPSSystemIdDirtyFlag())
            po.setPSSystemId(domain.getPSSystemId());

        return po ;
    }
}
