package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.stereotype.Repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;

import cn.ibizlab.r7.runtime.wf.core.repository.PSSystemRepository;
import cn.ibizlab.r7.runtime.wf.core.repository.po.PSSystem;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSSystemSearchContext;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.mapper.T_PSSYSTEMMapper;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po.T_PSSYSTEMImpl;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.r7.runtime.wf.mybatis.util.helper.QueryBuilder;


/**
 * 关系型数据实体表[T_PSSYSTEM]存储对象
 */
@Repository
@ConditionalOnProperty(prefix = "pssystem", value="store" , havingValue = "sql", matchIfMissing = true)
public class T_PSSYSTEMRepositoryImpl extends ServiceImpl<T_PSSYSTEMMapper, T_PSSYSTEMImpl> implements PSSystemRepository {

    
    /**
     * mybatis条件构造器
     */
    @Autowired
    QueryBuilder queryBuilder;
    /**
     * [T_PSSYSTEM]持久层映射对象
     */
    @Autowired
	T_PSSYSTEMMapper t_PSSYSTEMMapper;

    /**
     * 创建持久层对象
     * @return
     */
    public PSSystem createPO(){
        return new T_PSSYSTEMImpl();
    }

    /**
     * 获取数据
     * @param key 业务数据主键
     * @return
     */
    public PSSystem get(String key){
        return this.getById(key);
    }

    /**
     * 新建数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean create(PSSystem po){
        boolean bOk = this.save((T_PSSYSTEMImpl)po);
        return bOk;
    }

    /**
     * 更新数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean update(PSSystem po){
        boolean bOk = this.updateById((T_PSSYSTEMImpl)po);
        return bOk;
    }

    /**
     * 删除数据
     * @param key 业务数据主键
     * @return
     */
    public boolean remove(String key){
        return this.removeById(key);
    }

    /**
     * 查询集合[Default]
     * @param context 查询上下文对象
     * @return
     */
    public Page<PSSystem> searchDefault(PSSystemSearchContext context){
        QueryWrapper qw=queryBuilder.buildQueryWrapper(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page page=queryBuilder.buildPage(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<PSSystem> page_datas=t_PSSYSTEMMapper.searchDefault(page,context,qw);
        List<PSSystem> list_datas=queryBuilder.page2List(page_datas);
        return new PageImpl<PSSystem>(list_datas, context.getPageable(), page_datas.getTotal());
    }

    /**
     * 持久层对象转业务对象
     * @param po 持久层对象
     * @param domain 业务对象
     * @return
     */
    public cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSSystem convert2Domain( PSSystem po ,cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSSystem domain){
        if(po == null)
            return domain ;
        if(domain == null){
            domain = new cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSSystem();
        }
        //if(po.getUpdateDateDirtyFlag())
        domain.setUpdateDate(po.getUpdateDate());
        //if(po.getCreateManDirtyFlag())
        domain.setCreateMan(po.getCreateMan());
        //if(po.getRootpathDirtyFlag())
        domain.setRootpath(po.getRootpath());
        //if(po.getPSSystemIdDirtyFlag())
        domain.setPSSystemId(po.getPSSystemId());
        //if(po.getUpdateManDirtyFlag())
        domain.setUpdateMan(po.getUpdateMan());
        //if(po.getServiceUrlDirtyFlag())
        domain.setServiceUrl(po.getServiceUrl());
        //if(po.getServiceIdDirtyFlag())
        domain.setServiceId(po.getServiceId());
        //if(po.getCreateDateDirtyFlag())
        domain.setCreateDate(po.getCreateDate());
        //if(po.getLogicNameDirtyFlag())
        domain.setLogicName(po.getLogicName());
        //if(po.getPSSystemNameDirtyFlag())
        domain.setPSSystemName(po.getPSSystemName());
        //if(po.getWorkflowNameDirtyFlag())
        domain.setWorkflowName(po.getWorkflowName());
        //if(po.getOrgDeptIdDirtyFlag())
        domain.setOrgDeptId(po.getOrgDeptId());
        //if(po.getWorkflowIdDirtyFlag())
        domain.setWorkflowId(po.getWorkflowId());
        //if(po.getOrgIdDirtyFlag())
        domain.setOrgId(po.getOrgId());
        return domain ;
    }

    /**
     * 业务对象转持久层对象
     * @param domain 业务对象
     * @param po 持久层对象
     * @return
     */
    public PSSystem convert2PO(cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSSystem domain , PSSystem po){
        if(domain == null)
            return po ;
        if(po==null){
            po = createPO() ;
        }
        if(domain.getUpdateDateDirtyFlag())
            po.setUpdateDate(domain.getUpdateDate());
        if(domain.getCreateManDirtyFlag())
            po.setCreateMan(domain.getCreateMan());
        if(domain.getRootpathDirtyFlag())
            po.setRootpath(domain.getRootpath());
        if(domain.getPSSystemIdDirtyFlag())
            po.setPSSystemId(domain.getPSSystemId());
        if(domain.getUpdateManDirtyFlag())
            po.setUpdateMan(domain.getUpdateMan());
        if(domain.getServiceUrlDirtyFlag())
            po.setServiceUrl(domain.getServiceUrl());
        if(domain.getServiceIdDirtyFlag())
            po.setServiceId(domain.getServiceId());
        if(domain.getCreateDateDirtyFlag())
            po.setCreateDate(domain.getCreateDate());
        if(domain.getLogicNameDirtyFlag())
            po.setLogicName(domain.getLogicName());
        if(domain.getPSSystemNameDirtyFlag())
            po.setPSSystemName(domain.getPSSystemName());
        if(domain.getWorkflowNameDirtyFlag())
            po.setWorkflowName(domain.getWorkflowName());
        if(domain.getOrgDeptIdDirtyFlag())
            po.setOrgDeptId(domain.getOrgDeptId());
        if(domain.getWorkflowIdDirtyFlag())
            po.setWorkflowId(domain.getWorkflowId());
        if(domain.getOrgIdDirtyFlag())
            po.setOrgId(domain.getOrgId());

        return po ;
    }
}
