package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.stereotype.Repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;

import cn.ibizlab.r7.runtime.wf.core.repository.PSSysWFCatRepository;
import cn.ibizlab.r7.runtime.wf.core.repository.po.PSSysWFCat;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSSysWFCatSearchContext;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.mapper.T_PSSYSWFCATMapper;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po.T_PSSYSWFCATImpl;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.r7.runtime.wf.mybatis.util.helper.QueryBuilder;


/**
 * 关系型数据实体表[T_PSSYSWFCAT]存储对象
 */
@Repository
@ConditionalOnProperty(prefix = "pssyswfcat", value="store" , havingValue = "sql", matchIfMissing = true)
public class T_PSSYSWFCATRepositoryImpl extends ServiceImpl<T_PSSYSWFCATMapper, T_PSSYSWFCATImpl> implements PSSysWFCatRepository {

    
    /**
     * mybatis条件构造器
     */
    @Autowired
    QueryBuilder queryBuilder;
    /**
     * [T_PSSYSWFCAT]持久层映射对象
     */
    @Autowired
	T_PSSYSWFCATMapper t_PSSYSWFCATMapper;

    /**
     * 创建持久层对象
     * @return
     */
    public PSSysWFCat createPO(){
        return new T_PSSYSWFCATImpl();
    }

    /**
     * 获取数据
     * @param key 业务数据主键
     * @return
     */
    public PSSysWFCat get(String key){
        return this.getById(key);
    }

    /**
     * 新建数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean create(PSSysWFCat po){
        boolean bOk = this.save((T_PSSYSWFCATImpl)po);
        return bOk;
    }

    /**
     * 更新数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean update(PSSysWFCat po){
        boolean bOk = this.updateById((T_PSSYSWFCATImpl)po);
        return bOk;
    }

    /**
     * 删除数据
     * @param key 业务数据主键
     * @return
     */
    public boolean remove(String key){
        return this.removeById(key);
    }

    /**
     * 查询集合[Default]
     * @param context 查询上下文对象
     * @return
     */
    public Page<PSSysWFCat> searchDefault(PSSysWFCatSearchContext context){
        QueryWrapper qw=queryBuilder.buildQueryWrapper(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page page=queryBuilder.buildPage(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<PSSysWFCat> page_datas=t_PSSYSWFCATMapper.searchDefault(page,context,qw);
        List<PSSysWFCat> list_datas=queryBuilder.page2List(page_datas);
        return new PageImpl<PSSysWFCat>(list_datas, context.getPageable(), page_datas.getTotal());
    }

    /**
     * 持久层对象转业务对象
     * @param po 持久层对象
     * @param domain 业务对象
     * @return
     */
    public cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSSysWFCat convert2Domain( PSSysWFCat po ,cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSSysWFCat domain){
        if(po == null)
            return domain ;
        if(domain == null){
            domain = new cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSSysWFCat();
        }
        //if(po.getUpdateDateDirtyFlag())
        domain.setUpdateDate(po.getUpdateDate());
        //if(po.getPSSysWFCatIdDirtyFlag())
        domain.setPSSysWFCatId(po.getPSSysWFCatId());
        //if(po.getPSSysWFCatNameDirtyFlag())
        domain.setPSSysWFCatName(po.getPSSysWFCatName());
        //if(po.getCreateDateDirtyFlag())
        domain.setCreateDate(po.getCreateDate());
        //if(po.getCreateManDirtyFlag())
        domain.setCreateMan(po.getCreateMan());
        //if(po.getUpdateManDirtyFlag())
        domain.setUpdateMan(po.getUpdateMan());
        return domain ;
    }

    /**
     * 业务对象转持久层对象
     * @param domain 业务对象
     * @param po 持久层对象
     * @return
     */
    public PSSysWFCat convert2PO(cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSSysWFCat domain , PSSysWFCat po){
        if(domain == null)
            return po ;
        if(po==null){
            po = createPO() ;
        }
        if(domain.getUpdateDateDirtyFlag())
            po.setUpdateDate(domain.getUpdateDate());
        if(domain.getPSSysWFCatIdDirtyFlag())
            po.setPSSysWFCatId(domain.getPSSysWFCatId());
        if(domain.getPSSysWFCatNameDirtyFlag())
            po.setPSSysWFCatName(domain.getPSSysWFCatName());
        if(domain.getCreateDateDirtyFlag())
            po.setCreateDate(domain.getCreateDate());
        if(domain.getCreateManDirtyFlag())
            po.setCreateMan(domain.getCreateMan());
        if(domain.getUpdateManDirtyFlag())
            po.setUpdateMan(domain.getUpdateMan());

        return po ;
    }
}
