package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.stereotype.Repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;

import cn.ibizlab.r7.runtime.wf.core.repository.PSWFLinkRepository;
import cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFLink;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSWFLinkSearchContext;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.mapper.T_PSWFLINKMapper;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po.T_PSWFLINKImpl;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.r7.runtime.wf.mybatis.util.helper.QueryBuilder;


/**
 * 关系型数据实体表[T_PSWFLINK]存储对象
 */
@Repository
@ConditionalOnProperty(prefix = "pswflink", value="store" , havingValue = "sql", matchIfMissing = true)
public class T_PSWFLINKRepositoryImpl extends ServiceImpl<T_PSWFLINKMapper, T_PSWFLINKImpl> implements PSWFLinkRepository {

    
    /**
     * mybatis条件构造器
     */
    @Autowired
    QueryBuilder queryBuilder;
    /**
     * [T_PSWFLINK]持久层映射对象
     */
    @Autowired
	T_PSWFLINKMapper t_PSWFLINKMapper;

    /**
     * 创建持久层对象
     * @return
     */
    public PSWFLink createPO(){
        return new T_PSWFLINKImpl();
    }

    /**
     * 获取数据
     * @param key 业务数据主键
     * @return
     */
    public PSWFLink get(String key){
        return this.getById(key);
    }

    /**
     * 新建数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean create(PSWFLink po){
        boolean bOk = this.save((T_PSWFLINKImpl)po);
        return bOk;
    }

    /**
     * 更新数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean update(PSWFLink po){
        boolean bOk = this.updateById((T_PSWFLINKImpl)po);
        return bOk;
    }

    /**
     * 删除数据
     * @param key 业务数据主键
     * @return
     */
    public boolean remove(String key){
        return this.removeById(key);
    }

    /**
     * 查询集合[Default]
     * @param context 查询上下文对象
     * @return
     */
    public Page<PSWFLink> searchDefault(PSWFLinkSearchContext context){
        QueryWrapper qw=queryBuilder.buildQueryWrapper(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page page=queryBuilder.buildPage(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<PSWFLink> page_datas=t_PSWFLINKMapper.searchDefault(page,context,qw);
        List<PSWFLink> list_datas=queryBuilder.page2List(page_datas);
        return new PageImpl<PSWFLink>(list_datas, context.getPageable(), page_datas.getTotal());
    }

    /**
     * 持久层对象转业务对象
     * @param po 持久层对象
     * @param domain 业务对象
     * @return
     */
    public cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFLink convert2Domain( PSWFLink po ,cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFLink domain){
        if(po == null)
            return domain ;
        if(domain == null){
            domain = new cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFLink();
        }
        //if(po.getUpdateDateDirtyFlag())
        domain.setUpdateDate(po.getUpdateDate());
        //if(po.getLogicNameDirtyFlag())
        domain.setLogicName(po.getLogicName());
        //if(po.getCreateDateDirtyFlag())
        domain.setCreateDate(po.getCreateDate());
        //if(po.getPSWFLinkIdDirtyFlag())
        domain.setPSWFLinkId(po.getPSWFLinkId());
        //if(po.getUpdateManDirtyFlag())
        domain.setUpdateMan(po.getUpdateMan());
        //if(po.getCreateManDirtyFlag())
        domain.setCreateMan(po.getCreateMan());
        //if(po.getPSWFLinkNameDirtyFlag())
        domain.setPSWFLinkName(po.getPSWFLinkName());
        //if(po.getFrompswfprocidDirtyFlag())
        domain.setFrompswfprocid(po.getFrompswfprocid());
        //if(po.getPSWFVersionIdDirtyFlag())
        domain.setPSWFVersionId(po.getPSWFVersionId());
        //if(po.getTopswfprocidDirtyFlag())
        domain.setTopswfprocid(po.getTopswfprocid());
        return domain ;
    }

    /**
     * 业务对象转持久层对象
     * @param domain 业务对象
     * @param po 持久层对象
     * @return
     */
    public PSWFLink convert2PO(cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFLink domain , PSWFLink po){
        if(domain == null)
            return po ;
        if(po==null){
            po = createPO() ;
        }
        if(domain.getUpdateDateDirtyFlag())
            po.setUpdateDate(domain.getUpdateDate());
        if(domain.getLogicNameDirtyFlag())
            po.setLogicName(domain.getLogicName());
        if(domain.getCreateDateDirtyFlag())
            po.setCreateDate(domain.getCreateDate());
        if(domain.getPSWFLinkIdDirtyFlag())
            po.setPSWFLinkId(domain.getPSWFLinkId());
        if(domain.getUpdateManDirtyFlag())
            po.setUpdateMan(domain.getUpdateMan());
        if(domain.getCreateManDirtyFlag())
            po.setCreateMan(domain.getCreateMan());
        if(domain.getPSWFLinkNameDirtyFlag())
            po.setPSWFLinkName(domain.getPSWFLinkName());
        if(domain.getFrompswfprocidDirtyFlag())
            po.setFrompswfprocid(domain.getFrompswfprocid());
        if(domain.getPSWFVersionIdDirtyFlag())
            po.setPSWFVersionId(domain.getPSWFVersionId());
        if(domain.getTopswfprocidDirtyFlag())
            po.setTopswfprocid(domain.getTopswfprocid());

        return po ;
    }
}
