package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.stereotype.Repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;

import cn.ibizlab.r7.runtime.wf.core.repository.PSWFProcessRepository;
import cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFProcess;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSWFProcessSearchContext;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.mapper.T_PSWFPROCESSMapper;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po.T_PSWFPROCESSImpl;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.r7.runtime.wf.mybatis.util.helper.QueryBuilder;


/**
 * 关系型数据实体表[T_PSWFPROCESS]存储对象
 */
@Repository
@ConditionalOnProperty(prefix = "pswfprocess", value="store" , havingValue = "sql", matchIfMissing = true)
public class T_PSWFPROCESSRepositoryImpl extends ServiceImpl<T_PSWFPROCESSMapper, T_PSWFPROCESSImpl> implements PSWFProcessRepository {

    
    /**
     * mybatis条件构造器
     */
    @Autowired
    QueryBuilder queryBuilder;
    /**
     * [T_PSWFPROCESS]持久层映射对象
     */
    @Autowired
	T_PSWFPROCESSMapper t_PSWFPROCESSMapper;

    /**
     * 创建持久层对象
     * @return
     */
    public PSWFProcess createPO(){
        return new T_PSWFPROCESSImpl();
    }

    /**
     * 获取数据
     * @param key 业务数据主键
     * @return
     */
    public PSWFProcess get(String key){
        return this.getById(key);
    }

    /**
     * 新建数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean create(PSWFProcess po){
        boolean bOk = this.save((T_PSWFPROCESSImpl)po);
        return bOk;
    }

    /**
     * 更新数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean update(PSWFProcess po){
        boolean bOk = this.updateById((T_PSWFPROCESSImpl)po);
        return bOk;
    }

    /**
     * 删除数据
     * @param key 业务数据主键
     * @return
     */
    public boolean remove(String key){
        return this.removeById(key);
    }

    /**
     * 查询集合[Default]
     * @param context 查询上下文对象
     * @return
     */
    public Page<PSWFProcess> searchDefault(PSWFProcessSearchContext context){
        QueryWrapper qw=queryBuilder.buildQueryWrapper(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page page=queryBuilder.buildPage(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<PSWFProcess> page_datas=t_PSWFPROCESSMapper.searchDefault(page,context,qw);
        List<PSWFProcess> list_datas=queryBuilder.page2List(page_datas);
        return new PageImpl<PSWFProcess>(list_datas, context.getPageable(), page_datas.getTotal());
    }

    /**
     * 持久层对象转业务对象
     * @param po 持久层对象
     * @param domain 业务对象
     * @return
     */
    public cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFProcess convert2Domain( PSWFProcess po ,cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFProcess domain){
        if(po == null)
            return domain ;
        if(domain == null){
            domain = new cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFProcess();
        }
        //if(po.getUpdateManDirtyFlag())
        domain.setUpdateMan(po.getUpdateMan());
        //if(po.getCreateManDirtyFlag())
        domain.setCreateMan(po.getCreateMan());
        //if(po.getPreDefinedActionsDirtyFlag())
        domain.setPreDefinedActions(po.getPreDefinedActions());
        //if(po.getWFProcessTypeDirtyFlag())
        domain.setWFProcessType(po.getWFProcessType());
        //if(po.getPSWFProcessNameDirtyFlag())
        domain.setPSWFProcessName(po.getPSWFProcessName());
        //if(po.getPSWFProcessIdDirtyFlag())
        domain.setPSWFProcessId(po.getPSWFProcessId());
        //if(po.getUpdateDateDirtyFlag())
        domain.setUpdateDate(po.getUpdateDate());
        //if(po.getWFStepValueDirtyFlag())
        domain.setWFStepValue(po.getWFStepValue());
        //if(po.getMultiInstModeDirtyFlag())
        domain.setMultiInstMode(po.getMultiInstMode());
        //if(po.getCreateDateDirtyFlag())
        domain.setCreateDate(po.getCreateDate());
        //if(po.getWFStepNameDirtyFlag())
        domain.setWFStepName(po.getWFStepName());
        //if(po.getPSWFVersionNameDirtyFlag())
        domain.setPSWFVersionName(po.getPSWFVersionName());
        //if(po.getTargetpswfidDirtyFlag())
        domain.setTargetpswfid(po.getTargetpswfid());
        //if(po.getPSWFVersionIdDirtyFlag())
        domain.setPSWFVersionId(po.getPSWFVersionId());
        return domain ;
    }

    /**
     * 业务对象转持久层对象
     * @param domain 业务对象
     * @param po 持久层对象
     * @return
     */
    public PSWFProcess convert2PO(cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFProcess domain , PSWFProcess po){
        if(domain == null)
            return po ;
        if(po==null){
            po = createPO() ;
        }
        if(domain.getUpdateManDirtyFlag())
            po.setUpdateMan(domain.getUpdateMan());
        if(domain.getCreateManDirtyFlag())
            po.setCreateMan(domain.getCreateMan());
        if(domain.getPreDefinedActionsDirtyFlag())
            po.setPreDefinedActions(domain.getPreDefinedActions());
        if(domain.getWFProcessTypeDirtyFlag())
            po.setWFProcessType(domain.getWFProcessType());
        if(domain.getPSWFProcessNameDirtyFlag())
            po.setPSWFProcessName(domain.getPSWFProcessName());
        if(domain.getPSWFProcessIdDirtyFlag())
            po.setPSWFProcessId(domain.getPSWFProcessId());
        if(domain.getUpdateDateDirtyFlag())
            po.setUpdateDate(domain.getUpdateDate());
        if(domain.getWFStepValueDirtyFlag())
            po.setWFStepValue(domain.getWFStepValue());
        if(domain.getMultiInstModeDirtyFlag())
            po.setMultiInstMode(domain.getMultiInstMode());
        if(domain.getCreateDateDirtyFlag())
            po.setCreateDate(domain.getCreateDate());
        if(domain.getWFStepNameDirtyFlag())
            po.setWFStepName(domain.getWFStepName());
        if(domain.getPSWFVersionNameDirtyFlag())
            po.setPSWFVersionName(domain.getPSWFVersionName());
        if(domain.getTargetpswfidDirtyFlag())
            po.setTargetpswfid(domain.getTargetpswfid());
        if(domain.getPSWFVersionIdDirtyFlag())
            po.setPSWFVersionId(domain.getPSWFVersionId());

        return po ;
    }
}
