package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.stereotype.Repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;

import cn.ibizlab.r7.runtime.wf.core.repository.PSWFProcRoleRepository;
import cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFProcRole;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSWFProcRoleSearchContext;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.mapper.T_PSWFPROCROLEMapper;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po.T_PSWFPROCROLEImpl;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.r7.runtime.wf.mybatis.util.helper.QueryBuilder;


/**
 * 关系型数据实体表[T_PSWFPROCROLE]存储对象
 */
@Repository
@ConditionalOnProperty(prefix = "pswfprocrole", value="store" , havingValue = "sql", matchIfMissing = true)
public class T_PSWFPROCROLERepositoryImpl extends ServiceImpl<T_PSWFPROCROLEMapper, T_PSWFPROCROLEImpl> implements PSWFProcRoleRepository {

    
    /**
     * mybatis条件构造器
     */
    @Autowired
    QueryBuilder queryBuilder;
    /**
     * [T_PSWFPROCROLE]持久层映射对象
     */
    @Autowired
	T_PSWFPROCROLEMapper t_PSWFPROCROLEMapper;

    /**
     * 创建持久层对象
     * @return
     */
    public PSWFProcRole createPO(){
        return new T_PSWFPROCROLEImpl();
    }

    /**
     * 获取数据
     * @param key 业务数据主键
     * @return
     */
    public PSWFProcRole get(String key){
        return this.getById(key);
    }

    /**
     * 新建数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean create(PSWFProcRole po){
        boolean bOk = this.save((T_PSWFPROCROLEImpl)po);
        return bOk;
    }

    /**
     * 更新数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean update(PSWFProcRole po){
        boolean bOk = this.updateById((T_PSWFPROCROLEImpl)po);
        return bOk;
    }

    /**
     * 删除数据
     * @param key 业务数据主键
     * @return
     */
    public boolean remove(String key){
        return this.removeById(key);
    }

    /**
     * 查询集合[Default]
     * @param context 查询上下文对象
     * @return
     */
    public Page<PSWFProcRole> searchDefault(PSWFProcRoleSearchContext context){
        QueryWrapper qw=queryBuilder.buildQueryWrapper(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page page=queryBuilder.buildPage(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<PSWFProcRole> page_datas=t_PSWFPROCROLEMapper.searchDefault(page,context,qw);
        List<PSWFProcRole> list_datas=queryBuilder.page2List(page_datas);
        return new PageImpl<PSWFProcRole>(list_datas, context.getPageable(), page_datas.getTotal());
    }

    /**
     * 持久层对象转业务对象
     * @param po 持久层对象
     * @param domain 业务对象
     * @return
     */
    public cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFProcRole convert2Domain( PSWFProcRole po ,cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFProcRole domain){
        if(po == null)
            return domain ;
        if(domain == null){
            domain = new cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFProcRole();
        }
        //if(po.getRoleTypeDirtyFlag())
        domain.setRoleType(po.getRoleType());
        //if(po.getCreateDateDirtyFlag())
        domain.setCreateDate(po.getCreateDate());
        //if(po.getUdfieldDirtyFlag())
        domain.setUdfield(po.getUdfield());
        //if(po.getPSWFProcRoleNameDirtyFlag())
        domain.setPSWFProcRoleName(po.getPSWFProcRoleName());
        //if(po.getCreateManDirtyFlag())
        domain.setCreateMan(po.getCreateMan());
        //if(po.getUpdateDateDirtyFlag())
        domain.setUpdateDate(po.getUpdateDate());
        //if(po.getUpdateManDirtyFlag())
        domain.setUpdateMan(po.getUpdateMan());
        //if(po.getPSWFProcRoleIdDirtyFlag())
        domain.setPSWFProcRoleId(po.getPSWFProcRoleId());
        //if(po.getPSWFProcessNameDirtyFlag())
        domain.setPSWFProcessName(po.getPSWFProcessName());
        //if(po.getPSWFProcessIdDirtyFlag())
        domain.setPSWFProcessId(po.getPSWFProcessId());
        //if(po.getPSWFRoleIdDirtyFlag())
        domain.setPSWFRoleId(po.getPSWFRoleId());
        return domain ;
    }

    /**
     * 业务对象转持久层对象
     * @param domain 业务对象
     * @param po 持久层对象
     * @return
     */
    public PSWFProcRole convert2PO(cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFProcRole domain , PSWFProcRole po){
        if(domain == null)
            return po ;
        if(po==null){
            po = createPO() ;
        }
        if(domain.getRoleTypeDirtyFlag())
            po.setRoleType(domain.getRoleType());
        if(domain.getCreateDateDirtyFlag())
            po.setCreateDate(domain.getCreateDate());
        if(domain.getUdfieldDirtyFlag())
            po.setUdfield(domain.getUdfield());
        if(domain.getPSWFProcRoleNameDirtyFlag())
            po.setPSWFProcRoleName(domain.getPSWFProcRoleName());
        if(domain.getCreateManDirtyFlag())
            po.setCreateMan(domain.getCreateMan());
        if(domain.getUpdateDateDirtyFlag())
            po.setUpdateDate(domain.getUpdateDate());
        if(domain.getUpdateManDirtyFlag())
            po.setUpdateMan(domain.getUpdateMan());
        if(domain.getPSWFProcRoleIdDirtyFlag())
            po.setPSWFProcRoleId(domain.getPSWFProcRoleId());
        if(domain.getPSWFProcessNameDirtyFlag())
            po.setPSWFProcessName(domain.getPSWFProcessName());
        if(domain.getPSWFProcessIdDirtyFlag())
            po.setPSWFProcessId(domain.getPSWFProcessId());
        if(domain.getPSWFRoleIdDirtyFlag())
            po.setPSWFRoleId(domain.getPSWFRoleId());

        return po ;
    }
}
