package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.stereotype.Repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;

import cn.ibizlab.r7.runtime.wf.core.repository.PSWFPROCSUBWFRepository;
import cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFPROCSUBWF;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSWFPROCSUBWFSearchContext;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.mapper.T_PSWFPROCSUBWFMapper;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po.T_PSWFPROCSUBWFImpl;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.r7.runtime.wf.mybatis.util.helper.QueryBuilder;


/**
 * 关系型数据实体表[T_PSWFPROCSUBWF]存储对象
 */
@Repository
@ConditionalOnProperty(prefix = "pswfprocsubwf", value="store" , havingValue = "sql", matchIfMissing = true)
public class T_PSWFPROCSUBWFRepositoryImpl extends ServiceImpl<T_PSWFPROCSUBWFMapper, T_PSWFPROCSUBWFImpl> implements PSWFPROCSUBWFRepository {

    
    /**
     * mybatis条件构造器
     */
    @Autowired
    QueryBuilder queryBuilder;
    /**
     * [T_PSWFPROCSUBWF]持久层映射对象
     */
    @Autowired
	T_PSWFPROCSUBWFMapper t_PSWFPROCSUBWFMapper;

    /**
     * 创建持久层对象
     * @return
     */
    public PSWFPROCSUBWF createPO(){
        return new T_PSWFPROCSUBWFImpl();
    }

    /**
     * 获取数据
     * @param key 业务数据主键
     * @return
     */
    public PSWFPROCSUBWF get(String key){
        return this.getById(key);
    }

    /**
     * 新建数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean create(PSWFPROCSUBWF po){
        boolean bOk = this.save((T_PSWFPROCSUBWFImpl)po);
        return bOk;
    }

    /**
     * 更新数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean update(PSWFPROCSUBWF po){
        boolean bOk = this.updateById((T_PSWFPROCSUBWFImpl)po);
        return bOk;
    }

    /**
     * 删除数据
     * @param key 业务数据主键
     * @return
     */
    public boolean remove(String key){
        return this.removeById(key);
    }

    /**
     * 查询集合[Default]
     * @param context 查询上下文对象
     * @return
     */
    public Page<PSWFPROCSUBWF> searchDefault(PSWFPROCSUBWFSearchContext context){
        QueryWrapper qw=queryBuilder.buildQueryWrapper(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page page=queryBuilder.buildPage(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<PSWFPROCSUBWF> page_datas=t_PSWFPROCSUBWFMapper.searchDefault(page,context,qw);
        List<PSWFPROCSUBWF> list_datas=queryBuilder.page2List(page_datas);
        return new PageImpl<PSWFPROCSUBWF>(list_datas, context.getPageable(), page_datas.getTotal());
    }

    /**
     * 持久层对象转业务对象
     * @param po 持久层对象
     * @param domain 业务对象
     * @return
     */
    public cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFPROCSUBWF convert2Domain( PSWFPROCSUBWF po ,cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFPROCSUBWF domain){
        if(po == null)
            return domain ;
        if(domain == null){
            domain = new cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFPROCSUBWF();
        }
        //if(po.getPSWFPROCSUBWFNameDirtyFlag())
        domain.setPSWFPROCSUBWFName(po.getPSWFPROCSUBWFName());
        //if(po.getPSWFPROCSUBWFIdDirtyFlag())
        domain.setPSWFPROCSUBWFId(po.getPSWFPROCSUBWFId());
        //if(po.getUpdateDateDirtyFlag())
        domain.setUpdateDate(po.getUpdateDate());
        //if(po.getUpdateManDirtyFlag())
        domain.setUpdateMan(po.getUpdateMan());
        //if(po.getCreateDateDirtyFlag())
        domain.setCreateDate(po.getCreateDate());
        //if(po.getCreateManDirtyFlag())
        domain.setCreateMan(po.getCreateMan());
        //if(po.getSubwfdedatasetDirtyFlag())
        domain.setSubwfdedataset(po.getSubwfdedataset());
        //if(po.getPSWFVersionIdDirtyFlag())
        domain.setPSWFVersionId(po.getPSWFVersionId());
        //if(po.getSubwfdeidDirtyFlag())
        domain.setSubwfdeid(po.getSubwfdeid());
        //if(po.getPSWFProcessIdDirtyFlag())
        domain.setPSWFProcessId(po.getPSWFProcessId());
        //if(po.getPSWorkflowIdDirtyFlag())
        domain.setPSWorkflowId(po.getPSWorkflowId());
        return domain ;
    }

    /**
     * 业务对象转持久层对象
     * @param domain 业务对象
     * @param po 持久层对象
     * @return
     */
    public PSWFPROCSUBWF convert2PO(cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFPROCSUBWF domain , PSWFPROCSUBWF po){
        if(domain == null)
            return po ;
        if(po==null){
            po = createPO() ;
        }
        if(domain.getPSWFPROCSUBWFNameDirtyFlag())
            po.setPSWFPROCSUBWFName(domain.getPSWFPROCSUBWFName());
        if(domain.getPSWFPROCSUBWFIdDirtyFlag())
            po.setPSWFPROCSUBWFId(domain.getPSWFPROCSUBWFId());
        if(domain.getUpdateDateDirtyFlag())
            po.setUpdateDate(domain.getUpdateDate());
        if(domain.getUpdateManDirtyFlag())
            po.setUpdateMan(domain.getUpdateMan());
        if(domain.getCreateDateDirtyFlag())
            po.setCreateDate(domain.getCreateDate());
        if(domain.getCreateManDirtyFlag())
            po.setCreateMan(domain.getCreateMan());
        if(domain.getSubwfdedatasetDirtyFlag())
            po.setSubwfdedataset(domain.getSubwfdedataset());
        if(domain.getPSWFVersionIdDirtyFlag())
            po.setPSWFVersionId(domain.getPSWFVersionId());
        if(domain.getSubwfdeidDirtyFlag())
            po.setSubwfdeid(domain.getSubwfdeid());
        if(domain.getPSWFProcessIdDirtyFlag())
            po.setPSWFProcessId(domain.getPSWFProcessId());
        if(domain.getPSWorkflowIdDirtyFlag())
            po.setPSWorkflowId(domain.getPSWorkflowId());

        return po ;
    }
}
