package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.stereotype.Repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;

import cn.ibizlab.r7.runtime.wf.core.repository.PSWFRoleDetailRepository;
import cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRoleDetail;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSWFRoleDetailSearchContext;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.mapper.T_PSWFROLEDETAILMapper;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po.T_PSWFROLEDETAILImpl;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.r7.runtime.wf.mybatis.util.helper.QueryBuilder;


/**
 * 关系型数据实体表[T_PSWFROLEDETAIL]存储对象
 */
@Repository
@ConditionalOnProperty(prefix = "pswfroledetail", value="store" , havingValue = "sql", matchIfMissing = true)
public class T_PSWFROLEDETAILRepositoryImpl extends ServiceImpl<T_PSWFROLEDETAILMapper, T_PSWFROLEDETAILImpl> implements PSWFRoleDetailRepository {

    
    /**
     * mybatis条件构造器
     */
    @Autowired
    QueryBuilder queryBuilder;
    /**
     * [T_PSWFROLEDETAIL]持久层映射对象
     */
    @Autowired
	T_PSWFROLEDETAILMapper t_PSWFROLEDETAILMapper;

    /**
     * 创建持久层对象
     * @return
     */
    public PSWFRoleDetail createPO(){
        return new T_PSWFROLEDETAILImpl();
    }

    /**
     * 获取数据
     * @param key 业务数据主键
     * @return
     */
    public PSWFRoleDetail get(String key){
        return this.getById(key);
    }

    /**
     * 新建数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean create(PSWFRoleDetail po){
        boolean bOk = this.save((T_PSWFROLEDETAILImpl)po);
        return bOk;
    }

    /**
     * 更新数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean update(PSWFRoleDetail po){
        boolean bOk = this.updateById((T_PSWFROLEDETAILImpl)po);
        return bOk;
    }

    /**
     * 删除数据
     * @param key 业务数据主键
     * @return
     */
    public boolean remove(String key){
        return this.removeById(key);
    }

    /**
     * 查询集合[Default]
     * @param context 查询上下文对象
     * @return
     */
    public Page<PSWFRoleDetail> searchDefault(PSWFRoleDetailSearchContext context){
        QueryWrapper qw=queryBuilder.buildQueryWrapper(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page page=queryBuilder.buildPage(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<PSWFRoleDetail> page_datas=t_PSWFROLEDETAILMapper.searchDefault(page,context,qw);
        List<PSWFRoleDetail> list_datas=queryBuilder.page2List(page_datas);
        return new PageImpl<PSWFRoleDetail>(list_datas, context.getPageable(), page_datas.getTotal());
    }

    /**
     * 持久层对象转业务对象
     * @param po 持久层对象
     * @param domain 业务对象
     * @return
     */
    public cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFRoleDetail convert2Domain( PSWFRoleDetail po ,cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFRoleDetail domain){
        if(po == null)
            return domain ;
        if(domain == null){
            domain = new cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFRoleDetail();
        }
        //if(po.getUpdateManDirtyFlag())
        domain.setUpdateMan(po.getUpdateMan());
        //if(po.getStartTimeDirtyFlag())
        domain.setStartTime(po.getStartTime());
        //if(po.getCreateManDirtyFlag())
        domain.setCreateMan(po.getCreateMan());
        //if(po.getPSWFRoleDetailIdDirtyFlag())
        domain.setPSWFRoleDetailId(po.getPSWFRoleDetailId());
        //if(po.getPSWFRoleDetailNameDirtyFlag())
        domain.setPSWFRoleDetailName(po.getPSWFRoleDetailName());
        //if(po.getUpdateDateDirtyFlag())
        domain.setUpdateDate(po.getUpdateDate());
        //if(po.getEndtimeDirtyFlag())
        domain.setEndtime(po.getEndtime());
        //if(po.getCreateDateDirtyFlag())
        domain.setCreateDate(po.getCreateDate());
        //if(po.getOrgDeptNameDirtyFlag())
        domain.setOrgDeptName(po.getOrgDeptName());
        //if(po.getOrgUserNameDirtyFlag())
        domain.setOrgUserName(po.getOrgUserName());
        //if(po.getOrgNameDirtyFlag())
        domain.setOrgName(po.getOrgName());
        //if(po.getOrgUserIdDirtyFlag())
        domain.setOrgUserId(po.getOrgUserId());
        //if(po.getOrgIdDirtyFlag())
        domain.setOrgId(po.getOrgId());
        //if(po.getOrgDeptIdDirtyFlag())
        domain.setOrgDeptId(po.getOrgDeptId());
        //if(po.getPSWFRoleIdDirtyFlag())
        domain.setPSWFRoleId(po.getPSWFRoleId());
        return domain ;
    }

    /**
     * 业务对象转持久层对象
     * @param domain 业务对象
     * @param po 持久层对象
     * @return
     */
    public PSWFRoleDetail convert2PO(cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFRoleDetail domain , PSWFRoleDetail po){
        if(domain == null)
            return po ;
        if(po==null){
            po = createPO() ;
        }
        if(domain.getUpdateManDirtyFlag())
            po.setUpdateMan(domain.getUpdateMan());
        if(domain.getStartTimeDirtyFlag())
            po.setStartTime(domain.getStartTime());
        if(domain.getCreateManDirtyFlag())
            po.setCreateMan(domain.getCreateMan());
        if(domain.getPSWFRoleDetailIdDirtyFlag())
            po.setPSWFRoleDetailId(domain.getPSWFRoleDetailId());
        if(domain.getPSWFRoleDetailNameDirtyFlag())
            po.setPSWFRoleDetailName(domain.getPSWFRoleDetailName());
        if(domain.getUpdateDateDirtyFlag())
            po.setUpdateDate(domain.getUpdateDate());
        if(domain.getEndtimeDirtyFlag())
            po.setEndtime(domain.getEndtime());
        if(domain.getCreateDateDirtyFlag())
            po.setCreateDate(domain.getCreateDate());
        if(domain.getOrgDeptNameDirtyFlag())
            po.setOrgDeptName(domain.getOrgDeptName());
        if(domain.getOrgUserNameDirtyFlag())
            po.setOrgUserName(domain.getOrgUserName());
        if(domain.getOrgNameDirtyFlag())
            po.setOrgName(domain.getOrgName());
        if(domain.getOrgUserIdDirtyFlag())
            po.setOrgUserId(domain.getOrgUserId());
        if(domain.getOrgIdDirtyFlag())
            po.setOrgId(domain.getOrgId());
        if(domain.getOrgDeptIdDirtyFlag())
            po.setOrgDeptId(domain.getOrgDeptId());
        if(domain.getPSWFRoleIdDirtyFlag())
            po.setPSWFRoleId(domain.getPSWFRoleId());

        return po ;
    }
}
