package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.stereotype.Repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;

import cn.ibizlab.r7.runtime.wf.core.repository.PSWFRoleRepository;
import cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRole;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSWFRoleSearchContext;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.mapper.T_PSWFROLEMapper;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po.T_PSWFROLEImpl;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.r7.runtime.wf.mybatis.util.helper.QueryBuilder;


/**
 * 关系型数据实体表[T_PSWFROLE]存储对象
 */
@Repository
@ConditionalOnProperty(prefix = "pswfrole", value="store" , havingValue = "sql", matchIfMissing = true)
public class T_PSWFROLERepositoryImpl extends ServiceImpl<T_PSWFROLEMapper, T_PSWFROLEImpl> implements PSWFRoleRepository {

    
    /**
     * mybatis条件构造器
     */
    @Autowired
    QueryBuilder queryBuilder;
    /**
     * [T_PSWFROLE]持久层映射对象
     */
    @Autowired
	T_PSWFROLEMapper t_PSWFROLEMapper;

    /**
     * 创建持久层对象
     * @return
     */
    public PSWFRole createPO(){
        return new T_PSWFROLEImpl();
    }

    /**
     * 获取数据
     * @param key 业务数据主键
     * @return
     */
    public PSWFRole get(String key){
        return this.getById(key);
    }

    /**
     * 新建数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean create(PSWFRole po){
        boolean bOk = this.save((T_PSWFROLEImpl)po);
        return bOk;
    }

    /**
     * 更新数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean update(PSWFRole po){
        boolean bOk = this.updateById((T_PSWFROLEImpl)po);
        return bOk;
    }

    /**
     * 删除数据
     * @param key 业务数据主键
     * @return
     */
    public boolean remove(String key){
        return this.removeById(key);
    }

    /**
     * 查询集合[CurOrg]
     * @param context 查询上下文对象
     * @return
     */
    public Page<PSWFRole> searchCurOrg(PSWFRoleSearchContext context){
        QueryWrapper qw=queryBuilder.buildQueryWrapper(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page page=queryBuilder.buildPage(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<PSWFRole> page_datas=t_PSWFROLEMapper.searchCurOrg(page,context,qw);
        List<PSWFRole> list_datas=queryBuilder.page2List(page_datas);
        return new PageImpl<PSWFRole>(list_datas, context.getPageable(), page_datas.getTotal());
    }

    /**
     * 查询集合[CurOrgDept]
     * @param context 查询上下文对象
     * @return
     */
    public Page<PSWFRole> searchCurOrgDept(PSWFRoleSearchContext context){
        QueryWrapper qw=queryBuilder.buildQueryWrapper(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page page=queryBuilder.buildPage(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<PSWFRole> page_datas=t_PSWFROLEMapper.searchCurOrgDept(page,context,qw);
        List<PSWFRole> list_datas=queryBuilder.page2List(page_datas);
        return new PageImpl<PSWFRole>(list_datas, context.getPageable(), page_datas.getTotal());
    }

    /**
     * 查询集合[Default]
     * @param context 查询上下文对象
     * @return
     */
    public Page<PSWFRole> searchDefault(PSWFRoleSearchContext context){
        QueryWrapper qw=queryBuilder.buildQueryWrapper(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page page=queryBuilder.buildPage(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<PSWFRole> page_datas=t_PSWFROLEMapper.searchDefault(page,context,qw);
        List<PSWFRole> list_datas=queryBuilder.page2List(page_datas);
        return new PageImpl<PSWFRole>(list_datas, context.getPageable(), page_datas.getTotal());
    }

    /**
     * 持久层对象转业务对象
     * @param po 持久层对象
     * @param domain 业务对象
     * @return
     */
    public cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFRole convert2Domain( PSWFRole po ,cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFRole domain){
        if(po == null)
            return domain ;
        if(domain == null){
            domain = new cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFRole();
        }
        //if(po.getRoleData2DirtyFlag())
        domain.setRoleData2(po.getRoleData2());
        //if(po.getRoleDataDirtyFlag())
        domain.setRoleData(po.getRoleData());
        //if(po.getPSWFRoleIdDirtyFlag())
        domain.setPSWFRoleId(po.getPSWFRoleId());
        //if(po.getUpdateDateDirtyFlag())
        domain.setUpdateDate(po.getUpdateDate());
        //if(po.getSystemFlagDirtyFlag())
        domain.setSystemFlag(po.getSystemFlag());
        //if(po.getCreateDateDirtyFlag())
        domain.setCreateDate(po.getCreateDate());
        //if(po.getCreateManDirtyFlag())
        domain.setCreateMan(po.getCreateMan());
        //if(po.getUpdateManDirtyFlag())
        domain.setUpdateMan(po.getUpdateMan());
        //if(po.getPSWFRoleNameDirtyFlag())
        domain.setPSWFRoleName(po.getPSWFRoleName());
        //if(po.getWFRoleTypeDirtyFlag())
        domain.setWFRoleType(po.getWFRoleType());
        //if(po.getOrgDeptNameDirtyFlag())
        domain.setOrgDeptName(po.getOrgDeptName());
        //if(po.getOrgNameDirtyFlag())
        domain.setOrgName(po.getOrgName());
        //if(po.getOrgDeptIdDirtyFlag())
        domain.setOrgDeptId(po.getOrgDeptId());
        //if(po.getOrgIdDirtyFlag())
        domain.setOrgId(po.getOrgId());
        return domain ;
    }

    /**
     * 业务对象转持久层对象
     * @param domain 业务对象
     * @param po 持久层对象
     * @return
     */
    public PSWFRole convert2PO(cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFRole domain , PSWFRole po){
        if(domain == null)
            return po ;
        if(po==null){
            po = createPO() ;
        }
        if(domain.getRoleData2DirtyFlag())
            po.setRoleData2(domain.getRoleData2());
        if(domain.getRoleDataDirtyFlag())
            po.setRoleData(domain.getRoleData());
        if(domain.getPSWFRoleIdDirtyFlag())
            po.setPSWFRoleId(domain.getPSWFRoleId());
        if(domain.getUpdateDateDirtyFlag())
            po.setUpdateDate(domain.getUpdateDate());
        if(domain.getSystemFlagDirtyFlag())
            po.setSystemFlag(domain.getSystemFlag());
        if(domain.getCreateDateDirtyFlag())
            po.setCreateDate(domain.getCreateDate());
        if(domain.getCreateManDirtyFlag())
            po.setCreateMan(domain.getCreateMan());
        if(domain.getUpdateManDirtyFlag())
            po.setUpdateMan(domain.getUpdateMan());
        if(domain.getPSWFRoleNameDirtyFlag())
            po.setPSWFRoleName(domain.getPSWFRoleName());
        if(domain.getWFRoleTypeDirtyFlag())
            po.setWFRoleType(domain.getWFRoleType());
        if(domain.getOrgDeptNameDirtyFlag())
            po.setOrgDeptName(domain.getOrgDeptName());
        if(domain.getOrgNameDirtyFlag())
            po.setOrgName(domain.getOrgName());
        if(domain.getOrgDeptIdDirtyFlag())
            po.setOrgDeptId(domain.getOrgDeptId());
        if(domain.getOrgIdDirtyFlag())
            po.setOrgId(domain.getOrgId());

        return po ;
    }
}
