package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.stereotype.Repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;

import cn.ibizlab.r7.runtime.wf.core.repository.PSWFVersionRepository;
import cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFVersion;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSWFVersionSearchContext;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.mapper.T_PSWFVERSIONMapper;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po.T_PSWFVERSIONImpl;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.r7.runtime.wf.mybatis.util.helper.QueryBuilder;


/**
 * 关系型数据实体表[T_PSWFVERSION]存储对象
 */
@Repository
@ConditionalOnProperty(prefix = "pswfversion", value="store" , havingValue = "sql", matchIfMissing = true)
public class T_PSWFVERSIONRepositoryImpl extends ServiceImpl<T_PSWFVERSIONMapper, T_PSWFVERSIONImpl> implements PSWFVersionRepository {

    
    /**
     * mybatis条件构造器
     */
    @Autowired
    QueryBuilder queryBuilder;
    /**
     * [T_PSWFVERSION]持久层映射对象
     */
    @Autowired
	T_PSWFVERSIONMapper t_PSWFVERSIONMapper;

    /**
     * 创建持久层对象
     * @return
     */
    public PSWFVersion createPO(){
        return new T_PSWFVERSIONImpl();
    }

    /**
     * 获取数据
     * @param key 业务数据主键
     * @return
     */
    public PSWFVersion get(String key){
        return this.getById(key);
    }

    /**
     * 新建数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean create(PSWFVersion po){
        boolean bOk = this.save((T_PSWFVERSIONImpl)po);
        return bOk;
    }

    /**
     * 更新数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean update(PSWFVersion po){
        boolean bOk = this.updateById((T_PSWFVERSIONImpl)po);
        return bOk;
    }

    /**
     * 删除数据
     * @param key 业务数据主键
     * @return
     */
    public boolean remove(String key){
        return this.removeById(key);
    }

    /**
     * 查询集合[Default]
     * @param context 查询上下文对象
     * @return
     */
    public Page<PSWFVersion> searchDefault(PSWFVersionSearchContext context){
        QueryWrapper qw=queryBuilder.buildQueryWrapper(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page page=queryBuilder.buildPage(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<PSWFVersion> page_datas=t_PSWFVERSIONMapper.searchDefault(page,context,qw);
        List<PSWFVersion> list_datas=queryBuilder.page2List(page_datas);
        return new PageImpl<PSWFVersion>(list_datas, context.getPageable(), page_datas.getTotal());
    }

    /**
     * 持久层对象转业务对象
     * @param po 持久层对象
     * @param domain 业务对象
     * @return
     */
    public cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFVersion convert2Domain( PSWFVersion po ,cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFVersion domain){
        if(po == null)
            return domain ;
        if(domain == null){
            domain = new cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFVersion();
        }
        //if(po.getCreateDateDirtyFlag())
        domain.setCreateDate(po.getCreateDate());
        //if(po.getVersionDirtyFlag())
        domain.setVersion(po.getVersion());
        //if(po.getPSWFVersionIdDirtyFlag())
        domain.setPSWFVersionId(po.getPSWFVersionId());
        //if(po.getFileNameDirtyFlag())
        domain.setFileName(po.getFileName());
        //if(po.getUpdateManDirtyFlag())
        domain.setUpdateMan(po.getUpdateMan());
        //if(po.getLogicNameDirtyFlag())
        domain.setLogicName(po.getLogicName());
        //if(po.getViewurlDirtyFlag())
        domain.setViewurl(po.getViewurl());
        //if(po.getStartApiDirtyFlag())
        domain.setStartApi(po.getStartApi());
        //if(po.getPSWFVersionNameDirtyFlag())
        domain.setPSWFVersionName(po.getPSWFVersionName());
        //if(po.getModuleIdDirtyFlag())
        domain.setModuleId(po.getModuleId());
        //if(po.getFileContentDirtyFlag())
        domain.setFileContent(po.getFileContent());
        //if(po.getUpdateDateDirtyFlag())
        domain.setUpdateDate(po.getUpdateDate());
        //if(po.getStartUrlDirtyFlag())
        domain.setStartUrl(po.getStartUrl());
        //if(po.getWFEngineDeployIdDirtyFlag())
        domain.setWFEngineDeployId(po.getWFEngineDeployId());
        //if(po.getCreateManDirtyFlag())
        domain.setCreateMan(po.getCreateMan());
        //if(po.getOrgDeptNameDirtyFlag())
        domain.setOrgDeptName(po.getOrgDeptName());
        //if(po.getOrgNameDirtyFlag())
        domain.setOrgName(po.getOrgName());
        //if(po.getPSWFWorkflowNameDirtyFlag())
        domain.setPSWFWorkflowName(po.getPSWFWorkflowName());
        //if(po.getOrgIdDirtyFlag())
        domain.setOrgId(po.getOrgId());
        //if(po.getPSWorkflowIdDirtyFlag())
        domain.setPSWorkflowId(po.getPSWorkflowId());
        //if(po.getWFAppIdDirtyFlag())
        domain.setWFAppId(po.getWFAppId());
        //if(po.getWFModeIdDirtyFlag())
        domain.setWFModeId(po.getWFModeId());
        //if(po.getOrgDeptIdDirtyFlag())
        domain.setOrgDeptId(po.getOrgDeptId());
        return domain ;
    }

    /**
     * 业务对象转持久层对象
     * @param domain 业务对象
     * @param po 持久层对象
     * @return
     */
    public PSWFVersion convert2PO(cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFVersion domain , PSWFVersion po){
        if(domain == null)
            return po ;
        if(po==null){
            po = createPO() ;
        }
        if(domain.getCreateDateDirtyFlag())
            po.setCreateDate(domain.getCreateDate());
        if(domain.getVersionDirtyFlag())
            po.setVersion(domain.getVersion());
        if(domain.getPSWFVersionIdDirtyFlag())
            po.setPSWFVersionId(domain.getPSWFVersionId());
        if(domain.getFileNameDirtyFlag())
            po.setFileName(domain.getFileName());
        if(domain.getUpdateManDirtyFlag())
            po.setUpdateMan(domain.getUpdateMan());
        if(domain.getLogicNameDirtyFlag())
            po.setLogicName(domain.getLogicName());
        if(domain.getViewurlDirtyFlag())
            po.setViewurl(domain.getViewurl());
        if(domain.getStartApiDirtyFlag())
            po.setStartApi(domain.getStartApi());
        if(domain.getPSWFVersionNameDirtyFlag())
            po.setPSWFVersionName(domain.getPSWFVersionName());
        if(domain.getModuleIdDirtyFlag())
            po.setModuleId(domain.getModuleId());
        if(domain.getFileContentDirtyFlag())
            po.setFileContent(domain.getFileContent());
        if(domain.getUpdateDateDirtyFlag())
            po.setUpdateDate(domain.getUpdateDate());
        if(domain.getStartUrlDirtyFlag())
            po.setStartUrl(domain.getStartUrl());
        if(domain.getWFEngineDeployIdDirtyFlag())
            po.setWFEngineDeployId(domain.getWFEngineDeployId());
        if(domain.getCreateManDirtyFlag())
            po.setCreateMan(domain.getCreateMan());
        if(domain.getOrgDeptNameDirtyFlag())
            po.setOrgDeptName(domain.getOrgDeptName());
        if(domain.getOrgNameDirtyFlag())
            po.setOrgName(domain.getOrgName());
        if(domain.getPSWFWorkflowNameDirtyFlag())
            po.setPSWFWorkflowName(domain.getPSWFWorkflowName());
        if(domain.getOrgIdDirtyFlag())
            po.setOrgId(domain.getOrgId());
        if(domain.getPSWorkflowIdDirtyFlag())
            po.setPSWorkflowId(domain.getPSWorkflowId());
        if(domain.getWFAppIdDirtyFlag())
            po.setWFAppId(domain.getWFAppId());
        if(domain.getWFModeIdDirtyFlag())
            po.setWFModeId(domain.getWFModeId());
        if(domain.getOrgDeptIdDirtyFlag())
            po.setOrgDeptId(domain.getOrgDeptId());

        return po ;
    }
}
