package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.stereotype.Repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;

import cn.ibizlab.r7.runtime.wf.core.repository.PSWorkflowRepository;
import cn.ibizlab.r7.runtime.wf.core.repository.po.PSWorkflow;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSWorkflowSearchContext;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.mapper.T_PSWORKFLOWMapper;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po.T_PSWORKFLOWImpl;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.r7.runtime.wf.mybatis.util.helper.QueryBuilder;


/**
 * 关系型数据实体表[T_PSWORKFLOW]存储对象
 */
@Repository
@ConditionalOnProperty(prefix = "psworkflow", value="store" , havingValue = "sql", matchIfMissing = true)
public class T_PSWORKFLOWRepositoryImpl extends ServiceImpl<T_PSWORKFLOWMapper, T_PSWORKFLOWImpl> implements PSWorkflowRepository {

    
    /**
     * mybatis条件构造器
     */
    @Autowired
    QueryBuilder queryBuilder;
    /**
     * [T_PSWORKFLOW]持久层映射对象
     */
    @Autowired
	T_PSWORKFLOWMapper t_PSWORKFLOWMapper;

    /**
     * 创建持久层对象
     * @return
     */
    public PSWorkflow createPO(){
        return new T_PSWORKFLOWImpl();
    }

    /**
     * 获取数据
     * @param key 业务数据主键
     * @return
     */
    public PSWorkflow get(String key){
        return this.getById(key);
    }

    /**
     * 新建数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean create(PSWorkflow po){
        boolean bOk = this.save((T_PSWORKFLOWImpl)po);
        return bOk;
    }

    /**
     * 更新数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean update(PSWorkflow po){
        boolean bOk = this.updateById((T_PSWORKFLOWImpl)po);
        return bOk;
    }

    /**
     * 删除数据
     * @param key 业务数据主键
     * @return
     */
    public boolean remove(String key){
        return this.removeById(key);
    }

    /**
     * 查询集合[CurOrg]
     * @param context 查询上下文对象
     * @return
     */
    public Page<PSWorkflow> searchCurOrg(PSWorkflowSearchContext context){
        QueryWrapper qw=queryBuilder.buildQueryWrapper(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page page=queryBuilder.buildPage(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<PSWorkflow> page_datas=t_PSWORKFLOWMapper.searchCurOrg(page,context,qw);
        List<PSWorkflow> list_datas=queryBuilder.page2List(page_datas);
        return new PageImpl<PSWorkflow>(list_datas, context.getPageable(), page_datas.getTotal());
    }

    /**
     * 查询集合[CurOrgDept]
     * @param context 查询上下文对象
     * @return
     */
    public Page<PSWorkflow> searchCurOrgDept(PSWorkflowSearchContext context){
        QueryWrapper qw=queryBuilder.buildQueryWrapper(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page page=queryBuilder.buildPage(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<PSWorkflow> page_datas=t_PSWORKFLOWMapper.searchCurOrgDept(page,context,qw);
        List<PSWorkflow> list_datas=queryBuilder.page2List(page_datas);
        return new PageImpl<PSWorkflow>(list_datas, context.getPageable(), page_datas.getTotal());
    }

    /**
     * 查询集合[Default]
     * @param context 查询上下文对象
     * @return
     */
    public Page<PSWorkflow> searchDefault(PSWorkflowSearchContext context){
        QueryWrapper qw=queryBuilder.buildQueryWrapper(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page page=queryBuilder.buildPage(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<PSWorkflow> page_datas=t_PSWORKFLOWMapper.searchDefault(page,context,qw);
        List<PSWorkflow> list_datas=queryBuilder.page2List(page_datas);
        return new PageImpl<PSWorkflow>(list_datas, context.getPageable(), page_datas.getTotal());
    }

    /**
     * 持久层对象转业务对象
     * @param po 持久层对象
     * @param domain 业务对象
     * @return
     */
    public cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWorkflow convert2Domain( PSWorkflow po ,cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWorkflow domain){
        if(po == null)
            return domain ;
        if(domain == null){
            domain = new cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWorkflow();
        }
        //if(po.getWfenginetypeDirtyFlag())
        domain.setWfenginetype(po.getWfenginetype());
        //if(po.getUpdateManDirtyFlag())
        domain.setUpdateMan(po.getUpdateMan());
        //if(po.getCreateDateDirtyFlag())
        domain.setCreateDate(po.getCreateDate());
        //if(po.getWftypeDirtyFlag())
        domain.setWftype(po.getWftype());
        //if(po.getCreateManDirtyFlag())
        domain.setCreateMan(po.getCreateMan());
        //if(po.getPSWorkflowIdDirtyFlag())
        domain.setPSWorkflowId(po.getPSWorkflowId());
        //if(po.getUpdateDateDirtyFlag())
        domain.setUpdateDate(po.getUpdateDate());
        //if(po.getPSWFWorkflowNameDirtyFlag())
        domain.setPSWFWorkflowName(po.getPSWFWorkflowName());
        //if(po.getLogicNameDirtyFlag())
        domain.setLogicName(po.getLogicName());
        //if(po.getOrgDeptNameDirtyFlag())
        domain.setOrgDeptName(po.getOrgDeptName());
        //if(po.getOrgNameDirtyFlag())
        domain.setOrgName(po.getOrgName());
        //if(po.getOrgDeptIdDirtyFlag())
        domain.setOrgDeptId(po.getOrgDeptId());
        //if(po.getOrgIdDirtyFlag())
        domain.setOrgId(po.getOrgId());
        //if(po.getPSSystemIdDirtyFlag())
        domain.setPSSystemId(po.getPSSystemId());
        return domain ;
    }

    /**
     * 业务对象转持久层对象
     * @param domain 业务对象
     * @param po 持久层对象
     * @return
     */
    public PSWorkflow convert2PO(cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWorkflow domain , PSWorkflow po){
        if(domain == null)
            return po ;
        if(po==null){
            po = createPO() ;
        }
        if(domain.getWfenginetypeDirtyFlag())
            po.setWfenginetype(domain.getWfenginetype());
        if(domain.getUpdateManDirtyFlag())
            po.setUpdateMan(domain.getUpdateMan());
        if(domain.getCreateDateDirtyFlag())
            po.setCreateDate(domain.getCreateDate());
        if(domain.getWftypeDirtyFlag())
            po.setWftype(domain.getWftype());
        if(domain.getCreateManDirtyFlag())
            po.setCreateMan(domain.getCreateMan());
        if(domain.getPSWorkflowIdDirtyFlag())
            po.setPSWorkflowId(domain.getPSWorkflowId());
        if(domain.getUpdateDateDirtyFlag())
            po.setUpdateDate(domain.getUpdateDate());
        if(domain.getPSWFWorkflowNameDirtyFlag())
            po.setPSWFWorkflowName(domain.getPSWFWorkflowName());
        if(domain.getLogicNameDirtyFlag())
            po.setLogicName(domain.getLogicName());
        if(domain.getOrgDeptNameDirtyFlag())
            po.setOrgDeptName(domain.getOrgDeptName());
        if(domain.getOrgNameDirtyFlag())
            po.setOrgName(domain.getOrgName());
        if(domain.getOrgDeptIdDirtyFlag())
            po.setOrgDeptId(domain.getOrgDeptId());
        if(domain.getOrgIdDirtyFlag())
            po.setOrgId(domain.getOrgId());
        if(domain.getPSSystemIdDirtyFlag())
            po.setPSSystemId(domain.getPSSystemId());

        return po ;
    }
}
