package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.stereotype.Repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;

import cn.ibizlab.r7.runtime.wf.core.repository.WFAppRepository;
import cn.ibizlab.r7.runtime.wf.core.repository.po.WFApp;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WFAppSearchContext;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.mapper.T_WFAPPMapper;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po.T_WFAPPImpl;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.r7.runtime.wf.mybatis.util.helper.QueryBuilder;


/**
 * 关系型数据实体表[T_WFAPP]存储对象
 */
@Repository
@ConditionalOnProperty(prefix = "wfapp", value="store" , havingValue = "sql", matchIfMissing = true)
public class T_WFAPPRepositoryImpl extends ServiceImpl<T_WFAPPMapper, T_WFAPPImpl> implements WFAppRepository {

    
    /**
     * mybatis条件构造器
     */
    @Autowired
    QueryBuilder queryBuilder;
    /**
     * [T_WFAPP]持久层映射对象
     */
    @Autowired
	T_WFAPPMapper t_WFAPPMapper;

    /**
     * 创建持久层对象
     * @return
     */
    public WFApp createPO(){
        return new T_WFAPPImpl();
    }

    /**
     * 获取数据
     * @param key 业务数据主键
     * @return
     */
    public WFApp get(String key){
        return this.getById(key);
    }

    /**
     * 新建数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean create(WFApp po){
        boolean bOk = this.save((T_WFAPPImpl)po);
        return bOk;
    }

    /**
     * 更新数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean update(WFApp po){
        boolean bOk = this.updateById((T_WFAPPImpl)po);
        return bOk;
    }

    /**
     * 删除数据
     * @param key 业务数据主键
     * @return
     */
    public boolean remove(String key){
        return this.removeById(key);
    }

    /**
     * 查询集合[Default]
     * @param context 查询上下文对象
     * @return
     */
    public Page<WFApp> searchDefault(WFAppSearchContext context){
        QueryWrapper qw=queryBuilder.buildQueryWrapper(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page page=queryBuilder.buildPage(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<WFApp> page_datas=t_WFAPPMapper.searchDefault(page,context,qw);
        List<WFApp> list_datas=queryBuilder.page2List(page_datas);
        return new PageImpl<WFApp>(list_datas, context.getPageable(), page_datas.getTotal());
    }

    /**
     * 持久层对象转业务对象
     * @param po 持久层对象
     * @param domain 业务对象
     * @return
     */
    public cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFApp convert2Domain( WFApp po ,cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFApp domain){
        if(po == null)
            return domain ;
        if(domain == null){
            domain = new cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFApp();
        }
        //if(po.getCreateManDirtyFlag())
        domain.setCreateMan(po.getCreateMan());
        //if(po.getWFAppNameDirtyFlag())
        domain.setWFAppName(po.getWFAppName());
        //if(po.getCreateDateDirtyFlag())
        domain.setCreateDate(po.getCreateDate());
        //if(po.getServiceIdDirtyFlag())
        domain.setServiceId(po.getServiceId());
        //if(po.getServiceUrlDirtyFlag())
        domain.setServiceUrl(po.getServiceUrl());
        //if(po.getUpdateDateDirtyFlag())
        domain.setUpdateDate(po.getUpdateDate());
        //if(po.getUpdateManDirtyFlag())
        domain.setUpdateMan(po.getUpdateMan());
        //if(po.getLogicNameDirtyFlag())
        domain.setLogicName(po.getLogicName());
        //if(po.getAppUrlDirtyFlag())
        domain.setAppUrl(po.getAppUrl());
        //if(po.getWFAppIdDirtyFlag())
        domain.setWFAppId(po.getWFAppId());
        //if(po.getPSSystemIdDirtyFlag())
        domain.setPSSystemId(po.getPSSystemId());
        return domain ;
    }

    /**
     * 业务对象转持久层对象
     * @param domain 业务对象
     * @param po 持久层对象
     * @return
     */
    public WFApp convert2PO(cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFApp domain , WFApp po){
        if(domain == null)
            return po ;
        if(po==null){
            po = createPO() ;
        }
        if(domain.getCreateManDirtyFlag())
            po.setCreateMan(domain.getCreateMan());
        if(domain.getWFAppNameDirtyFlag())
            po.setWFAppName(domain.getWFAppName());
        if(domain.getCreateDateDirtyFlag())
            po.setCreateDate(domain.getCreateDate());
        if(domain.getServiceIdDirtyFlag())
            po.setServiceId(domain.getServiceId());
        if(domain.getServiceUrlDirtyFlag())
            po.setServiceUrl(domain.getServiceUrl());
        if(domain.getUpdateDateDirtyFlag())
            po.setUpdateDate(domain.getUpdateDate());
        if(domain.getUpdateManDirtyFlag())
            po.setUpdateMan(domain.getUpdateMan());
        if(domain.getLogicNameDirtyFlag())
            po.setLogicName(domain.getLogicName());
        if(domain.getAppUrlDirtyFlag())
            po.setAppUrl(domain.getAppUrl());
        if(domain.getWFAppIdDirtyFlag())
            po.setWFAppId(domain.getWFAppId());
        if(domain.getPSSystemIdDirtyFlag())
            po.setPSSystemId(domain.getPSSystemId());

        return po ;
    }
}
