package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.stereotype.Repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;

import cn.ibizlab.r7.runtime.wf.core.repository.WFEngineRepository;
import cn.ibizlab.r7.runtime.wf.core.repository.po.WFEngine;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WFEngineSearchContext;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.mapper.T_WFENGINEMapper;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po.T_WFENGINEImpl;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.r7.runtime.wf.mybatis.util.helper.QueryBuilder;


/**
 * 关系型数据实体表[T_WFENGINE]存储对象
 */
@Repository
@ConditionalOnProperty(prefix = "wfengine", value="store" , havingValue = "sql", matchIfMissing = true)
public class T_WFENGINERepositoryImpl extends ServiceImpl<T_WFENGINEMapper, T_WFENGINEImpl> implements WFEngineRepository {

    
    /**
     * mybatis条件构造器
     */
    @Autowired
    QueryBuilder queryBuilder;
    /**
     * [T_WFENGINE]持久层映射对象
     */
    @Autowired
	T_WFENGINEMapper t_WFENGINEMapper;

    /**
     * 创建持久层对象
     * @return
     */
    public WFEngine createPO(){
        return new T_WFENGINEImpl();
    }

    /**
     * 获取数据
     * @param key 业务数据主键
     * @return
     */
    public WFEngine get(String key){
        return this.getById(key);
    }

    /**
     * 新建数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean create(WFEngine po){
        boolean bOk = this.save((T_WFENGINEImpl)po);
        return bOk;
    }

    /**
     * 更新数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean update(WFEngine po){
        boolean bOk = this.updateById((T_WFENGINEImpl)po);
        return bOk;
    }

    /**
     * 删除数据
     * @param key 业务数据主键
     * @return
     */
    public boolean remove(String key){
        return this.removeById(key);
    }

    /**
     * 查询集合[Default]
     * @param context 查询上下文对象
     * @return
     */
    public Page<WFEngine> searchDefault(WFEngineSearchContext context){
        QueryWrapper qw=queryBuilder.buildQueryWrapper(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page page=queryBuilder.buildPage(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<WFEngine> page_datas=t_WFENGINEMapper.searchDefault(page,context,qw);
        List<WFEngine> list_datas=queryBuilder.page2List(page_datas);
        return new PageImpl<WFEngine>(list_datas, context.getPageable(), page_datas.getTotal());
    }

    /**
     * 持久层对象转业务对象
     * @param po 持久层对象
     * @param domain 业务对象
     * @return
     */
    public cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFEngine convert2Domain( WFEngine po ,cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFEngine domain){
        if(po == null)
            return domain ;
        if(domain == null){
            domain = new cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFEngine();
        }
        //if(po.getUpdateDateDirtyFlag())
        domain.setUpdateDate(po.getUpdateDate());
        //if(po.getWFEngineNameDirtyFlag())
        domain.setWFEngineName(po.getWFEngineName());
        //if(po.getWFEngineIdDirtyFlag())
        domain.setWFEngineId(po.getWFEngineId());
        //if(po.getCreateDateDirtyFlag())
        domain.setCreateDate(po.getCreateDate());
        //if(po.getCreateManDirtyFlag())
        domain.setCreateMan(po.getCreateMan());
        //if(po.getUpdateManDirtyFlag())
        domain.setUpdateMan(po.getUpdateMan());
        //if(po.getLogicNameDirtyFlag())
        domain.setLogicName(po.getLogicName());
        //if(po.getEnginetypeDirtyFlag())
        domain.setEnginetype(po.getEnginetype());
        //if(po.getWorkflowIdDirtyFlag())
        domain.setWorkflowId(po.getWorkflowId());
        return domain ;
    }

    /**
     * 业务对象转持久层对象
     * @param domain 业务对象
     * @param po 持久层对象
     * @return
     */
    public WFEngine convert2PO(cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFEngine domain , WFEngine po){
        if(domain == null)
            return po ;
        if(po==null){
            po = createPO() ;
        }
        if(domain.getUpdateDateDirtyFlag())
            po.setUpdateDate(domain.getUpdateDate());
        if(domain.getWFEngineNameDirtyFlag())
            po.setWFEngineName(domain.getWFEngineName());
        if(domain.getWFEngineIdDirtyFlag())
            po.setWFEngineId(domain.getWFEngineId());
        if(domain.getCreateDateDirtyFlag())
            po.setCreateDate(domain.getCreateDate());
        if(domain.getCreateManDirtyFlag())
            po.setCreateMan(domain.getCreateMan());
        if(domain.getUpdateManDirtyFlag())
            po.setUpdateMan(domain.getUpdateMan());
        if(domain.getLogicNameDirtyFlag())
            po.setLogicName(domain.getLogicName());
        if(domain.getEnginetypeDirtyFlag())
            po.setEnginetype(domain.getEnginetype());
        if(domain.getWorkflowIdDirtyFlag())
            po.setWorkflowId(domain.getWorkflowId());

        return po ;
    }
}
