package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.stereotype.Repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;

import cn.ibizlab.r7.runtime.wf.core.repository.WFIAActionRepository;
import cn.ibizlab.r7.runtime.wf.core.repository.po.WFIAAction;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WFIAActionSearchContext;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.mapper.T_WFIAACTIONMapper;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po.T_WFIAACTIONImpl;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.r7.runtime.wf.mybatis.util.helper.QueryBuilder;


/**
 * 关系型数据实体表[T_WFIAACTION]存储对象
 */
@Repository
@ConditionalOnProperty(prefix = "wfiaaction", value="store" , havingValue = "sql", matchIfMissing = true)
public class T_WFIAACTIONRepositoryImpl extends ServiceImpl<T_WFIAACTIONMapper, T_WFIAACTIONImpl> implements WFIAActionRepository {

    
    /**
     * mybatis条件构造器
     */
    @Autowired
    QueryBuilder queryBuilder;
    /**
     * [T_WFIAACTION]持久层映射对象
     */
    @Autowired
	T_WFIAACTIONMapper t_WFIAACTIONMapper;

    /**
     * 创建持久层对象
     * @return
     */
    public WFIAAction createPO(){
        return new T_WFIAACTIONImpl();
    }

    /**
     * 获取数据
     * @param key 业务数据主键
     * @return
     */
    public WFIAAction get(String key){
        return this.getById(key);
    }

    /**
     * 新建数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean create(WFIAAction po){
        boolean bOk = this.save((T_WFIAACTIONImpl)po);
        return bOk;
    }

    /**
     * 更新数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean update(WFIAAction po){
        boolean bOk = this.updateById((T_WFIAACTIONImpl)po);
        return bOk;
    }

    /**
     * 删除数据
     * @param key 业务数据主键
     * @return
     */
    public boolean remove(String key){
        return this.removeById(key);
    }

    /**
     * 查询集合[Default]
     * @param context 查询上下文对象
     * @return
     */
    public Page<WFIAAction> searchDefault(WFIAActionSearchContext context){
        QueryWrapper qw=queryBuilder.buildQueryWrapper(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page page=queryBuilder.buildPage(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<WFIAAction> page_datas=t_WFIAACTIONMapper.searchDefault(page,context,qw);
        List<WFIAAction> list_datas=queryBuilder.page2List(page_datas);
        return new PageImpl<WFIAAction>(list_datas, context.getPageable(), page_datas.getTotal());
    }

    /**
     * 持久层对象转业务对象
     * @param po 持久层对象
     * @param domain 业务对象
     * @return
     */
    public cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFIAAction convert2Domain( WFIAAction po ,cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFIAAction domain){
        if(po == null)
            return domain ;
        if(domain == null){
            domain = new cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFIAAction();
        }
        //if(po.getPersonListDirtyFlag())
        domain.setPersonList(po.getPersonList());
        //if(po.getOpPersonDirtyFlag())
        domain.setOpPerson(po.getOpPerson());
        //if(po.getUserData2DirtyFlag())
        domain.setUserData2(po.getUserData2());
        //if(po.getActionTypeDirtyFlag())
        domain.setActionType(po.getActionType());
        //if(po.getUserDataDirtyFlag())
        domain.setUserData(po.getUserData());
        //if(po.getUpdateManDirtyFlag())
        domain.setUpdateMan(po.getUpdateMan());
        //if(po.getOpinionDirtyFlag())
        domain.setOpinion(po.getOpinion());
        //if(po.getCreateDateDirtyFlag())
        domain.setCreateDate(po.getCreateDate());
        //if(po.getWFIAActionIdDirtyFlag())
        domain.setWFIAActionId(po.getWFIAActionId());
        //if(po.getWFInstanceIdDirtyFlag())
        domain.setWFInstanceId(po.getWFInstanceId());
        //if(po.getUpdateDateDirtyFlag())
        domain.setUpdateDate(po.getUpdateDate());
        //if(po.getCreateManDirtyFlag())
        domain.setCreateMan(po.getCreateMan());
        //if(po.getLogicNameDirtyFlag())
        domain.setLogicName(po.getLogicName());
        //if(po.getWFIAActionNameDirtyFlag())
        domain.setWFIAActionName(po.getWFIAActionName());
        //if(po.getWFStepIdDirtyFlag())
        domain.setWFStepId(po.getWFStepId());
        return domain ;
    }

    /**
     * 业务对象转持久层对象
     * @param domain 业务对象
     * @param po 持久层对象
     * @return
     */
    public WFIAAction convert2PO(cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFIAAction domain , WFIAAction po){
        if(domain == null)
            return po ;
        if(po==null){
            po = createPO() ;
        }
        if(domain.getPersonListDirtyFlag())
            po.setPersonList(domain.getPersonList());
        if(domain.getOpPersonDirtyFlag())
            po.setOpPerson(domain.getOpPerson());
        if(domain.getUserData2DirtyFlag())
            po.setUserData2(domain.getUserData2());
        if(domain.getActionTypeDirtyFlag())
            po.setActionType(domain.getActionType());
        if(domain.getUserDataDirtyFlag())
            po.setUserData(domain.getUserData());
        if(domain.getUpdateManDirtyFlag())
            po.setUpdateMan(domain.getUpdateMan());
        if(domain.getOpinionDirtyFlag())
            po.setOpinion(domain.getOpinion());
        if(domain.getCreateDateDirtyFlag())
            po.setCreateDate(domain.getCreateDate());
        if(domain.getWFIAActionIdDirtyFlag())
            po.setWFIAActionId(domain.getWFIAActionId());
        if(domain.getWFInstanceIdDirtyFlag())
            po.setWFInstanceId(domain.getWFInstanceId());
        if(domain.getUpdateDateDirtyFlag())
            po.setUpdateDate(domain.getUpdateDate());
        if(domain.getCreateManDirtyFlag())
            po.setCreateMan(domain.getCreateMan());
        if(domain.getLogicNameDirtyFlag())
            po.setLogicName(domain.getLogicName());
        if(domain.getWFIAActionNameDirtyFlag())
            po.setWFIAActionName(domain.getWFIAActionName());
        if(domain.getWFStepIdDirtyFlag())
            po.setWFStepId(domain.getWFStepId());

        return po ;
    }
}
