package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.stereotype.Repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;

import cn.ibizlab.r7.runtime.wf.core.repository.WFInstanceRepository;
import cn.ibizlab.r7.runtime.wf.core.repository.po.WFInstance;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WFInstanceSearchContext;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.mapper.T_WFINSTANCEMapper;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po.T_WFINSTANCEImpl;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.r7.runtime.wf.mybatis.util.helper.QueryBuilder;


/**
 * 关系型数据实体表[T_WFINSTANCE]存储对象
 */
@Repository
@ConditionalOnProperty(prefix = "wfinstance", value="store" , havingValue = "sql", matchIfMissing = true)
public class T_WFINSTANCERepositoryImpl extends ServiceImpl<T_WFINSTANCEMapper, T_WFINSTANCEImpl> implements WFInstanceRepository {

    
    /**
     * mybatis条件构造器
     */
    @Autowired
    QueryBuilder queryBuilder;
    /**
     * [T_WFINSTANCE]持久层映射对象
     */
    @Autowired
	T_WFINSTANCEMapper t_WFINSTANCEMapper;

    /**
     * 创建持久层对象
     * @return
     */
    public WFInstance createPO(){
        return new T_WFINSTANCEImpl();
    }

    /**
     * 获取数据
     * @param key 业务数据主键
     * @return
     */
    public WFInstance get(String key){
        return this.getById(key);
    }

    /**
     * 新建数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean create(WFInstance po){
        boolean bOk = this.save((T_WFINSTANCEImpl)po);
        return bOk;
    }

    /**
     * 更新数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean update(WFInstance po){
        boolean bOk = this.updateById((T_WFINSTANCEImpl)po);
        return bOk;
    }

    /**
     * 删除数据
     * @param key 业务数据主键
     * @return
     */
    public boolean remove(String key){
        return this.removeById(key);
    }

    /**
     * 查询集合[Default]
     * @param context 查询上下文对象
     * @return
     */
    public Page<WFInstance> searchDefault(WFInstanceSearchContext context){
        QueryWrapper qw=queryBuilder.buildQueryWrapper(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page page=queryBuilder.buildPage(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<WFInstance> page_datas=t_WFINSTANCEMapper.searchDefault(page,context,qw);
        List<WFInstance> list_datas=queryBuilder.page2List(page_datas);
        return new PageImpl<WFInstance>(list_datas, context.getPageable(), page_datas.getTotal());
    }

    /**
     * 持久层对象转业务对象
     * @param po 持久层对象
     * @param domain 业务对象
     * @return
     */
    public cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFInstance convert2Domain( WFInstance po ,cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFInstance domain){
        if(po == null)
            return domain ;
        if(domain == null){
            domain = new cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFInstance();
        }
        //if(po.getStartTimeDirtyFlag())
        domain.setStartTime(po.getStartTime());
        //if(po.getBsdataDirtyFlag())
        domain.setBsdata(po.getBsdata());
        //if(po.getParentInstIdDirtyFlag())
        domain.setParentInstId(po.getParentInstId());
        //if(po.getWFUserIdDirtyFlag())
        domain.setWFUserId(po.getWFUserId());
        //if(po.getProxyModuleIdDirtyFlag())
        domain.setProxyModuleId(po.getProxyModuleId());
        //if(po.getOriginOrgDeptIdDirtyFlag())
        domain.setOriginOrgDeptId(po.getOriginOrgDeptId());
        //if(po.getPrevStepValueDirtyFlag())
        domain.setPrevStepValue(po.getPrevStepValue());
        //if(po.getCurStepValueDirtyFlag())
        domain.setCurStepValue(po.getCurStepValue());
        //if(po.getOriginPersonIdDirtyFlag())
        domain.setOriginPersonId(po.getOriginPersonId());
        //if(po.getInstanceTypeDirtyFlag())
        domain.setInstanceType(po.getInstanceType());
        //if(po.getCreateManDirtyFlag())
        domain.setCreateMan(po.getCreateMan());
        //if(po.getIsclosedDirtyFlag())
        domain.setIsclosed(po.getIsclosed());
        //if(po.getOriginOrgNameDirtyFlag())
        domain.setOriginOrgName(po.getOriginOrgName());
        //if(po.getOwnerDirtyFlag())
        domain.setOwner(po.getOwner());
        //if(po.getParentStepDirtyFlag())
        domain.setParentStep(po.getParentStep());
        //if(po.getWFInstanceIdDirtyFlag())
        domain.setWFInstanceId(po.getWFInstanceId());
        //if(po.getBswfdataDirtyFlag())
        domain.setBswfdata(po.getBswfdata());
        //if(po.getWFInstanceNameDirtyFlag())
        domain.setWFInstanceName(po.getWFInstanceName());
        //if(po.getOriginOrgDeptNameDirtyFlag())
        domain.setOriginOrgDeptName(po.getOriginOrgDeptName());
        //if(po.getEndtimeDirtyFlag())
        domain.setEndtime(po.getEndtime());
        //if(po.getOriginOrgIdDirtyFlag())
        domain.setOriginOrgId(po.getOriginOrgId());
        //if(po.getWFEngineInstanceIdDirtyFlag())
        domain.setWFEngineInstanceId(po.getWFEngineInstanceId());
        //if(po.getUpdateManDirtyFlag())
        domain.setUpdateMan(po.getUpdateMan());
        //if(po.getPrevProcessDirtyFlag())
        domain.setPrevProcess(po.getPrevProcess());
        //if(po.getCreateDateDirtyFlag())
        domain.setCreateDate(po.getCreateDate());
        //if(po.getOriginPersonNameDirtyFlag())
        domain.setOriginPersonName(po.getOriginPersonName());
        //if(po.getWFStateDirtyFlag())
        domain.setWFState(po.getWFState());
        //if(po.getPrevstepDirtyFlag())
        domain.setPrevstep(po.getPrevstep());
        //if(po.getUpdateDateDirtyFlag())
        domain.setUpdateDate(po.getUpdateDate());
        //if(po.getCurProcessDirtyFlag())
        domain.setCurProcess(po.getCurProcess());
        //if(po.getCurstepDirtyFlag())
        domain.setCurstep(po.getCurstep());
        //if(po.getLogicNameDirtyFlag())
        domain.setLogicName(po.getLogicName());
        //if(po.getMajorInstIdDirtyFlag())
        domain.setMajorInstId(po.getMajorInstId());
        //if(po.getOrgDeptIdDirtyFlag())
        domain.setOrgDeptId(po.getOrgDeptId());
        //if(po.getWFEngineIdDirtyFlag())
        domain.setWFEngineId(po.getWFEngineId());
        //if(po.getPSWorkflowIdDirtyFlag())
        domain.setPSWorkflowId(po.getPSWorkflowId());
        //if(po.getOrgIdDirtyFlag())
        domain.setOrgId(po.getOrgId());
        //if(po.getPSWFVersionIdDirtyFlag())
        domain.setPSWFVersionId(po.getPSWFVersionId());
        return domain ;
    }

    /**
     * 业务对象转持久层对象
     * @param domain 业务对象
     * @param po 持久层对象
     * @return
     */
    public WFInstance convert2PO(cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFInstance domain , WFInstance po){
        if(domain == null)
            return po ;
        if(po==null){
            po = createPO() ;
        }
        if(domain.getStartTimeDirtyFlag())
            po.setStartTime(domain.getStartTime());
        if(domain.getBsdataDirtyFlag())
            po.setBsdata(domain.getBsdata());
        if(domain.getParentInstIdDirtyFlag())
            po.setParentInstId(domain.getParentInstId());
        if(domain.getWFUserIdDirtyFlag())
            po.setWFUserId(domain.getWFUserId());
        if(domain.getProxyModuleIdDirtyFlag())
            po.setProxyModuleId(domain.getProxyModuleId());
        if(domain.getOriginOrgDeptIdDirtyFlag())
            po.setOriginOrgDeptId(domain.getOriginOrgDeptId());
        if(domain.getPrevStepValueDirtyFlag())
            po.setPrevStepValue(domain.getPrevStepValue());
        if(domain.getCurStepValueDirtyFlag())
            po.setCurStepValue(domain.getCurStepValue());
        if(domain.getOriginPersonIdDirtyFlag())
            po.setOriginPersonId(domain.getOriginPersonId());
        if(domain.getInstanceTypeDirtyFlag())
            po.setInstanceType(domain.getInstanceType());
        if(domain.getCreateManDirtyFlag())
            po.setCreateMan(domain.getCreateMan());
        if(domain.getIsclosedDirtyFlag())
            po.setIsclosed(domain.getIsclosed());
        if(domain.getOriginOrgNameDirtyFlag())
            po.setOriginOrgName(domain.getOriginOrgName());
        if(domain.getOwnerDirtyFlag())
            po.setOwner(domain.getOwner());
        if(domain.getParentStepDirtyFlag())
            po.setParentStep(domain.getParentStep());
        if(domain.getWFInstanceIdDirtyFlag())
            po.setWFInstanceId(domain.getWFInstanceId());
        if(domain.getBswfdataDirtyFlag())
            po.setBswfdata(domain.getBswfdata());
        if(domain.getWFInstanceNameDirtyFlag())
            po.setWFInstanceName(domain.getWFInstanceName());
        if(domain.getOriginOrgDeptNameDirtyFlag())
            po.setOriginOrgDeptName(domain.getOriginOrgDeptName());
        if(domain.getEndtimeDirtyFlag())
            po.setEndtime(domain.getEndtime());
        if(domain.getOriginOrgIdDirtyFlag())
            po.setOriginOrgId(domain.getOriginOrgId());
        if(domain.getWFEngineInstanceIdDirtyFlag())
            po.setWFEngineInstanceId(domain.getWFEngineInstanceId());
        if(domain.getUpdateManDirtyFlag())
            po.setUpdateMan(domain.getUpdateMan());
        if(domain.getPrevProcessDirtyFlag())
            po.setPrevProcess(domain.getPrevProcess());
        if(domain.getCreateDateDirtyFlag())
            po.setCreateDate(domain.getCreateDate());
        if(domain.getOriginPersonNameDirtyFlag())
            po.setOriginPersonName(domain.getOriginPersonName());
        if(domain.getWFStateDirtyFlag())
            po.setWFState(domain.getWFState());
        if(domain.getPrevstepDirtyFlag())
            po.setPrevstep(domain.getPrevstep());
        if(domain.getUpdateDateDirtyFlag())
            po.setUpdateDate(domain.getUpdateDate());
        if(domain.getCurProcessDirtyFlag())
            po.setCurProcess(domain.getCurProcess());
        if(domain.getCurstepDirtyFlag())
            po.setCurstep(domain.getCurstep());
        if(domain.getLogicNameDirtyFlag())
            po.setLogicName(domain.getLogicName());
        if(domain.getMajorInstIdDirtyFlag())
            po.setMajorInstId(domain.getMajorInstId());
        if(domain.getOrgDeptIdDirtyFlag())
            po.setOrgDeptId(domain.getOrgDeptId());
        if(domain.getWFEngineIdDirtyFlag())
            po.setWFEngineId(domain.getWFEngineId());
        if(domain.getPSWorkflowIdDirtyFlag())
            po.setPSWorkflowId(domain.getPSWorkflowId());
        if(domain.getOrgIdDirtyFlag())
            po.setOrgId(domain.getOrgId());
        if(domain.getPSWFVersionIdDirtyFlag())
            po.setPSWFVersionId(domain.getPSWFVersionId());

        return po ;
    }
}
