package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.stereotype.Repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;

import cn.ibizlab.r7.runtime.wf.core.repository.WFModeRepository;
import cn.ibizlab.r7.runtime.wf.core.repository.po.WFMode;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WFModeSearchContext;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.mapper.T_WFMODEMapper;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po.T_WFMODEImpl;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.r7.runtime.wf.mybatis.util.helper.QueryBuilder;


/**
 * 关系型数据实体表[T_WFMODE]存储对象
 */
@Repository
@ConditionalOnProperty(prefix = "wfmode", value="store" , havingValue = "sql", matchIfMissing = true)
public class T_WFMODERepositoryImpl extends ServiceImpl<T_WFMODEMapper, T_WFMODEImpl> implements WFModeRepository {

    
    /**
     * mybatis条件构造器
     */
    @Autowired
    QueryBuilder queryBuilder;
    /**
     * [T_WFMODE]持久层映射对象
     */
    @Autowired
	T_WFMODEMapper t_WFMODEMapper;

    /**
     * 创建持久层对象
     * @return
     */
    public WFMode createPO(){
        return new T_WFMODEImpl();
    }

    /**
     * 获取数据
     * @param key 业务数据主键
     * @return
     */
    public WFMode get(String key){
        return this.getById(key);
    }

    /**
     * 新建数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean create(WFMode po){
        boolean bOk = this.save((T_WFMODEImpl)po);
        return bOk;
    }

    /**
     * 更新数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean update(WFMode po){
        boolean bOk = this.updateById((T_WFMODEImpl)po);
        return bOk;
    }

    /**
     * 删除数据
     * @param key 业务数据主键
     * @return
     */
    public boolean remove(String key){
        return this.removeById(key);
    }

    /**
     * 查询集合[Default]
     * @param context 查询上下文对象
     * @return
     */
    public Page<WFMode> searchDefault(WFModeSearchContext context){
        QueryWrapper qw=queryBuilder.buildQueryWrapper(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page page=queryBuilder.buildPage(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<WFMode> page_datas=t_WFMODEMapper.searchDefault(page,context,qw);
        List<WFMode> list_datas=queryBuilder.page2List(page_datas);
        return new PageImpl<WFMode>(list_datas, context.getPageable(), page_datas.getTotal());
    }

    /**
     * 持久层对象转业务对象
     * @param po 持久层对象
     * @param domain 业务对象
     * @return
     */
    public cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFMode convert2Domain( WFMode po ,cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFMode domain){
        if(po == null)
            return domain ;
        if(domain == null){
            domain = new cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFMode();
        }
        //if(po.getLogicNameDirtyFlag())
        domain.setLogicName(po.getLogicName());
        //if(po.getCreateDateDirtyFlag())
        domain.setCreateDate(po.getCreateDate());
        //if(po.getWFModeIdDirtyFlag())
        domain.setWFModeId(po.getWFModeId());
        //if(po.getUpdateManDirtyFlag())
        domain.setUpdateMan(po.getUpdateMan());
        //if(po.getUpdateDateDirtyFlag())
        domain.setUpdateDate(po.getUpdateDate());
        //if(po.getCreateManDirtyFlag())
        domain.setCreateMan(po.getCreateMan());
        //if(po.getWFModeNameDirtyFlag())
        domain.setWFModeName(po.getWFModeName());
        //if(po.getPSSystemIdDirtyFlag())
        domain.setPSSystemId(po.getPSSystemId());
        return domain ;
    }

    /**
     * 业务对象转持久层对象
     * @param domain 业务对象
     * @param po 持久层对象
     * @return
     */
    public WFMode convert2PO(cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFMode domain , WFMode po){
        if(domain == null)
            return po ;
        if(po==null){
            po = createPO() ;
        }
        if(domain.getLogicNameDirtyFlag())
            po.setLogicName(domain.getLogicName());
        if(domain.getCreateDateDirtyFlag())
            po.setCreateDate(domain.getCreateDate());
        if(domain.getWFModeIdDirtyFlag())
            po.setWFModeId(domain.getWFModeId());
        if(domain.getUpdateManDirtyFlag())
            po.setUpdateMan(domain.getUpdateMan());
        if(domain.getUpdateDateDirtyFlag())
            po.setUpdateDate(domain.getUpdateDate());
        if(domain.getCreateManDirtyFlag())
            po.setCreateMan(domain.getCreateMan());
        if(domain.getWFModeNameDirtyFlag())
            po.setWFModeName(domain.getWFModeName());
        if(domain.getPSSystemIdDirtyFlag())
            po.setPSSystemId(domain.getPSSystemId());

        return po ;
    }
}
