package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.stereotype.Repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;

import cn.ibizlab.r7.runtime.wf.core.repository.WFRoleRepository;
import cn.ibizlab.r7.runtime.wf.core.repository.po.WFRole;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WFRoleSearchContext;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.mapper.T_WFROLEMapper;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po.T_WFROLEImpl;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.r7.runtime.wf.mybatis.util.helper.QueryBuilder;


/**
 * 关系型数据实体表[T_WFROLE]存储对象
 */
@Repository
@ConditionalOnProperty(prefix = "wfrole", value="store" , havingValue = "sql", matchIfMissing = true)
public class T_WFROLERepositoryImpl extends ServiceImpl<T_WFROLEMapper, T_WFROLEImpl> implements WFRoleRepository {

    
    /**
     * mybatis条件构造器
     */
    @Autowired
    QueryBuilder queryBuilder;
    /**
     * [T_WFROLE]持久层映射对象
     */
    @Autowired
	T_WFROLEMapper t_WFROLEMapper;

    /**
     * 创建持久层对象
     * @return
     */
    public WFRole createPO(){
        return new T_WFROLEImpl();
    }

    /**
     * 获取数据
     * @param key 业务数据主键
     * @return
     */
    public WFRole get(String key){
        return this.getById(key);
    }

    /**
     * 新建数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean create(WFRole po){
        boolean bOk = this.save((T_WFROLEImpl)po);
        return bOk;
    }

    /**
     * 更新数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean update(WFRole po){
        boolean bOk = this.updateById((T_WFROLEImpl)po);
        return bOk;
    }

    /**
     * 删除数据
     * @param key 业务数据主键
     * @return
     */
    public boolean remove(String key){
        return this.removeById(key);
    }

    /**
     * 查询集合[Default]
     * @param context 查询上下文对象
     * @return
     */
    public Page<WFRole> searchDefault(WFRoleSearchContext context){
        QueryWrapper qw=queryBuilder.buildQueryWrapper(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page page=queryBuilder.buildPage(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<WFRole> page_datas=t_WFROLEMapper.searchDefault(page,context,qw);
        List<WFRole> list_datas=queryBuilder.page2List(page_datas);
        return new PageImpl<WFRole>(list_datas, context.getPageable(), page_datas.getTotal());
    }

    /**
     * 持久层对象转业务对象
     * @param po 持久层对象
     * @param domain 业务对象
     * @return
     */
    public cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFRole convert2Domain( WFRole po ,cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFRole domain){
        if(po == null)
            return domain ;
        if(domain == null){
            domain = new cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFRole();
        }
        //if(po.getWFRoleIdDirtyFlag())
        domain.setWFRoleId(po.getWFRoleId());
        //if(po.getCreateDateDirtyFlag())
        domain.setCreateDate(po.getCreateDate());
        //if(po.getUpdateDateDirtyFlag())
        domain.setUpdateDate(po.getUpdateDate());
        //if(po.getCreateManDirtyFlag())
        domain.setCreateMan(po.getCreateMan());
        //if(po.getWFRoleNameDirtyFlag())
        domain.setWFRoleName(po.getWFRoleName());
        //if(po.getUpdateManDirtyFlag())
        domain.setUpdateMan(po.getUpdateMan());
        return domain ;
    }

    /**
     * 业务对象转持久层对象
     * @param domain 业务对象
     * @param po 持久层对象
     * @return
     */
    public WFRole convert2PO(cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFRole domain , WFRole po){
        if(domain == null)
            return po ;
        if(po==null){
            po = createPO() ;
        }
        if(domain.getWFRoleIdDirtyFlag())
            po.setWFRoleId(domain.getWFRoleId());
        if(domain.getCreateDateDirtyFlag())
            po.setCreateDate(domain.getCreateDate());
        if(domain.getUpdateDateDirtyFlag())
            po.setUpdateDate(domain.getUpdateDate());
        if(domain.getCreateManDirtyFlag())
            po.setCreateMan(domain.getCreateMan());
        if(domain.getWFRoleNameDirtyFlag())
            po.setWFRoleName(domain.getWFRoleName());
        if(domain.getUpdateManDirtyFlag())
            po.setUpdateMan(domain.getUpdateMan());

        return po ;
    }
}
