package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.stereotype.Repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;

import cn.ibizlab.r7.runtime.wf.core.repository.WFStepActorRepository;
import cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepActor;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WFStepActorSearchContext;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.mapper.T_WFSTEPACTORMapper;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po.T_WFSTEPACTORImpl;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.r7.runtime.wf.mybatis.util.helper.QueryBuilder;


/**
 * 关系型数据实体表[T_WFSTEPACTOR]存储对象
 */
@Repository
@ConditionalOnProperty(prefix = "wfstepactor", value="store" , havingValue = "sql", matchIfMissing = true)
public class T_WFSTEPACTORRepositoryImpl extends ServiceImpl<T_WFSTEPACTORMapper, T_WFSTEPACTORImpl> implements WFStepActorRepository {

    
    /**
     * mybatis条件构造器
     */
    @Autowired
    QueryBuilder queryBuilder;
    /**
     * [T_WFSTEPACTOR]持久层映射对象
     */
    @Autowired
	T_WFSTEPACTORMapper t_WFSTEPACTORMapper;

    /**
     * 创建持久层对象
     * @return
     */
    public WFStepActor createPO(){
        return new T_WFSTEPACTORImpl();
    }

    /**
     * 获取数据
     * @param key 业务数据主键
     * @return
     */
    public WFStepActor get(String key){
        return this.getById(key);
    }

    /**
     * 新建数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean create(WFStepActor po){
        boolean bOk = this.save((T_WFSTEPACTORImpl)po);
        return bOk;
    }

    /**
     * 更新数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean update(WFStepActor po){
        boolean bOk = this.updateById((T_WFSTEPACTORImpl)po);
        return bOk;
    }

    /**
     * 删除数据
     * @param key 业务数据主键
     * @return
     */
    public boolean remove(String key){
        return this.removeById(key);
    }

    /**
     * 查询集合[Default]
     * @param context 查询上下文对象
     * @return
     */
    public Page<WFStepActor> searchDefault(WFStepActorSearchContext context){
        QueryWrapper qw=queryBuilder.buildQueryWrapper(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page page=queryBuilder.buildPage(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<WFStepActor> page_datas=t_WFSTEPACTORMapper.searchDefault(page,context,qw);
        List<WFStepActor> list_datas=queryBuilder.page2List(page_datas);
        return new PageImpl<WFStepActor>(list_datas, context.getPageable(), page_datas.getTotal());
    }

    /**
     * 持久层对象转业务对象
     * @param po 持久层对象
     * @param domain 业务对象
     * @return
     */
    public cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFStepActor convert2Domain( WFStepActor po ,cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFStepActor domain){
        if(po == null)
            return domain ;
        if(domain == null){
            domain = new cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFStepActor();
        }
        //if(po.getLogicNameDirtyFlag())
        domain.setLogicName(po.getLogicName());
        //if(po.getParentInstIdDirtyFlag())
        domain.setParentInstId(po.getParentInstId());
        //if(po.getUpdateDateDirtyFlag())
        domain.setUpdateDate(po.getUpdateDate());
        //if(po.getMajorInstIdDirtyFlag())
        domain.setMajorInstId(po.getMajorInstId());
        //if(po.getWFStepActorIdDirtyFlag())
        domain.setWFStepActorId(po.getWFStepActorId());
        //if(po.getUpdateManDirtyFlag())
        domain.setUpdateMan(po.getUpdateMan());
        //if(po.getCreateDateDirtyFlag())
        domain.setCreateDate(po.getCreateDate());
        //if(po.getFinishTimeDirtyFlag())
        domain.setFinishTime(po.getFinishTime());
        //if(po.getWFStepActorNameDirtyFlag())
        domain.setWFStepActorName(po.getWFStepActorName());
        //if(po.getTaskIdDirtyFlag())
        domain.setTaskId(po.getTaskId());
        //if(po.getCreateManDirtyFlag())
        domain.setCreateMan(po.getCreateMan());
        //if(po.getIsFinishDirtyFlag())
        domain.setIsFinish(po.getIsFinish());
        //if(po.getReadTimeDirtyFlag())
        domain.setReadTime(po.getReadTime());
        //if(po.getIsReadOnlyDirtyFlag())
        domain.setIsReadOnly(po.getIsReadOnly());
        //if(po.getStartTimeDirtyFlag())
        domain.setStartTime(po.getStartTime());
        //if(po.getWFUserNameDirtyFlag())
        domain.setWFUserName(po.getWFUserName());
        //if(po.getWFUserIdDirtyFlag())
        domain.setWFUserId(po.getWFUserId());
        //if(po.getWFStepIdDirtyFlag())
        domain.setWFStepId(po.getWFStepId());
        //if(po.getPSWFProcessIdDirtyFlag())
        domain.setPSWFProcessId(po.getPSWFProcessId());
        //if(po.getWFInstanceIdDirtyFlag())
        domain.setWFInstanceId(po.getWFInstanceId());
        //if(po.getPSWFVersionIdDirtyFlag())
        domain.setPSWFVersionId(po.getPSWFVersionId());
        return domain ;
    }

    /**
     * 业务对象转持久层对象
     * @param domain 业务对象
     * @param po 持久层对象
     * @return
     */
    public WFStepActor convert2PO(cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFStepActor domain , WFStepActor po){
        if(domain == null)
            return po ;
        if(po==null){
            po = createPO() ;
        }
        if(domain.getLogicNameDirtyFlag())
            po.setLogicName(domain.getLogicName());
        if(domain.getParentInstIdDirtyFlag())
            po.setParentInstId(domain.getParentInstId());
        if(domain.getUpdateDateDirtyFlag())
            po.setUpdateDate(domain.getUpdateDate());
        if(domain.getMajorInstIdDirtyFlag())
            po.setMajorInstId(domain.getMajorInstId());
        if(domain.getWFStepActorIdDirtyFlag())
            po.setWFStepActorId(domain.getWFStepActorId());
        if(domain.getUpdateManDirtyFlag())
            po.setUpdateMan(domain.getUpdateMan());
        if(domain.getCreateDateDirtyFlag())
            po.setCreateDate(domain.getCreateDate());
        if(domain.getFinishTimeDirtyFlag())
            po.setFinishTime(domain.getFinishTime());
        if(domain.getWFStepActorNameDirtyFlag())
            po.setWFStepActorName(domain.getWFStepActorName());
        if(domain.getTaskIdDirtyFlag())
            po.setTaskId(domain.getTaskId());
        if(domain.getCreateManDirtyFlag())
            po.setCreateMan(domain.getCreateMan());
        if(domain.getIsFinishDirtyFlag())
            po.setIsFinish(domain.getIsFinish());
        if(domain.getReadTimeDirtyFlag())
            po.setReadTime(domain.getReadTime());
        if(domain.getIsReadOnlyDirtyFlag())
            po.setIsReadOnly(domain.getIsReadOnly());
        if(domain.getStartTimeDirtyFlag())
            po.setStartTime(domain.getStartTime());
        if(domain.getWFUserNameDirtyFlag())
            po.setWFUserName(domain.getWFUserName());
        if(domain.getWFUserIdDirtyFlag())
            po.setWFUserId(domain.getWFUserId());
        if(domain.getWFStepIdDirtyFlag())
            po.setWFStepId(domain.getWFStepId());
        if(domain.getPSWFProcessIdDirtyFlag())
            po.setPSWFProcessId(domain.getPSWFProcessId());
        if(domain.getWFInstanceIdDirtyFlag())
            po.setWFInstanceId(domain.getWFInstanceId());
        if(domain.getPSWFVersionIdDirtyFlag())
            po.setPSWFVersionId(domain.getPSWFVersionId());

        return po ;
    }
}
