package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.stereotype.Repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;

import cn.ibizlab.r7.runtime.wf.core.repository.WFStepDataRepository;
import cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepData;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WFStepDataSearchContext;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.mapper.T_WFSTEPDATAMapper;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po.T_WFSTEPDATAImpl;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.r7.runtime.wf.mybatis.util.helper.QueryBuilder;


/**
 * 关系型数据实体表[T_WFSTEPDATA]存储对象
 */
@Repository
@ConditionalOnProperty(prefix = "wfstepdata", value="store" , havingValue = "sql", matchIfMissing = true)
public class T_WFSTEPDATARepositoryImpl extends ServiceImpl<T_WFSTEPDATAMapper, T_WFSTEPDATAImpl> implements WFStepDataRepository {

    
    /**
     * mybatis条件构造器
     */
    @Autowired
    QueryBuilder queryBuilder;
    /**
     * [T_WFSTEPDATA]持久层映射对象
     */
    @Autowired
	T_WFSTEPDATAMapper t_WFSTEPDATAMapper;

    /**
     * 创建持久层对象
     * @return
     */
    public WFStepData createPO(){
        return new T_WFSTEPDATAImpl();
    }

    /**
     * 获取数据
     * @param key 业务数据主键
     * @return
     */
    public WFStepData get(String key){
        return this.getById(key);
    }

    /**
     * 新建数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean create(WFStepData po){
        boolean bOk = this.save((T_WFSTEPDATAImpl)po);
        return bOk;
    }

    /**
     * 更新数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean update(WFStepData po){
        boolean bOk = this.updateById((T_WFSTEPDATAImpl)po);
        return bOk;
    }

    /**
     * 删除数据
     * @param key 业务数据主键
     * @return
     */
    public boolean remove(String key){
        return this.removeById(key);
    }

    /**
     * 查询集合[ByBswfdata]
     * @param context 查询上下文对象
     * @return
     */
    public Page<WFStepData> searchByBswfdata(WFStepDataSearchContext context){
        QueryWrapper qw=queryBuilder.buildQueryWrapper(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page page=queryBuilder.buildPage(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<WFStepData> page_datas=t_WFSTEPDATAMapper.searchByBswfdata(page,context,qw);
        List<WFStepData> list_datas=queryBuilder.page2List(page_datas);
        return new PageImpl<WFStepData>(list_datas, context.getPageable(), page_datas.getTotal());
    }

    /**
     * 查询集合[ByBsdata]
     * @param context 查询上下文对象
     * @return
     */
    public Page<WFStepData> searchByBsdata(WFStepDataSearchContext context){
        QueryWrapper qw=queryBuilder.buildQueryWrapper(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page page=queryBuilder.buildPage(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<WFStepData> page_datas=t_WFSTEPDATAMapper.searchByBsdata(page,context,qw);
        List<WFStepData> list_datas=queryBuilder.page2List(page_datas);
        return new PageImpl<WFStepData>(list_datas, context.getPageable(), page_datas.getTotal());
    }

    /**
     * 查询集合[Default]
     * @param context 查询上下文对象
     * @return
     */
    public Page<WFStepData> searchDefault(WFStepDataSearchContext context){
        QueryWrapper qw=queryBuilder.buildQueryWrapper(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page page=queryBuilder.buildPage(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<WFStepData> page_datas=t_WFSTEPDATAMapper.searchDefault(page,context,qw);
        List<WFStepData> list_datas=queryBuilder.page2List(page_datas);
        return new PageImpl<WFStepData>(list_datas, context.getPageable(), page_datas.getTotal());
    }

    /**
     * 持久层对象转业务对象
     * @param po 持久层对象
     * @param domain 业务对象
     * @return
     */
    public cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFStepData convert2Domain( WFStepData po ,cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFStepData domain){
        if(po == null)
            return domain ;
        if(domain == null){
            domain = new cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFStepData();
        }
        //if(po.getWFStepDataIdDirtyFlag())
        domain.setWFStepDataId(po.getWFStepDataId());
        //if(po.getActionPersonDirtyFlag())
        domain.setActionPerson(po.getActionPerson());
        //if(po.getActionInfoDirtyFlag())
        domain.setActionInfo(po.getActionInfo());
        //if(po.getMajorInstIdDirtyFlag())
        domain.setMajorInstId(po.getMajorInstId());
        //if(po.getActionTimeDirtyFlag())
        domain.setActionTime(po.getActionTime());
        //if(po.getCreateManDirtyFlag())
        domain.setCreateMan(po.getCreateMan());
        //if(po.getUpdateDateDirtyFlag())
        domain.setUpdateDate(po.getUpdateDate());
        //if(po.getActionDirtyFlag())
        domain.setAction(po.getAction());
        //if(po.getCreateDateDirtyFlag())
        domain.setCreateDate(po.getCreateDate());
        //if(po.getParentInstIdDirtyFlag())
        domain.setParentInstId(po.getParentInstId());
        //if(po.getUpdateManDirtyFlag())
        domain.setUpdateMan(po.getUpdateMan());
        //if(po.getWFStepDataNameDirtyFlag())
        domain.setWFStepDataName(po.getWFStepDataName());
        //if(po.getWFStepNameDirtyFlag())
        domain.setWFStepName(po.getWFStepName());
        //if(po.getWFStepIdDirtyFlag())
        domain.setWFStepId(po.getWFStepId());
        //if(po.getWFInstanceIdDirtyFlag())
        domain.setWFInstanceId(po.getWFInstanceId());
        //if(po.getWFIAActionIdDirtyFlag())
        domain.setWFIAActionId(po.getWFIAActionId());
        return domain ;
    }

    /**
     * 业务对象转持久层对象
     * @param domain 业务对象
     * @param po 持久层对象
     * @return
     */
    public WFStepData convert2PO(cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFStepData domain , WFStepData po){
        if(domain == null)
            return po ;
        if(po==null){
            po = createPO() ;
        }
        if(domain.getWFStepDataIdDirtyFlag())
            po.setWFStepDataId(domain.getWFStepDataId());
        if(domain.getActionPersonDirtyFlag())
            po.setActionPerson(domain.getActionPerson());
        if(domain.getActionInfoDirtyFlag())
            po.setActionInfo(domain.getActionInfo());
        if(domain.getMajorInstIdDirtyFlag())
            po.setMajorInstId(domain.getMajorInstId());
        if(domain.getActionTimeDirtyFlag())
            po.setActionTime(domain.getActionTime());
        if(domain.getCreateManDirtyFlag())
            po.setCreateMan(domain.getCreateMan());
        if(domain.getUpdateDateDirtyFlag())
            po.setUpdateDate(domain.getUpdateDate());
        if(domain.getActionDirtyFlag())
            po.setAction(domain.getAction());
        if(domain.getCreateDateDirtyFlag())
            po.setCreateDate(domain.getCreateDate());
        if(domain.getParentInstIdDirtyFlag())
            po.setParentInstId(domain.getParentInstId());
        if(domain.getUpdateManDirtyFlag())
            po.setUpdateMan(domain.getUpdateMan());
        if(domain.getWFStepDataNameDirtyFlag())
            po.setWFStepDataName(domain.getWFStepDataName());
        if(domain.getWFStepNameDirtyFlag())
            po.setWFStepName(domain.getWFStepName());
        if(domain.getWFStepIdDirtyFlag())
            po.setWFStepId(domain.getWFStepId());
        if(domain.getWFInstanceIdDirtyFlag())
            po.setWFInstanceId(domain.getWFInstanceId());
        if(domain.getWFIAActionIdDirtyFlag())
            po.setWFIAActionId(domain.getWFIAActionId());

        return po ;
    }
}
