package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.stereotype.Repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;

import cn.ibizlab.r7.runtime.wf.core.repository.WFStepRepository;
import cn.ibizlab.r7.runtime.wf.core.repository.po.WFStep;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WFStepSearchContext;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.mapper.T_WFSTEPMapper;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po.T_WFSTEPImpl;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.r7.runtime.wf.mybatis.util.helper.QueryBuilder;


/**
 * 关系型数据实体表[T_WFSTEP]存储对象
 */
@Repository
@ConditionalOnProperty(prefix = "wfstep", value="store" , havingValue = "sql", matchIfMissing = true)
public class T_WFSTEPRepositoryImpl extends ServiceImpl<T_WFSTEPMapper, T_WFSTEPImpl> implements WFStepRepository {

    
    /**
     * mybatis条件构造器
     */
    @Autowired
    QueryBuilder queryBuilder;
    /**
     * [T_WFSTEP]持久层映射对象
     */
    @Autowired
	T_WFSTEPMapper t_WFSTEPMapper;

    /**
     * 创建持久层对象
     * @return
     */
    public WFStep createPO(){
        return new T_WFSTEPImpl();
    }

    /**
     * 获取数据
     * @param key 业务数据主键
     * @return
     */
    public WFStep get(String key){
        return this.getById(key);
    }

    /**
     * 新建数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean create(WFStep po){
        boolean bOk = this.save((T_WFSTEPImpl)po);
        return bOk;
    }

    /**
     * 更新数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean update(WFStep po){
        boolean bOk = this.updateById((T_WFSTEPImpl)po);
        return bOk;
    }

    /**
     * 删除数据
     * @param key 业务数据主键
     * @return
     */
    public boolean remove(String key){
        return this.removeById(key);
    }

    /**
     * 查询集合[Default]
     * @param context 查询上下文对象
     * @return
     */
    public Page<WFStep> searchDefault(WFStepSearchContext context){
        QueryWrapper qw=queryBuilder.buildQueryWrapper(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page page=queryBuilder.buildPage(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<WFStep> page_datas=t_WFSTEPMapper.searchDefault(page,context,qw);
        List<WFStep> list_datas=queryBuilder.page2List(page_datas);
        return new PageImpl<WFStep>(list_datas, context.getPageable(), page_datas.getTotal());
    }

    /**
     * 持久层对象转业务对象
     * @param po 持久层对象
     * @param domain 业务对象
     * @return
     */
    public cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFStep convert2Domain( WFStep po ,cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFStep domain){
        if(po == null)
            return domain ;
        if(domain == null){
            domain = new cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFStep();
        }
        //if(po.getIsFinishDirtyFlag())
        domain.setIsFinish(po.getIsFinish());
        //if(po.getStartTimeDirtyFlag())
        domain.setStartTime(po.getStartTime());
        //if(po.getLogicNameDirtyFlag())
        domain.setLogicName(po.getLogicName());
        //if(po.getUpdateDateDirtyFlag())
        domain.setUpdateDate(po.getUpdateDate());
        //if(po.getUpdateManDirtyFlag())
        domain.setUpdateMan(po.getUpdateMan());
        //if(po.getEndTimeDirtyFlag())
        domain.setEndTime(po.getEndTime());
        //if(po.getCreateManDirtyFlag())
        domain.setCreateMan(po.getCreateMan());
        //if(po.getParentInstIdDirtyFlag())
        domain.setParentInstId(po.getParentInstId());
        //if(po.getWFStepNameDirtyFlag())
        domain.setWFStepName(po.getWFStepName());
        //if(po.getWFStepIdDirtyFlag())
        domain.setWFStepId(po.getWFStepId());
        //if(po.getMajorInstIdDirtyFlag())
        domain.setMajorInstId(po.getMajorInstId());
        //if(po.getTraceStepDirtyFlag())
        domain.setTraceStep(po.getTraceStep());
        //if(po.getCreateDateDirtyFlag())
        domain.setCreateDate(po.getCreateDate());
        //if(po.getPSWFProcessIdDirtyFlag())
        domain.setPSWFProcessId(po.getPSWFProcessId());
        //if(po.getPSWFVersionIdDirtyFlag())
        domain.setPSWFVersionId(po.getPSWFVersionId());
        //if(po.getWFInstanceIdDirtyFlag())
        domain.setWFInstanceId(po.getWFInstanceId());
        return domain ;
    }

    /**
     * 业务对象转持久层对象
     * @param domain 业务对象
     * @param po 持久层对象
     * @return
     */
    public WFStep convert2PO(cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFStep domain , WFStep po){
        if(domain == null)
            return po ;
        if(po==null){
            po = createPO() ;
        }
        if(domain.getIsFinishDirtyFlag())
            po.setIsFinish(domain.getIsFinish());
        if(domain.getStartTimeDirtyFlag())
            po.setStartTime(domain.getStartTime());
        if(domain.getLogicNameDirtyFlag())
            po.setLogicName(domain.getLogicName());
        if(domain.getUpdateDateDirtyFlag())
            po.setUpdateDate(domain.getUpdateDate());
        if(domain.getUpdateManDirtyFlag())
            po.setUpdateMan(domain.getUpdateMan());
        if(domain.getEndTimeDirtyFlag())
            po.setEndTime(domain.getEndTime());
        if(domain.getCreateManDirtyFlag())
            po.setCreateMan(domain.getCreateMan());
        if(domain.getParentInstIdDirtyFlag())
            po.setParentInstId(domain.getParentInstId());
        if(domain.getWFStepNameDirtyFlag())
            po.setWFStepName(domain.getWFStepName());
        if(domain.getWFStepIdDirtyFlag())
            po.setWFStepId(domain.getWFStepId());
        if(domain.getMajorInstIdDirtyFlag())
            po.setMajorInstId(domain.getMajorInstId());
        if(domain.getTraceStepDirtyFlag())
            po.setTraceStep(domain.getTraceStep());
        if(domain.getCreateDateDirtyFlag())
            po.setCreateDate(domain.getCreateDate());
        if(domain.getPSWFProcessIdDirtyFlag())
            po.setPSWFProcessId(domain.getPSWFProcessId());
        if(domain.getPSWFVersionIdDirtyFlag())
            po.setPSWFVersionId(domain.getPSWFVersionId());
        if(domain.getWFInstanceIdDirtyFlag())
            po.setWFInstanceId(domain.getWFInstanceId());

        return po ;
    }
}
