package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.stereotype.Repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;

import cn.ibizlab.r7.runtime.wf.core.repository.WFUserRepository;
import cn.ibizlab.r7.runtime.wf.core.repository.po.WFUser;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WFUserSearchContext;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.mapper.T_WFUSERMapper;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po.T_WFUSERImpl;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.r7.runtime.wf.mybatis.util.helper.QueryBuilder;


/**
 * 关系型数据实体表[T_WFUSER]存储对象
 */
@Repository
@ConditionalOnProperty(prefix = "wfuser", value="store" , havingValue = "sql", matchIfMissing = true)
public class T_WFUSERRepositoryImpl extends ServiceImpl<T_WFUSERMapper, T_WFUSERImpl> implements WFUserRepository {

    
    /**
     * mybatis条件构造器
     */
    @Autowired
    QueryBuilder queryBuilder;
    /**
     * [T_WFUSER]持久层映射对象
     */
    @Autowired
	T_WFUSERMapper t_WFUSERMapper;

    /**
     * 创建持久层对象
     * @return
     */
    public WFUser createPO(){
        return new T_WFUSERImpl();
    }

    /**
     * 获取数据
     * @param key 业务数据主键
     * @return
     */
    public WFUser get(String key){
        return this.getById(key);
    }

    /**
     * 新建数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean create(WFUser po){
        boolean bOk = this.save((T_WFUSERImpl)po);
        return bOk;
    }

    /**
     * 更新数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean update(WFUser po){
        boolean bOk = this.updateById((T_WFUSERImpl)po);
        return bOk;
    }

    /**
     * 删除数据
     * @param key 业务数据主键
     * @return
     */
    public boolean remove(String key){
        return this.removeById(key);
    }

    /**
     * 查询集合[Default]
     * @param context 查询上下文对象
     * @return
     */
    public Page<WFUser> searchDefault(WFUserSearchContext context){
        QueryWrapper qw=queryBuilder.buildQueryWrapper(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page page=queryBuilder.buildPage(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<WFUser> page_datas=t_WFUSERMapper.searchDefault(page,context,qw);
        List<WFUser> list_datas=queryBuilder.page2List(page_datas);
        return new PageImpl<WFUser>(list_datas, context.getPageable(), page_datas.getTotal());
    }

    /**
     * 持久层对象转业务对象
     * @param po 持久层对象
     * @param domain 业务对象
     * @return
     */
    public cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFUser convert2Domain( WFUser po ,cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFUser domain){
        if(po == null)
            return domain ;
        if(domain == null){
            domain = new cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFUser();
        }
        //if(po.getUpdateDateDirtyFlag())
        domain.setUpdateDate(po.getUpdateDate());
        //if(po.getWFUserIdDirtyFlag())
        domain.setWFUserId(po.getWFUserId());
        //if(po.getWFUserNameDirtyFlag())
        domain.setWFUserName(po.getWFUserName());
        //if(po.getLogicNameDirtyFlag())
        domain.setLogicName(po.getLogicName());
        //if(po.getCreateManDirtyFlag())
        domain.setCreateMan(po.getCreateMan());
        //if(po.getUpdateManDirtyFlag())
        domain.setUpdateMan(po.getUpdateMan());
        //if(po.getCreateDateDirtyFlag())
        domain.setCreateDate(po.getCreateDate());
        return domain ;
    }

    /**
     * 业务对象转持久层对象
     * @param domain 业务对象
     * @param po 持久层对象
     * @return
     */
    public WFUser convert2PO(cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFUser domain , WFUser po){
        if(domain == null)
            return po ;
        if(po==null){
            po = createPO() ;
        }
        if(domain.getUpdateDateDirtyFlag())
            po.setUpdateDate(domain.getUpdateDate());
        if(domain.getWFUserIdDirtyFlag())
            po.setWFUserId(domain.getWFUserId());
        if(domain.getWFUserNameDirtyFlag())
            po.setWFUserName(domain.getWFUserName());
        if(domain.getLogicNameDirtyFlag())
            po.setLogicName(domain.getLogicName());
        if(domain.getCreateManDirtyFlag())
            po.setCreateMan(domain.getCreateMan());
        if(domain.getUpdateManDirtyFlag())
            po.setUpdateMan(domain.getUpdateMan());
        if(domain.getCreateDateDirtyFlag())
            po.setCreateDate(domain.getCreateDate());

        return po ;
    }
}
