package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.stereotype.Repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;

import cn.ibizlab.r7.runtime.wf.core.repository.WFWorklistRepository;
import cn.ibizlab.r7.runtime.wf.core.repository.po.WFWorklist;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WFWorklistSearchContext;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.mapper.T_WFWORKLISTMapper;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po.T_WFWORKLISTImpl;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.r7.runtime.wf.mybatis.util.helper.QueryBuilder;


/**
 * 关系型数据实体表[T_WFWORKLIST]存储对象
 */
@Repository
@ConditionalOnProperty(prefix = "wfworklist", value="store" , havingValue = "sql", matchIfMissing = true)
public class T_WFWORKLISTRepositoryImpl extends ServiceImpl<T_WFWORKLISTMapper, T_WFWORKLISTImpl> implements WFWorklistRepository {

    
    /**
     * mybatis条件构造器
     */
    @Autowired
    QueryBuilder queryBuilder;
    /**
     * [T_WFWORKLIST]持久层映射对象
     */
    @Autowired
	T_WFWORKLISTMapper t_WFWORKLISTMapper;

    /**
     * 创建持久层对象
     * @return
     */
    public WFWorklist createPO(){
        return new T_WFWORKLISTImpl();
    }

    /**
     * 获取数据
     * @param key 业务数据主键
     * @return
     */
    public WFWorklist get(String key){
        return this.getById(key);
    }

    /**
     * 新建数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean create(WFWorklist po){
        boolean bOk = this.save((T_WFWORKLISTImpl)po);
        return bOk;
    }

    /**
     * 更新数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean update(WFWorklist po){
        boolean bOk = this.updateById((T_WFWORKLISTImpl)po);
        return bOk;
    }

    /**
     * 删除数据
     * @param key 业务数据主键
     * @return
     */
    public boolean remove(String key){
        return this.removeById(key);
    }

    /**
     * 查询集合[Default]
     * @param context 查询上下文对象
     * @return
     */
    public Page<WFWorklist> searchDefault(WFWorklistSearchContext context){
        QueryWrapper qw=queryBuilder.buildQueryWrapper(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page page=queryBuilder.buildPage(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<WFWorklist> page_datas=t_WFWORKLISTMapper.searchDefault(page,context,qw);
        List<WFWorklist> list_datas=queryBuilder.page2List(page_datas);
        return new PageImpl<WFWorklist>(list_datas, context.getPageable(), page_datas.getTotal());
    }

    /**
     * 查询集合[DoneTask]
     * @param context 查询上下文对象
     * @return
     */
    public Page<WFWorklist> searchDoneTask(WFWorklistSearchContext context){
        QueryWrapper qw=queryBuilder.buildQueryWrapper(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page page=queryBuilder.buildPage(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<WFWorklist> page_datas=t_WFWORKLISTMapper.searchDoneTask(page,context,qw);
        List<WFWorklist> list_datas=queryBuilder.page2List(page_datas);
        return new PageImpl<WFWorklist>(list_datas, context.getPageable(), page_datas.getTotal());
    }

    /**
     * 查询集合[TodoTask]
     * @param context 查询上下文对象
     * @return
     */
    public Page<WFWorklist> searchTodoTask(WFWorklistSearchContext context){
        QueryWrapper qw=queryBuilder.buildQueryWrapper(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page page=queryBuilder.buildPage(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<WFWorklist> page_datas=t_WFWORKLISTMapper.searchTodoTask(page,context,qw);
        List<WFWorklist> list_datas=queryBuilder.page2List(page_datas);
        return new PageImpl<WFWorklist>(list_datas, context.getPageable(), page_datas.getTotal());
    }

    /**
     * 持久层对象转业务对象
     * @param po 持久层对象
     * @param domain 业务对象
     * @return
     */
    public cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFWorklist convert2Domain( WFWorklist po ,cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFWorklist domain){
        if(po == null)
            return domain ;
        if(domain == null){
            domain = new cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFWorklist();
        }
        //if(po.getInitiatorDirtyFlag())
        domain.setInitiator(po.getInitiator());
        //if(po.getWorkDateDirtyFlag())
        domain.setWorkDate(po.getWorkDate());
        //if(po.getIsclosedDirtyFlag())
        domain.setIsclosed(po.getIsclosed());
        //if(po.getUpdateDateDirtyFlag())
        domain.setUpdateDate(po.getUpdateDate());
        //if(po.getWFWorklistIdDirtyFlag())
        domain.setWFWorklistId(po.getWFWorklistId());
        //if(po.getWorklistStateDirtyFlag())
        domain.setWorklistState(po.getWorklistState());
        //if(po.getWorkInfoDirtyFlag())
        domain.setWorkInfo(po.getWorkInfo());
        //if(po.getWFWorklistNameDirtyFlag())
        domain.setWFWorklistName(po.getWFWorklistName());
        //if(po.getIsreadDirtyFlag())
        domain.setIsread(po.getIsread());
        //if(po.getLogicNameDirtyFlag())
        domain.setLogicName(po.getLogicName());
        //if(po.getMemoDirtyFlag())
        domain.setMemo(po.getMemo());
        //if(po.getViewUrlDirtyFlag())
        domain.setViewUrl(po.getViewUrl());
        //if(po.getCreateDateDirtyFlag())
        domain.setCreateDate(po.getCreateDate());
        //if(po.getWFModuleIdDirtyFlag())
        domain.setWFModuleId(po.getWFModuleId());
        //if(po.getFinishDateDirtyFlag())
        domain.setFinishDate(po.getFinishDate());
        //if(po.getDoneDirtyFlag())
        domain.setDone(po.getDone());
        //if(po.getUpdateManDirtyFlag())
        domain.setUpdateMan(po.getUpdateMan());
        //if(po.getUrgencyDirtyFlag())
        domain.setUrgency(po.getUrgency());
        //if(po.getCreateManDirtyFlag())
        domain.setCreateMan(po.getCreateMan());
        //if(po.getWFStepDirtyFlag())
        domain.setWFStep(po.getWFStep());
        //if(po.getWFDataIdDirtyFlag())
        domain.setWFDataId(po.getWFDataId());
        //if(po.getWfengineworklistidDirtyFlag())
        domain.setWfengineworklistid(po.getWfengineworklistid());
        //if(po.getOrgDeptNameDirtyFlag())
        domain.setOrgDeptName(po.getOrgDeptName());
        //if(po.getWFUserIdDirtyFlag())
        domain.setWFUserId(po.getWFUserId());
        //if(po.getPSWFRoleIdDirtyFlag())
        domain.setPSWFRoleId(po.getPSWFRoleId());
        //if(po.getOrgDeptIdDirtyFlag())
        domain.setOrgDeptId(po.getOrgDeptId());
        //if(po.getOrgDeptUserIdDirtyFlag())
        domain.setOrgDeptUserId(po.getOrgDeptUserId());
        //if(po.getWFInstanceIdDirtyFlag())
        domain.setWFInstanceId(po.getWFInstanceId());
        //if(po.getOrgIdDirtyFlag())
        domain.setOrgId(po.getOrgId());
        return domain ;
    }

    /**
     * 业务对象转持久层对象
     * @param domain 业务对象
     * @param po 持久层对象
     * @return
     */
    public WFWorklist convert2PO(cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFWorklist domain , WFWorklist po){
        if(domain == null)
            return po ;
        if(po==null){
            po = createPO() ;
        }
        if(domain.getInitiatorDirtyFlag())
            po.setInitiator(domain.getInitiator());
        if(domain.getWorkDateDirtyFlag())
            po.setWorkDate(domain.getWorkDate());
        if(domain.getIsclosedDirtyFlag())
            po.setIsclosed(domain.getIsclosed());
        if(domain.getUpdateDateDirtyFlag())
            po.setUpdateDate(domain.getUpdateDate());
        if(domain.getWFWorklistIdDirtyFlag())
            po.setWFWorklistId(domain.getWFWorklistId());
        if(domain.getWorklistStateDirtyFlag())
            po.setWorklistState(domain.getWorklistState());
        if(domain.getWorkInfoDirtyFlag())
            po.setWorkInfo(domain.getWorkInfo());
        if(domain.getWFWorklistNameDirtyFlag())
            po.setWFWorklistName(domain.getWFWorklistName());
        if(domain.getIsreadDirtyFlag())
            po.setIsread(domain.getIsread());
        if(domain.getLogicNameDirtyFlag())
            po.setLogicName(domain.getLogicName());
        if(domain.getMemoDirtyFlag())
            po.setMemo(domain.getMemo());
        if(domain.getViewUrlDirtyFlag())
            po.setViewUrl(domain.getViewUrl());
        if(domain.getCreateDateDirtyFlag())
            po.setCreateDate(domain.getCreateDate());
        if(domain.getWFModuleIdDirtyFlag())
            po.setWFModuleId(domain.getWFModuleId());
        if(domain.getFinishDateDirtyFlag())
            po.setFinishDate(domain.getFinishDate());
        if(domain.getDoneDirtyFlag())
            po.setDone(domain.getDone());
        if(domain.getUpdateManDirtyFlag())
            po.setUpdateMan(domain.getUpdateMan());
        if(domain.getUrgencyDirtyFlag())
            po.setUrgency(domain.getUrgency());
        if(domain.getCreateManDirtyFlag())
            po.setCreateMan(domain.getCreateMan());
        if(domain.getWFStepDirtyFlag())
            po.setWFStep(domain.getWFStep());
        if(domain.getWFDataIdDirtyFlag())
            po.setWFDataId(domain.getWFDataId());
        if(domain.getWfengineworklistidDirtyFlag())
            po.setWfengineworklistid(domain.getWfengineworklistid());
        if(domain.getOrgDeptNameDirtyFlag())
            po.setOrgDeptName(domain.getOrgDeptName());
        if(domain.getWFUserIdDirtyFlag())
            po.setWFUserId(domain.getWFUserId());
        if(domain.getPSWFRoleIdDirtyFlag())
            po.setPSWFRoleId(domain.getPSWFRoleId());
        if(domain.getOrgDeptIdDirtyFlag())
            po.setOrgDeptId(domain.getOrgDeptId());
        if(domain.getOrgDeptUserIdDirtyFlag())
            po.setOrgDeptUserId(domain.getOrgDeptUserId());
        if(domain.getWFInstanceIdDirtyFlag())
            po.setWFInstanceId(domain.getWFInstanceId());
        if(domain.getOrgIdDirtyFlag())
            po.setOrgId(domain.getOrgId());

        return po ;
    }
}
