package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.stereotype.Repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;

import cn.ibizlab.r7.runtime.wf.core.repository.WorkflowRepository;
import cn.ibizlab.r7.runtime.wf.core.repository.po.Workflow;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WorkflowSearchContext;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.mapper.T_WORKFLOWMapper;
import cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po.T_WORKFLOWImpl;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.r7.runtime.wf.mybatis.util.helper.QueryBuilder;


/**
 * 关系型数据实体表[T_WORKFLOW]存储对象
 */
@Repository
@ConditionalOnProperty(prefix = "workflow", value="store" , havingValue = "sql", matchIfMissing = true)
public class T_WORKFLOWRepositoryImpl extends ServiceImpl<T_WORKFLOWMapper, T_WORKFLOWImpl> implements WorkflowRepository {

    
    /**
     * mybatis条件构造器
     */
    @Autowired
    QueryBuilder queryBuilder;
    /**
     * [T_WORKFLOW]持久层映射对象
     */
    @Autowired
	T_WORKFLOWMapper t_WORKFLOWMapper;

    /**
     * 创建持久层对象
     * @return
     */
    public Workflow createPO(){
        return new T_WORKFLOWImpl();
    }

    /**
     * 获取数据
     * @param key 业务数据主键
     * @return
     */
    public Workflow get(String key){
        return this.getById(key);
    }

    /**
     * 新建数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean create(Workflow po){
        boolean bOk = this.save((T_WORKFLOWImpl)po);
        return bOk;
    }

    /**
     * 更新数据
     * @param po 持久层数据对象
     * @return
     */
    public boolean update(Workflow po){
        boolean bOk = this.updateById((T_WORKFLOWImpl)po);
        return bOk;
    }

    /**
     * 删除数据
     * @param key 业务数据主键
     * @return
     */
    public boolean remove(String key){
        return this.removeById(key);
    }

    /**
     * 查询集合[Default]
     * @param context 查询上下文对象
     * @return
     */
    public Page<Workflow> searchDefault(WorkflowSearchContext context){
        QueryWrapper qw=queryBuilder.buildQueryWrapper(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page page=queryBuilder.buildPage(context);
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<Workflow> page_datas=t_WORKFLOWMapper.searchDefault(page,context,qw);
        List<Workflow> list_datas=queryBuilder.page2List(page_datas);
        return new PageImpl<Workflow>(list_datas, context.getPageable(), page_datas.getTotal());
    }

    /**
     * 持久层对象转业务对象
     * @param po 持久层对象
     * @param domain 业务对象
     * @return
     */
    public cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.Workflow convert2Domain( Workflow po ,cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.Workflow domain){
        if(po == null)
            return domain ;
        if(domain == null){
            domain = new cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.Workflow();
        }
        //if(po.getUpdateManDirtyFlag())
        domain.setUpdateMan(po.getUpdateMan());
        //if(po.getWorkflowIdDirtyFlag())
        domain.setWorkflowId(po.getWorkflowId());
        //if(po.getCreateDateDirtyFlag())
        domain.setCreateDate(po.getCreateDate());
        //if(po.getWorkflowNameDirtyFlag())
        domain.setWorkflowName(po.getWorkflowName());
        //if(po.getUpdateDateDirtyFlag())
        domain.setUpdateDate(po.getUpdateDate());
        //if(po.getCreateManDirtyFlag())
        domain.setCreateMan(po.getCreateMan());
        //if(po.getLogicNameDirtyFlag())
        domain.setLogicName(po.getLogicName());
        return domain ;
    }

    /**
     * 业务对象转持久层对象
     * @param domain 业务对象
     * @param po 持久层对象
     * @return
     */
    public Workflow convert2PO(cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.Workflow domain , Workflow po){
        if(domain == null)
            return po ;
        if(po==null){
            po = createPO() ;
        }
        if(domain.getUpdateManDirtyFlag())
            po.setUpdateMan(domain.getUpdateMan());
        if(domain.getWorkflowIdDirtyFlag())
            po.setWorkflowId(domain.getWorkflowId());
        if(domain.getCreateDateDirtyFlag())
            po.setCreateDate(domain.getCreateDate());
        if(domain.getWorkflowNameDirtyFlag())
            po.setWorkflowName(domain.getWorkflowName());
        if(domain.getUpdateDateDirtyFlag())
            po.setUpdateDate(domain.getUpdateDate());
        if(domain.getCreateManDirtyFlag())
            po.setCreateMan(domain.getCreateMan());
        if(domain.getLogicNameDirtyFlag())
            po.setLogicName(domain.getLogicName());

        return po ;
    }
}
