package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po;

import cn.ibizlab.r7.runtime.wf.core.repository.po.OrgDeptWFVer;
import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonIgnore;
import java.io.Serializable;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import cn.ibizlab.r7.runtime.wf.util.annotation.PreField;
import cn.ibizlab.r7.runtime.wf.util.enums.FillMode;
import cn.ibizlab.r7.runtime.wf.util.enums.PredefinedType;

/**
 * 关系型数据实体表[OrgDeptWFVer] 对象
 */
@TableName(value = "T_ORGDEPTWFVER",resultMap = "T_ORGDEPTWFVERResultMap")
public class T_ORGDEPTWFVERImpl implements OrgDeptWFVer,Serializable {

    /**
     * [建立时间]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createDate;
    /**
     * [建立时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createDateDirtyFlag;

    /**
     * [更新人]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    private String updateMan;
    /**
     * [更新人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateManDirtyFlag;

    /**
     * [部门流程版本名称]
     */
    private String orgDeptWFVerName;
    /**
     * [部门流程版本名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean orgDeptWFVerNameDirtyFlag;

    /**
     * [部门流程版本标识]
     */
    @TableId(value= "orgdeptwfverid",type=IdType.UUID)
    private String orgDeptWFVerId;
    /**
     * [部门流程版本标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean orgDeptWFVerIdDirtyFlag;

    /**
     * [开始时间]
     */
    private Timestamp startTime;
    /**
     * [开始时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean startTimeDirtyFlag;

    /**
     * [更新时间]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updateDate;
    /**
     * [更新时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateDateDirtyFlag;

    /**
     * [建立人]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    private String createMan;
    /**
     * [建立人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createManDirtyFlag;

    /**
     * [结束时间]
     */
    private Timestamp endtime;
    /**
     * [结束时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean endtimeDirtyFlag;

    /**
     * [部门名称]
     */
    private String orgDeptName;
    /**
     * [部门名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean orgDeptNameDirtyFlag;

    @TableField(exist = false)
    private String pSWFVersionName;
    /**
     * [业务流程版本名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSWFVersionNameDirtyFlag;

    @TableField(exist = false)
    private String pSWFWorkflowName;
    /**
     * [业务工作流名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSWFWorkflowNameDirtyFlag;

    /**
     * [部门标识]
     */
    private String orgDeptId;
    /**
     * [部门标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean orgDeptIdDirtyFlag;

    /**
     * [业务工作流标识]
     */
    private String pSWorkflowId;
    /**
     * [业务工作流标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSWorkflowIdDirtyFlag;

    /**
     * [业务流程版本标识]
     */
    private String pSWFVersionId;
    /**
     * [业务流程版本标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSWFVersionIdDirtyFlag;

    /**
     * 获取 [建立时间]
     */
    public Timestamp getCreateDate(){
        return this.createDate ;
    }

    /**
     * 设置 [建立时间]
     */
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [建立时间]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return this.createDateDirtyFlag ;
    }
    /**
     * 获取 [更新人]
     */
    public String getUpdateMan(){
        return this.updateMan ;
    }

    /**
     * 设置 [更新人]
     */
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [更新人]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return this.updateManDirtyFlag ;
    }
    /**
     * 获取 [部门流程版本名称]
     */
    public String getOrgDeptWFVerName(){
        return this.orgDeptWFVerName ;
    }

    /**
     * 设置 [部门流程版本名称]
     */
    public void setOrgDeptWFVerName(String  orgDeptWFVerName){
        this.orgDeptWFVerName = orgDeptWFVerName ;
        this.orgDeptWFVerNameDirtyFlag = true ;
    }

    /**
     * 获取 [部门流程版本名称]脏标记
     */
    @JsonIgnore
    public boolean getOrgDeptWFVerNameDirtyFlag(){
        return this.orgDeptWFVerNameDirtyFlag ;
    }
    /**
     * 获取 [部门流程版本标识]
     */
    public String getOrgDeptWFVerId(){
        return this.orgDeptWFVerId ;
    }

    /**
     * 设置 [部门流程版本标识]
     */
    public void setOrgDeptWFVerId(String  orgDeptWFVerId){
        this.orgDeptWFVerId = orgDeptWFVerId ;
        this.orgDeptWFVerIdDirtyFlag = true ;
    }

    /**
     * 获取 [部门流程版本标识]脏标记
     */
    @JsonIgnore
    public boolean getOrgDeptWFVerIdDirtyFlag(){
        return this.orgDeptWFVerIdDirtyFlag ;
    }
    /**
     * 获取 [开始时间]
     */
    public Timestamp getStartTime(){
        return this.startTime ;
    }

    /**
     * 设置 [开始时间]
     */
    public void setStartTime(Timestamp  startTime){
        this.startTime = startTime ;
        this.startTimeDirtyFlag = true ;
    }

    /**
     * 获取 [开始时间]脏标记
     */
    @JsonIgnore
    public boolean getStartTimeDirtyFlag(){
        return this.startTimeDirtyFlag ;
    }
    /**
     * 获取 [更新时间]
     */
    public Timestamp getUpdateDate(){
        return this.updateDate ;
    }

    /**
     * 设置 [更新时间]
     */
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [更新时间]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return this.updateDateDirtyFlag ;
    }
    /**
     * 获取 [建立人]
     */
    public String getCreateMan(){
        return this.createMan ;
    }

    /**
     * 设置 [建立人]
     */
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [建立人]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return this.createManDirtyFlag ;
    }
    /**
     * 获取 [结束时间]
     */
    public Timestamp getEndtime(){
        return this.endtime ;
    }

    /**
     * 设置 [结束时间]
     */
    public void setEndtime(Timestamp  endtime){
        this.endtime = endtime ;
        this.endtimeDirtyFlag = true ;
    }

    /**
     * 获取 [结束时间]脏标记
     */
    @JsonIgnore
    public boolean getEndtimeDirtyFlag(){
        return this.endtimeDirtyFlag ;
    }
    /**
     * 获取 [部门名称]
     */
    public String getOrgDeptName(){
        return this.orgDeptName ;
    }

    /**
     * 设置 [部门名称]
     */
    public void setOrgDeptName(String  orgDeptName){
        this.orgDeptName = orgDeptName ;
        this.orgDeptNameDirtyFlag = true ;
    }

    /**
     * 获取 [部门名称]脏标记
     */
    @JsonIgnore
    public boolean getOrgDeptNameDirtyFlag(){
        return this.orgDeptNameDirtyFlag ;
    }
    /**
     * 获取 [业务流程版本名称]
     */
    public String getPSWFVersionName(){
        return this.pSWFVersionName ;   
    }

    /**
     * 设置 [业务流程版本名称]
     */
    public void setPSWFVersionName(String  pSWFVersionName){
        this.pSWFVersionName = pSWFVersionName ;
        this.pSWFVersionNameDirtyFlag = true ;
    }

    /**
     * 获取 [业务流程版本名称]脏标记
     */
    @JsonIgnore
    public boolean getPSWFVersionNameDirtyFlag(){
        return this.pSWFVersionNameDirtyFlag ;
    }
    /**
     * 获取 [业务工作流名称]
     */
    public String getPSWFWorkflowName(){
        return this.pSWFWorkflowName ;   
    }

    /**
     * 设置 [业务工作流名称]
     */
    public void setPSWFWorkflowName(String  pSWFWorkflowName){
        this.pSWFWorkflowName = pSWFWorkflowName ;
        this.pSWFWorkflowNameDirtyFlag = true ;
    }

    /**
     * 获取 [业务工作流名称]脏标记
     */
    @JsonIgnore
    public boolean getPSWFWorkflowNameDirtyFlag(){
        return this.pSWFWorkflowNameDirtyFlag ;
    }
    /**
     * 获取 [部门标识]
     */
    public String getOrgDeptId(){
        return this.orgDeptId ;
    }

    /**
     * 设置 [部门标识]
     */
    public void setOrgDeptId(String  orgDeptId){
        this.orgDeptId = orgDeptId ;
        this.orgDeptIdDirtyFlag = true ;
    }

    /**
     * 获取 [部门标识]脏标记
     */
    @JsonIgnore
    public boolean getOrgDeptIdDirtyFlag(){
        return this.orgDeptIdDirtyFlag ;
    }
    /**
     * 获取 [业务工作流标识]
     */
    public String getPSWorkflowId(){
        return this.pSWorkflowId ;
    }

    /**
     * 设置 [业务工作流标识]
     */
    public void setPSWorkflowId(String  pSWorkflowId){
        this.pSWorkflowId = pSWorkflowId ;
        this.pSWorkflowIdDirtyFlag = true ;
    }

    /**
     * 获取 [业务工作流标识]脏标记
     */
    @JsonIgnore
    public boolean getPSWorkflowIdDirtyFlag(){
        return this.pSWorkflowIdDirtyFlag ;
    }
    /**
     * 获取 [业务流程版本标识]
     */
    public String getPSWFVersionId(){
        return this.pSWFVersionId ;
    }

    /**
     * 设置 [业务流程版本标识]
     */
    public void setPSWFVersionId(String  pSWFVersionId){
        this.pSWFVersionId = pSWFVersionId ;
        this.pSWFVersionIdDirtyFlag = true ;
    }

    /**
     * 获取 [业务流程版本标识]脏标记
     */
    @JsonIgnore
    public boolean getPSWFVersionIdDirtyFlag(){
        return this.pSWFVersionIdDirtyFlag ;
    }
}