package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po;

import cn.ibizlab.r7.runtime.wf.core.repository.po.PSDataEntity;
import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonIgnore;
import java.io.Serializable;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import cn.ibizlab.r7.runtime.wf.util.annotation.PreField;
import cn.ibizlab.r7.runtime.wf.util.enums.FillMode;
import cn.ibizlab.r7.runtime.wf.util.enums.PredefinedType;

/**
 * 关系型数据实体表[PSDataEntity] 对象
 */
@TableName(value = "T_PSDATAENTITY",resultMap = "T_PSDATAENTITYResultMap")
public class T_PSDATAENTITYImpl implements PSDataEntity,Serializable {

    /**
     * [更新人]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    private String updateMan;
    /**
     * [更新人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateManDirtyFlag;

    /**
     * [业务实体名称]
     */
    private String pSDataEntityName;
    /**
     * [业务实体名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSDataEntityNameDirtyFlag;

    /**
     * [业务实体标识]
     */
    @TableId(value= "psdataentityid",type=IdType.UUID)
    private String pSDataEntityId;
    /**
     * [业务实体标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSDataEntityIdDirtyFlag;

    /**
     * [更新时间]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updateDate;
    /**
     * [更新时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateDateDirtyFlag;

    /**
     * [代码名]
     */
    private String codename;
    /**
     * [代码名]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean codenameDirtyFlag;

    /**
     * [建立时间]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createDate;
    /**
     * [建立时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createDateDirtyFlag;

    /**
     * [建立人]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    private String createMan;
    /**
     * [建立人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createManDirtyFlag;

    /**
     * [逻辑名称]
     */
    private String logicName;
    /**
     * [逻辑名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean logicNameDirtyFlag;

    /**
     * [业务系统标识]
     */
    private String pSSystemId;
    /**
     * [业务系统标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSSystemIdDirtyFlag;

    /**
     * 获取 [更新人]
     */
    public String getUpdateMan(){
        return this.updateMan ;
    }

    /**
     * 设置 [更新人]
     */
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [更新人]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return this.updateManDirtyFlag ;
    }
    /**
     * 获取 [业务实体名称]
     */
    public String getPSDataEntityName(){
        return this.pSDataEntityName ;
    }

    /**
     * 设置 [业务实体名称]
     */
    public void setPSDataEntityName(String  pSDataEntityName){
        this.pSDataEntityName = pSDataEntityName ;
        this.pSDataEntityNameDirtyFlag = true ;
    }

    /**
     * 获取 [业务实体名称]脏标记
     */
    @JsonIgnore
    public boolean getPSDataEntityNameDirtyFlag(){
        return this.pSDataEntityNameDirtyFlag ;
    }
    /**
     * 获取 [业务实体标识]
     */
    public String getPSDataEntityId(){
        return this.pSDataEntityId ;
    }

    /**
     * 设置 [业务实体标识]
     */
    public void setPSDataEntityId(String  pSDataEntityId){
        this.pSDataEntityId = pSDataEntityId ;
        this.pSDataEntityIdDirtyFlag = true ;
    }

    /**
     * 获取 [业务实体标识]脏标记
     */
    @JsonIgnore
    public boolean getPSDataEntityIdDirtyFlag(){
        return this.pSDataEntityIdDirtyFlag ;
    }
    /**
     * 获取 [更新时间]
     */
    public Timestamp getUpdateDate(){
        return this.updateDate ;
    }

    /**
     * 设置 [更新时间]
     */
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [更新时间]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return this.updateDateDirtyFlag ;
    }
    /**
     * 获取 [代码名]
     */
    public String getCodename(){
        return this.codename ;
    }

    /**
     * 设置 [代码名]
     */
    public void setCodename(String  codename){
        this.codename = codename ;
        this.codenameDirtyFlag = true ;
    }

    /**
     * 获取 [代码名]脏标记
     */
    @JsonIgnore
    public boolean getCodenameDirtyFlag(){
        return this.codenameDirtyFlag ;
    }
    /**
     * 获取 [建立时间]
     */
    public Timestamp getCreateDate(){
        return this.createDate ;
    }

    /**
     * 设置 [建立时间]
     */
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [建立时间]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return this.createDateDirtyFlag ;
    }
    /**
     * 获取 [建立人]
     */
    public String getCreateMan(){
        return this.createMan ;
    }

    /**
     * 设置 [建立人]
     */
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [建立人]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return this.createManDirtyFlag ;
    }
    /**
     * 获取 [逻辑名称]
     */
    public String getLogicName(){
        return this.logicName ;
    }

    /**
     * 设置 [逻辑名称]
     */
    public void setLogicName(String  logicName){
        this.logicName = logicName ;
        this.logicNameDirtyFlag = true ;
    }

    /**
     * 获取 [逻辑名称]脏标记
     */
    @JsonIgnore
    public boolean getLogicNameDirtyFlag(){
        return this.logicNameDirtyFlag ;
    }
    /**
     * 获取 [业务系统标识]
     */
    public String getPSSystemId(){
        return this.pSSystemId ;
    }

    /**
     * 设置 [业务系统标识]
     */
    public void setPSSystemId(String  pSSystemId){
        this.pSSystemId = pSSystemId ;
        this.pSSystemIdDirtyFlag = true ;
    }

    /**
     * 获取 [业务系统标识]脏标记
     */
    @JsonIgnore
    public boolean getPSSystemIdDirtyFlag(){
        return this.pSSystemIdDirtyFlag ;
    }
}