package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po;

import cn.ibizlab.r7.runtime.wf.core.repository.po.PSDEWF;
import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonIgnore;
import java.io.Serializable;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import cn.ibizlab.r7.runtime.wf.util.annotation.PreField;
import cn.ibizlab.r7.runtime.wf.util.enums.FillMode;
import cn.ibizlab.r7.runtime.wf.util.enums.PredefinedType;

/**
 * 关系型数据实体表[PSDEWF] 对象
 */
@TableName(value = "T_PSDEWF",resultMap = "T_PSDEWFResultMap")
public class T_PSDEWFImpl implements PSDEWF,Serializable {

    /**
     * [错误跳转主状态]
     */
    private String errorvalue;
    /**
     * [错误跳转主状态]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean errorvalueDirtyFlag;

    /**
     * [逻辑名称]
     */
    private String logicName;
    /**
     * [逻辑名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean logicNameDirtyFlag;

    /**
     * [用户状态属性]
     */
    private String udstatefield;
    /**
     * [用户状态属性]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean udstatefieldDirtyFlag;

    /**
     * [业务实体工作流名称]
     */
    private String pSDEWFName;
    /**
     * [业务实体工作流名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSDEWFNameDirtyFlag;

    /**
     * [流程步骤属性]
     */
    private String wfstepfield;
    /**
     * [流程步骤属性]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wfstepfieldDirtyFlag;

    /**
     * [业务实体工作流标识]
     */
    @TableId(value= "psdewfid",type=IdType.UUID)
    private String pSDEWFId;
    /**
     * [业务实体工作流标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSDEWFIdDirtyFlag;

    /**
     * [处理中主状态]
     */
    private String processvalue;
    /**
     * [处理中主状态]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean processvalueDirtyFlag;

    /**
     * [工作流代理模式]
     */
    private Integer wFProxyMode;
    /**
     * [工作流代理模式]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFProxyModeDirtyFlag;

    /**
     * [流程状态属性]
     */
    private String wfstatefield;
    /**
     * [流程状态属性]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wfstatefieldDirtyFlag;

    /**
     * [建立人]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    private String createMan;
    /**
     * [建立人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createManDirtyFlag;

    /**
     * [完成跳转主状态]
     */
    private String finishvalue;
    /**
     * [完成跳转主状态]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean finishvalueDirtyFlag;

    /**
     * [更新时间]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updateDate;
    /**
     * [更新时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateDateDirtyFlag;

    /**
     * [建立时间]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createDate;
    /**
     * [建立时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createDateDirtyFlag;

    /**
     * [更新人]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    private String updateMan;
    /**
     * [更新人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateManDirtyFlag;

    /**
     * [实体代码名]
     */
    private String pSDECodeName;
    /**
     * [实体代码名]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSDECodeNameDirtyFlag;

    /**
     * [业务工作流标识]
     */
    private String pSWorkflowId;
    /**
     * [业务工作流标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSWorkflowIdDirtyFlag;

    /**
     * [业务实体标识]
     */
    private String pSDataEntityId;
    /**
     * [业务实体标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSDataEntityIdDirtyFlag;

    /**
     * 获取 [错误跳转主状态]
     */
    public String getErrorvalue(){
        return this.errorvalue ;
    }

    /**
     * 设置 [错误跳转主状态]
     */
    public void setErrorvalue(String  errorvalue){
        this.errorvalue = errorvalue ;
        this.errorvalueDirtyFlag = true ;
    }

    /**
     * 获取 [错误跳转主状态]脏标记
     */
    @JsonIgnore
    public boolean getErrorvalueDirtyFlag(){
        return this.errorvalueDirtyFlag ;
    }
    /**
     * 获取 [逻辑名称]
     */
    public String getLogicName(){
        return this.logicName ;
    }

    /**
     * 设置 [逻辑名称]
     */
    public void setLogicName(String  logicName){
        this.logicName = logicName ;
        this.logicNameDirtyFlag = true ;
    }

    /**
     * 获取 [逻辑名称]脏标记
     */
    @JsonIgnore
    public boolean getLogicNameDirtyFlag(){
        return this.logicNameDirtyFlag ;
    }
    /**
     * 获取 [用户状态属性]
     */
    public String getUdstatefield(){
        return this.udstatefield ;
    }

    /**
     * 设置 [用户状态属性]
     */
    public void setUdstatefield(String  udstatefield){
        this.udstatefield = udstatefield ;
        this.udstatefieldDirtyFlag = true ;
    }

    /**
     * 获取 [用户状态属性]脏标记
     */
    @JsonIgnore
    public boolean getUdstatefieldDirtyFlag(){
        return this.udstatefieldDirtyFlag ;
    }
    /**
     * 获取 [业务实体工作流名称]
     */
    public String getPSDEWFName(){
        return this.pSDEWFName ;
    }

    /**
     * 设置 [业务实体工作流名称]
     */
    public void setPSDEWFName(String  pSDEWFName){
        this.pSDEWFName = pSDEWFName ;
        this.pSDEWFNameDirtyFlag = true ;
    }

    /**
     * 获取 [业务实体工作流名称]脏标记
     */
    @JsonIgnore
    public boolean getPSDEWFNameDirtyFlag(){
        return this.pSDEWFNameDirtyFlag ;
    }
    /**
     * 获取 [流程步骤属性]
     */
    public String getWfstepfield(){
        return this.wfstepfield ;
    }

    /**
     * 设置 [流程步骤属性]
     */
    public void setWfstepfield(String  wfstepfield){
        this.wfstepfield = wfstepfield ;
        this.wfstepfieldDirtyFlag = true ;
    }

    /**
     * 获取 [流程步骤属性]脏标记
     */
    @JsonIgnore
    public boolean getWfstepfieldDirtyFlag(){
        return this.wfstepfieldDirtyFlag ;
    }
    /**
     * 获取 [业务实体工作流标识]
     */
    public String getPSDEWFId(){
        return this.pSDEWFId ;
    }

    /**
     * 设置 [业务实体工作流标识]
     */
    public void setPSDEWFId(String  pSDEWFId){
        this.pSDEWFId = pSDEWFId ;
        this.pSDEWFIdDirtyFlag = true ;
    }

    /**
     * 获取 [业务实体工作流标识]脏标记
     */
    @JsonIgnore
    public boolean getPSDEWFIdDirtyFlag(){
        return this.pSDEWFIdDirtyFlag ;
    }
    /**
     * 获取 [处理中主状态]
     */
    public String getProcessvalue(){
        return this.processvalue ;
    }

    /**
     * 设置 [处理中主状态]
     */
    public void setProcessvalue(String  processvalue){
        this.processvalue = processvalue ;
        this.processvalueDirtyFlag = true ;
    }

    /**
     * 获取 [处理中主状态]脏标记
     */
    @JsonIgnore
    public boolean getProcessvalueDirtyFlag(){
        return this.processvalueDirtyFlag ;
    }
    /**
     * 获取 [工作流代理模式]
     */
    public Integer getWFProxyMode(){
        return this.wFProxyMode ;
    }

    /**
     * 设置 [工作流代理模式]
     */
    public void setWFProxyMode(Integer  wFProxyMode){
        this.wFProxyMode = wFProxyMode ;
        this.wFProxyModeDirtyFlag = true ;
    }

    /**
     * 获取 [工作流代理模式]脏标记
     */
    @JsonIgnore
    public boolean getWFProxyModeDirtyFlag(){
        return this.wFProxyModeDirtyFlag ;
    }
    /**
     * 获取 [流程状态属性]
     */
    public String getWfstatefield(){
        return this.wfstatefield ;
    }

    /**
     * 设置 [流程状态属性]
     */
    public void setWfstatefield(String  wfstatefield){
        this.wfstatefield = wfstatefield ;
        this.wfstatefieldDirtyFlag = true ;
    }

    /**
     * 获取 [流程状态属性]脏标记
     */
    @JsonIgnore
    public boolean getWfstatefieldDirtyFlag(){
        return this.wfstatefieldDirtyFlag ;
    }
    /**
     * 获取 [建立人]
     */
    public String getCreateMan(){
        return this.createMan ;
    }

    /**
     * 设置 [建立人]
     */
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [建立人]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return this.createManDirtyFlag ;
    }
    /**
     * 获取 [完成跳转主状态]
     */
    public String getFinishvalue(){
        return this.finishvalue ;
    }

    /**
     * 设置 [完成跳转主状态]
     */
    public void setFinishvalue(String  finishvalue){
        this.finishvalue = finishvalue ;
        this.finishvalueDirtyFlag = true ;
    }

    /**
     * 获取 [完成跳转主状态]脏标记
     */
    @JsonIgnore
    public boolean getFinishvalueDirtyFlag(){
        return this.finishvalueDirtyFlag ;
    }
    /**
     * 获取 [更新时间]
     */
    public Timestamp getUpdateDate(){
        return this.updateDate ;
    }

    /**
     * 设置 [更新时间]
     */
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [更新时间]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return this.updateDateDirtyFlag ;
    }
    /**
     * 获取 [建立时间]
     */
    public Timestamp getCreateDate(){
        return this.createDate ;
    }

    /**
     * 设置 [建立时间]
     */
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [建立时间]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return this.createDateDirtyFlag ;
    }
    /**
     * 获取 [更新人]
     */
    public String getUpdateMan(){
        return this.updateMan ;
    }

    /**
     * 设置 [更新人]
     */
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [更新人]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return this.updateManDirtyFlag ;
    }
    /**
     * 获取 [实体代码名]
     */
    public String getPSDECodeName(){
        return this.pSDECodeName ;
    }

    /**
     * 设置 [实体代码名]
     */
    public void setPSDECodeName(String  pSDECodeName){
        this.pSDECodeName = pSDECodeName ;
        this.pSDECodeNameDirtyFlag = true ;
    }

    /**
     * 获取 [实体代码名]脏标记
     */
    @JsonIgnore
    public boolean getPSDECodeNameDirtyFlag(){
        return this.pSDECodeNameDirtyFlag ;
    }
    /**
     * 获取 [业务工作流标识]
     */
    public String getPSWorkflowId(){
        return this.pSWorkflowId ;
    }

    /**
     * 设置 [业务工作流标识]
     */
    public void setPSWorkflowId(String  pSWorkflowId){
        this.pSWorkflowId = pSWorkflowId ;
        this.pSWorkflowIdDirtyFlag = true ;
    }

    /**
     * 获取 [业务工作流标识]脏标记
     */
    @JsonIgnore
    public boolean getPSWorkflowIdDirtyFlag(){
        return this.pSWorkflowIdDirtyFlag ;
    }
    /**
     * 获取 [业务实体标识]
     */
    public String getPSDataEntityId(){
        return this.pSDataEntityId ;
    }

    /**
     * 设置 [业务实体标识]
     */
    public void setPSDataEntityId(String  pSDataEntityId){
        this.pSDataEntityId = pSDataEntityId ;
        this.pSDataEntityIdDirtyFlag = true ;
    }

    /**
     * 获取 [业务实体标识]脏标记
     */
    @JsonIgnore
    public boolean getPSDataEntityIdDirtyFlag(){
        return this.pSDataEntityIdDirtyFlag ;
    }
}