package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po;

import cn.ibizlab.r7.runtime.wf.core.repository.po.PSSystem;
import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonIgnore;
import java.io.Serializable;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import cn.ibizlab.r7.runtime.wf.util.annotation.PreField;
import cn.ibizlab.r7.runtime.wf.util.enums.FillMode;
import cn.ibizlab.r7.runtime.wf.util.enums.PredefinedType;

/**
 * 关系型数据实体表[PSSystem] 对象
 */
@TableName(value = "T_PSSYSTEM",resultMap = "T_PSSYSTEMResultMap")
public class T_PSSYSTEMImpl implements PSSystem,Serializable {

    /**
     * [更新时间]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updateDate;
    /**
     * [更新时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateDateDirtyFlag;

    /**
     * [建立人]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    private String createMan;
    /**
     * [建立人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createManDirtyFlag;

    /**
     * [根路径]
     */
    private String rootpath;
    /**
     * [根路径]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean rootpathDirtyFlag;

    /**
     * [业务系统标识]
     */
    @TableId(value= "pssystemid",type=IdType.UUID)
    private String pSSystemId;
    /**
     * [业务系统标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSSystemIdDirtyFlag;

    /**
     * [更新人]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    private String updateMan;
    /**
     * [更新人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateManDirtyFlag;

    /**
     * [服务地址]
     */
    private String serviceUrl;
    /**
     * [服务地址]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean serviceUrlDirtyFlag;

    /**
     * [服务标识]
     */
    private String serviceId;
    /**
     * [服务标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean serviceIdDirtyFlag;

    /**
     * [建立时间]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createDate;
    /**
     * [建立时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createDateDirtyFlag;

    /**
     * [逻辑名称]
     */
    private String logicName;
    /**
     * [逻辑名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean logicNameDirtyFlag;

    /**
     * [业务系统名称]
     */
    private String pSSystemName;
    /**
     * [业务系统名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSSystemNameDirtyFlag;

    @TableField(exist = false)
    private String workflowName;
    /**
     * [统一工作流名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean workflowNameDirtyFlag;

    /**
     * [部门标识]
     */
    private String orgDeptId;
    /**
     * [部门标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean orgDeptIdDirtyFlag;

    /**
     * [统一工作流标识]
     */
    private String workflowId;
    /**
     * [统一工作流标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean workflowIdDirtyFlag;

    /**
     * [组织标识]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.ORGID)
    private String orgId;
    /**
     * [组织标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean orgIdDirtyFlag;

    /**
     * 获取 [更新时间]
     */
    public Timestamp getUpdateDate(){
        return this.updateDate ;
    }

    /**
     * 设置 [更新时间]
     */
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [更新时间]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return this.updateDateDirtyFlag ;
    }
    /**
     * 获取 [建立人]
     */
    public String getCreateMan(){
        return this.createMan ;
    }

    /**
     * 设置 [建立人]
     */
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [建立人]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return this.createManDirtyFlag ;
    }
    /**
     * 获取 [根路径]
     */
    public String getRootpath(){
        return this.rootpath ;
    }

    /**
     * 设置 [根路径]
     */
    public void setRootpath(String  rootpath){
        this.rootpath = rootpath ;
        this.rootpathDirtyFlag = true ;
    }

    /**
     * 获取 [根路径]脏标记
     */
    @JsonIgnore
    public boolean getRootpathDirtyFlag(){
        return this.rootpathDirtyFlag ;
    }
    /**
     * 获取 [业务系统标识]
     */
    public String getPSSystemId(){
        return this.pSSystemId ;
    }

    /**
     * 设置 [业务系统标识]
     */
    public void setPSSystemId(String  pSSystemId){
        this.pSSystemId = pSSystemId ;
        this.pSSystemIdDirtyFlag = true ;
    }

    /**
     * 获取 [业务系统标识]脏标记
     */
    @JsonIgnore
    public boolean getPSSystemIdDirtyFlag(){
        return this.pSSystemIdDirtyFlag ;
    }
    /**
     * 获取 [更新人]
     */
    public String getUpdateMan(){
        return this.updateMan ;
    }

    /**
     * 设置 [更新人]
     */
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [更新人]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return this.updateManDirtyFlag ;
    }
    /**
     * 获取 [服务地址]
     */
    public String getServiceUrl(){
        return this.serviceUrl ;
    }

    /**
     * 设置 [服务地址]
     */
    public void setServiceUrl(String  serviceUrl){
        this.serviceUrl = serviceUrl ;
        this.serviceUrlDirtyFlag = true ;
    }

    /**
     * 获取 [服务地址]脏标记
     */
    @JsonIgnore
    public boolean getServiceUrlDirtyFlag(){
        return this.serviceUrlDirtyFlag ;
    }
    /**
     * 获取 [服务标识]
     */
    public String getServiceId(){
        return this.serviceId ;
    }

    /**
     * 设置 [服务标识]
     */
    public void setServiceId(String  serviceId){
        this.serviceId = serviceId ;
        this.serviceIdDirtyFlag = true ;
    }

    /**
     * 获取 [服务标识]脏标记
     */
    @JsonIgnore
    public boolean getServiceIdDirtyFlag(){
        return this.serviceIdDirtyFlag ;
    }
    /**
     * 获取 [建立时间]
     */
    public Timestamp getCreateDate(){
        return this.createDate ;
    }

    /**
     * 设置 [建立时间]
     */
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [建立时间]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return this.createDateDirtyFlag ;
    }
    /**
     * 获取 [逻辑名称]
     */
    public String getLogicName(){
        return this.logicName ;
    }

    /**
     * 设置 [逻辑名称]
     */
    public void setLogicName(String  logicName){
        this.logicName = logicName ;
        this.logicNameDirtyFlag = true ;
    }

    /**
     * 获取 [逻辑名称]脏标记
     */
    @JsonIgnore
    public boolean getLogicNameDirtyFlag(){
        return this.logicNameDirtyFlag ;
    }
    /**
     * 获取 [业务系统名称]
     */
    public String getPSSystemName(){
        return this.pSSystemName ;
    }

    /**
     * 设置 [业务系统名称]
     */
    public void setPSSystemName(String  pSSystemName){
        this.pSSystemName = pSSystemName ;
        this.pSSystemNameDirtyFlag = true ;
    }

    /**
     * 获取 [业务系统名称]脏标记
     */
    @JsonIgnore
    public boolean getPSSystemNameDirtyFlag(){
        return this.pSSystemNameDirtyFlag ;
    }
    /**
     * 获取 [统一工作流名称]
     */
    public String getWorkflowName(){
        return this.workflowName ;   
    }

    /**
     * 设置 [统一工作流名称]
     */
    public void setWorkflowName(String  workflowName){
        this.workflowName = workflowName ;
        this.workflowNameDirtyFlag = true ;
    }

    /**
     * 获取 [统一工作流名称]脏标记
     */
    @JsonIgnore
    public boolean getWorkflowNameDirtyFlag(){
        return this.workflowNameDirtyFlag ;
    }
    /**
     * 获取 [部门标识]
     */
    public String getOrgDeptId(){
        return this.orgDeptId ;
    }

    /**
     * 设置 [部门标识]
     */
    public void setOrgDeptId(String  orgDeptId){
        this.orgDeptId = orgDeptId ;
        this.orgDeptIdDirtyFlag = true ;
    }

    /**
     * 获取 [部门标识]脏标记
     */
    @JsonIgnore
    public boolean getOrgDeptIdDirtyFlag(){
        return this.orgDeptIdDirtyFlag ;
    }
    /**
     * 获取 [统一工作流标识]
     */
    public String getWorkflowId(){
        return this.workflowId ;
    }

    /**
     * 设置 [统一工作流标识]
     */
    public void setWorkflowId(String  workflowId){
        this.workflowId = workflowId ;
        this.workflowIdDirtyFlag = true ;
    }

    /**
     * 获取 [统一工作流标识]脏标记
     */
    @JsonIgnore
    public boolean getWorkflowIdDirtyFlag(){
        return this.workflowIdDirtyFlag ;
    }
    /**
     * 获取 [组织标识]
     */
    public String getOrgId(){
        return this.orgId ;
    }

    /**
     * 设置 [组织标识]
     */
    public void setOrgId(String  orgId){
        this.orgId = orgId ;
        this.orgIdDirtyFlag = true ;
    }

    /**
     * 获取 [组织标识]脏标记
     */
    @JsonIgnore
    public boolean getOrgIdDirtyFlag(){
        return this.orgIdDirtyFlag ;
    }
}