package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po;

import cn.ibizlab.r7.runtime.wf.core.repository.po.PSSysWFCat;
import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonIgnore;
import java.io.Serializable;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import cn.ibizlab.r7.runtime.wf.util.annotation.PreField;
import cn.ibizlab.r7.runtime.wf.util.enums.FillMode;
import cn.ibizlab.r7.runtime.wf.util.enums.PredefinedType;

/**
 * 关系型数据实体表[PSSysWFCat] 对象
 */
@TableName(value = "T_PSSYSWFCAT",resultMap = "T_PSSYSWFCATResultMap")
public class T_PSSYSWFCATImpl implements PSSysWFCat,Serializable {

    /**
     * [更新时间]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updateDate;
    /**
     * [更新时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateDateDirtyFlag;

    /**
     * [系统流程分类标识]
     */
    @TableId(value= "pssyswfcatid",type=IdType.UUID)
    private String pSSysWFCatId;
    /**
     * [系统流程分类标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSSysWFCatIdDirtyFlag;

    /**
     * [系统流程分类名称]
     */
    private String pSSysWFCatName;
    /**
     * [系统流程分类名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSSysWFCatNameDirtyFlag;

    /**
     * [建立时间]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createDate;
    /**
     * [建立时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createDateDirtyFlag;

    /**
     * [建立人]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    private String createMan;
    /**
     * [建立人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createManDirtyFlag;

    /**
     * [更新人]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    private String updateMan;
    /**
     * [更新人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateManDirtyFlag;

    /**
     * 获取 [更新时间]
     */
    public Timestamp getUpdateDate(){
        return this.updateDate ;
    }

    /**
     * 设置 [更新时间]
     */
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [更新时间]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return this.updateDateDirtyFlag ;
    }
    /**
     * 获取 [系统流程分类标识]
     */
    public String getPSSysWFCatId(){
        return this.pSSysWFCatId ;
    }

    /**
     * 设置 [系统流程分类标识]
     */
    public void setPSSysWFCatId(String  pSSysWFCatId){
        this.pSSysWFCatId = pSSysWFCatId ;
        this.pSSysWFCatIdDirtyFlag = true ;
    }

    /**
     * 获取 [系统流程分类标识]脏标记
     */
    @JsonIgnore
    public boolean getPSSysWFCatIdDirtyFlag(){
        return this.pSSysWFCatIdDirtyFlag ;
    }
    /**
     * 获取 [系统流程分类名称]
     */
    public String getPSSysWFCatName(){
        return this.pSSysWFCatName ;
    }

    /**
     * 设置 [系统流程分类名称]
     */
    public void setPSSysWFCatName(String  pSSysWFCatName){
        this.pSSysWFCatName = pSSysWFCatName ;
        this.pSSysWFCatNameDirtyFlag = true ;
    }

    /**
     * 获取 [系统流程分类名称]脏标记
     */
    @JsonIgnore
    public boolean getPSSysWFCatNameDirtyFlag(){
        return this.pSSysWFCatNameDirtyFlag ;
    }
    /**
     * 获取 [建立时间]
     */
    public Timestamp getCreateDate(){
        return this.createDate ;
    }

    /**
     * 设置 [建立时间]
     */
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [建立时间]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return this.createDateDirtyFlag ;
    }
    /**
     * 获取 [建立人]
     */
    public String getCreateMan(){
        return this.createMan ;
    }

    /**
     * 设置 [建立人]
     */
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [建立人]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return this.createManDirtyFlag ;
    }
    /**
     * 获取 [更新人]
     */
    public String getUpdateMan(){
        return this.updateMan ;
    }

    /**
     * 设置 [更新人]
     */
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [更新人]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return this.updateManDirtyFlag ;
    }
}