package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po;

import cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFLink;
import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonIgnore;
import java.io.Serializable;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import cn.ibizlab.r7.runtime.wf.util.annotation.PreField;
import cn.ibizlab.r7.runtime.wf.util.enums.FillMode;
import cn.ibizlab.r7.runtime.wf.util.enums.PredefinedType;

/**
 * 关系型数据实体表[PSWFLink] 对象
 */
@TableName(value = "T_PSWFLINK",resultMap = "T_PSWFLINKResultMap")
public class T_PSWFLINKImpl implements PSWFLink,Serializable {

    /**
     * [更新时间]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updateDate;
    /**
     * [更新时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateDateDirtyFlag;

    /**
     * [逻辑名称]
     */
    private String logicName;
    /**
     * [逻辑名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean logicNameDirtyFlag;

    /**
     * [建立时间]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createDate;
    /**
     * [建立时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createDateDirtyFlag;

    /**
     * [流程连接标识]
     */
    @TableId(value= "pswflinkid",type=IdType.UUID)
    private String pSWFLinkId;
    /**
     * [流程连接标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSWFLinkIdDirtyFlag;

    /**
     * [更新人]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    private String updateMan;
    /**
     * [更新人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateManDirtyFlag;

    /**
     * [建立人]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    private String createMan;
    /**
     * [建立人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createManDirtyFlag;

    /**
     * [流程连接名称]
     */
    private String pSWFLinkName;
    /**
     * [流程连接名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSWFLinkNameDirtyFlag;

    /**
     * [流程处理标识]
     */
    private String frompswfprocid;
    /**
     * [流程处理标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean frompswfprocidDirtyFlag;

    /**
     * [业务流程版本标识]
     */
    private String pSWFVersionId;
    /**
     * [业务流程版本标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSWFVersionIdDirtyFlag;

    /**
     * [流程处理标识]
     */
    private String topswfprocid;
    /**
     * [流程处理标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean topswfprocidDirtyFlag;

    /**
     * 获取 [更新时间]
     */
    public Timestamp getUpdateDate(){
        return this.updateDate ;
    }

    /**
     * 设置 [更新时间]
     */
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [更新时间]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return this.updateDateDirtyFlag ;
    }
    /**
     * 获取 [逻辑名称]
     */
    public String getLogicName(){
        return this.logicName ;
    }

    /**
     * 设置 [逻辑名称]
     */
    public void setLogicName(String  logicName){
        this.logicName = logicName ;
        this.logicNameDirtyFlag = true ;
    }

    /**
     * 获取 [逻辑名称]脏标记
     */
    @JsonIgnore
    public boolean getLogicNameDirtyFlag(){
        return this.logicNameDirtyFlag ;
    }
    /**
     * 获取 [建立时间]
     */
    public Timestamp getCreateDate(){
        return this.createDate ;
    }

    /**
     * 设置 [建立时间]
     */
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [建立时间]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return this.createDateDirtyFlag ;
    }
    /**
     * 获取 [流程连接标识]
     */
    public String getPSWFLinkId(){
        return this.pSWFLinkId ;
    }

    /**
     * 设置 [流程连接标识]
     */
    public void setPSWFLinkId(String  pSWFLinkId){
        this.pSWFLinkId = pSWFLinkId ;
        this.pSWFLinkIdDirtyFlag = true ;
    }

    /**
     * 获取 [流程连接标识]脏标记
     */
    @JsonIgnore
    public boolean getPSWFLinkIdDirtyFlag(){
        return this.pSWFLinkIdDirtyFlag ;
    }
    /**
     * 获取 [更新人]
     */
    public String getUpdateMan(){
        return this.updateMan ;
    }

    /**
     * 设置 [更新人]
     */
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [更新人]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return this.updateManDirtyFlag ;
    }
    /**
     * 获取 [建立人]
     */
    public String getCreateMan(){
        return this.createMan ;
    }

    /**
     * 设置 [建立人]
     */
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [建立人]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return this.createManDirtyFlag ;
    }
    /**
     * 获取 [流程连接名称]
     */
    public String getPSWFLinkName(){
        return this.pSWFLinkName ;
    }

    /**
     * 设置 [流程连接名称]
     */
    public void setPSWFLinkName(String  pSWFLinkName){
        this.pSWFLinkName = pSWFLinkName ;
        this.pSWFLinkNameDirtyFlag = true ;
    }

    /**
     * 获取 [流程连接名称]脏标记
     */
    @JsonIgnore
    public boolean getPSWFLinkNameDirtyFlag(){
        return this.pSWFLinkNameDirtyFlag ;
    }
    /**
     * 获取 [流程处理标识]
     */
    public String getFrompswfprocid(){
        return this.frompswfprocid ;
    }

    /**
     * 设置 [流程处理标识]
     */
    public void setFrompswfprocid(String  frompswfprocid){
        this.frompswfprocid = frompswfprocid ;
        this.frompswfprocidDirtyFlag = true ;
    }

    /**
     * 获取 [流程处理标识]脏标记
     */
    @JsonIgnore
    public boolean getFrompswfprocidDirtyFlag(){
        return this.frompswfprocidDirtyFlag ;
    }
    /**
     * 获取 [业务流程版本标识]
     */
    public String getPSWFVersionId(){
        return this.pSWFVersionId ;
    }

    /**
     * 设置 [业务流程版本标识]
     */
    public void setPSWFVersionId(String  pSWFVersionId){
        this.pSWFVersionId = pSWFVersionId ;
        this.pSWFVersionIdDirtyFlag = true ;
    }

    /**
     * 获取 [业务流程版本标识]脏标记
     */
    @JsonIgnore
    public boolean getPSWFVersionIdDirtyFlag(){
        return this.pSWFVersionIdDirtyFlag ;
    }
    /**
     * 获取 [流程处理标识]
     */
    public String getTopswfprocid(){
        return this.topswfprocid ;
    }

    /**
     * 设置 [流程处理标识]
     */
    public void setTopswfprocid(String  topswfprocid){
        this.topswfprocid = topswfprocid ;
        this.topswfprocidDirtyFlag = true ;
    }

    /**
     * 获取 [流程处理标识]脏标记
     */
    @JsonIgnore
    public boolean getTopswfprocidDirtyFlag(){
        return this.topswfprocidDirtyFlag ;
    }
}