package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po;

import cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFProcess;
import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonIgnore;
import java.io.Serializable;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import cn.ibizlab.r7.runtime.wf.util.annotation.PreField;
import cn.ibizlab.r7.runtime.wf.util.enums.FillMode;
import cn.ibizlab.r7.runtime.wf.util.enums.PredefinedType;

/**
 * 关系型数据实体表[PSWFProcess] 对象
 */
@TableName(value = "T_PSWFPROCESS",resultMap = "T_PSWFPROCESSResultMap")
public class T_PSWFPROCESSImpl implements PSWFProcess,Serializable {

    /**
     * [更新人]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    private String updateMan;
    /**
     * [更新人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateManDirtyFlag;

    /**
     * [建立人]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    private String createMan;
    /**
     * [建立人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createManDirtyFlag;

    /**
     * [预定义行为]
     */
    private String preDefinedActions;
    /**
     * [预定义行为]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean preDefinedActionsDirtyFlag;

    /**
     * [处理类型]
     */
    private String wFProcessType;
    /**
     * [处理类型]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFProcessTypeDirtyFlag;

    /**
     * [流程处理名称]
     */
    private String pSWFProcessName;
    /**
     * [流程处理名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSWFProcessNameDirtyFlag;

    /**
     * [流程处理标识]
     */
    @TableId(value= "pswfprocessid",type=IdType.UUID)
    private String pSWFProcessId;
    /**
     * [流程处理标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSWFProcessIdDirtyFlag;

    /**
     * [更新时间]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updateDate;
    /**
     * [更新时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateDateDirtyFlag;

    /**
     * [步骤值]
     */
    private String wFStepValue;
    /**
     * [步骤值]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFStepValueDirtyFlag;

    /**
     * [多实例模式]
     */
    private String multiInstMode;
    /**
     * [多实例模式]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean multiInstModeDirtyFlag;

    /**
     * [建立时间]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createDate;
    /**
     * [建立时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createDateDirtyFlag;

    /**
     * [步骤名称]
     */
    private String wFStepName;
    /**
     * [步骤名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFStepNameDirtyFlag;

    @TableField(exist = false)
    private String pSWFVersionName;
    /**
     * [业务流程版本名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSWFVersionNameDirtyFlag;

    /**
     * [业务工作流标识]
     */
    private String targetpswfid;
    /**
     * [业务工作流标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean targetpswfidDirtyFlag;

    /**
     * [业务流程版本标识]
     */
    private String pSWFVersionId;
    /**
     * [业务流程版本标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSWFVersionIdDirtyFlag;

    /**
     * 获取 [更新人]
     */
    public String getUpdateMan(){
        return this.updateMan ;
    }

    /**
     * 设置 [更新人]
     */
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [更新人]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return this.updateManDirtyFlag ;
    }
    /**
     * 获取 [建立人]
     */
    public String getCreateMan(){
        return this.createMan ;
    }

    /**
     * 设置 [建立人]
     */
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [建立人]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return this.createManDirtyFlag ;
    }
    /**
     * 获取 [预定义行为]
     */
    public String getPreDefinedActions(){
        return this.preDefinedActions ;
    }

    /**
     * 设置 [预定义行为]
     */
    public void setPreDefinedActions(String  preDefinedActions){
        this.preDefinedActions = preDefinedActions ;
        this.preDefinedActionsDirtyFlag = true ;
    }

    /**
     * 获取 [预定义行为]脏标记
     */
    @JsonIgnore
    public boolean getPreDefinedActionsDirtyFlag(){
        return this.preDefinedActionsDirtyFlag ;
    }
    /**
     * 获取 [处理类型]
     */
    public String getWFProcessType(){
        return this.wFProcessType ;
    }

    /**
     * 设置 [处理类型]
     */
    public void setWFProcessType(String  wFProcessType){
        this.wFProcessType = wFProcessType ;
        this.wFProcessTypeDirtyFlag = true ;
    }

    /**
     * 获取 [处理类型]脏标记
     */
    @JsonIgnore
    public boolean getWFProcessTypeDirtyFlag(){
        return this.wFProcessTypeDirtyFlag ;
    }
    /**
     * 获取 [流程处理名称]
     */
    public String getPSWFProcessName(){
        return this.pSWFProcessName ;
    }

    /**
     * 设置 [流程处理名称]
     */
    public void setPSWFProcessName(String  pSWFProcessName){
        this.pSWFProcessName = pSWFProcessName ;
        this.pSWFProcessNameDirtyFlag = true ;
    }

    /**
     * 获取 [流程处理名称]脏标记
     */
    @JsonIgnore
    public boolean getPSWFProcessNameDirtyFlag(){
        return this.pSWFProcessNameDirtyFlag ;
    }
    /**
     * 获取 [流程处理标识]
     */
    public String getPSWFProcessId(){
        return this.pSWFProcessId ;
    }

    /**
     * 设置 [流程处理标识]
     */
    public void setPSWFProcessId(String  pSWFProcessId){
        this.pSWFProcessId = pSWFProcessId ;
        this.pSWFProcessIdDirtyFlag = true ;
    }

    /**
     * 获取 [流程处理标识]脏标记
     */
    @JsonIgnore
    public boolean getPSWFProcessIdDirtyFlag(){
        return this.pSWFProcessIdDirtyFlag ;
    }
    /**
     * 获取 [更新时间]
     */
    public Timestamp getUpdateDate(){
        return this.updateDate ;
    }

    /**
     * 设置 [更新时间]
     */
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [更新时间]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return this.updateDateDirtyFlag ;
    }
    /**
     * 获取 [步骤值]
     */
    public String getWFStepValue(){
        return this.wFStepValue ;
    }

    /**
     * 设置 [步骤值]
     */
    public void setWFStepValue(String  wFStepValue){
        this.wFStepValue = wFStepValue ;
        this.wFStepValueDirtyFlag = true ;
    }

    /**
     * 获取 [步骤值]脏标记
     */
    @JsonIgnore
    public boolean getWFStepValueDirtyFlag(){
        return this.wFStepValueDirtyFlag ;
    }
    /**
     * 获取 [多实例模式]
     */
    public String getMultiInstMode(){
        return this.multiInstMode ;
    }

    /**
     * 设置 [多实例模式]
     */
    public void setMultiInstMode(String  multiInstMode){
        this.multiInstMode = multiInstMode ;
        this.multiInstModeDirtyFlag = true ;
    }

    /**
     * 获取 [多实例模式]脏标记
     */
    @JsonIgnore
    public boolean getMultiInstModeDirtyFlag(){
        return this.multiInstModeDirtyFlag ;
    }
    /**
     * 获取 [建立时间]
     */
    public Timestamp getCreateDate(){
        return this.createDate ;
    }

    /**
     * 设置 [建立时间]
     */
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [建立时间]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return this.createDateDirtyFlag ;
    }
    /**
     * 获取 [步骤名称]
     */
    public String getWFStepName(){
        return this.wFStepName ;
    }

    /**
     * 设置 [步骤名称]
     */
    public void setWFStepName(String  wFStepName){
        this.wFStepName = wFStepName ;
        this.wFStepNameDirtyFlag = true ;
    }

    /**
     * 获取 [步骤名称]脏标记
     */
    @JsonIgnore
    public boolean getWFStepNameDirtyFlag(){
        return this.wFStepNameDirtyFlag ;
    }
    /**
     * 获取 [业务流程版本名称]
     */
    public String getPSWFVersionName(){
        return this.pSWFVersionName ;   
    }

    /**
     * 设置 [业务流程版本名称]
     */
    public void setPSWFVersionName(String  pSWFVersionName){
        this.pSWFVersionName = pSWFVersionName ;
        this.pSWFVersionNameDirtyFlag = true ;
    }

    /**
     * 获取 [业务流程版本名称]脏标记
     */
    @JsonIgnore
    public boolean getPSWFVersionNameDirtyFlag(){
        return this.pSWFVersionNameDirtyFlag ;
    }
    /**
     * 获取 [业务工作流标识]
     */
    public String getTargetpswfid(){
        return this.targetpswfid ;
    }

    /**
     * 设置 [业务工作流标识]
     */
    public void setTargetpswfid(String  targetpswfid){
        this.targetpswfid = targetpswfid ;
        this.targetpswfidDirtyFlag = true ;
    }

    /**
     * 获取 [业务工作流标识]脏标记
     */
    @JsonIgnore
    public boolean getTargetpswfidDirtyFlag(){
        return this.targetpswfidDirtyFlag ;
    }
    /**
     * 获取 [业务流程版本标识]
     */
    public String getPSWFVersionId(){
        return this.pSWFVersionId ;
    }

    /**
     * 设置 [业务流程版本标识]
     */
    public void setPSWFVersionId(String  pSWFVersionId){
        this.pSWFVersionId = pSWFVersionId ;
        this.pSWFVersionIdDirtyFlag = true ;
    }

    /**
     * 获取 [业务流程版本标识]脏标记
     */
    @JsonIgnore
    public boolean getPSWFVersionIdDirtyFlag(){
        return this.pSWFVersionIdDirtyFlag ;
    }
}