package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po;

import cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFProcRole;
import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonIgnore;
import java.io.Serializable;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import cn.ibizlab.r7.runtime.wf.util.annotation.PreField;
import cn.ibizlab.r7.runtime.wf.util.enums.FillMode;
import cn.ibizlab.r7.runtime.wf.util.enums.PredefinedType;

/**
 * 关系型数据实体表[PSWFProcRole] 对象
 */
@TableName(value = "T_PSWFPROCROLE",resultMap = "T_PSWFPROCROLEResultMap")
public class T_PSWFPROCROLEImpl implements PSWFProcRole,Serializable {

    /**
     * [角色类型]
     */
    private String roleType;
    /**
     * [角色类型]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean roleTypeDirtyFlag;

    /**
     * [建立时间]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createDate;
    /**
     * [建立时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createDateDirtyFlag;

    /**
     * [数据对象属性名称]
     */
    private String udfield;
    /**
     * [数据对象属性名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean udfieldDirtyFlag;

    /**
     * [流程处理角色名称]
     */
    private String pSWFProcRoleName;
    /**
     * [流程处理角色名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSWFProcRoleNameDirtyFlag;

    /**
     * [建立人]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    private String createMan;
    /**
     * [建立人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createManDirtyFlag;

    /**
     * [更新时间]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updateDate;
    /**
     * [更新时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateDateDirtyFlag;

    /**
     * [更新人]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    private String updateMan;
    /**
     * [更新人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateManDirtyFlag;

    /**
     * [流程处理角色标识]
     */
    @TableId(value= "pswfprocroleid",type=IdType.UUID)
    private String pSWFProcRoleId;
    /**
     * [流程处理角色标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSWFProcRoleIdDirtyFlag;

    @TableField(exist = false)
    private String pSWFProcessName;
    /**
     * [流程处理名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSWFProcessNameDirtyFlag;

    /**
     * [流程处理标识]
     */
    private String pSWFProcessId;
    /**
     * [流程处理标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSWFProcessIdDirtyFlag;

    /**
     * [平台流程角色标识]
     */
    private String pSWFRoleId;
    /**
     * [平台流程角色标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSWFRoleIdDirtyFlag;

    /**
     * 获取 [角色类型]
     */
    public String getRoleType(){
        return this.roleType ;
    }

    /**
     * 设置 [角色类型]
     */
    public void setRoleType(String  roleType){
        this.roleType = roleType ;
        this.roleTypeDirtyFlag = true ;
    }

    /**
     * 获取 [角色类型]脏标记
     */
    @JsonIgnore
    public boolean getRoleTypeDirtyFlag(){
        return this.roleTypeDirtyFlag ;
    }
    /**
     * 获取 [建立时间]
     */
    public Timestamp getCreateDate(){
        return this.createDate ;
    }

    /**
     * 设置 [建立时间]
     */
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [建立时间]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return this.createDateDirtyFlag ;
    }
    /**
     * 获取 [数据对象属性名称]
     */
    public String getUdfield(){
        return this.udfield ;
    }

    /**
     * 设置 [数据对象属性名称]
     */
    public void setUdfield(String  udfield){
        this.udfield = udfield ;
        this.udfieldDirtyFlag = true ;
    }

    /**
     * 获取 [数据对象属性名称]脏标记
     */
    @JsonIgnore
    public boolean getUdfieldDirtyFlag(){
        return this.udfieldDirtyFlag ;
    }
    /**
     * 获取 [流程处理角色名称]
     */
    public String getPSWFProcRoleName(){
        return this.pSWFProcRoleName ;
    }

    /**
     * 设置 [流程处理角色名称]
     */
    public void setPSWFProcRoleName(String  pSWFProcRoleName){
        this.pSWFProcRoleName = pSWFProcRoleName ;
        this.pSWFProcRoleNameDirtyFlag = true ;
    }

    /**
     * 获取 [流程处理角色名称]脏标记
     */
    @JsonIgnore
    public boolean getPSWFProcRoleNameDirtyFlag(){
        return this.pSWFProcRoleNameDirtyFlag ;
    }
    /**
     * 获取 [建立人]
     */
    public String getCreateMan(){
        return this.createMan ;
    }

    /**
     * 设置 [建立人]
     */
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [建立人]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return this.createManDirtyFlag ;
    }
    /**
     * 获取 [更新时间]
     */
    public Timestamp getUpdateDate(){
        return this.updateDate ;
    }

    /**
     * 设置 [更新时间]
     */
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [更新时间]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return this.updateDateDirtyFlag ;
    }
    /**
     * 获取 [更新人]
     */
    public String getUpdateMan(){
        return this.updateMan ;
    }

    /**
     * 设置 [更新人]
     */
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [更新人]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return this.updateManDirtyFlag ;
    }
    /**
     * 获取 [流程处理角色标识]
     */
    public String getPSWFProcRoleId(){
        return this.pSWFProcRoleId ;
    }

    /**
     * 设置 [流程处理角色标识]
     */
    public void setPSWFProcRoleId(String  pSWFProcRoleId){
        this.pSWFProcRoleId = pSWFProcRoleId ;
        this.pSWFProcRoleIdDirtyFlag = true ;
    }

    /**
     * 获取 [流程处理角色标识]脏标记
     */
    @JsonIgnore
    public boolean getPSWFProcRoleIdDirtyFlag(){
        return this.pSWFProcRoleIdDirtyFlag ;
    }
    /**
     * 获取 [流程处理名称]
     */
    public String getPSWFProcessName(){
        return this.pSWFProcessName ;   
    }

    /**
     * 设置 [流程处理名称]
     */
    public void setPSWFProcessName(String  pSWFProcessName){
        this.pSWFProcessName = pSWFProcessName ;
        this.pSWFProcessNameDirtyFlag = true ;
    }

    /**
     * 获取 [流程处理名称]脏标记
     */
    @JsonIgnore
    public boolean getPSWFProcessNameDirtyFlag(){
        return this.pSWFProcessNameDirtyFlag ;
    }
    /**
     * 获取 [流程处理标识]
     */
    public String getPSWFProcessId(){
        return this.pSWFProcessId ;
    }

    /**
     * 设置 [流程处理标识]
     */
    public void setPSWFProcessId(String  pSWFProcessId){
        this.pSWFProcessId = pSWFProcessId ;
        this.pSWFProcessIdDirtyFlag = true ;
    }

    /**
     * 获取 [流程处理标识]脏标记
     */
    @JsonIgnore
    public boolean getPSWFProcessIdDirtyFlag(){
        return this.pSWFProcessIdDirtyFlag ;
    }
    /**
     * 获取 [平台流程角色标识]
     */
    public String getPSWFRoleId(){
        return this.pSWFRoleId ;
    }

    /**
     * 设置 [平台流程角色标识]
     */
    public void setPSWFRoleId(String  pSWFRoleId){
        this.pSWFRoleId = pSWFRoleId ;
        this.pSWFRoleIdDirtyFlag = true ;
    }

    /**
     * 获取 [平台流程角色标识]脏标记
     */
    @JsonIgnore
    public boolean getPSWFRoleIdDirtyFlag(){
        return this.pSWFRoleIdDirtyFlag ;
    }
}