package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po;

import cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRoleDetail;
import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonIgnore;
import java.io.Serializable;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import cn.ibizlab.r7.runtime.wf.util.annotation.PreField;
import cn.ibizlab.r7.runtime.wf.util.enums.FillMode;
import cn.ibizlab.r7.runtime.wf.util.enums.PredefinedType;

/**
 * 关系型数据实体表[PSWFRoleDetail] 对象
 */
@TableName(value = "T_PSWFROLEDETAIL",resultMap = "T_PSWFROLEDETAILResultMap")
public class T_PSWFROLEDETAILImpl implements PSWFRoleDetail,Serializable {

    /**
     * [更新人]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    private String updateMan;
    /**
     * [更新人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateManDirtyFlag;

    /**
     * [开始时间]
     */
    private Timestamp startTime;
    /**
     * [开始时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean startTimeDirtyFlag;

    /**
     * [建立人]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    private String createMan;
    /**
     * [建立人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createManDirtyFlag;

    /**
     * [平台流程角色成员标识]
     */
    @TableId(value= "pswfroledetailid",type=IdType.UUID)
    private String pSWFRoleDetailId;
    /**
     * [平台流程角色成员标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSWFRoleDetailIdDirtyFlag;

    /**
     * [角色成员名称]
     */
    private String pSWFRoleDetailName;
    /**
     * [角色成员名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSWFRoleDetailNameDirtyFlag;

    /**
     * [更新时间]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updateDate;
    /**
     * [更新时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateDateDirtyFlag;

    /**
     * [结束时间]
     */
    private Timestamp endtime;
    /**
     * [结束时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean endtimeDirtyFlag;

    /**
     * [建立时间]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createDate;
    /**
     * [建立时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createDateDirtyFlag;

    /**
     * [部门名称]
     */
    private String orgDeptName;
    /**
     * [部门名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean orgDeptNameDirtyFlag;

    /**
     * [用户名称]
     */
    private String orgUserName;
    /**
     * [用户名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean orgUserNameDirtyFlag;

    /**
     * [组织名称]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.ORGNAME)
    private String orgName;
    /**
     * [组织名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean orgNameDirtyFlag;

    /**
     * [组织用户标识]
     */
    private String orgUserId;
    /**
     * [组织用户标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean orgUserIdDirtyFlag;

    /**
     * [组织标识]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.ORGID)
    private String orgId;
    /**
     * [组织标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean orgIdDirtyFlag;

    /**
     * [部门标识]
     */
    private String orgDeptId;
    /**
     * [部门标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean orgDeptIdDirtyFlag;

    /**
     * [平台流程角色标识]
     */
    private String pSWFRoleId;
    /**
     * [平台流程角色标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSWFRoleIdDirtyFlag;

    /**
     * 获取 [更新人]
     */
    public String getUpdateMan(){
        return this.updateMan ;
    }

    /**
     * 设置 [更新人]
     */
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [更新人]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return this.updateManDirtyFlag ;
    }
    /**
     * 获取 [开始时间]
     */
    public Timestamp getStartTime(){
        return this.startTime ;
    }

    /**
     * 设置 [开始时间]
     */
    public void setStartTime(Timestamp  startTime){
        this.startTime = startTime ;
        this.startTimeDirtyFlag = true ;
    }

    /**
     * 获取 [开始时间]脏标记
     */
    @JsonIgnore
    public boolean getStartTimeDirtyFlag(){
        return this.startTimeDirtyFlag ;
    }
    /**
     * 获取 [建立人]
     */
    public String getCreateMan(){
        return this.createMan ;
    }

    /**
     * 设置 [建立人]
     */
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [建立人]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return this.createManDirtyFlag ;
    }
    /**
     * 获取 [平台流程角色成员标识]
     */
    public String getPSWFRoleDetailId(){
        return this.pSWFRoleDetailId ;
    }

    /**
     * 设置 [平台流程角色成员标识]
     */
    public void setPSWFRoleDetailId(String  pSWFRoleDetailId){
        this.pSWFRoleDetailId = pSWFRoleDetailId ;
        this.pSWFRoleDetailIdDirtyFlag = true ;
    }

    /**
     * 获取 [平台流程角色成员标识]脏标记
     */
    @JsonIgnore
    public boolean getPSWFRoleDetailIdDirtyFlag(){
        return this.pSWFRoleDetailIdDirtyFlag ;
    }
    /**
     * 获取 [角色成员名称]
     */
    public String getPSWFRoleDetailName(){
        return this.pSWFRoleDetailName ;
    }

    /**
     * 设置 [角色成员名称]
     */
    public void setPSWFRoleDetailName(String  pSWFRoleDetailName){
        this.pSWFRoleDetailName = pSWFRoleDetailName ;
        this.pSWFRoleDetailNameDirtyFlag = true ;
    }

    /**
     * 获取 [角色成员名称]脏标记
     */
    @JsonIgnore
    public boolean getPSWFRoleDetailNameDirtyFlag(){
        return this.pSWFRoleDetailNameDirtyFlag ;
    }
    /**
     * 获取 [更新时间]
     */
    public Timestamp getUpdateDate(){
        return this.updateDate ;
    }

    /**
     * 设置 [更新时间]
     */
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [更新时间]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return this.updateDateDirtyFlag ;
    }
    /**
     * 获取 [结束时间]
     */
    public Timestamp getEndtime(){
        return this.endtime ;
    }

    /**
     * 设置 [结束时间]
     */
    public void setEndtime(Timestamp  endtime){
        this.endtime = endtime ;
        this.endtimeDirtyFlag = true ;
    }

    /**
     * 获取 [结束时间]脏标记
     */
    @JsonIgnore
    public boolean getEndtimeDirtyFlag(){
        return this.endtimeDirtyFlag ;
    }
    /**
     * 获取 [建立时间]
     */
    public Timestamp getCreateDate(){
        return this.createDate ;
    }

    /**
     * 设置 [建立时间]
     */
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [建立时间]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return this.createDateDirtyFlag ;
    }
    /**
     * 获取 [部门名称]
     */
    public String getOrgDeptName(){
        return this.orgDeptName ;
    }

    /**
     * 设置 [部门名称]
     */
    public void setOrgDeptName(String  orgDeptName){
        this.orgDeptName = orgDeptName ;
        this.orgDeptNameDirtyFlag = true ;
    }

    /**
     * 获取 [部门名称]脏标记
     */
    @JsonIgnore
    public boolean getOrgDeptNameDirtyFlag(){
        return this.orgDeptNameDirtyFlag ;
    }
    /**
     * 获取 [用户名称]
     */
    public String getOrgUserName(){
        return this.orgUserName ;
    }

    /**
     * 设置 [用户名称]
     */
    public void setOrgUserName(String  orgUserName){
        this.orgUserName = orgUserName ;
        this.orgUserNameDirtyFlag = true ;
    }

    /**
     * 获取 [用户名称]脏标记
     */
    @JsonIgnore
    public boolean getOrgUserNameDirtyFlag(){
        return this.orgUserNameDirtyFlag ;
    }
    /**
     * 获取 [组织名称]
     */
    public String getOrgName(){
        return this.orgName ;
    }

    /**
     * 设置 [组织名称]
     */
    public void setOrgName(String  orgName){
        this.orgName = orgName ;
        this.orgNameDirtyFlag = true ;
    }

    /**
     * 获取 [组织名称]脏标记
     */
    @JsonIgnore
    public boolean getOrgNameDirtyFlag(){
        return this.orgNameDirtyFlag ;
    }
    /**
     * 获取 [组织用户标识]
     */
    public String getOrgUserId(){
        return this.orgUserId ;
    }

    /**
     * 设置 [组织用户标识]
     */
    public void setOrgUserId(String  orgUserId){
        this.orgUserId = orgUserId ;
        this.orgUserIdDirtyFlag = true ;
    }

    /**
     * 获取 [组织用户标识]脏标记
     */
    @JsonIgnore
    public boolean getOrgUserIdDirtyFlag(){
        return this.orgUserIdDirtyFlag ;
    }
    /**
     * 获取 [组织标识]
     */
    public String getOrgId(){
        return this.orgId ;
    }

    /**
     * 设置 [组织标识]
     */
    public void setOrgId(String  orgId){
        this.orgId = orgId ;
        this.orgIdDirtyFlag = true ;
    }

    /**
     * 获取 [组织标识]脏标记
     */
    @JsonIgnore
    public boolean getOrgIdDirtyFlag(){
        return this.orgIdDirtyFlag ;
    }
    /**
     * 获取 [部门标识]
     */
    public String getOrgDeptId(){
        return this.orgDeptId ;
    }

    /**
     * 设置 [部门标识]
     */
    public void setOrgDeptId(String  orgDeptId){
        this.orgDeptId = orgDeptId ;
        this.orgDeptIdDirtyFlag = true ;
    }

    /**
     * 获取 [部门标识]脏标记
     */
    @JsonIgnore
    public boolean getOrgDeptIdDirtyFlag(){
        return this.orgDeptIdDirtyFlag ;
    }
    /**
     * 获取 [平台流程角色标识]
     */
    public String getPSWFRoleId(){
        return this.pSWFRoleId ;
    }

    /**
     * 设置 [平台流程角色标识]
     */
    public void setPSWFRoleId(String  pSWFRoleId){
        this.pSWFRoleId = pSWFRoleId ;
        this.pSWFRoleIdDirtyFlag = true ;
    }

    /**
     * 获取 [平台流程角色标识]脏标记
     */
    @JsonIgnore
    public boolean getPSWFRoleIdDirtyFlag(){
        return this.pSWFRoleIdDirtyFlag ;
    }
}