package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po;

import cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFRole;
import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonIgnore;
import java.io.Serializable;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import cn.ibizlab.r7.runtime.wf.util.annotation.PreField;
import cn.ibizlab.r7.runtime.wf.util.enums.FillMode;
import cn.ibizlab.r7.runtime.wf.util.enums.PredefinedType;

/**
 * 关系型数据实体表[PSWFRole] 对象
 */
@TableName(value = "T_PSWFROLE",resultMap = "T_PSWFROLEResultMap")
public class T_PSWFROLEImpl implements PSWFRole,Serializable {

    /**
     * [角色数据2]
     */
    private String roleData2;
    /**
     * [角色数据2]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean roleData2DirtyFlag;

    /**
     * [角色数据]
     */
    private String roleData;
    /**
     * [角色数据]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean roleDataDirtyFlag;

    /**
     * [平台流程角色标识]
     */
    @TableId(value= "pswfroleid",type=IdType.UUID)
    private String pSWFRoleId;
    /**
     * [平台流程角色标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSWFRoleIdDirtyFlag;

    /**
     * [更新时间]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updateDate;
    /**
     * [更新时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateDateDirtyFlag;

    /**
     * [系统数据]
     */
    private Integer systemFlag;
    /**
     * [系统数据]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean systemFlagDirtyFlag;

    /**
     * [建立时间]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createDate;
    /**
     * [建立时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createDateDirtyFlag;

    /**
     * [建立人]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    private String createMan;
    /**
     * [建立人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createManDirtyFlag;

    /**
     * [更新人]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    private String updateMan;
    /**
     * [更新人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateManDirtyFlag;

    /**
     * [流程角色名称]
     */
    private String pSWFRoleName;
    /**
     * [流程角色名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSWFRoleNameDirtyFlag;

    /**
     * [角色类型]
     */
    private String wFRoleType;
    /**
     * [角色类型]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFRoleTypeDirtyFlag;

    /**
     * [部门名称]
     */
    private String orgDeptName;
    /**
     * [部门名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean orgDeptNameDirtyFlag;

    /**
     * [组织名称]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.ORGNAME)
    private String orgName;
    /**
     * [组织名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean orgNameDirtyFlag;

    /**
     * [部门标识]
     */
    private String orgDeptId;
    /**
     * [部门标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean orgDeptIdDirtyFlag;

    /**
     * [组织标识]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.ORGID)
    private String orgId;
    /**
     * [组织标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean orgIdDirtyFlag;

    /**
     * 获取 [角色数据2]
     */
    public String getRoleData2(){
        return this.roleData2 ;
    }

    /**
     * 设置 [角色数据2]
     */
    public void setRoleData2(String  roleData2){
        this.roleData2 = roleData2 ;
        this.roleData2DirtyFlag = true ;
    }

    /**
     * 获取 [角色数据2]脏标记
     */
    @JsonIgnore
    public boolean getRoleData2DirtyFlag(){
        return this.roleData2DirtyFlag ;
    }
    /**
     * 获取 [角色数据]
     */
    public String getRoleData(){
        return this.roleData ;
    }

    /**
     * 设置 [角色数据]
     */
    public void setRoleData(String  roleData){
        this.roleData = roleData ;
        this.roleDataDirtyFlag = true ;
    }

    /**
     * 获取 [角色数据]脏标记
     */
    @JsonIgnore
    public boolean getRoleDataDirtyFlag(){
        return this.roleDataDirtyFlag ;
    }
    /**
     * 获取 [平台流程角色标识]
     */
    public String getPSWFRoleId(){
        return this.pSWFRoleId ;
    }

    /**
     * 设置 [平台流程角色标识]
     */
    public void setPSWFRoleId(String  pSWFRoleId){
        this.pSWFRoleId = pSWFRoleId ;
        this.pSWFRoleIdDirtyFlag = true ;
    }

    /**
     * 获取 [平台流程角色标识]脏标记
     */
    @JsonIgnore
    public boolean getPSWFRoleIdDirtyFlag(){
        return this.pSWFRoleIdDirtyFlag ;
    }
    /**
     * 获取 [更新时间]
     */
    public Timestamp getUpdateDate(){
        return this.updateDate ;
    }

    /**
     * 设置 [更新时间]
     */
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [更新时间]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return this.updateDateDirtyFlag ;
    }
    /**
     * 获取 [系统数据]
     */
    public Integer getSystemFlag(){
        return this.systemFlag ;
    }

    /**
     * 设置 [系统数据]
     */
    public void setSystemFlag(Integer  systemFlag){
        this.systemFlag = systemFlag ;
        this.systemFlagDirtyFlag = true ;
    }

    /**
     * 获取 [系统数据]脏标记
     */
    @JsonIgnore
    public boolean getSystemFlagDirtyFlag(){
        return this.systemFlagDirtyFlag ;
    }
    /**
     * 获取 [建立时间]
     */
    public Timestamp getCreateDate(){
        return this.createDate ;
    }

    /**
     * 设置 [建立时间]
     */
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [建立时间]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return this.createDateDirtyFlag ;
    }
    /**
     * 获取 [建立人]
     */
    public String getCreateMan(){
        return this.createMan ;
    }

    /**
     * 设置 [建立人]
     */
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [建立人]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return this.createManDirtyFlag ;
    }
    /**
     * 获取 [更新人]
     */
    public String getUpdateMan(){
        return this.updateMan ;
    }

    /**
     * 设置 [更新人]
     */
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [更新人]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return this.updateManDirtyFlag ;
    }
    /**
     * 获取 [流程角色名称]
     */
    public String getPSWFRoleName(){
        return this.pSWFRoleName ;
    }

    /**
     * 设置 [流程角色名称]
     */
    public void setPSWFRoleName(String  pSWFRoleName){
        this.pSWFRoleName = pSWFRoleName ;
        this.pSWFRoleNameDirtyFlag = true ;
    }

    /**
     * 获取 [流程角色名称]脏标记
     */
    @JsonIgnore
    public boolean getPSWFRoleNameDirtyFlag(){
        return this.pSWFRoleNameDirtyFlag ;
    }
    /**
     * 获取 [角色类型]
     */
    public String getWFRoleType(){
        return this.wFRoleType ;
    }

    /**
     * 设置 [角色类型]
     */
    public void setWFRoleType(String  wFRoleType){
        this.wFRoleType = wFRoleType ;
        this.wFRoleTypeDirtyFlag = true ;
    }

    /**
     * 获取 [角色类型]脏标记
     */
    @JsonIgnore
    public boolean getWFRoleTypeDirtyFlag(){
        return this.wFRoleTypeDirtyFlag ;
    }
    /**
     * 获取 [部门名称]
     */
    public String getOrgDeptName(){
        return this.orgDeptName ;
    }

    /**
     * 设置 [部门名称]
     */
    public void setOrgDeptName(String  orgDeptName){
        this.orgDeptName = orgDeptName ;
        this.orgDeptNameDirtyFlag = true ;
    }

    /**
     * 获取 [部门名称]脏标记
     */
    @JsonIgnore
    public boolean getOrgDeptNameDirtyFlag(){
        return this.orgDeptNameDirtyFlag ;
    }
    /**
     * 获取 [组织名称]
     */
    public String getOrgName(){
        return this.orgName ;
    }

    /**
     * 设置 [组织名称]
     */
    public void setOrgName(String  orgName){
        this.orgName = orgName ;
        this.orgNameDirtyFlag = true ;
    }

    /**
     * 获取 [组织名称]脏标记
     */
    @JsonIgnore
    public boolean getOrgNameDirtyFlag(){
        return this.orgNameDirtyFlag ;
    }
    /**
     * 获取 [部门标识]
     */
    public String getOrgDeptId(){
        return this.orgDeptId ;
    }

    /**
     * 设置 [部门标识]
     */
    public void setOrgDeptId(String  orgDeptId){
        this.orgDeptId = orgDeptId ;
        this.orgDeptIdDirtyFlag = true ;
    }

    /**
     * 获取 [部门标识]脏标记
     */
    @JsonIgnore
    public boolean getOrgDeptIdDirtyFlag(){
        return this.orgDeptIdDirtyFlag ;
    }
    /**
     * 获取 [组织标识]
     */
    public String getOrgId(){
        return this.orgId ;
    }

    /**
     * 设置 [组织标识]
     */
    public void setOrgId(String  orgId){
        this.orgId = orgId ;
        this.orgIdDirtyFlag = true ;
    }

    /**
     * 获取 [组织标识]脏标记
     */
    @JsonIgnore
    public boolean getOrgIdDirtyFlag(){
        return this.orgIdDirtyFlag ;
    }
}