package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po;

import cn.ibizlab.r7.runtime.wf.core.repository.po.PSWFVersion;
import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonIgnore;
import java.io.Serializable;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import cn.ibizlab.r7.runtime.wf.util.annotation.PreField;
import cn.ibizlab.r7.runtime.wf.util.enums.FillMode;
import cn.ibizlab.r7.runtime.wf.util.enums.PredefinedType;

/**
 * 关系型数据实体表[PSWFVersion] 对象
 */
@TableName(value = "T_PSWFVERSION",resultMap = "T_PSWFVERSIONResultMap")
public class T_PSWFVERSIONImpl implements PSWFVersion,Serializable {

    /**
     * [建立时间]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createDate;
    /**
     * [建立时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createDateDirtyFlag;

    /**
     * [版本]
     */
    private Integer version;
    /**
     * [版本]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean versionDirtyFlag;

    /**
     * [业务流程版本标识]
     */
    @TableId(value= "pswfversionid",type=IdType.UUID)
    private String pSWFVersionId;
    /**
     * [业务流程版本标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSWFVersionIdDirtyFlag;

    /**
     * [流程文件名]
     */
    private String fileName;
    /**
     * [流程文件名]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean fileNameDirtyFlag;

    /**
     * [更新人]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    private String updateMan;
    /**
     * [更新人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateManDirtyFlag;

    /**
     * [逻辑名称]
     */
    private String logicName;
    /**
     * [逻辑名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean logicNameDirtyFlag;

    /**
     * [查看流程页面]
     */
    private String viewurl;
    /**
     * [查看流程页面]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean viewurlDirtyFlag;

    /**
     * [启动流程Api]
     */
    private String startApi;
    /**
     * [启动流程Api]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean startApiDirtyFlag;

    /**
     * [版本名称]
     */
    private String pSWFVersionName;
    /**
     * [版本名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSWFVersionNameDirtyFlag;

    /**
     * [流程实体]
     */
    private String moduleId;
    /**
     * [流程实体]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean moduleIdDirtyFlag;

    /**
     * [流程文件内容]
     */
    private byte[] fileContent;
    /**
     * [流程文件内容]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean fileContentDirtyFlag;

    /**
     * [更新时间]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updateDate;
    /**
     * [更新时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateDateDirtyFlag;

    /**
     * [启动流程页面]
     */
    private String startUrl;
    /**
     * [启动流程页面]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean startUrlDirtyFlag;

    /**
     * [引擎部署标识]
     */
    private String wFEngineDeployId;
    /**
     * [引擎部署标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFEngineDeployIdDirtyFlag;

    /**
     * [建立人]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    private String createMan;
    /**
     * [建立人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createManDirtyFlag;

    /**
     * [部门名称]
     */
    private String orgDeptName;
    /**
     * [部门名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean orgDeptNameDirtyFlag;

    /**
     * [组织名称]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.ORGNAME)
    private String orgName;
    /**
     * [组织名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean orgNameDirtyFlag;

    /**
     * [业务工作流名称]
     */
    private String pSWFWorkflowName;
    /**
     * [业务工作流名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSWFWorkflowNameDirtyFlag;

    /**
     * [组织标识]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.ORGID)
    private String orgId;
    /**
     * [组织标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean orgIdDirtyFlag;

    /**
     * [业务工作流标识]
     */
    private String pSWorkflowId;
    /**
     * [业务工作流标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSWorkflowIdDirtyFlag;

    /**
     * [工作流应用标识]
     */
    private String wFAppId;
    /**
     * [工作流应用标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFAppIdDirtyFlag;

    /**
     * [工作流模式标识]
     */
    private String wFModeId;
    /**
     * [工作流模式标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFModeIdDirtyFlag;

    /**
     * [部门标识]
     */
    private String orgDeptId;
    /**
     * [部门标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean orgDeptIdDirtyFlag;

    /**
     * 获取 [建立时间]
     */
    public Timestamp getCreateDate(){
        return this.createDate ;
    }

    /**
     * 设置 [建立时间]
     */
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [建立时间]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return this.createDateDirtyFlag ;
    }
    /**
     * 获取 [版本]
     */
    public Integer getVersion(){
        return this.version ;
    }

    /**
     * 设置 [版本]
     */
    public void setVersion(Integer  version){
        this.version = version ;
        this.versionDirtyFlag = true ;
    }

    /**
     * 获取 [版本]脏标记
     */
    @JsonIgnore
    public boolean getVersionDirtyFlag(){
        return this.versionDirtyFlag ;
    }
    /**
     * 获取 [业务流程版本标识]
     */
    public String getPSWFVersionId(){
        return this.pSWFVersionId ;
    }

    /**
     * 设置 [业务流程版本标识]
     */
    public void setPSWFVersionId(String  pSWFVersionId){
        this.pSWFVersionId = pSWFVersionId ;
        this.pSWFVersionIdDirtyFlag = true ;
    }

    /**
     * 获取 [业务流程版本标识]脏标记
     */
    @JsonIgnore
    public boolean getPSWFVersionIdDirtyFlag(){
        return this.pSWFVersionIdDirtyFlag ;
    }
    /**
     * 获取 [流程文件名]
     */
    public String getFileName(){
        return this.fileName ;
    }

    /**
     * 设置 [流程文件名]
     */
    public void setFileName(String  fileName){
        this.fileName = fileName ;
        this.fileNameDirtyFlag = true ;
    }

    /**
     * 获取 [流程文件名]脏标记
     */
    @JsonIgnore
    public boolean getFileNameDirtyFlag(){
        return this.fileNameDirtyFlag ;
    }
    /**
     * 获取 [更新人]
     */
    public String getUpdateMan(){
        return this.updateMan ;
    }

    /**
     * 设置 [更新人]
     */
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [更新人]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return this.updateManDirtyFlag ;
    }
    /**
     * 获取 [逻辑名称]
     */
    public String getLogicName(){
        return this.logicName ;
    }

    /**
     * 设置 [逻辑名称]
     */
    public void setLogicName(String  logicName){
        this.logicName = logicName ;
        this.logicNameDirtyFlag = true ;
    }

    /**
     * 获取 [逻辑名称]脏标记
     */
    @JsonIgnore
    public boolean getLogicNameDirtyFlag(){
        return this.logicNameDirtyFlag ;
    }
    /**
     * 获取 [查看流程页面]
     */
    public String getViewurl(){
        return this.viewurl ;
    }

    /**
     * 设置 [查看流程页面]
     */
    public void setViewurl(String  viewurl){
        this.viewurl = viewurl ;
        this.viewurlDirtyFlag = true ;
    }

    /**
     * 获取 [查看流程页面]脏标记
     */
    @JsonIgnore
    public boolean getViewurlDirtyFlag(){
        return this.viewurlDirtyFlag ;
    }
    /**
     * 获取 [启动流程Api]
     */
    public String getStartApi(){
        return this.startApi ;
    }

    /**
     * 设置 [启动流程Api]
     */
    public void setStartApi(String  startApi){
        this.startApi = startApi ;
        this.startApiDirtyFlag = true ;
    }

    /**
     * 获取 [启动流程Api]脏标记
     */
    @JsonIgnore
    public boolean getStartApiDirtyFlag(){
        return this.startApiDirtyFlag ;
    }
    /**
     * 获取 [版本名称]
     */
    public String getPSWFVersionName(){
        return this.pSWFVersionName ;
    }

    /**
     * 设置 [版本名称]
     */
    public void setPSWFVersionName(String  pSWFVersionName){
        this.pSWFVersionName = pSWFVersionName ;
        this.pSWFVersionNameDirtyFlag = true ;
    }

    /**
     * 获取 [版本名称]脏标记
     */
    @JsonIgnore
    public boolean getPSWFVersionNameDirtyFlag(){
        return this.pSWFVersionNameDirtyFlag ;
    }
    /**
     * 获取 [流程实体]
     */
    public String getModuleId(){
        return this.moduleId ;
    }

    /**
     * 设置 [流程实体]
     */
    public void setModuleId(String  moduleId){
        this.moduleId = moduleId ;
        this.moduleIdDirtyFlag = true ;
    }

    /**
     * 获取 [流程实体]脏标记
     */
    @JsonIgnore
    public boolean getModuleIdDirtyFlag(){
        return this.moduleIdDirtyFlag ;
    }
    /**
     * 获取 [流程文件内容]
     */
    public byte[] getFileContent(){
        return this.fileContent ;
    }

    /**
     * 设置 [流程文件内容]
     */
    public void setFileContent(byte[]  fileContent){
        this.fileContent = fileContent ;
        this.fileContentDirtyFlag = true ;
    }

    /**
     * 获取 [流程文件内容]脏标记
     */
    @JsonIgnore
    public boolean getFileContentDirtyFlag(){
        return this.fileContentDirtyFlag ;
    }
    /**
     * 获取 [更新时间]
     */
    public Timestamp getUpdateDate(){
        return this.updateDate ;
    }

    /**
     * 设置 [更新时间]
     */
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [更新时间]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return this.updateDateDirtyFlag ;
    }
    /**
     * 获取 [启动流程页面]
     */
    public String getStartUrl(){
        return this.startUrl ;
    }

    /**
     * 设置 [启动流程页面]
     */
    public void setStartUrl(String  startUrl){
        this.startUrl = startUrl ;
        this.startUrlDirtyFlag = true ;
    }

    /**
     * 获取 [启动流程页面]脏标记
     */
    @JsonIgnore
    public boolean getStartUrlDirtyFlag(){
        return this.startUrlDirtyFlag ;
    }
    /**
     * 获取 [引擎部署标识]
     */
    public String getWFEngineDeployId(){
        return this.wFEngineDeployId ;
    }

    /**
     * 设置 [引擎部署标识]
     */
    public void setWFEngineDeployId(String  wFEngineDeployId){
        this.wFEngineDeployId = wFEngineDeployId ;
        this.wFEngineDeployIdDirtyFlag = true ;
    }

    /**
     * 获取 [引擎部署标识]脏标记
     */
    @JsonIgnore
    public boolean getWFEngineDeployIdDirtyFlag(){
        return this.wFEngineDeployIdDirtyFlag ;
    }
    /**
     * 获取 [建立人]
     */
    public String getCreateMan(){
        return this.createMan ;
    }

    /**
     * 设置 [建立人]
     */
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [建立人]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return this.createManDirtyFlag ;
    }
    /**
     * 获取 [部门名称]
     */
    public String getOrgDeptName(){
        return this.orgDeptName ;
    }

    /**
     * 设置 [部门名称]
     */
    public void setOrgDeptName(String  orgDeptName){
        this.orgDeptName = orgDeptName ;
        this.orgDeptNameDirtyFlag = true ;
    }

    /**
     * 获取 [部门名称]脏标记
     */
    @JsonIgnore
    public boolean getOrgDeptNameDirtyFlag(){
        return this.orgDeptNameDirtyFlag ;
    }
    /**
     * 获取 [组织名称]
     */
    public String getOrgName(){
        return this.orgName ;
    }

    /**
     * 设置 [组织名称]
     */
    public void setOrgName(String  orgName){
        this.orgName = orgName ;
        this.orgNameDirtyFlag = true ;
    }

    /**
     * 获取 [组织名称]脏标记
     */
    @JsonIgnore
    public boolean getOrgNameDirtyFlag(){
        return this.orgNameDirtyFlag ;
    }
    /**
     * 获取 [业务工作流名称]
     */
    public String getPSWFWorkflowName(){
        return this.pSWFWorkflowName ;
    }

    /**
     * 设置 [业务工作流名称]
     */
    public void setPSWFWorkflowName(String  pSWFWorkflowName){
        this.pSWFWorkflowName = pSWFWorkflowName ;
        this.pSWFWorkflowNameDirtyFlag = true ;
    }

    /**
     * 获取 [业务工作流名称]脏标记
     */
    @JsonIgnore
    public boolean getPSWFWorkflowNameDirtyFlag(){
        return this.pSWFWorkflowNameDirtyFlag ;
    }
    /**
     * 获取 [组织标识]
     */
    public String getOrgId(){
        return this.orgId ;
    }

    /**
     * 设置 [组织标识]
     */
    public void setOrgId(String  orgId){
        this.orgId = orgId ;
        this.orgIdDirtyFlag = true ;
    }

    /**
     * 获取 [组织标识]脏标记
     */
    @JsonIgnore
    public boolean getOrgIdDirtyFlag(){
        return this.orgIdDirtyFlag ;
    }
    /**
     * 获取 [业务工作流标识]
     */
    public String getPSWorkflowId(){
        return this.pSWorkflowId ;
    }

    /**
     * 设置 [业务工作流标识]
     */
    public void setPSWorkflowId(String  pSWorkflowId){
        this.pSWorkflowId = pSWorkflowId ;
        this.pSWorkflowIdDirtyFlag = true ;
    }

    /**
     * 获取 [业务工作流标识]脏标记
     */
    @JsonIgnore
    public boolean getPSWorkflowIdDirtyFlag(){
        return this.pSWorkflowIdDirtyFlag ;
    }
    /**
     * 获取 [工作流应用标识]
     */
    public String getWFAppId(){
        return this.wFAppId ;
    }

    /**
     * 设置 [工作流应用标识]
     */
    public void setWFAppId(String  wFAppId){
        this.wFAppId = wFAppId ;
        this.wFAppIdDirtyFlag = true ;
    }

    /**
     * 获取 [工作流应用标识]脏标记
     */
    @JsonIgnore
    public boolean getWFAppIdDirtyFlag(){
        return this.wFAppIdDirtyFlag ;
    }
    /**
     * 获取 [工作流模式标识]
     */
    public String getWFModeId(){
        return this.wFModeId ;
    }

    /**
     * 设置 [工作流模式标识]
     */
    public void setWFModeId(String  wFModeId){
        this.wFModeId = wFModeId ;
        this.wFModeIdDirtyFlag = true ;
    }

    /**
     * 获取 [工作流模式标识]脏标记
     */
    @JsonIgnore
    public boolean getWFModeIdDirtyFlag(){
        return this.wFModeIdDirtyFlag ;
    }
    /**
     * 获取 [部门标识]
     */
    public String getOrgDeptId(){
        return this.orgDeptId ;
    }

    /**
     * 设置 [部门标识]
     */
    public void setOrgDeptId(String  orgDeptId){
        this.orgDeptId = orgDeptId ;
        this.orgDeptIdDirtyFlag = true ;
    }

    /**
     * 获取 [部门标识]脏标记
     */
    @JsonIgnore
    public boolean getOrgDeptIdDirtyFlag(){
        return this.orgDeptIdDirtyFlag ;
    }
}