package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po;

import cn.ibizlab.r7.runtime.wf.core.repository.po.PSWorkflow;
import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonIgnore;
import java.io.Serializable;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import cn.ibizlab.r7.runtime.wf.util.annotation.PreField;
import cn.ibizlab.r7.runtime.wf.util.enums.FillMode;
import cn.ibizlab.r7.runtime.wf.util.enums.PredefinedType;

/**
 * 关系型数据实体表[PSWorkflow] 对象
 */
@TableName(value = "T_PSWORKFLOW",resultMap = "T_PSWORKFLOWResultMap")
public class T_PSWORKFLOWImpl implements PSWorkflow,Serializable {

    /**
     * [引擎类型]
     */
    private String wfenginetype;
    /**
     * [引擎类型]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wfenginetypeDirtyFlag;

    /**
     * [更新人]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    private String updateMan;
    /**
     * [更新人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateManDirtyFlag;

    /**
     * [建立时间]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createDate;
    /**
     * [建立时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createDateDirtyFlag;

    /**
     * [工作流类型]
     */
    private String wftype;
    /**
     * [工作流类型]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wftypeDirtyFlag;

    /**
     * [建立人]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    private String createMan;
    /**
     * [建立人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createManDirtyFlag;

    /**
     * [业务工作流标识]
     */
    @TableId(value= "psworkflowid",type=IdType.UUID)
    private String pSWorkflowId;
    /**
     * [业务工作流标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSWorkflowIdDirtyFlag;

    /**
     * [更新时间]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updateDate;
    /**
     * [更新时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateDateDirtyFlag;

    /**
     * [工作流名称]
     */
    private String pSWFWorkflowName;
    /**
     * [工作流名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSWFWorkflowNameDirtyFlag;

    /**
     * [工作流名称]
     */
    private String logicName;
    /**
     * [工作流名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean logicNameDirtyFlag;

    /**
     * [部门名称]
     */
    private String orgDeptName;
    /**
     * [部门名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean orgDeptNameDirtyFlag;

    /**
     * [组织名称]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.ORGNAME)
    private String orgName;
    /**
     * [组织名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean orgNameDirtyFlag;

    /**
     * [部门标识]
     */
    private String orgDeptId;
    /**
     * [部门标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean orgDeptIdDirtyFlag;

    /**
     * [组织标识]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.ORGID)
    private String orgId;
    /**
     * [组织标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean orgIdDirtyFlag;

    /**
     * [业务系统标识]
     */
    private String pSSystemId;
    /**
     * [业务系统标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSSystemIdDirtyFlag;

    /**
     * 获取 [引擎类型]
     */
    public String getWfenginetype(){
        return this.wfenginetype ;
    }

    /**
     * 设置 [引擎类型]
     */
    public void setWfenginetype(String  wfenginetype){
        this.wfenginetype = wfenginetype ;
        this.wfenginetypeDirtyFlag = true ;
    }

    /**
     * 获取 [引擎类型]脏标记
     */
    @JsonIgnore
    public boolean getWfenginetypeDirtyFlag(){
        return this.wfenginetypeDirtyFlag ;
    }
    /**
     * 获取 [更新人]
     */
    public String getUpdateMan(){
        return this.updateMan ;
    }

    /**
     * 设置 [更新人]
     */
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [更新人]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return this.updateManDirtyFlag ;
    }
    /**
     * 获取 [建立时间]
     */
    public Timestamp getCreateDate(){
        return this.createDate ;
    }

    /**
     * 设置 [建立时间]
     */
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [建立时间]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return this.createDateDirtyFlag ;
    }
    /**
     * 获取 [工作流类型]
     */
    public String getWftype(){
        return this.wftype ;
    }

    /**
     * 设置 [工作流类型]
     */
    public void setWftype(String  wftype){
        this.wftype = wftype ;
        this.wftypeDirtyFlag = true ;
    }

    /**
     * 获取 [工作流类型]脏标记
     */
    @JsonIgnore
    public boolean getWftypeDirtyFlag(){
        return this.wftypeDirtyFlag ;
    }
    /**
     * 获取 [建立人]
     */
    public String getCreateMan(){
        return this.createMan ;
    }

    /**
     * 设置 [建立人]
     */
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [建立人]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return this.createManDirtyFlag ;
    }
    /**
     * 获取 [业务工作流标识]
     */
    public String getPSWorkflowId(){
        return this.pSWorkflowId ;
    }

    /**
     * 设置 [业务工作流标识]
     */
    public void setPSWorkflowId(String  pSWorkflowId){
        this.pSWorkflowId = pSWorkflowId ;
        this.pSWorkflowIdDirtyFlag = true ;
    }

    /**
     * 获取 [业务工作流标识]脏标记
     */
    @JsonIgnore
    public boolean getPSWorkflowIdDirtyFlag(){
        return this.pSWorkflowIdDirtyFlag ;
    }
    /**
     * 获取 [更新时间]
     */
    public Timestamp getUpdateDate(){
        return this.updateDate ;
    }

    /**
     * 设置 [更新时间]
     */
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [更新时间]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return this.updateDateDirtyFlag ;
    }
    /**
     * 获取 [工作流名称]
     */
    public String getPSWFWorkflowName(){
        return this.pSWFWorkflowName ;
    }

    /**
     * 设置 [工作流名称]
     */
    public void setPSWFWorkflowName(String  pSWFWorkflowName){
        this.pSWFWorkflowName = pSWFWorkflowName ;
        this.pSWFWorkflowNameDirtyFlag = true ;
    }

    /**
     * 获取 [工作流名称]脏标记
     */
    @JsonIgnore
    public boolean getPSWFWorkflowNameDirtyFlag(){
        return this.pSWFWorkflowNameDirtyFlag ;
    }
    /**
     * 获取 [工作流名称]
     */
    public String getLogicName(){
        return this.logicName ;
    }

    /**
     * 设置 [工作流名称]
     */
    public void setLogicName(String  logicName){
        this.logicName = logicName ;
        this.logicNameDirtyFlag = true ;
    }

    /**
     * 获取 [工作流名称]脏标记
     */
    @JsonIgnore
    public boolean getLogicNameDirtyFlag(){
        return this.logicNameDirtyFlag ;
    }
    /**
     * 获取 [部门名称]
     */
    public String getOrgDeptName(){
        return this.orgDeptName ;
    }

    /**
     * 设置 [部门名称]
     */
    public void setOrgDeptName(String  orgDeptName){
        this.orgDeptName = orgDeptName ;
        this.orgDeptNameDirtyFlag = true ;
    }

    /**
     * 获取 [部门名称]脏标记
     */
    @JsonIgnore
    public boolean getOrgDeptNameDirtyFlag(){
        return this.orgDeptNameDirtyFlag ;
    }
    /**
     * 获取 [组织名称]
     */
    public String getOrgName(){
        return this.orgName ;
    }

    /**
     * 设置 [组织名称]
     */
    public void setOrgName(String  orgName){
        this.orgName = orgName ;
        this.orgNameDirtyFlag = true ;
    }

    /**
     * 获取 [组织名称]脏标记
     */
    @JsonIgnore
    public boolean getOrgNameDirtyFlag(){
        return this.orgNameDirtyFlag ;
    }
    /**
     * 获取 [部门标识]
     */
    public String getOrgDeptId(){
        return this.orgDeptId ;
    }

    /**
     * 设置 [部门标识]
     */
    public void setOrgDeptId(String  orgDeptId){
        this.orgDeptId = orgDeptId ;
        this.orgDeptIdDirtyFlag = true ;
    }

    /**
     * 获取 [部门标识]脏标记
     */
    @JsonIgnore
    public boolean getOrgDeptIdDirtyFlag(){
        return this.orgDeptIdDirtyFlag ;
    }
    /**
     * 获取 [组织标识]
     */
    public String getOrgId(){
        return this.orgId ;
    }

    /**
     * 设置 [组织标识]
     */
    public void setOrgId(String  orgId){
        this.orgId = orgId ;
        this.orgIdDirtyFlag = true ;
    }

    /**
     * 获取 [组织标识]脏标记
     */
    @JsonIgnore
    public boolean getOrgIdDirtyFlag(){
        return this.orgIdDirtyFlag ;
    }
    /**
     * 获取 [业务系统标识]
     */
    public String getPSSystemId(){
        return this.pSSystemId ;
    }

    /**
     * 设置 [业务系统标识]
     */
    public void setPSSystemId(String  pSSystemId){
        this.pSSystemId = pSSystemId ;
        this.pSSystemIdDirtyFlag = true ;
    }

    /**
     * 获取 [业务系统标识]脏标记
     */
    @JsonIgnore
    public boolean getPSSystemIdDirtyFlag(){
        return this.pSSystemIdDirtyFlag ;
    }
}