package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po;

import cn.ibizlab.r7.runtime.wf.core.repository.po.WFApp;
import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonIgnore;
import java.io.Serializable;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import cn.ibizlab.r7.runtime.wf.util.annotation.PreField;
import cn.ibizlab.r7.runtime.wf.util.enums.FillMode;
import cn.ibizlab.r7.runtime.wf.util.enums.PredefinedType;

/**
 * 关系型数据实体表[WFApp] 对象
 */
@TableName(value = "T_WFAPP",resultMap = "T_WFAPPResultMap")
public class T_WFAPPImpl implements WFApp,Serializable {

    /**
     * [建立人]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    private String createMan;
    /**
     * [建立人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createManDirtyFlag;

    /**
     * [工作流应用名称]
     */
    private String wFAppName;
    /**
     * [工作流应用名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFAppNameDirtyFlag;

    /**
     * [建立时间]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createDate;
    /**
     * [建立时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createDateDirtyFlag;

    /**
     * [服务标识]
     */
    private String serviceId;
    /**
     * [服务标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean serviceIdDirtyFlag;

    /**
     * [服务地址]
     */
    private String serviceUrl;
    /**
     * [服务地址]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean serviceUrlDirtyFlag;

    /**
     * [更新时间]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updateDate;
    /**
     * [更新时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateDateDirtyFlag;

    /**
     * [更新人]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    private String updateMan;
    /**
     * [更新人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateManDirtyFlag;

    /**
     * [逻辑名称]
     */
    private String logicName;
    /**
     * [逻辑名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean logicNameDirtyFlag;

    /**
     * [应用地址]
     */
    private String appUrl;
    /**
     * [应用地址]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean appUrlDirtyFlag;

    /**
     * [工作流应用标识]
     */
    @TableId(value= "wfappid",type=IdType.UUID)
    private String wFAppId;
    /**
     * [工作流应用标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFAppIdDirtyFlag;

    /**
     * [业务系统标识]
     */
    private String pSSystemId;
    /**
     * [业务系统标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSSystemIdDirtyFlag;

    /**
     * 获取 [建立人]
     */
    public String getCreateMan(){
        return this.createMan ;
    }

    /**
     * 设置 [建立人]
     */
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [建立人]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return this.createManDirtyFlag ;
    }
    /**
     * 获取 [工作流应用名称]
     */
    public String getWFAppName(){
        return this.wFAppName ;
    }

    /**
     * 设置 [工作流应用名称]
     */
    public void setWFAppName(String  wFAppName){
        this.wFAppName = wFAppName ;
        this.wFAppNameDirtyFlag = true ;
    }

    /**
     * 获取 [工作流应用名称]脏标记
     */
    @JsonIgnore
    public boolean getWFAppNameDirtyFlag(){
        return this.wFAppNameDirtyFlag ;
    }
    /**
     * 获取 [建立时间]
     */
    public Timestamp getCreateDate(){
        return this.createDate ;
    }

    /**
     * 设置 [建立时间]
     */
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [建立时间]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return this.createDateDirtyFlag ;
    }
    /**
     * 获取 [服务标识]
     */
    public String getServiceId(){
        return this.serviceId ;
    }

    /**
     * 设置 [服务标识]
     */
    public void setServiceId(String  serviceId){
        this.serviceId = serviceId ;
        this.serviceIdDirtyFlag = true ;
    }

    /**
     * 获取 [服务标识]脏标记
     */
    @JsonIgnore
    public boolean getServiceIdDirtyFlag(){
        return this.serviceIdDirtyFlag ;
    }
    /**
     * 获取 [服务地址]
     */
    public String getServiceUrl(){
        return this.serviceUrl ;
    }

    /**
     * 设置 [服务地址]
     */
    public void setServiceUrl(String  serviceUrl){
        this.serviceUrl = serviceUrl ;
        this.serviceUrlDirtyFlag = true ;
    }

    /**
     * 获取 [服务地址]脏标记
     */
    @JsonIgnore
    public boolean getServiceUrlDirtyFlag(){
        return this.serviceUrlDirtyFlag ;
    }
    /**
     * 获取 [更新时间]
     */
    public Timestamp getUpdateDate(){
        return this.updateDate ;
    }

    /**
     * 设置 [更新时间]
     */
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [更新时间]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return this.updateDateDirtyFlag ;
    }
    /**
     * 获取 [更新人]
     */
    public String getUpdateMan(){
        return this.updateMan ;
    }

    /**
     * 设置 [更新人]
     */
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [更新人]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return this.updateManDirtyFlag ;
    }
    /**
     * 获取 [逻辑名称]
     */
    public String getLogicName(){
        return this.logicName ;
    }

    /**
     * 设置 [逻辑名称]
     */
    public void setLogicName(String  logicName){
        this.logicName = logicName ;
        this.logicNameDirtyFlag = true ;
    }

    /**
     * 获取 [逻辑名称]脏标记
     */
    @JsonIgnore
    public boolean getLogicNameDirtyFlag(){
        return this.logicNameDirtyFlag ;
    }
    /**
     * 获取 [应用地址]
     */
    public String getAppUrl(){
        return this.appUrl ;
    }

    /**
     * 设置 [应用地址]
     */
    public void setAppUrl(String  appUrl){
        this.appUrl = appUrl ;
        this.appUrlDirtyFlag = true ;
    }

    /**
     * 获取 [应用地址]脏标记
     */
    @JsonIgnore
    public boolean getAppUrlDirtyFlag(){
        return this.appUrlDirtyFlag ;
    }
    /**
     * 获取 [工作流应用标识]
     */
    public String getWFAppId(){
        return this.wFAppId ;
    }

    /**
     * 设置 [工作流应用标识]
     */
    public void setWFAppId(String  wFAppId){
        this.wFAppId = wFAppId ;
        this.wFAppIdDirtyFlag = true ;
    }

    /**
     * 获取 [工作流应用标识]脏标记
     */
    @JsonIgnore
    public boolean getWFAppIdDirtyFlag(){
        return this.wFAppIdDirtyFlag ;
    }
    /**
     * 获取 [业务系统标识]
     */
    public String getPSSystemId(){
        return this.pSSystemId ;
    }

    /**
     * 设置 [业务系统标识]
     */
    public void setPSSystemId(String  pSSystemId){
        this.pSSystemId = pSSystemId ;
        this.pSSystemIdDirtyFlag = true ;
    }

    /**
     * 获取 [业务系统标识]脏标记
     */
    @JsonIgnore
    public boolean getPSSystemIdDirtyFlag(){
        return this.pSSystemIdDirtyFlag ;
    }
}