package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po;

import cn.ibizlab.r7.runtime.wf.core.repository.po.WFEngine;
import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonIgnore;
import java.io.Serializable;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import cn.ibizlab.r7.runtime.wf.util.annotation.PreField;
import cn.ibizlab.r7.runtime.wf.util.enums.FillMode;
import cn.ibizlab.r7.runtime.wf.util.enums.PredefinedType;

/**
 * 关系型数据实体表[WFEngine] 对象
 */
@TableName(value = "T_WFENGINE",resultMap = "T_WFENGINEResultMap")
public class T_WFENGINEImpl implements WFEngine,Serializable {

    /**
     * [更新时间]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updateDate;
    /**
     * [更新时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateDateDirtyFlag;

    /**
     * [工作流引擎名称]
     */
    private String wFEngineName;
    /**
     * [工作流引擎名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFEngineNameDirtyFlag;

    /**
     * [工作流引擎标识]
     */
    @TableId(value= "wfengineid",type=IdType.UUID)
    private String wFEngineId;
    /**
     * [工作流引擎标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFEngineIdDirtyFlag;

    /**
     * [建立时间]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createDate;
    /**
     * [建立时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createDateDirtyFlag;

    /**
     * [建立人]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    private String createMan;
    /**
     * [建立人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createManDirtyFlag;

    /**
     * [更新人]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    private String updateMan;
    /**
     * [更新人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateManDirtyFlag;

    /**
     * [逻辑名称]
     */
    private String logicName;
    /**
     * [逻辑名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean logicNameDirtyFlag;

    /**
     * [引擎类型]
     */
    private String enginetype;
    /**
     * [引擎类型]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean enginetypeDirtyFlag;

    /**
     * [统一工作流标识]
     */
    private String workflowId;
    /**
     * [统一工作流标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean workflowIdDirtyFlag;

    /**
     * 获取 [更新时间]
     */
    public Timestamp getUpdateDate(){
        return this.updateDate ;
    }

    /**
     * 设置 [更新时间]
     */
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [更新时间]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return this.updateDateDirtyFlag ;
    }
    /**
     * 获取 [工作流引擎名称]
     */
    public String getWFEngineName(){
        return this.wFEngineName ;
    }

    /**
     * 设置 [工作流引擎名称]
     */
    public void setWFEngineName(String  wFEngineName){
        this.wFEngineName = wFEngineName ;
        this.wFEngineNameDirtyFlag = true ;
    }

    /**
     * 获取 [工作流引擎名称]脏标记
     */
    @JsonIgnore
    public boolean getWFEngineNameDirtyFlag(){
        return this.wFEngineNameDirtyFlag ;
    }
    /**
     * 获取 [工作流引擎标识]
     */
    public String getWFEngineId(){
        return this.wFEngineId ;
    }

    /**
     * 设置 [工作流引擎标识]
     */
    public void setWFEngineId(String  wFEngineId){
        this.wFEngineId = wFEngineId ;
        this.wFEngineIdDirtyFlag = true ;
    }

    /**
     * 获取 [工作流引擎标识]脏标记
     */
    @JsonIgnore
    public boolean getWFEngineIdDirtyFlag(){
        return this.wFEngineIdDirtyFlag ;
    }
    /**
     * 获取 [建立时间]
     */
    public Timestamp getCreateDate(){
        return this.createDate ;
    }

    /**
     * 设置 [建立时间]
     */
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [建立时间]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return this.createDateDirtyFlag ;
    }
    /**
     * 获取 [建立人]
     */
    public String getCreateMan(){
        return this.createMan ;
    }

    /**
     * 设置 [建立人]
     */
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [建立人]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return this.createManDirtyFlag ;
    }
    /**
     * 获取 [更新人]
     */
    public String getUpdateMan(){
        return this.updateMan ;
    }

    /**
     * 设置 [更新人]
     */
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [更新人]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return this.updateManDirtyFlag ;
    }
    /**
     * 获取 [逻辑名称]
     */
    public String getLogicName(){
        return this.logicName ;
    }

    /**
     * 设置 [逻辑名称]
     */
    public void setLogicName(String  logicName){
        this.logicName = logicName ;
        this.logicNameDirtyFlag = true ;
    }

    /**
     * 获取 [逻辑名称]脏标记
     */
    @JsonIgnore
    public boolean getLogicNameDirtyFlag(){
        return this.logicNameDirtyFlag ;
    }
    /**
     * 获取 [引擎类型]
     */
    public String getEnginetype(){
        return this.enginetype ;
    }

    /**
     * 设置 [引擎类型]
     */
    public void setEnginetype(String  enginetype){
        this.enginetype = enginetype ;
        this.enginetypeDirtyFlag = true ;
    }

    /**
     * 获取 [引擎类型]脏标记
     */
    @JsonIgnore
    public boolean getEnginetypeDirtyFlag(){
        return this.enginetypeDirtyFlag ;
    }
    /**
     * 获取 [统一工作流标识]
     */
    public String getWorkflowId(){
        return this.workflowId ;
    }

    /**
     * 设置 [统一工作流标识]
     */
    public void setWorkflowId(String  workflowId){
        this.workflowId = workflowId ;
        this.workflowIdDirtyFlag = true ;
    }

    /**
     * 获取 [统一工作流标识]脏标记
     */
    @JsonIgnore
    public boolean getWorkflowIdDirtyFlag(){
        return this.workflowIdDirtyFlag ;
    }
}