package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po;

import cn.ibizlab.r7.runtime.wf.core.repository.po.WFIAAction;
import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonIgnore;
import java.io.Serializable;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import cn.ibizlab.r7.runtime.wf.util.annotation.PreField;
import cn.ibizlab.r7.runtime.wf.util.enums.FillMode;
import cn.ibizlab.r7.runtime.wf.util.enums.PredefinedType;

/**
 * 关系型数据实体表[WFIAAction] 对象
 */
@TableName(value = "T_WFIAACTION",resultMap = "T_WFIAACTIONResultMap")
public class T_WFIAACTIONImpl implements WFIAAction,Serializable {

    /**
     * [处理人]
     */
    private String personList;
    /**
     * [处理人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean personListDirtyFlag;

    /**
     * [操作人]
     */
    private String opPerson;
    /**
     * [操作人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean opPersonDirtyFlag;

    /**
     * [用户数据2]
     */
    private String userData2;
    /**
     * [用户数据2]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean userData2DirtyFlag;

    /**
     * [操作类型]
     */
    private String actionType;
    /**
     * [操作类型]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean actionTypeDirtyFlag;

    /**
     * [用户数据]
     */
    private String userData;
    /**
     * [用户数据]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean userDataDirtyFlag;

    /**
     * [更新人]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    private String updateMan;
    /**
     * [更新人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateManDirtyFlag;

    /**
     * [审批意见]
     */
    private String opinion;
    /**
     * [审批意见]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean opinionDirtyFlag;

    /**
     * [建立时间]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createDate;
    /**
     * [建立时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createDateDirtyFlag;

    /**
     * [工作流步骤操作标识]
     */
    @TableId(value= "wfiaactionid",type=IdType.UUID)
    private String wFIAActionId;
    /**
     * [工作流步骤操作标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFIAActionIdDirtyFlag;

    /**
     * [实例]
     */
    private String wFInstanceId;
    /**
     * [实例]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFInstanceIdDirtyFlag;

    /**
     * [更新时间]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updateDate;
    /**
     * [更新时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateDateDirtyFlag;

    /**
     * [建立人]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    private String createMan;
    /**
     * [建立人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createManDirtyFlag;

    /**
     * [逻辑名称]
     */
    private String logicName;
    /**
     * [逻辑名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean logicNameDirtyFlag;

    /**
     * [工作流步骤操作名称]
     */
    private String wFIAActionName;
    /**
     * [工作流步骤操作名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFIAActionNameDirtyFlag;

    /**
     * [工作流步骤标识]
     */
    private String wFStepId;
    /**
     * [工作流步骤标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFStepIdDirtyFlag;

    /**
     * 获取 [处理人]
     */
    public String getPersonList(){
        return this.personList ;
    }

    /**
     * 设置 [处理人]
     */
    public void setPersonList(String  personList){
        this.personList = personList ;
        this.personListDirtyFlag = true ;
    }

    /**
     * 获取 [处理人]脏标记
     */
    @JsonIgnore
    public boolean getPersonListDirtyFlag(){
        return this.personListDirtyFlag ;
    }
    /**
     * 获取 [操作人]
     */
    public String getOpPerson(){
        return this.opPerson ;
    }

    /**
     * 设置 [操作人]
     */
    public void setOpPerson(String  opPerson){
        this.opPerson = opPerson ;
        this.opPersonDirtyFlag = true ;
    }

    /**
     * 获取 [操作人]脏标记
     */
    @JsonIgnore
    public boolean getOpPersonDirtyFlag(){
        return this.opPersonDirtyFlag ;
    }
    /**
     * 获取 [用户数据2]
     */
    public String getUserData2(){
        return this.userData2 ;
    }

    /**
     * 设置 [用户数据2]
     */
    public void setUserData2(String  userData2){
        this.userData2 = userData2 ;
        this.userData2DirtyFlag = true ;
    }

    /**
     * 获取 [用户数据2]脏标记
     */
    @JsonIgnore
    public boolean getUserData2DirtyFlag(){
        return this.userData2DirtyFlag ;
    }
    /**
     * 获取 [操作类型]
     */
    public String getActionType(){
        return this.actionType ;
    }

    /**
     * 设置 [操作类型]
     */
    public void setActionType(String  actionType){
        this.actionType = actionType ;
        this.actionTypeDirtyFlag = true ;
    }

    /**
     * 获取 [操作类型]脏标记
     */
    @JsonIgnore
    public boolean getActionTypeDirtyFlag(){
        return this.actionTypeDirtyFlag ;
    }
    /**
     * 获取 [用户数据]
     */
    public String getUserData(){
        return this.userData ;
    }

    /**
     * 设置 [用户数据]
     */
    public void setUserData(String  userData){
        this.userData = userData ;
        this.userDataDirtyFlag = true ;
    }

    /**
     * 获取 [用户数据]脏标记
     */
    @JsonIgnore
    public boolean getUserDataDirtyFlag(){
        return this.userDataDirtyFlag ;
    }
    /**
     * 获取 [更新人]
     */
    public String getUpdateMan(){
        return this.updateMan ;
    }

    /**
     * 设置 [更新人]
     */
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [更新人]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return this.updateManDirtyFlag ;
    }
    /**
     * 获取 [审批意见]
     */
    public String getOpinion(){
        return this.opinion ;
    }

    /**
     * 设置 [审批意见]
     */
    public void setOpinion(String  opinion){
        this.opinion = opinion ;
        this.opinionDirtyFlag = true ;
    }

    /**
     * 获取 [审批意见]脏标记
     */
    @JsonIgnore
    public boolean getOpinionDirtyFlag(){
        return this.opinionDirtyFlag ;
    }
    /**
     * 获取 [建立时间]
     */
    public Timestamp getCreateDate(){
        return this.createDate ;
    }

    /**
     * 设置 [建立时间]
     */
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [建立时间]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return this.createDateDirtyFlag ;
    }
    /**
     * 获取 [工作流步骤操作标识]
     */
    public String getWFIAActionId(){
        return this.wFIAActionId ;
    }

    /**
     * 设置 [工作流步骤操作标识]
     */
    public void setWFIAActionId(String  wFIAActionId){
        this.wFIAActionId = wFIAActionId ;
        this.wFIAActionIdDirtyFlag = true ;
    }

    /**
     * 获取 [工作流步骤操作标识]脏标记
     */
    @JsonIgnore
    public boolean getWFIAActionIdDirtyFlag(){
        return this.wFIAActionIdDirtyFlag ;
    }
    /**
     * 获取 [实例]
     */
    public String getWFInstanceId(){
        return this.wFInstanceId ;
    }

    /**
     * 设置 [实例]
     */
    public void setWFInstanceId(String  wFInstanceId){
        this.wFInstanceId = wFInstanceId ;
        this.wFInstanceIdDirtyFlag = true ;
    }

    /**
     * 获取 [实例]脏标记
     */
    @JsonIgnore
    public boolean getWFInstanceIdDirtyFlag(){
        return this.wFInstanceIdDirtyFlag ;
    }
    /**
     * 获取 [更新时间]
     */
    public Timestamp getUpdateDate(){
        return this.updateDate ;
    }

    /**
     * 设置 [更新时间]
     */
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [更新时间]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return this.updateDateDirtyFlag ;
    }
    /**
     * 获取 [建立人]
     */
    public String getCreateMan(){
        return this.createMan ;
    }

    /**
     * 设置 [建立人]
     */
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [建立人]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return this.createManDirtyFlag ;
    }
    /**
     * 获取 [逻辑名称]
     */
    public String getLogicName(){
        return this.logicName ;
    }

    /**
     * 设置 [逻辑名称]
     */
    public void setLogicName(String  logicName){
        this.logicName = logicName ;
        this.logicNameDirtyFlag = true ;
    }

    /**
     * 获取 [逻辑名称]脏标记
     */
    @JsonIgnore
    public boolean getLogicNameDirtyFlag(){
        return this.logicNameDirtyFlag ;
    }
    /**
     * 获取 [工作流步骤操作名称]
     */
    public String getWFIAActionName(){
        return this.wFIAActionName ;
    }

    /**
     * 设置 [工作流步骤操作名称]
     */
    public void setWFIAActionName(String  wFIAActionName){
        this.wFIAActionName = wFIAActionName ;
        this.wFIAActionNameDirtyFlag = true ;
    }

    /**
     * 获取 [工作流步骤操作名称]脏标记
     */
    @JsonIgnore
    public boolean getWFIAActionNameDirtyFlag(){
        return this.wFIAActionNameDirtyFlag ;
    }
    /**
     * 获取 [工作流步骤标识]
     */
    public String getWFStepId(){
        return this.wFStepId ;
    }

    /**
     * 设置 [工作流步骤标识]
     */
    public void setWFStepId(String  wFStepId){
        this.wFStepId = wFStepId ;
        this.wFStepIdDirtyFlag = true ;
    }

    /**
     * 获取 [工作流步骤标识]脏标记
     */
    @JsonIgnore
    public boolean getWFStepIdDirtyFlag(){
        return this.wFStepIdDirtyFlag ;
    }
}