package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po;

import cn.ibizlab.r7.runtime.wf.core.repository.po.WFInstance;
import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonIgnore;
import java.io.Serializable;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import cn.ibizlab.r7.runtime.wf.util.annotation.PreField;
import cn.ibizlab.r7.runtime.wf.util.enums.FillMode;
import cn.ibizlab.r7.runtime.wf.util.enums.PredefinedType;

/**
 * 关系型数据实体表[WFInstance] 对象
 */
@TableName(value = "T_WFINSTANCE",resultMap = "T_WFINSTANCEResultMap")
public class T_WFINSTANCEImpl implements WFInstance,Serializable {

    /**
     * [开始时间]
     */
    private Timestamp startTime;
    /**
     * [开始时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean startTimeDirtyFlag;

    /**
     * [业务数据]
     */
    private String bsdata;
    /**
     * [业务数据]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean bsdataDirtyFlag;

    /**
     * [父实例标识]
     */
    private String parentInstId;
    /**
     * [父实例标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean parentInstIdDirtyFlag;

    /**
     * [指定用户]
     */
    private String wFUserId;
    /**
     * [指定用户]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFUserIdDirtyFlag;

    /**
     * [代理业务]
     */
    private String proxyModuleId;
    /**
     * [代理业务]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean proxyModuleIdDirtyFlag;

    /**
     * [发起人部门]
     */
    private String originOrgDeptId;
    /**
     * [发起人部门]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean originOrgDeptIdDirtyFlag;

    /**
     * [上一步骤值]
     */
    private String prevStepValue;
    /**
     * [上一步骤值]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean prevStepValueDirtyFlag;

    /**
     * [当前步骤值]
     */
    private String curStepValue;
    /**
     * [当前步骤值]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean curStepValueDirtyFlag;

    /**
     * [发起人]
     */
    private String originPersonId;
    /**
     * [发起人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean originPersonIdDirtyFlag;

    /**
     * [实例类型]
     */
    private String instanceType;
    /**
     * [实例类型]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean instanceTypeDirtyFlag;

    /**
     * [建立人]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    private String createMan;
    /**
     * [建立人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createManDirtyFlag;

    /**
     * [是否关闭]
     */
    private Integer isclosed;
    /**
     * [是否关闭]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean isclosedDirtyFlag;

    /**
     * [发起人组织]
     */
    private String originOrgName;
    /**
     * [发起人组织]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean originOrgNameDirtyFlag;

    /**
     * [流程所有者]
     */
    private String owner;
    /**
     * [流程所有者]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean ownerDirtyFlag;

    /**
     * [父实例步骤]
     */
    private String parentStep;
    /**
     * [父实例步骤]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean parentStepDirtyFlag;

    /**
     * [工作流实例标识]
     */
    @TableId(value= "wfinstanceid",type=IdType.UUID)
    private String wFInstanceId;
    /**
     * [工作流实例标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFInstanceIdDirtyFlag;

    /**
     * [流程数据]
     */
    private String bswfdata;
    /**
     * [流程数据]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean bswfdataDirtyFlag;

    /**
     * [工作流实例名称]
     */
    private String wFInstanceName;
    /**
     * [工作流实例名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFInstanceNameDirtyFlag;

    /**
     * [发起人部门]
     */
    private String originOrgDeptName;
    /**
     * [发起人部门]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean originOrgDeptNameDirtyFlag;

    /**
     * [结束时间]
     */
    private Timestamp endtime;
    /**
     * [结束时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean endtimeDirtyFlag;

    /**
     * [发起人组织]
     */
    private String originOrgId;
    /**
     * [发起人组织]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean originOrgIdDirtyFlag;

    /**
     * [工作流引擎实例标识]
     */
    private String wFEngineInstanceId;
    /**
     * [工作流引擎实例标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFEngineInstanceIdDirtyFlag;

    /**
     * [更新人]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    private String updateMan;
    /**
     * [更新人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateManDirtyFlag;

    /**
     * [上一步流程处理]
     */
    private String prevProcess;
    /**
     * [上一步流程处理]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean prevProcessDirtyFlag;

    /**
     * [建立时间]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createDate;
    /**
     * [建立时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createDateDirtyFlag;

    /**
     * [发起人]
     */
    private String originPersonName;
    /**
     * [发起人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean originPersonNameDirtyFlag;

    /**
     * [流程状态]
     */
    private String wFState;
    /**
     * [流程状态]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFStateDirtyFlag;

    /**
     * [上一步骤]
     */
    private String prevstep;
    /**
     * [上一步骤]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean prevstepDirtyFlag;

    /**
     * [更新时间]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updateDate;
    /**
     * [更新时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateDateDirtyFlag;

    /**
     * [当前流程处理]
     */
    private String curProcess;
    /**
     * [当前流程处理]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean curProcessDirtyFlag;

    /**
     * [当前步骤]
     */
    private String curstep;
    /**
     * [当前步骤]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean curstepDirtyFlag;

    /**
     * [逻辑名称]
     */
    private String logicName;
    /**
     * [逻辑名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean logicNameDirtyFlag;

    /**
     * [主实例标识]
     */
    private String majorInstId;
    /**
     * [主实例标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean majorInstIdDirtyFlag;

    /**
     * [部门标识]
     */
    private String orgDeptId;
    /**
     * [部门标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean orgDeptIdDirtyFlag;

    /**
     * [工作流引擎标识]
     */
    private String wFEngineId;
    /**
     * [工作流引擎标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFEngineIdDirtyFlag;

    /**
     * [业务工作流标识]
     */
    private String pSWorkflowId;
    /**
     * [业务工作流标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSWorkflowIdDirtyFlag;

    /**
     * [组织标识]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.ORGID)
    private String orgId;
    /**
     * [组织标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean orgIdDirtyFlag;

    /**
     * [业务流程版本标识]
     */
    private String pSWFVersionId;
    /**
     * [业务流程版本标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSWFVersionIdDirtyFlag;

    /**
     * 获取 [开始时间]
     */
    public Timestamp getStartTime(){
        return this.startTime ;
    }

    /**
     * 设置 [开始时间]
     */
    public void setStartTime(Timestamp  startTime){
        this.startTime = startTime ;
        this.startTimeDirtyFlag = true ;
    }

    /**
     * 获取 [开始时间]脏标记
     */
    @JsonIgnore
    public boolean getStartTimeDirtyFlag(){
        return this.startTimeDirtyFlag ;
    }
    /**
     * 获取 [业务数据]
     */
    public String getBsdata(){
        return this.bsdata ;
    }

    /**
     * 设置 [业务数据]
     */
    public void setBsdata(String  bsdata){
        this.bsdata = bsdata ;
        this.bsdataDirtyFlag = true ;
    }

    /**
     * 获取 [业务数据]脏标记
     */
    @JsonIgnore
    public boolean getBsdataDirtyFlag(){
        return this.bsdataDirtyFlag ;
    }
    /**
     * 获取 [父实例标识]
     */
    public String getParentInstId(){
        return this.parentInstId ;
    }

    /**
     * 设置 [父实例标识]
     */
    public void setParentInstId(String  parentInstId){
        this.parentInstId = parentInstId ;
        this.parentInstIdDirtyFlag = true ;
    }

    /**
     * 获取 [父实例标识]脏标记
     */
    @JsonIgnore
    public boolean getParentInstIdDirtyFlag(){
        return this.parentInstIdDirtyFlag ;
    }
    /**
     * 获取 [指定用户]
     */
    public String getWFUserId(){
        return this.wFUserId ;
    }

    /**
     * 设置 [指定用户]
     */
    public void setWFUserId(String  wFUserId){
        this.wFUserId = wFUserId ;
        this.wFUserIdDirtyFlag = true ;
    }

    /**
     * 获取 [指定用户]脏标记
     */
    @JsonIgnore
    public boolean getWFUserIdDirtyFlag(){
        return this.wFUserIdDirtyFlag ;
    }
    /**
     * 获取 [代理业务]
     */
    public String getProxyModuleId(){
        return this.proxyModuleId ;
    }

    /**
     * 设置 [代理业务]
     */
    public void setProxyModuleId(String  proxyModuleId){
        this.proxyModuleId = proxyModuleId ;
        this.proxyModuleIdDirtyFlag = true ;
    }

    /**
     * 获取 [代理业务]脏标记
     */
    @JsonIgnore
    public boolean getProxyModuleIdDirtyFlag(){
        return this.proxyModuleIdDirtyFlag ;
    }
    /**
     * 获取 [发起人部门]
     */
    public String getOriginOrgDeptId(){
        return this.originOrgDeptId ;
    }

    /**
     * 设置 [发起人部门]
     */
    public void setOriginOrgDeptId(String  originOrgDeptId){
        this.originOrgDeptId = originOrgDeptId ;
        this.originOrgDeptIdDirtyFlag = true ;
    }

    /**
     * 获取 [发起人部门]脏标记
     */
    @JsonIgnore
    public boolean getOriginOrgDeptIdDirtyFlag(){
        return this.originOrgDeptIdDirtyFlag ;
    }
    /**
     * 获取 [上一步骤值]
     */
    public String getPrevStepValue(){
        return this.prevStepValue ;
    }

    /**
     * 设置 [上一步骤值]
     */
    public void setPrevStepValue(String  prevStepValue){
        this.prevStepValue = prevStepValue ;
        this.prevStepValueDirtyFlag = true ;
    }

    /**
     * 获取 [上一步骤值]脏标记
     */
    @JsonIgnore
    public boolean getPrevStepValueDirtyFlag(){
        return this.prevStepValueDirtyFlag ;
    }
    /**
     * 获取 [当前步骤值]
     */
    public String getCurStepValue(){
        return this.curStepValue ;
    }

    /**
     * 设置 [当前步骤值]
     */
    public void setCurStepValue(String  curStepValue){
        this.curStepValue = curStepValue ;
        this.curStepValueDirtyFlag = true ;
    }

    /**
     * 获取 [当前步骤值]脏标记
     */
    @JsonIgnore
    public boolean getCurStepValueDirtyFlag(){
        return this.curStepValueDirtyFlag ;
    }
    /**
     * 获取 [发起人]
     */
    public String getOriginPersonId(){
        return this.originPersonId ;
    }

    /**
     * 设置 [发起人]
     */
    public void setOriginPersonId(String  originPersonId){
        this.originPersonId = originPersonId ;
        this.originPersonIdDirtyFlag = true ;
    }

    /**
     * 获取 [发起人]脏标记
     */
    @JsonIgnore
    public boolean getOriginPersonIdDirtyFlag(){
        return this.originPersonIdDirtyFlag ;
    }
    /**
     * 获取 [实例类型]
     */
    public String getInstanceType(){
        return this.instanceType ;
    }

    /**
     * 设置 [实例类型]
     */
    public void setInstanceType(String  instanceType){
        this.instanceType = instanceType ;
        this.instanceTypeDirtyFlag = true ;
    }

    /**
     * 获取 [实例类型]脏标记
     */
    @JsonIgnore
    public boolean getInstanceTypeDirtyFlag(){
        return this.instanceTypeDirtyFlag ;
    }
    /**
     * 获取 [建立人]
     */
    public String getCreateMan(){
        return this.createMan ;
    }

    /**
     * 设置 [建立人]
     */
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [建立人]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return this.createManDirtyFlag ;
    }
    /**
     * 获取 [是否关闭]
     */
    public Integer getIsclosed(){
        return this.isclosed ;
    }

    /**
     * 设置 [是否关闭]
     */
    public void setIsclosed(Integer  isclosed){
        this.isclosed = isclosed ;
        this.isclosedDirtyFlag = true ;
    }

    /**
     * 获取 [是否关闭]脏标记
     */
    @JsonIgnore
    public boolean getIsclosedDirtyFlag(){
        return this.isclosedDirtyFlag ;
    }
    /**
     * 获取 [发起人组织]
     */
    public String getOriginOrgName(){
        return this.originOrgName ;
    }

    /**
     * 设置 [发起人组织]
     */
    public void setOriginOrgName(String  originOrgName){
        this.originOrgName = originOrgName ;
        this.originOrgNameDirtyFlag = true ;
    }

    /**
     * 获取 [发起人组织]脏标记
     */
    @JsonIgnore
    public boolean getOriginOrgNameDirtyFlag(){
        return this.originOrgNameDirtyFlag ;
    }
    /**
     * 获取 [流程所有者]
     */
    public String getOwner(){
        return this.owner ;
    }

    /**
     * 设置 [流程所有者]
     */
    public void setOwner(String  owner){
        this.owner = owner ;
        this.ownerDirtyFlag = true ;
    }

    /**
     * 获取 [流程所有者]脏标记
     */
    @JsonIgnore
    public boolean getOwnerDirtyFlag(){
        return this.ownerDirtyFlag ;
    }
    /**
     * 获取 [父实例步骤]
     */
    public String getParentStep(){
        return this.parentStep ;
    }

    /**
     * 设置 [父实例步骤]
     */
    public void setParentStep(String  parentStep){
        this.parentStep = parentStep ;
        this.parentStepDirtyFlag = true ;
    }

    /**
     * 获取 [父实例步骤]脏标记
     */
    @JsonIgnore
    public boolean getParentStepDirtyFlag(){
        return this.parentStepDirtyFlag ;
    }
    /**
     * 获取 [工作流实例标识]
     */
    public String getWFInstanceId(){
        return this.wFInstanceId ;
    }

    /**
     * 设置 [工作流实例标识]
     */
    public void setWFInstanceId(String  wFInstanceId){
        this.wFInstanceId = wFInstanceId ;
        this.wFInstanceIdDirtyFlag = true ;
    }

    /**
     * 获取 [工作流实例标识]脏标记
     */
    @JsonIgnore
    public boolean getWFInstanceIdDirtyFlag(){
        return this.wFInstanceIdDirtyFlag ;
    }
    /**
     * 获取 [流程数据]
     */
    public String getBswfdata(){
        return this.bswfdata ;
    }

    /**
     * 设置 [流程数据]
     */
    public void setBswfdata(String  bswfdata){
        this.bswfdata = bswfdata ;
        this.bswfdataDirtyFlag = true ;
    }

    /**
     * 获取 [流程数据]脏标记
     */
    @JsonIgnore
    public boolean getBswfdataDirtyFlag(){
        return this.bswfdataDirtyFlag ;
    }
    /**
     * 获取 [工作流实例名称]
     */
    public String getWFInstanceName(){
        return this.wFInstanceName ;
    }

    /**
     * 设置 [工作流实例名称]
     */
    public void setWFInstanceName(String  wFInstanceName){
        this.wFInstanceName = wFInstanceName ;
        this.wFInstanceNameDirtyFlag = true ;
    }

    /**
     * 获取 [工作流实例名称]脏标记
     */
    @JsonIgnore
    public boolean getWFInstanceNameDirtyFlag(){
        return this.wFInstanceNameDirtyFlag ;
    }
    /**
     * 获取 [发起人部门]
     */
    public String getOriginOrgDeptName(){
        return this.originOrgDeptName ;
    }

    /**
     * 设置 [发起人部门]
     */
    public void setOriginOrgDeptName(String  originOrgDeptName){
        this.originOrgDeptName = originOrgDeptName ;
        this.originOrgDeptNameDirtyFlag = true ;
    }

    /**
     * 获取 [发起人部门]脏标记
     */
    @JsonIgnore
    public boolean getOriginOrgDeptNameDirtyFlag(){
        return this.originOrgDeptNameDirtyFlag ;
    }
    /**
     * 获取 [结束时间]
     */
    public Timestamp getEndtime(){
        return this.endtime ;
    }

    /**
     * 设置 [结束时间]
     */
    public void setEndtime(Timestamp  endtime){
        this.endtime = endtime ;
        this.endtimeDirtyFlag = true ;
    }

    /**
     * 获取 [结束时间]脏标记
     */
    @JsonIgnore
    public boolean getEndtimeDirtyFlag(){
        return this.endtimeDirtyFlag ;
    }
    /**
     * 获取 [发起人组织]
     */
    public String getOriginOrgId(){
        return this.originOrgId ;
    }

    /**
     * 设置 [发起人组织]
     */
    public void setOriginOrgId(String  originOrgId){
        this.originOrgId = originOrgId ;
        this.originOrgIdDirtyFlag = true ;
    }

    /**
     * 获取 [发起人组织]脏标记
     */
    @JsonIgnore
    public boolean getOriginOrgIdDirtyFlag(){
        return this.originOrgIdDirtyFlag ;
    }
    /**
     * 获取 [工作流引擎实例标识]
     */
    public String getWFEngineInstanceId(){
        return this.wFEngineInstanceId ;
    }

    /**
     * 设置 [工作流引擎实例标识]
     */
    public void setWFEngineInstanceId(String  wFEngineInstanceId){
        this.wFEngineInstanceId = wFEngineInstanceId ;
        this.wFEngineInstanceIdDirtyFlag = true ;
    }

    /**
     * 获取 [工作流引擎实例标识]脏标记
     */
    @JsonIgnore
    public boolean getWFEngineInstanceIdDirtyFlag(){
        return this.wFEngineInstanceIdDirtyFlag ;
    }
    /**
     * 获取 [更新人]
     */
    public String getUpdateMan(){
        return this.updateMan ;
    }

    /**
     * 设置 [更新人]
     */
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [更新人]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return this.updateManDirtyFlag ;
    }
    /**
     * 获取 [上一步流程处理]
     */
    public String getPrevProcess(){
        return this.prevProcess ;
    }

    /**
     * 设置 [上一步流程处理]
     */
    public void setPrevProcess(String  prevProcess){
        this.prevProcess = prevProcess ;
        this.prevProcessDirtyFlag = true ;
    }

    /**
     * 获取 [上一步流程处理]脏标记
     */
    @JsonIgnore
    public boolean getPrevProcessDirtyFlag(){
        return this.prevProcessDirtyFlag ;
    }
    /**
     * 获取 [建立时间]
     */
    public Timestamp getCreateDate(){
        return this.createDate ;
    }

    /**
     * 设置 [建立时间]
     */
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [建立时间]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return this.createDateDirtyFlag ;
    }
    /**
     * 获取 [发起人]
     */
    public String getOriginPersonName(){
        return this.originPersonName ;
    }

    /**
     * 设置 [发起人]
     */
    public void setOriginPersonName(String  originPersonName){
        this.originPersonName = originPersonName ;
        this.originPersonNameDirtyFlag = true ;
    }

    /**
     * 获取 [发起人]脏标记
     */
    @JsonIgnore
    public boolean getOriginPersonNameDirtyFlag(){
        return this.originPersonNameDirtyFlag ;
    }
    /**
     * 获取 [流程状态]
     */
    public String getWFState(){
        return this.wFState ;
    }

    /**
     * 设置 [流程状态]
     */
    public void setWFState(String  wFState){
        this.wFState = wFState ;
        this.wFStateDirtyFlag = true ;
    }

    /**
     * 获取 [流程状态]脏标记
     */
    @JsonIgnore
    public boolean getWFStateDirtyFlag(){
        return this.wFStateDirtyFlag ;
    }
    /**
     * 获取 [上一步骤]
     */
    public String getPrevstep(){
        return this.prevstep ;
    }

    /**
     * 设置 [上一步骤]
     */
    public void setPrevstep(String  prevstep){
        this.prevstep = prevstep ;
        this.prevstepDirtyFlag = true ;
    }

    /**
     * 获取 [上一步骤]脏标记
     */
    @JsonIgnore
    public boolean getPrevstepDirtyFlag(){
        return this.prevstepDirtyFlag ;
    }
    /**
     * 获取 [更新时间]
     */
    public Timestamp getUpdateDate(){
        return this.updateDate ;
    }

    /**
     * 设置 [更新时间]
     */
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [更新时间]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return this.updateDateDirtyFlag ;
    }
    /**
     * 获取 [当前流程处理]
     */
    public String getCurProcess(){
        return this.curProcess ;
    }

    /**
     * 设置 [当前流程处理]
     */
    public void setCurProcess(String  curProcess){
        this.curProcess = curProcess ;
        this.curProcessDirtyFlag = true ;
    }

    /**
     * 获取 [当前流程处理]脏标记
     */
    @JsonIgnore
    public boolean getCurProcessDirtyFlag(){
        return this.curProcessDirtyFlag ;
    }
    /**
     * 获取 [当前步骤]
     */
    public String getCurstep(){
        return this.curstep ;
    }

    /**
     * 设置 [当前步骤]
     */
    public void setCurstep(String  curstep){
        this.curstep = curstep ;
        this.curstepDirtyFlag = true ;
    }

    /**
     * 获取 [当前步骤]脏标记
     */
    @JsonIgnore
    public boolean getCurstepDirtyFlag(){
        return this.curstepDirtyFlag ;
    }
    /**
     * 获取 [逻辑名称]
     */
    public String getLogicName(){
        return this.logicName ;
    }

    /**
     * 设置 [逻辑名称]
     */
    public void setLogicName(String  logicName){
        this.logicName = logicName ;
        this.logicNameDirtyFlag = true ;
    }

    /**
     * 获取 [逻辑名称]脏标记
     */
    @JsonIgnore
    public boolean getLogicNameDirtyFlag(){
        return this.logicNameDirtyFlag ;
    }
    /**
     * 获取 [主实例标识]
     */
    public String getMajorInstId(){
        return this.majorInstId ;
    }

    /**
     * 设置 [主实例标识]
     */
    public void setMajorInstId(String  majorInstId){
        this.majorInstId = majorInstId ;
        this.majorInstIdDirtyFlag = true ;
    }

    /**
     * 获取 [主实例标识]脏标记
     */
    @JsonIgnore
    public boolean getMajorInstIdDirtyFlag(){
        return this.majorInstIdDirtyFlag ;
    }
    /**
     * 获取 [部门标识]
     */
    public String getOrgDeptId(){
        return this.orgDeptId ;
    }

    /**
     * 设置 [部门标识]
     */
    public void setOrgDeptId(String  orgDeptId){
        this.orgDeptId = orgDeptId ;
        this.orgDeptIdDirtyFlag = true ;
    }

    /**
     * 获取 [部门标识]脏标记
     */
    @JsonIgnore
    public boolean getOrgDeptIdDirtyFlag(){
        return this.orgDeptIdDirtyFlag ;
    }
    /**
     * 获取 [工作流引擎标识]
     */
    public String getWFEngineId(){
        return this.wFEngineId ;
    }

    /**
     * 设置 [工作流引擎标识]
     */
    public void setWFEngineId(String  wFEngineId){
        this.wFEngineId = wFEngineId ;
        this.wFEngineIdDirtyFlag = true ;
    }

    /**
     * 获取 [工作流引擎标识]脏标记
     */
    @JsonIgnore
    public boolean getWFEngineIdDirtyFlag(){
        return this.wFEngineIdDirtyFlag ;
    }
    /**
     * 获取 [业务工作流标识]
     */
    public String getPSWorkflowId(){
        return this.pSWorkflowId ;
    }

    /**
     * 设置 [业务工作流标识]
     */
    public void setPSWorkflowId(String  pSWorkflowId){
        this.pSWorkflowId = pSWorkflowId ;
        this.pSWorkflowIdDirtyFlag = true ;
    }

    /**
     * 获取 [业务工作流标识]脏标记
     */
    @JsonIgnore
    public boolean getPSWorkflowIdDirtyFlag(){
        return this.pSWorkflowIdDirtyFlag ;
    }
    /**
     * 获取 [组织标识]
     */
    public String getOrgId(){
        return this.orgId ;
    }

    /**
     * 设置 [组织标识]
     */
    public void setOrgId(String  orgId){
        this.orgId = orgId ;
        this.orgIdDirtyFlag = true ;
    }

    /**
     * 获取 [组织标识]脏标记
     */
    @JsonIgnore
    public boolean getOrgIdDirtyFlag(){
        return this.orgIdDirtyFlag ;
    }
    /**
     * 获取 [业务流程版本标识]
     */
    public String getPSWFVersionId(){
        return this.pSWFVersionId ;
    }

    /**
     * 设置 [业务流程版本标识]
     */
    public void setPSWFVersionId(String  pSWFVersionId){
        this.pSWFVersionId = pSWFVersionId ;
        this.pSWFVersionIdDirtyFlag = true ;
    }

    /**
     * 获取 [业务流程版本标识]脏标记
     */
    @JsonIgnore
    public boolean getPSWFVersionIdDirtyFlag(){
        return this.pSWFVersionIdDirtyFlag ;
    }
}