package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po;

import cn.ibizlab.r7.runtime.wf.core.repository.po.WFMode;
import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonIgnore;
import java.io.Serializable;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import cn.ibizlab.r7.runtime.wf.util.annotation.PreField;
import cn.ibizlab.r7.runtime.wf.util.enums.FillMode;
import cn.ibizlab.r7.runtime.wf.util.enums.PredefinedType;

/**
 * 关系型数据实体表[WFMode] 对象
 */
@TableName(value = "T_WFMODE",resultMap = "T_WFMODEResultMap")
public class T_WFMODEImpl implements WFMode,Serializable {

    /**
     * [逻辑名称]
     */
    private String logicName;
    /**
     * [逻辑名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean logicNameDirtyFlag;

    /**
     * [建立时间]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createDate;
    /**
     * [建立时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createDateDirtyFlag;

    /**
     * [工作流模式标识]
     */
    @TableId(value= "wfmodeid",type=IdType.UUID)
    private String wFModeId;
    /**
     * [工作流模式标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFModeIdDirtyFlag;

    /**
     * [更新人]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    private String updateMan;
    /**
     * [更新人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateManDirtyFlag;

    /**
     * [更新时间]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updateDate;
    /**
     * [更新时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateDateDirtyFlag;

    /**
     * [建立人]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    private String createMan;
    /**
     * [建立人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createManDirtyFlag;

    /**
     * [工作流模式名称]
     */
    private String wFModeName;
    /**
     * [工作流模式名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFModeNameDirtyFlag;

    /**
     * [业务系统标识]
     */
    private String pSSystemId;
    /**
     * [业务系统标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSSystemIdDirtyFlag;

    /**
     * 获取 [逻辑名称]
     */
    public String getLogicName(){
        return this.logicName ;
    }

    /**
     * 设置 [逻辑名称]
     */
    public void setLogicName(String  logicName){
        this.logicName = logicName ;
        this.logicNameDirtyFlag = true ;
    }

    /**
     * 获取 [逻辑名称]脏标记
     */
    @JsonIgnore
    public boolean getLogicNameDirtyFlag(){
        return this.logicNameDirtyFlag ;
    }
    /**
     * 获取 [建立时间]
     */
    public Timestamp getCreateDate(){
        return this.createDate ;
    }

    /**
     * 设置 [建立时间]
     */
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [建立时间]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return this.createDateDirtyFlag ;
    }
    /**
     * 获取 [工作流模式标识]
     */
    public String getWFModeId(){
        return this.wFModeId ;
    }

    /**
     * 设置 [工作流模式标识]
     */
    public void setWFModeId(String  wFModeId){
        this.wFModeId = wFModeId ;
        this.wFModeIdDirtyFlag = true ;
    }

    /**
     * 获取 [工作流模式标识]脏标记
     */
    @JsonIgnore
    public boolean getWFModeIdDirtyFlag(){
        return this.wFModeIdDirtyFlag ;
    }
    /**
     * 获取 [更新人]
     */
    public String getUpdateMan(){
        return this.updateMan ;
    }

    /**
     * 设置 [更新人]
     */
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [更新人]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return this.updateManDirtyFlag ;
    }
    /**
     * 获取 [更新时间]
     */
    public Timestamp getUpdateDate(){
        return this.updateDate ;
    }

    /**
     * 设置 [更新时间]
     */
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [更新时间]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return this.updateDateDirtyFlag ;
    }
    /**
     * 获取 [建立人]
     */
    public String getCreateMan(){
        return this.createMan ;
    }

    /**
     * 设置 [建立人]
     */
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [建立人]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return this.createManDirtyFlag ;
    }
    /**
     * 获取 [工作流模式名称]
     */
    public String getWFModeName(){
        return this.wFModeName ;
    }

    /**
     * 设置 [工作流模式名称]
     */
    public void setWFModeName(String  wFModeName){
        this.wFModeName = wFModeName ;
        this.wFModeNameDirtyFlag = true ;
    }

    /**
     * 获取 [工作流模式名称]脏标记
     */
    @JsonIgnore
    public boolean getWFModeNameDirtyFlag(){
        return this.wFModeNameDirtyFlag ;
    }
    /**
     * 获取 [业务系统标识]
     */
    public String getPSSystemId(){
        return this.pSSystemId ;
    }

    /**
     * 设置 [业务系统标识]
     */
    public void setPSSystemId(String  pSSystemId){
        this.pSSystemId = pSSystemId ;
        this.pSSystemIdDirtyFlag = true ;
    }

    /**
     * 获取 [业务系统标识]脏标记
     */
    @JsonIgnore
    public boolean getPSSystemIdDirtyFlag(){
        return this.pSSystemIdDirtyFlag ;
    }
}