package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po;

import cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepActor;
import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonIgnore;
import java.io.Serializable;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import cn.ibizlab.r7.runtime.wf.util.annotation.PreField;
import cn.ibizlab.r7.runtime.wf.util.enums.FillMode;
import cn.ibizlab.r7.runtime.wf.util.enums.PredefinedType;

/**
 * 关系型数据实体表[WFStepActor] 对象
 */
@TableName(value = "T_WFSTEPACTOR",resultMap = "T_WFSTEPACTORResultMap")
public class T_WFSTEPACTORImpl implements WFStepActor,Serializable {

    /**
     * [逻辑名称]
     */
    private String logicName;
    /**
     * [逻辑名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean logicNameDirtyFlag;

    /**
     * [父实例标识]
     */
    private String parentInstId;
    /**
     * [父实例标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean parentInstIdDirtyFlag;

    /**
     * [更新时间]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updateDate;
    /**
     * [更新时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateDateDirtyFlag;

    /**
     * [主实例标识]
     */
    private String majorInstId;
    /**
     * [主实例标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean majorInstIdDirtyFlag;

    /**
     * [工作流步骤操作者标识]
     */
    @TableId(value= "wfstepactorid",type=IdType.UUID)
    private String wFStepActorId;
    /**
     * [工作流步骤操作者标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFStepActorIdDirtyFlag;

    /**
     * [更新人]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    private String updateMan;
    /**
     * [更新人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateManDirtyFlag;

    /**
     * [建立时间]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createDate;
    /**
     * [建立时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createDateDirtyFlag;

    /**
     * [完成时间]
     */
    private Timestamp finishTime;
    /**
     * [完成时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean finishTimeDirtyFlag;

    /**
     * [工作流步骤操作者名称]
     */
    private String wFStepActorName;
    /**
     * [工作流步骤操作者名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFStepActorNameDirtyFlag;

    /**
     * [任务标识]
     */
    private String taskId;
    /**
     * [任务标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean taskIdDirtyFlag;

    /**
     * [建立人]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    private String createMan;
    /**
     * [建立人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createManDirtyFlag;

    /**
     * [是否处理]
     */
    private Integer isFinish;
    /**
     * [是否处理]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean isFinishDirtyFlag;

    /**
     * [查看时间]
     */
    private Timestamp readTime;
    /**
     * [查看时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean readTimeDirtyFlag;

    /**
     * [只读]
     */
    private Integer isReadOnly;
    /**
     * [只读]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean isReadOnlyDirtyFlag;

    /**
     * [开始时间]
     */
    private Timestamp startTime;
    /**
     * [开始时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean startTimeDirtyFlag;

    @TableField(exist = false)
    private String wFUserName;
    /**
     * [工作流用户名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFUserNameDirtyFlag;

    /**
     * [工作流用户标识]
     */
    private String wFUserId;
    /**
     * [工作流用户标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFUserIdDirtyFlag;

    /**
     * [工作流步骤标识]
     */
    private String wFStepId;
    /**
     * [工作流步骤标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFStepIdDirtyFlag;

    /**
     * [流程处理标识]
     */
    private String pSWFProcessId;
    /**
     * [流程处理标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSWFProcessIdDirtyFlag;

    /**
     * [工作流实例标识]
     */
    private String wFInstanceId;
    /**
     * [工作流实例标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFInstanceIdDirtyFlag;

    /**
     * [业务流程版本标识]
     */
    private String pSWFVersionId;
    /**
     * [业务流程版本标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSWFVersionIdDirtyFlag;

    /**
     * 获取 [逻辑名称]
     */
    public String getLogicName(){
        return this.logicName ;
    }

    /**
     * 设置 [逻辑名称]
     */
    public void setLogicName(String  logicName){
        this.logicName = logicName ;
        this.logicNameDirtyFlag = true ;
    }

    /**
     * 获取 [逻辑名称]脏标记
     */
    @JsonIgnore
    public boolean getLogicNameDirtyFlag(){
        return this.logicNameDirtyFlag ;
    }
    /**
     * 获取 [父实例标识]
     */
    public String getParentInstId(){
        return this.parentInstId ;
    }

    /**
     * 设置 [父实例标识]
     */
    public void setParentInstId(String  parentInstId){
        this.parentInstId = parentInstId ;
        this.parentInstIdDirtyFlag = true ;
    }

    /**
     * 获取 [父实例标识]脏标记
     */
    @JsonIgnore
    public boolean getParentInstIdDirtyFlag(){
        return this.parentInstIdDirtyFlag ;
    }
    /**
     * 获取 [更新时间]
     */
    public Timestamp getUpdateDate(){
        return this.updateDate ;
    }

    /**
     * 设置 [更新时间]
     */
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [更新时间]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return this.updateDateDirtyFlag ;
    }
    /**
     * 获取 [主实例标识]
     */
    public String getMajorInstId(){
        return this.majorInstId ;
    }

    /**
     * 设置 [主实例标识]
     */
    public void setMajorInstId(String  majorInstId){
        this.majorInstId = majorInstId ;
        this.majorInstIdDirtyFlag = true ;
    }

    /**
     * 获取 [主实例标识]脏标记
     */
    @JsonIgnore
    public boolean getMajorInstIdDirtyFlag(){
        return this.majorInstIdDirtyFlag ;
    }
    /**
     * 获取 [工作流步骤操作者标识]
     */
    public String getWFStepActorId(){
        return this.wFStepActorId ;
    }

    /**
     * 设置 [工作流步骤操作者标识]
     */
    public void setWFStepActorId(String  wFStepActorId){
        this.wFStepActorId = wFStepActorId ;
        this.wFStepActorIdDirtyFlag = true ;
    }

    /**
     * 获取 [工作流步骤操作者标识]脏标记
     */
    @JsonIgnore
    public boolean getWFStepActorIdDirtyFlag(){
        return this.wFStepActorIdDirtyFlag ;
    }
    /**
     * 获取 [更新人]
     */
    public String getUpdateMan(){
        return this.updateMan ;
    }

    /**
     * 设置 [更新人]
     */
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [更新人]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return this.updateManDirtyFlag ;
    }
    /**
     * 获取 [建立时间]
     */
    public Timestamp getCreateDate(){
        return this.createDate ;
    }

    /**
     * 设置 [建立时间]
     */
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [建立时间]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return this.createDateDirtyFlag ;
    }
    /**
     * 获取 [完成时间]
     */
    public Timestamp getFinishTime(){
        return this.finishTime ;
    }

    /**
     * 设置 [完成时间]
     */
    public void setFinishTime(Timestamp  finishTime){
        this.finishTime = finishTime ;
        this.finishTimeDirtyFlag = true ;
    }

    /**
     * 获取 [完成时间]脏标记
     */
    @JsonIgnore
    public boolean getFinishTimeDirtyFlag(){
        return this.finishTimeDirtyFlag ;
    }
    /**
     * 获取 [工作流步骤操作者名称]
     */
    public String getWFStepActorName(){
        return this.wFStepActorName ;
    }

    /**
     * 设置 [工作流步骤操作者名称]
     */
    public void setWFStepActorName(String  wFStepActorName){
        this.wFStepActorName = wFStepActorName ;
        this.wFStepActorNameDirtyFlag = true ;
    }

    /**
     * 获取 [工作流步骤操作者名称]脏标记
     */
    @JsonIgnore
    public boolean getWFStepActorNameDirtyFlag(){
        return this.wFStepActorNameDirtyFlag ;
    }
    /**
     * 获取 [任务标识]
     */
    public String getTaskId(){
        return this.taskId ;
    }

    /**
     * 设置 [任务标识]
     */
    public void setTaskId(String  taskId){
        this.taskId = taskId ;
        this.taskIdDirtyFlag = true ;
    }

    /**
     * 获取 [任务标识]脏标记
     */
    @JsonIgnore
    public boolean getTaskIdDirtyFlag(){
        return this.taskIdDirtyFlag ;
    }
    /**
     * 获取 [建立人]
     */
    public String getCreateMan(){
        return this.createMan ;
    }

    /**
     * 设置 [建立人]
     */
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [建立人]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return this.createManDirtyFlag ;
    }
    /**
     * 获取 [是否处理]
     */
    public Integer getIsFinish(){
        return this.isFinish ;
    }

    /**
     * 设置 [是否处理]
     */
    public void setIsFinish(Integer  isFinish){
        this.isFinish = isFinish ;
        this.isFinishDirtyFlag = true ;
    }

    /**
     * 获取 [是否处理]脏标记
     */
    @JsonIgnore
    public boolean getIsFinishDirtyFlag(){
        return this.isFinishDirtyFlag ;
    }
    /**
     * 获取 [查看时间]
     */
    public Timestamp getReadTime(){
        return this.readTime ;
    }

    /**
     * 设置 [查看时间]
     */
    public void setReadTime(Timestamp  readTime){
        this.readTime = readTime ;
        this.readTimeDirtyFlag = true ;
    }

    /**
     * 获取 [查看时间]脏标记
     */
    @JsonIgnore
    public boolean getReadTimeDirtyFlag(){
        return this.readTimeDirtyFlag ;
    }
    /**
     * 获取 [只读]
     */
    public Integer getIsReadOnly(){
        return this.isReadOnly ;
    }

    /**
     * 设置 [只读]
     */
    public void setIsReadOnly(Integer  isReadOnly){
        this.isReadOnly = isReadOnly ;
        this.isReadOnlyDirtyFlag = true ;
    }

    /**
     * 获取 [只读]脏标记
     */
    @JsonIgnore
    public boolean getIsReadOnlyDirtyFlag(){
        return this.isReadOnlyDirtyFlag ;
    }
    /**
     * 获取 [开始时间]
     */
    public Timestamp getStartTime(){
        return this.startTime ;
    }

    /**
     * 设置 [开始时间]
     */
    public void setStartTime(Timestamp  startTime){
        this.startTime = startTime ;
        this.startTimeDirtyFlag = true ;
    }

    /**
     * 获取 [开始时间]脏标记
     */
    @JsonIgnore
    public boolean getStartTimeDirtyFlag(){
        return this.startTimeDirtyFlag ;
    }
    /**
     * 获取 [工作流用户名称]
     */
    public String getWFUserName(){
        return this.wFUserName ;   
    }

    /**
     * 设置 [工作流用户名称]
     */
    public void setWFUserName(String  wFUserName){
        this.wFUserName = wFUserName ;
        this.wFUserNameDirtyFlag = true ;
    }

    /**
     * 获取 [工作流用户名称]脏标记
     */
    @JsonIgnore
    public boolean getWFUserNameDirtyFlag(){
        return this.wFUserNameDirtyFlag ;
    }
    /**
     * 获取 [工作流用户标识]
     */
    public String getWFUserId(){
        return this.wFUserId ;
    }

    /**
     * 设置 [工作流用户标识]
     */
    public void setWFUserId(String  wFUserId){
        this.wFUserId = wFUserId ;
        this.wFUserIdDirtyFlag = true ;
    }

    /**
     * 获取 [工作流用户标识]脏标记
     */
    @JsonIgnore
    public boolean getWFUserIdDirtyFlag(){
        return this.wFUserIdDirtyFlag ;
    }
    /**
     * 获取 [工作流步骤标识]
     */
    public String getWFStepId(){
        return this.wFStepId ;
    }

    /**
     * 设置 [工作流步骤标识]
     */
    public void setWFStepId(String  wFStepId){
        this.wFStepId = wFStepId ;
        this.wFStepIdDirtyFlag = true ;
    }

    /**
     * 获取 [工作流步骤标识]脏标记
     */
    @JsonIgnore
    public boolean getWFStepIdDirtyFlag(){
        return this.wFStepIdDirtyFlag ;
    }
    /**
     * 获取 [流程处理标识]
     */
    public String getPSWFProcessId(){
        return this.pSWFProcessId ;
    }

    /**
     * 设置 [流程处理标识]
     */
    public void setPSWFProcessId(String  pSWFProcessId){
        this.pSWFProcessId = pSWFProcessId ;
        this.pSWFProcessIdDirtyFlag = true ;
    }

    /**
     * 获取 [流程处理标识]脏标记
     */
    @JsonIgnore
    public boolean getPSWFProcessIdDirtyFlag(){
        return this.pSWFProcessIdDirtyFlag ;
    }
    /**
     * 获取 [工作流实例标识]
     */
    public String getWFInstanceId(){
        return this.wFInstanceId ;
    }

    /**
     * 设置 [工作流实例标识]
     */
    public void setWFInstanceId(String  wFInstanceId){
        this.wFInstanceId = wFInstanceId ;
        this.wFInstanceIdDirtyFlag = true ;
    }

    /**
     * 获取 [工作流实例标识]脏标记
     */
    @JsonIgnore
    public boolean getWFInstanceIdDirtyFlag(){
        return this.wFInstanceIdDirtyFlag ;
    }
    /**
     * 获取 [业务流程版本标识]
     */
    public String getPSWFVersionId(){
        return this.pSWFVersionId ;
    }

    /**
     * 设置 [业务流程版本标识]
     */
    public void setPSWFVersionId(String  pSWFVersionId){
        this.pSWFVersionId = pSWFVersionId ;
        this.pSWFVersionIdDirtyFlag = true ;
    }

    /**
     * 获取 [业务流程版本标识]脏标记
     */
    @JsonIgnore
    public boolean getPSWFVersionIdDirtyFlag(){
        return this.pSWFVersionIdDirtyFlag ;
    }
}