package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po;

import cn.ibizlab.r7.runtime.wf.core.repository.po.WFStepData;
import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonIgnore;
import java.io.Serializable;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import cn.ibizlab.r7.runtime.wf.util.annotation.PreField;
import cn.ibizlab.r7.runtime.wf.util.enums.FillMode;
import cn.ibizlab.r7.runtime.wf.util.enums.PredefinedType;

/**
 * 关系型数据实体表[WFStepData] 对象
 */
@TableName(value = "T_WFSTEPDATA",resultMap = "T_WFSTEPDATAResultMap")
public class T_WFSTEPDATAImpl implements WFStepData,Serializable {

    /**
     * [流程步骤信息标识]
     */
    @TableId(value= "wfstepdataid",type=IdType.UUID)
    private String wFStepDataId;
    /**
     * [流程步骤信息标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFStepDataIdDirtyFlag;

    /**
     * [操作人]
     */
    private String actionPerson;
    /**
     * [操作人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean actionPersonDirtyFlag;

    /**
     * [操作信息]
     */
    private String actionInfo;
    /**
     * [操作信息]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean actionInfoDirtyFlag;

    /**
     * [主实例标识]
     */
    private String majorInstId;
    /**
     * [主实例标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean majorInstIdDirtyFlag;

    /**
     * [操作时间]
     */
    private Timestamp actionTime;
    /**
     * [操作时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean actionTimeDirtyFlag;

    /**
     * [建立人]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    private String createMan;
    /**
     * [建立人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createManDirtyFlag;

    /**
     * [更新时间]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updateDate;
    /**
     * [更新时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateDateDirtyFlag;

    /**
     * [操作]
     */
    private String action;
    /**
     * [操作]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean actionDirtyFlag;

    /**
     * [建立时间]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createDate;
    /**
     * [建立时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createDateDirtyFlag;

    /**
     * [父实例标识]
     */
    private String parentInstId;
    /**
     * [父实例标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean parentInstIdDirtyFlag;

    /**
     * [更新人]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    private String updateMan;
    /**
     * [更新人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateManDirtyFlag;

    /**
     * [流程步骤信息名称]
     */
    private String wFStepDataName;
    /**
     * [流程步骤信息名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFStepDataNameDirtyFlag;

    @TableField(exist = false)
    private String wFStepName;
    /**
     * [工作流步骤名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFStepNameDirtyFlag;

    /**
     * [工作流步骤标识]
     */
    private String wFStepId;
    /**
     * [工作流步骤标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFStepIdDirtyFlag;

    /**
     * [工作流实例标识]
     */
    private String wFInstanceId;
    /**
     * [工作流实例标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFInstanceIdDirtyFlag;

    /**
     * [工作流步骤操作标识]
     */
    private String wFIAActionId;
    /**
     * [工作流步骤操作标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFIAActionIdDirtyFlag;

    /**
     * 获取 [流程步骤信息标识]
     */
    public String getWFStepDataId(){
        return this.wFStepDataId ;
    }

    /**
     * 设置 [流程步骤信息标识]
     */
    public void setWFStepDataId(String  wFStepDataId){
        this.wFStepDataId = wFStepDataId ;
        this.wFStepDataIdDirtyFlag = true ;
    }

    /**
     * 获取 [流程步骤信息标识]脏标记
     */
    @JsonIgnore
    public boolean getWFStepDataIdDirtyFlag(){
        return this.wFStepDataIdDirtyFlag ;
    }
    /**
     * 获取 [操作人]
     */
    public String getActionPerson(){
        return this.actionPerson ;
    }

    /**
     * 设置 [操作人]
     */
    public void setActionPerson(String  actionPerson){
        this.actionPerson = actionPerson ;
        this.actionPersonDirtyFlag = true ;
    }

    /**
     * 获取 [操作人]脏标记
     */
    @JsonIgnore
    public boolean getActionPersonDirtyFlag(){
        return this.actionPersonDirtyFlag ;
    }
    /**
     * 获取 [操作信息]
     */
    public String getActionInfo(){
        return this.actionInfo ;
    }

    /**
     * 设置 [操作信息]
     */
    public void setActionInfo(String  actionInfo){
        this.actionInfo = actionInfo ;
        this.actionInfoDirtyFlag = true ;
    }

    /**
     * 获取 [操作信息]脏标记
     */
    @JsonIgnore
    public boolean getActionInfoDirtyFlag(){
        return this.actionInfoDirtyFlag ;
    }
    /**
     * 获取 [主实例标识]
     */
    public String getMajorInstId(){
        return this.majorInstId ;
    }

    /**
     * 设置 [主实例标识]
     */
    public void setMajorInstId(String  majorInstId){
        this.majorInstId = majorInstId ;
        this.majorInstIdDirtyFlag = true ;
    }

    /**
     * 获取 [主实例标识]脏标记
     */
    @JsonIgnore
    public boolean getMajorInstIdDirtyFlag(){
        return this.majorInstIdDirtyFlag ;
    }
    /**
     * 获取 [操作时间]
     */
    public Timestamp getActionTime(){
        return this.actionTime ;
    }

    /**
     * 设置 [操作时间]
     */
    public void setActionTime(Timestamp  actionTime){
        this.actionTime = actionTime ;
        this.actionTimeDirtyFlag = true ;
    }

    /**
     * 获取 [操作时间]脏标记
     */
    @JsonIgnore
    public boolean getActionTimeDirtyFlag(){
        return this.actionTimeDirtyFlag ;
    }
    /**
     * 获取 [建立人]
     */
    public String getCreateMan(){
        return this.createMan ;
    }

    /**
     * 设置 [建立人]
     */
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [建立人]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return this.createManDirtyFlag ;
    }
    /**
     * 获取 [更新时间]
     */
    public Timestamp getUpdateDate(){
        return this.updateDate ;
    }

    /**
     * 设置 [更新时间]
     */
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [更新时间]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return this.updateDateDirtyFlag ;
    }
    /**
     * 获取 [操作]
     */
    public String getAction(){
        return this.action ;
    }

    /**
     * 设置 [操作]
     */
    public void setAction(String  action){
        this.action = action ;
        this.actionDirtyFlag = true ;
    }

    /**
     * 获取 [操作]脏标记
     */
    @JsonIgnore
    public boolean getActionDirtyFlag(){
        return this.actionDirtyFlag ;
    }
    /**
     * 获取 [建立时间]
     */
    public Timestamp getCreateDate(){
        return this.createDate ;
    }

    /**
     * 设置 [建立时间]
     */
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [建立时间]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return this.createDateDirtyFlag ;
    }
    /**
     * 获取 [父实例标识]
     */
    public String getParentInstId(){
        return this.parentInstId ;
    }

    /**
     * 设置 [父实例标识]
     */
    public void setParentInstId(String  parentInstId){
        this.parentInstId = parentInstId ;
        this.parentInstIdDirtyFlag = true ;
    }

    /**
     * 获取 [父实例标识]脏标记
     */
    @JsonIgnore
    public boolean getParentInstIdDirtyFlag(){
        return this.parentInstIdDirtyFlag ;
    }
    /**
     * 获取 [更新人]
     */
    public String getUpdateMan(){
        return this.updateMan ;
    }

    /**
     * 设置 [更新人]
     */
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [更新人]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return this.updateManDirtyFlag ;
    }
    /**
     * 获取 [流程步骤信息名称]
     */
    public String getWFStepDataName(){
        return this.wFStepDataName ;
    }

    /**
     * 设置 [流程步骤信息名称]
     */
    public void setWFStepDataName(String  wFStepDataName){
        this.wFStepDataName = wFStepDataName ;
        this.wFStepDataNameDirtyFlag = true ;
    }

    /**
     * 获取 [流程步骤信息名称]脏标记
     */
    @JsonIgnore
    public boolean getWFStepDataNameDirtyFlag(){
        return this.wFStepDataNameDirtyFlag ;
    }
    /**
     * 获取 [工作流步骤名称]
     */
    public String getWFStepName(){
        return this.wFStepName ;   
    }

    /**
     * 设置 [工作流步骤名称]
     */
    public void setWFStepName(String  wFStepName){
        this.wFStepName = wFStepName ;
        this.wFStepNameDirtyFlag = true ;
    }

    /**
     * 获取 [工作流步骤名称]脏标记
     */
    @JsonIgnore
    public boolean getWFStepNameDirtyFlag(){
        return this.wFStepNameDirtyFlag ;
    }
    /**
     * 获取 [工作流步骤标识]
     */
    public String getWFStepId(){
        return this.wFStepId ;
    }

    /**
     * 设置 [工作流步骤标识]
     */
    public void setWFStepId(String  wFStepId){
        this.wFStepId = wFStepId ;
        this.wFStepIdDirtyFlag = true ;
    }

    /**
     * 获取 [工作流步骤标识]脏标记
     */
    @JsonIgnore
    public boolean getWFStepIdDirtyFlag(){
        return this.wFStepIdDirtyFlag ;
    }
    /**
     * 获取 [工作流实例标识]
     */
    public String getWFInstanceId(){
        return this.wFInstanceId ;
    }

    /**
     * 设置 [工作流实例标识]
     */
    public void setWFInstanceId(String  wFInstanceId){
        this.wFInstanceId = wFInstanceId ;
        this.wFInstanceIdDirtyFlag = true ;
    }

    /**
     * 获取 [工作流实例标识]脏标记
     */
    @JsonIgnore
    public boolean getWFInstanceIdDirtyFlag(){
        return this.wFInstanceIdDirtyFlag ;
    }
    /**
     * 获取 [工作流步骤操作标识]
     */
    public String getWFIAActionId(){
        return this.wFIAActionId ;
    }

    /**
     * 设置 [工作流步骤操作标识]
     */
    public void setWFIAActionId(String  wFIAActionId){
        this.wFIAActionId = wFIAActionId ;
        this.wFIAActionIdDirtyFlag = true ;
    }

    /**
     * 获取 [工作流步骤操作标识]脏标记
     */
    @JsonIgnore
    public boolean getWFIAActionIdDirtyFlag(){
        return this.wFIAActionIdDirtyFlag ;
    }
}