package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po;

import cn.ibizlab.r7.runtime.wf.core.repository.po.WFStep;
import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonIgnore;
import java.io.Serializable;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import cn.ibizlab.r7.runtime.wf.util.annotation.PreField;
import cn.ibizlab.r7.runtime.wf.util.enums.FillMode;
import cn.ibizlab.r7.runtime.wf.util.enums.PredefinedType;

/**
 * 关系型数据实体表[WFStep] 对象
 */
@TableName(value = "T_WFSTEP",resultMap = "T_WFSTEPResultMap")
public class T_WFSTEPImpl implements WFStep,Serializable {

    /**
     * [是否完成]
     */
    private Integer isFinish;
    /**
     * [是否完成]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean isFinishDirtyFlag;

    /**
     * [开始时间]
     */
    private Timestamp startTime;
    /**
     * [开始时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean startTimeDirtyFlag;

    /**
     * [逻辑名称]
     */
    private String logicName;
    /**
     * [逻辑名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean logicNameDirtyFlag;

    /**
     * [更新时间]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updateDate;
    /**
     * [更新时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateDateDirtyFlag;

    /**
     * [更新人]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    private String updateMan;
    /**
     * [更新人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateManDirtyFlag;

    /**
     * [结束时间]
     */
    private Timestamp endTime;
    /**
     * [结束时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean endTimeDirtyFlag;

    /**
     * [建立人]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    private String createMan;
    /**
     * [建立人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createManDirtyFlag;

    /**
     * [父实例标识]
     */
    private String parentInstId;
    /**
     * [父实例标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean parentInstIdDirtyFlag;

    /**
     * [工作流步骤名称]
     */
    private String wFStepName;
    /**
     * [工作流步骤名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFStepNameDirtyFlag;

    /**
     * [工作流步骤标识]
     */
    @TableId(value= "wfstepid",type=IdType.UUID)
    private String wFStepId;
    /**
     * [工作流步骤标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFStepIdDirtyFlag;

    /**
     * [主实例标识]
     */
    private String majorInstId;
    /**
     * [主实例标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean majorInstIdDirtyFlag;

    /**
     * [步骤次序]
     */
    private Integer traceStep;
    /**
     * [步骤次序]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean traceStepDirtyFlag;

    /**
     * [建立时间]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createDate;
    /**
     * [建立时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createDateDirtyFlag;

    /**
     * [流程处理标识]
     */
    private String pSWFProcessId;
    /**
     * [流程处理标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSWFProcessIdDirtyFlag;

    /**
     * [业务流程版本标识]
     */
    private String pSWFVersionId;
    /**
     * [业务流程版本标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSWFVersionIdDirtyFlag;

    /**
     * [工作流实例标识]
     */
    private String wFInstanceId;
    /**
     * [工作流实例标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFInstanceIdDirtyFlag;

    /**
     * 获取 [是否完成]
     */
    public Integer getIsFinish(){
        return this.isFinish ;
    }

    /**
     * 设置 [是否完成]
     */
    public void setIsFinish(Integer  isFinish){
        this.isFinish = isFinish ;
        this.isFinishDirtyFlag = true ;
    }

    /**
     * 获取 [是否完成]脏标记
     */
    @JsonIgnore
    public boolean getIsFinishDirtyFlag(){
        return this.isFinishDirtyFlag ;
    }
    /**
     * 获取 [开始时间]
     */
    public Timestamp getStartTime(){
        return this.startTime ;
    }

    /**
     * 设置 [开始时间]
     */
    public void setStartTime(Timestamp  startTime){
        this.startTime = startTime ;
        this.startTimeDirtyFlag = true ;
    }

    /**
     * 获取 [开始时间]脏标记
     */
    @JsonIgnore
    public boolean getStartTimeDirtyFlag(){
        return this.startTimeDirtyFlag ;
    }
    /**
     * 获取 [逻辑名称]
     */
    public String getLogicName(){
        return this.logicName ;
    }

    /**
     * 设置 [逻辑名称]
     */
    public void setLogicName(String  logicName){
        this.logicName = logicName ;
        this.logicNameDirtyFlag = true ;
    }

    /**
     * 获取 [逻辑名称]脏标记
     */
    @JsonIgnore
    public boolean getLogicNameDirtyFlag(){
        return this.logicNameDirtyFlag ;
    }
    /**
     * 获取 [更新时间]
     */
    public Timestamp getUpdateDate(){
        return this.updateDate ;
    }

    /**
     * 设置 [更新时间]
     */
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [更新时间]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return this.updateDateDirtyFlag ;
    }
    /**
     * 获取 [更新人]
     */
    public String getUpdateMan(){
        return this.updateMan ;
    }

    /**
     * 设置 [更新人]
     */
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [更新人]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return this.updateManDirtyFlag ;
    }
    /**
     * 获取 [结束时间]
     */
    public Timestamp getEndTime(){
        return this.endTime ;
    }

    /**
     * 设置 [结束时间]
     */
    public void setEndTime(Timestamp  endTime){
        this.endTime = endTime ;
        this.endTimeDirtyFlag = true ;
    }

    /**
     * 获取 [结束时间]脏标记
     */
    @JsonIgnore
    public boolean getEndTimeDirtyFlag(){
        return this.endTimeDirtyFlag ;
    }
    /**
     * 获取 [建立人]
     */
    public String getCreateMan(){
        return this.createMan ;
    }

    /**
     * 设置 [建立人]
     */
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [建立人]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return this.createManDirtyFlag ;
    }
    /**
     * 获取 [父实例标识]
     */
    public String getParentInstId(){
        return this.parentInstId ;
    }

    /**
     * 设置 [父实例标识]
     */
    public void setParentInstId(String  parentInstId){
        this.parentInstId = parentInstId ;
        this.parentInstIdDirtyFlag = true ;
    }

    /**
     * 获取 [父实例标识]脏标记
     */
    @JsonIgnore
    public boolean getParentInstIdDirtyFlag(){
        return this.parentInstIdDirtyFlag ;
    }
    /**
     * 获取 [工作流步骤名称]
     */
    public String getWFStepName(){
        return this.wFStepName ;
    }

    /**
     * 设置 [工作流步骤名称]
     */
    public void setWFStepName(String  wFStepName){
        this.wFStepName = wFStepName ;
        this.wFStepNameDirtyFlag = true ;
    }

    /**
     * 获取 [工作流步骤名称]脏标记
     */
    @JsonIgnore
    public boolean getWFStepNameDirtyFlag(){
        return this.wFStepNameDirtyFlag ;
    }
    /**
     * 获取 [工作流步骤标识]
     */
    public String getWFStepId(){
        return this.wFStepId ;
    }

    /**
     * 设置 [工作流步骤标识]
     */
    public void setWFStepId(String  wFStepId){
        this.wFStepId = wFStepId ;
        this.wFStepIdDirtyFlag = true ;
    }

    /**
     * 获取 [工作流步骤标识]脏标记
     */
    @JsonIgnore
    public boolean getWFStepIdDirtyFlag(){
        return this.wFStepIdDirtyFlag ;
    }
    /**
     * 获取 [主实例标识]
     */
    public String getMajorInstId(){
        return this.majorInstId ;
    }

    /**
     * 设置 [主实例标识]
     */
    public void setMajorInstId(String  majorInstId){
        this.majorInstId = majorInstId ;
        this.majorInstIdDirtyFlag = true ;
    }

    /**
     * 获取 [主实例标识]脏标记
     */
    @JsonIgnore
    public boolean getMajorInstIdDirtyFlag(){
        return this.majorInstIdDirtyFlag ;
    }
    /**
     * 获取 [步骤次序]
     */
    public Integer getTraceStep(){
        return this.traceStep ;
    }

    /**
     * 设置 [步骤次序]
     */
    public void setTraceStep(Integer  traceStep){
        this.traceStep = traceStep ;
        this.traceStepDirtyFlag = true ;
    }

    /**
     * 获取 [步骤次序]脏标记
     */
    @JsonIgnore
    public boolean getTraceStepDirtyFlag(){
        return this.traceStepDirtyFlag ;
    }
    /**
     * 获取 [建立时间]
     */
    public Timestamp getCreateDate(){
        return this.createDate ;
    }

    /**
     * 设置 [建立时间]
     */
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [建立时间]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return this.createDateDirtyFlag ;
    }
    /**
     * 获取 [流程处理标识]
     */
    public String getPSWFProcessId(){
        return this.pSWFProcessId ;
    }

    /**
     * 设置 [流程处理标识]
     */
    public void setPSWFProcessId(String  pSWFProcessId){
        this.pSWFProcessId = pSWFProcessId ;
        this.pSWFProcessIdDirtyFlag = true ;
    }

    /**
     * 获取 [流程处理标识]脏标记
     */
    @JsonIgnore
    public boolean getPSWFProcessIdDirtyFlag(){
        return this.pSWFProcessIdDirtyFlag ;
    }
    /**
     * 获取 [业务流程版本标识]
     */
    public String getPSWFVersionId(){
        return this.pSWFVersionId ;
    }

    /**
     * 设置 [业务流程版本标识]
     */
    public void setPSWFVersionId(String  pSWFVersionId){
        this.pSWFVersionId = pSWFVersionId ;
        this.pSWFVersionIdDirtyFlag = true ;
    }

    /**
     * 获取 [业务流程版本标识]脏标记
     */
    @JsonIgnore
    public boolean getPSWFVersionIdDirtyFlag(){
        return this.pSWFVersionIdDirtyFlag ;
    }
    /**
     * 获取 [工作流实例标识]
     */
    public String getWFInstanceId(){
        return this.wFInstanceId ;
    }

    /**
     * 设置 [工作流实例标识]
     */
    public void setWFInstanceId(String  wFInstanceId){
        this.wFInstanceId = wFInstanceId ;
        this.wFInstanceIdDirtyFlag = true ;
    }

    /**
     * 获取 [工作流实例标识]脏标记
     */
    @JsonIgnore
    public boolean getWFInstanceIdDirtyFlag(){
        return this.wFInstanceIdDirtyFlag ;
    }
}