package cn.ibizlab.r7.runtime.wf.mybatis.r7rt_wf.po;

import cn.ibizlab.r7.runtime.wf.core.repository.po.WFWorklist;
import com.baomidou.mybatisplus.annotation.*;
import com.fasterxml.jackson.annotation.JsonIgnore;
import java.io.Serializable;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import cn.ibizlab.r7.runtime.wf.util.annotation.PreField;
import cn.ibizlab.r7.runtime.wf.util.enums.FillMode;
import cn.ibizlab.r7.runtime.wf.util.enums.PredefinedType;

/**
 * 关系型数据实体表[WFWorklist] 对象
 */
@TableName(value = "T_WFWORKLIST",resultMap = "T_WFWORKLISTResultMap")
public class T_WFWORKLISTImpl implements WFWorklist,Serializable {

    /**
     * [发起人]
     */
    private String initiator;
    /**
     * [发起人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean initiatorDirtyFlag;

    /**
     * [待办时间]
     */
    private Timestamp workDate;
    /**
     * [待办时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean workDateDirtyFlag;

    /**
     * [是否关闭]
     */
    private Integer isclosed;
    /**
     * [是否关闭]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean isclosedDirtyFlag;

    /**
     * [更新时间]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updateDate;
    /**
     * [更新时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateDateDirtyFlag;

    /**
     * [工作流工作列表标识]
     */
    @TableId(value= "wfworklistid",type=IdType.UUID)
    private String wFWorklistId;
    /**
     * [工作流工作列表标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFWorklistIdDirtyFlag;

    /**
     * [代办状态]
     */
    private String worklistState;
    /**
     * [代办状态]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean worklistStateDirtyFlag;

    /**
     * [待办信息]
     */
    private String workInfo;
    /**
     * [待办信息]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean workInfoDirtyFlag;

    /**
     * [处理环节]
     */
    private String wFWorklistName;
    /**
     * [处理环节]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFWorklistNameDirtyFlag;

    /**
     * [是否已读]
     */
    private Integer isread;
    /**
     * [是否已读]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean isreadDirtyFlag;

    /**
     * [逻辑名称]
     */
    private String logicName;
    /**
     * [逻辑名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean logicNameDirtyFlag;

    /**
     * [处理说明]
     */
    private String memo;
    /**
     * [处理说明]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean memoDirtyFlag;

    /**
     * [视图地址]
     */
    private String viewUrl;
    /**
     * [视图地址]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean viewUrlDirtyFlag;

    /**
     * [建立时间]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createDate;
    /**
     * [建立时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createDateDirtyFlag;

    /**
     * [流程模块标识]
     */
    private String wFModuleId;
    /**
     * [流程模块标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFModuleIdDirtyFlag;

    /**
     * [处理时间]
     */
    private Timestamp finishDate;
    /**
     * [处理时间]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean finishDateDirtyFlag;

    /**
     * [已处理]
     */
    private Integer done;
    /**
     * [已处理]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean doneDirtyFlag;

    /**
     * [更新人]
     */
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    private String updateMan;
    /**
     * [更新人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean updateManDirtyFlag;

    /**
     * [紧急程度]
     */
    private String urgency;
    /**
     * [紧急程度]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean urgencyDirtyFlag;

    /**
     * [建立人]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    private String createMan;
    /**
     * [建立人]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean createManDirtyFlag;

    /**
     * [当前步骤]
     */
    private String wFStep;
    /**
     * [当前步骤]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFStepDirtyFlag;

    /**
     * [流程数据标识]
     */
    private String wFDataId;
    /**
     * [流程数据标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFDataIdDirtyFlag;

    /**
     * [引擎工作列表标识]
     */
    private String wfengineworklistid;
    /**
     * [引擎工作列表标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wfengineworklistidDirtyFlag;

    /**
     * [部门名称]
     */
    private String orgDeptName;
    /**
     * [部门名称]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean orgDeptNameDirtyFlag;

    /**
     * [工作流用户标识]
     */
    private String wFUserId;
    /**
     * [工作流用户标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFUserIdDirtyFlag;

    /**
     * [平台流程角色标识]
     */
    private String pSWFRoleId;
    /**
     * [平台流程角色标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean pSWFRoleIdDirtyFlag;

    /**
     * [部门标识]
     */
    private String orgDeptId;
    /**
     * [部门标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean orgDeptIdDirtyFlag;

    /**
     * [部门用户标识]
     */
    private String orgDeptUserId;
    /**
     * [部门用户标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean orgDeptUserIdDirtyFlag;

    /**
     * [工作流实例标识]
     */
    private String wFInstanceId;
    /**
     * [工作流实例标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean wFInstanceIdDirtyFlag;

    /**
     * [组织标识]
     */
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.ORGID)
    private String orgId;
    /**
     * [组织标识]脏标记
     */
    @JsonIgnore
    @TableField(exist = false)
    private boolean orgIdDirtyFlag;

    /**
     * 获取 [发起人]
     */
    public String getInitiator(){
        return this.initiator ;
    }

    /**
     * 设置 [发起人]
     */
    public void setInitiator(String  initiator){
        this.initiator = initiator ;
        this.initiatorDirtyFlag = true ;
    }

    /**
     * 获取 [发起人]脏标记
     */
    @JsonIgnore
    public boolean getInitiatorDirtyFlag(){
        return this.initiatorDirtyFlag ;
    }
    /**
     * 获取 [待办时间]
     */
    public Timestamp getWorkDate(){
        return this.workDate ;
    }

    /**
     * 设置 [待办时间]
     */
    public void setWorkDate(Timestamp  workDate){
        this.workDate = workDate ;
        this.workDateDirtyFlag = true ;
    }

    /**
     * 获取 [待办时间]脏标记
     */
    @JsonIgnore
    public boolean getWorkDateDirtyFlag(){
        return this.workDateDirtyFlag ;
    }
    /**
     * 获取 [是否关闭]
     */
    public Integer getIsclosed(){
        return this.isclosed ;
    }

    /**
     * 设置 [是否关闭]
     */
    public void setIsclosed(Integer  isclosed){
        this.isclosed = isclosed ;
        this.isclosedDirtyFlag = true ;
    }

    /**
     * 获取 [是否关闭]脏标记
     */
    @JsonIgnore
    public boolean getIsclosedDirtyFlag(){
        return this.isclosedDirtyFlag ;
    }
    /**
     * 获取 [更新时间]
     */
    public Timestamp getUpdateDate(){
        return this.updateDate ;
    }

    /**
     * 设置 [更新时间]
     */
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [更新时间]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return this.updateDateDirtyFlag ;
    }
    /**
     * 获取 [工作流工作列表标识]
     */
    public String getWFWorklistId(){
        return this.wFWorklistId ;
    }

    /**
     * 设置 [工作流工作列表标识]
     */
    public void setWFWorklistId(String  wFWorklistId){
        this.wFWorklistId = wFWorklistId ;
        this.wFWorklistIdDirtyFlag = true ;
    }

    /**
     * 获取 [工作流工作列表标识]脏标记
     */
    @JsonIgnore
    public boolean getWFWorklistIdDirtyFlag(){
        return this.wFWorklistIdDirtyFlag ;
    }
    /**
     * 获取 [代办状态]
     */
    public String getWorklistState(){
        return this.worklistState ;
    }

    /**
     * 设置 [代办状态]
     */
    public void setWorklistState(String  worklistState){
        this.worklistState = worklistState ;
        this.worklistStateDirtyFlag = true ;
    }

    /**
     * 获取 [代办状态]脏标记
     */
    @JsonIgnore
    public boolean getWorklistStateDirtyFlag(){
        return this.worklistStateDirtyFlag ;
    }
    /**
     * 获取 [待办信息]
     */
    public String getWorkInfo(){
        return this.workInfo ;
    }

    /**
     * 设置 [待办信息]
     */
    public void setWorkInfo(String  workInfo){
        this.workInfo = workInfo ;
        this.workInfoDirtyFlag = true ;
    }

    /**
     * 获取 [待办信息]脏标记
     */
    @JsonIgnore
    public boolean getWorkInfoDirtyFlag(){
        return this.workInfoDirtyFlag ;
    }
    /**
     * 获取 [处理环节]
     */
    public String getWFWorklistName(){
        return this.wFWorklistName ;
    }

    /**
     * 设置 [处理环节]
     */
    public void setWFWorklistName(String  wFWorklistName){
        this.wFWorklistName = wFWorklistName ;
        this.wFWorklistNameDirtyFlag = true ;
    }

    /**
     * 获取 [处理环节]脏标记
     */
    @JsonIgnore
    public boolean getWFWorklistNameDirtyFlag(){
        return this.wFWorklistNameDirtyFlag ;
    }
    /**
     * 获取 [是否已读]
     */
    public Integer getIsread(){
        return this.isread ;
    }

    /**
     * 设置 [是否已读]
     */
    public void setIsread(Integer  isread){
        this.isread = isread ;
        this.isreadDirtyFlag = true ;
    }

    /**
     * 获取 [是否已读]脏标记
     */
    @JsonIgnore
    public boolean getIsreadDirtyFlag(){
        return this.isreadDirtyFlag ;
    }
    /**
     * 获取 [逻辑名称]
     */
    public String getLogicName(){
        return this.logicName ;
    }

    /**
     * 设置 [逻辑名称]
     */
    public void setLogicName(String  logicName){
        this.logicName = logicName ;
        this.logicNameDirtyFlag = true ;
    }

    /**
     * 获取 [逻辑名称]脏标记
     */
    @JsonIgnore
    public boolean getLogicNameDirtyFlag(){
        return this.logicNameDirtyFlag ;
    }
    /**
     * 获取 [处理说明]
     */
    public String getMemo(){
        return this.memo ;
    }

    /**
     * 设置 [处理说明]
     */
    public void setMemo(String  memo){
        this.memo = memo ;
        this.memoDirtyFlag = true ;
    }

    /**
     * 获取 [处理说明]脏标记
     */
    @JsonIgnore
    public boolean getMemoDirtyFlag(){
        return this.memoDirtyFlag ;
    }
    /**
     * 获取 [视图地址]
     */
    public String getViewUrl(){
        return this.viewUrl ;
    }

    /**
     * 设置 [视图地址]
     */
    public void setViewUrl(String  viewUrl){
        this.viewUrl = viewUrl ;
        this.viewUrlDirtyFlag = true ;
    }

    /**
     * 获取 [视图地址]脏标记
     */
    @JsonIgnore
    public boolean getViewUrlDirtyFlag(){
        return this.viewUrlDirtyFlag ;
    }
    /**
     * 获取 [建立时间]
     */
    public Timestamp getCreateDate(){
        return this.createDate ;
    }

    /**
     * 设置 [建立时间]
     */
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [建立时间]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return this.createDateDirtyFlag ;
    }
    /**
     * 获取 [流程模块标识]
     */
    public String getWFModuleId(){
        return this.wFModuleId ;
    }

    /**
     * 设置 [流程模块标识]
     */
    public void setWFModuleId(String  wFModuleId){
        this.wFModuleId = wFModuleId ;
        this.wFModuleIdDirtyFlag = true ;
    }

    /**
     * 获取 [流程模块标识]脏标记
     */
    @JsonIgnore
    public boolean getWFModuleIdDirtyFlag(){
        return this.wFModuleIdDirtyFlag ;
    }
    /**
     * 获取 [处理时间]
     */
    public Timestamp getFinishDate(){
        return this.finishDate ;
    }

    /**
     * 设置 [处理时间]
     */
    public void setFinishDate(Timestamp  finishDate){
        this.finishDate = finishDate ;
        this.finishDateDirtyFlag = true ;
    }

    /**
     * 获取 [处理时间]脏标记
     */
    @JsonIgnore
    public boolean getFinishDateDirtyFlag(){
        return this.finishDateDirtyFlag ;
    }
    /**
     * 获取 [已处理]
     */
    public Integer getDone(){
        return this.done ;
    }

    /**
     * 设置 [已处理]
     */
    public void setDone(Integer  done){
        this.done = done ;
        this.doneDirtyFlag = true ;
    }

    /**
     * 获取 [已处理]脏标记
     */
    @JsonIgnore
    public boolean getDoneDirtyFlag(){
        return this.doneDirtyFlag ;
    }
    /**
     * 获取 [更新人]
     */
    public String getUpdateMan(){
        return this.updateMan ;
    }

    /**
     * 设置 [更新人]
     */
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [更新人]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return this.updateManDirtyFlag ;
    }
    /**
     * 获取 [紧急程度]
     */
    public String getUrgency(){
        return this.urgency ;
    }

    /**
     * 设置 [紧急程度]
     */
    public void setUrgency(String  urgency){
        this.urgency = urgency ;
        this.urgencyDirtyFlag = true ;
    }

    /**
     * 获取 [紧急程度]脏标记
     */
    @JsonIgnore
    public boolean getUrgencyDirtyFlag(){
        return this.urgencyDirtyFlag ;
    }
    /**
     * 获取 [建立人]
     */
    public String getCreateMan(){
        return this.createMan ;
    }

    /**
     * 设置 [建立人]
     */
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [建立人]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return this.createManDirtyFlag ;
    }
    /**
     * 获取 [当前步骤]
     */
    public String getWFStep(){
        return this.wFStep ;
    }

    /**
     * 设置 [当前步骤]
     */
    public void setWFStep(String  wFStep){
        this.wFStep = wFStep ;
        this.wFStepDirtyFlag = true ;
    }

    /**
     * 获取 [当前步骤]脏标记
     */
    @JsonIgnore
    public boolean getWFStepDirtyFlag(){
        return this.wFStepDirtyFlag ;
    }
    /**
     * 获取 [流程数据标识]
     */
    public String getWFDataId(){
        return this.wFDataId ;
    }

    /**
     * 设置 [流程数据标识]
     */
    public void setWFDataId(String  wFDataId){
        this.wFDataId = wFDataId ;
        this.wFDataIdDirtyFlag = true ;
    }

    /**
     * 获取 [流程数据标识]脏标记
     */
    @JsonIgnore
    public boolean getWFDataIdDirtyFlag(){
        return this.wFDataIdDirtyFlag ;
    }
    /**
     * 获取 [引擎工作列表标识]
     */
    public String getWfengineworklistid(){
        return this.wfengineworklistid ;
    }

    /**
     * 设置 [引擎工作列表标识]
     */
    public void setWfengineworklistid(String  wfengineworklistid){
        this.wfengineworklistid = wfengineworklistid ;
        this.wfengineworklistidDirtyFlag = true ;
    }

    /**
     * 获取 [引擎工作列表标识]脏标记
     */
    @JsonIgnore
    public boolean getWfengineworklistidDirtyFlag(){
        return this.wfengineworklistidDirtyFlag ;
    }
    /**
     * 获取 [部门名称]
     */
    public String getOrgDeptName(){
        return this.orgDeptName ;
    }

    /**
     * 设置 [部门名称]
     */
    public void setOrgDeptName(String  orgDeptName){
        this.orgDeptName = orgDeptName ;
        this.orgDeptNameDirtyFlag = true ;
    }

    /**
     * 获取 [部门名称]脏标记
     */
    @JsonIgnore
    public boolean getOrgDeptNameDirtyFlag(){
        return this.orgDeptNameDirtyFlag ;
    }
    /**
     * 获取 [工作流用户标识]
     */
    public String getWFUserId(){
        return this.wFUserId ;
    }

    /**
     * 设置 [工作流用户标识]
     */
    public void setWFUserId(String  wFUserId){
        this.wFUserId = wFUserId ;
        this.wFUserIdDirtyFlag = true ;
    }

    /**
     * 获取 [工作流用户标识]脏标记
     */
    @JsonIgnore
    public boolean getWFUserIdDirtyFlag(){
        return this.wFUserIdDirtyFlag ;
    }
    /**
     * 获取 [平台流程角色标识]
     */
    public String getPSWFRoleId(){
        return this.pSWFRoleId ;
    }

    /**
     * 设置 [平台流程角色标识]
     */
    public void setPSWFRoleId(String  pSWFRoleId){
        this.pSWFRoleId = pSWFRoleId ;
        this.pSWFRoleIdDirtyFlag = true ;
    }

    /**
     * 获取 [平台流程角色标识]脏标记
     */
    @JsonIgnore
    public boolean getPSWFRoleIdDirtyFlag(){
        return this.pSWFRoleIdDirtyFlag ;
    }
    /**
     * 获取 [部门标识]
     */
    public String getOrgDeptId(){
        return this.orgDeptId ;
    }

    /**
     * 设置 [部门标识]
     */
    public void setOrgDeptId(String  orgDeptId){
        this.orgDeptId = orgDeptId ;
        this.orgDeptIdDirtyFlag = true ;
    }

    /**
     * 获取 [部门标识]脏标记
     */
    @JsonIgnore
    public boolean getOrgDeptIdDirtyFlag(){
        return this.orgDeptIdDirtyFlag ;
    }
    /**
     * 获取 [部门用户标识]
     */
    public String getOrgDeptUserId(){
        return this.orgDeptUserId ;
    }

    /**
     * 设置 [部门用户标识]
     */
    public void setOrgDeptUserId(String  orgDeptUserId){
        this.orgDeptUserId = orgDeptUserId ;
        this.orgDeptUserIdDirtyFlag = true ;
    }

    /**
     * 获取 [部门用户标识]脏标记
     */
    @JsonIgnore
    public boolean getOrgDeptUserIdDirtyFlag(){
        return this.orgDeptUserIdDirtyFlag ;
    }
    /**
     * 获取 [工作流实例标识]
     */
    public String getWFInstanceId(){
        return this.wFInstanceId ;
    }

    /**
     * 设置 [工作流实例标识]
     */
    public void setWFInstanceId(String  wFInstanceId){
        this.wFInstanceId = wFInstanceId ;
        this.wFInstanceIdDirtyFlag = true ;
    }

    /**
     * 获取 [工作流实例标识]脏标记
     */
    @JsonIgnore
    public boolean getWFInstanceIdDirtyFlag(){
        return this.wFInstanceIdDirtyFlag ;
    }
    /**
     * 获取 [组织标识]
     */
    public String getOrgId(){
        return this.orgId ;
    }

    /**
     * 设置 [组织标识]
     */
    public void setOrgId(String  orgId){
        this.orgId = orgId ;
        this.orgIdDirtyFlag = true ;
    }

    /**
     * 获取 [组织标识]脏标记
     */
    @JsonIgnore
    public boolean getOrgIdDirtyFlag(){
        return this.orgIdDirtyFlag ;
    }
}