package cn.ibizlab.r7.runtime.wf.service.uniwfinternalservice.dto;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.math.BigInteger;
import java.util.Map;
import java.util.HashMap;
import java.io.Serializable;
import java.math.BigDecimal;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.valuerule.anno.pssystem.*;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSSystem;
import org.springframework.cglib.beans.BeanCopier;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * 服务DTO对象[PSSystemDTO]
 */
public class PSSystemDTO implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 属性 [UPDATEDATE]
     *
     */
    @PSSystemUpdateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp updateDate;

    @JsonIgnore
    private boolean updateDateDirtyFlag;

    /**
     * 属性 [CREATEMAN]
     *
     */
    @PSSystemCreateManDefault(info = "默认规则")
    private String createMan;

    @JsonIgnore
    private boolean createManDirtyFlag;

    /**
     * 属性 [ROOTPATH]
     *
     */
    @PSSystemRootpathDefault(info = "默认规则")
    private String rootpath;

    @JsonIgnore
    private boolean rootpathDirtyFlag;

    /**
     * 属性 [PSSYSTEMID]
     *
     */
    @PSSystemPSSystemIdDefault(info = "默认规则")
    private String pSSystemId;

    @JsonIgnore
    private boolean pSSystemIdDirtyFlag;

    /**
     * 属性 [UPDATEMAN]
     *
     */
    @PSSystemUpdateManDefault(info = "默认规则")
    private String updateMan;

    @JsonIgnore
    private boolean updateManDirtyFlag;

    /**
     * 属性 [SERVICEURL]
     *
     */
    @PSSystemServiceUrlDefault(info = "默认规则")
    private String serviceUrl;

    @JsonIgnore
    private boolean serviceUrlDirtyFlag;

    /**
     * 属性 [SERVICEID]
     *
     */
    @PSSystemServiceIdDefault(info = "默认规则")
    private String serviceId;

    @JsonIgnore
    private boolean serviceIdDirtyFlag;

    /**
     * 属性 [CREATEDATE]
     *
     */
    @PSSystemCreateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp createDate;

    @JsonIgnore
    private boolean createDateDirtyFlag;

    /**
     * 属性 [LOGICNAME]
     *
     */
    @PSSystemLogicNameDefault(info = "默认规则")
    private String logicName;

    @JsonIgnore
    private boolean logicNameDirtyFlag;

    /**
     * 属性 [PSSYSTEMNAME]
     *
     */
    @PSSystemPSSystemNameDefault(info = "默认规则")
    private String pSSystemName;

    @JsonIgnore
    private boolean pSSystemNameDirtyFlag;

    /**
     * 属性 [WORKFLOWNAME]
     *
     */
    @PSSystemWorkflowNameDefault(info = "默认规则")
    private String workflowName;

    @JsonIgnore
    private boolean workflowNameDirtyFlag;

    /**
     * 属性 [ORGDEPTID]
     *
     */
    @PSSystemOrgDeptIdDefault(info = "默认规则")
    private String orgDeptId;

    @JsonIgnore
    private boolean orgDeptIdDirtyFlag;

    /**
     * 属性 [WORKFLOWID]
     *
     */
    @PSSystemWorkflowIdDefault(info = "默认规则")
    private String workflowId;

    @JsonIgnore
    private boolean workflowIdDirtyFlag;

    /**
     * 属性 [ORGID]
     *
     */
    @PSSystemOrgIdDefault(info = "默认规则")
    private String orgId;

    @JsonIgnore
    private boolean orgIdDirtyFlag;


    /**
     * 获取 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public Timestamp getUpdateDate(){
        return updateDate ;
    }

    /**
     * 设置 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return updateDateDirtyFlag ;
    }

    /**
     * 获取 [CREATEMAN]
     */
    @JsonProperty("createman")
    public String getCreateMan(){
        return createMan ;
    }

    /**
     * 设置 [CREATEMAN]
     */
    @JsonProperty("createman")
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return createManDirtyFlag ;
    }

    /**
     * 获取 [ROOTPATH]
     */
    @JsonProperty("rootpath")
    public String getRootpath(){
        return rootpath ;
    }

    /**
     * 设置 [ROOTPATH]
     */
    @JsonProperty("rootpath")
    public void setRootpath(String  rootpath){
        this.rootpath = rootpath ;
        this.rootpathDirtyFlag = true ;
    }

    /**
     * 获取 [ROOTPATH]脏标记
     */
    @JsonIgnore
    public boolean getRootpathDirtyFlag(){
        return rootpathDirtyFlag ;
    }

    /**
     * 获取 [PSSYSTEMID]
     */
    @JsonProperty("pssystemid")
    public String getPSSystemId(){
        return pSSystemId ;
    }

    /**
     * 设置 [PSSYSTEMID]
     */
    @JsonProperty("pssystemid")
    public void setPSSystemId(String  pSSystemId){
        this.pSSystemId = pSSystemId ;
        this.pSSystemIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSSYSTEMID]脏标记
     */
    @JsonIgnore
    public boolean getPSSystemIdDirtyFlag(){
        return pSSystemIdDirtyFlag ;
    }

    /**
     * 获取 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public String getUpdateMan(){
        return updateMan ;
    }

    /**
     * 设置 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return updateManDirtyFlag ;
    }

    /**
     * 获取 [SERVICEURL]
     */
    @JsonProperty("serviceurl")
    public String getServiceUrl(){
        return serviceUrl ;
    }

    /**
     * 设置 [SERVICEURL]
     */
    @JsonProperty("serviceurl")
    public void setServiceUrl(String  serviceUrl){
        this.serviceUrl = serviceUrl ;
        this.serviceUrlDirtyFlag = true ;
    }

    /**
     * 获取 [SERVICEURL]脏标记
     */
    @JsonIgnore
    public boolean getServiceUrlDirtyFlag(){
        return serviceUrlDirtyFlag ;
    }

    /**
     * 获取 [SERVICEID]
     */
    @JsonProperty("serviceid")
    public String getServiceId(){
        return serviceId ;
    }

    /**
     * 设置 [SERVICEID]
     */
    @JsonProperty("serviceid")
    public void setServiceId(String  serviceId){
        this.serviceId = serviceId ;
        this.serviceIdDirtyFlag = true ;
    }

    /**
     * 获取 [SERVICEID]脏标记
     */
    @JsonIgnore
    public boolean getServiceIdDirtyFlag(){
        return serviceIdDirtyFlag ;
    }

    /**
     * 获取 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public Timestamp getCreateDate(){
        return createDate ;
    }

    /**
     * 设置 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return createDateDirtyFlag ;
    }

    /**
     * 获取 [LOGICNAME]
     */
    @JsonProperty("logicname")
    public String getLogicName(){
        return logicName ;
    }

    /**
     * 设置 [LOGICNAME]
     */
    @JsonProperty("logicname")
    public void setLogicName(String  logicName){
        this.logicName = logicName ;
        this.logicNameDirtyFlag = true ;
    }

    /**
     * 获取 [LOGICNAME]脏标记
     */
    @JsonIgnore
    public boolean getLogicNameDirtyFlag(){
        return logicNameDirtyFlag ;
    }

    /**
     * 获取 [PSSYSTEMNAME]
     */
    @JsonProperty("pssystemname")
    public String getPSSystemName(){
        return pSSystemName ;
    }

    /**
     * 设置 [PSSYSTEMNAME]
     */
    @JsonProperty("pssystemname")
    public void setPSSystemName(String  pSSystemName){
        this.pSSystemName = pSSystemName ;
        this.pSSystemNameDirtyFlag = true ;
    }

    /**
     * 获取 [PSSYSTEMNAME]脏标记
     */
    @JsonIgnore
    public boolean getPSSystemNameDirtyFlag(){
        return pSSystemNameDirtyFlag ;
    }

    /**
     * 获取 [WORKFLOWNAME]
     */
    @JsonProperty("workflowname")
    public String getWorkflowName(){
        return workflowName ;
    }

    /**
     * 设置 [WORKFLOWNAME]
     */
    @JsonProperty("workflowname")
    public void setWorkflowName(String  workflowName){
        this.workflowName = workflowName ;
        this.workflowNameDirtyFlag = true ;
    }

    /**
     * 获取 [WORKFLOWNAME]脏标记
     */
    @JsonIgnore
    public boolean getWorkflowNameDirtyFlag(){
        return workflowNameDirtyFlag ;
    }

    /**
     * 获取 [ORGDEPTID]
     */
    @JsonProperty("orgdeptid")
    public String getOrgDeptId(){
        return orgDeptId ;
    }

    /**
     * 设置 [ORGDEPTID]
     */
    @JsonProperty("orgdeptid")
    public void setOrgDeptId(String  orgDeptId){
        this.orgDeptId = orgDeptId ;
        this.orgDeptIdDirtyFlag = true ;
    }

    /**
     * 获取 [ORGDEPTID]脏标记
     */
    @JsonIgnore
    public boolean getOrgDeptIdDirtyFlag(){
        return orgDeptIdDirtyFlag ;
    }

    /**
     * 获取 [WORKFLOWID]
     */
    @JsonProperty("workflowid")
    public String getWorkflowId(){
        return workflowId ;
    }

    /**
     * 设置 [WORKFLOWID]
     */
    @JsonProperty("workflowid")
    public void setWorkflowId(String  workflowId){
        this.workflowId = workflowId ;
        this.workflowIdDirtyFlag = true ;
    }

    /**
     * 获取 [WORKFLOWID]脏标记
     */
    @JsonIgnore
    public boolean getWorkflowIdDirtyFlag(){
        return workflowIdDirtyFlag ;
    }

    /**
     * 获取 [ORGID]
     */
    @JsonProperty("orgid")
    public String getOrgId(){
        return orgId ;
    }

    /**
     * 设置 [ORGID]
     */
    @JsonProperty("orgid")
    public void setOrgId(String  orgId){
        this.orgId = orgId ;
        this.orgIdDirtyFlag = true ;
    }

    /**
     * 获取 [ORGID]脏标记
     */
    @JsonIgnore
    public boolean getOrgIdDirtyFlag(){
        return orgIdDirtyFlag ;
    }



    public PSSystem toDO() {
        PSSystem srfdomain = new PSSystem();
        if(getUpdateDateDirtyFlag())
            srfdomain.setUpdateDate(updateDate);
        if(getCreateManDirtyFlag())
            srfdomain.setCreateMan(createMan);
        if(getRootpathDirtyFlag())
            srfdomain.setRootpath(rootpath);
        if(getPSSystemIdDirtyFlag())
            srfdomain.setPSSystemId(pSSystemId);
        if(getUpdateManDirtyFlag())
            srfdomain.setUpdateMan(updateMan);
        if(getServiceUrlDirtyFlag())
            srfdomain.setServiceUrl(serviceUrl);
        if(getServiceIdDirtyFlag())
            srfdomain.setServiceId(serviceId);
        if(getCreateDateDirtyFlag())
            srfdomain.setCreateDate(createDate);
        if(getLogicNameDirtyFlag())
            srfdomain.setLogicName(logicName);
        if(getPSSystemNameDirtyFlag())
            srfdomain.setPSSystemName(pSSystemName);
        if(getWorkflowNameDirtyFlag())
            srfdomain.setWorkflowName(workflowName);
        if(getOrgDeptIdDirtyFlag())
            srfdomain.setOrgDeptId(orgDeptId);
        if(getWorkflowIdDirtyFlag())
            srfdomain.setWorkflowId(workflowId);
        if(getOrgIdDirtyFlag())
            srfdomain.setOrgId(orgId);

        return srfdomain;
    }

    public void fromDO(PSSystem srfdomain) {
        if(srfdomain == null )
          return ;
        if(srfdomain.getUpdateDateDirtyFlag())
            this.setUpdateDate(srfdomain.getUpdateDate());
        if(srfdomain.getCreateManDirtyFlag())
            this.setCreateMan(srfdomain.getCreateMan());
        if(srfdomain.getRootpathDirtyFlag())
            this.setRootpath(srfdomain.getRootpath());
        if(srfdomain.getPSSystemIdDirtyFlag())
            this.setPSSystemId(srfdomain.getPSSystemId());
        if(srfdomain.getUpdateManDirtyFlag())
            this.setUpdateMan(srfdomain.getUpdateMan());
        if(srfdomain.getServiceUrlDirtyFlag())
            this.setServiceUrl(srfdomain.getServiceUrl());
        if(srfdomain.getServiceIdDirtyFlag())
            this.setServiceId(srfdomain.getServiceId());
        if(srfdomain.getCreateDateDirtyFlag())
            this.setCreateDate(srfdomain.getCreateDate());
        if(srfdomain.getLogicNameDirtyFlag())
            this.setLogicName(srfdomain.getLogicName());
        if(srfdomain.getPSSystemNameDirtyFlag())
            this.setPSSystemName(srfdomain.getPSSystemName());
        if(srfdomain.getWorkflowNameDirtyFlag())
            this.setWorkflowName(srfdomain.getWorkflowName());
        if(srfdomain.getOrgDeptIdDirtyFlag())
            this.setOrgDeptId(srfdomain.getOrgDeptId());
        if(srfdomain.getWorkflowIdDirtyFlag())
            this.setWorkflowId(srfdomain.getWorkflowId());
        if(srfdomain.getOrgIdDirtyFlag())
            this.setOrgId(srfdomain.getOrgId());

    }

    public List<PSSystemDTO> fromDOPage(List<PSSystem> poPage)   {
        if(poPage == null)
            return null;
        List<PSSystemDTO> dtos=new ArrayList<PSSystemDTO>();
        for(PSSystem domain : poPage) {
            PSSystemDTO dto = new PSSystemDTO();
            dto.fromDO(domain);
            dtos.add(dto);
        }
        return dtos;
    }
}

