package cn.ibizlab.r7.runtime.wf.service.uniwfinternalservice.dto;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.math.BigInteger;
import java.util.Map;
import java.util.HashMap;
import java.io.Serializable;
import java.math.BigDecimal;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.valuerule.anno.pswfprocsubwf.*;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFPROCSUBWF;
import org.springframework.cglib.beans.BeanCopier;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * 服务DTO对象[PSWFPROCSUBWFDTO]
 */
public class PSWFPROCSUBWFDTO implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 属性 [PSWFPROCSUBWFNAME]
     *
     */
    @PSWFPROCSUBWFPSWFPROCSUBWFNameDefault(info = "默认规则")
    private String pSWFPROCSUBWFName;

    @JsonIgnore
    private boolean pSWFPROCSUBWFNameDirtyFlag;

    /**
     * 属性 [PSWFPROCSUBWFID]
     *
     */
    @PSWFPROCSUBWFPSWFPROCSUBWFIdDefault(info = "默认规则")
    private String pSWFPROCSUBWFId;

    @JsonIgnore
    private boolean pSWFPROCSUBWFIdDirtyFlag;

    /**
     * 属性 [UPDATEDATE]
     *
     */
    @PSWFPROCSUBWFUpdateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp updateDate;

    @JsonIgnore
    private boolean updateDateDirtyFlag;

    /**
     * 属性 [UPDATEMAN]
     *
     */
    @PSWFPROCSUBWFUpdateManDefault(info = "默认规则")
    private String updateMan;

    @JsonIgnore
    private boolean updateManDirtyFlag;

    /**
     * 属性 [CREATEDATE]
     *
     */
    @PSWFPROCSUBWFCreateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp createDate;

    @JsonIgnore
    private boolean createDateDirtyFlag;

    /**
     * 属性 [CREATEMAN]
     *
     */
    @PSWFPROCSUBWFCreateManDefault(info = "默认规则")
    private String createMan;

    @JsonIgnore
    private boolean createManDirtyFlag;

    /**
     * 属性 [SUBWFDEDATASET]
     *
     */
    @PSWFPROCSUBWFSubwfdedatasetDefault(info = "默认规则")
    private String subwfdedataset;

    @JsonIgnore
    private boolean subwfdedatasetDirtyFlag;

    /**
     * 属性 [PSWFVERSIONID]
     *
     */
    @PSWFPROCSUBWFPSWFVersionIdDefault(info = "默认规则")
    private String pSWFVersionId;

    @JsonIgnore
    private boolean pSWFVersionIdDirtyFlag;

    /**
     * 属性 [SUBWFDEID]
     *
     */
    @PSWFPROCSUBWFSubwfdeidDefault(info = "默认规则")
    private String subwfdeid;

    @JsonIgnore
    private boolean subwfdeidDirtyFlag;

    /**
     * 属性 [PSWFPROCESSID]
     *
     */
    @PSWFPROCSUBWFPSWFProcessIdDefault(info = "默认规则")
    private String pSWFProcessId;

    @JsonIgnore
    private boolean pSWFProcessIdDirtyFlag;

    /**
     * 属性 [PSWORKFLOWID]
     *
     */
    @PSWFPROCSUBWFPSWorkflowIdDefault(info = "默认规则")
    private String pSWorkflowId;

    @JsonIgnore
    private boolean pSWorkflowIdDirtyFlag;


    /**
     * 获取 [PSWFPROCSUBWFNAME]
     */
    @JsonProperty("pswfprocsubwfname")
    public String getPSWFPROCSUBWFName(){
        return pSWFPROCSUBWFName ;
    }

    /**
     * 设置 [PSWFPROCSUBWFNAME]
     */
    @JsonProperty("pswfprocsubwfname")
    public void setPSWFPROCSUBWFName(String  pSWFPROCSUBWFName){
        this.pSWFPROCSUBWFName = pSWFPROCSUBWFName ;
        this.pSWFPROCSUBWFNameDirtyFlag = true ;
    }

    /**
     * 获取 [PSWFPROCSUBWFNAME]脏标记
     */
    @JsonIgnore
    public boolean getPSWFPROCSUBWFNameDirtyFlag(){
        return pSWFPROCSUBWFNameDirtyFlag ;
    }

    /**
     * 获取 [PSWFPROCSUBWFID]
     */
    @JsonProperty("pswfprocsubwfid")
    public String getPSWFPROCSUBWFId(){
        return pSWFPROCSUBWFId ;
    }

    /**
     * 设置 [PSWFPROCSUBWFID]
     */
    @JsonProperty("pswfprocsubwfid")
    public void setPSWFPROCSUBWFId(String  pSWFPROCSUBWFId){
        this.pSWFPROCSUBWFId = pSWFPROCSUBWFId ;
        this.pSWFPROCSUBWFIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSWFPROCSUBWFID]脏标记
     */
    @JsonIgnore
    public boolean getPSWFPROCSUBWFIdDirtyFlag(){
        return pSWFPROCSUBWFIdDirtyFlag ;
    }

    /**
     * 获取 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public Timestamp getUpdateDate(){
        return updateDate ;
    }

    /**
     * 设置 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return updateDateDirtyFlag ;
    }

    /**
     * 获取 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public String getUpdateMan(){
        return updateMan ;
    }

    /**
     * 设置 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return updateManDirtyFlag ;
    }

    /**
     * 获取 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public Timestamp getCreateDate(){
        return createDate ;
    }

    /**
     * 设置 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return createDateDirtyFlag ;
    }

    /**
     * 获取 [CREATEMAN]
     */
    @JsonProperty("createman")
    public String getCreateMan(){
        return createMan ;
    }

    /**
     * 设置 [CREATEMAN]
     */
    @JsonProperty("createman")
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return createManDirtyFlag ;
    }

    /**
     * 获取 [SUBWFDEDATASET]
     */
    @JsonProperty("subwfdedataset")
    public String getSubwfdedataset(){
        return subwfdedataset ;
    }

    /**
     * 设置 [SUBWFDEDATASET]
     */
    @JsonProperty("subwfdedataset")
    public void setSubwfdedataset(String  subwfdedataset){
        this.subwfdedataset = subwfdedataset ;
        this.subwfdedatasetDirtyFlag = true ;
    }

    /**
     * 获取 [SUBWFDEDATASET]脏标记
     */
    @JsonIgnore
    public boolean getSubwfdedatasetDirtyFlag(){
        return subwfdedatasetDirtyFlag ;
    }

    /**
     * 获取 [PSWFVERSIONID]
     */
    @JsonProperty("pswfversionid")
    public String getPSWFVersionId(){
        return pSWFVersionId ;
    }

    /**
     * 设置 [PSWFVERSIONID]
     */
    @JsonProperty("pswfversionid")
    public void setPSWFVersionId(String  pSWFVersionId){
        this.pSWFVersionId = pSWFVersionId ;
        this.pSWFVersionIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSWFVERSIONID]脏标记
     */
    @JsonIgnore
    public boolean getPSWFVersionIdDirtyFlag(){
        return pSWFVersionIdDirtyFlag ;
    }

    /**
     * 获取 [SUBWFDEID]
     */
    @JsonProperty("subwfdeid")
    public String getSubwfdeid(){
        return subwfdeid ;
    }

    /**
     * 设置 [SUBWFDEID]
     */
    @JsonProperty("subwfdeid")
    public void setSubwfdeid(String  subwfdeid){
        this.subwfdeid = subwfdeid ;
        this.subwfdeidDirtyFlag = true ;
    }

    /**
     * 获取 [SUBWFDEID]脏标记
     */
    @JsonIgnore
    public boolean getSubwfdeidDirtyFlag(){
        return subwfdeidDirtyFlag ;
    }

    /**
     * 获取 [PSWFPROCESSID]
     */
    @JsonProperty("pswfprocessid")
    public String getPSWFProcessId(){
        return pSWFProcessId ;
    }

    /**
     * 设置 [PSWFPROCESSID]
     */
    @JsonProperty("pswfprocessid")
    public void setPSWFProcessId(String  pSWFProcessId){
        this.pSWFProcessId = pSWFProcessId ;
        this.pSWFProcessIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSWFPROCESSID]脏标记
     */
    @JsonIgnore
    public boolean getPSWFProcessIdDirtyFlag(){
        return pSWFProcessIdDirtyFlag ;
    }

    /**
     * 获取 [PSWORKFLOWID]
     */
    @JsonProperty("psworkflowid")
    public String getPSWorkflowId(){
        return pSWorkflowId ;
    }

    /**
     * 设置 [PSWORKFLOWID]
     */
    @JsonProperty("psworkflowid")
    public void setPSWorkflowId(String  pSWorkflowId){
        this.pSWorkflowId = pSWorkflowId ;
        this.pSWorkflowIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSWORKFLOWID]脏标记
     */
    @JsonIgnore
    public boolean getPSWorkflowIdDirtyFlag(){
        return pSWorkflowIdDirtyFlag ;
    }



    public PSWFPROCSUBWF toDO() {
        PSWFPROCSUBWF srfdomain = new PSWFPROCSUBWF();
        if(getPSWFPROCSUBWFNameDirtyFlag())
            srfdomain.setPSWFPROCSUBWFName(pSWFPROCSUBWFName);
        if(getPSWFPROCSUBWFIdDirtyFlag())
            srfdomain.setPSWFPROCSUBWFId(pSWFPROCSUBWFId);
        if(getUpdateDateDirtyFlag())
            srfdomain.setUpdateDate(updateDate);
        if(getUpdateManDirtyFlag())
            srfdomain.setUpdateMan(updateMan);
        if(getCreateDateDirtyFlag())
            srfdomain.setCreateDate(createDate);
        if(getCreateManDirtyFlag())
            srfdomain.setCreateMan(createMan);
        if(getSubwfdedatasetDirtyFlag())
            srfdomain.setSubwfdedataset(subwfdedataset);
        if(getPSWFVersionIdDirtyFlag())
            srfdomain.setPSWFVersionId(pSWFVersionId);
        if(getSubwfdeidDirtyFlag())
            srfdomain.setSubwfdeid(subwfdeid);
        if(getPSWFProcessIdDirtyFlag())
            srfdomain.setPSWFProcessId(pSWFProcessId);
        if(getPSWorkflowIdDirtyFlag())
            srfdomain.setPSWorkflowId(pSWorkflowId);

        return srfdomain;
    }

    public void fromDO(PSWFPROCSUBWF srfdomain) {
        if(srfdomain == null )
          return ;
        if(srfdomain.getPSWFPROCSUBWFNameDirtyFlag())
            this.setPSWFPROCSUBWFName(srfdomain.getPSWFPROCSUBWFName());
        if(srfdomain.getPSWFPROCSUBWFIdDirtyFlag())
            this.setPSWFPROCSUBWFId(srfdomain.getPSWFPROCSUBWFId());
        if(srfdomain.getUpdateDateDirtyFlag())
            this.setUpdateDate(srfdomain.getUpdateDate());
        if(srfdomain.getUpdateManDirtyFlag())
            this.setUpdateMan(srfdomain.getUpdateMan());
        if(srfdomain.getCreateDateDirtyFlag())
            this.setCreateDate(srfdomain.getCreateDate());
        if(srfdomain.getCreateManDirtyFlag())
            this.setCreateMan(srfdomain.getCreateMan());
        if(srfdomain.getSubwfdedatasetDirtyFlag())
            this.setSubwfdedataset(srfdomain.getSubwfdedataset());
        if(srfdomain.getPSWFVersionIdDirtyFlag())
            this.setPSWFVersionId(srfdomain.getPSWFVersionId());
        if(srfdomain.getSubwfdeidDirtyFlag())
            this.setSubwfdeid(srfdomain.getSubwfdeid());
        if(srfdomain.getPSWFProcessIdDirtyFlag())
            this.setPSWFProcessId(srfdomain.getPSWFProcessId());
        if(srfdomain.getPSWorkflowIdDirtyFlag())
            this.setPSWorkflowId(srfdomain.getPSWorkflowId());

    }

    public List<PSWFPROCSUBWFDTO> fromDOPage(List<PSWFPROCSUBWF> poPage)   {
        if(poPage == null)
            return null;
        List<PSWFPROCSUBWFDTO> dtos=new ArrayList<PSWFPROCSUBWFDTO>();
        for(PSWFPROCSUBWF domain : poPage) {
            PSWFPROCSUBWFDTO dto = new PSWFPROCSUBWFDTO();
            dto.fromDO(domain);
            dtos.add(dto);
        }
        return dtos;
    }
}

