package cn.ibizlab.r7.runtime.wf.service.uniwfinternalservice.dto;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.math.BigInteger;
import java.util.Map;
import java.util.HashMap;
import java.io.Serializable;
import java.math.BigDecimal;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.valuerule.anno.pswfversion.*;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFVersion;
import org.springframework.cglib.beans.BeanCopier;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * 服务DTO对象[PSWFVersionDTO]
 */
public class PSWFVersionDTO implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 属性 [CREATEDATE]
     *
     */
    @PSWFVersionCreateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp createDate;

    @JsonIgnore
    private boolean createDateDirtyFlag;

    /**
     * 属性 [VERSION]
     *
     */
    @PSWFVersionVersionDefault(info = "默认规则")
    private Integer version;

    @JsonIgnore
    private boolean versionDirtyFlag;

    /**
     * 属性 [PSWFVERSIONID]
     *
     */
    @PSWFVersionPSWFVersionIdDefault(info = "默认规则")
    private String pSWFVersionId;

    @JsonIgnore
    private boolean pSWFVersionIdDirtyFlag;

    /**
     * 属性 [FILENAME]
     *
     */
    @PSWFVersionFileNameDefault(info = "默认规则")
    private String fileName;

    @JsonIgnore
    private boolean fileNameDirtyFlag;

    /**
     * 属性 [UPDATEMAN]
     *
     */
    @PSWFVersionUpdateManDefault(info = "默认规则")
    private String updateMan;

    @JsonIgnore
    private boolean updateManDirtyFlag;

    /**
     * 属性 [LOGICNAME]
     *
     */
    @PSWFVersionLogicNameDefault(info = "默认规则")
    private String logicName;

    @JsonIgnore
    private boolean logicNameDirtyFlag;

    /**
     * 属性 [VIEWURL]
     *
     */
    @PSWFVersionViewurlDefault(info = "默认规则")
    private String viewurl;

    @JsonIgnore
    private boolean viewurlDirtyFlag;

    /**
     * 属性 [STARTAPI]
     *
     */
    @PSWFVersionStartApiDefault(info = "默认规则")
    private String startApi;

    @JsonIgnore
    private boolean startApiDirtyFlag;

    /**
     * 属性 [PSWFVERSIONNAME]
     *
     */
    @PSWFVersionPSWFVersionNameDefault(info = "默认规则")
    private String pSWFVersionName;

    @JsonIgnore
    private boolean pSWFVersionNameDirtyFlag;

    /**
     * 属性 [MODULEID]
     *
     */
    @PSWFVersionModuleIdDefault(info = "默认规则")
    private String moduleId;

    @JsonIgnore
    private boolean moduleIdDirtyFlag;

    /**
     * 属性 [FILECONTENT]
     *
     */
    @PSWFVersionFileContentDefault(info = "默认规则")
    private byte[] fileContent;

    @JsonIgnore
    private boolean fileContentDirtyFlag;

    /**
     * 属性 [UPDATEDATE]
     *
     */
    @PSWFVersionUpdateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp updateDate;

    @JsonIgnore
    private boolean updateDateDirtyFlag;

    /**
     * 属性 [STARTURL]
     *
     */
    @PSWFVersionStartUrlDefault(info = "默认规则")
    private String startUrl;

    @JsonIgnore
    private boolean startUrlDirtyFlag;

    /**
     * 属性 [WFENGINEDEPLOYID]
     *
     */
    @PSWFVersionWFEngineDeployIdDefault(info = "默认规则")
    private String wFEngineDeployId;

    @JsonIgnore
    private boolean wFEngineDeployIdDirtyFlag;

    /**
     * 属性 [CREATEMAN]
     *
     */
    @PSWFVersionCreateManDefault(info = "默认规则")
    private String createMan;

    @JsonIgnore
    private boolean createManDirtyFlag;

    /**
     * 属性 [ORGDEPTNAME]
     *
     */
    @PSWFVersionOrgDeptNameDefault(info = "默认规则")
    private String orgDeptName;

    @JsonIgnore
    private boolean orgDeptNameDirtyFlag;

    /**
     * 属性 [ORGNAME]
     *
     */
    @PSWFVersionOrgNameDefault(info = "默认规则")
    private String orgName;

    @JsonIgnore
    private boolean orgNameDirtyFlag;

    /**
     * 属性 [PSWORKFLOWNAME]
     *
     */
    @PSWFVersionPSWFWorkflowNameDefault(info = "默认规则")
    private String pSWFWorkflowName;

    @JsonIgnore
    private boolean pSWFWorkflowNameDirtyFlag;

    /**
     * 属性 [ORGID]
     *
     */
    @PSWFVersionOrgIdDefault(info = "默认规则")
    private String orgId;

    @JsonIgnore
    private boolean orgIdDirtyFlag;

    /**
     * 属性 [PSWORKFLOWID]
     *
     */
    @PSWFVersionPSWorkflowIdDefault(info = "默认规则")
    private String pSWorkflowId;

    @JsonIgnore
    private boolean pSWorkflowIdDirtyFlag;

    /**
     * 属性 [WFAPPID]
     *
     */
    @PSWFVersionWFAppIdDefault(info = "默认规则")
    private String wFAppId;

    @JsonIgnore
    private boolean wFAppIdDirtyFlag;

    /**
     * 属性 [WFMODEID]
     *
     */
    @PSWFVersionWFModeIdDefault(info = "默认规则")
    private String wFModeId;

    @JsonIgnore
    private boolean wFModeIdDirtyFlag;

    /**
     * 属性 [ORGDEPTID]
     *
     */
    @PSWFVersionOrgDeptIdDefault(info = "默认规则")
    private String orgDeptId;

    @JsonIgnore
    private boolean orgDeptIdDirtyFlag;


    /**
     * 获取 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public Timestamp getCreateDate(){
        return createDate ;
    }

    /**
     * 设置 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return createDateDirtyFlag ;
    }

    /**
     * 获取 [VERSION]
     */
    @JsonProperty("version")
    public Integer getVersion(){
        return version ;
    }

    /**
     * 设置 [VERSION]
     */
    @JsonProperty("version")
    public void setVersion(Integer  version){
        this.version = version ;
        this.versionDirtyFlag = true ;
    }

    /**
     * 获取 [VERSION]脏标记
     */
    @JsonIgnore
    public boolean getVersionDirtyFlag(){
        return versionDirtyFlag ;
    }

    /**
     * 获取 [PSWFVERSIONID]
     */
    @JsonProperty("pswfversionid")
    public String getPSWFVersionId(){
        return pSWFVersionId ;
    }

    /**
     * 设置 [PSWFVERSIONID]
     */
    @JsonProperty("pswfversionid")
    public void setPSWFVersionId(String  pSWFVersionId){
        this.pSWFVersionId = pSWFVersionId ;
        this.pSWFVersionIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSWFVERSIONID]脏标记
     */
    @JsonIgnore
    public boolean getPSWFVersionIdDirtyFlag(){
        return pSWFVersionIdDirtyFlag ;
    }

    /**
     * 获取 [FILENAME]
     */
    @JsonProperty("filename")
    public String getFileName(){
        return fileName ;
    }

    /**
     * 设置 [FILENAME]
     */
    @JsonProperty("filename")
    public void setFileName(String  fileName){
        this.fileName = fileName ;
        this.fileNameDirtyFlag = true ;
    }

    /**
     * 获取 [FILENAME]脏标记
     */
    @JsonIgnore
    public boolean getFileNameDirtyFlag(){
        return fileNameDirtyFlag ;
    }

    /**
     * 获取 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public String getUpdateMan(){
        return updateMan ;
    }

    /**
     * 设置 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return updateManDirtyFlag ;
    }

    /**
     * 获取 [LOGICNAME]
     */
    @JsonProperty("logicname")
    public String getLogicName(){
        return logicName ;
    }

    /**
     * 设置 [LOGICNAME]
     */
    @JsonProperty("logicname")
    public void setLogicName(String  logicName){
        this.logicName = logicName ;
        this.logicNameDirtyFlag = true ;
    }

    /**
     * 获取 [LOGICNAME]脏标记
     */
    @JsonIgnore
    public boolean getLogicNameDirtyFlag(){
        return logicNameDirtyFlag ;
    }

    /**
     * 获取 [VIEWURL]
     */
    @JsonProperty("viewurl")
    public String getViewurl(){
        return viewurl ;
    }

    /**
     * 设置 [VIEWURL]
     */
    @JsonProperty("viewurl")
    public void setViewurl(String  viewurl){
        this.viewurl = viewurl ;
        this.viewurlDirtyFlag = true ;
    }

    /**
     * 获取 [VIEWURL]脏标记
     */
    @JsonIgnore
    public boolean getViewurlDirtyFlag(){
        return viewurlDirtyFlag ;
    }

    /**
     * 获取 [STARTAPI]
     */
    @JsonProperty("startapi")
    public String getStartApi(){
        return startApi ;
    }

    /**
     * 设置 [STARTAPI]
     */
    @JsonProperty("startapi")
    public void setStartApi(String  startApi){
        this.startApi = startApi ;
        this.startApiDirtyFlag = true ;
    }

    /**
     * 获取 [STARTAPI]脏标记
     */
    @JsonIgnore
    public boolean getStartApiDirtyFlag(){
        return startApiDirtyFlag ;
    }

    /**
     * 获取 [PSWFVERSIONNAME]
     */
    @JsonProperty("pswfversionname")
    public String getPSWFVersionName(){
        return pSWFVersionName ;
    }

    /**
     * 设置 [PSWFVERSIONNAME]
     */
    @JsonProperty("pswfversionname")
    public void setPSWFVersionName(String  pSWFVersionName){
        this.pSWFVersionName = pSWFVersionName ;
        this.pSWFVersionNameDirtyFlag = true ;
    }

    /**
     * 获取 [PSWFVERSIONNAME]脏标记
     */
    @JsonIgnore
    public boolean getPSWFVersionNameDirtyFlag(){
        return pSWFVersionNameDirtyFlag ;
    }

    /**
     * 获取 [MODULEID]
     */
    @JsonProperty("moduleid")
    public String getModuleId(){
        return moduleId ;
    }

    /**
     * 设置 [MODULEID]
     */
    @JsonProperty("moduleid")
    public void setModuleId(String  moduleId){
        this.moduleId = moduleId ;
        this.moduleIdDirtyFlag = true ;
    }

    /**
     * 获取 [MODULEID]脏标记
     */
    @JsonIgnore
    public boolean getModuleIdDirtyFlag(){
        return moduleIdDirtyFlag ;
    }

    /**
     * 获取 [FILECONTENT]
     */
    @JsonProperty("filecontent")
    public byte[] getFileContent(){
        return fileContent ;
    }

    /**
     * 设置 [FILECONTENT]
     */
    @JsonProperty("filecontent")
    public void setFileContent(byte[]  fileContent){
        this.fileContent = fileContent ;
        this.fileContentDirtyFlag = true ;
    }

    /**
     * 获取 [FILECONTENT]脏标记
     */
    @JsonIgnore
    public boolean getFileContentDirtyFlag(){
        return fileContentDirtyFlag ;
    }

    /**
     * 获取 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public Timestamp getUpdateDate(){
        return updateDate ;
    }

    /**
     * 设置 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return updateDateDirtyFlag ;
    }

    /**
     * 获取 [STARTURL]
     */
    @JsonProperty("starturl")
    public String getStartUrl(){
        return startUrl ;
    }

    /**
     * 设置 [STARTURL]
     */
    @JsonProperty("starturl")
    public void setStartUrl(String  startUrl){
        this.startUrl = startUrl ;
        this.startUrlDirtyFlag = true ;
    }

    /**
     * 获取 [STARTURL]脏标记
     */
    @JsonIgnore
    public boolean getStartUrlDirtyFlag(){
        return startUrlDirtyFlag ;
    }

    /**
     * 获取 [WFENGINEDEPLOYID]
     */
    @JsonProperty("wfenginedeployid")
    public String getWFEngineDeployId(){
        return wFEngineDeployId ;
    }

    /**
     * 设置 [WFENGINEDEPLOYID]
     */
    @JsonProperty("wfenginedeployid")
    public void setWFEngineDeployId(String  wFEngineDeployId){
        this.wFEngineDeployId = wFEngineDeployId ;
        this.wFEngineDeployIdDirtyFlag = true ;
    }

    /**
     * 获取 [WFENGINEDEPLOYID]脏标记
     */
    @JsonIgnore
    public boolean getWFEngineDeployIdDirtyFlag(){
        return wFEngineDeployIdDirtyFlag ;
    }

    /**
     * 获取 [CREATEMAN]
     */
    @JsonProperty("createman")
    public String getCreateMan(){
        return createMan ;
    }

    /**
     * 设置 [CREATEMAN]
     */
    @JsonProperty("createman")
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return createManDirtyFlag ;
    }

    /**
     * 获取 [ORGDEPTNAME]
     */
    @JsonProperty("orgdeptname")
    public String getOrgDeptName(){
        return orgDeptName ;
    }

    /**
     * 设置 [ORGDEPTNAME]
     */
    @JsonProperty("orgdeptname")
    public void setOrgDeptName(String  orgDeptName){
        this.orgDeptName = orgDeptName ;
        this.orgDeptNameDirtyFlag = true ;
    }

    /**
     * 获取 [ORGDEPTNAME]脏标记
     */
    @JsonIgnore
    public boolean getOrgDeptNameDirtyFlag(){
        return orgDeptNameDirtyFlag ;
    }

    /**
     * 获取 [ORGNAME]
     */
    @JsonProperty("orgname")
    public String getOrgName(){
        return orgName ;
    }

    /**
     * 设置 [ORGNAME]
     */
    @JsonProperty("orgname")
    public void setOrgName(String  orgName){
        this.orgName = orgName ;
        this.orgNameDirtyFlag = true ;
    }

    /**
     * 获取 [ORGNAME]脏标记
     */
    @JsonIgnore
    public boolean getOrgNameDirtyFlag(){
        return orgNameDirtyFlag ;
    }

    /**
     * 获取 [PSWORKFLOWNAME]
     */
    @JsonProperty("pswfworkflowname")
    public String getPSWFWorkflowName(){
        return pSWFWorkflowName ;
    }

    /**
     * 设置 [PSWORKFLOWNAME]
     */
    @JsonProperty("pswfworkflowname")
    public void setPSWFWorkflowName(String  pSWFWorkflowName){
        this.pSWFWorkflowName = pSWFWorkflowName ;
        this.pSWFWorkflowNameDirtyFlag = true ;
    }

    /**
     * 获取 [PSWORKFLOWNAME]脏标记
     */
    @JsonIgnore
    public boolean getPSWFWorkflowNameDirtyFlag(){
        return pSWFWorkflowNameDirtyFlag ;
    }

    /**
     * 获取 [ORGID]
     */
    @JsonProperty("orgid")
    public String getOrgId(){
        return orgId ;
    }

    /**
     * 设置 [ORGID]
     */
    @JsonProperty("orgid")
    public void setOrgId(String  orgId){
        this.orgId = orgId ;
        this.orgIdDirtyFlag = true ;
    }

    /**
     * 获取 [ORGID]脏标记
     */
    @JsonIgnore
    public boolean getOrgIdDirtyFlag(){
        return orgIdDirtyFlag ;
    }

    /**
     * 获取 [PSWORKFLOWID]
     */
    @JsonProperty("psworkflowid")
    public String getPSWorkflowId(){
        return pSWorkflowId ;
    }

    /**
     * 设置 [PSWORKFLOWID]
     */
    @JsonProperty("psworkflowid")
    public void setPSWorkflowId(String  pSWorkflowId){
        this.pSWorkflowId = pSWorkflowId ;
        this.pSWorkflowIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSWORKFLOWID]脏标记
     */
    @JsonIgnore
    public boolean getPSWorkflowIdDirtyFlag(){
        return pSWorkflowIdDirtyFlag ;
    }

    /**
     * 获取 [WFAPPID]
     */
    @JsonProperty("wfappid")
    public String getWFAppId(){
        return wFAppId ;
    }

    /**
     * 设置 [WFAPPID]
     */
    @JsonProperty("wfappid")
    public void setWFAppId(String  wFAppId){
        this.wFAppId = wFAppId ;
        this.wFAppIdDirtyFlag = true ;
    }

    /**
     * 获取 [WFAPPID]脏标记
     */
    @JsonIgnore
    public boolean getWFAppIdDirtyFlag(){
        return wFAppIdDirtyFlag ;
    }

    /**
     * 获取 [WFMODEID]
     */
    @JsonProperty("wfmodeid")
    public String getWFModeId(){
        return wFModeId ;
    }

    /**
     * 设置 [WFMODEID]
     */
    @JsonProperty("wfmodeid")
    public void setWFModeId(String  wFModeId){
        this.wFModeId = wFModeId ;
        this.wFModeIdDirtyFlag = true ;
    }

    /**
     * 获取 [WFMODEID]脏标记
     */
    @JsonIgnore
    public boolean getWFModeIdDirtyFlag(){
        return wFModeIdDirtyFlag ;
    }

    /**
     * 获取 [ORGDEPTID]
     */
    @JsonProperty("orgdeptid")
    public String getOrgDeptId(){
        return orgDeptId ;
    }

    /**
     * 设置 [ORGDEPTID]
     */
    @JsonProperty("orgdeptid")
    public void setOrgDeptId(String  orgDeptId){
        this.orgDeptId = orgDeptId ;
        this.orgDeptIdDirtyFlag = true ;
    }

    /**
     * 获取 [ORGDEPTID]脏标记
     */
    @JsonIgnore
    public boolean getOrgDeptIdDirtyFlag(){
        return orgDeptIdDirtyFlag ;
    }



    public PSWFVersion toDO() {
        PSWFVersion srfdomain = new PSWFVersion();
        if(getCreateDateDirtyFlag())
            srfdomain.setCreateDate(createDate);
        if(getVersionDirtyFlag())
            srfdomain.setVersion(version);
        if(getPSWFVersionIdDirtyFlag())
            srfdomain.setPSWFVersionId(pSWFVersionId);
        if(getFileNameDirtyFlag())
            srfdomain.setFileName(fileName);
        if(getUpdateManDirtyFlag())
            srfdomain.setUpdateMan(updateMan);
        if(getLogicNameDirtyFlag())
            srfdomain.setLogicName(logicName);
        if(getViewurlDirtyFlag())
            srfdomain.setViewurl(viewurl);
        if(getStartApiDirtyFlag())
            srfdomain.setStartApi(startApi);
        if(getPSWFVersionNameDirtyFlag())
            srfdomain.setPSWFVersionName(pSWFVersionName);
        if(getModuleIdDirtyFlag())
            srfdomain.setModuleId(moduleId);
        if(getFileContentDirtyFlag())
            srfdomain.setFileContent(fileContent);
        if(getUpdateDateDirtyFlag())
            srfdomain.setUpdateDate(updateDate);
        if(getStartUrlDirtyFlag())
            srfdomain.setStartUrl(startUrl);
        if(getWFEngineDeployIdDirtyFlag())
            srfdomain.setWFEngineDeployId(wFEngineDeployId);
        if(getCreateManDirtyFlag())
            srfdomain.setCreateMan(createMan);
        if(getOrgDeptNameDirtyFlag())
            srfdomain.setOrgDeptName(orgDeptName);
        if(getOrgNameDirtyFlag())
            srfdomain.setOrgName(orgName);
        if(getPSWFWorkflowNameDirtyFlag())
            srfdomain.setPSWFWorkflowName(pSWFWorkflowName);
        if(getOrgIdDirtyFlag())
            srfdomain.setOrgId(orgId);
        if(getPSWorkflowIdDirtyFlag())
            srfdomain.setPSWorkflowId(pSWorkflowId);
        if(getWFAppIdDirtyFlag())
            srfdomain.setWFAppId(wFAppId);
        if(getWFModeIdDirtyFlag())
            srfdomain.setWFModeId(wFModeId);
        if(getOrgDeptIdDirtyFlag())
            srfdomain.setOrgDeptId(orgDeptId);

        return srfdomain;
    }

    public void fromDO(PSWFVersion srfdomain) {
        if(srfdomain == null )
          return ;
        if(srfdomain.getCreateDateDirtyFlag())
            this.setCreateDate(srfdomain.getCreateDate());
        if(srfdomain.getVersionDirtyFlag())
            this.setVersion(srfdomain.getVersion());
        if(srfdomain.getPSWFVersionIdDirtyFlag())
            this.setPSWFVersionId(srfdomain.getPSWFVersionId());
        if(srfdomain.getFileNameDirtyFlag())
            this.setFileName(srfdomain.getFileName());
        if(srfdomain.getUpdateManDirtyFlag())
            this.setUpdateMan(srfdomain.getUpdateMan());
        if(srfdomain.getLogicNameDirtyFlag())
            this.setLogicName(srfdomain.getLogicName());
        if(srfdomain.getViewurlDirtyFlag())
            this.setViewurl(srfdomain.getViewurl());
        if(srfdomain.getStartApiDirtyFlag())
            this.setStartApi(srfdomain.getStartApi());
        if(srfdomain.getPSWFVersionNameDirtyFlag())
            this.setPSWFVersionName(srfdomain.getPSWFVersionName());
        if(srfdomain.getModuleIdDirtyFlag())
            this.setModuleId(srfdomain.getModuleId());
        if(srfdomain.getFileContentDirtyFlag())
            this.setFileContent(srfdomain.getFileContent());
        if(srfdomain.getUpdateDateDirtyFlag())
            this.setUpdateDate(srfdomain.getUpdateDate());
        if(srfdomain.getStartUrlDirtyFlag())
            this.setStartUrl(srfdomain.getStartUrl());
        if(srfdomain.getWFEngineDeployIdDirtyFlag())
            this.setWFEngineDeployId(srfdomain.getWFEngineDeployId());
        if(srfdomain.getCreateManDirtyFlag())
            this.setCreateMan(srfdomain.getCreateMan());
        if(srfdomain.getOrgDeptNameDirtyFlag())
            this.setOrgDeptName(srfdomain.getOrgDeptName());
        if(srfdomain.getOrgNameDirtyFlag())
            this.setOrgName(srfdomain.getOrgName());
        if(srfdomain.getPSWFWorkflowNameDirtyFlag())
            this.setPSWFWorkflowName(srfdomain.getPSWFWorkflowName());
        if(srfdomain.getOrgIdDirtyFlag())
            this.setOrgId(srfdomain.getOrgId());
        if(srfdomain.getPSWorkflowIdDirtyFlag())
            this.setPSWorkflowId(srfdomain.getPSWorkflowId());
        if(srfdomain.getWFAppIdDirtyFlag())
            this.setWFAppId(srfdomain.getWFAppId());
        if(srfdomain.getWFModeIdDirtyFlag())
            this.setWFModeId(srfdomain.getWFModeId());
        if(srfdomain.getOrgDeptIdDirtyFlag())
            this.setOrgDeptId(srfdomain.getOrgDeptId());

    }

    public List<PSWFVersionDTO> fromDOPage(List<PSWFVersion> poPage)   {
        if(poPage == null)
            return null;
        List<PSWFVersionDTO> dtos=new ArrayList<PSWFVersionDTO>();
        for(PSWFVersion domain : poPage) {
            PSWFVersionDTO dto = new PSWFVersionDTO();
            dto.fromDO(domain);
            dtos.add(dto);
        }
        return dtos;
    }
}

