package cn.ibizlab.r7.runtime.wf.service.uniwfinternalservice.dto;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.math.BigInteger;
import java.util.Map;
import java.util.HashMap;
import java.io.Serializable;
import java.math.BigDecimal;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.valuerule.anno.wfinstance.*;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFInstance;
import org.springframework.cglib.beans.BeanCopier;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * 服务DTO对象[WFInstanceDTO]
 */
public class WFInstanceDTO implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 属性 [STARTTIME]
     *
     */
    @WFInstanceStartTimeDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp startTime;

    @JsonIgnore
    private boolean startTimeDirtyFlag;

    /**
     * 属性 [BSDATA]
     *
     */
    @WFInstanceBsdataDefault(info = "默认规则")
    private String bsdata;

    @JsonIgnore
    private boolean bsdataDirtyFlag;

    /**
     * 属性 [PARENTINSTID]
     *
     */
    @WFInstanceParentInstIdDefault(info = "默认规则")
    private String parentInstId;

    @JsonIgnore
    private boolean parentInstIdDirtyFlag;

    /**
     * 属性 [WFUSERID]
     *
     */
    @WFInstanceWFUserIdDefault(info = "默认规则")
    private String wFUserId;

    @JsonIgnore
    private boolean wFUserIdDirtyFlag;

    /**
     * 属性 [PROXYMODULEID]
     *
     */
    @WFInstanceProxyModuleIdDefault(info = "默认规则")
    private String proxyModuleId;

    @JsonIgnore
    private boolean proxyModuleIdDirtyFlag;

    /**
     * 属性 [ORIGINORGDEPTID]
     *
     */
    @WFInstanceOriginOrgDeptIdDefault(info = "默认规则")
    private String originOrgDeptId;

    @JsonIgnore
    private boolean originOrgDeptIdDirtyFlag;

    /**
     * 属性 [PREVSTEPVALUE]
     *
     */
    @WFInstancePrevStepValueDefault(info = "默认规则")
    private String prevStepValue;

    @JsonIgnore
    private boolean prevStepValueDirtyFlag;

    /**
     * 属性 [CURSTEPVALUE]
     *
     */
    @WFInstanceCurStepValueDefault(info = "默认规则")
    private String curStepValue;

    @JsonIgnore
    private boolean curStepValueDirtyFlag;

    /**
     * 属性 [ORIGINPERSONID]
     *
     */
    @WFInstanceOriginPersonIdDefault(info = "默认规则")
    private String originPersonId;

    @JsonIgnore
    private boolean originPersonIdDirtyFlag;

    /**
     * 属性 [INSTANCETYPE]
     *
     */
    @WFInstanceInstanceTypeDefault(info = "默认规则")
    private String instanceType;

    @JsonIgnore
    private boolean instanceTypeDirtyFlag;

    /**
     * 属性 [CREATEMAN]
     *
     */
    @WFInstanceCreateManDefault(info = "默认规则")
    private String createMan;

    @JsonIgnore
    private boolean createManDirtyFlag;

    /**
     * 属性 [ISCLOSED]
     *
     */
    @WFInstanceIsclosedDefault(info = "默认规则")
    private Integer isclosed;

    @JsonIgnore
    private boolean isclosedDirtyFlag;

    /**
     * 属性 [ORIGINORGNAME]
     *
     */
    @WFInstanceOriginOrgNameDefault(info = "默认规则")
    private String originOrgName;

    @JsonIgnore
    private boolean originOrgNameDirtyFlag;

    /**
     * 属性 [OWNER]
     *
     */
    @WFInstanceOwnerDefault(info = "默认规则")
    private String owner;

    @JsonIgnore
    private boolean ownerDirtyFlag;

    /**
     * 属性 [PARENTSTEP]
     *
     */
    @WFInstanceParentStepDefault(info = "默认规则")
    private String parentStep;

    @JsonIgnore
    private boolean parentStepDirtyFlag;

    /**
     * 属性 [WFINSTANCEID]
     *
     */
    @WFInstanceWFInstanceIdDefault(info = "默认规则")
    private String wFInstanceId;

    @JsonIgnore
    private boolean wFInstanceIdDirtyFlag;

    /**
     * 属性 [BSWFDATA]
     *
     */
    @WFInstanceBswfdataDefault(info = "默认规则")
    private String bswfdata;

    @JsonIgnore
    private boolean bswfdataDirtyFlag;

    /**
     * 属性 [WFINSTANCENAME]
     *
     */
    @WFInstanceWFInstanceNameDefault(info = "默认规则")
    private String wFInstanceName;

    @JsonIgnore
    private boolean wFInstanceNameDirtyFlag;

    /**
     * 属性 [ORIGINORGDEPTNAME]
     *
     */
    @WFInstanceOriginOrgDeptNameDefault(info = "默认规则")
    private String originOrgDeptName;

    @JsonIgnore
    private boolean originOrgDeptNameDirtyFlag;

    /**
     * 属性 [ENDTIME]
     *
     */
    @WFInstanceEndtimeDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp endtime;

    @JsonIgnore
    private boolean endtimeDirtyFlag;

    /**
     * 属性 [ORIGINORGID]
     *
     */
    @WFInstanceOriginOrgIdDefault(info = "默认规则")
    private String originOrgId;

    @JsonIgnore
    private boolean originOrgIdDirtyFlag;

    /**
     * 属性 [WFENGINEINSTANCEID]
     *
     */
    @WFInstanceWFEngineInstanceIdDefault(info = "默认规则")
    private String wFEngineInstanceId;

    @JsonIgnore
    private boolean wFEngineInstanceIdDirtyFlag;

    /**
     * 属性 [UPDATEMAN]
     *
     */
    @WFInstanceUpdateManDefault(info = "默认规则")
    private String updateMan;

    @JsonIgnore
    private boolean updateManDirtyFlag;

    /**
     * 属性 [PREVPROCESS]
     *
     */
    @WFInstancePrevProcessDefault(info = "默认规则")
    private String prevProcess;

    @JsonIgnore
    private boolean prevProcessDirtyFlag;

    /**
     * 属性 [CREATEDATE]
     *
     */
    @WFInstanceCreateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp createDate;

    @JsonIgnore
    private boolean createDateDirtyFlag;

    /**
     * 属性 [ORIGINPERSONNAME]
     *
     */
    @WFInstanceOriginPersonNameDefault(info = "默认规则")
    private String originPersonName;

    @JsonIgnore
    private boolean originPersonNameDirtyFlag;

    /**
     * 属性 [WFSTATE]
     *
     */
    @WFInstanceWFStateDefault(info = "默认规则")
    private String wFState;

    @JsonIgnore
    private boolean wFStateDirtyFlag;

    /**
     * 属性 [PREVSTEP]
     *
     */
    @WFInstancePrevstepDefault(info = "默认规则")
    private String prevstep;

    @JsonIgnore
    private boolean prevstepDirtyFlag;

    /**
     * 属性 [UPDATEDATE]
     *
     */
    @WFInstanceUpdateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp updateDate;

    @JsonIgnore
    private boolean updateDateDirtyFlag;

    /**
     * 属性 [CURPROCESS]
     *
     */
    @WFInstanceCurProcessDefault(info = "默认规则")
    private String curProcess;

    @JsonIgnore
    private boolean curProcessDirtyFlag;

    /**
     * 属性 [CURSTEP]
     *
     */
    @WFInstanceCurstepDefault(info = "默认规则")
    private String curstep;

    @JsonIgnore
    private boolean curstepDirtyFlag;

    /**
     * 属性 [LOGICNAME]
     *
     */
    @WFInstanceLogicNameDefault(info = "默认规则")
    private String logicName;

    @JsonIgnore
    private boolean logicNameDirtyFlag;

    /**
     * 属性 [MAJORINSTID]
     *
     */
    @WFInstanceMajorInstIdDefault(info = "默认规则")
    private String majorInstId;

    @JsonIgnore
    private boolean majorInstIdDirtyFlag;

    /**
     * 属性 [ORGDEPTID]
     *
     */
    @WFInstanceOrgDeptIdDefault(info = "默认规则")
    private String orgDeptId;

    @JsonIgnore
    private boolean orgDeptIdDirtyFlag;

    /**
     * 属性 [WFENGINEID]
     *
     */
    @WFInstanceWFEngineIdDefault(info = "默认规则")
    private String wFEngineId;

    @JsonIgnore
    private boolean wFEngineIdDirtyFlag;

    /**
     * 属性 [PSWORKFLOWID]
     *
     */
    @WFInstancePSWorkflowIdDefault(info = "默认规则")
    private String pSWorkflowId;

    @JsonIgnore
    private boolean pSWorkflowIdDirtyFlag;

    /**
     * 属性 [ORGID]
     *
     */
    @WFInstanceOrgIdDefault(info = "默认规则")
    private String orgId;

    @JsonIgnore
    private boolean orgIdDirtyFlag;

    /**
     * 属性 [PSWFVERSIONID]
     *
     */
    @WFInstancePSWFVersionIdDefault(info = "默认规则")
    private String pSWFVersionId;

    @JsonIgnore
    private boolean pSWFVersionIdDirtyFlag;


    /**
     * 获取 [STARTTIME]
     */
    @JsonProperty("starttime")
    public Timestamp getStartTime(){
        return startTime ;
    }

    /**
     * 设置 [STARTTIME]
     */
    @JsonProperty("starttime")
    public void setStartTime(Timestamp  startTime){
        this.startTime = startTime ;
        this.startTimeDirtyFlag = true ;
    }

    /**
     * 获取 [STARTTIME]脏标记
     */
    @JsonIgnore
    public boolean getStartTimeDirtyFlag(){
        return startTimeDirtyFlag ;
    }

    /**
     * 获取 [BSDATA]
     */
    @JsonProperty("bsdata")
    public String getBsdata(){
        return bsdata ;
    }

    /**
     * 设置 [BSDATA]
     */
    @JsonProperty("bsdata")
    public void setBsdata(String  bsdata){
        this.bsdata = bsdata ;
        this.bsdataDirtyFlag = true ;
    }

    /**
     * 获取 [BSDATA]脏标记
     */
    @JsonIgnore
    public boolean getBsdataDirtyFlag(){
        return bsdataDirtyFlag ;
    }

    /**
     * 获取 [PARENTINSTID]
     */
    @JsonProperty("parentinstid")
    public String getParentInstId(){
        return parentInstId ;
    }

    /**
     * 设置 [PARENTINSTID]
     */
    @JsonProperty("parentinstid")
    public void setParentInstId(String  parentInstId){
        this.parentInstId = parentInstId ;
        this.parentInstIdDirtyFlag = true ;
    }

    /**
     * 获取 [PARENTINSTID]脏标记
     */
    @JsonIgnore
    public boolean getParentInstIdDirtyFlag(){
        return parentInstIdDirtyFlag ;
    }

    /**
     * 获取 [WFUSERID]
     */
    @JsonProperty("wfuserid")
    public String getWFUserId(){
        return wFUserId ;
    }

    /**
     * 设置 [WFUSERID]
     */
    @JsonProperty("wfuserid")
    public void setWFUserId(String  wFUserId){
        this.wFUserId = wFUserId ;
        this.wFUserIdDirtyFlag = true ;
    }

    /**
     * 获取 [WFUSERID]脏标记
     */
    @JsonIgnore
    public boolean getWFUserIdDirtyFlag(){
        return wFUserIdDirtyFlag ;
    }

    /**
     * 获取 [PROXYMODULEID]
     */
    @JsonProperty("proxymoduleid")
    public String getProxyModuleId(){
        return proxyModuleId ;
    }

    /**
     * 设置 [PROXYMODULEID]
     */
    @JsonProperty("proxymoduleid")
    public void setProxyModuleId(String  proxyModuleId){
        this.proxyModuleId = proxyModuleId ;
        this.proxyModuleIdDirtyFlag = true ;
    }

    /**
     * 获取 [PROXYMODULEID]脏标记
     */
    @JsonIgnore
    public boolean getProxyModuleIdDirtyFlag(){
        return proxyModuleIdDirtyFlag ;
    }

    /**
     * 获取 [ORIGINORGDEPTID]
     */
    @JsonProperty("originorgdeptid")
    public String getOriginOrgDeptId(){
        return originOrgDeptId ;
    }

    /**
     * 设置 [ORIGINORGDEPTID]
     */
    @JsonProperty("originorgdeptid")
    public void setOriginOrgDeptId(String  originOrgDeptId){
        this.originOrgDeptId = originOrgDeptId ;
        this.originOrgDeptIdDirtyFlag = true ;
    }

    /**
     * 获取 [ORIGINORGDEPTID]脏标记
     */
    @JsonIgnore
    public boolean getOriginOrgDeptIdDirtyFlag(){
        return originOrgDeptIdDirtyFlag ;
    }

    /**
     * 获取 [PREVSTEPVALUE]
     */
    @JsonProperty("prevstepvalue")
    public String getPrevStepValue(){
        return prevStepValue ;
    }

    /**
     * 设置 [PREVSTEPVALUE]
     */
    @JsonProperty("prevstepvalue")
    public void setPrevStepValue(String  prevStepValue){
        this.prevStepValue = prevStepValue ;
        this.prevStepValueDirtyFlag = true ;
    }

    /**
     * 获取 [PREVSTEPVALUE]脏标记
     */
    @JsonIgnore
    public boolean getPrevStepValueDirtyFlag(){
        return prevStepValueDirtyFlag ;
    }

    /**
     * 获取 [CURSTEPVALUE]
     */
    @JsonProperty("curstepvalue")
    public String getCurStepValue(){
        return curStepValue ;
    }

    /**
     * 设置 [CURSTEPVALUE]
     */
    @JsonProperty("curstepvalue")
    public void setCurStepValue(String  curStepValue){
        this.curStepValue = curStepValue ;
        this.curStepValueDirtyFlag = true ;
    }

    /**
     * 获取 [CURSTEPVALUE]脏标记
     */
    @JsonIgnore
    public boolean getCurStepValueDirtyFlag(){
        return curStepValueDirtyFlag ;
    }

    /**
     * 获取 [ORIGINPERSONID]
     */
    @JsonProperty("originpersonid")
    public String getOriginPersonId(){
        return originPersonId ;
    }

    /**
     * 设置 [ORIGINPERSONID]
     */
    @JsonProperty("originpersonid")
    public void setOriginPersonId(String  originPersonId){
        this.originPersonId = originPersonId ;
        this.originPersonIdDirtyFlag = true ;
    }

    /**
     * 获取 [ORIGINPERSONID]脏标记
     */
    @JsonIgnore
    public boolean getOriginPersonIdDirtyFlag(){
        return originPersonIdDirtyFlag ;
    }

    /**
     * 获取 [INSTANCETYPE]
     */
    @JsonProperty("instancetype")
    public String getInstanceType(){
        return instanceType ;
    }

    /**
     * 设置 [INSTANCETYPE]
     */
    @JsonProperty("instancetype")
    public void setInstanceType(String  instanceType){
        this.instanceType = instanceType ;
        this.instanceTypeDirtyFlag = true ;
    }

    /**
     * 获取 [INSTANCETYPE]脏标记
     */
    @JsonIgnore
    public boolean getInstanceTypeDirtyFlag(){
        return instanceTypeDirtyFlag ;
    }

    /**
     * 获取 [CREATEMAN]
     */
    @JsonProperty("createman")
    public String getCreateMan(){
        return createMan ;
    }

    /**
     * 设置 [CREATEMAN]
     */
    @JsonProperty("createman")
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return createManDirtyFlag ;
    }

    /**
     * 获取 [ISCLOSED]
     */
    @JsonProperty("isclosed")
    public Integer getIsclosed(){
        return isclosed ;
    }

    /**
     * 设置 [ISCLOSED]
     */
    @JsonProperty("isclosed")
    public void setIsclosed(Integer  isclosed){
        this.isclosed = isclosed ;
        this.isclosedDirtyFlag = true ;
    }

    /**
     * 获取 [ISCLOSED]脏标记
     */
    @JsonIgnore
    public boolean getIsclosedDirtyFlag(){
        return isclosedDirtyFlag ;
    }

    /**
     * 获取 [ORIGINORGNAME]
     */
    @JsonProperty("originorgname")
    public String getOriginOrgName(){
        return originOrgName ;
    }

    /**
     * 设置 [ORIGINORGNAME]
     */
    @JsonProperty("originorgname")
    public void setOriginOrgName(String  originOrgName){
        this.originOrgName = originOrgName ;
        this.originOrgNameDirtyFlag = true ;
    }

    /**
     * 获取 [ORIGINORGNAME]脏标记
     */
    @JsonIgnore
    public boolean getOriginOrgNameDirtyFlag(){
        return originOrgNameDirtyFlag ;
    }

    /**
     * 获取 [OWNER]
     */
    @JsonProperty("owner")
    public String getOwner(){
        return owner ;
    }

    /**
     * 设置 [OWNER]
     */
    @JsonProperty("owner")
    public void setOwner(String  owner){
        this.owner = owner ;
        this.ownerDirtyFlag = true ;
    }

    /**
     * 获取 [OWNER]脏标记
     */
    @JsonIgnore
    public boolean getOwnerDirtyFlag(){
        return ownerDirtyFlag ;
    }

    /**
     * 获取 [PARENTSTEP]
     */
    @JsonProperty("parentstep")
    public String getParentStep(){
        return parentStep ;
    }

    /**
     * 设置 [PARENTSTEP]
     */
    @JsonProperty("parentstep")
    public void setParentStep(String  parentStep){
        this.parentStep = parentStep ;
        this.parentStepDirtyFlag = true ;
    }

    /**
     * 获取 [PARENTSTEP]脏标记
     */
    @JsonIgnore
    public boolean getParentStepDirtyFlag(){
        return parentStepDirtyFlag ;
    }

    /**
     * 获取 [WFINSTANCEID]
     */
    @JsonProperty("wfinstanceid")
    public String getWFInstanceId(){
        return wFInstanceId ;
    }

    /**
     * 设置 [WFINSTANCEID]
     */
    @JsonProperty("wfinstanceid")
    public void setWFInstanceId(String  wFInstanceId){
        this.wFInstanceId = wFInstanceId ;
        this.wFInstanceIdDirtyFlag = true ;
    }

    /**
     * 获取 [WFINSTANCEID]脏标记
     */
    @JsonIgnore
    public boolean getWFInstanceIdDirtyFlag(){
        return wFInstanceIdDirtyFlag ;
    }

    /**
     * 获取 [BSWFDATA]
     */
    @JsonProperty("bswfdata")
    public String getBswfdata(){
        return bswfdata ;
    }

    /**
     * 设置 [BSWFDATA]
     */
    @JsonProperty("bswfdata")
    public void setBswfdata(String  bswfdata){
        this.bswfdata = bswfdata ;
        this.bswfdataDirtyFlag = true ;
    }

    /**
     * 获取 [BSWFDATA]脏标记
     */
    @JsonIgnore
    public boolean getBswfdataDirtyFlag(){
        return bswfdataDirtyFlag ;
    }

    /**
     * 获取 [WFINSTANCENAME]
     */
    @JsonProperty("wfinstancename")
    public String getWFInstanceName(){
        return wFInstanceName ;
    }

    /**
     * 设置 [WFINSTANCENAME]
     */
    @JsonProperty("wfinstancename")
    public void setWFInstanceName(String  wFInstanceName){
        this.wFInstanceName = wFInstanceName ;
        this.wFInstanceNameDirtyFlag = true ;
    }

    /**
     * 获取 [WFINSTANCENAME]脏标记
     */
    @JsonIgnore
    public boolean getWFInstanceNameDirtyFlag(){
        return wFInstanceNameDirtyFlag ;
    }

    /**
     * 获取 [ORIGINORGDEPTNAME]
     */
    @JsonProperty("originorgdeptname")
    public String getOriginOrgDeptName(){
        return originOrgDeptName ;
    }

    /**
     * 设置 [ORIGINORGDEPTNAME]
     */
    @JsonProperty("originorgdeptname")
    public void setOriginOrgDeptName(String  originOrgDeptName){
        this.originOrgDeptName = originOrgDeptName ;
        this.originOrgDeptNameDirtyFlag = true ;
    }

    /**
     * 获取 [ORIGINORGDEPTNAME]脏标记
     */
    @JsonIgnore
    public boolean getOriginOrgDeptNameDirtyFlag(){
        return originOrgDeptNameDirtyFlag ;
    }

    /**
     * 获取 [ENDTIME]
     */
    @JsonProperty("endtime")
    public Timestamp getEndtime(){
        return endtime ;
    }

    /**
     * 设置 [ENDTIME]
     */
    @JsonProperty("endtime")
    public void setEndtime(Timestamp  endtime){
        this.endtime = endtime ;
        this.endtimeDirtyFlag = true ;
    }

    /**
     * 获取 [ENDTIME]脏标记
     */
    @JsonIgnore
    public boolean getEndtimeDirtyFlag(){
        return endtimeDirtyFlag ;
    }

    /**
     * 获取 [ORIGINORGID]
     */
    @JsonProperty("originorgid")
    public String getOriginOrgId(){
        return originOrgId ;
    }

    /**
     * 设置 [ORIGINORGID]
     */
    @JsonProperty("originorgid")
    public void setOriginOrgId(String  originOrgId){
        this.originOrgId = originOrgId ;
        this.originOrgIdDirtyFlag = true ;
    }

    /**
     * 获取 [ORIGINORGID]脏标记
     */
    @JsonIgnore
    public boolean getOriginOrgIdDirtyFlag(){
        return originOrgIdDirtyFlag ;
    }

    /**
     * 获取 [WFENGINEINSTANCEID]
     */
    @JsonProperty("wfengineinstanceid")
    public String getWFEngineInstanceId(){
        return wFEngineInstanceId ;
    }

    /**
     * 设置 [WFENGINEINSTANCEID]
     */
    @JsonProperty("wfengineinstanceid")
    public void setWFEngineInstanceId(String  wFEngineInstanceId){
        this.wFEngineInstanceId = wFEngineInstanceId ;
        this.wFEngineInstanceIdDirtyFlag = true ;
    }

    /**
     * 获取 [WFENGINEINSTANCEID]脏标记
     */
    @JsonIgnore
    public boolean getWFEngineInstanceIdDirtyFlag(){
        return wFEngineInstanceIdDirtyFlag ;
    }

    /**
     * 获取 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public String getUpdateMan(){
        return updateMan ;
    }

    /**
     * 设置 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return updateManDirtyFlag ;
    }

    /**
     * 获取 [PREVPROCESS]
     */
    @JsonProperty("prevprocess")
    public String getPrevProcess(){
        return prevProcess ;
    }

    /**
     * 设置 [PREVPROCESS]
     */
    @JsonProperty("prevprocess")
    public void setPrevProcess(String  prevProcess){
        this.prevProcess = prevProcess ;
        this.prevProcessDirtyFlag = true ;
    }

    /**
     * 获取 [PREVPROCESS]脏标记
     */
    @JsonIgnore
    public boolean getPrevProcessDirtyFlag(){
        return prevProcessDirtyFlag ;
    }

    /**
     * 获取 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public Timestamp getCreateDate(){
        return createDate ;
    }

    /**
     * 设置 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return createDateDirtyFlag ;
    }

    /**
     * 获取 [ORIGINPERSONNAME]
     */
    @JsonProperty("originpersonname")
    public String getOriginPersonName(){
        return originPersonName ;
    }

    /**
     * 设置 [ORIGINPERSONNAME]
     */
    @JsonProperty("originpersonname")
    public void setOriginPersonName(String  originPersonName){
        this.originPersonName = originPersonName ;
        this.originPersonNameDirtyFlag = true ;
    }

    /**
     * 获取 [ORIGINPERSONNAME]脏标记
     */
    @JsonIgnore
    public boolean getOriginPersonNameDirtyFlag(){
        return originPersonNameDirtyFlag ;
    }

    /**
     * 获取 [WFSTATE]
     */
    @JsonProperty("wfstate")
    public String getWFState(){
        return wFState ;
    }

    /**
     * 设置 [WFSTATE]
     */
    @JsonProperty("wfstate")
    public void setWFState(String  wFState){
        this.wFState = wFState ;
        this.wFStateDirtyFlag = true ;
    }

    /**
     * 获取 [WFSTATE]脏标记
     */
    @JsonIgnore
    public boolean getWFStateDirtyFlag(){
        return wFStateDirtyFlag ;
    }

    /**
     * 获取 [PREVSTEP]
     */
    @JsonProperty("prevstep")
    public String getPrevstep(){
        return prevstep ;
    }

    /**
     * 设置 [PREVSTEP]
     */
    @JsonProperty("prevstep")
    public void setPrevstep(String  prevstep){
        this.prevstep = prevstep ;
        this.prevstepDirtyFlag = true ;
    }

    /**
     * 获取 [PREVSTEP]脏标记
     */
    @JsonIgnore
    public boolean getPrevstepDirtyFlag(){
        return prevstepDirtyFlag ;
    }

    /**
     * 获取 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public Timestamp getUpdateDate(){
        return updateDate ;
    }

    /**
     * 设置 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return updateDateDirtyFlag ;
    }

    /**
     * 获取 [CURPROCESS]
     */
    @JsonProperty("curprocess")
    public String getCurProcess(){
        return curProcess ;
    }

    /**
     * 设置 [CURPROCESS]
     */
    @JsonProperty("curprocess")
    public void setCurProcess(String  curProcess){
        this.curProcess = curProcess ;
        this.curProcessDirtyFlag = true ;
    }

    /**
     * 获取 [CURPROCESS]脏标记
     */
    @JsonIgnore
    public boolean getCurProcessDirtyFlag(){
        return curProcessDirtyFlag ;
    }

    /**
     * 获取 [CURSTEP]
     */
    @JsonProperty("curstep")
    public String getCurstep(){
        return curstep ;
    }

    /**
     * 设置 [CURSTEP]
     */
    @JsonProperty("curstep")
    public void setCurstep(String  curstep){
        this.curstep = curstep ;
        this.curstepDirtyFlag = true ;
    }

    /**
     * 获取 [CURSTEP]脏标记
     */
    @JsonIgnore
    public boolean getCurstepDirtyFlag(){
        return curstepDirtyFlag ;
    }

    /**
     * 获取 [LOGICNAME]
     */
    @JsonProperty("logicname")
    public String getLogicName(){
        return logicName ;
    }

    /**
     * 设置 [LOGICNAME]
     */
    @JsonProperty("logicname")
    public void setLogicName(String  logicName){
        this.logicName = logicName ;
        this.logicNameDirtyFlag = true ;
    }

    /**
     * 获取 [LOGICNAME]脏标记
     */
    @JsonIgnore
    public boolean getLogicNameDirtyFlag(){
        return logicNameDirtyFlag ;
    }

    /**
     * 获取 [MAJORINSTID]
     */
    @JsonProperty("majorinstid")
    public String getMajorInstId(){
        return majorInstId ;
    }

    /**
     * 设置 [MAJORINSTID]
     */
    @JsonProperty("majorinstid")
    public void setMajorInstId(String  majorInstId){
        this.majorInstId = majorInstId ;
        this.majorInstIdDirtyFlag = true ;
    }

    /**
     * 获取 [MAJORINSTID]脏标记
     */
    @JsonIgnore
    public boolean getMajorInstIdDirtyFlag(){
        return majorInstIdDirtyFlag ;
    }

    /**
     * 获取 [ORGDEPTID]
     */
    @JsonProperty("orgdeptid")
    public String getOrgDeptId(){
        return orgDeptId ;
    }

    /**
     * 设置 [ORGDEPTID]
     */
    @JsonProperty("orgdeptid")
    public void setOrgDeptId(String  orgDeptId){
        this.orgDeptId = orgDeptId ;
        this.orgDeptIdDirtyFlag = true ;
    }

    /**
     * 获取 [ORGDEPTID]脏标记
     */
    @JsonIgnore
    public boolean getOrgDeptIdDirtyFlag(){
        return orgDeptIdDirtyFlag ;
    }

    /**
     * 获取 [WFENGINEID]
     */
    @JsonProperty("wfengineid")
    public String getWFEngineId(){
        return wFEngineId ;
    }

    /**
     * 设置 [WFENGINEID]
     */
    @JsonProperty("wfengineid")
    public void setWFEngineId(String  wFEngineId){
        this.wFEngineId = wFEngineId ;
        this.wFEngineIdDirtyFlag = true ;
    }

    /**
     * 获取 [WFENGINEID]脏标记
     */
    @JsonIgnore
    public boolean getWFEngineIdDirtyFlag(){
        return wFEngineIdDirtyFlag ;
    }

    /**
     * 获取 [PSWORKFLOWID]
     */
    @JsonProperty("psworkflowid")
    public String getPSWorkflowId(){
        return pSWorkflowId ;
    }

    /**
     * 设置 [PSWORKFLOWID]
     */
    @JsonProperty("psworkflowid")
    public void setPSWorkflowId(String  pSWorkflowId){
        this.pSWorkflowId = pSWorkflowId ;
        this.pSWorkflowIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSWORKFLOWID]脏标记
     */
    @JsonIgnore
    public boolean getPSWorkflowIdDirtyFlag(){
        return pSWorkflowIdDirtyFlag ;
    }

    /**
     * 获取 [ORGID]
     */
    @JsonProperty("orgid")
    public String getOrgId(){
        return orgId ;
    }

    /**
     * 设置 [ORGID]
     */
    @JsonProperty("orgid")
    public void setOrgId(String  orgId){
        this.orgId = orgId ;
        this.orgIdDirtyFlag = true ;
    }

    /**
     * 获取 [ORGID]脏标记
     */
    @JsonIgnore
    public boolean getOrgIdDirtyFlag(){
        return orgIdDirtyFlag ;
    }

    /**
     * 获取 [PSWFVERSIONID]
     */
    @JsonProperty("pswfversionid")
    public String getPSWFVersionId(){
        return pSWFVersionId ;
    }

    /**
     * 设置 [PSWFVERSIONID]
     */
    @JsonProperty("pswfversionid")
    public void setPSWFVersionId(String  pSWFVersionId){
        this.pSWFVersionId = pSWFVersionId ;
        this.pSWFVersionIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSWFVERSIONID]脏标记
     */
    @JsonIgnore
    public boolean getPSWFVersionIdDirtyFlag(){
        return pSWFVersionIdDirtyFlag ;
    }



    public WFInstance toDO() {
        WFInstance srfdomain = new WFInstance();
        if(getStartTimeDirtyFlag())
            srfdomain.setStartTime(startTime);
        if(getBsdataDirtyFlag())
            srfdomain.setBsdata(bsdata);
        if(getParentInstIdDirtyFlag())
            srfdomain.setParentInstId(parentInstId);
        if(getWFUserIdDirtyFlag())
            srfdomain.setWFUserId(wFUserId);
        if(getProxyModuleIdDirtyFlag())
            srfdomain.setProxyModuleId(proxyModuleId);
        if(getOriginOrgDeptIdDirtyFlag())
            srfdomain.setOriginOrgDeptId(originOrgDeptId);
        if(getPrevStepValueDirtyFlag())
            srfdomain.setPrevStepValue(prevStepValue);
        if(getCurStepValueDirtyFlag())
            srfdomain.setCurStepValue(curStepValue);
        if(getOriginPersonIdDirtyFlag())
            srfdomain.setOriginPersonId(originPersonId);
        if(getInstanceTypeDirtyFlag())
            srfdomain.setInstanceType(instanceType);
        if(getCreateManDirtyFlag())
            srfdomain.setCreateMan(createMan);
        if(getIsclosedDirtyFlag())
            srfdomain.setIsclosed(isclosed);
        if(getOriginOrgNameDirtyFlag())
            srfdomain.setOriginOrgName(originOrgName);
        if(getOwnerDirtyFlag())
            srfdomain.setOwner(owner);
        if(getParentStepDirtyFlag())
            srfdomain.setParentStep(parentStep);
        if(getWFInstanceIdDirtyFlag())
            srfdomain.setWFInstanceId(wFInstanceId);
        if(getBswfdataDirtyFlag())
            srfdomain.setBswfdata(bswfdata);
        if(getWFInstanceNameDirtyFlag())
            srfdomain.setWFInstanceName(wFInstanceName);
        if(getOriginOrgDeptNameDirtyFlag())
            srfdomain.setOriginOrgDeptName(originOrgDeptName);
        if(getEndtimeDirtyFlag())
            srfdomain.setEndtime(endtime);
        if(getOriginOrgIdDirtyFlag())
            srfdomain.setOriginOrgId(originOrgId);
        if(getWFEngineInstanceIdDirtyFlag())
            srfdomain.setWFEngineInstanceId(wFEngineInstanceId);
        if(getUpdateManDirtyFlag())
            srfdomain.setUpdateMan(updateMan);
        if(getPrevProcessDirtyFlag())
            srfdomain.setPrevProcess(prevProcess);
        if(getCreateDateDirtyFlag())
            srfdomain.setCreateDate(createDate);
        if(getOriginPersonNameDirtyFlag())
            srfdomain.setOriginPersonName(originPersonName);
        if(getWFStateDirtyFlag())
            srfdomain.setWFState(wFState);
        if(getPrevstepDirtyFlag())
            srfdomain.setPrevstep(prevstep);
        if(getUpdateDateDirtyFlag())
            srfdomain.setUpdateDate(updateDate);
        if(getCurProcessDirtyFlag())
            srfdomain.setCurProcess(curProcess);
        if(getCurstepDirtyFlag())
            srfdomain.setCurstep(curstep);
        if(getLogicNameDirtyFlag())
            srfdomain.setLogicName(logicName);
        if(getMajorInstIdDirtyFlag())
            srfdomain.setMajorInstId(majorInstId);
        if(getOrgDeptIdDirtyFlag())
            srfdomain.setOrgDeptId(orgDeptId);
        if(getWFEngineIdDirtyFlag())
            srfdomain.setWFEngineId(wFEngineId);
        if(getPSWorkflowIdDirtyFlag())
            srfdomain.setPSWorkflowId(pSWorkflowId);
        if(getOrgIdDirtyFlag())
            srfdomain.setOrgId(orgId);
        if(getPSWFVersionIdDirtyFlag())
            srfdomain.setPSWFVersionId(pSWFVersionId);

        return srfdomain;
    }

    public void fromDO(WFInstance srfdomain) {
        if(srfdomain == null )
          return ;
        if(srfdomain.getStartTimeDirtyFlag())
            this.setStartTime(srfdomain.getStartTime());
        if(srfdomain.getBsdataDirtyFlag())
            this.setBsdata(srfdomain.getBsdata());
        if(srfdomain.getParentInstIdDirtyFlag())
            this.setParentInstId(srfdomain.getParentInstId());
        if(srfdomain.getWFUserIdDirtyFlag())
            this.setWFUserId(srfdomain.getWFUserId());
        if(srfdomain.getProxyModuleIdDirtyFlag())
            this.setProxyModuleId(srfdomain.getProxyModuleId());
        if(srfdomain.getOriginOrgDeptIdDirtyFlag())
            this.setOriginOrgDeptId(srfdomain.getOriginOrgDeptId());
        if(srfdomain.getPrevStepValueDirtyFlag())
            this.setPrevStepValue(srfdomain.getPrevStepValue());
        if(srfdomain.getCurStepValueDirtyFlag())
            this.setCurStepValue(srfdomain.getCurStepValue());
        if(srfdomain.getOriginPersonIdDirtyFlag())
            this.setOriginPersonId(srfdomain.getOriginPersonId());
        if(srfdomain.getInstanceTypeDirtyFlag())
            this.setInstanceType(srfdomain.getInstanceType());
        if(srfdomain.getCreateManDirtyFlag())
            this.setCreateMan(srfdomain.getCreateMan());
        if(srfdomain.getIsclosedDirtyFlag())
            this.setIsclosed(srfdomain.getIsclosed());
        if(srfdomain.getOriginOrgNameDirtyFlag())
            this.setOriginOrgName(srfdomain.getOriginOrgName());
        if(srfdomain.getOwnerDirtyFlag())
            this.setOwner(srfdomain.getOwner());
        if(srfdomain.getParentStepDirtyFlag())
            this.setParentStep(srfdomain.getParentStep());
        if(srfdomain.getWFInstanceIdDirtyFlag())
            this.setWFInstanceId(srfdomain.getWFInstanceId());
        if(srfdomain.getBswfdataDirtyFlag())
            this.setBswfdata(srfdomain.getBswfdata());
        if(srfdomain.getWFInstanceNameDirtyFlag())
            this.setWFInstanceName(srfdomain.getWFInstanceName());
        if(srfdomain.getOriginOrgDeptNameDirtyFlag())
            this.setOriginOrgDeptName(srfdomain.getOriginOrgDeptName());
        if(srfdomain.getEndtimeDirtyFlag())
            this.setEndtime(srfdomain.getEndtime());
        if(srfdomain.getOriginOrgIdDirtyFlag())
            this.setOriginOrgId(srfdomain.getOriginOrgId());
        if(srfdomain.getWFEngineInstanceIdDirtyFlag())
            this.setWFEngineInstanceId(srfdomain.getWFEngineInstanceId());
        if(srfdomain.getUpdateManDirtyFlag())
            this.setUpdateMan(srfdomain.getUpdateMan());
        if(srfdomain.getPrevProcessDirtyFlag())
            this.setPrevProcess(srfdomain.getPrevProcess());
        if(srfdomain.getCreateDateDirtyFlag())
            this.setCreateDate(srfdomain.getCreateDate());
        if(srfdomain.getOriginPersonNameDirtyFlag())
            this.setOriginPersonName(srfdomain.getOriginPersonName());
        if(srfdomain.getWFStateDirtyFlag())
            this.setWFState(srfdomain.getWFState());
        if(srfdomain.getPrevstepDirtyFlag())
            this.setPrevstep(srfdomain.getPrevstep());
        if(srfdomain.getUpdateDateDirtyFlag())
            this.setUpdateDate(srfdomain.getUpdateDate());
        if(srfdomain.getCurProcessDirtyFlag())
            this.setCurProcess(srfdomain.getCurProcess());
        if(srfdomain.getCurstepDirtyFlag())
            this.setCurstep(srfdomain.getCurstep());
        if(srfdomain.getLogicNameDirtyFlag())
            this.setLogicName(srfdomain.getLogicName());
        if(srfdomain.getMajorInstIdDirtyFlag())
            this.setMajorInstId(srfdomain.getMajorInstId());
        if(srfdomain.getOrgDeptIdDirtyFlag())
            this.setOrgDeptId(srfdomain.getOrgDeptId());
        if(srfdomain.getWFEngineIdDirtyFlag())
            this.setWFEngineId(srfdomain.getWFEngineId());
        if(srfdomain.getPSWorkflowIdDirtyFlag())
            this.setPSWorkflowId(srfdomain.getPSWorkflowId());
        if(srfdomain.getOrgIdDirtyFlag())
            this.setOrgId(srfdomain.getOrgId());
        if(srfdomain.getPSWFVersionIdDirtyFlag())
            this.setPSWFVersionId(srfdomain.getPSWFVersionId());

    }

    public List<WFInstanceDTO> fromDOPage(List<WFInstance> poPage)   {
        if(poPage == null)
            return null;
        List<WFInstanceDTO> dtos=new ArrayList<WFInstanceDTO>();
        for(WFInstance domain : poPage) {
            WFInstanceDTO dto = new WFInstanceDTO();
            dto.fromDO(domain);
            dtos.add(dto);
        }
        return dtos;
    }
}

