package cn.ibizlab.r7.runtime.wf.service.uniwfinternalservice.dto;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.math.BigInteger;
import java.util.Map;
import java.util.HashMap;
import java.io.Serializable;
import java.math.BigDecimal;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.valuerule.anno.wfmode.*;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFMode;
import org.springframework.cglib.beans.BeanCopier;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * 服务DTO对象[WFModeDTO]
 */
public class WFModeDTO implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 属性 [LOGICNAME]
     *
     */
    @WFModeLogicNameDefault(info = "默认规则")
    private String logicName;

    @JsonIgnore
    private boolean logicNameDirtyFlag;

    /**
     * 属性 [CREATEDATE]
     *
     */
    @WFModeCreateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp createDate;

    @JsonIgnore
    private boolean createDateDirtyFlag;

    /**
     * 属性 [WFMODEID]
     *
     */
    @WFModeWFModeIdDefault(info = "默认规则")
    private String wFModeId;

    @JsonIgnore
    private boolean wFModeIdDirtyFlag;

    /**
     * 属性 [UPDATEMAN]
     *
     */
    @WFModeUpdateManDefault(info = "默认规则")
    private String updateMan;

    @JsonIgnore
    private boolean updateManDirtyFlag;

    /**
     * 属性 [UPDATEDATE]
     *
     */
    @WFModeUpdateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp updateDate;

    @JsonIgnore
    private boolean updateDateDirtyFlag;

    /**
     * 属性 [CREATEMAN]
     *
     */
    @WFModeCreateManDefault(info = "默认规则")
    private String createMan;

    @JsonIgnore
    private boolean createManDirtyFlag;

    /**
     * 属性 [WFMODENAME]
     *
     */
    @WFModeWFModeNameDefault(info = "默认规则")
    private String wFModeName;

    @JsonIgnore
    private boolean wFModeNameDirtyFlag;

    /**
     * 属性 [PSSYSTEMID]
     *
     */
    @WFModePSSystemIdDefault(info = "默认规则")
    private String pSSystemId;

    @JsonIgnore
    private boolean pSSystemIdDirtyFlag;


    /**
     * 获取 [LOGICNAME]
     */
    @JsonProperty("logicname")
    public String getLogicName(){
        return logicName ;
    }

    /**
     * 设置 [LOGICNAME]
     */
    @JsonProperty("logicname")
    public void setLogicName(String  logicName){
        this.logicName = logicName ;
        this.logicNameDirtyFlag = true ;
    }

    /**
     * 获取 [LOGICNAME]脏标记
     */
    @JsonIgnore
    public boolean getLogicNameDirtyFlag(){
        return logicNameDirtyFlag ;
    }

    /**
     * 获取 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public Timestamp getCreateDate(){
        return createDate ;
    }

    /**
     * 设置 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return createDateDirtyFlag ;
    }

    /**
     * 获取 [WFMODEID]
     */
    @JsonProperty("wfmodeid")
    public String getWFModeId(){
        return wFModeId ;
    }

    /**
     * 设置 [WFMODEID]
     */
    @JsonProperty("wfmodeid")
    public void setWFModeId(String  wFModeId){
        this.wFModeId = wFModeId ;
        this.wFModeIdDirtyFlag = true ;
    }

    /**
     * 获取 [WFMODEID]脏标记
     */
    @JsonIgnore
    public boolean getWFModeIdDirtyFlag(){
        return wFModeIdDirtyFlag ;
    }

    /**
     * 获取 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public String getUpdateMan(){
        return updateMan ;
    }

    /**
     * 设置 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return updateManDirtyFlag ;
    }

    /**
     * 获取 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public Timestamp getUpdateDate(){
        return updateDate ;
    }

    /**
     * 设置 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return updateDateDirtyFlag ;
    }

    /**
     * 获取 [CREATEMAN]
     */
    @JsonProperty("createman")
    public String getCreateMan(){
        return createMan ;
    }

    /**
     * 设置 [CREATEMAN]
     */
    @JsonProperty("createman")
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return createManDirtyFlag ;
    }

    /**
     * 获取 [WFMODENAME]
     */
    @JsonProperty("wfmodename")
    public String getWFModeName(){
        return wFModeName ;
    }

    /**
     * 设置 [WFMODENAME]
     */
    @JsonProperty("wfmodename")
    public void setWFModeName(String  wFModeName){
        this.wFModeName = wFModeName ;
        this.wFModeNameDirtyFlag = true ;
    }

    /**
     * 获取 [WFMODENAME]脏标记
     */
    @JsonIgnore
    public boolean getWFModeNameDirtyFlag(){
        return wFModeNameDirtyFlag ;
    }

    /**
     * 获取 [PSSYSTEMID]
     */
    @JsonProperty("pssystemid")
    public String getPSSystemId(){
        return pSSystemId ;
    }

    /**
     * 设置 [PSSYSTEMID]
     */
    @JsonProperty("pssystemid")
    public void setPSSystemId(String  pSSystemId){
        this.pSSystemId = pSSystemId ;
        this.pSSystemIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSSYSTEMID]脏标记
     */
    @JsonIgnore
    public boolean getPSSystemIdDirtyFlag(){
        return pSSystemIdDirtyFlag ;
    }



    public WFMode toDO() {
        WFMode srfdomain = new WFMode();
        if(getLogicNameDirtyFlag())
            srfdomain.setLogicName(logicName);
        if(getCreateDateDirtyFlag())
            srfdomain.setCreateDate(createDate);
        if(getWFModeIdDirtyFlag())
            srfdomain.setWFModeId(wFModeId);
        if(getUpdateManDirtyFlag())
            srfdomain.setUpdateMan(updateMan);
        if(getUpdateDateDirtyFlag())
            srfdomain.setUpdateDate(updateDate);
        if(getCreateManDirtyFlag())
            srfdomain.setCreateMan(createMan);
        if(getWFModeNameDirtyFlag())
            srfdomain.setWFModeName(wFModeName);
        if(getPSSystemIdDirtyFlag())
            srfdomain.setPSSystemId(pSSystemId);

        return srfdomain;
    }

    public void fromDO(WFMode srfdomain) {
        if(srfdomain == null )
          return ;
        if(srfdomain.getLogicNameDirtyFlag())
            this.setLogicName(srfdomain.getLogicName());
        if(srfdomain.getCreateDateDirtyFlag())
            this.setCreateDate(srfdomain.getCreateDate());
        if(srfdomain.getWFModeIdDirtyFlag())
            this.setWFModeId(srfdomain.getWFModeId());
        if(srfdomain.getUpdateManDirtyFlag())
            this.setUpdateMan(srfdomain.getUpdateMan());
        if(srfdomain.getUpdateDateDirtyFlag())
            this.setUpdateDate(srfdomain.getUpdateDate());
        if(srfdomain.getCreateManDirtyFlag())
            this.setCreateMan(srfdomain.getCreateMan());
        if(srfdomain.getWFModeNameDirtyFlag())
            this.setWFModeName(srfdomain.getWFModeName());
        if(srfdomain.getPSSystemIdDirtyFlag())
            this.setPSSystemId(srfdomain.getPSSystemId());

    }

    public List<WFModeDTO> fromDOPage(List<WFMode> poPage)   {
        if(poPage == null)
            return null;
        List<WFModeDTO> dtos=new ArrayList<WFModeDTO>();
        for(WFMode domain : poPage) {
            WFModeDTO dto = new WFModeDTO();
            dto.fromDO(domain);
            dtos.add(dto);
        }
        return dtos;
    }
}

