package cn.ibizlab.r7.runtime.wf.service.uniwfinternalservice.dto;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.math.BigInteger;
import java.util.Map;
import java.util.HashMap;
import java.io.Serializable;
import java.math.BigDecimal;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.valuerule.anno.wfstepdata.*;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFStepData;
import org.springframework.cglib.beans.BeanCopier;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * 服务DTO对象[WFStepDataDTO]
 */
public class WFStepDataDTO implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 属性 [WFSTEPDATAID]
     *
     */
    @WFStepDataWFStepDataIdDefault(info = "默认规则")
    private String wFStepDataId;

    @JsonIgnore
    private boolean wFStepDataIdDirtyFlag;

    /**
     * 属性 [ACTIONPERSON]
     *
     */
    @WFStepDataActionPersonDefault(info = "默认规则")
    private String actionPerson;

    @JsonIgnore
    private boolean actionPersonDirtyFlag;

    /**
     * 属性 [ACTIONINFO]
     *
     */
    @WFStepDataActionInfoDefault(info = "默认规则")
    private String actionInfo;

    @JsonIgnore
    private boolean actionInfoDirtyFlag;

    /**
     * 属性 [MAJORINSTID]
     *
     */
    @WFStepDataMajorInstIdDefault(info = "默认规则")
    private String majorInstId;

    @JsonIgnore
    private boolean majorInstIdDirtyFlag;

    /**
     * 属性 [ACTIONTIME]
     *
     */
    @WFStepDataActionTimeDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp actionTime;

    @JsonIgnore
    private boolean actionTimeDirtyFlag;

    /**
     * 属性 [CREATEMAN]
     *
     */
    @WFStepDataCreateManDefault(info = "默认规则")
    private String createMan;

    @JsonIgnore
    private boolean createManDirtyFlag;

    /**
     * 属性 [UPDATEDATE]
     *
     */
    @WFStepDataUpdateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp updateDate;

    @JsonIgnore
    private boolean updateDateDirtyFlag;

    /**
     * 属性 [ACTION]
     *
     */
    @WFStepDataActionDefault(info = "默认规则")
    private String action;

    @JsonIgnore
    private boolean actionDirtyFlag;

    /**
     * 属性 [CREATEDATE]
     *
     */
    @WFStepDataCreateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp createDate;

    @JsonIgnore
    private boolean createDateDirtyFlag;

    /**
     * 属性 [PARENTINSTID]
     *
     */
    @WFStepDataParentInstIdDefault(info = "默认规则")
    private String parentInstId;

    @JsonIgnore
    private boolean parentInstIdDirtyFlag;

    /**
     * 属性 [UPDATEMAN]
     *
     */
    @WFStepDataUpdateManDefault(info = "默认规则")
    private String updateMan;

    @JsonIgnore
    private boolean updateManDirtyFlag;

    /**
     * 属性 [WFSTEPDATANAME]
     *
     */
    @WFStepDataWFStepDataNameDefault(info = "默认规则")
    private String wFStepDataName;

    @JsonIgnore
    private boolean wFStepDataNameDirtyFlag;

    /**
     * 属性 [WFSTEPNAME]
     *
     */
    @WFStepDataWFStepNameDefault(info = "默认规则")
    private String wFStepName;

    @JsonIgnore
    private boolean wFStepNameDirtyFlag;

    /**
     * 属性 [WFSTEPID]
     *
     */
    @WFStepDataWFStepIdDefault(info = "默认规则")
    private String wFStepId;

    @JsonIgnore
    private boolean wFStepIdDirtyFlag;

    /**
     * 属性 [WFINSTANCEID]
     *
     */
    @WFStepDataWFInstanceIdDefault(info = "默认规则")
    private String wFInstanceId;

    @JsonIgnore
    private boolean wFInstanceIdDirtyFlag;

    /**
     * 属性 [WFIAACTIONID]
     *
     */
    @WFStepDataWFIAActionIdDefault(info = "默认规则")
    private String wFIAActionId;

    @JsonIgnore
    private boolean wFIAActionIdDirtyFlag;


    /**
     * 获取 [WFSTEPDATAID]
     */
    @JsonProperty("wfstepdataid")
    public String getWFStepDataId(){
        return wFStepDataId ;
    }

    /**
     * 设置 [WFSTEPDATAID]
     */
    @JsonProperty("wfstepdataid")
    public void setWFStepDataId(String  wFStepDataId){
        this.wFStepDataId = wFStepDataId ;
        this.wFStepDataIdDirtyFlag = true ;
    }

    /**
     * 获取 [WFSTEPDATAID]脏标记
     */
    @JsonIgnore
    public boolean getWFStepDataIdDirtyFlag(){
        return wFStepDataIdDirtyFlag ;
    }

    /**
     * 获取 [ACTIONPERSON]
     */
    @JsonProperty("actionperson")
    public String getActionPerson(){
        return actionPerson ;
    }

    /**
     * 设置 [ACTIONPERSON]
     */
    @JsonProperty("actionperson")
    public void setActionPerson(String  actionPerson){
        this.actionPerson = actionPerson ;
        this.actionPersonDirtyFlag = true ;
    }

    /**
     * 获取 [ACTIONPERSON]脏标记
     */
    @JsonIgnore
    public boolean getActionPersonDirtyFlag(){
        return actionPersonDirtyFlag ;
    }

    /**
     * 获取 [ACTIONINFO]
     */
    @JsonProperty("actioninfo")
    public String getActionInfo(){
        return actionInfo ;
    }

    /**
     * 设置 [ACTIONINFO]
     */
    @JsonProperty("actioninfo")
    public void setActionInfo(String  actionInfo){
        this.actionInfo = actionInfo ;
        this.actionInfoDirtyFlag = true ;
    }

    /**
     * 获取 [ACTIONINFO]脏标记
     */
    @JsonIgnore
    public boolean getActionInfoDirtyFlag(){
        return actionInfoDirtyFlag ;
    }

    /**
     * 获取 [MAJORINSTID]
     */
    @JsonProperty("majorinstid")
    public String getMajorInstId(){
        return majorInstId ;
    }

    /**
     * 设置 [MAJORINSTID]
     */
    @JsonProperty("majorinstid")
    public void setMajorInstId(String  majorInstId){
        this.majorInstId = majorInstId ;
        this.majorInstIdDirtyFlag = true ;
    }

    /**
     * 获取 [MAJORINSTID]脏标记
     */
    @JsonIgnore
    public boolean getMajorInstIdDirtyFlag(){
        return majorInstIdDirtyFlag ;
    }

    /**
     * 获取 [ACTIONTIME]
     */
    @JsonProperty("actiontime")
    public Timestamp getActionTime(){
        return actionTime ;
    }

    /**
     * 设置 [ACTIONTIME]
     */
    @JsonProperty("actiontime")
    public void setActionTime(Timestamp  actionTime){
        this.actionTime = actionTime ;
        this.actionTimeDirtyFlag = true ;
    }

    /**
     * 获取 [ACTIONTIME]脏标记
     */
    @JsonIgnore
    public boolean getActionTimeDirtyFlag(){
        return actionTimeDirtyFlag ;
    }

    /**
     * 获取 [CREATEMAN]
     */
    @JsonProperty("createman")
    public String getCreateMan(){
        return createMan ;
    }

    /**
     * 设置 [CREATEMAN]
     */
    @JsonProperty("createman")
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return createManDirtyFlag ;
    }

    /**
     * 获取 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public Timestamp getUpdateDate(){
        return updateDate ;
    }

    /**
     * 设置 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return updateDateDirtyFlag ;
    }

    /**
     * 获取 [ACTION]
     */
    @JsonProperty("action")
    public String getAction(){
        return action ;
    }

    /**
     * 设置 [ACTION]
     */
    @JsonProperty("action")
    public void setAction(String  action){
        this.action = action ;
        this.actionDirtyFlag = true ;
    }

    /**
     * 获取 [ACTION]脏标记
     */
    @JsonIgnore
    public boolean getActionDirtyFlag(){
        return actionDirtyFlag ;
    }

    /**
     * 获取 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public Timestamp getCreateDate(){
        return createDate ;
    }

    /**
     * 设置 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return createDateDirtyFlag ;
    }

    /**
     * 获取 [PARENTINSTID]
     */
    @JsonProperty("parentinstid")
    public String getParentInstId(){
        return parentInstId ;
    }

    /**
     * 设置 [PARENTINSTID]
     */
    @JsonProperty("parentinstid")
    public void setParentInstId(String  parentInstId){
        this.parentInstId = parentInstId ;
        this.parentInstIdDirtyFlag = true ;
    }

    /**
     * 获取 [PARENTINSTID]脏标记
     */
    @JsonIgnore
    public boolean getParentInstIdDirtyFlag(){
        return parentInstIdDirtyFlag ;
    }

    /**
     * 获取 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public String getUpdateMan(){
        return updateMan ;
    }

    /**
     * 设置 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return updateManDirtyFlag ;
    }

    /**
     * 获取 [WFSTEPDATANAME]
     */
    @JsonProperty("wfstepdataname")
    public String getWFStepDataName(){
        return wFStepDataName ;
    }

    /**
     * 设置 [WFSTEPDATANAME]
     */
    @JsonProperty("wfstepdataname")
    public void setWFStepDataName(String  wFStepDataName){
        this.wFStepDataName = wFStepDataName ;
        this.wFStepDataNameDirtyFlag = true ;
    }

    /**
     * 获取 [WFSTEPDATANAME]脏标记
     */
    @JsonIgnore
    public boolean getWFStepDataNameDirtyFlag(){
        return wFStepDataNameDirtyFlag ;
    }

    /**
     * 获取 [WFSTEPNAME]
     */
    @JsonProperty("wfstepname")
    public String getWFStepName(){
        return wFStepName ;
    }

    /**
     * 设置 [WFSTEPNAME]
     */
    @JsonProperty("wfstepname")
    public void setWFStepName(String  wFStepName){
        this.wFStepName = wFStepName ;
        this.wFStepNameDirtyFlag = true ;
    }

    /**
     * 获取 [WFSTEPNAME]脏标记
     */
    @JsonIgnore
    public boolean getWFStepNameDirtyFlag(){
        return wFStepNameDirtyFlag ;
    }

    /**
     * 获取 [WFSTEPID]
     */
    @JsonProperty("wfstepid")
    public String getWFStepId(){
        return wFStepId ;
    }

    /**
     * 设置 [WFSTEPID]
     */
    @JsonProperty("wfstepid")
    public void setWFStepId(String  wFStepId){
        this.wFStepId = wFStepId ;
        this.wFStepIdDirtyFlag = true ;
    }

    /**
     * 获取 [WFSTEPID]脏标记
     */
    @JsonIgnore
    public boolean getWFStepIdDirtyFlag(){
        return wFStepIdDirtyFlag ;
    }

    /**
     * 获取 [WFINSTANCEID]
     */
    @JsonProperty("wfinstanceid")
    public String getWFInstanceId(){
        return wFInstanceId ;
    }

    /**
     * 设置 [WFINSTANCEID]
     */
    @JsonProperty("wfinstanceid")
    public void setWFInstanceId(String  wFInstanceId){
        this.wFInstanceId = wFInstanceId ;
        this.wFInstanceIdDirtyFlag = true ;
    }

    /**
     * 获取 [WFINSTANCEID]脏标记
     */
    @JsonIgnore
    public boolean getWFInstanceIdDirtyFlag(){
        return wFInstanceIdDirtyFlag ;
    }

    /**
     * 获取 [WFIAACTIONID]
     */
    @JsonProperty("wfiaactionid")
    public String getWFIAActionId(){
        return wFIAActionId ;
    }

    /**
     * 设置 [WFIAACTIONID]
     */
    @JsonProperty("wfiaactionid")
    public void setWFIAActionId(String  wFIAActionId){
        this.wFIAActionId = wFIAActionId ;
        this.wFIAActionIdDirtyFlag = true ;
    }

    /**
     * 获取 [WFIAACTIONID]脏标记
     */
    @JsonIgnore
    public boolean getWFIAActionIdDirtyFlag(){
        return wFIAActionIdDirtyFlag ;
    }



    public WFStepData toDO() {
        WFStepData srfdomain = new WFStepData();
        if(getWFStepDataIdDirtyFlag())
            srfdomain.setWFStepDataId(wFStepDataId);
        if(getActionPersonDirtyFlag())
            srfdomain.setActionPerson(actionPerson);
        if(getActionInfoDirtyFlag())
            srfdomain.setActionInfo(actionInfo);
        if(getMajorInstIdDirtyFlag())
            srfdomain.setMajorInstId(majorInstId);
        if(getActionTimeDirtyFlag())
            srfdomain.setActionTime(actionTime);
        if(getCreateManDirtyFlag())
            srfdomain.setCreateMan(createMan);
        if(getUpdateDateDirtyFlag())
            srfdomain.setUpdateDate(updateDate);
        if(getActionDirtyFlag())
            srfdomain.setAction(action);
        if(getCreateDateDirtyFlag())
            srfdomain.setCreateDate(createDate);
        if(getParentInstIdDirtyFlag())
            srfdomain.setParentInstId(parentInstId);
        if(getUpdateManDirtyFlag())
            srfdomain.setUpdateMan(updateMan);
        if(getWFStepDataNameDirtyFlag())
            srfdomain.setWFStepDataName(wFStepDataName);
        if(getWFStepNameDirtyFlag())
            srfdomain.setWFStepName(wFStepName);
        if(getWFStepIdDirtyFlag())
            srfdomain.setWFStepId(wFStepId);
        if(getWFInstanceIdDirtyFlag())
            srfdomain.setWFInstanceId(wFInstanceId);
        if(getWFIAActionIdDirtyFlag())
            srfdomain.setWFIAActionId(wFIAActionId);

        return srfdomain;
    }

    public void fromDO(WFStepData srfdomain) {
        if(srfdomain == null )
          return ;
        if(srfdomain.getWFStepDataIdDirtyFlag())
            this.setWFStepDataId(srfdomain.getWFStepDataId());
        if(srfdomain.getActionPersonDirtyFlag())
            this.setActionPerson(srfdomain.getActionPerson());
        if(srfdomain.getActionInfoDirtyFlag())
            this.setActionInfo(srfdomain.getActionInfo());
        if(srfdomain.getMajorInstIdDirtyFlag())
            this.setMajorInstId(srfdomain.getMajorInstId());
        if(srfdomain.getActionTimeDirtyFlag())
            this.setActionTime(srfdomain.getActionTime());
        if(srfdomain.getCreateManDirtyFlag())
            this.setCreateMan(srfdomain.getCreateMan());
        if(srfdomain.getUpdateDateDirtyFlag())
            this.setUpdateDate(srfdomain.getUpdateDate());
        if(srfdomain.getActionDirtyFlag())
            this.setAction(srfdomain.getAction());
        if(srfdomain.getCreateDateDirtyFlag())
            this.setCreateDate(srfdomain.getCreateDate());
        if(srfdomain.getParentInstIdDirtyFlag())
            this.setParentInstId(srfdomain.getParentInstId());
        if(srfdomain.getUpdateManDirtyFlag())
            this.setUpdateMan(srfdomain.getUpdateMan());
        if(srfdomain.getWFStepDataNameDirtyFlag())
            this.setWFStepDataName(srfdomain.getWFStepDataName());
        if(srfdomain.getWFStepNameDirtyFlag())
            this.setWFStepName(srfdomain.getWFStepName());
        if(srfdomain.getWFStepIdDirtyFlag())
            this.setWFStepId(srfdomain.getWFStepId());
        if(srfdomain.getWFInstanceIdDirtyFlag())
            this.setWFInstanceId(srfdomain.getWFInstanceId());
        if(srfdomain.getWFIAActionIdDirtyFlag())
            this.setWFIAActionId(srfdomain.getWFIAActionId());

    }

    public List<WFStepDataDTO> fromDOPage(List<WFStepData> poPage)   {
        if(poPage == null)
            return null;
        List<WFStepDataDTO> dtos=new ArrayList<WFStepDataDTO>();
        for(WFStepData domain : poPage) {
            WFStepDataDTO dto = new WFStepDataDTO();
            dto.fromDO(domain);
            dtos.add(dto);
        }
        return dtos;
    }
}

