package cn.ibizlab.r7.runtime.wf.service.uniwfinternalservice.dto;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.math.BigInteger;
import java.util.Map;
import java.util.HashMap;
import java.io.Serializable;
import java.math.BigDecimal;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.valuerule.anno.wfworklist.*;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFWorklist;
import org.springframework.cglib.beans.BeanCopier;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * 服务DTO对象[WFWorklistDTO]
 */
public class WFWorklistDTO implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 属性 [INITIATOR]
     *
     */
    @WFWorklistInitiatorDefault(info = "默认规则")
    private String initiator;

    @JsonIgnore
    private boolean initiatorDirtyFlag;

    /**
     * 属性 [WORKDATE]
     *
     */
    @WFWorklistWorkDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp workDate;

    @JsonIgnore
    private boolean workDateDirtyFlag;

    /**
     * 属性 [ISCLOSED]
     *
     */
    @WFWorklistIsclosedDefault(info = "默认规则")
    private Integer isclosed;

    @JsonIgnore
    private boolean isclosedDirtyFlag;

    /**
     * 属性 [UPDATEDATE]
     *
     */
    @WFWorklistUpdateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp updateDate;

    @JsonIgnore
    private boolean updateDateDirtyFlag;

    /**
     * 属性 [WFWORKLISTID]
     *
     */
    @WFWorklistWFWorklistIdDefault(info = "默认规则")
    private String wFWorklistId;

    @JsonIgnore
    private boolean wFWorklistIdDirtyFlag;

    /**
     * 属性 [WORKLISTSTATE]
     *
     */
    @WFWorklistWorklistStateDefault(info = "默认规则")
    private String worklistState;

    @JsonIgnore
    private boolean worklistStateDirtyFlag;

    /**
     * 属性 [WORKINFO]
     *
     */
    @WFWorklistWorkInfoDefault(info = "默认规则")
    private String workInfo;

    @JsonIgnore
    private boolean workInfoDirtyFlag;

    /**
     * 属性 [WFWORKLISTNAME]
     *
     */
    @WFWorklistWFWorklistNameDefault(info = "默认规则")
    private String wFWorklistName;

    @JsonIgnore
    private boolean wFWorklistNameDirtyFlag;

    /**
     * 属性 [ISREAD]
     *
     */
    @WFWorklistIsreadDefault(info = "默认规则")
    private Integer isread;

    @JsonIgnore
    private boolean isreadDirtyFlag;

    /**
     * 属性 [LOGICNAME]
     *
     */
    @WFWorklistLogicNameDefault(info = "默认规则")
    private String logicName;

    @JsonIgnore
    private boolean logicNameDirtyFlag;

    /**
     * 属性 [MEMO]
     *
     */
    @WFWorklistMemoDefault(info = "默认规则")
    private String memo;

    @JsonIgnore
    private boolean memoDirtyFlag;

    /**
     * 属性 [VIEWURL]
     *
     */
    @WFWorklistViewUrlDefault(info = "默认规则")
    private String viewUrl;

    @JsonIgnore
    private boolean viewUrlDirtyFlag;

    /**
     * 属性 [CREATEDATE]
     *
     */
    @WFWorklistCreateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp createDate;

    @JsonIgnore
    private boolean createDateDirtyFlag;

    /**
     * 属性 [WFMODULEID]
     *
     */
    @WFWorklistWFModuleIdDefault(info = "默认规则")
    private String wFModuleId;

    @JsonIgnore
    private boolean wFModuleIdDirtyFlag;

    /**
     * 属性 [FINISHDATE]
     *
     */
    @WFWorklistFinishDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp finishDate;

    @JsonIgnore
    private boolean finishDateDirtyFlag;

    /**
     * 属性 [DONE]
     *
     */
    @WFWorklistDoneDefault(info = "默认规则")
    private Integer done;

    @JsonIgnore
    private boolean doneDirtyFlag;

    /**
     * 属性 [UPDATEMAN]
     *
     */
    @WFWorklistUpdateManDefault(info = "默认规则")
    private String updateMan;

    @JsonIgnore
    private boolean updateManDirtyFlag;

    /**
     * 属性 [URGENCY]
     *
     */
    @WFWorklistUrgencyDefault(info = "默认规则")
    private String urgency;

    @JsonIgnore
    private boolean urgencyDirtyFlag;

    /**
     * 属性 [CREATEMAN]
     *
     */
    @WFWorklistCreateManDefault(info = "默认规则")
    private String createMan;

    @JsonIgnore
    private boolean createManDirtyFlag;

    /**
     * 属性 [WFSTEP]
     *
     */
    @WFWorklistWFStepDefault(info = "默认规则")
    private String wFStep;

    @JsonIgnore
    private boolean wFStepDirtyFlag;

    /**
     * 属性 [WFDATAID]
     *
     */
    @WFWorklistWFDataIdDefault(info = "默认规则")
    private String wFDataId;

    @JsonIgnore
    private boolean wFDataIdDirtyFlag;

    /**
     * 属性 [WFENGINEWORKLISTID]
     *
     */
    @WFWorklistWfengineworklistidDefault(info = "默认规则")
    private String wfengineworklistid;

    @JsonIgnore
    private boolean wfengineworklistidDirtyFlag;

    /**
     * 属性 [ORGDEPTNAME]
     *
     */
    @WFWorklistOrgDeptNameDefault(info = "默认规则")
    private String orgDeptName;

    @JsonIgnore
    private boolean orgDeptNameDirtyFlag;

    /**
     * 属性 [WFUSERID]
     *
     */
    @WFWorklistWFUserIdDefault(info = "默认规则")
    private String wFUserId;

    @JsonIgnore
    private boolean wFUserIdDirtyFlag;

    /**
     * 属性 [PSWFROLEID]
     *
     */
    @WFWorklistPSWFRoleIdDefault(info = "默认规则")
    private String pSWFRoleId;

    @JsonIgnore
    private boolean pSWFRoleIdDirtyFlag;

    /**
     * 属性 [ORGDEPTID]
     *
     */
    @WFWorklistOrgDeptIdDefault(info = "默认规则")
    private String orgDeptId;

    @JsonIgnore
    private boolean orgDeptIdDirtyFlag;

    /**
     * 属性 [ORGDEPTUSERID]
     *
     */
    @WFWorklistOrgDeptUserIdDefault(info = "默认规则")
    private String orgDeptUserId;

    @JsonIgnore
    private boolean orgDeptUserIdDirtyFlag;

    /**
     * 属性 [WFINSTANCEID]
     *
     */
    @WFWorklistWFInstanceIdDefault(info = "默认规则")
    private String wFInstanceId;

    @JsonIgnore
    private boolean wFInstanceIdDirtyFlag;

    /**
     * 属性 [ORGID]
     *
     */
    @WFWorklistOrgIdDefault(info = "默认规则")
    private String orgId;

    @JsonIgnore
    private boolean orgIdDirtyFlag;


    /**
     * 获取 [INITIATOR]
     */
    @JsonProperty("initiator")
    public String getInitiator(){
        return initiator ;
    }

    /**
     * 设置 [INITIATOR]
     */
    @JsonProperty("initiator")
    public void setInitiator(String  initiator){
        this.initiator = initiator ;
        this.initiatorDirtyFlag = true ;
    }

    /**
     * 获取 [INITIATOR]脏标记
     */
    @JsonIgnore
    public boolean getInitiatorDirtyFlag(){
        return initiatorDirtyFlag ;
    }

    /**
     * 获取 [WORKDATE]
     */
    @JsonProperty("workdate")
    public Timestamp getWorkDate(){
        return workDate ;
    }

    /**
     * 设置 [WORKDATE]
     */
    @JsonProperty("workdate")
    public void setWorkDate(Timestamp  workDate){
        this.workDate = workDate ;
        this.workDateDirtyFlag = true ;
    }

    /**
     * 获取 [WORKDATE]脏标记
     */
    @JsonIgnore
    public boolean getWorkDateDirtyFlag(){
        return workDateDirtyFlag ;
    }

    /**
     * 获取 [ISCLOSED]
     */
    @JsonProperty("isclosed")
    public Integer getIsclosed(){
        return isclosed ;
    }

    /**
     * 设置 [ISCLOSED]
     */
    @JsonProperty("isclosed")
    public void setIsclosed(Integer  isclosed){
        this.isclosed = isclosed ;
        this.isclosedDirtyFlag = true ;
    }

    /**
     * 获取 [ISCLOSED]脏标记
     */
    @JsonIgnore
    public boolean getIsclosedDirtyFlag(){
        return isclosedDirtyFlag ;
    }

    /**
     * 获取 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public Timestamp getUpdateDate(){
        return updateDate ;
    }

    /**
     * 设置 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return updateDateDirtyFlag ;
    }

    /**
     * 获取 [WFWORKLISTID]
     */
    @JsonProperty("wfworklistid")
    public String getWFWorklistId(){
        return wFWorklistId ;
    }

    /**
     * 设置 [WFWORKLISTID]
     */
    @JsonProperty("wfworklistid")
    public void setWFWorklistId(String  wFWorklistId){
        this.wFWorklistId = wFWorklistId ;
        this.wFWorklistIdDirtyFlag = true ;
    }

    /**
     * 获取 [WFWORKLISTID]脏标记
     */
    @JsonIgnore
    public boolean getWFWorklistIdDirtyFlag(){
        return wFWorklistIdDirtyFlag ;
    }

    /**
     * 获取 [WORKLISTSTATE]
     */
    @JsonProperty("workliststate")
    public String getWorklistState(){
        return worklistState ;
    }

    /**
     * 设置 [WORKLISTSTATE]
     */
    @JsonProperty("workliststate")
    public void setWorklistState(String  worklistState){
        this.worklistState = worklistState ;
        this.worklistStateDirtyFlag = true ;
    }

    /**
     * 获取 [WORKLISTSTATE]脏标记
     */
    @JsonIgnore
    public boolean getWorklistStateDirtyFlag(){
        return worklistStateDirtyFlag ;
    }

    /**
     * 获取 [WORKINFO]
     */
    @JsonProperty("workinfo")
    public String getWorkInfo(){
        return workInfo ;
    }

    /**
     * 设置 [WORKINFO]
     */
    @JsonProperty("workinfo")
    public void setWorkInfo(String  workInfo){
        this.workInfo = workInfo ;
        this.workInfoDirtyFlag = true ;
    }

    /**
     * 获取 [WORKINFO]脏标记
     */
    @JsonIgnore
    public boolean getWorkInfoDirtyFlag(){
        return workInfoDirtyFlag ;
    }

    /**
     * 获取 [WFWORKLISTNAME]
     */
    @JsonProperty("wfworklistname")
    public String getWFWorklistName(){
        return wFWorklistName ;
    }

    /**
     * 设置 [WFWORKLISTNAME]
     */
    @JsonProperty("wfworklistname")
    public void setWFWorklistName(String  wFWorklistName){
        this.wFWorklistName = wFWorklistName ;
        this.wFWorklistNameDirtyFlag = true ;
    }

    /**
     * 获取 [WFWORKLISTNAME]脏标记
     */
    @JsonIgnore
    public boolean getWFWorklistNameDirtyFlag(){
        return wFWorklistNameDirtyFlag ;
    }

    /**
     * 获取 [ISREAD]
     */
    @JsonProperty("isread")
    public Integer getIsread(){
        return isread ;
    }

    /**
     * 设置 [ISREAD]
     */
    @JsonProperty("isread")
    public void setIsread(Integer  isread){
        this.isread = isread ;
        this.isreadDirtyFlag = true ;
    }

    /**
     * 获取 [ISREAD]脏标记
     */
    @JsonIgnore
    public boolean getIsreadDirtyFlag(){
        return isreadDirtyFlag ;
    }

    /**
     * 获取 [LOGICNAME]
     */
    @JsonProperty("logicname")
    public String getLogicName(){
        return logicName ;
    }

    /**
     * 设置 [LOGICNAME]
     */
    @JsonProperty("logicname")
    public void setLogicName(String  logicName){
        this.logicName = logicName ;
        this.logicNameDirtyFlag = true ;
    }

    /**
     * 获取 [LOGICNAME]脏标记
     */
    @JsonIgnore
    public boolean getLogicNameDirtyFlag(){
        return logicNameDirtyFlag ;
    }

    /**
     * 获取 [MEMO]
     */
    @JsonProperty("memo")
    public String getMemo(){
        return memo ;
    }

    /**
     * 设置 [MEMO]
     */
    @JsonProperty("memo")
    public void setMemo(String  memo){
        this.memo = memo ;
        this.memoDirtyFlag = true ;
    }

    /**
     * 获取 [MEMO]脏标记
     */
    @JsonIgnore
    public boolean getMemoDirtyFlag(){
        return memoDirtyFlag ;
    }

    /**
     * 获取 [VIEWURL]
     */
    @JsonProperty("viewurl")
    public String getViewUrl(){
        return viewUrl ;
    }

    /**
     * 设置 [VIEWURL]
     */
    @JsonProperty("viewurl")
    public void setViewUrl(String  viewUrl){
        this.viewUrl = viewUrl ;
        this.viewUrlDirtyFlag = true ;
    }

    /**
     * 获取 [VIEWURL]脏标记
     */
    @JsonIgnore
    public boolean getViewUrlDirtyFlag(){
        return viewUrlDirtyFlag ;
    }

    /**
     * 获取 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public Timestamp getCreateDate(){
        return createDate ;
    }

    /**
     * 设置 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return createDateDirtyFlag ;
    }

    /**
     * 获取 [WFMODULEID]
     */
    @JsonProperty("wfmoduleid")
    public String getWFModuleId(){
        return wFModuleId ;
    }

    /**
     * 设置 [WFMODULEID]
     */
    @JsonProperty("wfmoduleid")
    public void setWFModuleId(String  wFModuleId){
        this.wFModuleId = wFModuleId ;
        this.wFModuleIdDirtyFlag = true ;
    }

    /**
     * 获取 [WFMODULEID]脏标记
     */
    @JsonIgnore
    public boolean getWFModuleIdDirtyFlag(){
        return wFModuleIdDirtyFlag ;
    }

    /**
     * 获取 [FINISHDATE]
     */
    @JsonProperty("finishdate")
    public Timestamp getFinishDate(){
        return finishDate ;
    }

    /**
     * 设置 [FINISHDATE]
     */
    @JsonProperty("finishdate")
    public void setFinishDate(Timestamp  finishDate){
        this.finishDate = finishDate ;
        this.finishDateDirtyFlag = true ;
    }

    /**
     * 获取 [FINISHDATE]脏标记
     */
    @JsonIgnore
    public boolean getFinishDateDirtyFlag(){
        return finishDateDirtyFlag ;
    }

    /**
     * 获取 [DONE]
     */
    @JsonProperty("done")
    public Integer getDone(){
        return done ;
    }

    /**
     * 设置 [DONE]
     */
    @JsonProperty("done")
    public void setDone(Integer  done){
        this.done = done ;
        this.doneDirtyFlag = true ;
    }

    /**
     * 获取 [DONE]脏标记
     */
    @JsonIgnore
    public boolean getDoneDirtyFlag(){
        return doneDirtyFlag ;
    }

    /**
     * 获取 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public String getUpdateMan(){
        return updateMan ;
    }

    /**
     * 设置 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return updateManDirtyFlag ;
    }

    /**
     * 获取 [URGENCY]
     */
    @JsonProperty("urgency")
    public String getUrgency(){
        return urgency ;
    }

    /**
     * 设置 [URGENCY]
     */
    @JsonProperty("urgency")
    public void setUrgency(String  urgency){
        this.urgency = urgency ;
        this.urgencyDirtyFlag = true ;
    }

    /**
     * 获取 [URGENCY]脏标记
     */
    @JsonIgnore
    public boolean getUrgencyDirtyFlag(){
        return urgencyDirtyFlag ;
    }

    /**
     * 获取 [CREATEMAN]
     */
    @JsonProperty("createman")
    public String getCreateMan(){
        return createMan ;
    }

    /**
     * 设置 [CREATEMAN]
     */
    @JsonProperty("createman")
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return createManDirtyFlag ;
    }

    /**
     * 获取 [WFSTEP]
     */
    @JsonProperty("wfstep")
    public String getWFStep(){
        return wFStep ;
    }

    /**
     * 设置 [WFSTEP]
     */
    @JsonProperty("wfstep")
    public void setWFStep(String  wFStep){
        this.wFStep = wFStep ;
        this.wFStepDirtyFlag = true ;
    }

    /**
     * 获取 [WFSTEP]脏标记
     */
    @JsonIgnore
    public boolean getWFStepDirtyFlag(){
        return wFStepDirtyFlag ;
    }

    /**
     * 获取 [WFDATAID]
     */
    @JsonProperty("wfdataid")
    public String getWFDataId(){
        return wFDataId ;
    }

    /**
     * 设置 [WFDATAID]
     */
    @JsonProperty("wfdataid")
    public void setWFDataId(String  wFDataId){
        this.wFDataId = wFDataId ;
        this.wFDataIdDirtyFlag = true ;
    }

    /**
     * 获取 [WFDATAID]脏标记
     */
    @JsonIgnore
    public boolean getWFDataIdDirtyFlag(){
        return wFDataIdDirtyFlag ;
    }

    /**
     * 获取 [WFENGINEWORKLISTID]
     */
    @JsonProperty("wfengineworklistid")
    public String getWfengineworklistid(){
        return wfengineworklistid ;
    }

    /**
     * 设置 [WFENGINEWORKLISTID]
     */
    @JsonProperty("wfengineworklistid")
    public void setWfengineworklistid(String  wfengineworklistid){
        this.wfengineworklistid = wfengineworklistid ;
        this.wfengineworklistidDirtyFlag = true ;
    }

    /**
     * 获取 [WFENGINEWORKLISTID]脏标记
     */
    @JsonIgnore
    public boolean getWfengineworklistidDirtyFlag(){
        return wfengineworklistidDirtyFlag ;
    }

    /**
     * 获取 [ORGDEPTNAME]
     */
    @JsonProperty("orgdeptname")
    public String getOrgDeptName(){
        return orgDeptName ;
    }

    /**
     * 设置 [ORGDEPTNAME]
     */
    @JsonProperty("orgdeptname")
    public void setOrgDeptName(String  orgDeptName){
        this.orgDeptName = orgDeptName ;
        this.orgDeptNameDirtyFlag = true ;
    }

    /**
     * 获取 [ORGDEPTNAME]脏标记
     */
    @JsonIgnore
    public boolean getOrgDeptNameDirtyFlag(){
        return orgDeptNameDirtyFlag ;
    }

    /**
     * 获取 [WFUSERID]
     */
    @JsonProperty("wfuserid")
    public String getWFUserId(){
        return wFUserId ;
    }

    /**
     * 设置 [WFUSERID]
     */
    @JsonProperty("wfuserid")
    public void setWFUserId(String  wFUserId){
        this.wFUserId = wFUserId ;
        this.wFUserIdDirtyFlag = true ;
    }

    /**
     * 获取 [WFUSERID]脏标记
     */
    @JsonIgnore
    public boolean getWFUserIdDirtyFlag(){
        return wFUserIdDirtyFlag ;
    }

    /**
     * 获取 [PSWFROLEID]
     */
    @JsonProperty("pswfroleid")
    public String getPSWFRoleId(){
        return pSWFRoleId ;
    }

    /**
     * 设置 [PSWFROLEID]
     */
    @JsonProperty("pswfroleid")
    public void setPSWFRoleId(String  pSWFRoleId){
        this.pSWFRoleId = pSWFRoleId ;
        this.pSWFRoleIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSWFROLEID]脏标记
     */
    @JsonIgnore
    public boolean getPSWFRoleIdDirtyFlag(){
        return pSWFRoleIdDirtyFlag ;
    }

    /**
     * 获取 [ORGDEPTID]
     */
    @JsonProperty("orgdeptid")
    public String getOrgDeptId(){
        return orgDeptId ;
    }

    /**
     * 设置 [ORGDEPTID]
     */
    @JsonProperty("orgdeptid")
    public void setOrgDeptId(String  orgDeptId){
        this.orgDeptId = orgDeptId ;
        this.orgDeptIdDirtyFlag = true ;
    }

    /**
     * 获取 [ORGDEPTID]脏标记
     */
    @JsonIgnore
    public boolean getOrgDeptIdDirtyFlag(){
        return orgDeptIdDirtyFlag ;
    }

    /**
     * 获取 [ORGDEPTUSERID]
     */
    @JsonProperty("orgdeptuserid")
    public String getOrgDeptUserId(){
        return orgDeptUserId ;
    }

    /**
     * 设置 [ORGDEPTUSERID]
     */
    @JsonProperty("orgdeptuserid")
    public void setOrgDeptUserId(String  orgDeptUserId){
        this.orgDeptUserId = orgDeptUserId ;
        this.orgDeptUserIdDirtyFlag = true ;
    }

    /**
     * 获取 [ORGDEPTUSERID]脏标记
     */
    @JsonIgnore
    public boolean getOrgDeptUserIdDirtyFlag(){
        return orgDeptUserIdDirtyFlag ;
    }

    /**
     * 获取 [WFINSTANCEID]
     */
    @JsonProperty("wfinstanceid")
    public String getWFInstanceId(){
        return wFInstanceId ;
    }

    /**
     * 设置 [WFINSTANCEID]
     */
    @JsonProperty("wfinstanceid")
    public void setWFInstanceId(String  wFInstanceId){
        this.wFInstanceId = wFInstanceId ;
        this.wFInstanceIdDirtyFlag = true ;
    }

    /**
     * 获取 [WFINSTANCEID]脏标记
     */
    @JsonIgnore
    public boolean getWFInstanceIdDirtyFlag(){
        return wFInstanceIdDirtyFlag ;
    }

    /**
     * 获取 [ORGID]
     */
    @JsonProperty("orgid")
    public String getOrgId(){
        return orgId ;
    }

    /**
     * 设置 [ORGID]
     */
    @JsonProperty("orgid")
    public void setOrgId(String  orgId){
        this.orgId = orgId ;
        this.orgIdDirtyFlag = true ;
    }

    /**
     * 获取 [ORGID]脏标记
     */
    @JsonIgnore
    public boolean getOrgIdDirtyFlag(){
        return orgIdDirtyFlag ;
    }



    public WFWorklist toDO() {
        WFWorklist srfdomain = new WFWorklist();
        if(getInitiatorDirtyFlag())
            srfdomain.setInitiator(initiator);
        if(getWorkDateDirtyFlag())
            srfdomain.setWorkDate(workDate);
        if(getIsclosedDirtyFlag())
            srfdomain.setIsclosed(isclosed);
        if(getUpdateDateDirtyFlag())
            srfdomain.setUpdateDate(updateDate);
        if(getWFWorklistIdDirtyFlag())
            srfdomain.setWFWorklistId(wFWorklistId);
        if(getWorklistStateDirtyFlag())
            srfdomain.setWorklistState(worklistState);
        if(getWorkInfoDirtyFlag())
            srfdomain.setWorkInfo(workInfo);
        if(getWFWorklistNameDirtyFlag())
            srfdomain.setWFWorklistName(wFWorklistName);
        if(getIsreadDirtyFlag())
            srfdomain.setIsread(isread);
        if(getLogicNameDirtyFlag())
            srfdomain.setLogicName(logicName);
        if(getMemoDirtyFlag())
            srfdomain.setMemo(memo);
        if(getViewUrlDirtyFlag())
            srfdomain.setViewUrl(viewUrl);
        if(getCreateDateDirtyFlag())
            srfdomain.setCreateDate(createDate);
        if(getWFModuleIdDirtyFlag())
            srfdomain.setWFModuleId(wFModuleId);
        if(getFinishDateDirtyFlag())
            srfdomain.setFinishDate(finishDate);
        if(getDoneDirtyFlag())
            srfdomain.setDone(done);
        if(getUpdateManDirtyFlag())
            srfdomain.setUpdateMan(updateMan);
        if(getUrgencyDirtyFlag())
            srfdomain.setUrgency(urgency);
        if(getCreateManDirtyFlag())
            srfdomain.setCreateMan(createMan);
        if(getWFStepDirtyFlag())
            srfdomain.setWFStep(wFStep);
        if(getWFDataIdDirtyFlag())
            srfdomain.setWFDataId(wFDataId);
        if(getWfengineworklistidDirtyFlag())
            srfdomain.setWfengineworklistid(wfengineworklistid);
        if(getOrgDeptNameDirtyFlag())
            srfdomain.setOrgDeptName(orgDeptName);
        if(getWFUserIdDirtyFlag())
            srfdomain.setWFUserId(wFUserId);
        if(getPSWFRoleIdDirtyFlag())
            srfdomain.setPSWFRoleId(pSWFRoleId);
        if(getOrgDeptIdDirtyFlag())
            srfdomain.setOrgDeptId(orgDeptId);
        if(getOrgDeptUserIdDirtyFlag())
            srfdomain.setOrgDeptUserId(orgDeptUserId);
        if(getWFInstanceIdDirtyFlag())
            srfdomain.setWFInstanceId(wFInstanceId);
        if(getOrgIdDirtyFlag())
            srfdomain.setOrgId(orgId);

        return srfdomain;
    }

    public void fromDO(WFWorklist srfdomain) {
        if(srfdomain == null )
          return ;
        if(srfdomain.getInitiatorDirtyFlag())
            this.setInitiator(srfdomain.getInitiator());
        if(srfdomain.getWorkDateDirtyFlag())
            this.setWorkDate(srfdomain.getWorkDate());
        if(srfdomain.getIsclosedDirtyFlag())
            this.setIsclosed(srfdomain.getIsclosed());
        if(srfdomain.getUpdateDateDirtyFlag())
            this.setUpdateDate(srfdomain.getUpdateDate());
        if(srfdomain.getWFWorklistIdDirtyFlag())
            this.setWFWorklistId(srfdomain.getWFWorklistId());
        if(srfdomain.getWorklistStateDirtyFlag())
            this.setWorklistState(srfdomain.getWorklistState());
        if(srfdomain.getWorkInfoDirtyFlag())
            this.setWorkInfo(srfdomain.getWorkInfo());
        if(srfdomain.getWFWorklistNameDirtyFlag())
            this.setWFWorklistName(srfdomain.getWFWorklistName());
        if(srfdomain.getIsreadDirtyFlag())
            this.setIsread(srfdomain.getIsread());
        if(srfdomain.getLogicNameDirtyFlag())
            this.setLogicName(srfdomain.getLogicName());
        if(srfdomain.getMemoDirtyFlag())
            this.setMemo(srfdomain.getMemo());
        if(srfdomain.getViewUrlDirtyFlag())
            this.setViewUrl(srfdomain.getViewUrl());
        if(srfdomain.getCreateDateDirtyFlag())
            this.setCreateDate(srfdomain.getCreateDate());
        if(srfdomain.getWFModuleIdDirtyFlag())
            this.setWFModuleId(srfdomain.getWFModuleId());
        if(srfdomain.getFinishDateDirtyFlag())
            this.setFinishDate(srfdomain.getFinishDate());
        if(srfdomain.getDoneDirtyFlag())
            this.setDone(srfdomain.getDone());
        if(srfdomain.getUpdateManDirtyFlag())
            this.setUpdateMan(srfdomain.getUpdateMan());
        if(srfdomain.getUrgencyDirtyFlag())
            this.setUrgency(srfdomain.getUrgency());
        if(srfdomain.getCreateManDirtyFlag())
            this.setCreateMan(srfdomain.getCreateMan());
        if(srfdomain.getWFStepDirtyFlag())
            this.setWFStep(srfdomain.getWFStep());
        if(srfdomain.getWFDataIdDirtyFlag())
            this.setWFDataId(srfdomain.getWFDataId());
        if(srfdomain.getWfengineworklistidDirtyFlag())
            this.setWfengineworklistid(srfdomain.getWfengineworklistid());
        if(srfdomain.getOrgDeptNameDirtyFlag())
            this.setOrgDeptName(srfdomain.getOrgDeptName());
        if(srfdomain.getWFUserIdDirtyFlag())
            this.setWFUserId(srfdomain.getWFUserId());
        if(srfdomain.getPSWFRoleIdDirtyFlag())
            this.setPSWFRoleId(srfdomain.getPSWFRoleId());
        if(srfdomain.getOrgDeptIdDirtyFlag())
            this.setOrgDeptId(srfdomain.getOrgDeptId());
        if(srfdomain.getOrgDeptUserIdDirtyFlag())
            this.setOrgDeptUserId(srfdomain.getOrgDeptUserId());
        if(srfdomain.getWFInstanceIdDirtyFlag())
            this.setWFInstanceId(srfdomain.getWFInstanceId());
        if(srfdomain.getOrgIdDirtyFlag())
            this.setOrgId(srfdomain.getOrgId());

    }

    public List<WFWorklistDTO> fromDOPage(List<WFWorklist> poPage)   {
        if(poPage == null)
            return null;
        List<WFWorklistDTO> dtos=new ArrayList<WFWorklistDTO>();
        for(WFWorklist domain : poPage) {
            WFWorklistDTO dto = new WFWorklistDTO();
            dto.fromDO(domain);
            dtos.add(dto);
        }
        return dtos;
    }
}

