package cn.ibizlab.r7.runtime.wf.service.uniwfinternalservice.resource;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import javax.servlet.ServletRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.http.HttpStatus;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.StringUtils;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiResponse;
import io.swagger.annotations.ApiResponses;

import com.alibaba.fastjson.JSONObject;
import org.springframework.data.domain.PageRequest;
import cn.ibizlab.r7.runtime.wf.service.uniwfinternalservice.dto.PSDEWFDTO;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSDEWF;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IPSDEWFService;
import cn.ibizlab.r7.runtime.wf.util.SearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSDEWFSearchContext;

@Api(tags = {"PSDEWF" })
@RestController
@RequestMapping("")
public class PSDEWFResource {

    @Autowired
    private IPSDEWFService psdewfService;

    public IPSDEWFService getPsdewfService() {
        return this.psdewfService;
    }

    @ApiOperation(value = "注册", tags = {"PSDEWF" },  notes = "注册")
	@RequestMapping(method = RequestMethod.POST, value = "/uniwfinternalservice/psdewfs/regist")
    @Transactional
    public ResponseEntity<List<PSDEWFDTO>> regist(@RequestBody List<PSDEWFDTO> psdewfdtos) {
        if (psdewfdtos == null) {
            return ResponseEntity.status(HttpStatus.OK).body(null);
        }
        List<PSDEWFDTO> psdewfdtos2 = new ArrayList<PSDEWFDTO>();
        for (PSDEWFDTO psdewfdto : psdewfdtos) {
            PSDEWF domain = psdewfdto.toDO();
            psdewfService.save(domain);
            psdewfdto.fromDO(domain);
            psdewfdtos2.add(psdewfdto);
        }

		return ResponseEntity.status(HttpStatus.OK).body(psdewfdtos2);
    }

	@ApiOperation(value = "获取DEFAULT", tags = {"PSDEWF" } ,notes = "获取DEFAULT")
    @RequestMapping(method= RequestMethod.GET , value="/uniwfinternalservice/psdewfs/fetchdefault")
	public ResponseEntity<Page<PSDEWFDTO>> fetchDefault(PSDEWFSearchContext context,Pageable pageable ,ServletRequest request) {
        context.setPageable(pageable);
        List<PSDEWFDTO> list = new ArrayList<PSDEWFDTO>();
        
        Page<PSDEWF> domains = psdewfService.searchDefault(context) ;
        for(PSDEWF psdewf : domains.getContent()){
            PSDEWFDTO dto = new PSDEWFDTO();
            dto.fromDO(psdewf);
            list.add(dto);
        }
	    return ResponseEntity.status(HttpStatus.OK).body(new PageImpl(list,context.getPageable(),domains.getTotalElements()));
	}


}
