package cn.ibizlab.r7.runtime.wf.service.uniwfinternalservice.resource;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import javax.servlet.ServletRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.http.HttpStatus;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.StringUtils;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiResponse;
import io.swagger.annotations.ApiResponses;

import com.alibaba.fastjson.JSONObject;
import org.springframework.data.domain.PageRequest;
import cn.ibizlab.r7.runtime.wf.service.uniwfinternalservice.dto.PSDataEntityDTO;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSDataEntity;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IPSDataEntityService;
import cn.ibizlab.r7.runtime.wf.util.SearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSDataEntitySearchContext;

@Api(tags = {"PSDataEntity" })
@RestController
@RequestMapping("")
public class PSDataEntityResource {

    @Autowired
    private IPSDataEntityService psdataentityService;

    public IPSDataEntityService getPsdataentityService() {
        return this.psdataentityService;
    }

    @ApiOperation(value = "注册", tags = {"PSDataEntity" },  notes = "注册")
	@RequestMapping(method = RequestMethod.POST, value = "/uniwfinternalservice/psdataentities/regist")
    @Transactional
    public ResponseEntity<List<PSDataEntityDTO>> regist(@RequestBody List<PSDataEntityDTO> psdataentitydtos) {
        if (psdataentitydtos == null) {
            return ResponseEntity.status(HttpStatus.OK).body(null);
        }
        List<PSDataEntityDTO> psdataentitydtos2 = new ArrayList<PSDataEntityDTO>();
        for (PSDataEntityDTO psdataentitydto : psdataentitydtos) {
            PSDataEntity domain = psdataentitydto.toDO();
            psdataentityService.save(domain);
            psdataentitydto.fromDO(domain);
            psdataentitydtos2.add(psdataentitydto);
        }

		return ResponseEntity.status(HttpStatus.OK).body(psdataentitydtos2);
    }


}
