package cn.ibizlab.r7.runtime.wf.service.uniwfinternalservice.resource;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import javax.servlet.ServletRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.http.HttpStatus;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.StringUtils;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiResponse;
import io.swagger.annotations.ApiResponses;

import com.alibaba.fastjson.JSONObject;
import org.springframework.data.domain.PageRequest;
import cn.ibizlab.r7.runtime.wf.service.uniwfinternalservice.dto.PSSystemDTO;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSSystem;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IPSSystemService;
import cn.ibizlab.r7.runtime.wf.util.SearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSSystemSearchContext;

@Api(tags = {"PSSystem" })
@RestController
@RequestMapping("")
public class PSSystemResource {

    @Autowired
    private IPSSystemService pssystemService;

    public IPSSystemService getPssystemService() {
        return this.pssystemService;
    }

    @ApiOperation(value = "注册", tags = {"PSSystem" },  notes = "注册")
	@RequestMapping(method = RequestMethod.POST, value = "/uniwfinternalservice/pssystems/regist")
    @Transactional
    public ResponseEntity<PSSystemDTO> regist(@RequestBody PSSystemDTO pssystemdto) {
        PSSystem domain = pssystemdto.toDO();
		pssystemService.save(domain);
        pssystemdto.fromDO(domain);
		return ResponseEntity.status(HttpStatus.OK).body(pssystemdto);
    }


}
