package cn.ibizlab.r7.runtime.wf.service.uniwfinternalservice.resource;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import javax.servlet.ServletRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.http.HttpStatus;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.StringUtils;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiResponse;
import io.swagger.annotations.ApiResponses;

import com.alibaba.fastjson.JSONObject;
import org.springframework.data.domain.PageRequest;
import cn.ibizlab.r7.runtime.wf.service.uniwfinternalservice.dto.PSWFLinkDTO;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFLink;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IPSWFLinkService;
import cn.ibizlab.r7.runtime.wf.util.SearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSWFLinkSearchContext;

@Api(tags = {"PSWFLink" })
@RestController
@RequestMapping("")
public class PSWFLinkResource {

    @Autowired
    private IPSWFLinkService pswflinkService;

    public IPSWFLinkService getPswflinkService() {
        return this.pswflinkService;
    }

    @ApiOperation(value = "", tags = {"PSWFLink" },  notes = "")
	@RequestMapping(method = RequestMethod.POST, value = "/uniwfinternalservice/pswflinks/regist")
    @Transactional
    public ResponseEntity<List<PSWFLinkDTO>> regist(@RequestBody List<PSWFLinkDTO> pswflinkdtos) {
        if (pswflinkdtos == null) {
            return ResponseEntity.status(HttpStatus.OK).body(null);
        }
        List<PSWFLinkDTO> pswflinkdtos2 = new ArrayList<PSWFLinkDTO>();
        for (PSWFLinkDTO pswflinkdto : pswflinkdtos) {
            PSWFLink domain = pswflinkdto.toDO();
            pswflinkService.save(domain);
            pswflinkdto.fromDO(domain);
            pswflinkdtos2.add(pswflinkdto);
        }

		return ResponseEntity.status(HttpStatus.OK).body(pswflinkdtos2);
    }


}
