package cn.ibizlab.r7.runtime.wf.service.uniwfinternalservice.resource;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import javax.servlet.ServletRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.http.HttpStatus;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.StringUtils;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiResponse;
import io.swagger.annotations.ApiResponses;

import com.alibaba.fastjson.JSONObject;
import org.springframework.data.domain.PageRequest;
import cn.ibizlab.r7.runtime.wf.service.uniwfinternalservice.dto.PSWFPROCSUBWFDTO;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFPROCSUBWF;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IPSWFPROCSUBWFService;
import cn.ibizlab.r7.runtime.wf.util.SearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSWFPROCSUBWFSearchContext;

@Api(tags = {"PSWFPROCSUBWF" })
@RestController
@RequestMapping("")
public class PSWFPROCSUBWFResource {

    @Autowired
    private IPSWFPROCSUBWFService pswfprocsubwfService;

    public IPSWFPROCSUBWFService getPswfprocsubwfService() {
        return this.pswfprocsubwfService;
    }

    @ApiOperation(value = "注册", tags = {"PSWFPROCSUBWF" },  notes = "注册")
	@RequestMapping(method = RequestMethod.POST, value = "/uniwfinternalservice/pswfprocsubwfs/regist")
    @Transactional
    public ResponseEntity<List<PSWFPROCSUBWFDTO>> regist(@RequestBody List<PSWFPROCSUBWFDTO> pswfprocsubwfdtos) {
        if (pswfprocsubwfdtos == null) {
            return ResponseEntity.status(HttpStatus.OK).body(null);
        }
        List<PSWFPROCSUBWFDTO> pswfprocsubwfdtos2 = new ArrayList<PSWFPROCSUBWFDTO>();
        for (PSWFPROCSUBWFDTO pswfprocsubwfdto : pswfprocsubwfdtos) {
            PSWFPROCSUBWF domain = pswfprocsubwfdto.toDO();
            pswfprocsubwfService.save(domain);
            pswfprocsubwfdto.fromDO(domain);
            pswfprocsubwfdtos2.add(pswfprocsubwfdto);
        }

		return ResponseEntity.status(HttpStatus.OK).body(pswfprocsubwfdtos2);
    }

    @ApiOperation(value = "清空（通过流程处理标识）", tags = {"PSWFPROCSUBWF" },  notes = "清空（通过流程处理标识）")
	@RequestMapping(method = RequestMethod.POST, value = "/uniwfinternalservice/pswfprocsubwfs/clearbyproc")
    @Transactional
    public ResponseEntity<JSONObject> clearByProc(@RequestBody JSONObject data) {
        return ResponseEntity.status(HttpStatus.OK).body(data);
    }

	@ApiOperation(value = "获取DEFAULT", tags = {"PSWFPROCSUBWF" } ,notes = "获取DEFAULT")
    @RequestMapping(method= RequestMethod.GET , value="/uniwfinternalservice/pswfprocsubwfs/fetchdefault")
	public ResponseEntity<Page<PSWFPROCSUBWFDTO>> fetchDefault(PSWFPROCSUBWFSearchContext context,Pageable pageable ,ServletRequest request) {
        context.setPageable(pageable);
        List<PSWFPROCSUBWFDTO> list = new ArrayList<PSWFPROCSUBWFDTO>();
        
        Page<PSWFPROCSUBWF> domains = pswfprocsubwfService.searchDefault(context) ;
        for(PSWFPROCSUBWF pswfprocsubwf : domains.getContent()){
            PSWFPROCSUBWFDTO dto = new PSWFPROCSUBWFDTO();
            dto.fromDO(pswfprocsubwf);
            list.add(dto);
        }
	    return ResponseEntity.status(HttpStatus.OK).body(new PageImpl(list,context.getPageable(),domains.getTotalElements()));
	}


}
