package cn.ibizlab.r7.runtime.wf.service.uniwfinternalservice.resource;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import javax.servlet.ServletRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.http.HttpStatus;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.StringUtils;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiResponse;
import io.swagger.annotations.ApiResponses;

import com.alibaba.fastjson.JSONObject;
import org.springframework.data.domain.PageRequest;
import cn.ibizlab.r7.runtime.wf.service.uniwfinternalservice.dto.PSWFProcRoleDTO;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFProcRole;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IPSWFProcRoleService;
import cn.ibizlab.r7.runtime.wf.util.SearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSWFProcRoleSearchContext;

@Api(tags = {"PSWFProcRole" })
@RestController
@RequestMapping("")
public class PSWFProcRoleResource {

    @Autowired
    private IPSWFProcRoleService pswfprocroleService;

    public IPSWFProcRoleService getPswfprocroleService() {
        return this.pswfprocroleService;
    }

    @ApiOperation(value = "注册", tags = {"PSWFProcRole" },  notes = "注册")
	@RequestMapping(method = RequestMethod.POST, value = "/uniwfinternalservice/pswfprocroles/regist")
    @Transactional
    public ResponseEntity<List<PSWFProcRoleDTO>> regist(@RequestBody List<PSWFProcRoleDTO> pswfprocroledtos) {
        if (pswfprocroledtos == null) {
            return ResponseEntity.status(HttpStatus.OK).body(null);
        }
        List<PSWFProcRoleDTO> pswfprocroledtos2 = new ArrayList<PSWFProcRoleDTO>();
        for (PSWFProcRoleDTO pswfprocroledto : pswfprocroledtos) {
            PSWFProcRole domain = pswfprocroledto.toDO();
            pswfprocroleService.save(domain);
            pswfprocroledto.fromDO(domain);
            pswfprocroledtos2.add(pswfprocroledto);
        }

		return ResponseEntity.status(HttpStatus.OK).body(pswfprocroledtos2);
    }

    @ApiOperation(value = "清空（通过流程处理标识）", tags = {"PSWFProcRole" },  notes = "清空（通过流程处理标识）")
	@RequestMapping(method = RequestMethod.POST, value = "/uniwfinternalservice/pswfprocroles/clearbyproc")
    @Transactional
    public ResponseEntity<JSONObject> clearByProc(@RequestBody JSONObject data) {
        return ResponseEntity.status(HttpStatus.OK).body(data);
    }

	@ApiOperation(value = "获取DEFAULT", tags = {"PSWFProcRole" } ,notes = "获取DEFAULT")
    @RequestMapping(method= RequestMethod.GET , value="/uniwfinternalservice/pswfprocroles/fetchdefault")
	public ResponseEntity<Page<PSWFProcRoleDTO>> fetchDefault(PSWFProcRoleSearchContext context,Pageable pageable ,ServletRequest request) {
        context.setPageable(pageable);
        List<PSWFProcRoleDTO> list = new ArrayList<PSWFProcRoleDTO>();
        
        Page<PSWFProcRole> domains = pswfprocroleService.searchDefault(context) ;
        for(PSWFProcRole pswfprocrole : domains.getContent()){
            PSWFProcRoleDTO dto = new PSWFProcRoleDTO();
            dto.fromDO(pswfprocrole);
            list.add(dto);
        }
	    return ResponseEntity.status(HttpStatus.OK).body(new PageImpl(list,context.getPageable(),domains.getTotalElements()));
	}


}
