package cn.ibizlab.r7.runtime.wf.service.uniwfinternalservice.resource;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import javax.servlet.ServletRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.http.HttpStatus;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.StringUtils;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiResponse;
import io.swagger.annotations.ApiResponses;

import com.alibaba.fastjson.JSONObject;
import org.springframework.data.domain.PageRequest;
import cn.ibizlab.r7.runtime.wf.service.uniwfinternalservice.dto.PSWFProcessDTO;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFProcess;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IPSWFProcessService;
import cn.ibizlab.r7.runtime.wf.util.SearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSWFProcessSearchContext;

@Api(tags = {"PSWFProcess" })
@RestController
@RequestMapping("")
public class PSWFProcessResource {

    @Autowired
    private IPSWFProcessService pswfprocessService;

    public IPSWFProcessService getPswfprocessService() {
        return this.pswfprocessService;
    }

    @ApiOperation(value = "注册", tags = {"PSWFProcess" },  notes = "注册")
	@RequestMapping(method = RequestMethod.POST, value = "/uniwfinternalservice/pswfprocesses/regist")
    @Transactional
    public ResponseEntity<List<PSWFProcessDTO>> regist(@RequestBody List<PSWFProcessDTO> pswfprocessdtos) {
        if (pswfprocessdtos == null) {
            return ResponseEntity.status(HttpStatus.OK).body(null);
        }
        List<PSWFProcessDTO> pswfprocessdtos2 = new ArrayList<PSWFProcessDTO>();
        for (PSWFProcessDTO pswfprocessdto : pswfprocessdtos) {
            PSWFProcess domain = pswfprocessdto.toDO();
            pswfprocessService.save(domain);
            pswfprocessdto.fromDO(domain);
            pswfprocessdtos2.add(pswfprocessdto);
        }

		return ResponseEntity.status(HttpStatus.OK).body(pswfprocessdtos2);
    }


}
