package cn.ibizlab.r7.runtime.wf.service.uniwfinternalservice.resource;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import javax.servlet.ServletRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.http.HttpStatus;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.StringUtils;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiResponse;
import io.swagger.annotations.ApiResponses;

import com.alibaba.fastjson.JSONObject;
import org.springframework.data.domain.PageRequest;
import cn.ibizlab.r7.runtime.wf.service.uniwfinternalservice.dto.PSWFRoleDTO;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFRole;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IPSWFRoleService;
import cn.ibizlab.r7.runtime.wf.util.SearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSWFRoleSearchContext;

@Api(tags = {"PSWFRole" })
@RestController
@RequestMapping("")
public class PSWFRoleResource {

    @Autowired
    private IPSWFRoleService pswfroleService;

    public IPSWFRoleService getPswfroleService() {
        return this.pswfroleService;
    }

    @ApiOperation(value = "注册", tags = {"PSWFRole" },  notes = "注册")
	@RequestMapping(method = RequestMethod.POST, value = "/uniwfinternalservice/pswfroles/regist")
    @Transactional
    public ResponseEntity<List<PSWFRoleDTO>> regist(@RequestBody List<PSWFRoleDTO> pswfroledtos) {
        if (pswfroledtos == null) {
            return ResponseEntity.status(HttpStatus.OK).body(null);
        }
        List<PSWFRoleDTO> pswfroledtos2 = new ArrayList<PSWFRoleDTO>();
        for (PSWFRoleDTO pswfroledto : pswfroledtos) {
            PSWFRole domain = pswfroledto.toDO();
            pswfroleService.save(domain);
            pswfroledto.fromDO(domain);
            pswfroledtos2.add(pswfroledto);
        }

		return ResponseEntity.status(HttpStatus.OK).body(pswfroledtos2);
    }


}
