package cn.ibizlab.r7.runtime.wf.service.uniwfinternalservice.resource;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import javax.servlet.ServletRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.http.HttpStatus;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.StringUtils;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiResponse;
import io.swagger.annotations.ApiResponses;

import com.alibaba.fastjson.JSONObject;
import org.springframework.data.domain.PageRequest;
import cn.ibizlab.r7.runtime.wf.service.uniwfinternalservice.dto.PSWorkflowDTO;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWorkflow;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IPSWorkflowService;
import cn.ibizlab.r7.runtime.wf.util.SearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSWorkflowSearchContext;

@Api(tags = {"PSWorkflow" })
@RestController
@RequestMapping("")
public class PSWorkflowResource {

    @Autowired
    private IPSWorkflowService psworkflowService;

    public IPSWorkflowService getPsworkflowService() {
        return this.psworkflowService;
    }

    @ApiOperation(value = "注册", tags = {"PSWorkflow" },  notes = "注册")
	@RequestMapping(method = RequestMethod.POST, value = "/uniwfinternalservice/psworkflows/regist")
    @Transactional
    public ResponseEntity<List<PSWorkflowDTO>> regist(@RequestBody List<PSWorkflowDTO> psworkflowdtos) {
        if (psworkflowdtos == null) {
            return ResponseEntity.status(HttpStatus.OK).body(null);
        }
        List<PSWorkflowDTO> psworkflowdtos2 = new ArrayList<PSWorkflowDTO>();
        for (PSWorkflowDTO psworkflowdto : psworkflowdtos) {
            PSWorkflow domain = psworkflowdto.toDO();
            psworkflowService.save(domain);
            psworkflowdto.fromDO(domain);
            psworkflowdtos2.add(psworkflowdto);
        }

		return ResponseEntity.status(HttpStatus.OK).body(psworkflowdtos2);
    }


}
