package cn.ibizlab.r7.runtime.wf.service.uniwfinternalservice.resource;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import javax.servlet.ServletRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.http.HttpStatus;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.StringUtils;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiResponse;
import io.swagger.annotations.ApiResponses;

import com.alibaba.fastjson.JSONObject;
import org.springframework.data.domain.PageRequest;
import cn.ibizlab.r7.runtime.wf.service.uniwfinternalservice.dto.WFAppDTO;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFApp;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IWFAppService;
import cn.ibizlab.r7.runtime.wf.util.SearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WFAppSearchContext;

@Api(tags = {"WFApp" })
@RestController
@RequestMapping("")
public class WFAppResource {

    @Autowired
    private IWFAppService wfappService;

    public IWFAppService getWfappService() {
        return this.wfappService;
    }

    @ApiOperation(value = "查询工作流应用", tags = {"WFApp" },  notes = "查询工作流应用")
	@RequestMapping(method = RequestMethod.POST, value = "/uniwfinternalservice/wfapps/{wfapp_id}/querywfapp")
    @Transactional
    public ResponseEntity<WFAppDTO> queryWFApp(@PathVariable("wfapp_id") String wfapp_id, @RequestBody WFAppDTO wfappdto) {
        WFApp wfapp = wfappdto.toDO();
    	wfapp = wfappService.queryWFApp(wfapp) ;
    	wfappdto.fromDO(wfapp);
        return ResponseEntity.status(HttpStatus.OK).body(wfappdto);
    }

    @ApiOperation(value = "注册", tags = {"WFApp" },  notes = "注册")
	@RequestMapping(method = RequestMethod.POST, value = "/uniwfinternalservice/wfapps/regist")
    @Transactional
    public ResponseEntity<WFAppDTO> regist(@RequestBody WFAppDTO wfappdto) {
        WFApp domain = wfappdto.toDO();
		wfappService.save(domain);
        wfappdto.fromDO(domain);
		return ResponseEntity.status(HttpStatus.OK).body(wfappdto);
    }


}
