package cn.ibizlab.r7.runtime.wf.service.uniwfinternalservice.resource;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import javax.servlet.ServletRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.http.HttpStatus;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.StringUtils;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiResponse;
import io.swagger.annotations.ApiResponses;

import com.alibaba.fastjson.JSONObject;
import org.springframework.data.domain.PageRequest;
import cn.ibizlab.r7.runtime.wf.service.uniwfinternalservice.dto.WFEngineDTO;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFEngine;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IWFEngineService;
import cn.ibizlab.r7.runtime.wf.util.SearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WFEngineSearchContext;

@Api(tags = {"WFEngine" })
@RestController
@RequestMapping("")
public class WFEngineResource {

    @Autowired
    private IWFEngineService wfengineService;

    public IWFEngineService getWfengineService() {
        return this.wfengineService;
    }

    @ApiOperation(value = "注册", tags = {"WFEngine" },  notes = "注册")
	@RequestMapping(method = RequestMethod.POST, value = "/uniwfinternalservice/wfengines/regist")
    @Transactional
    public ResponseEntity<List<WFEngineDTO>> regist(@RequestBody List<WFEngineDTO> wfenginedtos) {
        if (wfenginedtos == null) {
            return ResponseEntity.status(HttpStatus.OK).body(null);
        }
        List<WFEngineDTO> wfenginedtos2 = new ArrayList<WFEngineDTO>();
        for (WFEngineDTO wfenginedto : wfenginedtos) {
            WFEngine domain = wfenginedto.toDO();
            wfengineService.save(domain);
            wfenginedto.fromDO(domain);
            wfenginedtos2.add(wfenginedto);
        }

		return ResponseEntity.status(HttpStatus.OK).body(wfenginedtos2);
    }


}
