package cn.ibizlab.r7.runtime.wf.service.uniwfinternalservice.resource;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import javax.servlet.ServletRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.http.HttpStatus;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.StringUtils;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiResponse;
import io.swagger.annotations.ApiResponses;

import com.alibaba.fastjson.JSONObject;
import org.springframework.data.domain.PageRequest;
import cn.ibizlab.r7.runtime.wf.service.uniwfinternalservice.dto.WFIAActionDTO;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFIAAction;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IWFIAActionService;
import cn.ibizlab.r7.runtime.wf.util.SearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WFIAActionSearchContext;

@Api(tags = {"WFIAAction" })
@RestController
@RequestMapping("")
public class WFIAActionResource {

    @Autowired
    private IWFIAActionService wfiaactionService;

    public IWFIAActionService getWfiaactionService() {
        return this.wfiaactionService;
    }

    @ApiOperation(value = "Create", tags = {"WFIAAction" },  notes = "Create")
	@RequestMapping(method = RequestMethod.POST, value = "/uniwfinternalservice/wfiaactions")
    @Transactional
    public ResponseEntity<WFIAActionDTO> create(@RequestBody WFIAActionDTO wfiaactiondto) {
        WFIAActionDTO dto = new WFIAActionDTO();
        WFIAAction domain = wfiaactiondto.toDO();
		wfiaactionService.create(domain);
        dto.fromDO(domain);
		return ResponseEntity.status(HttpStatus.OK).body(dto);
    }

	@ApiOperation(value = "获取DEFAULT", tags = {"WFIAAction" } ,notes = "获取DEFAULT")
    @RequestMapping(method= RequestMethod.GET , value="/uniwfinternalservice/wfiaactions/fetchdefault")
	public ResponseEntity<Page<WFIAActionDTO>> fetchDefault(WFIAActionSearchContext context,Pageable pageable ,ServletRequest request) {
        context.setPageable(pageable);
        List<WFIAActionDTO> list = new ArrayList<WFIAActionDTO>();
        
        Page<WFIAAction> domains = wfiaactionService.searchDefault(context) ;
        for(WFIAAction wfiaaction : domains.getContent()){
            WFIAActionDTO dto = new WFIAActionDTO();
            dto.fromDO(wfiaaction);
            list.add(dto);
        }
	    return ResponseEntity.status(HttpStatus.OK).body(new PageImpl(list,context.getPageable(),domains.getTotalElements()));
	}


}
