package cn.ibizlab.r7.runtime.wf.service.uniwfinternalservice.resource;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import javax.servlet.ServletRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.http.HttpStatus;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.StringUtils;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiResponse;
import io.swagger.annotations.ApiResponses;

import com.alibaba.fastjson.JSONObject;
import org.springframework.data.domain.PageRequest;
import cn.ibizlab.r7.runtime.wf.service.uniwfinternalservice.dto.WFModeDTO;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFMode;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IWFModeService;
import cn.ibizlab.r7.runtime.wf.util.SearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WFModeSearchContext;

@Api(tags = {"WFMode" })
@RestController
@RequestMapping("")
public class WFModeResource {

    @Autowired
    private IWFModeService wfmodeService;

    public IWFModeService getWfmodeService() {
        return this.wfmodeService;
    }

    @ApiOperation(value = "注册", tags = {"WFMode" },  notes = "注册")
	@RequestMapping(method = RequestMethod.POST, value = "/uniwfinternalservice/wfmodes/regist")
    @Transactional
    public ResponseEntity<List<WFModeDTO>> regist(@RequestBody List<WFModeDTO> wfmodedtos) {
        if (wfmodedtos == null) {
            return ResponseEntity.status(HttpStatus.OK).body(null);
        }
        List<WFModeDTO> wfmodedtos2 = new ArrayList<WFModeDTO>();
        for (WFModeDTO wfmodedto : wfmodedtos) {
            WFMode domain = wfmodedto.toDO();
            wfmodeService.save(domain);
            wfmodedto.fromDO(domain);
            wfmodedtos2.add(wfmodedto);
        }

		return ResponseEntity.status(HttpStatus.OK).body(wfmodedtos2);
    }


}
