package cn.ibizlab.r7.runtime.wf.service.uniwfinternalservice.resource;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import javax.servlet.ServletRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.http.HttpStatus;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.StringUtils;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiResponse;
import io.swagger.annotations.ApiResponses;

import com.alibaba.fastjson.JSONObject;
import org.springframework.data.domain.PageRequest;
import cn.ibizlab.r7.runtime.wf.service.uniwfinternalservice.dto.WFStepDataDTO;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFStepData;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IWFStepDataService;
import cn.ibizlab.r7.runtime.wf.util.SearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WFStepDataSearchContext;

@Api(tags = {"WFStepData" })
@RestController
@RequestMapping("")
public class WFStepDataResource {

    @Autowired
    private IWFStepDataService wfstepdataService;

    public IWFStepDataService getWfstepdataService() {
        return this.wfstepdataService;
    }

	@ApiOperation(value = "获取ByBswfdata", tags = {"WFStepData" } ,notes = "获取ByBswfdata")
    @RequestMapping(method= RequestMethod.GET , value="/uniwfinternalservice/wfstepdata/fetchbybswfdata")
	public ResponseEntity<Page<WFStepDataDTO>> fetchByBswfdata(WFStepDataSearchContext context,Pageable pageable ,ServletRequest request) {
        context.setPageable(pageable);
        List<WFStepDataDTO> list = new ArrayList<WFStepDataDTO>();
        
        Page<WFStepData> domains = wfstepdataService.searchByBswfdata(context) ;
        for(WFStepData wfstepdata : domains.getContent()){
            WFStepDataDTO dto = new WFStepDataDTO();
            dto.fromDO(wfstepdata);
            list.add(dto);
        }
	    return ResponseEntity.status(HttpStatus.OK).body(new PageImpl(list,context.getPageable(),domains.getTotalElements()));
	}

	@ApiOperation(value = "获取ByBsdata", tags = {"WFStepData" } ,notes = "获取ByBsdata")
    @RequestMapping(method= RequestMethod.GET , value="/uniwfinternalservice/wfstepdata/fetchbybsdata")
	public ResponseEntity<Page<WFStepDataDTO>> fetchByBsdata(WFStepDataSearchContext context,Pageable pageable ,ServletRequest request) {
        context.setPageable(pageable);
        List<WFStepDataDTO> list = new ArrayList<WFStepDataDTO>();
        
        Page<WFStepData> domains = wfstepdataService.searchByBsdata(context) ;
        for(WFStepData wfstepdata : domains.getContent()){
            WFStepDataDTO dto = new WFStepDataDTO();
            dto.fromDO(wfstepdata);
            list.add(dto);
        }
	    return ResponseEntity.status(HttpStatus.OK).body(new PageImpl(list,context.getPageable(),domains.getTotalElements()));
	}

	@ApiOperation(value = "获取DEFAULT", tags = {"WFStepData" } ,notes = "获取DEFAULT")
    @RequestMapping(method= RequestMethod.GET , value="/uniwfinternalservice/wfstepdata/fetchdefault")
	public ResponseEntity<Page<WFStepDataDTO>> fetchDefault(WFStepDataSearchContext context,Pageable pageable ,ServletRequest request) {
        context.setPageable(pageable);
        List<WFStepDataDTO> list = new ArrayList<WFStepDataDTO>();
        
        Page<WFStepData> domains = wfstepdataService.searchDefault(context) ;
        for(WFStepData wfstepdata : domains.getContent()){
            WFStepDataDTO dto = new WFStepDataDTO();
            dto.fromDO(wfstepdata);
            list.add(dto);
        }
	    return ResponseEntity.status(HttpStatus.OK).body(new PageImpl(list,context.getPageable(),domains.getTotalElements()));
	}


}
