package cn.ibizlab.r7.runtime.wf.service.uniwfinternalservice.resource;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import javax.servlet.ServletRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.http.HttpStatus;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.StringUtils;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiResponse;
import io.swagger.annotations.ApiResponses;

import com.alibaba.fastjson.JSONObject;
import org.springframework.data.domain.PageRequest;
import cn.ibizlab.r7.runtime.wf.service.uniwfinternalservice.dto.WorkflowDTO;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.Workflow;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IWorkflowService;
import cn.ibizlab.r7.runtime.wf.util.SearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.WorkflowSearchContext;

@Api(tags = {"Workflow" })
@RestController
@RequestMapping("")
public class WorkflowResource {

    @Autowired
    private IWorkflowService workflowService;

    public IWorkflowService getWorkflowService() {
        return this.workflowService;
    }

    @ApiOperation(value = "注册", tags = {"Workflow" },  notes = "注册")
	@RequestMapping(method = RequestMethod.POST, value = "/uniwfinternalservice/workflows/regist")
    @Transactional
    public ResponseEntity<WorkflowDTO> regist(@RequestBody WorkflowDTO workflowdto) {
        Workflow domain = workflowdto.toDO();
		workflowService.save(domain);
        workflowdto.fromDO(domain);
		return ResponseEntity.status(HttpStatus.OK).body(workflowdto);
    }


}
