package cn.ibizlab.r7.runtime.wf.service.wfapi.dto;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.math.BigInteger;
import java.util.Map;
import java.util.HashMap;
import java.io.Serializable;
import java.math.BigDecimal;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.valuerule.anno.entity.*;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.Entity;
import org.springframework.cglib.beans.BeanCopier;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * 服务DTO对象[EntityDTO]
 */
public class EntityDTO implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 属性 [ENTITYID]
     *
     */
    @EntityEntityIdDefault(info = "默认规则")
    private String entityId;

    @JsonIgnore
    private boolean entityIdDirtyFlag;

    /**
     * 属性 [ENTITYNAME]
     *
     */
    @EntityEntityNameDefault(info = "默认规则")
    private String entityName;

    @JsonIgnore
    private boolean entityNameDirtyFlag;

    /**
     * 属性 [CREATEDATE]
     *
     */
    @EntityCreateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp createDate;

    @JsonIgnore
    private boolean createDateDirtyFlag;

    /**
     * 属性 [UPDATEDATE]
     *
     */
    @EntityUpdateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp updateDate;

    @JsonIgnore
    private boolean updateDateDirtyFlag;

    /**
     * 属性 [UPDATEMAN]
     *
     */
    @EntityUpdateManDefault(info = "默认规则")
    private String updateMan;

    @JsonIgnore
    private boolean updateManDirtyFlag;

    /**
     * 属性 [CREATEMAN]
     *
     */
    @EntityCreateManDefault(info = "默认规则")
    private String createMan;

    @JsonIgnore
    private boolean createManDirtyFlag;


    /**
     * 获取 [ENTITYID]
     */
    @JsonProperty("entityid")
    public String getEntityId(){
        return entityId ;
    }

    /**
     * 设置 [ENTITYID]
     */
    @JsonProperty("entityid")
    public void setEntityId(String  entityId){
        this.entityId = entityId ;
        this.entityIdDirtyFlag = true ;
    }

    /**
     * 获取 [ENTITYID]脏标记
     */
    @JsonIgnore
    public boolean getEntityIdDirtyFlag(){
        return entityIdDirtyFlag ;
    }

    /**
     * 获取 [ENTITYNAME]
     */
    @JsonProperty("entityname")
    public String getEntityName(){
        return entityName ;
    }

    /**
     * 设置 [ENTITYNAME]
     */
    @JsonProperty("entityname")
    public void setEntityName(String  entityName){
        this.entityName = entityName ;
        this.entityNameDirtyFlag = true ;
    }

    /**
     * 获取 [ENTITYNAME]脏标记
     */
    @JsonIgnore
    public boolean getEntityNameDirtyFlag(){
        return entityNameDirtyFlag ;
    }

    /**
     * 获取 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public Timestamp getCreateDate(){
        return createDate ;
    }

    /**
     * 设置 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return createDateDirtyFlag ;
    }

    /**
     * 获取 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public Timestamp getUpdateDate(){
        return updateDate ;
    }

    /**
     * 设置 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return updateDateDirtyFlag ;
    }

    /**
     * 获取 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public String getUpdateMan(){
        return updateMan ;
    }

    /**
     * 设置 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return updateManDirtyFlag ;
    }

    /**
     * 获取 [CREATEMAN]
     */
    @JsonProperty("createman")
    public String getCreateMan(){
        return createMan ;
    }

    /**
     * 设置 [CREATEMAN]
     */
    @JsonProperty("createman")
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return createManDirtyFlag ;
    }



    public Entity toDO() {
        Entity srfdomain = new Entity();
        if(getEntityIdDirtyFlag())
            srfdomain.setEntityId(entityId);
        if(getEntityNameDirtyFlag())
            srfdomain.setEntityName(entityName);
        if(getCreateDateDirtyFlag())
            srfdomain.setCreateDate(createDate);
        if(getUpdateDateDirtyFlag())
            srfdomain.setUpdateDate(updateDate);
        if(getUpdateManDirtyFlag())
            srfdomain.setUpdateMan(updateMan);
        if(getCreateManDirtyFlag())
            srfdomain.setCreateMan(createMan);

        return srfdomain;
    }

    public void fromDO(Entity srfdomain) {
        if(srfdomain == null )
          return ;
        if(srfdomain.getEntityIdDirtyFlag())
            this.setEntityId(srfdomain.getEntityId());
        if(srfdomain.getEntityNameDirtyFlag())
            this.setEntityName(srfdomain.getEntityName());
        if(srfdomain.getCreateDateDirtyFlag())
            this.setCreateDate(srfdomain.getCreateDate());
        if(srfdomain.getUpdateDateDirtyFlag())
            this.setUpdateDate(srfdomain.getUpdateDate());
        if(srfdomain.getUpdateManDirtyFlag())
            this.setUpdateMan(srfdomain.getUpdateMan());
        if(srfdomain.getCreateManDirtyFlag())
            this.setCreateMan(srfdomain.getCreateMan());

    }

    public List<EntityDTO> fromDOPage(List<Entity> poPage)   {
        if(poPage == null)
            return null;
        List<EntityDTO> dtos=new ArrayList<EntityDTO>();
        for(Entity domain : poPage) {
            EntityDTO dto = new EntityDTO();
            dto.fromDO(domain);
            dtos.add(dto);
        }
        return dtos;
    }
}

