package cn.ibizlab.r7.runtime.wf.service.wfapi.dto;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.math.BigInteger;
import java.util.Map;
import java.util.HashMap;
import java.io.Serializable;
import java.math.BigDecimal;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.valuerule.anno.orgdeptwfver.*;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.OrgDeptWFVer;
import org.springframework.cglib.beans.BeanCopier;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * 服务DTO对象[OrgDeptWFVerDTO]
 */
public class OrgDeptWFVerDTO implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 属性 [CREATEDATE]
     *
     */
    @OrgDeptWFVerCreateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp createDate;

    @JsonIgnore
    private boolean createDateDirtyFlag;

    /**
     * 属性 [UPDATEMAN]
     *
     */
    @OrgDeptWFVerUpdateManDefault(info = "默认规则")
    private String updateMan;

    @JsonIgnore
    private boolean updateManDirtyFlag;

    /**
     * 属性 [ORGDEPTWFVERNAME]
     *
     */
    @OrgDeptWFVerOrgDeptWFVerNameDefault(info = "默认规则")
    private String orgDeptWFVerName;

    @JsonIgnore
    private boolean orgDeptWFVerNameDirtyFlag;

    /**
     * 属性 [ORGDEPTWFVERID]
     *
     */
    @OrgDeptWFVerOrgDeptWFVerIdDefault(info = "默认规则")
    private String orgDeptWFVerId;

    @JsonIgnore
    private boolean orgDeptWFVerIdDirtyFlag;

    /**
     * 属性 [STARTTIME]
     *
     */
    @OrgDeptWFVerStartTimeDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp startTime;

    @JsonIgnore
    private boolean startTimeDirtyFlag;

    /**
     * 属性 [UPDATEDATE]
     *
     */
    @OrgDeptWFVerUpdateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp updateDate;

    @JsonIgnore
    private boolean updateDateDirtyFlag;

    /**
     * 属性 [CREATEMAN]
     *
     */
    @OrgDeptWFVerCreateManDefault(info = "默认规则")
    private String createMan;

    @JsonIgnore
    private boolean createManDirtyFlag;

    /**
     * 属性 [ENDTIME]
     *
     */
    @OrgDeptWFVerEndtimeDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp endtime;

    @JsonIgnore
    private boolean endtimeDirtyFlag;

    /**
     * 属性 [ORGDEPTNAME]
     *
     */
    @OrgDeptWFVerOrgDeptNameDefault(info = "默认规则")
    private String orgDeptName;

    @JsonIgnore
    private boolean orgDeptNameDirtyFlag;

    /**
     * 属性 [PSWFVERSIONNAME]
     *
     */
    @OrgDeptWFVerPSWFVersionNameDefault(info = "默认规则")
    private String pSWFVersionName;

    @JsonIgnore
    private boolean pSWFVersionNameDirtyFlag;

    /**
     * 属性 [PSWORKFLOWNAME]
     *
     */
    @OrgDeptWFVerPSWFWorkflowNameDefault(info = "默认规则")
    private String pSWFWorkflowName;

    @JsonIgnore
    private boolean pSWFWorkflowNameDirtyFlag;

    /**
     * 属性 [ORGDEPTID]
     *
     */
    @OrgDeptWFVerOrgDeptIdDefault(info = "默认规则")
    private String orgDeptId;

    @JsonIgnore
    private boolean orgDeptIdDirtyFlag;

    /**
     * 属性 [PSWORKFLOWID]
     *
     */
    @OrgDeptWFVerPSWorkflowIdDefault(info = "默认规则")
    private String pSWorkflowId;

    @JsonIgnore
    private boolean pSWorkflowIdDirtyFlag;

    /**
     * 属性 [PSWFVERSIONID]
     *
     */
    @OrgDeptWFVerPSWFVersionIdDefault(info = "默认规则")
    private String pSWFVersionId;

    @JsonIgnore
    private boolean pSWFVersionIdDirtyFlag;


    /**
     * 获取 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public Timestamp getCreateDate(){
        return createDate ;
    }

    /**
     * 设置 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return createDateDirtyFlag ;
    }

    /**
     * 获取 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public String getUpdateMan(){
        return updateMan ;
    }

    /**
     * 设置 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return updateManDirtyFlag ;
    }

    /**
     * 获取 [ORGDEPTWFVERNAME]
     */
    @JsonProperty("orgdeptwfvername")
    public String getOrgDeptWFVerName(){
        return orgDeptWFVerName ;
    }

    /**
     * 设置 [ORGDEPTWFVERNAME]
     */
    @JsonProperty("orgdeptwfvername")
    public void setOrgDeptWFVerName(String  orgDeptWFVerName){
        this.orgDeptWFVerName = orgDeptWFVerName ;
        this.orgDeptWFVerNameDirtyFlag = true ;
    }

    /**
     * 获取 [ORGDEPTWFVERNAME]脏标记
     */
    @JsonIgnore
    public boolean getOrgDeptWFVerNameDirtyFlag(){
        return orgDeptWFVerNameDirtyFlag ;
    }

    /**
     * 获取 [ORGDEPTWFVERID]
     */
    @JsonProperty("orgdeptwfverid")
    public String getOrgDeptWFVerId(){
        return orgDeptWFVerId ;
    }

    /**
     * 设置 [ORGDEPTWFVERID]
     */
    @JsonProperty("orgdeptwfverid")
    public void setOrgDeptWFVerId(String  orgDeptWFVerId){
        this.orgDeptWFVerId = orgDeptWFVerId ;
        this.orgDeptWFVerIdDirtyFlag = true ;
    }

    /**
     * 获取 [ORGDEPTWFVERID]脏标记
     */
    @JsonIgnore
    public boolean getOrgDeptWFVerIdDirtyFlag(){
        return orgDeptWFVerIdDirtyFlag ;
    }

    /**
     * 获取 [STARTTIME]
     */
    @JsonProperty("starttime")
    public Timestamp getStartTime(){
        return startTime ;
    }

    /**
     * 设置 [STARTTIME]
     */
    @JsonProperty("starttime")
    public void setStartTime(Timestamp  startTime){
        this.startTime = startTime ;
        this.startTimeDirtyFlag = true ;
    }

    /**
     * 获取 [STARTTIME]脏标记
     */
    @JsonIgnore
    public boolean getStartTimeDirtyFlag(){
        return startTimeDirtyFlag ;
    }

    /**
     * 获取 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public Timestamp getUpdateDate(){
        return updateDate ;
    }

    /**
     * 设置 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return updateDateDirtyFlag ;
    }

    /**
     * 获取 [CREATEMAN]
     */
    @JsonProperty("createman")
    public String getCreateMan(){
        return createMan ;
    }

    /**
     * 设置 [CREATEMAN]
     */
    @JsonProperty("createman")
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return createManDirtyFlag ;
    }

    /**
     * 获取 [ENDTIME]
     */
    @JsonProperty("endtime")
    public Timestamp getEndtime(){
        return endtime ;
    }

    /**
     * 设置 [ENDTIME]
     */
    @JsonProperty("endtime")
    public void setEndtime(Timestamp  endtime){
        this.endtime = endtime ;
        this.endtimeDirtyFlag = true ;
    }

    /**
     * 获取 [ENDTIME]脏标记
     */
    @JsonIgnore
    public boolean getEndtimeDirtyFlag(){
        return endtimeDirtyFlag ;
    }

    /**
     * 获取 [ORGDEPTNAME]
     */
    @JsonProperty("orgdeptname")
    public String getOrgDeptName(){
        return orgDeptName ;
    }

    /**
     * 设置 [ORGDEPTNAME]
     */
    @JsonProperty("orgdeptname")
    public void setOrgDeptName(String  orgDeptName){
        this.orgDeptName = orgDeptName ;
        this.orgDeptNameDirtyFlag = true ;
    }

    /**
     * 获取 [ORGDEPTNAME]脏标记
     */
    @JsonIgnore
    public boolean getOrgDeptNameDirtyFlag(){
        return orgDeptNameDirtyFlag ;
    }

    /**
     * 获取 [PSWFVERSIONNAME]
     */
    @JsonProperty("pswfversionname")
    public String getPSWFVersionName(){
        return pSWFVersionName ;
    }

    /**
     * 设置 [PSWFVERSIONNAME]
     */
    @JsonProperty("pswfversionname")
    public void setPSWFVersionName(String  pSWFVersionName){
        this.pSWFVersionName = pSWFVersionName ;
        this.pSWFVersionNameDirtyFlag = true ;
    }

    /**
     * 获取 [PSWFVERSIONNAME]脏标记
     */
    @JsonIgnore
    public boolean getPSWFVersionNameDirtyFlag(){
        return pSWFVersionNameDirtyFlag ;
    }

    /**
     * 获取 [PSWORKFLOWNAME]
     */
    @JsonProperty("pswfworkflowname")
    public String getPSWFWorkflowName(){
        return pSWFWorkflowName ;
    }

    /**
     * 设置 [PSWORKFLOWNAME]
     */
    @JsonProperty("pswfworkflowname")
    public void setPSWFWorkflowName(String  pSWFWorkflowName){
        this.pSWFWorkflowName = pSWFWorkflowName ;
        this.pSWFWorkflowNameDirtyFlag = true ;
    }

    /**
     * 获取 [PSWORKFLOWNAME]脏标记
     */
    @JsonIgnore
    public boolean getPSWFWorkflowNameDirtyFlag(){
        return pSWFWorkflowNameDirtyFlag ;
    }

    /**
     * 获取 [ORGDEPTID]
     */
    @JsonProperty("orgdeptid")
    public String getOrgDeptId(){
        return orgDeptId ;
    }

    /**
     * 设置 [ORGDEPTID]
     */
    @JsonProperty("orgdeptid")
    public void setOrgDeptId(String  orgDeptId){
        this.orgDeptId = orgDeptId ;
        this.orgDeptIdDirtyFlag = true ;
    }

    /**
     * 获取 [ORGDEPTID]脏标记
     */
    @JsonIgnore
    public boolean getOrgDeptIdDirtyFlag(){
        return orgDeptIdDirtyFlag ;
    }

    /**
     * 获取 [PSWORKFLOWID]
     */
    @JsonProperty("psworkflowid")
    public String getPSWorkflowId(){
        return pSWorkflowId ;
    }

    /**
     * 设置 [PSWORKFLOWID]
     */
    @JsonProperty("psworkflowid")
    public void setPSWorkflowId(String  pSWorkflowId){
        this.pSWorkflowId = pSWorkflowId ;
        this.pSWorkflowIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSWORKFLOWID]脏标记
     */
    @JsonIgnore
    public boolean getPSWorkflowIdDirtyFlag(){
        return pSWorkflowIdDirtyFlag ;
    }

    /**
     * 获取 [PSWFVERSIONID]
     */
    @JsonProperty("pswfversionid")
    public String getPSWFVersionId(){
        return pSWFVersionId ;
    }

    /**
     * 设置 [PSWFVERSIONID]
     */
    @JsonProperty("pswfversionid")
    public void setPSWFVersionId(String  pSWFVersionId){
        this.pSWFVersionId = pSWFVersionId ;
        this.pSWFVersionIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSWFVERSIONID]脏标记
     */
    @JsonIgnore
    public boolean getPSWFVersionIdDirtyFlag(){
        return pSWFVersionIdDirtyFlag ;
    }



    public OrgDeptWFVer toDO() {
        OrgDeptWFVer srfdomain = new OrgDeptWFVer();
        if(getCreateDateDirtyFlag())
            srfdomain.setCreateDate(createDate);
        if(getUpdateManDirtyFlag())
            srfdomain.setUpdateMan(updateMan);
        if(getOrgDeptWFVerNameDirtyFlag())
            srfdomain.setOrgDeptWFVerName(orgDeptWFVerName);
        if(getOrgDeptWFVerIdDirtyFlag())
            srfdomain.setOrgDeptWFVerId(orgDeptWFVerId);
        if(getStartTimeDirtyFlag())
            srfdomain.setStartTime(startTime);
        if(getUpdateDateDirtyFlag())
            srfdomain.setUpdateDate(updateDate);
        if(getCreateManDirtyFlag())
            srfdomain.setCreateMan(createMan);
        if(getEndtimeDirtyFlag())
            srfdomain.setEndtime(endtime);
        if(getOrgDeptNameDirtyFlag())
            srfdomain.setOrgDeptName(orgDeptName);
        if(getPSWFVersionNameDirtyFlag())
            srfdomain.setPSWFVersionName(pSWFVersionName);
        if(getPSWFWorkflowNameDirtyFlag())
            srfdomain.setPSWFWorkflowName(pSWFWorkflowName);
        if(getOrgDeptIdDirtyFlag())
            srfdomain.setOrgDeptId(orgDeptId);
        if(getPSWorkflowIdDirtyFlag())
            srfdomain.setPSWorkflowId(pSWorkflowId);
        if(getPSWFVersionIdDirtyFlag())
            srfdomain.setPSWFVersionId(pSWFVersionId);

        return srfdomain;
    }

    public void fromDO(OrgDeptWFVer srfdomain) {
        if(srfdomain == null )
          return ;
        if(srfdomain.getCreateDateDirtyFlag())
            this.setCreateDate(srfdomain.getCreateDate());
        if(srfdomain.getUpdateManDirtyFlag())
            this.setUpdateMan(srfdomain.getUpdateMan());
        if(srfdomain.getOrgDeptWFVerNameDirtyFlag())
            this.setOrgDeptWFVerName(srfdomain.getOrgDeptWFVerName());
        if(srfdomain.getOrgDeptWFVerIdDirtyFlag())
            this.setOrgDeptWFVerId(srfdomain.getOrgDeptWFVerId());
        if(srfdomain.getStartTimeDirtyFlag())
            this.setStartTime(srfdomain.getStartTime());
        if(srfdomain.getUpdateDateDirtyFlag())
            this.setUpdateDate(srfdomain.getUpdateDate());
        if(srfdomain.getCreateManDirtyFlag())
            this.setCreateMan(srfdomain.getCreateMan());
        if(srfdomain.getEndtimeDirtyFlag())
            this.setEndtime(srfdomain.getEndtime());
        if(srfdomain.getOrgDeptNameDirtyFlag())
            this.setOrgDeptName(srfdomain.getOrgDeptName());
        if(srfdomain.getPSWFVersionNameDirtyFlag())
            this.setPSWFVersionName(srfdomain.getPSWFVersionName());
        if(srfdomain.getPSWFWorkflowNameDirtyFlag())
            this.setPSWFWorkflowName(srfdomain.getPSWFWorkflowName());
        if(srfdomain.getOrgDeptIdDirtyFlag())
            this.setOrgDeptId(srfdomain.getOrgDeptId());
        if(srfdomain.getPSWorkflowIdDirtyFlag())
            this.setPSWorkflowId(srfdomain.getPSWorkflowId());
        if(srfdomain.getPSWFVersionIdDirtyFlag())
            this.setPSWFVersionId(srfdomain.getPSWFVersionId());

    }

    public List<OrgDeptWFVerDTO> fromDOPage(List<OrgDeptWFVer> poPage)   {
        if(poPage == null)
            return null;
        List<OrgDeptWFVerDTO> dtos=new ArrayList<OrgDeptWFVerDTO>();
        for(OrgDeptWFVer domain : poPage) {
            OrgDeptWFVerDTO dto = new OrgDeptWFVerDTO();
            dto.fromDO(domain);
            dtos.add(dto);
        }
        return dtos;
    }
}

