package cn.ibizlab.r7.runtime.wf.service.wfapi.dto;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.math.BigInteger;
import java.util.Map;
import java.util.HashMap;
import java.io.Serializable;
import java.math.BigDecimal;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.valuerule.anno.psdewf.*;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSDEWF;
import org.springframework.cglib.beans.BeanCopier;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * 服务DTO对象[PSDEWFDTO]
 */
public class PSDEWFDTO implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 属性 [ERRORVALUE]
     *
     */
    @PSDEWFErrorvalueDefault(info = "默认规则")
    private String errorvalue;

    @JsonIgnore
    private boolean errorvalueDirtyFlag;

    /**
     * 属性 [LOGICNAME]
     *
     */
    @PSDEWFLogicNameDefault(info = "默认规则")
    private String logicName;

    @JsonIgnore
    private boolean logicNameDirtyFlag;

    /**
     * 属性 [UDSTATEFIELD]
     *
     */
    @PSDEWFUdstatefieldDefault(info = "默认规则")
    private String udstatefield;

    @JsonIgnore
    private boolean udstatefieldDirtyFlag;

    /**
     * 属性 [PSDEWFNAME]
     *
     */
    @PSDEWFPSDEWFNameDefault(info = "默认规则")
    private String pSDEWFName;

    @JsonIgnore
    private boolean pSDEWFNameDirtyFlag;

    /**
     * 属性 [WFSTEPFIELD]
     *
     */
    @PSDEWFWfstepfieldDefault(info = "默认规则")
    private String wfstepfield;

    @JsonIgnore
    private boolean wfstepfieldDirtyFlag;

    /**
     * 属性 [PSDEWFID]
     *
     */
    @PSDEWFPSDEWFIdDefault(info = "默认规则")
    private String pSDEWFId;

    @JsonIgnore
    private boolean pSDEWFIdDirtyFlag;

    /**
     * 属性 [PROCESSVALUE]
     *
     */
    @PSDEWFProcessvalueDefault(info = "默认规则")
    private String processvalue;

    @JsonIgnore
    private boolean processvalueDirtyFlag;

    /**
     * 属性 [WFPROXYMODE]
     *
     */
    @PSDEWFWFProxyModeDefault(info = "默认规则")
    private Integer wFProxyMode;

    @JsonIgnore
    private boolean wFProxyModeDirtyFlag;

    /**
     * 属性 [WFSTATEFIELD]
     *
     */
    @PSDEWFWfstatefieldDefault(info = "默认规则")
    private String wfstatefield;

    @JsonIgnore
    private boolean wfstatefieldDirtyFlag;

    /**
     * 属性 [CREATEMAN]
     *
     */
    @PSDEWFCreateManDefault(info = "默认规则")
    private String createMan;

    @JsonIgnore
    private boolean createManDirtyFlag;

    /**
     * 属性 [FINISHVALUE]
     *
     */
    @PSDEWFFinishvalueDefault(info = "默认规则")
    private String finishvalue;

    @JsonIgnore
    private boolean finishvalueDirtyFlag;

    /**
     * 属性 [UPDATEDATE]
     *
     */
    @PSDEWFUpdateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp updateDate;

    @JsonIgnore
    private boolean updateDateDirtyFlag;

    /**
     * 属性 [CREATEDATE]
     *
     */
    @PSDEWFCreateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp createDate;

    @JsonIgnore
    private boolean createDateDirtyFlag;

    /**
     * 属性 [UPDATEMAN]
     *
     */
    @PSDEWFUpdateManDefault(info = "默认规则")
    private String updateMan;

    @JsonIgnore
    private boolean updateManDirtyFlag;

    /**
     * 属性 [PSDECODENAME]
     *
     */
    @PSDEWFPSDECodeNameDefault(info = "默认规则")
    private String pSDECodeName;

    @JsonIgnore
    private boolean pSDECodeNameDirtyFlag;

    /**
     * 属性 [PSWORKFLOWID]
     *
     */
    @PSDEWFPSWorkflowIdDefault(info = "默认规则")
    private String pSWorkflowId;

    @JsonIgnore
    private boolean pSWorkflowIdDirtyFlag;

    /**
     * 属性 [PSDATAENTITYID]
     *
     */
    @PSDEWFPSDataEntityIdDefault(info = "默认规则")
    private String pSDataEntityId;

    @JsonIgnore
    private boolean pSDataEntityIdDirtyFlag;


    /**
     * 获取 [ERRORVALUE]
     */
    @JsonProperty("errorvalue")
    public String getErrorvalue(){
        return errorvalue ;
    }

    /**
     * 设置 [ERRORVALUE]
     */
    @JsonProperty("errorvalue")
    public void setErrorvalue(String  errorvalue){
        this.errorvalue = errorvalue ;
        this.errorvalueDirtyFlag = true ;
    }

    /**
     * 获取 [ERRORVALUE]脏标记
     */
    @JsonIgnore
    public boolean getErrorvalueDirtyFlag(){
        return errorvalueDirtyFlag ;
    }

    /**
     * 获取 [LOGICNAME]
     */
    @JsonProperty("logicname")
    public String getLogicName(){
        return logicName ;
    }

    /**
     * 设置 [LOGICNAME]
     */
    @JsonProperty("logicname")
    public void setLogicName(String  logicName){
        this.logicName = logicName ;
        this.logicNameDirtyFlag = true ;
    }

    /**
     * 获取 [LOGICNAME]脏标记
     */
    @JsonIgnore
    public boolean getLogicNameDirtyFlag(){
        return logicNameDirtyFlag ;
    }

    /**
     * 获取 [UDSTATEFIELD]
     */
    @JsonProperty("udstatefield")
    public String getUdstatefield(){
        return udstatefield ;
    }

    /**
     * 设置 [UDSTATEFIELD]
     */
    @JsonProperty("udstatefield")
    public void setUdstatefield(String  udstatefield){
        this.udstatefield = udstatefield ;
        this.udstatefieldDirtyFlag = true ;
    }

    /**
     * 获取 [UDSTATEFIELD]脏标记
     */
    @JsonIgnore
    public boolean getUdstatefieldDirtyFlag(){
        return udstatefieldDirtyFlag ;
    }

    /**
     * 获取 [PSDEWFNAME]
     */
    @JsonProperty("psdewfname")
    public String getPSDEWFName(){
        return pSDEWFName ;
    }

    /**
     * 设置 [PSDEWFNAME]
     */
    @JsonProperty("psdewfname")
    public void setPSDEWFName(String  pSDEWFName){
        this.pSDEWFName = pSDEWFName ;
        this.pSDEWFNameDirtyFlag = true ;
    }

    /**
     * 获取 [PSDEWFNAME]脏标记
     */
    @JsonIgnore
    public boolean getPSDEWFNameDirtyFlag(){
        return pSDEWFNameDirtyFlag ;
    }

    /**
     * 获取 [WFSTEPFIELD]
     */
    @JsonProperty("wfstepfield")
    public String getWfstepfield(){
        return wfstepfield ;
    }

    /**
     * 设置 [WFSTEPFIELD]
     */
    @JsonProperty("wfstepfield")
    public void setWfstepfield(String  wfstepfield){
        this.wfstepfield = wfstepfield ;
        this.wfstepfieldDirtyFlag = true ;
    }

    /**
     * 获取 [WFSTEPFIELD]脏标记
     */
    @JsonIgnore
    public boolean getWfstepfieldDirtyFlag(){
        return wfstepfieldDirtyFlag ;
    }

    /**
     * 获取 [PSDEWFID]
     */
    @JsonProperty("psdewfid")
    public String getPSDEWFId(){
        return pSDEWFId ;
    }

    /**
     * 设置 [PSDEWFID]
     */
    @JsonProperty("psdewfid")
    public void setPSDEWFId(String  pSDEWFId){
        this.pSDEWFId = pSDEWFId ;
        this.pSDEWFIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSDEWFID]脏标记
     */
    @JsonIgnore
    public boolean getPSDEWFIdDirtyFlag(){
        return pSDEWFIdDirtyFlag ;
    }

    /**
     * 获取 [PROCESSVALUE]
     */
    @JsonProperty("processvalue")
    public String getProcessvalue(){
        return processvalue ;
    }

    /**
     * 设置 [PROCESSVALUE]
     */
    @JsonProperty("processvalue")
    public void setProcessvalue(String  processvalue){
        this.processvalue = processvalue ;
        this.processvalueDirtyFlag = true ;
    }

    /**
     * 获取 [PROCESSVALUE]脏标记
     */
    @JsonIgnore
    public boolean getProcessvalueDirtyFlag(){
        return processvalueDirtyFlag ;
    }

    /**
     * 获取 [WFPROXYMODE]
     */
    @JsonProperty("wfproxymode")
    public Integer getWFProxyMode(){
        return wFProxyMode ;
    }

    /**
     * 设置 [WFPROXYMODE]
     */
    @JsonProperty("wfproxymode")
    public void setWFProxyMode(Integer  wFProxyMode){
        this.wFProxyMode = wFProxyMode ;
        this.wFProxyModeDirtyFlag = true ;
    }

    /**
     * 获取 [WFPROXYMODE]脏标记
     */
    @JsonIgnore
    public boolean getWFProxyModeDirtyFlag(){
        return wFProxyModeDirtyFlag ;
    }

    /**
     * 获取 [WFSTATEFIELD]
     */
    @JsonProperty("wfstatefield")
    public String getWfstatefield(){
        return wfstatefield ;
    }

    /**
     * 设置 [WFSTATEFIELD]
     */
    @JsonProperty("wfstatefield")
    public void setWfstatefield(String  wfstatefield){
        this.wfstatefield = wfstatefield ;
        this.wfstatefieldDirtyFlag = true ;
    }

    /**
     * 获取 [WFSTATEFIELD]脏标记
     */
    @JsonIgnore
    public boolean getWfstatefieldDirtyFlag(){
        return wfstatefieldDirtyFlag ;
    }

    /**
     * 获取 [CREATEMAN]
     */
    @JsonProperty("createman")
    public String getCreateMan(){
        return createMan ;
    }

    /**
     * 设置 [CREATEMAN]
     */
    @JsonProperty("createman")
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return createManDirtyFlag ;
    }

    /**
     * 获取 [FINISHVALUE]
     */
    @JsonProperty("finishvalue")
    public String getFinishvalue(){
        return finishvalue ;
    }

    /**
     * 设置 [FINISHVALUE]
     */
    @JsonProperty("finishvalue")
    public void setFinishvalue(String  finishvalue){
        this.finishvalue = finishvalue ;
        this.finishvalueDirtyFlag = true ;
    }

    /**
     * 获取 [FINISHVALUE]脏标记
     */
    @JsonIgnore
    public boolean getFinishvalueDirtyFlag(){
        return finishvalueDirtyFlag ;
    }

    /**
     * 获取 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public Timestamp getUpdateDate(){
        return updateDate ;
    }

    /**
     * 设置 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return updateDateDirtyFlag ;
    }

    /**
     * 获取 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public Timestamp getCreateDate(){
        return createDate ;
    }

    /**
     * 设置 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return createDateDirtyFlag ;
    }

    /**
     * 获取 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public String getUpdateMan(){
        return updateMan ;
    }

    /**
     * 设置 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return updateManDirtyFlag ;
    }

    /**
     * 获取 [PSDECODENAME]
     */
    @JsonProperty("psdecodename")
    public String getPSDECodeName(){
        return pSDECodeName ;
    }

    /**
     * 设置 [PSDECODENAME]
     */
    @JsonProperty("psdecodename")
    public void setPSDECodeName(String  pSDECodeName){
        this.pSDECodeName = pSDECodeName ;
        this.pSDECodeNameDirtyFlag = true ;
    }

    /**
     * 获取 [PSDECODENAME]脏标记
     */
    @JsonIgnore
    public boolean getPSDECodeNameDirtyFlag(){
        return pSDECodeNameDirtyFlag ;
    }

    /**
     * 获取 [PSWORKFLOWID]
     */
    @JsonProperty("psworkflowid")
    public String getPSWorkflowId(){
        return pSWorkflowId ;
    }

    /**
     * 设置 [PSWORKFLOWID]
     */
    @JsonProperty("psworkflowid")
    public void setPSWorkflowId(String  pSWorkflowId){
        this.pSWorkflowId = pSWorkflowId ;
        this.pSWorkflowIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSWORKFLOWID]脏标记
     */
    @JsonIgnore
    public boolean getPSWorkflowIdDirtyFlag(){
        return pSWorkflowIdDirtyFlag ;
    }

    /**
     * 获取 [PSDATAENTITYID]
     */
    @JsonProperty("psdataentityid")
    public String getPSDataEntityId(){
        return pSDataEntityId ;
    }

    /**
     * 设置 [PSDATAENTITYID]
     */
    @JsonProperty("psdataentityid")
    public void setPSDataEntityId(String  pSDataEntityId){
        this.pSDataEntityId = pSDataEntityId ;
        this.pSDataEntityIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSDATAENTITYID]脏标记
     */
    @JsonIgnore
    public boolean getPSDataEntityIdDirtyFlag(){
        return pSDataEntityIdDirtyFlag ;
    }



    public PSDEWF toDO() {
        PSDEWF srfdomain = new PSDEWF();
        if(getErrorvalueDirtyFlag())
            srfdomain.setErrorvalue(errorvalue);
        if(getLogicNameDirtyFlag())
            srfdomain.setLogicName(logicName);
        if(getUdstatefieldDirtyFlag())
            srfdomain.setUdstatefield(udstatefield);
        if(getPSDEWFNameDirtyFlag())
            srfdomain.setPSDEWFName(pSDEWFName);
        if(getWfstepfieldDirtyFlag())
            srfdomain.setWfstepfield(wfstepfield);
        if(getPSDEWFIdDirtyFlag())
            srfdomain.setPSDEWFId(pSDEWFId);
        if(getProcessvalueDirtyFlag())
            srfdomain.setProcessvalue(processvalue);
        if(getWFProxyModeDirtyFlag())
            srfdomain.setWFProxyMode(wFProxyMode);
        if(getWfstatefieldDirtyFlag())
            srfdomain.setWfstatefield(wfstatefield);
        if(getCreateManDirtyFlag())
            srfdomain.setCreateMan(createMan);
        if(getFinishvalueDirtyFlag())
            srfdomain.setFinishvalue(finishvalue);
        if(getUpdateDateDirtyFlag())
            srfdomain.setUpdateDate(updateDate);
        if(getCreateDateDirtyFlag())
            srfdomain.setCreateDate(createDate);
        if(getUpdateManDirtyFlag())
            srfdomain.setUpdateMan(updateMan);
        if(getPSDECodeNameDirtyFlag())
            srfdomain.setPSDECodeName(pSDECodeName);
        if(getPSWorkflowIdDirtyFlag())
            srfdomain.setPSWorkflowId(pSWorkflowId);
        if(getPSDataEntityIdDirtyFlag())
            srfdomain.setPSDataEntityId(pSDataEntityId);

        return srfdomain;
    }

    public void fromDO(PSDEWF srfdomain) {
        if(srfdomain == null )
          return ;
        if(srfdomain.getErrorvalueDirtyFlag())
            this.setErrorvalue(srfdomain.getErrorvalue());
        if(srfdomain.getLogicNameDirtyFlag())
            this.setLogicName(srfdomain.getLogicName());
        if(srfdomain.getUdstatefieldDirtyFlag())
            this.setUdstatefield(srfdomain.getUdstatefield());
        if(srfdomain.getPSDEWFNameDirtyFlag())
            this.setPSDEWFName(srfdomain.getPSDEWFName());
        if(srfdomain.getWfstepfieldDirtyFlag())
            this.setWfstepfield(srfdomain.getWfstepfield());
        if(srfdomain.getPSDEWFIdDirtyFlag())
            this.setPSDEWFId(srfdomain.getPSDEWFId());
        if(srfdomain.getProcessvalueDirtyFlag())
            this.setProcessvalue(srfdomain.getProcessvalue());
        if(srfdomain.getWFProxyModeDirtyFlag())
            this.setWFProxyMode(srfdomain.getWFProxyMode());
        if(srfdomain.getWfstatefieldDirtyFlag())
            this.setWfstatefield(srfdomain.getWfstatefield());
        if(srfdomain.getCreateManDirtyFlag())
            this.setCreateMan(srfdomain.getCreateMan());
        if(srfdomain.getFinishvalueDirtyFlag())
            this.setFinishvalue(srfdomain.getFinishvalue());
        if(srfdomain.getUpdateDateDirtyFlag())
            this.setUpdateDate(srfdomain.getUpdateDate());
        if(srfdomain.getCreateDateDirtyFlag())
            this.setCreateDate(srfdomain.getCreateDate());
        if(srfdomain.getUpdateManDirtyFlag())
            this.setUpdateMan(srfdomain.getUpdateMan());
        if(srfdomain.getPSDECodeNameDirtyFlag())
            this.setPSDECodeName(srfdomain.getPSDECodeName());
        if(srfdomain.getPSWorkflowIdDirtyFlag())
            this.setPSWorkflowId(srfdomain.getPSWorkflowId());
        if(srfdomain.getPSDataEntityIdDirtyFlag())
            this.setPSDataEntityId(srfdomain.getPSDataEntityId());

    }

    public List<PSDEWFDTO> fromDOPage(List<PSDEWF> poPage)   {
        if(poPage == null)
            return null;
        List<PSDEWFDTO> dtos=new ArrayList<PSDEWFDTO>();
        for(PSDEWF domain : poPage) {
            PSDEWFDTO dto = new PSDEWFDTO();
            dto.fromDO(domain);
            dtos.add(dto);
        }
        return dtos;
    }
}

