package cn.ibizlab.r7.runtime.wf.service.wfapi.dto;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.math.BigInteger;
import java.util.Map;
import java.util.HashMap;
import java.io.Serializable;
import java.math.BigDecimal;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.valuerule.anno.psdataentity.*;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSDataEntity;
import org.springframework.cglib.beans.BeanCopier;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * 服务DTO对象[PSDataEntityDTO]
 */
public class PSDataEntityDTO implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 属性 [UPDATEMAN]
     *
     */
    @PSDataEntityUpdateManDefault(info = "默认规则")
    private String updateMan;

    @JsonIgnore
    private boolean updateManDirtyFlag;

    /**
     * 属性 [PSDATAENTITYNAME]
     *
     */
    @PSDataEntityPSDataEntityNameDefault(info = "默认规则")
    private String pSDataEntityName;

    @JsonIgnore
    private boolean pSDataEntityNameDirtyFlag;

    /**
     * 属性 [PSDATAENTITYID]
     *
     */
    @PSDataEntityPSDataEntityIdDefault(info = "默认规则")
    private String pSDataEntityId;

    @JsonIgnore
    private boolean pSDataEntityIdDirtyFlag;

    /**
     * 属性 [UPDATEDATE]
     *
     */
    @PSDataEntityUpdateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp updateDate;

    @JsonIgnore
    private boolean updateDateDirtyFlag;

    /**
     * 属性 [CODENAME]
     *
     */
    @PSDataEntityCodenameDefault(info = "默认规则")
    private String codename;

    @JsonIgnore
    private boolean codenameDirtyFlag;

    /**
     * 属性 [CREATEDATE]
     *
     */
    @PSDataEntityCreateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp createDate;

    @JsonIgnore
    private boolean createDateDirtyFlag;

    /**
     * 属性 [CREATEMAN]
     *
     */
    @PSDataEntityCreateManDefault(info = "默认规则")
    private String createMan;

    @JsonIgnore
    private boolean createManDirtyFlag;

    /**
     * 属性 [LOGICNAME]
     *
     */
    @PSDataEntityLogicNameDefault(info = "默认规则")
    private String logicName;

    @JsonIgnore
    private boolean logicNameDirtyFlag;

    /**
     * 属性 [PSSYSTEMID]
     *
     */
    @PSDataEntityPSSystemIdDefault(info = "默认规则")
    private String pSSystemId;

    @JsonIgnore
    private boolean pSSystemIdDirtyFlag;


    /**
     * 获取 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public String getUpdateMan(){
        return updateMan ;
    }

    /**
     * 设置 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return updateManDirtyFlag ;
    }

    /**
     * 获取 [PSDATAENTITYNAME]
     */
    @JsonProperty("psdataentityname")
    public String getPSDataEntityName(){
        return pSDataEntityName ;
    }

    /**
     * 设置 [PSDATAENTITYNAME]
     */
    @JsonProperty("psdataentityname")
    public void setPSDataEntityName(String  pSDataEntityName){
        this.pSDataEntityName = pSDataEntityName ;
        this.pSDataEntityNameDirtyFlag = true ;
    }

    /**
     * 获取 [PSDATAENTITYNAME]脏标记
     */
    @JsonIgnore
    public boolean getPSDataEntityNameDirtyFlag(){
        return pSDataEntityNameDirtyFlag ;
    }

    /**
     * 获取 [PSDATAENTITYID]
     */
    @JsonProperty("psdataentityid")
    public String getPSDataEntityId(){
        return pSDataEntityId ;
    }

    /**
     * 设置 [PSDATAENTITYID]
     */
    @JsonProperty("psdataentityid")
    public void setPSDataEntityId(String  pSDataEntityId){
        this.pSDataEntityId = pSDataEntityId ;
        this.pSDataEntityIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSDATAENTITYID]脏标记
     */
    @JsonIgnore
    public boolean getPSDataEntityIdDirtyFlag(){
        return pSDataEntityIdDirtyFlag ;
    }

    /**
     * 获取 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public Timestamp getUpdateDate(){
        return updateDate ;
    }

    /**
     * 设置 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return updateDateDirtyFlag ;
    }

    /**
     * 获取 [CODENAME]
     */
    @JsonProperty("codename")
    public String getCodename(){
        return codename ;
    }

    /**
     * 设置 [CODENAME]
     */
    @JsonProperty("codename")
    public void setCodename(String  codename){
        this.codename = codename ;
        this.codenameDirtyFlag = true ;
    }

    /**
     * 获取 [CODENAME]脏标记
     */
    @JsonIgnore
    public boolean getCodenameDirtyFlag(){
        return codenameDirtyFlag ;
    }

    /**
     * 获取 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public Timestamp getCreateDate(){
        return createDate ;
    }

    /**
     * 设置 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return createDateDirtyFlag ;
    }

    /**
     * 获取 [CREATEMAN]
     */
    @JsonProperty("createman")
    public String getCreateMan(){
        return createMan ;
    }

    /**
     * 设置 [CREATEMAN]
     */
    @JsonProperty("createman")
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return createManDirtyFlag ;
    }

    /**
     * 获取 [LOGICNAME]
     */
    @JsonProperty("logicname")
    public String getLogicName(){
        return logicName ;
    }

    /**
     * 设置 [LOGICNAME]
     */
    @JsonProperty("logicname")
    public void setLogicName(String  logicName){
        this.logicName = logicName ;
        this.logicNameDirtyFlag = true ;
    }

    /**
     * 获取 [LOGICNAME]脏标记
     */
    @JsonIgnore
    public boolean getLogicNameDirtyFlag(){
        return logicNameDirtyFlag ;
    }

    /**
     * 获取 [PSSYSTEMID]
     */
    @JsonProperty("pssystemid")
    public String getPSSystemId(){
        return pSSystemId ;
    }

    /**
     * 设置 [PSSYSTEMID]
     */
    @JsonProperty("pssystemid")
    public void setPSSystemId(String  pSSystemId){
        this.pSSystemId = pSSystemId ;
        this.pSSystemIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSSYSTEMID]脏标记
     */
    @JsonIgnore
    public boolean getPSSystemIdDirtyFlag(){
        return pSSystemIdDirtyFlag ;
    }



    public PSDataEntity toDO() {
        PSDataEntity srfdomain = new PSDataEntity();
        if(getUpdateManDirtyFlag())
            srfdomain.setUpdateMan(updateMan);
        if(getPSDataEntityNameDirtyFlag())
            srfdomain.setPSDataEntityName(pSDataEntityName);
        if(getPSDataEntityIdDirtyFlag())
            srfdomain.setPSDataEntityId(pSDataEntityId);
        if(getUpdateDateDirtyFlag())
            srfdomain.setUpdateDate(updateDate);
        if(getCodenameDirtyFlag())
            srfdomain.setCodename(codename);
        if(getCreateDateDirtyFlag())
            srfdomain.setCreateDate(createDate);
        if(getCreateManDirtyFlag())
            srfdomain.setCreateMan(createMan);
        if(getLogicNameDirtyFlag())
            srfdomain.setLogicName(logicName);
        if(getPSSystemIdDirtyFlag())
            srfdomain.setPSSystemId(pSSystemId);

        return srfdomain;
    }

    public void fromDO(PSDataEntity srfdomain) {
        if(srfdomain == null )
          return ;
        if(srfdomain.getUpdateManDirtyFlag())
            this.setUpdateMan(srfdomain.getUpdateMan());
        if(srfdomain.getPSDataEntityNameDirtyFlag())
            this.setPSDataEntityName(srfdomain.getPSDataEntityName());
        if(srfdomain.getPSDataEntityIdDirtyFlag())
            this.setPSDataEntityId(srfdomain.getPSDataEntityId());
        if(srfdomain.getUpdateDateDirtyFlag())
            this.setUpdateDate(srfdomain.getUpdateDate());
        if(srfdomain.getCodenameDirtyFlag())
            this.setCodename(srfdomain.getCodename());
        if(srfdomain.getCreateDateDirtyFlag())
            this.setCreateDate(srfdomain.getCreateDate());
        if(srfdomain.getCreateManDirtyFlag())
            this.setCreateMan(srfdomain.getCreateMan());
        if(srfdomain.getLogicNameDirtyFlag())
            this.setLogicName(srfdomain.getLogicName());
        if(srfdomain.getPSSystemIdDirtyFlag())
            this.setPSSystemId(srfdomain.getPSSystemId());

    }

    public List<PSDataEntityDTO> fromDOPage(List<PSDataEntity> poPage)   {
        if(poPage == null)
            return null;
        List<PSDataEntityDTO> dtos=new ArrayList<PSDataEntityDTO>();
        for(PSDataEntity domain : poPage) {
            PSDataEntityDTO dto = new PSDataEntityDTO();
            dto.fromDO(domain);
            dtos.add(dto);
        }
        return dtos;
    }
}

