package cn.ibizlab.r7.runtime.wf.service.wfapi.dto;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.math.BigInteger;
import java.util.Map;
import java.util.HashMap;
import java.io.Serializable;
import java.math.BigDecimal;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.valuerule.anno.pssysapp.*;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSSysApp;
import org.springframework.cglib.beans.BeanCopier;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * 服务DTO对象[PSSysAppDTO]
 */
public class PSSysAppDTO implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 属性 [CREATEDATE]
     *
     */
    @PSSysAppCreateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp createDate;

    @JsonIgnore
    private boolean createDateDirtyFlag;

    /**
     * 属性 [PSSYSAPPID]
     *
     */
    @PSSysAppPSSysAppIdDefault(info = "默认规则")
    private String pSSysAppId;

    @JsonIgnore
    private boolean pSSysAppIdDirtyFlag;

    /**
     * 属性 [UPDATEMAN]
     *
     */
    @PSSysAppUpdateManDefault(info = "默认规则")
    private String updateMan;

    @JsonIgnore
    private boolean updateManDirtyFlag;

    /**
     * 属性 [PROXYVIEWURL]
     *
     */
    @PSSysAppProxyviewurlDefault(info = "默认规则")
    private String proxyviewurl;

    @JsonIgnore
    private boolean proxyviewurlDirtyFlag;

    /**
     * 属性 [CREATEMAN]
     *
     */
    @PSSysAppCreateManDefault(info = "默认规则")
    private String createMan;

    @JsonIgnore
    private boolean createManDirtyFlag;

    /**
     * 属性 [APPURL]
     *
     */
    @PSSysAppAppUrlDefault(info = "默认规则")
    private String appUrl;

    @JsonIgnore
    private boolean appUrlDirtyFlag;

    /**
     * 属性 [LOGICNAME]
     *
     */
    @PSSysAppLogicNameDefault(info = "默认规则")
    private String logicName;

    @JsonIgnore
    private boolean logicNameDirtyFlag;

    /**
     * 属性 [SERVICEURL]
     *
     */
    @PSSysAppServiceUrlDefault(info = "默认规则")
    private String serviceUrl;

    @JsonIgnore
    private boolean serviceUrlDirtyFlag;

    /**
     * 属性 [PSSYSAPPNAME]
     *
     */
    @PSSysAppPSSysAppNameDefault(info = "默认规则")
    private String pSSysAppName;

    @JsonIgnore
    private boolean pSSysAppNameDirtyFlag;

    /**
     * 属性 [SERVICEID]
     *
     */
    @PSSysAppServiceIdDefault(info = "默认规则")
    private String serviceId;

    @JsonIgnore
    private boolean serviceIdDirtyFlag;

    /**
     * 属性 [UPDATEDATE]
     *
     */
    @PSSysAppUpdateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp updateDate;

    @JsonIgnore
    private boolean updateDateDirtyFlag;

    /**
     * 属性 [PSSYSTEMID]
     *
     */
    @PSSysAppPSSystemIdDefault(info = "默认规则")
    private String pSSystemId;

    @JsonIgnore
    private boolean pSSystemIdDirtyFlag;


    /**
     * 获取 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public Timestamp getCreateDate(){
        return createDate ;
    }

    /**
     * 设置 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return createDateDirtyFlag ;
    }

    /**
     * 获取 [PSSYSAPPID]
     */
    @JsonProperty("pssysappid")
    public String getPSSysAppId(){
        return pSSysAppId ;
    }

    /**
     * 设置 [PSSYSAPPID]
     */
    @JsonProperty("pssysappid")
    public void setPSSysAppId(String  pSSysAppId){
        this.pSSysAppId = pSSysAppId ;
        this.pSSysAppIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSSYSAPPID]脏标记
     */
    @JsonIgnore
    public boolean getPSSysAppIdDirtyFlag(){
        return pSSysAppIdDirtyFlag ;
    }

    /**
     * 获取 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public String getUpdateMan(){
        return updateMan ;
    }

    /**
     * 设置 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return updateManDirtyFlag ;
    }

    /**
     * 获取 [PROXYVIEWURL]
     */
    @JsonProperty("proxyviewurl")
    public String getProxyviewurl(){
        return proxyviewurl ;
    }

    /**
     * 设置 [PROXYVIEWURL]
     */
    @JsonProperty("proxyviewurl")
    public void setProxyviewurl(String  proxyviewurl){
        this.proxyviewurl = proxyviewurl ;
        this.proxyviewurlDirtyFlag = true ;
    }

    /**
     * 获取 [PROXYVIEWURL]脏标记
     */
    @JsonIgnore
    public boolean getProxyviewurlDirtyFlag(){
        return proxyviewurlDirtyFlag ;
    }

    /**
     * 获取 [CREATEMAN]
     */
    @JsonProperty("createman")
    public String getCreateMan(){
        return createMan ;
    }

    /**
     * 设置 [CREATEMAN]
     */
    @JsonProperty("createman")
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return createManDirtyFlag ;
    }

    /**
     * 获取 [APPURL]
     */
    @JsonProperty("appurl")
    public String getAppUrl(){
        return appUrl ;
    }

    /**
     * 设置 [APPURL]
     */
    @JsonProperty("appurl")
    public void setAppUrl(String  appUrl){
        this.appUrl = appUrl ;
        this.appUrlDirtyFlag = true ;
    }

    /**
     * 获取 [APPURL]脏标记
     */
    @JsonIgnore
    public boolean getAppUrlDirtyFlag(){
        return appUrlDirtyFlag ;
    }

    /**
     * 获取 [LOGICNAME]
     */
    @JsonProperty("logicname")
    public String getLogicName(){
        return logicName ;
    }

    /**
     * 设置 [LOGICNAME]
     */
    @JsonProperty("logicname")
    public void setLogicName(String  logicName){
        this.logicName = logicName ;
        this.logicNameDirtyFlag = true ;
    }

    /**
     * 获取 [LOGICNAME]脏标记
     */
    @JsonIgnore
    public boolean getLogicNameDirtyFlag(){
        return logicNameDirtyFlag ;
    }

    /**
     * 获取 [SERVICEURL]
     */
    @JsonProperty("serviceurl")
    public String getServiceUrl(){
        return serviceUrl ;
    }

    /**
     * 设置 [SERVICEURL]
     */
    @JsonProperty("serviceurl")
    public void setServiceUrl(String  serviceUrl){
        this.serviceUrl = serviceUrl ;
        this.serviceUrlDirtyFlag = true ;
    }

    /**
     * 获取 [SERVICEURL]脏标记
     */
    @JsonIgnore
    public boolean getServiceUrlDirtyFlag(){
        return serviceUrlDirtyFlag ;
    }

    /**
     * 获取 [PSSYSAPPNAME]
     */
    @JsonProperty("pssysappname")
    public String getPSSysAppName(){
        return pSSysAppName ;
    }

    /**
     * 设置 [PSSYSAPPNAME]
     */
    @JsonProperty("pssysappname")
    public void setPSSysAppName(String  pSSysAppName){
        this.pSSysAppName = pSSysAppName ;
        this.pSSysAppNameDirtyFlag = true ;
    }

    /**
     * 获取 [PSSYSAPPNAME]脏标记
     */
    @JsonIgnore
    public boolean getPSSysAppNameDirtyFlag(){
        return pSSysAppNameDirtyFlag ;
    }

    /**
     * 获取 [SERVICEID]
     */
    @JsonProperty("serviceid")
    public String getServiceId(){
        return serviceId ;
    }

    /**
     * 设置 [SERVICEID]
     */
    @JsonProperty("serviceid")
    public void setServiceId(String  serviceId){
        this.serviceId = serviceId ;
        this.serviceIdDirtyFlag = true ;
    }

    /**
     * 获取 [SERVICEID]脏标记
     */
    @JsonIgnore
    public boolean getServiceIdDirtyFlag(){
        return serviceIdDirtyFlag ;
    }

    /**
     * 获取 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public Timestamp getUpdateDate(){
        return updateDate ;
    }

    /**
     * 设置 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return updateDateDirtyFlag ;
    }

    /**
     * 获取 [PSSYSTEMID]
     */
    @JsonProperty("pssystemid")
    public String getPSSystemId(){
        return pSSystemId ;
    }

    /**
     * 设置 [PSSYSTEMID]
     */
    @JsonProperty("pssystemid")
    public void setPSSystemId(String  pSSystemId){
        this.pSSystemId = pSSystemId ;
        this.pSSystemIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSSYSTEMID]脏标记
     */
    @JsonIgnore
    public boolean getPSSystemIdDirtyFlag(){
        return pSSystemIdDirtyFlag ;
    }



    public PSSysApp toDO() {
        PSSysApp srfdomain = new PSSysApp();
        if(getCreateDateDirtyFlag())
            srfdomain.setCreateDate(createDate);
        if(getPSSysAppIdDirtyFlag())
            srfdomain.setPSSysAppId(pSSysAppId);
        if(getUpdateManDirtyFlag())
            srfdomain.setUpdateMan(updateMan);
        if(getProxyviewurlDirtyFlag())
            srfdomain.setProxyviewurl(proxyviewurl);
        if(getCreateManDirtyFlag())
            srfdomain.setCreateMan(createMan);
        if(getAppUrlDirtyFlag())
            srfdomain.setAppUrl(appUrl);
        if(getLogicNameDirtyFlag())
            srfdomain.setLogicName(logicName);
        if(getServiceUrlDirtyFlag())
            srfdomain.setServiceUrl(serviceUrl);
        if(getPSSysAppNameDirtyFlag())
            srfdomain.setPSSysAppName(pSSysAppName);
        if(getServiceIdDirtyFlag())
            srfdomain.setServiceId(serviceId);
        if(getUpdateDateDirtyFlag())
            srfdomain.setUpdateDate(updateDate);
        if(getPSSystemIdDirtyFlag())
            srfdomain.setPSSystemId(pSSystemId);

        return srfdomain;
    }

    public void fromDO(PSSysApp srfdomain) {
        if(srfdomain == null )
          return ;
        if(srfdomain.getCreateDateDirtyFlag())
            this.setCreateDate(srfdomain.getCreateDate());
        if(srfdomain.getPSSysAppIdDirtyFlag())
            this.setPSSysAppId(srfdomain.getPSSysAppId());
        if(srfdomain.getUpdateManDirtyFlag())
            this.setUpdateMan(srfdomain.getUpdateMan());
        if(srfdomain.getProxyviewurlDirtyFlag())
            this.setProxyviewurl(srfdomain.getProxyviewurl());
        if(srfdomain.getCreateManDirtyFlag())
            this.setCreateMan(srfdomain.getCreateMan());
        if(srfdomain.getAppUrlDirtyFlag())
            this.setAppUrl(srfdomain.getAppUrl());
        if(srfdomain.getLogicNameDirtyFlag())
            this.setLogicName(srfdomain.getLogicName());
        if(srfdomain.getServiceUrlDirtyFlag())
            this.setServiceUrl(srfdomain.getServiceUrl());
        if(srfdomain.getPSSysAppNameDirtyFlag())
            this.setPSSysAppName(srfdomain.getPSSysAppName());
        if(srfdomain.getServiceIdDirtyFlag())
            this.setServiceId(srfdomain.getServiceId());
        if(srfdomain.getUpdateDateDirtyFlag())
            this.setUpdateDate(srfdomain.getUpdateDate());
        if(srfdomain.getPSSystemIdDirtyFlag())
            this.setPSSystemId(srfdomain.getPSSystemId());

    }

    public List<PSSysAppDTO> fromDOPage(List<PSSysApp> poPage)   {
        if(poPage == null)
            return null;
        List<PSSysAppDTO> dtos=new ArrayList<PSSysAppDTO>();
        for(PSSysApp domain : poPage) {
            PSSysAppDTO dto = new PSSysAppDTO();
            dto.fromDO(domain);
            dtos.add(dto);
        }
        return dtos;
    }
}

