package cn.ibizlab.r7.runtime.wf.service.wfapi.dto;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.math.BigInteger;
import java.util.Map;
import java.util.HashMap;
import java.io.Serializable;
import java.math.BigDecimal;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.valuerule.anno.pssyswfcat.*;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSSysWFCat;
import org.springframework.cglib.beans.BeanCopier;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * 服务DTO对象[PSSysWFCatDTO]
 */
public class PSSysWFCatDTO implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 属性 [UPDATEDATE]
     *
     */
    @PSSysWFCatUpdateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp updateDate;

    @JsonIgnore
    private boolean updateDateDirtyFlag;

    /**
     * 属性 [PSSYSWFCATID]
     *
     */
    @PSSysWFCatPSSysWFCatIdDefault(info = "默认规则")
    private String pSSysWFCatId;

    @JsonIgnore
    private boolean pSSysWFCatIdDirtyFlag;

    /**
     * 属性 [PSSYSWFCATNAME]
     *
     */
    @PSSysWFCatPSSysWFCatNameDefault(info = "默认规则")
    private String pSSysWFCatName;

    @JsonIgnore
    private boolean pSSysWFCatNameDirtyFlag;

    /**
     * 属性 [CREATEDATE]
     *
     */
    @PSSysWFCatCreateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp createDate;

    @JsonIgnore
    private boolean createDateDirtyFlag;

    /**
     * 属性 [CREATEMAN]
     *
     */
    @PSSysWFCatCreateManDefault(info = "默认规则")
    private String createMan;

    @JsonIgnore
    private boolean createManDirtyFlag;

    /**
     * 属性 [UPDATEMAN]
     *
     */
    @PSSysWFCatUpdateManDefault(info = "默认规则")
    private String updateMan;

    @JsonIgnore
    private boolean updateManDirtyFlag;


    /**
     * 获取 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public Timestamp getUpdateDate(){
        return updateDate ;
    }

    /**
     * 设置 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return updateDateDirtyFlag ;
    }

    /**
     * 获取 [PSSYSWFCATID]
     */
    @JsonProperty("pssyswfcatid")
    public String getPSSysWFCatId(){
        return pSSysWFCatId ;
    }

    /**
     * 设置 [PSSYSWFCATID]
     */
    @JsonProperty("pssyswfcatid")
    public void setPSSysWFCatId(String  pSSysWFCatId){
        this.pSSysWFCatId = pSSysWFCatId ;
        this.pSSysWFCatIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSSYSWFCATID]脏标记
     */
    @JsonIgnore
    public boolean getPSSysWFCatIdDirtyFlag(){
        return pSSysWFCatIdDirtyFlag ;
    }

    /**
     * 获取 [PSSYSWFCATNAME]
     */
    @JsonProperty("pssyswfcatname")
    public String getPSSysWFCatName(){
        return pSSysWFCatName ;
    }

    /**
     * 设置 [PSSYSWFCATNAME]
     */
    @JsonProperty("pssyswfcatname")
    public void setPSSysWFCatName(String  pSSysWFCatName){
        this.pSSysWFCatName = pSSysWFCatName ;
        this.pSSysWFCatNameDirtyFlag = true ;
    }

    /**
     * 获取 [PSSYSWFCATNAME]脏标记
     */
    @JsonIgnore
    public boolean getPSSysWFCatNameDirtyFlag(){
        return pSSysWFCatNameDirtyFlag ;
    }

    /**
     * 获取 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public Timestamp getCreateDate(){
        return createDate ;
    }

    /**
     * 设置 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return createDateDirtyFlag ;
    }

    /**
     * 获取 [CREATEMAN]
     */
    @JsonProperty("createman")
    public String getCreateMan(){
        return createMan ;
    }

    /**
     * 设置 [CREATEMAN]
     */
    @JsonProperty("createman")
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return createManDirtyFlag ;
    }

    /**
     * 获取 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public String getUpdateMan(){
        return updateMan ;
    }

    /**
     * 设置 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return updateManDirtyFlag ;
    }



    public PSSysWFCat toDO() {
        PSSysWFCat srfdomain = new PSSysWFCat();
        if(getUpdateDateDirtyFlag())
            srfdomain.setUpdateDate(updateDate);
        if(getPSSysWFCatIdDirtyFlag())
            srfdomain.setPSSysWFCatId(pSSysWFCatId);
        if(getPSSysWFCatNameDirtyFlag())
            srfdomain.setPSSysWFCatName(pSSysWFCatName);
        if(getCreateDateDirtyFlag())
            srfdomain.setCreateDate(createDate);
        if(getCreateManDirtyFlag())
            srfdomain.setCreateMan(createMan);
        if(getUpdateManDirtyFlag())
            srfdomain.setUpdateMan(updateMan);

        return srfdomain;
    }

    public void fromDO(PSSysWFCat srfdomain) {
        if(srfdomain == null )
          return ;
        if(srfdomain.getUpdateDateDirtyFlag())
            this.setUpdateDate(srfdomain.getUpdateDate());
        if(srfdomain.getPSSysWFCatIdDirtyFlag())
            this.setPSSysWFCatId(srfdomain.getPSSysWFCatId());
        if(srfdomain.getPSSysWFCatNameDirtyFlag())
            this.setPSSysWFCatName(srfdomain.getPSSysWFCatName());
        if(srfdomain.getCreateDateDirtyFlag())
            this.setCreateDate(srfdomain.getCreateDate());
        if(srfdomain.getCreateManDirtyFlag())
            this.setCreateMan(srfdomain.getCreateMan());
        if(srfdomain.getUpdateManDirtyFlag())
            this.setUpdateMan(srfdomain.getUpdateMan());

    }

    public List<PSSysWFCatDTO> fromDOPage(List<PSSysWFCat> poPage)   {
        if(poPage == null)
            return null;
        List<PSSysWFCatDTO> dtos=new ArrayList<PSSysWFCatDTO>();
        for(PSSysWFCat domain : poPage) {
            PSSysWFCatDTO dto = new PSSysWFCatDTO();
            dto.fromDO(domain);
            dtos.add(dto);
        }
        return dtos;
    }
}

