package cn.ibizlab.r7.runtime.wf.service.wfapi.dto;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.math.BigInteger;
import java.util.Map;
import java.util.HashMap;
import java.io.Serializable;
import java.math.BigDecimal;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.valuerule.anno.pswflink.*;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFLink;
import org.springframework.cglib.beans.BeanCopier;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * 服务DTO对象[PSWFLinkDTO]
 */
public class PSWFLinkDTO implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 属性 [UPDATEDATE]
     *
     */
    @PSWFLinkUpdateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp updateDate;

    @JsonIgnore
    private boolean updateDateDirtyFlag;

    /**
     * 属性 [LOGICNAME]
     *
     */
    @PSWFLinkLogicNameDefault(info = "默认规则")
    private String logicName;

    @JsonIgnore
    private boolean logicNameDirtyFlag;

    /**
     * 属性 [CREATEDATE]
     *
     */
    @PSWFLinkCreateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp createDate;

    @JsonIgnore
    private boolean createDateDirtyFlag;

    /**
     * 属性 [PSWFLINKID]
     *
     */
    @PSWFLinkPSWFLinkIdDefault(info = "默认规则")
    private String pSWFLinkId;

    @JsonIgnore
    private boolean pSWFLinkIdDirtyFlag;

    /**
     * 属性 [UPDATEMAN]
     *
     */
    @PSWFLinkUpdateManDefault(info = "默认规则")
    private String updateMan;

    @JsonIgnore
    private boolean updateManDirtyFlag;

    /**
     * 属性 [CREATEMAN]
     *
     */
    @PSWFLinkCreateManDefault(info = "默认规则")
    private String createMan;

    @JsonIgnore
    private boolean createManDirtyFlag;

    /**
     * 属性 [PSWFLINKNAME]
     *
     */
    @PSWFLinkPSWFLinkNameDefault(info = "默认规则")
    private String pSWFLinkName;

    @JsonIgnore
    private boolean pSWFLinkNameDirtyFlag;

    /**
     * 属性 [FROMPSWFPROCID]
     *
     */
    @PSWFLinkFrompswfprocidDefault(info = "默认规则")
    private String frompswfprocid;

    @JsonIgnore
    private boolean frompswfprocidDirtyFlag;

    /**
     * 属性 [PSWFVERSIONID]
     *
     */
    @PSWFLinkPSWFVersionIdDefault(info = "默认规则")
    private String pSWFVersionId;

    @JsonIgnore
    private boolean pSWFVersionIdDirtyFlag;

    /**
     * 属性 [TOPSWFPROCID]
     *
     */
    @PSWFLinkTopswfprocidDefault(info = "默认规则")
    private String topswfprocid;

    @JsonIgnore
    private boolean topswfprocidDirtyFlag;


    /**
     * 获取 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public Timestamp getUpdateDate(){
        return updateDate ;
    }

    /**
     * 设置 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return updateDateDirtyFlag ;
    }

    /**
     * 获取 [LOGICNAME]
     */
    @JsonProperty("logicname")
    public String getLogicName(){
        return logicName ;
    }

    /**
     * 设置 [LOGICNAME]
     */
    @JsonProperty("logicname")
    public void setLogicName(String  logicName){
        this.logicName = logicName ;
        this.logicNameDirtyFlag = true ;
    }

    /**
     * 获取 [LOGICNAME]脏标记
     */
    @JsonIgnore
    public boolean getLogicNameDirtyFlag(){
        return logicNameDirtyFlag ;
    }

    /**
     * 获取 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public Timestamp getCreateDate(){
        return createDate ;
    }

    /**
     * 设置 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return createDateDirtyFlag ;
    }

    /**
     * 获取 [PSWFLINKID]
     */
    @JsonProperty("pswflinkid")
    public String getPSWFLinkId(){
        return pSWFLinkId ;
    }

    /**
     * 设置 [PSWFLINKID]
     */
    @JsonProperty("pswflinkid")
    public void setPSWFLinkId(String  pSWFLinkId){
        this.pSWFLinkId = pSWFLinkId ;
        this.pSWFLinkIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSWFLINKID]脏标记
     */
    @JsonIgnore
    public boolean getPSWFLinkIdDirtyFlag(){
        return pSWFLinkIdDirtyFlag ;
    }

    /**
     * 获取 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public String getUpdateMan(){
        return updateMan ;
    }

    /**
     * 设置 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return updateManDirtyFlag ;
    }

    /**
     * 获取 [CREATEMAN]
     */
    @JsonProperty("createman")
    public String getCreateMan(){
        return createMan ;
    }

    /**
     * 设置 [CREATEMAN]
     */
    @JsonProperty("createman")
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return createManDirtyFlag ;
    }

    /**
     * 获取 [PSWFLINKNAME]
     */
    @JsonProperty("pswflinkname")
    public String getPSWFLinkName(){
        return pSWFLinkName ;
    }

    /**
     * 设置 [PSWFLINKNAME]
     */
    @JsonProperty("pswflinkname")
    public void setPSWFLinkName(String  pSWFLinkName){
        this.pSWFLinkName = pSWFLinkName ;
        this.pSWFLinkNameDirtyFlag = true ;
    }

    /**
     * 获取 [PSWFLINKNAME]脏标记
     */
    @JsonIgnore
    public boolean getPSWFLinkNameDirtyFlag(){
        return pSWFLinkNameDirtyFlag ;
    }

    /**
     * 获取 [FROMPSWFPROCID]
     */
    @JsonProperty("frompswfprocid")
    public String getFrompswfprocid(){
        return frompswfprocid ;
    }

    /**
     * 设置 [FROMPSWFPROCID]
     */
    @JsonProperty("frompswfprocid")
    public void setFrompswfprocid(String  frompswfprocid){
        this.frompswfprocid = frompswfprocid ;
        this.frompswfprocidDirtyFlag = true ;
    }

    /**
     * 获取 [FROMPSWFPROCID]脏标记
     */
    @JsonIgnore
    public boolean getFrompswfprocidDirtyFlag(){
        return frompswfprocidDirtyFlag ;
    }

    /**
     * 获取 [PSWFVERSIONID]
     */
    @JsonProperty("pswfversionid")
    public String getPSWFVersionId(){
        return pSWFVersionId ;
    }

    /**
     * 设置 [PSWFVERSIONID]
     */
    @JsonProperty("pswfversionid")
    public void setPSWFVersionId(String  pSWFVersionId){
        this.pSWFVersionId = pSWFVersionId ;
        this.pSWFVersionIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSWFVERSIONID]脏标记
     */
    @JsonIgnore
    public boolean getPSWFVersionIdDirtyFlag(){
        return pSWFVersionIdDirtyFlag ;
    }

    /**
     * 获取 [TOPSWFPROCID]
     */
    @JsonProperty("topswfprocid")
    public String getTopswfprocid(){
        return topswfprocid ;
    }

    /**
     * 设置 [TOPSWFPROCID]
     */
    @JsonProperty("topswfprocid")
    public void setTopswfprocid(String  topswfprocid){
        this.topswfprocid = topswfprocid ;
        this.topswfprocidDirtyFlag = true ;
    }

    /**
     * 获取 [TOPSWFPROCID]脏标记
     */
    @JsonIgnore
    public boolean getTopswfprocidDirtyFlag(){
        return topswfprocidDirtyFlag ;
    }



    public PSWFLink toDO() {
        PSWFLink srfdomain = new PSWFLink();
        if(getUpdateDateDirtyFlag())
            srfdomain.setUpdateDate(updateDate);
        if(getLogicNameDirtyFlag())
            srfdomain.setLogicName(logicName);
        if(getCreateDateDirtyFlag())
            srfdomain.setCreateDate(createDate);
        if(getPSWFLinkIdDirtyFlag())
            srfdomain.setPSWFLinkId(pSWFLinkId);
        if(getUpdateManDirtyFlag())
            srfdomain.setUpdateMan(updateMan);
        if(getCreateManDirtyFlag())
            srfdomain.setCreateMan(createMan);
        if(getPSWFLinkNameDirtyFlag())
            srfdomain.setPSWFLinkName(pSWFLinkName);
        if(getFrompswfprocidDirtyFlag())
            srfdomain.setFrompswfprocid(frompswfprocid);
        if(getPSWFVersionIdDirtyFlag())
            srfdomain.setPSWFVersionId(pSWFVersionId);
        if(getTopswfprocidDirtyFlag())
            srfdomain.setTopswfprocid(topswfprocid);

        return srfdomain;
    }

    public void fromDO(PSWFLink srfdomain) {
        if(srfdomain == null )
          return ;
        if(srfdomain.getUpdateDateDirtyFlag())
            this.setUpdateDate(srfdomain.getUpdateDate());
        if(srfdomain.getLogicNameDirtyFlag())
            this.setLogicName(srfdomain.getLogicName());
        if(srfdomain.getCreateDateDirtyFlag())
            this.setCreateDate(srfdomain.getCreateDate());
        if(srfdomain.getPSWFLinkIdDirtyFlag())
            this.setPSWFLinkId(srfdomain.getPSWFLinkId());
        if(srfdomain.getUpdateManDirtyFlag())
            this.setUpdateMan(srfdomain.getUpdateMan());
        if(srfdomain.getCreateManDirtyFlag())
            this.setCreateMan(srfdomain.getCreateMan());
        if(srfdomain.getPSWFLinkNameDirtyFlag())
            this.setPSWFLinkName(srfdomain.getPSWFLinkName());
        if(srfdomain.getFrompswfprocidDirtyFlag())
            this.setFrompswfprocid(srfdomain.getFrompswfprocid());
        if(srfdomain.getPSWFVersionIdDirtyFlag())
            this.setPSWFVersionId(srfdomain.getPSWFVersionId());
        if(srfdomain.getTopswfprocidDirtyFlag())
            this.setTopswfprocid(srfdomain.getTopswfprocid());

    }

    public List<PSWFLinkDTO> fromDOPage(List<PSWFLink> poPage)   {
        if(poPage == null)
            return null;
        List<PSWFLinkDTO> dtos=new ArrayList<PSWFLinkDTO>();
        for(PSWFLink domain : poPage) {
            PSWFLinkDTO dto = new PSWFLinkDTO();
            dto.fromDO(domain);
            dtos.add(dto);
        }
        return dtos;
    }
}

