package cn.ibizlab.r7.runtime.wf.service.wfapi.dto;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.math.BigInteger;
import java.util.Map;
import java.util.HashMap;
import java.io.Serializable;
import java.math.BigDecimal;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.valuerule.anno.pswfprocrole.*;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFProcRole;
import org.springframework.cglib.beans.BeanCopier;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * 服务DTO对象[PSWFProcRoleDTO]
 */
public class PSWFProcRoleDTO implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 属性 [ROLETYPE]
     *
     */
    @PSWFProcRoleRoleTypeDefault(info = "默认规则")
    private String roleType;

    @JsonIgnore
    private boolean roleTypeDirtyFlag;

    /**
     * 属性 [CREATEDATE]
     *
     */
    @PSWFProcRoleCreateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp createDate;

    @JsonIgnore
    private boolean createDateDirtyFlag;

    /**
     * 属性 [UDFIELD]
     *
     */
    @PSWFProcRoleUdfieldDefault(info = "默认规则")
    private String udfield;

    @JsonIgnore
    private boolean udfieldDirtyFlag;

    /**
     * 属性 [PSWFPROCROLENAME]
     *
     */
    @PSWFProcRolePSWFProcRoleNameDefault(info = "默认规则")
    private String pSWFProcRoleName;

    @JsonIgnore
    private boolean pSWFProcRoleNameDirtyFlag;

    /**
     * 属性 [CREATEMAN]
     *
     */
    @PSWFProcRoleCreateManDefault(info = "默认规则")
    private String createMan;

    @JsonIgnore
    private boolean createManDirtyFlag;

    /**
     * 属性 [UPDATEDATE]
     *
     */
    @PSWFProcRoleUpdateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp updateDate;

    @JsonIgnore
    private boolean updateDateDirtyFlag;

    /**
     * 属性 [UPDATEMAN]
     *
     */
    @PSWFProcRoleUpdateManDefault(info = "默认规则")
    private String updateMan;

    @JsonIgnore
    private boolean updateManDirtyFlag;

    /**
     * 属性 [PSWFPROCROLEID]
     *
     */
    @PSWFProcRolePSWFProcRoleIdDefault(info = "默认规则")
    private String pSWFProcRoleId;

    @JsonIgnore
    private boolean pSWFProcRoleIdDirtyFlag;

    /**
     * 属性 [PSWFPROCESSNAME]
     *
     */
    @PSWFProcRolePSWFProcessNameDefault(info = "默认规则")
    private String pSWFProcessName;

    @JsonIgnore
    private boolean pSWFProcessNameDirtyFlag;

    /**
     * 属性 [PSWFPROCESSID]
     *
     */
    @PSWFProcRolePSWFProcessIdDefault(info = "默认规则")
    private String pSWFProcessId;

    @JsonIgnore
    private boolean pSWFProcessIdDirtyFlag;

    /**
     * 属性 [PSWFROLEID]
     *
     */
    @PSWFProcRolePSWFRoleIdDefault(info = "默认规则")
    private String pSWFRoleId;

    @JsonIgnore
    private boolean pSWFRoleIdDirtyFlag;


    /**
     * 获取 [ROLETYPE]
     */
    @JsonProperty("roletype")
    public String getRoleType(){
        return roleType ;
    }

    /**
     * 设置 [ROLETYPE]
     */
    @JsonProperty("roletype")
    public void setRoleType(String  roleType){
        this.roleType = roleType ;
        this.roleTypeDirtyFlag = true ;
    }

    /**
     * 获取 [ROLETYPE]脏标记
     */
    @JsonIgnore
    public boolean getRoleTypeDirtyFlag(){
        return roleTypeDirtyFlag ;
    }

    /**
     * 获取 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public Timestamp getCreateDate(){
        return createDate ;
    }

    /**
     * 设置 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return createDateDirtyFlag ;
    }

    /**
     * 获取 [UDFIELD]
     */
    @JsonProperty("udfield")
    public String getUdfield(){
        return udfield ;
    }

    /**
     * 设置 [UDFIELD]
     */
    @JsonProperty("udfield")
    public void setUdfield(String  udfield){
        this.udfield = udfield ;
        this.udfieldDirtyFlag = true ;
    }

    /**
     * 获取 [UDFIELD]脏标记
     */
    @JsonIgnore
    public boolean getUdfieldDirtyFlag(){
        return udfieldDirtyFlag ;
    }

    /**
     * 获取 [PSWFPROCROLENAME]
     */
    @JsonProperty("pswfprocrolename")
    public String getPSWFProcRoleName(){
        return pSWFProcRoleName ;
    }

    /**
     * 设置 [PSWFPROCROLENAME]
     */
    @JsonProperty("pswfprocrolename")
    public void setPSWFProcRoleName(String  pSWFProcRoleName){
        this.pSWFProcRoleName = pSWFProcRoleName ;
        this.pSWFProcRoleNameDirtyFlag = true ;
    }

    /**
     * 获取 [PSWFPROCROLENAME]脏标记
     */
    @JsonIgnore
    public boolean getPSWFProcRoleNameDirtyFlag(){
        return pSWFProcRoleNameDirtyFlag ;
    }

    /**
     * 获取 [CREATEMAN]
     */
    @JsonProperty("createman")
    public String getCreateMan(){
        return createMan ;
    }

    /**
     * 设置 [CREATEMAN]
     */
    @JsonProperty("createman")
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return createManDirtyFlag ;
    }

    /**
     * 获取 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public Timestamp getUpdateDate(){
        return updateDate ;
    }

    /**
     * 设置 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return updateDateDirtyFlag ;
    }

    /**
     * 获取 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public String getUpdateMan(){
        return updateMan ;
    }

    /**
     * 设置 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return updateManDirtyFlag ;
    }

    /**
     * 获取 [PSWFPROCROLEID]
     */
    @JsonProperty("pswfprocroleid")
    public String getPSWFProcRoleId(){
        return pSWFProcRoleId ;
    }

    /**
     * 设置 [PSWFPROCROLEID]
     */
    @JsonProperty("pswfprocroleid")
    public void setPSWFProcRoleId(String  pSWFProcRoleId){
        this.pSWFProcRoleId = pSWFProcRoleId ;
        this.pSWFProcRoleIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSWFPROCROLEID]脏标记
     */
    @JsonIgnore
    public boolean getPSWFProcRoleIdDirtyFlag(){
        return pSWFProcRoleIdDirtyFlag ;
    }

    /**
     * 获取 [PSWFPROCESSNAME]
     */
    @JsonProperty("pswfprocessname")
    public String getPSWFProcessName(){
        return pSWFProcessName ;
    }

    /**
     * 设置 [PSWFPROCESSNAME]
     */
    @JsonProperty("pswfprocessname")
    public void setPSWFProcessName(String  pSWFProcessName){
        this.pSWFProcessName = pSWFProcessName ;
        this.pSWFProcessNameDirtyFlag = true ;
    }

    /**
     * 获取 [PSWFPROCESSNAME]脏标记
     */
    @JsonIgnore
    public boolean getPSWFProcessNameDirtyFlag(){
        return pSWFProcessNameDirtyFlag ;
    }

    /**
     * 获取 [PSWFPROCESSID]
     */
    @JsonProperty("pswfprocessid")
    public String getPSWFProcessId(){
        return pSWFProcessId ;
    }

    /**
     * 设置 [PSWFPROCESSID]
     */
    @JsonProperty("pswfprocessid")
    public void setPSWFProcessId(String  pSWFProcessId){
        this.pSWFProcessId = pSWFProcessId ;
        this.pSWFProcessIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSWFPROCESSID]脏标记
     */
    @JsonIgnore
    public boolean getPSWFProcessIdDirtyFlag(){
        return pSWFProcessIdDirtyFlag ;
    }

    /**
     * 获取 [PSWFROLEID]
     */
    @JsonProperty("pswfroleid")
    public String getPSWFRoleId(){
        return pSWFRoleId ;
    }

    /**
     * 设置 [PSWFROLEID]
     */
    @JsonProperty("pswfroleid")
    public void setPSWFRoleId(String  pSWFRoleId){
        this.pSWFRoleId = pSWFRoleId ;
        this.pSWFRoleIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSWFROLEID]脏标记
     */
    @JsonIgnore
    public boolean getPSWFRoleIdDirtyFlag(){
        return pSWFRoleIdDirtyFlag ;
    }



    public PSWFProcRole toDO() {
        PSWFProcRole srfdomain = new PSWFProcRole();
        if(getRoleTypeDirtyFlag())
            srfdomain.setRoleType(roleType);
        if(getCreateDateDirtyFlag())
            srfdomain.setCreateDate(createDate);
        if(getUdfieldDirtyFlag())
            srfdomain.setUdfield(udfield);
        if(getPSWFProcRoleNameDirtyFlag())
            srfdomain.setPSWFProcRoleName(pSWFProcRoleName);
        if(getCreateManDirtyFlag())
            srfdomain.setCreateMan(createMan);
        if(getUpdateDateDirtyFlag())
            srfdomain.setUpdateDate(updateDate);
        if(getUpdateManDirtyFlag())
            srfdomain.setUpdateMan(updateMan);
        if(getPSWFProcRoleIdDirtyFlag())
            srfdomain.setPSWFProcRoleId(pSWFProcRoleId);
        if(getPSWFProcessNameDirtyFlag())
            srfdomain.setPSWFProcessName(pSWFProcessName);
        if(getPSWFProcessIdDirtyFlag())
            srfdomain.setPSWFProcessId(pSWFProcessId);
        if(getPSWFRoleIdDirtyFlag())
            srfdomain.setPSWFRoleId(pSWFRoleId);

        return srfdomain;
    }

    public void fromDO(PSWFProcRole srfdomain) {
        if(srfdomain == null )
          return ;
        if(srfdomain.getRoleTypeDirtyFlag())
            this.setRoleType(srfdomain.getRoleType());
        if(srfdomain.getCreateDateDirtyFlag())
            this.setCreateDate(srfdomain.getCreateDate());
        if(srfdomain.getUdfieldDirtyFlag())
            this.setUdfield(srfdomain.getUdfield());
        if(srfdomain.getPSWFProcRoleNameDirtyFlag())
            this.setPSWFProcRoleName(srfdomain.getPSWFProcRoleName());
        if(srfdomain.getCreateManDirtyFlag())
            this.setCreateMan(srfdomain.getCreateMan());
        if(srfdomain.getUpdateDateDirtyFlag())
            this.setUpdateDate(srfdomain.getUpdateDate());
        if(srfdomain.getUpdateManDirtyFlag())
            this.setUpdateMan(srfdomain.getUpdateMan());
        if(srfdomain.getPSWFProcRoleIdDirtyFlag())
            this.setPSWFProcRoleId(srfdomain.getPSWFProcRoleId());
        if(srfdomain.getPSWFProcessNameDirtyFlag())
            this.setPSWFProcessName(srfdomain.getPSWFProcessName());
        if(srfdomain.getPSWFProcessIdDirtyFlag())
            this.setPSWFProcessId(srfdomain.getPSWFProcessId());
        if(srfdomain.getPSWFRoleIdDirtyFlag())
            this.setPSWFRoleId(srfdomain.getPSWFRoleId());

    }

    public List<PSWFProcRoleDTO> fromDOPage(List<PSWFProcRole> poPage)   {
        if(poPage == null)
            return null;
        List<PSWFProcRoleDTO> dtos=new ArrayList<PSWFProcRoleDTO>();
        for(PSWFProcRole domain : poPage) {
            PSWFProcRoleDTO dto = new PSWFProcRoleDTO();
            dto.fromDO(domain);
            dtos.add(dto);
        }
        return dtos;
    }
}

