package cn.ibizlab.r7.runtime.wf.service.wfapi.dto;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.math.BigInteger;
import java.util.Map;
import java.util.HashMap;
import java.io.Serializable;
import java.math.BigDecimal;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.valuerule.anno.pswfprocess.*;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFProcess;
import org.springframework.cglib.beans.BeanCopier;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * 服务DTO对象[PSWFProcessDTO]
 */
public class PSWFProcessDTO implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 属性 [UPDATEMAN]
     *
     */
    @PSWFProcessUpdateManDefault(info = "默认规则")
    private String updateMan;

    @JsonIgnore
    private boolean updateManDirtyFlag;

    /**
     * 属性 [CREATEMAN]
     *
     */
    @PSWFProcessCreateManDefault(info = "默认规则")
    private String createMan;

    @JsonIgnore
    private boolean createManDirtyFlag;

    /**
     * 属性 [PREDEFINEDACTIONS]
     *
     */
    @PSWFProcessPreDefinedActionsDefault(info = "默认规则")
    private String preDefinedActions;

    @JsonIgnore
    private boolean preDefinedActionsDirtyFlag;

    /**
     * 属性 [WFPROCESSTYPE]
     *
     */
    @PSWFProcessWFProcessTypeDefault(info = "默认规则")
    private String wFProcessType;

    @JsonIgnore
    private boolean wFProcessTypeDirtyFlag;

    /**
     * 属性 [PSWFPROCESSNAME]
     *
     */
    @PSWFProcessPSWFProcessNameDefault(info = "默认规则")
    private String pSWFProcessName;

    @JsonIgnore
    private boolean pSWFProcessNameDirtyFlag;

    /**
     * 属性 [PSWFPROCESSID]
     *
     */
    @PSWFProcessPSWFProcessIdDefault(info = "默认规则")
    private String pSWFProcessId;

    @JsonIgnore
    private boolean pSWFProcessIdDirtyFlag;

    /**
     * 属性 [UPDATEDATE]
     *
     */
    @PSWFProcessUpdateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp updateDate;

    @JsonIgnore
    private boolean updateDateDirtyFlag;

    /**
     * 属性 [WFSTEPVALUE]
     *
     */
    @PSWFProcessWFStepValueDefault(info = "默认规则")
    private String wFStepValue;

    @JsonIgnore
    private boolean wFStepValueDirtyFlag;

    /**
     * 属性 [MULTIINSTMODE]
     *
     */
    @PSWFProcessMultiInstModeDefault(info = "默认规则")
    private String multiInstMode;

    @JsonIgnore
    private boolean multiInstModeDirtyFlag;

    /**
     * 属性 [CREATEDATE]
     *
     */
    @PSWFProcessCreateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp createDate;

    @JsonIgnore
    private boolean createDateDirtyFlag;

    /**
     * 属性 [WFSTEPNAME]
     *
     */
    @PSWFProcessWFStepNameDefault(info = "默认规则")
    private String wFStepName;

    @JsonIgnore
    private boolean wFStepNameDirtyFlag;

    /**
     * 属性 [PSWFVERSIONNAME]
     *
     */
    @PSWFProcessPSWFVersionNameDefault(info = "默认规则")
    private String pSWFVersionName;

    @JsonIgnore
    private boolean pSWFVersionNameDirtyFlag;

    /**
     * 属性 [TARGETPSWFID]
     *
     */
    @PSWFProcessTargetpswfidDefault(info = "默认规则")
    private String targetpswfid;

    @JsonIgnore
    private boolean targetpswfidDirtyFlag;

    /**
     * 属性 [PSWFVERSIONID]
     *
     */
    @PSWFProcessPSWFVersionIdDefault(info = "默认规则")
    private String pSWFVersionId;

    @JsonIgnore
    private boolean pSWFVersionIdDirtyFlag;


    /**
     * 获取 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public String getUpdateMan(){
        return updateMan ;
    }

    /**
     * 设置 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return updateManDirtyFlag ;
    }

    /**
     * 获取 [CREATEMAN]
     */
    @JsonProperty("createman")
    public String getCreateMan(){
        return createMan ;
    }

    /**
     * 设置 [CREATEMAN]
     */
    @JsonProperty("createman")
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return createManDirtyFlag ;
    }

    /**
     * 获取 [PREDEFINEDACTIONS]
     */
    @JsonProperty("predefinedactions")
    public String getPreDefinedActions(){
        return preDefinedActions ;
    }

    /**
     * 设置 [PREDEFINEDACTIONS]
     */
    @JsonProperty("predefinedactions")
    public void setPreDefinedActions(String  preDefinedActions){
        this.preDefinedActions = preDefinedActions ;
        this.preDefinedActionsDirtyFlag = true ;
    }

    /**
     * 获取 [PREDEFINEDACTIONS]脏标记
     */
    @JsonIgnore
    public boolean getPreDefinedActionsDirtyFlag(){
        return preDefinedActionsDirtyFlag ;
    }

    /**
     * 获取 [WFPROCESSTYPE]
     */
    @JsonProperty("wfprocesstype")
    public String getWFProcessType(){
        return wFProcessType ;
    }

    /**
     * 设置 [WFPROCESSTYPE]
     */
    @JsonProperty("wfprocesstype")
    public void setWFProcessType(String  wFProcessType){
        this.wFProcessType = wFProcessType ;
        this.wFProcessTypeDirtyFlag = true ;
    }

    /**
     * 获取 [WFPROCESSTYPE]脏标记
     */
    @JsonIgnore
    public boolean getWFProcessTypeDirtyFlag(){
        return wFProcessTypeDirtyFlag ;
    }

    /**
     * 获取 [PSWFPROCESSNAME]
     */
    @JsonProperty("pswfprocessname")
    public String getPSWFProcessName(){
        return pSWFProcessName ;
    }

    /**
     * 设置 [PSWFPROCESSNAME]
     */
    @JsonProperty("pswfprocessname")
    public void setPSWFProcessName(String  pSWFProcessName){
        this.pSWFProcessName = pSWFProcessName ;
        this.pSWFProcessNameDirtyFlag = true ;
    }

    /**
     * 获取 [PSWFPROCESSNAME]脏标记
     */
    @JsonIgnore
    public boolean getPSWFProcessNameDirtyFlag(){
        return pSWFProcessNameDirtyFlag ;
    }

    /**
     * 获取 [PSWFPROCESSID]
     */
    @JsonProperty("pswfprocessid")
    public String getPSWFProcessId(){
        return pSWFProcessId ;
    }

    /**
     * 设置 [PSWFPROCESSID]
     */
    @JsonProperty("pswfprocessid")
    public void setPSWFProcessId(String  pSWFProcessId){
        this.pSWFProcessId = pSWFProcessId ;
        this.pSWFProcessIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSWFPROCESSID]脏标记
     */
    @JsonIgnore
    public boolean getPSWFProcessIdDirtyFlag(){
        return pSWFProcessIdDirtyFlag ;
    }

    /**
     * 获取 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public Timestamp getUpdateDate(){
        return updateDate ;
    }

    /**
     * 设置 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return updateDateDirtyFlag ;
    }

    /**
     * 获取 [WFSTEPVALUE]
     */
    @JsonProperty("wfstepvalue")
    public String getWFStepValue(){
        return wFStepValue ;
    }

    /**
     * 设置 [WFSTEPVALUE]
     */
    @JsonProperty("wfstepvalue")
    public void setWFStepValue(String  wFStepValue){
        this.wFStepValue = wFStepValue ;
        this.wFStepValueDirtyFlag = true ;
    }

    /**
     * 获取 [WFSTEPVALUE]脏标记
     */
    @JsonIgnore
    public boolean getWFStepValueDirtyFlag(){
        return wFStepValueDirtyFlag ;
    }

    /**
     * 获取 [MULTIINSTMODE]
     */
    @JsonProperty("multiinstmode")
    public String getMultiInstMode(){
        return multiInstMode ;
    }

    /**
     * 设置 [MULTIINSTMODE]
     */
    @JsonProperty("multiinstmode")
    public void setMultiInstMode(String  multiInstMode){
        this.multiInstMode = multiInstMode ;
        this.multiInstModeDirtyFlag = true ;
    }

    /**
     * 获取 [MULTIINSTMODE]脏标记
     */
    @JsonIgnore
    public boolean getMultiInstModeDirtyFlag(){
        return multiInstModeDirtyFlag ;
    }

    /**
     * 获取 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public Timestamp getCreateDate(){
        return createDate ;
    }

    /**
     * 设置 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return createDateDirtyFlag ;
    }

    /**
     * 获取 [WFSTEPNAME]
     */
    @JsonProperty("wfstepname")
    public String getWFStepName(){
        return wFStepName ;
    }

    /**
     * 设置 [WFSTEPNAME]
     */
    @JsonProperty("wfstepname")
    public void setWFStepName(String  wFStepName){
        this.wFStepName = wFStepName ;
        this.wFStepNameDirtyFlag = true ;
    }

    /**
     * 获取 [WFSTEPNAME]脏标记
     */
    @JsonIgnore
    public boolean getWFStepNameDirtyFlag(){
        return wFStepNameDirtyFlag ;
    }

    /**
     * 获取 [PSWFVERSIONNAME]
     */
    @JsonProperty("pswfversionname")
    public String getPSWFVersionName(){
        return pSWFVersionName ;
    }

    /**
     * 设置 [PSWFVERSIONNAME]
     */
    @JsonProperty("pswfversionname")
    public void setPSWFVersionName(String  pSWFVersionName){
        this.pSWFVersionName = pSWFVersionName ;
        this.pSWFVersionNameDirtyFlag = true ;
    }

    /**
     * 获取 [PSWFVERSIONNAME]脏标记
     */
    @JsonIgnore
    public boolean getPSWFVersionNameDirtyFlag(){
        return pSWFVersionNameDirtyFlag ;
    }

    /**
     * 获取 [TARGETPSWFID]
     */
    @JsonProperty("targetpswfid")
    public String getTargetpswfid(){
        return targetpswfid ;
    }

    /**
     * 设置 [TARGETPSWFID]
     */
    @JsonProperty("targetpswfid")
    public void setTargetpswfid(String  targetpswfid){
        this.targetpswfid = targetpswfid ;
        this.targetpswfidDirtyFlag = true ;
    }

    /**
     * 获取 [TARGETPSWFID]脏标记
     */
    @JsonIgnore
    public boolean getTargetpswfidDirtyFlag(){
        return targetpswfidDirtyFlag ;
    }

    /**
     * 获取 [PSWFVERSIONID]
     */
    @JsonProperty("pswfversionid")
    public String getPSWFVersionId(){
        return pSWFVersionId ;
    }

    /**
     * 设置 [PSWFVERSIONID]
     */
    @JsonProperty("pswfversionid")
    public void setPSWFVersionId(String  pSWFVersionId){
        this.pSWFVersionId = pSWFVersionId ;
        this.pSWFVersionIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSWFVERSIONID]脏标记
     */
    @JsonIgnore
    public boolean getPSWFVersionIdDirtyFlag(){
        return pSWFVersionIdDirtyFlag ;
    }



    public PSWFProcess toDO() {
        PSWFProcess srfdomain = new PSWFProcess();
        if(getUpdateManDirtyFlag())
            srfdomain.setUpdateMan(updateMan);
        if(getCreateManDirtyFlag())
            srfdomain.setCreateMan(createMan);
        if(getPreDefinedActionsDirtyFlag())
            srfdomain.setPreDefinedActions(preDefinedActions);
        if(getWFProcessTypeDirtyFlag())
            srfdomain.setWFProcessType(wFProcessType);
        if(getPSWFProcessNameDirtyFlag())
            srfdomain.setPSWFProcessName(pSWFProcessName);
        if(getPSWFProcessIdDirtyFlag())
            srfdomain.setPSWFProcessId(pSWFProcessId);
        if(getUpdateDateDirtyFlag())
            srfdomain.setUpdateDate(updateDate);
        if(getWFStepValueDirtyFlag())
            srfdomain.setWFStepValue(wFStepValue);
        if(getMultiInstModeDirtyFlag())
            srfdomain.setMultiInstMode(multiInstMode);
        if(getCreateDateDirtyFlag())
            srfdomain.setCreateDate(createDate);
        if(getWFStepNameDirtyFlag())
            srfdomain.setWFStepName(wFStepName);
        if(getPSWFVersionNameDirtyFlag())
            srfdomain.setPSWFVersionName(pSWFVersionName);
        if(getTargetpswfidDirtyFlag())
            srfdomain.setTargetpswfid(targetpswfid);
        if(getPSWFVersionIdDirtyFlag())
            srfdomain.setPSWFVersionId(pSWFVersionId);

        return srfdomain;
    }

    public void fromDO(PSWFProcess srfdomain) {
        if(srfdomain == null )
          return ;
        if(srfdomain.getUpdateManDirtyFlag())
            this.setUpdateMan(srfdomain.getUpdateMan());
        if(srfdomain.getCreateManDirtyFlag())
            this.setCreateMan(srfdomain.getCreateMan());
        if(srfdomain.getPreDefinedActionsDirtyFlag())
            this.setPreDefinedActions(srfdomain.getPreDefinedActions());
        if(srfdomain.getWFProcessTypeDirtyFlag())
            this.setWFProcessType(srfdomain.getWFProcessType());
        if(srfdomain.getPSWFProcessNameDirtyFlag())
            this.setPSWFProcessName(srfdomain.getPSWFProcessName());
        if(srfdomain.getPSWFProcessIdDirtyFlag())
            this.setPSWFProcessId(srfdomain.getPSWFProcessId());
        if(srfdomain.getUpdateDateDirtyFlag())
            this.setUpdateDate(srfdomain.getUpdateDate());
        if(srfdomain.getWFStepValueDirtyFlag())
            this.setWFStepValue(srfdomain.getWFStepValue());
        if(srfdomain.getMultiInstModeDirtyFlag())
            this.setMultiInstMode(srfdomain.getMultiInstMode());
        if(srfdomain.getCreateDateDirtyFlag())
            this.setCreateDate(srfdomain.getCreateDate());
        if(srfdomain.getWFStepNameDirtyFlag())
            this.setWFStepName(srfdomain.getWFStepName());
        if(srfdomain.getPSWFVersionNameDirtyFlag())
            this.setPSWFVersionName(srfdomain.getPSWFVersionName());
        if(srfdomain.getTargetpswfidDirtyFlag())
            this.setTargetpswfid(srfdomain.getTargetpswfid());
        if(srfdomain.getPSWFVersionIdDirtyFlag())
            this.setPSWFVersionId(srfdomain.getPSWFVersionId());

    }

    public List<PSWFProcessDTO> fromDOPage(List<PSWFProcess> poPage)   {
        if(poPage == null)
            return null;
        List<PSWFProcessDTO> dtos=new ArrayList<PSWFProcessDTO>();
        for(PSWFProcess domain : poPage) {
            PSWFProcessDTO dto = new PSWFProcessDTO();
            dto.fromDO(domain);
            dtos.add(dto);
        }
        return dtos;
    }
}

