package cn.ibizlab.r7.runtime.wf.service.wfapi.dto;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.math.BigInteger;
import java.util.Map;
import java.util.HashMap;
import java.io.Serializable;
import java.math.BigDecimal;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.valuerule.anno.pswfrole.*;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFRole;
import org.springframework.cglib.beans.BeanCopier;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * 服务DTO对象[PSWFRoleDTO]
 */
public class PSWFRoleDTO implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 属性 [ROLEDATA2]
     *
     */
    @PSWFRoleRoleData2Default(info = "默认规则")
    private String roleData2;

    @JsonIgnore
    private boolean roleData2DirtyFlag;

    /**
     * 属性 [ROLEDATA]
     *
     */
    @PSWFRoleRoleDataDefault(info = "默认规则")
    private String roleData;

    @JsonIgnore
    private boolean roleDataDirtyFlag;

    /**
     * 属性 [PSWFROLEID]
     *
     */
    @PSWFRolePSWFRoleIdDefault(info = "默认规则")
    private String pSWFRoleId;

    @JsonIgnore
    private boolean pSWFRoleIdDirtyFlag;

    /**
     * 属性 [UPDATEDATE]
     *
     */
    @PSWFRoleUpdateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp updateDate;

    @JsonIgnore
    private boolean updateDateDirtyFlag;

    /**
     * 属性 [SYSTEMFLAG]
     *
     */
    @PSWFRoleSystemFlagDefault(info = "默认规则")
    private Integer systemFlag;

    @JsonIgnore
    private boolean systemFlagDirtyFlag;

    /**
     * 属性 [CREATEDATE]
     *
     */
    @PSWFRoleCreateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp createDate;

    @JsonIgnore
    private boolean createDateDirtyFlag;

    /**
     * 属性 [CREATEMAN]
     *
     */
    @PSWFRoleCreateManDefault(info = "默认规则")
    private String createMan;

    @JsonIgnore
    private boolean createManDirtyFlag;

    /**
     * 属性 [UPDATEMAN]
     *
     */
    @PSWFRoleUpdateManDefault(info = "默认规则")
    private String updateMan;

    @JsonIgnore
    private boolean updateManDirtyFlag;

    /**
     * 属性 [PSWFROLENAME]
     *
     */
    @PSWFRolePSWFRoleNameDefault(info = "默认规则")
    private String pSWFRoleName;

    @JsonIgnore
    private boolean pSWFRoleNameDirtyFlag;

    /**
     * 属性 [WFROLETYPE]
     *
     */
    @PSWFRoleWFRoleTypeDefault(info = "默认规则")
    private String wFRoleType;

    @JsonIgnore
    private boolean wFRoleTypeDirtyFlag;

    /**
     * 属性 [ORGDEPTNAME]
     *
     */
    @PSWFRoleOrgDeptNameDefault(info = "默认规则")
    private String orgDeptName;

    @JsonIgnore
    private boolean orgDeptNameDirtyFlag;

    /**
     * 属性 [ORGNAME]
     *
     */
    @PSWFRoleOrgNameDefault(info = "默认规则")
    private String orgName;

    @JsonIgnore
    private boolean orgNameDirtyFlag;

    /**
     * 属性 [ORGDEPTID]
     *
     */
    @PSWFRoleOrgDeptIdDefault(info = "默认规则")
    private String orgDeptId;

    @JsonIgnore
    private boolean orgDeptIdDirtyFlag;

    /**
     * 属性 [ORGID]
     *
     */
    @PSWFRoleOrgIdDefault(info = "默认规则")
    private String orgId;

    @JsonIgnore
    private boolean orgIdDirtyFlag;


    /**
     * 获取 [ROLEDATA2]
     */
    @JsonProperty("roledata2")
    public String getRoleData2(){
        return roleData2 ;
    }

    /**
     * 设置 [ROLEDATA2]
     */
    @JsonProperty("roledata2")
    public void setRoleData2(String  roleData2){
        this.roleData2 = roleData2 ;
        this.roleData2DirtyFlag = true ;
    }

    /**
     * 获取 [ROLEDATA2]脏标记
     */
    @JsonIgnore
    public boolean getRoleData2DirtyFlag(){
        return roleData2DirtyFlag ;
    }

    /**
     * 获取 [ROLEDATA]
     */
    @JsonProperty("roledata")
    public String getRoleData(){
        return roleData ;
    }

    /**
     * 设置 [ROLEDATA]
     */
    @JsonProperty("roledata")
    public void setRoleData(String  roleData){
        this.roleData = roleData ;
        this.roleDataDirtyFlag = true ;
    }

    /**
     * 获取 [ROLEDATA]脏标记
     */
    @JsonIgnore
    public boolean getRoleDataDirtyFlag(){
        return roleDataDirtyFlag ;
    }

    /**
     * 获取 [PSWFROLEID]
     */
    @JsonProperty("pswfroleid")
    public String getPSWFRoleId(){
        return pSWFRoleId ;
    }

    /**
     * 设置 [PSWFROLEID]
     */
    @JsonProperty("pswfroleid")
    public void setPSWFRoleId(String  pSWFRoleId){
        this.pSWFRoleId = pSWFRoleId ;
        this.pSWFRoleIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSWFROLEID]脏标记
     */
    @JsonIgnore
    public boolean getPSWFRoleIdDirtyFlag(){
        return pSWFRoleIdDirtyFlag ;
    }

    /**
     * 获取 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public Timestamp getUpdateDate(){
        return updateDate ;
    }

    /**
     * 设置 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return updateDateDirtyFlag ;
    }

    /**
     * 获取 [SYSTEMFLAG]
     */
    @JsonProperty("systemflag")
    public Integer getSystemFlag(){
        return systemFlag ;
    }

    /**
     * 设置 [SYSTEMFLAG]
     */
    @JsonProperty("systemflag")
    public void setSystemFlag(Integer  systemFlag){
        this.systemFlag = systemFlag ;
        this.systemFlagDirtyFlag = true ;
    }

    /**
     * 获取 [SYSTEMFLAG]脏标记
     */
    @JsonIgnore
    public boolean getSystemFlagDirtyFlag(){
        return systemFlagDirtyFlag ;
    }

    /**
     * 获取 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public Timestamp getCreateDate(){
        return createDate ;
    }

    /**
     * 设置 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return createDateDirtyFlag ;
    }

    /**
     * 获取 [CREATEMAN]
     */
    @JsonProperty("createman")
    public String getCreateMan(){
        return createMan ;
    }

    /**
     * 设置 [CREATEMAN]
     */
    @JsonProperty("createman")
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return createManDirtyFlag ;
    }

    /**
     * 获取 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public String getUpdateMan(){
        return updateMan ;
    }

    /**
     * 设置 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return updateManDirtyFlag ;
    }

    /**
     * 获取 [PSWFROLENAME]
     */
    @JsonProperty("pswfrolename")
    public String getPSWFRoleName(){
        return pSWFRoleName ;
    }

    /**
     * 设置 [PSWFROLENAME]
     */
    @JsonProperty("pswfrolename")
    public void setPSWFRoleName(String  pSWFRoleName){
        this.pSWFRoleName = pSWFRoleName ;
        this.pSWFRoleNameDirtyFlag = true ;
    }

    /**
     * 获取 [PSWFROLENAME]脏标记
     */
    @JsonIgnore
    public boolean getPSWFRoleNameDirtyFlag(){
        return pSWFRoleNameDirtyFlag ;
    }

    /**
     * 获取 [WFROLETYPE]
     */
    @JsonProperty("wfroletype")
    public String getWFRoleType(){
        return wFRoleType ;
    }

    /**
     * 设置 [WFROLETYPE]
     */
    @JsonProperty("wfroletype")
    public void setWFRoleType(String  wFRoleType){
        this.wFRoleType = wFRoleType ;
        this.wFRoleTypeDirtyFlag = true ;
    }

    /**
     * 获取 [WFROLETYPE]脏标记
     */
    @JsonIgnore
    public boolean getWFRoleTypeDirtyFlag(){
        return wFRoleTypeDirtyFlag ;
    }

    /**
     * 获取 [ORGDEPTNAME]
     */
    @JsonProperty("orgdeptname")
    public String getOrgDeptName(){
        return orgDeptName ;
    }

    /**
     * 设置 [ORGDEPTNAME]
     */
    @JsonProperty("orgdeptname")
    public void setOrgDeptName(String  orgDeptName){
        this.orgDeptName = orgDeptName ;
        this.orgDeptNameDirtyFlag = true ;
    }

    /**
     * 获取 [ORGDEPTNAME]脏标记
     */
    @JsonIgnore
    public boolean getOrgDeptNameDirtyFlag(){
        return orgDeptNameDirtyFlag ;
    }

    /**
     * 获取 [ORGNAME]
     */
    @JsonProperty("orgname")
    public String getOrgName(){
        return orgName ;
    }

    /**
     * 设置 [ORGNAME]
     */
    @JsonProperty("orgname")
    public void setOrgName(String  orgName){
        this.orgName = orgName ;
        this.orgNameDirtyFlag = true ;
    }

    /**
     * 获取 [ORGNAME]脏标记
     */
    @JsonIgnore
    public boolean getOrgNameDirtyFlag(){
        return orgNameDirtyFlag ;
    }

    /**
     * 获取 [ORGDEPTID]
     */
    @JsonProperty("orgdeptid")
    public String getOrgDeptId(){
        return orgDeptId ;
    }

    /**
     * 设置 [ORGDEPTID]
     */
    @JsonProperty("orgdeptid")
    public void setOrgDeptId(String  orgDeptId){
        this.orgDeptId = orgDeptId ;
        this.orgDeptIdDirtyFlag = true ;
    }

    /**
     * 获取 [ORGDEPTID]脏标记
     */
    @JsonIgnore
    public boolean getOrgDeptIdDirtyFlag(){
        return orgDeptIdDirtyFlag ;
    }

    /**
     * 获取 [ORGID]
     */
    @JsonProperty("orgid")
    public String getOrgId(){
        return orgId ;
    }

    /**
     * 设置 [ORGID]
     */
    @JsonProperty("orgid")
    public void setOrgId(String  orgId){
        this.orgId = orgId ;
        this.orgIdDirtyFlag = true ;
    }

    /**
     * 获取 [ORGID]脏标记
     */
    @JsonIgnore
    public boolean getOrgIdDirtyFlag(){
        return orgIdDirtyFlag ;
    }



    public PSWFRole toDO() {
        PSWFRole srfdomain = new PSWFRole();
        if(getRoleData2DirtyFlag())
            srfdomain.setRoleData2(roleData2);
        if(getRoleDataDirtyFlag())
            srfdomain.setRoleData(roleData);
        if(getPSWFRoleIdDirtyFlag())
            srfdomain.setPSWFRoleId(pSWFRoleId);
        if(getUpdateDateDirtyFlag())
            srfdomain.setUpdateDate(updateDate);
        if(getSystemFlagDirtyFlag())
            srfdomain.setSystemFlag(systemFlag);
        if(getCreateDateDirtyFlag())
            srfdomain.setCreateDate(createDate);
        if(getCreateManDirtyFlag())
            srfdomain.setCreateMan(createMan);
        if(getUpdateManDirtyFlag())
            srfdomain.setUpdateMan(updateMan);
        if(getPSWFRoleNameDirtyFlag())
            srfdomain.setPSWFRoleName(pSWFRoleName);
        if(getWFRoleTypeDirtyFlag())
            srfdomain.setWFRoleType(wFRoleType);
        if(getOrgDeptNameDirtyFlag())
            srfdomain.setOrgDeptName(orgDeptName);
        if(getOrgNameDirtyFlag())
            srfdomain.setOrgName(orgName);
        if(getOrgDeptIdDirtyFlag())
            srfdomain.setOrgDeptId(orgDeptId);
        if(getOrgIdDirtyFlag())
            srfdomain.setOrgId(orgId);

        return srfdomain;
    }

    public void fromDO(PSWFRole srfdomain) {
        if(srfdomain == null )
          return ;
        if(srfdomain.getRoleData2DirtyFlag())
            this.setRoleData2(srfdomain.getRoleData2());
        if(srfdomain.getRoleDataDirtyFlag())
            this.setRoleData(srfdomain.getRoleData());
        if(srfdomain.getPSWFRoleIdDirtyFlag())
            this.setPSWFRoleId(srfdomain.getPSWFRoleId());
        if(srfdomain.getUpdateDateDirtyFlag())
            this.setUpdateDate(srfdomain.getUpdateDate());
        if(srfdomain.getSystemFlagDirtyFlag())
            this.setSystemFlag(srfdomain.getSystemFlag());
        if(srfdomain.getCreateDateDirtyFlag())
            this.setCreateDate(srfdomain.getCreateDate());
        if(srfdomain.getCreateManDirtyFlag())
            this.setCreateMan(srfdomain.getCreateMan());
        if(srfdomain.getUpdateManDirtyFlag())
            this.setUpdateMan(srfdomain.getUpdateMan());
        if(srfdomain.getPSWFRoleNameDirtyFlag())
            this.setPSWFRoleName(srfdomain.getPSWFRoleName());
        if(srfdomain.getWFRoleTypeDirtyFlag())
            this.setWFRoleType(srfdomain.getWFRoleType());
        if(srfdomain.getOrgDeptNameDirtyFlag())
            this.setOrgDeptName(srfdomain.getOrgDeptName());
        if(srfdomain.getOrgNameDirtyFlag())
            this.setOrgName(srfdomain.getOrgName());
        if(srfdomain.getOrgDeptIdDirtyFlag())
            this.setOrgDeptId(srfdomain.getOrgDeptId());
        if(srfdomain.getOrgIdDirtyFlag())
            this.setOrgId(srfdomain.getOrgId());

    }

    public List<PSWFRoleDTO> fromDOPage(List<PSWFRole> poPage)   {
        if(poPage == null)
            return null;
        List<PSWFRoleDTO> dtos=new ArrayList<PSWFRoleDTO>();
        for(PSWFRole domain : poPage) {
            PSWFRoleDTO dto = new PSWFRoleDTO();
            dto.fromDO(domain);
            dtos.add(dto);
        }
        return dtos;
    }
}

