package cn.ibizlab.r7.runtime.wf.service.wfapi.dto;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.math.BigInteger;
import java.util.Map;
import java.util.HashMap;
import java.io.Serializable;
import java.math.BigDecimal;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.valuerule.anno.pswfroledetail.*;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFRoleDetail;
import org.springframework.cglib.beans.BeanCopier;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * 服务DTO对象[PSWFRoleDetailDTO]
 */
public class PSWFRoleDetailDTO implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 属性 [UPDATEMAN]
     *
     */
    @PSWFRoleDetailUpdateManDefault(info = "默认规则")
    private String updateMan;

    @JsonIgnore
    private boolean updateManDirtyFlag;

    /**
     * 属性 [STARTTIME]
     *
     */
    @PSWFRoleDetailStartTimeDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp startTime;

    @JsonIgnore
    private boolean startTimeDirtyFlag;

    /**
     * 属性 [CREATEMAN]
     *
     */
    @PSWFRoleDetailCreateManDefault(info = "默认规则")
    private String createMan;

    @JsonIgnore
    private boolean createManDirtyFlag;

    /**
     * 属性 [PSWFROLEDETAILID]
     *
     */
    @PSWFRoleDetailPSWFRoleDetailIdDefault(info = "默认规则")
    private String pSWFRoleDetailId;

    @JsonIgnore
    private boolean pSWFRoleDetailIdDirtyFlag;

    /**
     * 属性 [PSWFROLEDETAILNAME]
     *
     */
    @PSWFRoleDetailPSWFRoleDetailNameDefault(info = "默认规则")
    private String pSWFRoleDetailName;

    @JsonIgnore
    private boolean pSWFRoleDetailNameDirtyFlag;

    /**
     * 属性 [UPDATEDATE]
     *
     */
    @PSWFRoleDetailUpdateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp updateDate;

    @JsonIgnore
    private boolean updateDateDirtyFlag;

    /**
     * 属性 [ENDTIME]
     *
     */
    @PSWFRoleDetailEndtimeDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp endtime;

    @JsonIgnore
    private boolean endtimeDirtyFlag;

    /**
     * 属性 [CREATEDATE]
     *
     */
    @PSWFRoleDetailCreateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp createDate;

    @JsonIgnore
    private boolean createDateDirtyFlag;

    /**
     * 属性 [ORGDEPTNAME]
     *
     */
    @PSWFRoleDetailOrgDeptNameDefault(info = "默认规则")
    private String orgDeptName;

    @JsonIgnore
    private boolean orgDeptNameDirtyFlag;

    /**
     * 属性 [ORGUSERNAME]
     *
     */
    @PSWFRoleDetailOrgUserNameDefault(info = "默认规则")
    private String orgUserName;

    @JsonIgnore
    private boolean orgUserNameDirtyFlag;

    /**
     * 属性 [ORGNAME]
     *
     */
    @PSWFRoleDetailOrgNameDefault(info = "默认规则")
    private String orgName;

    @JsonIgnore
    private boolean orgNameDirtyFlag;

    /**
     * 属性 [ORGUSERID]
     *
     */
    @PSWFRoleDetailOrgUserIdDefault(info = "默认规则")
    private String orgUserId;

    @JsonIgnore
    private boolean orgUserIdDirtyFlag;

    /**
     * 属性 [ORGID]
     *
     */
    @PSWFRoleDetailOrgIdDefault(info = "默认规则")
    private String orgId;

    @JsonIgnore
    private boolean orgIdDirtyFlag;

    /**
     * 属性 [ORGDEPTID]
     *
     */
    @PSWFRoleDetailOrgDeptIdDefault(info = "默认规则")
    private String orgDeptId;

    @JsonIgnore
    private boolean orgDeptIdDirtyFlag;

    /**
     * 属性 [PSWFROLEID]
     *
     */
    @PSWFRoleDetailPSWFRoleIdDefault(info = "默认规则")
    private String pSWFRoleId;

    @JsonIgnore
    private boolean pSWFRoleIdDirtyFlag;


    /**
     * 获取 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public String getUpdateMan(){
        return updateMan ;
    }

    /**
     * 设置 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return updateManDirtyFlag ;
    }

    /**
     * 获取 [STARTTIME]
     */
    @JsonProperty("starttime")
    public Timestamp getStartTime(){
        return startTime ;
    }

    /**
     * 设置 [STARTTIME]
     */
    @JsonProperty("starttime")
    public void setStartTime(Timestamp  startTime){
        this.startTime = startTime ;
        this.startTimeDirtyFlag = true ;
    }

    /**
     * 获取 [STARTTIME]脏标记
     */
    @JsonIgnore
    public boolean getStartTimeDirtyFlag(){
        return startTimeDirtyFlag ;
    }

    /**
     * 获取 [CREATEMAN]
     */
    @JsonProperty("createman")
    public String getCreateMan(){
        return createMan ;
    }

    /**
     * 设置 [CREATEMAN]
     */
    @JsonProperty("createman")
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return createManDirtyFlag ;
    }

    /**
     * 获取 [PSWFROLEDETAILID]
     */
    @JsonProperty("pswfroledetailid")
    public String getPSWFRoleDetailId(){
        return pSWFRoleDetailId ;
    }

    /**
     * 设置 [PSWFROLEDETAILID]
     */
    @JsonProperty("pswfroledetailid")
    public void setPSWFRoleDetailId(String  pSWFRoleDetailId){
        this.pSWFRoleDetailId = pSWFRoleDetailId ;
        this.pSWFRoleDetailIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSWFROLEDETAILID]脏标记
     */
    @JsonIgnore
    public boolean getPSWFRoleDetailIdDirtyFlag(){
        return pSWFRoleDetailIdDirtyFlag ;
    }

    /**
     * 获取 [PSWFROLEDETAILNAME]
     */
    @JsonProperty("pswfroledetailname")
    public String getPSWFRoleDetailName(){
        return pSWFRoleDetailName ;
    }

    /**
     * 设置 [PSWFROLEDETAILNAME]
     */
    @JsonProperty("pswfroledetailname")
    public void setPSWFRoleDetailName(String  pSWFRoleDetailName){
        this.pSWFRoleDetailName = pSWFRoleDetailName ;
        this.pSWFRoleDetailNameDirtyFlag = true ;
    }

    /**
     * 获取 [PSWFROLEDETAILNAME]脏标记
     */
    @JsonIgnore
    public boolean getPSWFRoleDetailNameDirtyFlag(){
        return pSWFRoleDetailNameDirtyFlag ;
    }

    /**
     * 获取 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public Timestamp getUpdateDate(){
        return updateDate ;
    }

    /**
     * 设置 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return updateDateDirtyFlag ;
    }

    /**
     * 获取 [ENDTIME]
     */
    @JsonProperty("endtime")
    public Timestamp getEndtime(){
        return endtime ;
    }

    /**
     * 设置 [ENDTIME]
     */
    @JsonProperty("endtime")
    public void setEndtime(Timestamp  endtime){
        this.endtime = endtime ;
        this.endtimeDirtyFlag = true ;
    }

    /**
     * 获取 [ENDTIME]脏标记
     */
    @JsonIgnore
    public boolean getEndtimeDirtyFlag(){
        return endtimeDirtyFlag ;
    }

    /**
     * 获取 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public Timestamp getCreateDate(){
        return createDate ;
    }

    /**
     * 设置 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return createDateDirtyFlag ;
    }

    /**
     * 获取 [ORGDEPTNAME]
     */
    @JsonProperty("orgdeptname")
    public String getOrgDeptName(){
        return orgDeptName ;
    }

    /**
     * 设置 [ORGDEPTNAME]
     */
    @JsonProperty("orgdeptname")
    public void setOrgDeptName(String  orgDeptName){
        this.orgDeptName = orgDeptName ;
        this.orgDeptNameDirtyFlag = true ;
    }

    /**
     * 获取 [ORGDEPTNAME]脏标记
     */
    @JsonIgnore
    public boolean getOrgDeptNameDirtyFlag(){
        return orgDeptNameDirtyFlag ;
    }

    /**
     * 获取 [ORGUSERNAME]
     */
    @JsonProperty("orgusername")
    public String getOrgUserName(){
        return orgUserName ;
    }

    /**
     * 设置 [ORGUSERNAME]
     */
    @JsonProperty("orgusername")
    public void setOrgUserName(String  orgUserName){
        this.orgUserName = orgUserName ;
        this.orgUserNameDirtyFlag = true ;
    }

    /**
     * 获取 [ORGUSERNAME]脏标记
     */
    @JsonIgnore
    public boolean getOrgUserNameDirtyFlag(){
        return orgUserNameDirtyFlag ;
    }

    /**
     * 获取 [ORGNAME]
     */
    @JsonProperty("orgname")
    public String getOrgName(){
        return orgName ;
    }

    /**
     * 设置 [ORGNAME]
     */
    @JsonProperty("orgname")
    public void setOrgName(String  orgName){
        this.orgName = orgName ;
        this.orgNameDirtyFlag = true ;
    }

    /**
     * 获取 [ORGNAME]脏标记
     */
    @JsonIgnore
    public boolean getOrgNameDirtyFlag(){
        return orgNameDirtyFlag ;
    }

    /**
     * 获取 [ORGUSERID]
     */
    @JsonProperty("orguserid")
    public String getOrgUserId(){
        return orgUserId ;
    }

    /**
     * 设置 [ORGUSERID]
     */
    @JsonProperty("orguserid")
    public void setOrgUserId(String  orgUserId){
        this.orgUserId = orgUserId ;
        this.orgUserIdDirtyFlag = true ;
    }

    /**
     * 获取 [ORGUSERID]脏标记
     */
    @JsonIgnore
    public boolean getOrgUserIdDirtyFlag(){
        return orgUserIdDirtyFlag ;
    }

    /**
     * 获取 [ORGID]
     */
    @JsonProperty("orgid")
    public String getOrgId(){
        return orgId ;
    }

    /**
     * 设置 [ORGID]
     */
    @JsonProperty("orgid")
    public void setOrgId(String  orgId){
        this.orgId = orgId ;
        this.orgIdDirtyFlag = true ;
    }

    /**
     * 获取 [ORGID]脏标记
     */
    @JsonIgnore
    public boolean getOrgIdDirtyFlag(){
        return orgIdDirtyFlag ;
    }

    /**
     * 获取 [ORGDEPTID]
     */
    @JsonProperty("orgdeptid")
    public String getOrgDeptId(){
        return orgDeptId ;
    }

    /**
     * 设置 [ORGDEPTID]
     */
    @JsonProperty("orgdeptid")
    public void setOrgDeptId(String  orgDeptId){
        this.orgDeptId = orgDeptId ;
        this.orgDeptIdDirtyFlag = true ;
    }

    /**
     * 获取 [ORGDEPTID]脏标记
     */
    @JsonIgnore
    public boolean getOrgDeptIdDirtyFlag(){
        return orgDeptIdDirtyFlag ;
    }

    /**
     * 获取 [PSWFROLEID]
     */
    @JsonProperty("pswfroleid")
    public String getPSWFRoleId(){
        return pSWFRoleId ;
    }

    /**
     * 设置 [PSWFROLEID]
     */
    @JsonProperty("pswfroleid")
    public void setPSWFRoleId(String  pSWFRoleId){
        this.pSWFRoleId = pSWFRoleId ;
        this.pSWFRoleIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSWFROLEID]脏标记
     */
    @JsonIgnore
    public boolean getPSWFRoleIdDirtyFlag(){
        return pSWFRoleIdDirtyFlag ;
    }



    public PSWFRoleDetail toDO() {
        PSWFRoleDetail srfdomain = new PSWFRoleDetail();
        if(getUpdateManDirtyFlag())
            srfdomain.setUpdateMan(updateMan);
        if(getStartTimeDirtyFlag())
            srfdomain.setStartTime(startTime);
        if(getCreateManDirtyFlag())
            srfdomain.setCreateMan(createMan);
        if(getPSWFRoleDetailIdDirtyFlag())
            srfdomain.setPSWFRoleDetailId(pSWFRoleDetailId);
        if(getPSWFRoleDetailNameDirtyFlag())
            srfdomain.setPSWFRoleDetailName(pSWFRoleDetailName);
        if(getUpdateDateDirtyFlag())
            srfdomain.setUpdateDate(updateDate);
        if(getEndtimeDirtyFlag())
            srfdomain.setEndtime(endtime);
        if(getCreateDateDirtyFlag())
            srfdomain.setCreateDate(createDate);
        if(getOrgDeptNameDirtyFlag())
            srfdomain.setOrgDeptName(orgDeptName);
        if(getOrgUserNameDirtyFlag())
            srfdomain.setOrgUserName(orgUserName);
        if(getOrgNameDirtyFlag())
            srfdomain.setOrgName(orgName);
        if(getOrgUserIdDirtyFlag())
            srfdomain.setOrgUserId(orgUserId);
        if(getOrgIdDirtyFlag())
            srfdomain.setOrgId(orgId);
        if(getOrgDeptIdDirtyFlag())
            srfdomain.setOrgDeptId(orgDeptId);
        if(getPSWFRoleIdDirtyFlag())
            srfdomain.setPSWFRoleId(pSWFRoleId);

        return srfdomain;
    }

    public void fromDO(PSWFRoleDetail srfdomain) {
        if(srfdomain == null )
          return ;
        if(srfdomain.getUpdateManDirtyFlag())
            this.setUpdateMan(srfdomain.getUpdateMan());
        if(srfdomain.getStartTimeDirtyFlag())
            this.setStartTime(srfdomain.getStartTime());
        if(srfdomain.getCreateManDirtyFlag())
            this.setCreateMan(srfdomain.getCreateMan());
        if(srfdomain.getPSWFRoleDetailIdDirtyFlag())
            this.setPSWFRoleDetailId(srfdomain.getPSWFRoleDetailId());
        if(srfdomain.getPSWFRoleDetailNameDirtyFlag())
            this.setPSWFRoleDetailName(srfdomain.getPSWFRoleDetailName());
        if(srfdomain.getUpdateDateDirtyFlag())
            this.setUpdateDate(srfdomain.getUpdateDate());
        if(srfdomain.getEndtimeDirtyFlag())
            this.setEndtime(srfdomain.getEndtime());
        if(srfdomain.getCreateDateDirtyFlag())
            this.setCreateDate(srfdomain.getCreateDate());
        if(srfdomain.getOrgDeptNameDirtyFlag())
            this.setOrgDeptName(srfdomain.getOrgDeptName());
        if(srfdomain.getOrgUserNameDirtyFlag())
            this.setOrgUserName(srfdomain.getOrgUserName());
        if(srfdomain.getOrgNameDirtyFlag())
            this.setOrgName(srfdomain.getOrgName());
        if(srfdomain.getOrgUserIdDirtyFlag())
            this.setOrgUserId(srfdomain.getOrgUserId());
        if(srfdomain.getOrgIdDirtyFlag())
            this.setOrgId(srfdomain.getOrgId());
        if(srfdomain.getOrgDeptIdDirtyFlag())
            this.setOrgDeptId(srfdomain.getOrgDeptId());
        if(srfdomain.getPSWFRoleIdDirtyFlag())
            this.setPSWFRoleId(srfdomain.getPSWFRoleId());

    }

    public List<PSWFRoleDetailDTO> fromDOPage(List<PSWFRoleDetail> poPage)   {
        if(poPage == null)
            return null;
        List<PSWFRoleDetailDTO> dtos=new ArrayList<PSWFRoleDetailDTO>();
        for(PSWFRoleDetail domain : poPage) {
            PSWFRoleDetailDTO dto = new PSWFRoleDetailDTO();
            dto.fromDO(domain);
            dtos.add(dto);
        }
        return dtos;
    }
}

