package cn.ibizlab.r7.runtime.wf.service.wfapi.dto;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.math.BigInteger;
import java.util.Map;
import java.util.HashMap;
import java.io.Serializable;
import java.math.BigDecimal;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.valuerule.anno.psworkflow.*;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWorkflow;
import org.springframework.cglib.beans.BeanCopier;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * 服务DTO对象[PSWorkflowDTO]
 */
public class PSWorkflowDTO implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 属性 [WFENGINETYPE]
     *
     */
    @PSWorkflowWfenginetypeDefault(info = "默认规则")
    private String wfenginetype;

    @JsonIgnore
    private boolean wfenginetypeDirtyFlag;

    /**
     * 属性 [UPDATEMAN]
     *
     */
    @PSWorkflowUpdateManDefault(info = "默认规则")
    private String updateMan;

    @JsonIgnore
    private boolean updateManDirtyFlag;

    /**
     * 属性 [CREATEDATE]
     *
     */
    @PSWorkflowCreateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp createDate;

    @JsonIgnore
    private boolean createDateDirtyFlag;

    /**
     * 属性 [WFTYPE]
     *
     */
    @PSWorkflowWftypeDefault(info = "默认规则")
    private String wftype;

    @JsonIgnore
    private boolean wftypeDirtyFlag;

    /**
     * 属性 [CREATEMAN]
     *
     */
    @PSWorkflowCreateManDefault(info = "默认规则")
    private String createMan;

    @JsonIgnore
    private boolean createManDirtyFlag;

    /**
     * 属性 [PSWORKFLOWID]
     *
     */
    @PSWorkflowPSWorkflowIdDefault(info = "默认规则")
    private String pSWorkflowId;

    @JsonIgnore
    private boolean pSWorkflowIdDirtyFlag;

    /**
     * 属性 [UPDATEDATE]
     *
     */
    @PSWorkflowUpdateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp updateDate;

    @JsonIgnore
    private boolean updateDateDirtyFlag;

    /**
     * 属性 [PSWORKFLOWNAME]
     *
     */
    @PSWorkflowPSWFWorkflowNameDefault(info = "默认规则")
    private String pSWFWorkflowName;

    @JsonIgnore
    private boolean pSWFWorkflowNameDirtyFlag;

    /**
     * 属性 [LOGICNAME]
     *
     */
    @PSWorkflowLogicNameDefault(info = "默认规则")
    private String logicName;

    @JsonIgnore
    private boolean logicNameDirtyFlag;

    /**
     * 属性 [ORGDEPTNAME]
     *
     */
    @PSWorkflowOrgDeptNameDefault(info = "默认规则")
    private String orgDeptName;

    @JsonIgnore
    private boolean orgDeptNameDirtyFlag;

    /**
     * 属性 [ORGNAME]
     *
     */
    @PSWorkflowOrgNameDefault(info = "默认规则")
    private String orgName;

    @JsonIgnore
    private boolean orgNameDirtyFlag;

    /**
     * 属性 [ORGDEPTID]
     *
     */
    @PSWorkflowOrgDeptIdDefault(info = "默认规则")
    private String orgDeptId;

    @JsonIgnore
    private boolean orgDeptIdDirtyFlag;

    /**
     * 属性 [ORGID]
     *
     */
    @PSWorkflowOrgIdDefault(info = "默认规则")
    private String orgId;

    @JsonIgnore
    private boolean orgIdDirtyFlag;

    /**
     * 属性 [PSSYSTEMID]
     *
     */
    @PSWorkflowPSSystemIdDefault(info = "默认规则")
    private String pSSystemId;

    @JsonIgnore
    private boolean pSSystemIdDirtyFlag;


    /**
     * 获取 [WFENGINETYPE]
     */
    @JsonProperty("wfenginetype")
    public String getWfenginetype(){
        return wfenginetype ;
    }

    /**
     * 设置 [WFENGINETYPE]
     */
    @JsonProperty("wfenginetype")
    public void setWfenginetype(String  wfenginetype){
        this.wfenginetype = wfenginetype ;
        this.wfenginetypeDirtyFlag = true ;
    }

    /**
     * 获取 [WFENGINETYPE]脏标记
     */
    @JsonIgnore
    public boolean getWfenginetypeDirtyFlag(){
        return wfenginetypeDirtyFlag ;
    }

    /**
     * 获取 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public String getUpdateMan(){
        return updateMan ;
    }

    /**
     * 设置 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return updateManDirtyFlag ;
    }

    /**
     * 获取 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public Timestamp getCreateDate(){
        return createDate ;
    }

    /**
     * 设置 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return createDateDirtyFlag ;
    }

    /**
     * 获取 [WFTYPE]
     */
    @JsonProperty("wftype")
    public String getWftype(){
        return wftype ;
    }

    /**
     * 设置 [WFTYPE]
     */
    @JsonProperty("wftype")
    public void setWftype(String  wftype){
        this.wftype = wftype ;
        this.wftypeDirtyFlag = true ;
    }

    /**
     * 获取 [WFTYPE]脏标记
     */
    @JsonIgnore
    public boolean getWftypeDirtyFlag(){
        return wftypeDirtyFlag ;
    }

    /**
     * 获取 [CREATEMAN]
     */
    @JsonProperty("createman")
    public String getCreateMan(){
        return createMan ;
    }

    /**
     * 设置 [CREATEMAN]
     */
    @JsonProperty("createman")
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return createManDirtyFlag ;
    }

    /**
     * 获取 [PSWORKFLOWID]
     */
    @JsonProperty("psworkflowid")
    public String getPSWorkflowId(){
        return pSWorkflowId ;
    }

    /**
     * 设置 [PSWORKFLOWID]
     */
    @JsonProperty("psworkflowid")
    public void setPSWorkflowId(String  pSWorkflowId){
        this.pSWorkflowId = pSWorkflowId ;
        this.pSWorkflowIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSWORKFLOWID]脏标记
     */
    @JsonIgnore
    public boolean getPSWorkflowIdDirtyFlag(){
        return pSWorkflowIdDirtyFlag ;
    }

    /**
     * 获取 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public Timestamp getUpdateDate(){
        return updateDate ;
    }

    /**
     * 设置 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return updateDateDirtyFlag ;
    }

    /**
     * 获取 [PSWORKFLOWNAME]
     */
    @JsonProperty("pswfworkflowname")
    public String getPSWFWorkflowName(){
        return pSWFWorkflowName ;
    }

    /**
     * 设置 [PSWORKFLOWNAME]
     */
    @JsonProperty("pswfworkflowname")
    public void setPSWFWorkflowName(String  pSWFWorkflowName){
        this.pSWFWorkflowName = pSWFWorkflowName ;
        this.pSWFWorkflowNameDirtyFlag = true ;
    }

    /**
     * 获取 [PSWORKFLOWNAME]脏标记
     */
    @JsonIgnore
    public boolean getPSWFWorkflowNameDirtyFlag(){
        return pSWFWorkflowNameDirtyFlag ;
    }

    /**
     * 获取 [LOGICNAME]
     */
    @JsonProperty("logicname")
    public String getLogicName(){
        return logicName ;
    }

    /**
     * 设置 [LOGICNAME]
     */
    @JsonProperty("logicname")
    public void setLogicName(String  logicName){
        this.logicName = logicName ;
        this.logicNameDirtyFlag = true ;
    }

    /**
     * 获取 [LOGICNAME]脏标记
     */
    @JsonIgnore
    public boolean getLogicNameDirtyFlag(){
        return logicNameDirtyFlag ;
    }

    /**
     * 获取 [ORGDEPTNAME]
     */
    @JsonProperty("orgdeptname")
    public String getOrgDeptName(){
        return orgDeptName ;
    }

    /**
     * 设置 [ORGDEPTNAME]
     */
    @JsonProperty("orgdeptname")
    public void setOrgDeptName(String  orgDeptName){
        this.orgDeptName = orgDeptName ;
        this.orgDeptNameDirtyFlag = true ;
    }

    /**
     * 获取 [ORGDEPTNAME]脏标记
     */
    @JsonIgnore
    public boolean getOrgDeptNameDirtyFlag(){
        return orgDeptNameDirtyFlag ;
    }

    /**
     * 获取 [ORGNAME]
     */
    @JsonProperty("orgname")
    public String getOrgName(){
        return orgName ;
    }

    /**
     * 设置 [ORGNAME]
     */
    @JsonProperty("orgname")
    public void setOrgName(String  orgName){
        this.orgName = orgName ;
        this.orgNameDirtyFlag = true ;
    }

    /**
     * 获取 [ORGNAME]脏标记
     */
    @JsonIgnore
    public boolean getOrgNameDirtyFlag(){
        return orgNameDirtyFlag ;
    }

    /**
     * 获取 [ORGDEPTID]
     */
    @JsonProperty("orgdeptid")
    public String getOrgDeptId(){
        return orgDeptId ;
    }

    /**
     * 设置 [ORGDEPTID]
     */
    @JsonProperty("orgdeptid")
    public void setOrgDeptId(String  orgDeptId){
        this.orgDeptId = orgDeptId ;
        this.orgDeptIdDirtyFlag = true ;
    }

    /**
     * 获取 [ORGDEPTID]脏标记
     */
    @JsonIgnore
    public boolean getOrgDeptIdDirtyFlag(){
        return orgDeptIdDirtyFlag ;
    }

    /**
     * 获取 [ORGID]
     */
    @JsonProperty("orgid")
    public String getOrgId(){
        return orgId ;
    }

    /**
     * 设置 [ORGID]
     */
    @JsonProperty("orgid")
    public void setOrgId(String  orgId){
        this.orgId = orgId ;
        this.orgIdDirtyFlag = true ;
    }

    /**
     * 获取 [ORGID]脏标记
     */
    @JsonIgnore
    public boolean getOrgIdDirtyFlag(){
        return orgIdDirtyFlag ;
    }

    /**
     * 获取 [PSSYSTEMID]
     */
    @JsonProperty("pssystemid")
    public String getPSSystemId(){
        return pSSystemId ;
    }

    /**
     * 设置 [PSSYSTEMID]
     */
    @JsonProperty("pssystemid")
    public void setPSSystemId(String  pSSystemId){
        this.pSSystemId = pSSystemId ;
        this.pSSystemIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSSYSTEMID]脏标记
     */
    @JsonIgnore
    public boolean getPSSystemIdDirtyFlag(){
        return pSSystemIdDirtyFlag ;
    }



    public PSWorkflow toDO() {
        PSWorkflow srfdomain = new PSWorkflow();
        if(getWfenginetypeDirtyFlag())
            srfdomain.setWfenginetype(wfenginetype);
        if(getUpdateManDirtyFlag())
            srfdomain.setUpdateMan(updateMan);
        if(getCreateDateDirtyFlag())
            srfdomain.setCreateDate(createDate);
        if(getWftypeDirtyFlag())
            srfdomain.setWftype(wftype);
        if(getCreateManDirtyFlag())
            srfdomain.setCreateMan(createMan);
        if(getPSWorkflowIdDirtyFlag())
            srfdomain.setPSWorkflowId(pSWorkflowId);
        if(getUpdateDateDirtyFlag())
            srfdomain.setUpdateDate(updateDate);
        if(getPSWFWorkflowNameDirtyFlag())
            srfdomain.setPSWFWorkflowName(pSWFWorkflowName);
        if(getLogicNameDirtyFlag())
            srfdomain.setLogicName(logicName);
        if(getOrgDeptNameDirtyFlag())
            srfdomain.setOrgDeptName(orgDeptName);
        if(getOrgNameDirtyFlag())
            srfdomain.setOrgName(orgName);
        if(getOrgDeptIdDirtyFlag())
            srfdomain.setOrgDeptId(orgDeptId);
        if(getOrgIdDirtyFlag())
            srfdomain.setOrgId(orgId);
        if(getPSSystemIdDirtyFlag())
            srfdomain.setPSSystemId(pSSystemId);

        return srfdomain;
    }

    public void fromDO(PSWorkflow srfdomain) {
        if(srfdomain == null )
          return ;
        if(srfdomain.getWfenginetypeDirtyFlag())
            this.setWfenginetype(srfdomain.getWfenginetype());
        if(srfdomain.getUpdateManDirtyFlag())
            this.setUpdateMan(srfdomain.getUpdateMan());
        if(srfdomain.getCreateDateDirtyFlag())
            this.setCreateDate(srfdomain.getCreateDate());
        if(srfdomain.getWftypeDirtyFlag())
            this.setWftype(srfdomain.getWftype());
        if(srfdomain.getCreateManDirtyFlag())
            this.setCreateMan(srfdomain.getCreateMan());
        if(srfdomain.getPSWorkflowIdDirtyFlag())
            this.setPSWorkflowId(srfdomain.getPSWorkflowId());
        if(srfdomain.getUpdateDateDirtyFlag())
            this.setUpdateDate(srfdomain.getUpdateDate());
        if(srfdomain.getPSWFWorkflowNameDirtyFlag())
            this.setPSWFWorkflowName(srfdomain.getPSWFWorkflowName());
        if(srfdomain.getLogicNameDirtyFlag())
            this.setLogicName(srfdomain.getLogicName());
        if(srfdomain.getOrgDeptNameDirtyFlag())
            this.setOrgDeptName(srfdomain.getOrgDeptName());
        if(srfdomain.getOrgNameDirtyFlag())
            this.setOrgName(srfdomain.getOrgName());
        if(srfdomain.getOrgDeptIdDirtyFlag())
            this.setOrgDeptId(srfdomain.getOrgDeptId());
        if(srfdomain.getOrgIdDirtyFlag())
            this.setOrgId(srfdomain.getOrgId());
        if(srfdomain.getPSSystemIdDirtyFlag())
            this.setPSSystemId(srfdomain.getPSSystemId());

    }

    public List<PSWorkflowDTO> fromDOPage(List<PSWorkflow> poPage)   {
        if(poPage == null)
            return null;
        List<PSWorkflowDTO> dtos=new ArrayList<PSWorkflowDTO>();
        for(PSWorkflow domain : poPage) {
            PSWorkflowDTO dto = new PSWorkflowDTO();
            dto.fromDO(domain);
            dtos.add(dto);
        }
        return dtos;
    }
}

