package cn.ibizlab.r7.runtime.wf.service.wfapi.dto;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.math.BigInteger;
import java.util.Map;
import java.util.HashMap;
import java.io.Serializable;
import java.math.BigDecimal;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.valuerule.anno.wfapp.*;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFApp;
import org.springframework.cglib.beans.BeanCopier;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * 服务DTO对象[WFAppDTO]
 */
public class WFAppDTO implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 属性 [CREATEMAN]
     *
     */
    @WFAppCreateManDefault(info = "默认规则")
    private String createMan;

    @JsonIgnore
    private boolean createManDirtyFlag;

    /**
     * 属性 [WFAPPNAME]
     *
     */
    @WFAppWFAppNameDefault(info = "默认规则")
    private String wFAppName;

    @JsonIgnore
    private boolean wFAppNameDirtyFlag;

    /**
     * 属性 [CREATEDATE]
     *
     */
    @WFAppCreateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp createDate;

    @JsonIgnore
    private boolean createDateDirtyFlag;

    /**
     * 属性 [SERVICEID]
     *
     */
    @WFAppServiceIdDefault(info = "默认规则")
    private String serviceId;

    @JsonIgnore
    private boolean serviceIdDirtyFlag;

    /**
     * 属性 [SERVICEURL]
     *
     */
    @WFAppServiceUrlDefault(info = "默认规则")
    private String serviceUrl;

    @JsonIgnore
    private boolean serviceUrlDirtyFlag;

    /**
     * 属性 [UPDATEDATE]
     *
     */
    @WFAppUpdateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp updateDate;

    @JsonIgnore
    private boolean updateDateDirtyFlag;

    /**
     * 属性 [UPDATEMAN]
     *
     */
    @WFAppUpdateManDefault(info = "默认规则")
    private String updateMan;

    @JsonIgnore
    private boolean updateManDirtyFlag;

    /**
     * 属性 [LOGICNAME]
     *
     */
    @WFAppLogicNameDefault(info = "默认规则")
    private String logicName;

    @JsonIgnore
    private boolean logicNameDirtyFlag;

    /**
     * 属性 [APPURL]
     *
     */
    @WFAppAppUrlDefault(info = "默认规则")
    private String appUrl;

    @JsonIgnore
    private boolean appUrlDirtyFlag;

    /**
     * 属性 [WFAPPID]
     *
     */
    @WFAppWFAppIdDefault(info = "默认规则")
    private String wFAppId;

    @JsonIgnore
    private boolean wFAppIdDirtyFlag;

    /**
     * 属性 [PSSYSTEMID]
     *
     */
    @WFAppPSSystemIdDefault(info = "默认规则")
    private String pSSystemId;

    @JsonIgnore
    private boolean pSSystemIdDirtyFlag;


    /**
     * 获取 [CREATEMAN]
     */
    @JsonProperty("createman")
    public String getCreateMan(){
        return createMan ;
    }

    /**
     * 设置 [CREATEMAN]
     */
    @JsonProperty("createman")
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return createManDirtyFlag ;
    }

    /**
     * 获取 [WFAPPNAME]
     */
    @JsonProperty("wfappname")
    public String getWFAppName(){
        return wFAppName ;
    }

    /**
     * 设置 [WFAPPNAME]
     */
    @JsonProperty("wfappname")
    public void setWFAppName(String  wFAppName){
        this.wFAppName = wFAppName ;
        this.wFAppNameDirtyFlag = true ;
    }

    /**
     * 获取 [WFAPPNAME]脏标记
     */
    @JsonIgnore
    public boolean getWFAppNameDirtyFlag(){
        return wFAppNameDirtyFlag ;
    }

    /**
     * 获取 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public Timestamp getCreateDate(){
        return createDate ;
    }

    /**
     * 设置 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return createDateDirtyFlag ;
    }

    /**
     * 获取 [SERVICEID]
     */
    @JsonProperty("serviceid")
    public String getServiceId(){
        return serviceId ;
    }

    /**
     * 设置 [SERVICEID]
     */
    @JsonProperty("serviceid")
    public void setServiceId(String  serviceId){
        this.serviceId = serviceId ;
        this.serviceIdDirtyFlag = true ;
    }

    /**
     * 获取 [SERVICEID]脏标记
     */
    @JsonIgnore
    public boolean getServiceIdDirtyFlag(){
        return serviceIdDirtyFlag ;
    }

    /**
     * 获取 [SERVICEURL]
     */
    @JsonProperty("serviceurl")
    public String getServiceUrl(){
        return serviceUrl ;
    }

    /**
     * 设置 [SERVICEURL]
     */
    @JsonProperty("serviceurl")
    public void setServiceUrl(String  serviceUrl){
        this.serviceUrl = serviceUrl ;
        this.serviceUrlDirtyFlag = true ;
    }

    /**
     * 获取 [SERVICEURL]脏标记
     */
    @JsonIgnore
    public boolean getServiceUrlDirtyFlag(){
        return serviceUrlDirtyFlag ;
    }

    /**
     * 获取 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public Timestamp getUpdateDate(){
        return updateDate ;
    }

    /**
     * 设置 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return updateDateDirtyFlag ;
    }

    /**
     * 获取 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public String getUpdateMan(){
        return updateMan ;
    }

    /**
     * 设置 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return updateManDirtyFlag ;
    }

    /**
     * 获取 [LOGICNAME]
     */
    @JsonProperty("logicname")
    public String getLogicName(){
        return logicName ;
    }

    /**
     * 设置 [LOGICNAME]
     */
    @JsonProperty("logicname")
    public void setLogicName(String  logicName){
        this.logicName = logicName ;
        this.logicNameDirtyFlag = true ;
    }

    /**
     * 获取 [LOGICNAME]脏标记
     */
    @JsonIgnore
    public boolean getLogicNameDirtyFlag(){
        return logicNameDirtyFlag ;
    }

    /**
     * 获取 [APPURL]
     */
    @JsonProperty("appurl")
    public String getAppUrl(){
        return appUrl ;
    }

    /**
     * 设置 [APPURL]
     */
    @JsonProperty("appurl")
    public void setAppUrl(String  appUrl){
        this.appUrl = appUrl ;
        this.appUrlDirtyFlag = true ;
    }

    /**
     * 获取 [APPURL]脏标记
     */
    @JsonIgnore
    public boolean getAppUrlDirtyFlag(){
        return appUrlDirtyFlag ;
    }

    /**
     * 获取 [WFAPPID]
     */
    @JsonProperty("wfappid")
    public String getWFAppId(){
        return wFAppId ;
    }

    /**
     * 设置 [WFAPPID]
     */
    @JsonProperty("wfappid")
    public void setWFAppId(String  wFAppId){
        this.wFAppId = wFAppId ;
        this.wFAppIdDirtyFlag = true ;
    }

    /**
     * 获取 [WFAPPID]脏标记
     */
    @JsonIgnore
    public boolean getWFAppIdDirtyFlag(){
        return wFAppIdDirtyFlag ;
    }

    /**
     * 获取 [PSSYSTEMID]
     */
    @JsonProperty("pssystemid")
    public String getPSSystemId(){
        return pSSystemId ;
    }

    /**
     * 设置 [PSSYSTEMID]
     */
    @JsonProperty("pssystemid")
    public void setPSSystemId(String  pSSystemId){
        this.pSSystemId = pSSystemId ;
        this.pSSystemIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSSYSTEMID]脏标记
     */
    @JsonIgnore
    public boolean getPSSystemIdDirtyFlag(){
        return pSSystemIdDirtyFlag ;
    }



    public WFApp toDO() {
        WFApp srfdomain = new WFApp();
        if(getCreateManDirtyFlag())
            srfdomain.setCreateMan(createMan);
        if(getWFAppNameDirtyFlag())
            srfdomain.setWFAppName(wFAppName);
        if(getCreateDateDirtyFlag())
            srfdomain.setCreateDate(createDate);
        if(getServiceIdDirtyFlag())
            srfdomain.setServiceId(serviceId);
        if(getServiceUrlDirtyFlag())
            srfdomain.setServiceUrl(serviceUrl);
        if(getUpdateDateDirtyFlag())
            srfdomain.setUpdateDate(updateDate);
        if(getUpdateManDirtyFlag())
            srfdomain.setUpdateMan(updateMan);
        if(getLogicNameDirtyFlag())
            srfdomain.setLogicName(logicName);
        if(getAppUrlDirtyFlag())
            srfdomain.setAppUrl(appUrl);
        if(getWFAppIdDirtyFlag())
            srfdomain.setWFAppId(wFAppId);
        if(getPSSystemIdDirtyFlag())
            srfdomain.setPSSystemId(pSSystemId);

        return srfdomain;
    }

    public void fromDO(WFApp srfdomain) {
        if(srfdomain == null )
          return ;
        if(srfdomain.getCreateManDirtyFlag())
            this.setCreateMan(srfdomain.getCreateMan());
        if(srfdomain.getWFAppNameDirtyFlag())
            this.setWFAppName(srfdomain.getWFAppName());
        if(srfdomain.getCreateDateDirtyFlag())
            this.setCreateDate(srfdomain.getCreateDate());
        if(srfdomain.getServiceIdDirtyFlag())
            this.setServiceId(srfdomain.getServiceId());
        if(srfdomain.getServiceUrlDirtyFlag())
            this.setServiceUrl(srfdomain.getServiceUrl());
        if(srfdomain.getUpdateDateDirtyFlag())
            this.setUpdateDate(srfdomain.getUpdateDate());
        if(srfdomain.getUpdateManDirtyFlag())
            this.setUpdateMan(srfdomain.getUpdateMan());
        if(srfdomain.getLogicNameDirtyFlag())
            this.setLogicName(srfdomain.getLogicName());
        if(srfdomain.getAppUrlDirtyFlag())
            this.setAppUrl(srfdomain.getAppUrl());
        if(srfdomain.getWFAppIdDirtyFlag())
            this.setWFAppId(srfdomain.getWFAppId());
        if(srfdomain.getPSSystemIdDirtyFlag())
            this.setPSSystemId(srfdomain.getPSSystemId());

    }

    public List<WFAppDTO> fromDOPage(List<WFApp> poPage)   {
        if(poPage == null)
            return null;
        List<WFAppDTO> dtos=new ArrayList<WFAppDTO>();
        for(WFApp domain : poPage) {
            WFAppDTO dto = new WFAppDTO();
            dto.fromDO(domain);
            dtos.add(dto);
        }
        return dtos;
    }
}

