package cn.ibizlab.r7.runtime.wf.service.wfapi.dto;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.math.BigInteger;
import java.util.Map;
import java.util.HashMap;
import java.io.Serializable;
import java.math.BigDecimal;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.valuerule.anno.wfengine.*;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFEngine;
import org.springframework.cglib.beans.BeanCopier;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * 服务DTO对象[WFEngineDTO]
 */
public class WFEngineDTO implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 属性 [UPDATEDATE]
     *
     */
    @WFEngineUpdateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp updateDate;

    @JsonIgnore
    private boolean updateDateDirtyFlag;

    /**
     * 属性 [WFENGINENAME]
     *
     */
    @WFEngineWFEngineNameDefault(info = "默认规则")
    private String wFEngineName;

    @JsonIgnore
    private boolean wFEngineNameDirtyFlag;

    /**
     * 属性 [WFENGINEID]
     *
     */
    @WFEngineWFEngineIdDefault(info = "默认规则")
    private String wFEngineId;

    @JsonIgnore
    private boolean wFEngineIdDirtyFlag;

    /**
     * 属性 [CREATEDATE]
     *
     */
    @WFEngineCreateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp createDate;

    @JsonIgnore
    private boolean createDateDirtyFlag;

    /**
     * 属性 [CREATEMAN]
     *
     */
    @WFEngineCreateManDefault(info = "默认规则")
    private String createMan;

    @JsonIgnore
    private boolean createManDirtyFlag;

    /**
     * 属性 [UPDATEMAN]
     *
     */
    @WFEngineUpdateManDefault(info = "默认规则")
    private String updateMan;

    @JsonIgnore
    private boolean updateManDirtyFlag;

    /**
     * 属性 [LOGICNAME]
     *
     */
    @WFEngineLogicNameDefault(info = "默认规则")
    private String logicName;

    @JsonIgnore
    private boolean logicNameDirtyFlag;

    /**
     * 属性 [ENGINETYPE]
     *
     */
    @WFEngineEnginetypeDefault(info = "默认规则")
    private String enginetype;

    @JsonIgnore
    private boolean enginetypeDirtyFlag;

    /**
     * 属性 [WORKFLOWID]
     *
     */
    @WFEngineWorkflowIdDefault(info = "默认规则")
    private String workflowId;

    @JsonIgnore
    private boolean workflowIdDirtyFlag;


    /**
     * 获取 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public Timestamp getUpdateDate(){
        return updateDate ;
    }

    /**
     * 设置 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return updateDateDirtyFlag ;
    }

    /**
     * 获取 [WFENGINENAME]
     */
    @JsonProperty("wfenginename")
    public String getWFEngineName(){
        return wFEngineName ;
    }

    /**
     * 设置 [WFENGINENAME]
     */
    @JsonProperty("wfenginename")
    public void setWFEngineName(String  wFEngineName){
        this.wFEngineName = wFEngineName ;
        this.wFEngineNameDirtyFlag = true ;
    }

    /**
     * 获取 [WFENGINENAME]脏标记
     */
    @JsonIgnore
    public boolean getWFEngineNameDirtyFlag(){
        return wFEngineNameDirtyFlag ;
    }

    /**
     * 获取 [WFENGINEID]
     */
    @JsonProperty("wfengineid")
    public String getWFEngineId(){
        return wFEngineId ;
    }

    /**
     * 设置 [WFENGINEID]
     */
    @JsonProperty("wfengineid")
    public void setWFEngineId(String  wFEngineId){
        this.wFEngineId = wFEngineId ;
        this.wFEngineIdDirtyFlag = true ;
    }

    /**
     * 获取 [WFENGINEID]脏标记
     */
    @JsonIgnore
    public boolean getWFEngineIdDirtyFlag(){
        return wFEngineIdDirtyFlag ;
    }

    /**
     * 获取 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public Timestamp getCreateDate(){
        return createDate ;
    }

    /**
     * 设置 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return createDateDirtyFlag ;
    }

    /**
     * 获取 [CREATEMAN]
     */
    @JsonProperty("createman")
    public String getCreateMan(){
        return createMan ;
    }

    /**
     * 设置 [CREATEMAN]
     */
    @JsonProperty("createman")
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return createManDirtyFlag ;
    }

    /**
     * 获取 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public String getUpdateMan(){
        return updateMan ;
    }

    /**
     * 设置 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return updateManDirtyFlag ;
    }

    /**
     * 获取 [LOGICNAME]
     */
    @JsonProperty("logicname")
    public String getLogicName(){
        return logicName ;
    }

    /**
     * 设置 [LOGICNAME]
     */
    @JsonProperty("logicname")
    public void setLogicName(String  logicName){
        this.logicName = logicName ;
        this.logicNameDirtyFlag = true ;
    }

    /**
     * 获取 [LOGICNAME]脏标记
     */
    @JsonIgnore
    public boolean getLogicNameDirtyFlag(){
        return logicNameDirtyFlag ;
    }

    /**
     * 获取 [ENGINETYPE]
     */
    @JsonProperty("enginetype")
    public String getEnginetype(){
        return enginetype ;
    }

    /**
     * 设置 [ENGINETYPE]
     */
    @JsonProperty("enginetype")
    public void setEnginetype(String  enginetype){
        this.enginetype = enginetype ;
        this.enginetypeDirtyFlag = true ;
    }

    /**
     * 获取 [ENGINETYPE]脏标记
     */
    @JsonIgnore
    public boolean getEnginetypeDirtyFlag(){
        return enginetypeDirtyFlag ;
    }

    /**
     * 获取 [WORKFLOWID]
     */
    @JsonProperty("workflowid")
    public String getWorkflowId(){
        return workflowId ;
    }

    /**
     * 设置 [WORKFLOWID]
     */
    @JsonProperty("workflowid")
    public void setWorkflowId(String  workflowId){
        this.workflowId = workflowId ;
        this.workflowIdDirtyFlag = true ;
    }

    /**
     * 获取 [WORKFLOWID]脏标记
     */
    @JsonIgnore
    public boolean getWorkflowIdDirtyFlag(){
        return workflowIdDirtyFlag ;
    }



    public WFEngine toDO() {
        WFEngine srfdomain = new WFEngine();
        if(getUpdateDateDirtyFlag())
            srfdomain.setUpdateDate(updateDate);
        if(getWFEngineNameDirtyFlag())
            srfdomain.setWFEngineName(wFEngineName);
        if(getWFEngineIdDirtyFlag())
            srfdomain.setWFEngineId(wFEngineId);
        if(getCreateDateDirtyFlag())
            srfdomain.setCreateDate(createDate);
        if(getCreateManDirtyFlag())
            srfdomain.setCreateMan(createMan);
        if(getUpdateManDirtyFlag())
            srfdomain.setUpdateMan(updateMan);
        if(getLogicNameDirtyFlag())
            srfdomain.setLogicName(logicName);
        if(getEnginetypeDirtyFlag())
            srfdomain.setEnginetype(enginetype);
        if(getWorkflowIdDirtyFlag())
            srfdomain.setWorkflowId(workflowId);

        return srfdomain;
    }

    public void fromDO(WFEngine srfdomain) {
        if(srfdomain == null )
          return ;
        if(srfdomain.getUpdateDateDirtyFlag())
            this.setUpdateDate(srfdomain.getUpdateDate());
        if(srfdomain.getWFEngineNameDirtyFlag())
            this.setWFEngineName(srfdomain.getWFEngineName());
        if(srfdomain.getWFEngineIdDirtyFlag())
            this.setWFEngineId(srfdomain.getWFEngineId());
        if(srfdomain.getCreateDateDirtyFlag())
            this.setCreateDate(srfdomain.getCreateDate());
        if(srfdomain.getCreateManDirtyFlag())
            this.setCreateMan(srfdomain.getCreateMan());
        if(srfdomain.getUpdateManDirtyFlag())
            this.setUpdateMan(srfdomain.getUpdateMan());
        if(srfdomain.getLogicNameDirtyFlag())
            this.setLogicName(srfdomain.getLogicName());
        if(srfdomain.getEnginetypeDirtyFlag())
            this.setEnginetype(srfdomain.getEnginetype());
        if(srfdomain.getWorkflowIdDirtyFlag())
            this.setWorkflowId(srfdomain.getWorkflowId());

    }

    public List<WFEngineDTO> fromDOPage(List<WFEngine> poPage)   {
        if(poPage == null)
            return null;
        List<WFEngineDTO> dtos=new ArrayList<WFEngineDTO>();
        for(WFEngine domain : poPage) {
            WFEngineDTO dto = new WFEngineDTO();
            dto.fromDO(domain);
            dtos.add(dto);
        }
        return dtos;
    }
}

