package cn.ibizlab.r7.runtime.wf.service.wfapi.dto;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.math.BigInteger;
import java.util.Map;
import java.util.HashMap;
import java.io.Serializable;
import java.math.BigDecimal;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.valuerule.anno.wfrole.*;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFRole;
import org.springframework.cglib.beans.BeanCopier;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * 服务DTO对象[WFRoleDTO]
 */
public class WFRoleDTO implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 属性 [WFROLEID]
     *
     */
    @WFRoleWFRoleIdDefault(info = "默认规则")
    private String wFRoleId;

    @JsonIgnore
    private boolean wFRoleIdDirtyFlag;

    /**
     * 属性 [CREATEDATE]
     *
     */
    @WFRoleCreateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp createDate;

    @JsonIgnore
    private boolean createDateDirtyFlag;

    /**
     * 属性 [UPDATEDATE]
     *
     */
    @WFRoleUpdateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp updateDate;

    @JsonIgnore
    private boolean updateDateDirtyFlag;

    /**
     * 属性 [CREATEMAN]
     *
     */
    @WFRoleCreateManDefault(info = "默认规则")
    private String createMan;

    @JsonIgnore
    private boolean createManDirtyFlag;

    /**
     * 属性 [WFROLENAME]
     *
     */
    @WFRoleWFRoleNameDefault(info = "默认规则")
    private String wFRoleName;

    @JsonIgnore
    private boolean wFRoleNameDirtyFlag;

    /**
     * 属性 [UPDATEMAN]
     *
     */
    @WFRoleUpdateManDefault(info = "默认规则")
    private String updateMan;

    @JsonIgnore
    private boolean updateManDirtyFlag;


    /**
     * 获取 [WFROLEID]
     */
    @JsonProperty("wfroleid")
    public String getWFRoleId(){
        return wFRoleId ;
    }

    /**
     * 设置 [WFROLEID]
     */
    @JsonProperty("wfroleid")
    public void setWFRoleId(String  wFRoleId){
        this.wFRoleId = wFRoleId ;
        this.wFRoleIdDirtyFlag = true ;
    }

    /**
     * 获取 [WFROLEID]脏标记
     */
    @JsonIgnore
    public boolean getWFRoleIdDirtyFlag(){
        return wFRoleIdDirtyFlag ;
    }

    /**
     * 获取 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public Timestamp getCreateDate(){
        return createDate ;
    }

    /**
     * 设置 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return createDateDirtyFlag ;
    }

    /**
     * 获取 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public Timestamp getUpdateDate(){
        return updateDate ;
    }

    /**
     * 设置 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return updateDateDirtyFlag ;
    }

    /**
     * 获取 [CREATEMAN]
     */
    @JsonProperty("createman")
    public String getCreateMan(){
        return createMan ;
    }

    /**
     * 设置 [CREATEMAN]
     */
    @JsonProperty("createman")
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return createManDirtyFlag ;
    }

    /**
     * 获取 [WFROLENAME]
     */
    @JsonProperty("wfrolename")
    public String getWFRoleName(){
        return wFRoleName ;
    }

    /**
     * 设置 [WFROLENAME]
     */
    @JsonProperty("wfrolename")
    public void setWFRoleName(String  wFRoleName){
        this.wFRoleName = wFRoleName ;
        this.wFRoleNameDirtyFlag = true ;
    }

    /**
     * 获取 [WFROLENAME]脏标记
     */
    @JsonIgnore
    public boolean getWFRoleNameDirtyFlag(){
        return wFRoleNameDirtyFlag ;
    }

    /**
     * 获取 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public String getUpdateMan(){
        return updateMan ;
    }

    /**
     * 设置 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return updateManDirtyFlag ;
    }



    public WFRole toDO() {
        WFRole srfdomain = new WFRole();
        if(getWFRoleIdDirtyFlag())
            srfdomain.setWFRoleId(wFRoleId);
        if(getCreateDateDirtyFlag())
            srfdomain.setCreateDate(createDate);
        if(getUpdateDateDirtyFlag())
            srfdomain.setUpdateDate(updateDate);
        if(getCreateManDirtyFlag())
            srfdomain.setCreateMan(createMan);
        if(getWFRoleNameDirtyFlag())
            srfdomain.setWFRoleName(wFRoleName);
        if(getUpdateManDirtyFlag())
            srfdomain.setUpdateMan(updateMan);

        return srfdomain;
    }

    public void fromDO(WFRole srfdomain) {
        if(srfdomain == null )
          return ;
        if(srfdomain.getWFRoleIdDirtyFlag())
            this.setWFRoleId(srfdomain.getWFRoleId());
        if(srfdomain.getCreateDateDirtyFlag())
            this.setCreateDate(srfdomain.getCreateDate());
        if(srfdomain.getUpdateDateDirtyFlag())
            this.setUpdateDate(srfdomain.getUpdateDate());
        if(srfdomain.getCreateManDirtyFlag())
            this.setCreateMan(srfdomain.getCreateMan());
        if(srfdomain.getWFRoleNameDirtyFlag())
            this.setWFRoleName(srfdomain.getWFRoleName());
        if(srfdomain.getUpdateManDirtyFlag())
            this.setUpdateMan(srfdomain.getUpdateMan());

    }

    public List<WFRoleDTO> fromDOPage(List<WFRole> poPage)   {
        if(poPage == null)
            return null;
        List<WFRoleDTO> dtos=new ArrayList<WFRoleDTO>();
        for(WFRole domain : poPage) {
            WFRoleDTO dto = new WFRoleDTO();
            dto.fromDO(domain);
            dtos.add(dto);
        }
        return dtos;
    }
}

