package cn.ibizlab.r7.runtime.wf.service.wfapi.dto;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.math.BigInteger;
import java.util.Map;
import java.util.HashMap;
import java.io.Serializable;
import java.math.BigDecimal;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.valuerule.anno.wfstepactor.*;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFStepActor;
import org.springframework.cglib.beans.BeanCopier;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * 服务DTO对象[WFStepActorDTO]
 */
public class WFStepActorDTO implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 属性 [LOGICNAME]
     *
     */
    @WFStepActorLogicNameDefault(info = "默认规则")
    private String logicName;

    @JsonIgnore
    private boolean logicNameDirtyFlag;

    /**
     * 属性 [PARENTINSTID]
     *
     */
    @WFStepActorParentInstIdDefault(info = "默认规则")
    private String parentInstId;

    @JsonIgnore
    private boolean parentInstIdDirtyFlag;

    /**
     * 属性 [UPDATEDATE]
     *
     */
    @WFStepActorUpdateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp updateDate;

    @JsonIgnore
    private boolean updateDateDirtyFlag;

    /**
     * 属性 [MAJORINSTID]
     *
     */
    @WFStepActorMajorInstIdDefault(info = "默认规则")
    private String majorInstId;

    @JsonIgnore
    private boolean majorInstIdDirtyFlag;

    /**
     * 属性 [WFSTEPACTORID]
     *
     */
    @WFStepActorWFStepActorIdDefault(info = "默认规则")
    private String wFStepActorId;

    @JsonIgnore
    private boolean wFStepActorIdDirtyFlag;

    /**
     * 属性 [UPDATEMAN]
     *
     */
    @WFStepActorUpdateManDefault(info = "默认规则")
    private String updateMan;

    @JsonIgnore
    private boolean updateManDirtyFlag;

    /**
     * 属性 [CREATEDATE]
     *
     */
    @WFStepActorCreateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp createDate;

    @JsonIgnore
    private boolean createDateDirtyFlag;

    /**
     * 属性 [FINISHTIME]
     *
     */
    @WFStepActorFinishTimeDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp finishTime;

    @JsonIgnore
    private boolean finishTimeDirtyFlag;

    /**
     * 属性 [WFSTEPACTORNAME]
     *
     */
    @WFStepActorWFStepActorNameDefault(info = "默认规则")
    private String wFStepActorName;

    @JsonIgnore
    private boolean wFStepActorNameDirtyFlag;

    /**
     * 属性 [TASKID]
     *
     */
    @WFStepActorTaskIdDefault(info = "默认规则")
    private String taskId;

    @JsonIgnore
    private boolean taskIdDirtyFlag;

    /**
     * 属性 [CREATEMAN]
     *
     */
    @WFStepActorCreateManDefault(info = "默认规则")
    private String createMan;

    @JsonIgnore
    private boolean createManDirtyFlag;

    /**
     * 属性 [ISFINISH]
     *
     */
    @WFStepActorIsFinishDefault(info = "默认规则")
    private Integer isFinish;

    @JsonIgnore
    private boolean isFinishDirtyFlag;

    /**
     * 属性 [READTIME]
     *
     */
    @WFStepActorReadTimeDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp readTime;

    @JsonIgnore
    private boolean readTimeDirtyFlag;

    /**
     * 属性 [ISREADONLY]
     *
     */
    @WFStepActorIsReadOnlyDefault(info = "默认规则")
    private Integer isReadOnly;

    @JsonIgnore
    private boolean isReadOnlyDirtyFlag;

    /**
     * 属性 [STARTTIME]
     *
     */
    @WFStepActorStartTimeDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp startTime;

    @JsonIgnore
    private boolean startTimeDirtyFlag;

    /**
     * 属性 [WFUSERNAME]
     *
     */
    @WFStepActorWFUserNameDefault(info = "默认规则")
    private String wFUserName;

    @JsonIgnore
    private boolean wFUserNameDirtyFlag;

    /**
     * 属性 [WFUSERID]
     *
     */
    @WFStepActorWFUserIdDefault(info = "默认规则")
    private String wFUserId;

    @JsonIgnore
    private boolean wFUserIdDirtyFlag;

    /**
     * 属性 [WFSTEPID]
     *
     */
    @WFStepActorWFStepIdDefault(info = "默认规则")
    private String wFStepId;

    @JsonIgnore
    private boolean wFStepIdDirtyFlag;

    /**
     * 属性 [PSWFPROCESSID]
     *
     */
    @WFStepActorPSWFProcessIdDefault(info = "默认规则")
    private String pSWFProcessId;

    @JsonIgnore
    private boolean pSWFProcessIdDirtyFlag;

    /**
     * 属性 [WFINSTANCEID]
     *
     */
    @WFStepActorWFInstanceIdDefault(info = "默认规则")
    private String wFInstanceId;

    @JsonIgnore
    private boolean wFInstanceIdDirtyFlag;

    /**
     * 属性 [PSWFVERSIONID]
     *
     */
    @WFStepActorPSWFVersionIdDefault(info = "默认规则")
    private String pSWFVersionId;

    @JsonIgnore
    private boolean pSWFVersionIdDirtyFlag;


    /**
     * 获取 [LOGICNAME]
     */
    @JsonProperty("logicname")
    public String getLogicName(){
        return logicName ;
    }

    /**
     * 设置 [LOGICNAME]
     */
    @JsonProperty("logicname")
    public void setLogicName(String  logicName){
        this.logicName = logicName ;
        this.logicNameDirtyFlag = true ;
    }

    /**
     * 获取 [LOGICNAME]脏标记
     */
    @JsonIgnore
    public boolean getLogicNameDirtyFlag(){
        return logicNameDirtyFlag ;
    }

    /**
     * 获取 [PARENTINSTID]
     */
    @JsonProperty("parentinstid")
    public String getParentInstId(){
        return parentInstId ;
    }

    /**
     * 设置 [PARENTINSTID]
     */
    @JsonProperty("parentinstid")
    public void setParentInstId(String  parentInstId){
        this.parentInstId = parentInstId ;
        this.parentInstIdDirtyFlag = true ;
    }

    /**
     * 获取 [PARENTINSTID]脏标记
     */
    @JsonIgnore
    public boolean getParentInstIdDirtyFlag(){
        return parentInstIdDirtyFlag ;
    }

    /**
     * 获取 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public Timestamp getUpdateDate(){
        return updateDate ;
    }

    /**
     * 设置 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return updateDateDirtyFlag ;
    }

    /**
     * 获取 [MAJORINSTID]
     */
    @JsonProperty("majorinstid")
    public String getMajorInstId(){
        return majorInstId ;
    }

    /**
     * 设置 [MAJORINSTID]
     */
    @JsonProperty("majorinstid")
    public void setMajorInstId(String  majorInstId){
        this.majorInstId = majorInstId ;
        this.majorInstIdDirtyFlag = true ;
    }

    /**
     * 获取 [MAJORINSTID]脏标记
     */
    @JsonIgnore
    public boolean getMajorInstIdDirtyFlag(){
        return majorInstIdDirtyFlag ;
    }

    /**
     * 获取 [WFSTEPACTORID]
     */
    @JsonProperty("wfstepactorid")
    public String getWFStepActorId(){
        return wFStepActorId ;
    }

    /**
     * 设置 [WFSTEPACTORID]
     */
    @JsonProperty("wfstepactorid")
    public void setWFStepActorId(String  wFStepActorId){
        this.wFStepActorId = wFStepActorId ;
        this.wFStepActorIdDirtyFlag = true ;
    }

    /**
     * 获取 [WFSTEPACTORID]脏标记
     */
    @JsonIgnore
    public boolean getWFStepActorIdDirtyFlag(){
        return wFStepActorIdDirtyFlag ;
    }

    /**
     * 获取 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public String getUpdateMan(){
        return updateMan ;
    }

    /**
     * 设置 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return updateManDirtyFlag ;
    }

    /**
     * 获取 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public Timestamp getCreateDate(){
        return createDate ;
    }

    /**
     * 设置 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return createDateDirtyFlag ;
    }

    /**
     * 获取 [FINISHTIME]
     */
    @JsonProperty("finishtime")
    public Timestamp getFinishTime(){
        return finishTime ;
    }

    /**
     * 设置 [FINISHTIME]
     */
    @JsonProperty("finishtime")
    public void setFinishTime(Timestamp  finishTime){
        this.finishTime = finishTime ;
        this.finishTimeDirtyFlag = true ;
    }

    /**
     * 获取 [FINISHTIME]脏标记
     */
    @JsonIgnore
    public boolean getFinishTimeDirtyFlag(){
        return finishTimeDirtyFlag ;
    }

    /**
     * 获取 [WFSTEPACTORNAME]
     */
    @JsonProperty("wfstepactorname")
    public String getWFStepActorName(){
        return wFStepActorName ;
    }

    /**
     * 设置 [WFSTEPACTORNAME]
     */
    @JsonProperty("wfstepactorname")
    public void setWFStepActorName(String  wFStepActorName){
        this.wFStepActorName = wFStepActorName ;
        this.wFStepActorNameDirtyFlag = true ;
    }

    /**
     * 获取 [WFSTEPACTORNAME]脏标记
     */
    @JsonIgnore
    public boolean getWFStepActorNameDirtyFlag(){
        return wFStepActorNameDirtyFlag ;
    }

    /**
     * 获取 [TASKID]
     */
    @JsonProperty("taskid")
    public String getTaskId(){
        return taskId ;
    }

    /**
     * 设置 [TASKID]
     */
    @JsonProperty("taskid")
    public void setTaskId(String  taskId){
        this.taskId = taskId ;
        this.taskIdDirtyFlag = true ;
    }

    /**
     * 获取 [TASKID]脏标记
     */
    @JsonIgnore
    public boolean getTaskIdDirtyFlag(){
        return taskIdDirtyFlag ;
    }

    /**
     * 获取 [CREATEMAN]
     */
    @JsonProperty("createman")
    public String getCreateMan(){
        return createMan ;
    }

    /**
     * 设置 [CREATEMAN]
     */
    @JsonProperty("createman")
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return createManDirtyFlag ;
    }

    /**
     * 获取 [ISFINISH]
     */
    @JsonProperty("isfinish")
    public Integer getIsFinish(){
        return isFinish ;
    }

    /**
     * 设置 [ISFINISH]
     */
    @JsonProperty("isfinish")
    public void setIsFinish(Integer  isFinish){
        this.isFinish = isFinish ;
        this.isFinishDirtyFlag = true ;
    }

    /**
     * 获取 [ISFINISH]脏标记
     */
    @JsonIgnore
    public boolean getIsFinishDirtyFlag(){
        return isFinishDirtyFlag ;
    }

    /**
     * 获取 [READTIME]
     */
    @JsonProperty("readtime")
    public Timestamp getReadTime(){
        return readTime ;
    }

    /**
     * 设置 [READTIME]
     */
    @JsonProperty("readtime")
    public void setReadTime(Timestamp  readTime){
        this.readTime = readTime ;
        this.readTimeDirtyFlag = true ;
    }

    /**
     * 获取 [READTIME]脏标记
     */
    @JsonIgnore
    public boolean getReadTimeDirtyFlag(){
        return readTimeDirtyFlag ;
    }

    /**
     * 获取 [ISREADONLY]
     */
    @JsonProperty("isreadonly")
    public Integer getIsReadOnly(){
        return isReadOnly ;
    }

    /**
     * 设置 [ISREADONLY]
     */
    @JsonProperty("isreadonly")
    public void setIsReadOnly(Integer  isReadOnly){
        this.isReadOnly = isReadOnly ;
        this.isReadOnlyDirtyFlag = true ;
    }

    /**
     * 获取 [ISREADONLY]脏标记
     */
    @JsonIgnore
    public boolean getIsReadOnlyDirtyFlag(){
        return isReadOnlyDirtyFlag ;
    }

    /**
     * 获取 [STARTTIME]
     */
    @JsonProperty("starttime")
    public Timestamp getStartTime(){
        return startTime ;
    }

    /**
     * 设置 [STARTTIME]
     */
    @JsonProperty("starttime")
    public void setStartTime(Timestamp  startTime){
        this.startTime = startTime ;
        this.startTimeDirtyFlag = true ;
    }

    /**
     * 获取 [STARTTIME]脏标记
     */
    @JsonIgnore
    public boolean getStartTimeDirtyFlag(){
        return startTimeDirtyFlag ;
    }

    /**
     * 获取 [WFUSERNAME]
     */
    @JsonProperty("wfusername")
    public String getWFUserName(){
        return wFUserName ;
    }

    /**
     * 设置 [WFUSERNAME]
     */
    @JsonProperty("wfusername")
    public void setWFUserName(String  wFUserName){
        this.wFUserName = wFUserName ;
        this.wFUserNameDirtyFlag = true ;
    }

    /**
     * 获取 [WFUSERNAME]脏标记
     */
    @JsonIgnore
    public boolean getWFUserNameDirtyFlag(){
        return wFUserNameDirtyFlag ;
    }

    /**
     * 获取 [WFUSERID]
     */
    @JsonProperty("wfuserid")
    public String getWFUserId(){
        return wFUserId ;
    }

    /**
     * 设置 [WFUSERID]
     */
    @JsonProperty("wfuserid")
    public void setWFUserId(String  wFUserId){
        this.wFUserId = wFUserId ;
        this.wFUserIdDirtyFlag = true ;
    }

    /**
     * 获取 [WFUSERID]脏标记
     */
    @JsonIgnore
    public boolean getWFUserIdDirtyFlag(){
        return wFUserIdDirtyFlag ;
    }

    /**
     * 获取 [WFSTEPID]
     */
    @JsonProperty("wfstepid")
    public String getWFStepId(){
        return wFStepId ;
    }

    /**
     * 设置 [WFSTEPID]
     */
    @JsonProperty("wfstepid")
    public void setWFStepId(String  wFStepId){
        this.wFStepId = wFStepId ;
        this.wFStepIdDirtyFlag = true ;
    }

    /**
     * 获取 [WFSTEPID]脏标记
     */
    @JsonIgnore
    public boolean getWFStepIdDirtyFlag(){
        return wFStepIdDirtyFlag ;
    }

    /**
     * 获取 [PSWFPROCESSID]
     */
    @JsonProperty("pswfprocessid")
    public String getPSWFProcessId(){
        return pSWFProcessId ;
    }

    /**
     * 设置 [PSWFPROCESSID]
     */
    @JsonProperty("pswfprocessid")
    public void setPSWFProcessId(String  pSWFProcessId){
        this.pSWFProcessId = pSWFProcessId ;
        this.pSWFProcessIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSWFPROCESSID]脏标记
     */
    @JsonIgnore
    public boolean getPSWFProcessIdDirtyFlag(){
        return pSWFProcessIdDirtyFlag ;
    }

    /**
     * 获取 [WFINSTANCEID]
     */
    @JsonProperty("wfinstanceid")
    public String getWFInstanceId(){
        return wFInstanceId ;
    }

    /**
     * 设置 [WFINSTANCEID]
     */
    @JsonProperty("wfinstanceid")
    public void setWFInstanceId(String  wFInstanceId){
        this.wFInstanceId = wFInstanceId ;
        this.wFInstanceIdDirtyFlag = true ;
    }

    /**
     * 获取 [WFINSTANCEID]脏标记
     */
    @JsonIgnore
    public boolean getWFInstanceIdDirtyFlag(){
        return wFInstanceIdDirtyFlag ;
    }

    /**
     * 获取 [PSWFVERSIONID]
     */
    @JsonProperty("pswfversionid")
    public String getPSWFVersionId(){
        return pSWFVersionId ;
    }

    /**
     * 设置 [PSWFVERSIONID]
     */
    @JsonProperty("pswfversionid")
    public void setPSWFVersionId(String  pSWFVersionId){
        this.pSWFVersionId = pSWFVersionId ;
        this.pSWFVersionIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSWFVERSIONID]脏标记
     */
    @JsonIgnore
    public boolean getPSWFVersionIdDirtyFlag(){
        return pSWFVersionIdDirtyFlag ;
    }



    public WFStepActor toDO() {
        WFStepActor srfdomain = new WFStepActor();
        if(getLogicNameDirtyFlag())
            srfdomain.setLogicName(logicName);
        if(getParentInstIdDirtyFlag())
            srfdomain.setParentInstId(parentInstId);
        if(getUpdateDateDirtyFlag())
            srfdomain.setUpdateDate(updateDate);
        if(getMajorInstIdDirtyFlag())
            srfdomain.setMajorInstId(majorInstId);
        if(getWFStepActorIdDirtyFlag())
            srfdomain.setWFStepActorId(wFStepActorId);
        if(getUpdateManDirtyFlag())
            srfdomain.setUpdateMan(updateMan);
        if(getCreateDateDirtyFlag())
            srfdomain.setCreateDate(createDate);
        if(getFinishTimeDirtyFlag())
            srfdomain.setFinishTime(finishTime);
        if(getWFStepActorNameDirtyFlag())
            srfdomain.setWFStepActorName(wFStepActorName);
        if(getTaskIdDirtyFlag())
            srfdomain.setTaskId(taskId);
        if(getCreateManDirtyFlag())
            srfdomain.setCreateMan(createMan);
        if(getIsFinishDirtyFlag())
            srfdomain.setIsFinish(isFinish);
        if(getReadTimeDirtyFlag())
            srfdomain.setReadTime(readTime);
        if(getIsReadOnlyDirtyFlag())
            srfdomain.setIsReadOnly(isReadOnly);
        if(getStartTimeDirtyFlag())
            srfdomain.setStartTime(startTime);
        if(getWFUserNameDirtyFlag())
            srfdomain.setWFUserName(wFUserName);
        if(getWFUserIdDirtyFlag())
            srfdomain.setWFUserId(wFUserId);
        if(getWFStepIdDirtyFlag())
            srfdomain.setWFStepId(wFStepId);
        if(getPSWFProcessIdDirtyFlag())
            srfdomain.setPSWFProcessId(pSWFProcessId);
        if(getWFInstanceIdDirtyFlag())
            srfdomain.setWFInstanceId(wFInstanceId);
        if(getPSWFVersionIdDirtyFlag())
            srfdomain.setPSWFVersionId(pSWFVersionId);

        return srfdomain;
    }

    public void fromDO(WFStepActor srfdomain) {
        if(srfdomain == null )
          return ;
        if(srfdomain.getLogicNameDirtyFlag())
            this.setLogicName(srfdomain.getLogicName());
        if(srfdomain.getParentInstIdDirtyFlag())
            this.setParentInstId(srfdomain.getParentInstId());
        if(srfdomain.getUpdateDateDirtyFlag())
            this.setUpdateDate(srfdomain.getUpdateDate());
        if(srfdomain.getMajorInstIdDirtyFlag())
            this.setMajorInstId(srfdomain.getMajorInstId());
        if(srfdomain.getWFStepActorIdDirtyFlag())
            this.setWFStepActorId(srfdomain.getWFStepActorId());
        if(srfdomain.getUpdateManDirtyFlag())
            this.setUpdateMan(srfdomain.getUpdateMan());
        if(srfdomain.getCreateDateDirtyFlag())
            this.setCreateDate(srfdomain.getCreateDate());
        if(srfdomain.getFinishTimeDirtyFlag())
            this.setFinishTime(srfdomain.getFinishTime());
        if(srfdomain.getWFStepActorNameDirtyFlag())
            this.setWFStepActorName(srfdomain.getWFStepActorName());
        if(srfdomain.getTaskIdDirtyFlag())
            this.setTaskId(srfdomain.getTaskId());
        if(srfdomain.getCreateManDirtyFlag())
            this.setCreateMan(srfdomain.getCreateMan());
        if(srfdomain.getIsFinishDirtyFlag())
            this.setIsFinish(srfdomain.getIsFinish());
        if(srfdomain.getReadTimeDirtyFlag())
            this.setReadTime(srfdomain.getReadTime());
        if(srfdomain.getIsReadOnlyDirtyFlag())
            this.setIsReadOnly(srfdomain.getIsReadOnly());
        if(srfdomain.getStartTimeDirtyFlag())
            this.setStartTime(srfdomain.getStartTime());
        if(srfdomain.getWFUserNameDirtyFlag())
            this.setWFUserName(srfdomain.getWFUserName());
        if(srfdomain.getWFUserIdDirtyFlag())
            this.setWFUserId(srfdomain.getWFUserId());
        if(srfdomain.getWFStepIdDirtyFlag())
            this.setWFStepId(srfdomain.getWFStepId());
        if(srfdomain.getPSWFProcessIdDirtyFlag())
            this.setPSWFProcessId(srfdomain.getPSWFProcessId());
        if(srfdomain.getWFInstanceIdDirtyFlag())
            this.setWFInstanceId(srfdomain.getWFInstanceId());
        if(srfdomain.getPSWFVersionIdDirtyFlag())
            this.setPSWFVersionId(srfdomain.getPSWFVersionId());

    }

    public List<WFStepActorDTO> fromDOPage(List<WFStepActor> poPage)   {
        if(poPage == null)
            return null;
        List<WFStepActorDTO> dtos=new ArrayList<WFStepActorDTO>();
        for(WFStepActor domain : poPage) {
            WFStepActorDTO dto = new WFStepActorDTO();
            dto.fromDO(domain);
            dtos.add(dto);
        }
        return dtos;
    }
}

