package cn.ibizlab.r7.runtime.wf.service.wfapi.dto;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.math.BigInteger;
import java.util.Map;
import java.util.HashMap;
import java.io.Serializable;
import java.math.BigDecimal;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.valuerule.anno.wfstep.*;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.WFStep;
import org.springframework.cglib.beans.BeanCopier;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * 服务DTO对象[WFStepDTO]
 */
public class WFStepDTO implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 属性 [ISFINISH]
     *
     */
    @WFStepIsFinishDefault(info = "默认规则")
    private Integer isFinish;

    @JsonIgnore
    private boolean isFinishDirtyFlag;

    /**
     * 属性 [STARTTIME]
     *
     */
    @WFStepStartTimeDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp startTime;

    @JsonIgnore
    private boolean startTimeDirtyFlag;

    /**
     * 属性 [LOGICNAME]
     *
     */
    @WFStepLogicNameDefault(info = "默认规则")
    private String logicName;

    @JsonIgnore
    private boolean logicNameDirtyFlag;

    /**
     * 属性 [UPDATEDATE]
     *
     */
    @WFStepUpdateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp updateDate;

    @JsonIgnore
    private boolean updateDateDirtyFlag;

    /**
     * 属性 [UPDATEMAN]
     *
     */
    @WFStepUpdateManDefault(info = "默认规则")
    private String updateMan;

    @JsonIgnore
    private boolean updateManDirtyFlag;

    /**
     * 属性 [ENDTIME]
     *
     */
    @WFStepEndTimeDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp endTime;

    @JsonIgnore
    private boolean endTimeDirtyFlag;

    /**
     * 属性 [CREATEMAN]
     *
     */
    @WFStepCreateManDefault(info = "默认规则")
    private String createMan;

    @JsonIgnore
    private boolean createManDirtyFlag;

    /**
     * 属性 [PARENTINSTID]
     *
     */
    @WFStepParentInstIdDefault(info = "默认规则")
    private String parentInstId;

    @JsonIgnore
    private boolean parentInstIdDirtyFlag;

    /**
     * 属性 [WFSTEPNAME]
     *
     */
    @WFStepWFStepNameDefault(info = "默认规则")
    private String wFStepName;

    @JsonIgnore
    private boolean wFStepNameDirtyFlag;

    /**
     * 属性 [WFSTEPID]
     *
     */
    @WFStepWFStepIdDefault(info = "默认规则")
    private String wFStepId;

    @JsonIgnore
    private boolean wFStepIdDirtyFlag;

    /**
     * 属性 [MAJORINSTID]
     *
     */
    @WFStepMajorInstIdDefault(info = "默认规则")
    private String majorInstId;

    @JsonIgnore
    private boolean majorInstIdDirtyFlag;

    /**
     * 属性 [TRACESTEP]
     *
     */
    @WFStepTraceStepDefault(info = "默认规则")
    private Integer traceStep;

    @JsonIgnore
    private boolean traceStepDirtyFlag;

    /**
     * 属性 [CREATEDATE]
     *
     */
    @WFStepCreateDateDefault(info = "默认规则")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    private Timestamp createDate;

    @JsonIgnore
    private boolean createDateDirtyFlag;

    /**
     * 属性 [PSWFPROCESSID]
     *
     */
    @WFStepPSWFProcessIdDefault(info = "默认规则")
    private String pSWFProcessId;

    @JsonIgnore
    private boolean pSWFProcessIdDirtyFlag;

    /**
     * 属性 [PSWFVERSIONID]
     *
     */
    @WFStepPSWFVersionIdDefault(info = "默认规则")
    private String pSWFVersionId;

    @JsonIgnore
    private boolean pSWFVersionIdDirtyFlag;

    /**
     * 属性 [WFINSTANCEID]
     *
     */
    @WFStepWFInstanceIdDefault(info = "默认规则")
    private String wFInstanceId;

    @JsonIgnore
    private boolean wFInstanceIdDirtyFlag;


    /**
     * 获取 [ISFINISH]
     */
    @JsonProperty("isfinish")
    public Integer getIsFinish(){
        return isFinish ;
    }

    /**
     * 设置 [ISFINISH]
     */
    @JsonProperty("isfinish")
    public void setIsFinish(Integer  isFinish){
        this.isFinish = isFinish ;
        this.isFinishDirtyFlag = true ;
    }

    /**
     * 获取 [ISFINISH]脏标记
     */
    @JsonIgnore
    public boolean getIsFinishDirtyFlag(){
        return isFinishDirtyFlag ;
    }

    /**
     * 获取 [STARTTIME]
     */
    @JsonProperty("starttime")
    public Timestamp getStartTime(){
        return startTime ;
    }

    /**
     * 设置 [STARTTIME]
     */
    @JsonProperty("starttime")
    public void setStartTime(Timestamp  startTime){
        this.startTime = startTime ;
        this.startTimeDirtyFlag = true ;
    }

    /**
     * 获取 [STARTTIME]脏标记
     */
    @JsonIgnore
    public boolean getStartTimeDirtyFlag(){
        return startTimeDirtyFlag ;
    }

    /**
     * 获取 [LOGICNAME]
     */
    @JsonProperty("logicname")
    public String getLogicName(){
        return logicName ;
    }

    /**
     * 设置 [LOGICNAME]
     */
    @JsonProperty("logicname")
    public void setLogicName(String  logicName){
        this.logicName = logicName ;
        this.logicNameDirtyFlag = true ;
    }

    /**
     * 获取 [LOGICNAME]脏标记
     */
    @JsonIgnore
    public boolean getLogicNameDirtyFlag(){
        return logicNameDirtyFlag ;
    }

    /**
     * 获取 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public Timestamp getUpdateDate(){
        return updateDate ;
    }

    /**
     * 设置 [UPDATEDATE]
     */
    @JsonProperty("updatedate")
    public void setUpdateDate(Timestamp  updateDate){
        this.updateDate = updateDate ;
        this.updateDateDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getUpdateDateDirtyFlag(){
        return updateDateDirtyFlag ;
    }

    /**
     * 获取 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public String getUpdateMan(){
        return updateMan ;
    }

    /**
     * 设置 [UPDATEMAN]
     */
    @JsonProperty("updateman")
    public void setUpdateMan(String  updateMan){
        this.updateMan = updateMan ;
        this.updateManDirtyFlag = true ;
    }

    /**
     * 获取 [UPDATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getUpdateManDirtyFlag(){
        return updateManDirtyFlag ;
    }

    /**
     * 获取 [ENDTIME]
     */
    @JsonProperty("endtime")
    public Timestamp getEndTime(){
        return endTime ;
    }

    /**
     * 设置 [ENDTIME]
     */
    @JsonProperty("endtime")
    public void setEndTime(Timestamp  endTime){
        this.endTime = endTime ;
        this.endTimeDirtyFlag = true ;
    }

    /**
     * 获取 [ENDTIME]脏标记
     */
    @JsonIgnore
    public boolean getEndTimeDirtyFlag(){
        return endTimeDirtyFlag ;
    }

    /**
     * 获取 [CREATEMAN]
     */
    @JsonProperty("createman")
    public String getCreateMan(){
        return createMan ;
    }

    /**
     * 设置 [CREATEMAN]
     */
    @JsonProperty("createman")
    public void setCreateMan(String  createMan){
        this.createMan = createMan ;
        this.createManDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEMAN]脏标记
     */
    @JsonIgnore
    public boolean getCreateManDirtyFlag(){
        return createManDirtyFlag ;
    }

    /**
     * 获取 [PARENTINSTID]
     */
    @JsonProperty("parentinstid")
    public String getParentInstId(){
        return parentInstId ;
    }

    /**
     * 设置 [PARENTINSTID]
     */
    @JsonProperty("parentinstid")
    public void setParentInstId(String  parentInstId){
        this.parentInstId = parentInstId ;
        this.parentInstIdDirtyFlag = true ;
    }

    /**
     * 获取 [PARENTINSTID]脏标记
     */
    @JsonIgnore
    public boolean getParentInstIdDirtyFlag(){
        return parentInstIdDirtyFlag ;
    }

    /**
     * 获取 [WFSTEPNAME]
     */
    @JsonProperty("wfstepname")
    public String getWFStepName(){
        return wFStepName ;
    }

    /**
     * 设置 [WFSTEPNAME]
     */
    @JsonProperty("wfstepname")
    public void setWFStepName(String  wFStepName){
        this.wFStepName = wFStepName ;
        this.wFStepNameDirtyFlag = true ;
    }

    /**
     * 获取 [WFSTEPNAME]脏标记
     */
    @JsonIgnore
    public boolean getWFStepNameDirtyFlag(){
        return wFStepNameDirtyFlag ;
    }

    /**
     * 获取 [WFSTEPID]
     */
    @JsonProperty("wfstepid")
    public String getWFStepId(){
        return wFStepId ;
    }

    /**
     * 设置 [WFSTEPID]
     */
    @JsonProperty("wfstepid")
    public void setWFStepId(String  wFStepId){
        this.wFStepId = wFStepId ;
        this.wFStepIdDirtyFlag = true ;
    }

    /**
     * 获取 [WFSTEPID]脏标记
     */
    @JsonIgnore
    public boolean getWFStepIdDirtyFlag(){
        return wFStepIdDirtyFlag ;
    }

    /**
     * 获取 [MAJORINSTID]
     */
    @JsonProperty("majorinstid")
    public String getMajorInstId(){
        return majorInstId ;
    }

    /**
     * 设置 [MAJORINSTID]
     */
    @JsonProperty("majorinstid")
    public void setMajorInstId(String  majorInstId){
        this.majorInstId = majorInstId ;
        this.majorInstIdDirtyFlag = true ;
    }

    /**
     * 获取 [MAJORINSTID]脏标记
     */
    @JsonIgnore
    public boolean getMajorInstIdDirtyFlag(){
        return majorInstIdDirtyFlag ;
    }

    /**
     * 获取 [TRACESTEP]
     */
    @JsonProperty("tracestep")
    public Integer getTraceStep(){
        return traceStep ;
    }

    /**
     * 设置 [TRACESTEP]
     */
    @JsonProperty("tracestep")
    public void setTraceStep(Integer  traceStep){
        this.traceStep = traceStep ;
        this.traceStepDirtyFlag = true ;
    }

    /**
     * 获取 [TRACESTEP]脏标记
     */
    @JsonIgnore
    public boolean getTraceStepDirtyFlag(){
        return traceStepDirtyFlag ;
    }

    /**
     * 获取 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public Timestamp getCreateDate(){
        return createDate ;
    }

    /**
     * 设置 [CREATEDATE]
     */
    @JsonProperty("createdate")
    public void setCreateDate(Timestamp  createDate){
        this.createDate = createDate ;
        this.createDateDirtyFlag = true ;
    }

    /**
     * 获取 [CREATEDATE]脏标记
     */
    @JsonIgnore
    public boolean getCreateDateDirtyFlag(){
        return createDateDirtyFlag ;
    }

    /**
     * 获取 [PSWFPROCESSID]
     */
    @JsonProperty("pswfprocessid")
    public String getPSWFProcessId(){
        return pSWFProcessId ;
    }

    /**
     * 设置 [PSWFPROCESSID]
     */
    @JsonProperty("pswfprocessid")
    public void setPSWFProcessId(String  pSWFProcessId){
        this.pSWFProcessId = pSWFProcessId ;
        this.pSWFProcessIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSWFPROCESSID]脏标记
     */
    @JsonIgnore
    public boolean getPSWFProcessIdDirtyFlag(){
        return pSWFProcessIdDirtyFlag ;
    }

    /**
     * 获取 [PSWFVERSIONID]
     */
    @JsonProperty("pswfversionid")
    public String getPSWFVersionId(){
        return pSWFVersionId ;
    }

    /**
     * 设置 [PSWFVERSIONID]
     */
    @JsonProperty("pswfversionid")
    public void setPSWFVersionId(String  pSWFVersionId){
        this.pSWFVersionId = pSWFVersionId ;
        this.pSWFVersionIdDirtyFlag = true ;
    }

    /**
     * 获取 [PSWFVERSIONID]脏标记
     */
    @JsonIgnore
    public boolean getPSWFVersionIdDirtyFlag(){
        return pSWFVersionIdDirtyFlag ;
    }

    /**
     * 获取 [WFINSTANCEID]
     */
    @JsonProperty("wfinstanceid")
    public String getWFInstanceId(){
        return wFInstanceId ;
    }

    /**
     * 设置 [WFINSTANCEID]
     */
    @JsonProperty("wfinstanceid")
    public void setWFInstanceId(String  wFInstanceId){
        this.wFInstanceId = wFInstanceId ;
        this.wFInstanceIdDirtyFlag = true ;
    }

    /**
     * 获取 [WFINSTANCEID]脏标记
     */
    @JsonIgnore
    public boolean getWFInstanceIdDirtyFlag(){
        return wFInstanceIdDirtyFlag ;
    }



    public WFStep toDO() {
        WFStep srfdomain = new WFStep();
        if(getIsFinishDirtyFlag())
            srfdomain.setIsFinish(isFinish);
        if(getStartTimeDirtyFlag())
            srfdomain.setStartTime(startTime);
        if(getLogicNameDirtyFlag())
            srfdomain.setLogicName(logicName);
        if(getUpdateDateDirtyFlag())
            srfdomain.setUpdateDate(updateDate);
        if(getUpdateManDirtyFlag())
            srfdomain.setUpdateMan(updateMan);
        if(getEndTimeDirtyFlag())
            srfdomain.setEndTime(endTime);
        if(getCreateManDirtyFlag())
            srfdomain.setCreateMan(createMan);
        if(getParentInstIdDirtyFlag())
            srfdomain.setParentInstId(parentInstId);
        if(getWFStepNameDirtyFlag())
            srfdomain.setWFStepName(wFStepName);
        if(getWFStepIdDirtyFlag())
            srfdomain.setWFStepId(wFStepId);
        if(getMajorInstIdDirtyFlag())
            srfdomain.setMajorInstId(majorInstId);
        if(getTraceStepDirtyFlag())
            srfdomain.setTraceStep(traceStep);
        if(getCreateDateDirtyFlag())
            srfdomain.setCreateDate(createDate);
        if(getPSWFProcessIdDirtyFlag())
            srfdomain.setPSWFProcessId(pSWFProcessId);
        if(getPSWFVersionIdDirtyFlag())
            srfdomain.setPSWFVersionId(pSWFVersionId);
        if(getWFInstanceIdDirtyFlag())
            srfdomain.setWFInstanceId(wFInstanceId);

        return srfdomain;
    }

    public void fromDO(WFStep srfdomain) {
        if(srfdomain == null )
          return ;
        if(srfdomain.getIsFinishDirtyFlag())
            this.setIsFinish(srfdomain.getIsFinish());
        if(srfdomain.getStartTimeDirtyFlag())
            this.setStartTime(srfdomain.getStartTime());
        if(srfdomain.getLogicNameDirtyFlag())
            this.setLogicName(srfdomain.getLogicName());
        if(srfdomain.getUpdateDateDirtyFlag())
            this.setUpdateDate(srfdomain.getUpdateDate());
        if(srfdomain.getUpdateManDirtyFlag())
            this.setUpdateMan(srfdomain.getUpdateMan());
        if(srfdomain.getEndTimeDirtyFlag())
            this.setEndTime(srfdomain.getEndTime());
        if(srfdomain.getCreateManDirtyFlag())
            this.setCreateMan(srfdomain.getCreateMan());
        if(srfdomain.getParentInstIdDirtyFlag())
            this.setParentInstId(srfdomain.getParentInstId());
        if(srfdomain.getWFStepNameDirtyFlag())
            this.setWFStepName(srfdomain.getWFStepName());
        if(srfdomain.getWFStepIdDirtyFlag())
            this.setWFStepId(srfdomain.getWFStepId());
        if(srfdomain.getMajorInstIdDirtyFlag())
            this.setMajorInstId(srfdomain.getMajorInstId());
        if(srfdomain.getTraceStepDirtyFlag())
            this.setTraceStep(srfdomain.getTraceStep());
        if(srfdomain.getCreateDateDirtyFlag())
            this.setCreateDate(srfdomain.getCreateDate());
        if(srfdomain.getPSWFProcessIdDirtyFlag())
            this.setPSWFProcessId(srfdomain.getPSWFProcessId());
        if(srfdomain.getPSWFVersionIdDirtyFlag())
            this.setPSWFVersionId(srfdomain.getPSWFVersionId());
        if(srfdomain.getWFInstanceIdDirtyFlag())
            this.setWFInstanceId(srfdomain.getWFInstanceId());

    }

    public List<WFStepDTO> fromDOPage(List<WFStep> poPage)   {
        if(poPage == null)
            return null;
        List<WFStepDTO> dtos=new ArrayList<WFStepDTO>();
        for(WFStep domain : poPage) {
            WFStepDTO dto = new WFStepDTO();
            dto.fromDO(domain);
            dtos.add(dto);
        }
        return dtos;
    }
}

