package cn.ibizlab.r7.runtime.wf.service.wfapi.resource;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import javax.servlet.ServletRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.http.HttpStatus;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.StringUtils;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiResponse;
import io.swagger.annotations.ApiResponses;

import com.alibaba.fastjson.JSONObject;
import org.springframework.data.domain.PageRequest;
import cn.ibizlab.r7.runtime.wf.service.wfapi.dto.OrgDeptWFVerDTO;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.OrgDeptWFVer;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IOrgDeptWFVerService;
import cn.ibizlab.r7.runtime.wf.util.SearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.OrgDeptWFVerSearchContext;

@Api(tags = {"OrgDeptWFVer" })
@RestController
@RequestMapping("")
public class OrgDeptWFVerResource {

    @Autowired
    private IOrgDeptWFVerService orgdeptwfverService;

    public IOrgDeptWFVerService getOrgdeptwfverService() {
        return this.orgdeptwfverService;
    }

    @ApiOperation(value = "GetDraft", tags = {"OrgDeptWFVer" },  notes = "GetDraft")
	@RequestMapping(method = RequestMethod.GET, value = "/wfapi/orgdeptwfvers/{orgdeptwfver_id}/getdraft")
    @Transactional
    public ResponseEntity<OrgDeptWFVerDTO> getDraft(@PathVariable("orgdeptwfver_id") String orgdeptwfver_id, @RequestBody OrgDeptWFVerDTO orgdeptwfverdto) {
        OrgDeptWFVer orgdeptwfver = orgdeptwfverdto.toDO();
    	orgdeptwfver = orgdeptwfverService.getDraft(orgdeptwfver) ;
    	orgdeptwfverdto.fromDO(orgdeptwfver);
        return ResponseEntity.status(HttpStatus.OK).body(orgdeptwfverdto);
    }

    @ApiOperation(value = "Save", tags = {"OrgDeptWFVer" },  notes = "Save")
	@RequestMapping(method = RequestMethod.POST, value = "/wfapi/orgdeptwfvers/{orgdeptwfver_id}/save")
    public ResponseEntity<Boolean> save(@RequestBody OrgDeptWFVerDTO orgdeptwfverdto) {
        OrgDeptWFVer orgdeptwfver = orgdeptwfverdto.toDO();
    	Boolean b = orgdeptwfverService.save(orgdeptwfver) ;
        return ResponseEntity.status(HttpStatus.OK).body(b);
    }

    @ApiOperation(value = "Remove", tags = {"OrgDeptWFVer" },  notes = "Remove")
	@RequestMapping(method = RequestMethod.DELETE, value = "/wfapi/orgdeptwfvers/{orgdeptwfver_id}")
    @Transactional
    public ResponseEntity<Boolean> remove(@PathVariable("orgdeptwfver_id") String orgdeptwfver_id) {
        OrgDeptWFVerDTO orgdeptwfverdto = new OrgDeptWFVerDTO();
		OrgDeptWFVer domain = new OrgDeptWFVer();
		orgdeptwfverdto.setOrgDeptWFVerId(orgdeptwfver_id);
		domain.setOrgDeptWFVerId(orgdeptwfver_id);
        Boolean rst = orgdeptwfverService.remove(domain.getOrgDeptWFVerId());
        if(rst){
			return ResponseEntity.status(HttpStatus.OK).body(rst);
		}else{
			return ResponseEntity.status(HttpStatus.OK).body(rst);
		}
    }

    @ApiOperation(value = "Create", tags = {"OrgDeptWFVer" },  notes = "Create")
	@RequestMapping(method = RequestMethod.POST, value = "/wfapi/orgdeptwfvers")
    @Transactional
    public ResponseEntity<OrgDeptWFVerDTO> create(@RequestBody OrgDeptWFVerDTO orgdeptwfverdto) {
        OrgDeptWFVerDTO dto = new OrgDeptWFVerDTO();
        OrgDeptWFVer domain = orgdeptwfverdto.toDO();
		orgdeptwfverService.create(domain);
        dto.fromDO(domain);
		return ResponseEntity.status(HttpStatus.OK).body(dto);
    }

    @ApiOperation(value = "Update", tags = {"OrgDeptWFVer" },  notes = "Update")
	@RequestMapping(method = RequestMethod.PUT, value = "/wfapi/orgdeptwfvers/{orgdeptwfver_id}")
    @Transactional
    public ResponseEntity<OrgDeptWFVerDTO> update(@PathVariable("orgdeptwfver_id") String orgdeptwfver_id, @RequestBody OrgDeptWFVerDTO orgdeptwfverdto) {
		OrgDeptWFVer domain = orgdeptwfverdto.toDO();
        domain.setOrgDeptWFVerId(orgdeptwfver_id);
		orgdeptwfverService.update(domain);
		OrgDeptWFVerDTO dto = new OrgDeptWFVerDTO();
		dto.fromDO(domain);
        return ResponseEntity.status(HttpStatus.OK).body(dto);
    }

    @ApiOperation(value = "CheckKey", tags = {"OrgDeptWFVer" },  notes = "CheckKey")
	@RequestMapping(method = RequestMethod.POST, value = "/wfapi/orgdeptwfvers/checkkey")
    public ResponseEntity<Boolean> checkKey(@RequestBody OrgDeptWFVerDTO orgdeptwfverdto) {
        return  ResponseEntity.status(HttpStatus.OK).body(true);
    }

    @ApiOperation(value = "Get", tags = {"OrgDeptWFVer" },  notes = "Get")
	@RequestMapping(method = RequestMethod.GET, value = "/wfapi/orgdeptwfvers/{orgdeptwfver_id}")
    public ResponseEntity<OrgDeptWFVerDTO> get(@PathVariable("orgdeptwfver_id") String orgdeptwfver_id) {
        OrgDeptWFVerDTO dto = new OrgDeptWFVerDTO();
        OrgDeptWFVer domain = orgdeptwfverService.get(orgdeptwfver_id);
		dto.fromDO(domain);
        return ResponseEntity.status(HttpStatus.OK).body(dto);
    }

	@ApiOperation(value = "获取DEFAULT", tags = {"OrgDeptWFVer" } ,notes = "获取DEFAULT")
    @RequestMapping(method= RequestMethod.GET , value="/wfapi/orgdeptwfvers/fetchdefault")
	public ResponseEntity<Page<OrgDeptWFVerDTO>> fetchDefault(OrgDeptWFVerSearchContext context,Pageable pageable ,ServletRequest request) {
        context.setPageable(pageable);
        List<OrgDeptWFVerDTO> list = new ArrayList<OrgDeptWFVerDTO>();
        
        Page<OrgDeptWFVer> domains = orgdeptwfverService.searchDefault(context) ;
        for(OrgDeptWFVer orgdeptwfver : domains.getContent()){
            OrgDeptWFVerDTO dto = new OrgDeptWFVerDTO();
            dto.fromDO(orgdeptwfver);
            list.add(dto);
        }
	    return ResponseEntity.status(HttpStatus.OK).body(new PageImpl(list,context.getPageable(),domains.getTotalElements()));
	}

	@ApiOperation(value = "获取当前部门", tags = {"OrgDeptWFVer" } ,notes = "获取当前部门")
    @RequestMapping(method= RequestMethod.GET , value="/wfapi/orgdeptwfvers/fetchcurorgdept")
	public ResponseEntity<Page<OrgDeptWFVerDTO>> fetchCurOrgDept(OrgDeptWFVerSearchContext context,Pageable pageable ,ServletRequest request) {
        context.setPageable(pageable);
        List<OrgDeptWFVerDTO> list = new ArrayList<OrgDeptWFVerDTO>();
        
        Page<OrgDeptWFVer> domains = orgdeptwfverService.searchCurOrgDept(context) ;
        for(OrgDeptWFVer orgdeptwfver : domains.getContent()){
            OrgDeptWFVerDTO dto = new OrgDeptWFVerDTO();
            dto.fromDO(orgdeptwfver);
            list.add(dto);
        }
	    return ResponseEntity.status(HttpStatus.OK).body(new PageImpl(list,context.getPageable(),domains.getTotalElements()));
	}


}
