package cn.ibizlab.r7.runtime.wf.service.wfapi.resource;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import javax.servlet.ServletRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.http.HttpStatus;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.StringUtils;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiResponse;
import io.swagger.annotations.ApiResponses;

import com.alibaba.fastjson.JSONObject;
import org.springframework.data.domain.PageRequest;
import cn.ibizlab.r7.runtime.wf.service.wfapi.dto.PSWFPROCSUBWFDTO;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.domain.PSWFPROCSUBWF;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.service.IPSWFPROCSUBWFService;
import cn.ibizlab.r7.runtime.wf.util.SearchContext;
import cn.ibizlab.r7.runtime.wf.core.r7rt_wf.filter.PSWFPROCSUBWFSearchContext;

@Api(tags = {"PSWFPROCSUBWF" })
@RestController
@RequestMapping("")
public class PSWFPROCSUBWFResource {

    @Autowired
    private IPSWFPROCSUBWFService pswfprocsubwfService;

    public IPSWFPROCSUBWFService getPswfprocsubwfService() {
        return this.pswfprocsubwfService;
    }

    @ApiOperation(value = "Create", tags = {"PSWFPROCSUBWF" },  notes = "Create")
	@RequestMapping(method = RequestMethod.POST, value = "/wfapi/pswfprocsubwfs")
    @Transactional
    public ResponseEntity<PSWFPROCSUBWFDTO> create(@RequestBody PSWFPROCSUBWFDTO pswfprocsubwfdto) {
        PSWFPROCSUBWFDTO dto = new PSWFPROCSUBWFDTO();
        PSWFPROCSUBWF domain = pswfprocsubwfdto.toDO();
		pswfprocsubwfService.create(domain);
        dto.fromDO(domain);
		return ResponseEntity.status(HttpStatus.OK).body(dto);
    }

    @ApiOperation(value = "Remove", tags = {"PSWFPROCSUBWF" },  notes = "Remove")
	@RequestMapping(method = RequestMethod.DELETE, value = "/wfapi/pswfprocsubwfs/{pswfprocsubwf_id}")
    @Transactional
    public ResponseEntity<Boolean> remove(@PathVariable("pswfprocsubwf_id") String pswfprocsubwf_id) {
        PSWFPROCSUBWFDTO pswfprocsubwfdto = new PSWFPROCSUBWFDTO();
		PSWFPROCSUBWF domain = new PSWFPROCSUBWF();
		pswfprocsubwfdto.setPSWFPROCSUBWFId(pswfprocsubwf_id);
		domain.setPSWFPROCSUBWFId(pswfprocsubwf_id);
        Boolean rst = pswfprocsubwfService.remove(domain.getPSWFPROCSUBWFId());
        if(rst){
			return ResponseEntity.status(HttpStatus.OK).body(rst);
		}else{
			return ResponseEntity.status(HttpStatus.OK).body(rst);
		}
    }

    @ApiOperation(value = "Save", tags = {"PSWFPROCSUBWF" },  notes = "Save")
	@RequestMapping(method = RequestMethod.POST, value = "/wfapi/pswfprocsubwfs/{pswfprocsubwf_id}/save")
    public ResponseEntity<Boolean> save(@RequestBody PSWFPROCSUBWFDTO pswfprocsubwfdto) {
        PSWFPROCSUBWF pswfprocsubwf = pswfprocsubwfdto.toDO();
    	Boolean b = pswfprocsubwfService.save(pswfprocsubwf) ;
        return ResponseEntity.status(HttpStatus.OK).body(b);
    }

    @ApiOperation(value = "GetDraft", tags = {"PSWFPROCSUBWF" },  notes = "GetDraft")
	@RequestMapping(method = RequestMethod.GET, value = "/wfapi/pswfprocsubwfs/{pswfprocsubwf_id}/getdraft")
    @Transactional
    public ResponseEntity<PSWFPROCSUBWFDTO> getDraft(@PathVariable("pswfprocsubwf_id") String pswfprocsubwf_id, @RequestBody PSWFPROCSUBWFDTO pswfprocsubwfdto) {
        PSWFPROCSUBWF pswfprocsubwf = pswfprocsubwfdto.toDO();
    	pswfprocsubwf = pswfprocsubwfService.getDraft(pswfprocsubwf) ;
    	pswfprocsubwfdto.fromDO(pswfprocsubwf);
        return ResponseEntity.status(HttpStatus.OK).body(pswfprocsubwfdto);
    }

    @ApiOperation(value = "Update", tags = {"PSWFPROCSUBWF" },  notes = "Update")
	@RequestMapping(method = RequestMethod.PUT, value = "/wfapi/pswfprocsubwfs/{pswfprocsubwf_id}")
    @Transactional
    public ResponseEntity<PSWFPROCSUBWFDTO> update(@PathVariable("pswfprocsubwf_id") String pswfprocsubwf_id, @RequestBody PSWFPROCSUBWFDTO pswfprocsubwfdto) {
		PSWFPROCSUBWF domain = pswfprocsubwfdto.toDO();
        domain.setPSWFPROCSUBWFId(pswfprocsubwf_id);
		pswfprocsubwfService.update(domain);
		PSWFPROCSUBWFDTO dto = new PSWFPROCSUBWFDTO();
		dto.fromDO(domain);
        return ResponseEntity.status(HttpStatus.OK).body(dto);
    }

    @ApiOperation(value = "Get", tags = {"PSWFPROCSUBWF" },  notes = "Get")
	@RequestMapping(method = RequestMethod.GET, value = "/wfapi/pswfprocsubwfs/{pswfprocsubwf_id}")
    public ResponseEntity<PSWFPROCSUBWFDTO> get(@PathVariable("pswfprocsubwf_id") String pswfprocsubwf_id) {
        PSWFPROCSUBWFDTO dto = new PSWFPROCSUBWFDTO();
        PSWFPROCSUBWF domain = pswfprocsubwfService.get(pswfprocsubwf_id);
		dto.fromDO(domain);
        return ResponseEntity.status(HttpStatus.OK).body(dto);
    }

    @ApiOperation(value = "CheckKey", tags = {"PSWFPROCSUBWF" },  notes = "CheckKey")
	@RequestMapping(method = RequestMethod.POST, value = "/wfapi/pswfprocsubwfs/checkkey")
    public ResponseEntity<Boolean> checkKey(@RequestBody PSWFPROCSUBWFDTO pswfprocsubwfdto) {
        return  ResponseEntity.status(HttpStatus.OK).body(true);
    }

	@ApiOperation(value = "获取DEFAULT", tags = {"PSWFPROCSUBWF" } ,notes = "获取DEFAULT")
    @RequestMapping(method= RequestMethod.GET , value="/wfapi/pswfprocsubwfs/fetchdefault")
	public ResponseEntity<Page<PSWFPROCSUBWFDTO>> fetchDefault(PSWFPROCSUBWFSearchContext context,Pageable pageable ,ServletRequest request) {
        context.setPageable(pageable);
        List<PSWFPROCSUBWFDTO> list = new ArrayList<PSWFPROCSUBWFDTO>();
        
        Page<PSWFPROCSUBWF> domains = pswfprocsubwfService.searchDefault(context) ;
        for(PSWFPROCSUBWF pswfprocsubwf : domains.getContent()){
            PSWFPROCSUBWFDTO dto = new PSWFPROCSUBWFDTO();
            dto.fromDO(pswfprocsubwf);
            list.add(dto);
        }
	    return ResponseEntity.status(HttpStatus.OK).body(new PageImpl(list,context.getPageable(),domains.getTotalElements()));
	}


}
